SystemOrganization addCategory: #'SimpleMorphic-Basic'!
SystemOrganization addCategory: #'SimpleMorphic-Borders'!
SystemOrganization addCategory: #'SimpleMorphic-Events'!
SystemOrganization addCategory: #'SimpleMorphic-Kernel'!
SystemOrganization addCategory: #'SimpleMorphic-Layouts'!
SystemOrganization addCategory: #'SimpleMorphic-Menus'!
SystemOrganization addCategory: #'SimpleMorphic-Support'!
SystemOrganization addCategory: #'SimpleMorphic-System-Support'!
SystemOrganization addCategory: #'SimpleMorphic-Text Support'!
SystemOrganization addCategory: #'SimpleMorphic-ToolBuilder'!
SystemOrganization addCategory: #'SimpleMorphic-Tools'!
SystemOrganization addCategory: #'SimpleMorphic-Tools-Menu'!
SystemOrganization addCategory: #'SimpleMorphic-Widgets'!
SystemOrganization addCategory: #'SimpleMorphic-Windows'!

UIManager subclass: #SimpleMorphicUIManager
	instanceVariableNames: 'interactiveParser uiProcess'
	classVariableNames: 'SMxActiveEvent SMxActiveHand SMxActiveWorld SMxWorld'
	poolDictionaries: ''
	category: 'SimpleMorphic-ToolBuilder'!

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:22'!
smxActiveEvent
	^SMxActiveEvent! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:23'!
smxActiveEvent: aMorphicEvent
	SMxActiveEvent := aMorphicEvent! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:22'!
smxActiveHand
	^SMxActiveHand! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:23'!
smxActiveHand: aHand
	SMxActiveHand := aHand! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:23'!
smxActiveWorld
	^SMxActiveWorld! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:23'!
smxActiveWorld: aWorld
	SMxActiveWorld := aWorld! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:31'!
smxWorld
	^SMxWorld! !

!SimpleMorphicUIManager class methodsFor: 'global state' stamp: 'JuanVuletich 11/1/2010 15:31'!
smxWorld: aWorld
	SMxWorld := aWorld! !

!SimpleMorphicUIManager class methodsFor: 'start and stop SimpleMorphic' stamp: 'JuanVuletich 11/2/2010 10:11'!
start
	"
	SimpleMorphicUIManager start
	"
	SMxPreferences initialize.
	SMxPreferences resetHaloSpecifications.
	SMxPreferences restoreDefaultFonts.
	UIManager default: SimpleMorphicUIManager new.
	SMxPasteUpMorph new install.
	UIManager default spawnNewProcess.
	Project uiProcess suspend! !

!SimpleMorphicUIManager class methodsFor: 'start and stop SimpleMorphic' stamp: 'JuanVuletich 11/2/2010 10:16'!
stop
	"
	SimpleMorphicUIManager stop
	"
	UIManager default: MorphicUIManager new.
	Project spawnNewProcess.
	UIManager default currentWorld restoreMorphicDisplay! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 14:09'!
buildMorphicNotifierFor: aDebugger labelled: label message: messageString

	^SMxBrowserWindow buildMorphicNotifierFor: aDebugger labelled: label message: messageString
! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 15:35'!
checkForNewDisplaySize

	"Check whether the screen size has changed and if so take appropriate actions"

	Display extent = DisplayScreen actualScreenSize ifTrue: [^ Display].
	DisplayScreen startUp.
	SMxWorld restoreMorphicDisplay! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/18/2010 09:29'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^SMxPopUpMenu chooseFrom: aList lines: linesArray title: aString
! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/28/2010 11:54'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^ (SMxSelectionMenu labelList: labelList lines: linesArray selections: valueList)
				startUpWithCaption: aString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/28/2010 16:38'!
chooseOrRequestFrom: labels lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	| menuIndex menu labels2 linesArray2 answer |

	^ (labels size = 0 or: [
		labels2 := {'new...'}, labels.
		linesArray2 := {1}, (linesArray collect: [ :l | l + 1 ]).
		menu := SMxPopUpMenu labelArray: labels2 lines: linesArray2.
		menuIndex := menu
			startUpWithCaption: aString.
		menuIndex = 0 ifTrue: [^ nil].
		menuIndex = 1])
			ifTrue: [
				answer := self
					request: aString, ' - Please type it'
					initialAnswer: 'type here'.
				answer = '' ifTrue: [ answer := nil ].
				answer ]
			ifFalse: [
				labels2 at: menuIndex ]! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/28/2010 15:36'!
confirm: queryString
	^SMxPopUpMenu confirm: queryString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/29/2010 10:27'!
confirm: queryString orCancel: cancelBlock
	^SMxPopUpMenu confirm: queryString orCancel: cancelBlock! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 15:32'!
currentWorld
	SMxActiveWorld ifNotNil: [^SMxActiveWorld].
	^SMxWorld! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 10:57'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	^ProgressInitiationException 
		display: titleString
		at: aPoint 
		from: minVal 
		to: maxVal 
		during: workBlock! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 12/11/2010 21:05'!
enterOrRequestFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. 
	 Answer the value selected of the selected item or the new string entered."
	
	"For now, just open the old FillInTheBlank"
	
	^SMxFillInTheBlankMorph request: aString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 15:09'!
explorer: anObjectExplorer for: anObject withLabel: label

	^SMxToolWindow explorer: anObjectExplorer for: anObject withLabel: label! !

!SimpleMorphicUIManager methodsFor: 'bitBlt' stamp: 'JuanVuletich 10/18/2010 09:16'!
grafPort	
	
	^ Display defaultBitBltClass asGrafPort! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 18:06'!
inform: aString
	
	^SMxPopUpMenu inform: aString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 18:18'!
menuClass
	^SMxMenuMorph! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 09:26'!
messageNames: aMessageNames inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	^SMxBrowserWindow messageNames: aMessageNames inMorphicWindowWithInitialSearchString: initialString
! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 09:26'!
messageSet: aMessageSet inMorphicWindowLabeled: labelString

	^SMxBrowserWindow messageSet: aMessageSet inMorphicWindowLabeled: labelString! !

!SimpleMorphicUIManager methodsFor: 'events' stamp: 'JuanVuletich 10/22/2010 16:01'!
onDebug: process context: context title: title full: bool	
	
	| topCtxt |	
	
	topCtxt := process isActiveProcess ifTrue: [thisContext] ifFalse: [process suspendedContext].
	(topCtxt hasContext: context) ifFalse: [^ self error: 'context not in process'].	
	ToolSet debug: process context: context label: title contents: nil fullView: bool! !

!SimpleMorphicUIManager methodsFor: 'events' stamp: 'JuanVuletich 11/1/2010 15:35'!
onPrimitiveError: aString
																																																																 	
																																																																	
	(String
		streamContents: 
			[:s | | context |
			s nextPutAll: '***System error handling failed***'.
			s cr; nextPutAll: aString.
			context := thisContext sender sender.
			20 timesRepeat: [context == nil ifFalse: [s cr; print: (context := context sender)]].
			s cr; nextPutAll: '-------------------------------'.
			s cr; nextPutAll: 'Type CR to enter an emergency evaluator.'.
			s cr; nextPutAll: 'Type any other character to restart.'])
		displayAt: 0 @ 0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard = Character cr ifTrue: [Transcripter emergencyEvaluator].
	
	SMxWorld install "init hands and redisplay"! !

!SimpleMorphicUIManager methodsFor: 'events' stamp: 'IgorStasenko 1/24/2011 16:43'!
onSnapshot: resuming	
	
	"The resuming argument is true when image boots from disk,
	and false, if user just did an image snapshot."
	
	
	"if we resuming, check if we're still interactive "
	
	(resuming and: [ Smalltalk isInteractive not ]) ifTrue: [
			^ self nonInteractiveManager onSnapshot: resuming ].

	SMxSystemWindow wakeUpTopWindowUponStartup! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 15:28'!
openBrowser: aBrowser asMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."

	^SMxBrowserWindow openBrowser: aBrowser asMorphClassEditing: editString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 15:31'!
openBrowser: aBrowser asMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"

	^SMxBrowserWindow openBrowser: aBrowser asMorphEditing: editString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 15:35'!
openBrowser: aBrowser asMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"

	^SMxBrowserWindow openBrowser: aBrowser asMorphMessageEditing: editString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 15:40'!
openBrowser: aBrowser asMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a message category."

	^SMxBrowserWindow openBrowser: aBrowser asMorphMsgCatEditing: editString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 12:15'!
openBrowser: aBrowser asMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."

	^SMxBrowserWindow openBrowser: aBrowser asMorphSysCatEditing: editString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 15:05'!
openChangeList: aChangeList asMorphName: labelString multiSelect: multiSelect
	"Open a morphic view for the messageSet, whose label is labelString. 
	The listView may be either single or multiple selection type"

	^SMxBrowserWindow openChangeList: aChangeList asMorphName: labelString multiSelect: multiSelect
! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:28'!
openChangeSorterAsMorph: aChangeSorter

	SMxBrowserWindow openChangeSorterAsMorph: aChangeSorter! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 14:09'!
openDebugger: aDebugger fullMorphicLabel: aLabelString
	"Open a full morphic debugger with the given label"

	^SMxBrowserWindow openDebugger: aDebugger fullMorphicLabel: aLabelString
! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'IgorStasenko 1/21/2011 19:06'!
openDebuggerOn: process context: context label: title contents: contentsStringOrNil fullView: bool 
	"Open a notifier in response to an error, halt, or notify. A notifier view
	just shows a short view of the sender stack and provides a menu that
	lets the user open a full debugger."
	| errorWasInUIProcess |
	errorWasInUIProcess := self spawnNewProcessIfThisIsUI: process.
	SMxWorldState
		addDeferredUIMessage: [[| debugger | 
			debugger := Debugger new
						process: process
						controller: nil
						context: context.
			"schedule debugger in deferred UI message to address
			redraw problems after opening a debugger e.g. from
			the testrunner."
			"SMxWorldState addDeferredUIMessage: ["
			bool
				ifTrue: [debugger openFullNoSuspendLabel: title]
				ifFalse: [debugger openNotifierContents: contentsStringOrNil label: title].
			debugger errorWasInUIProcess: errorWasInUIProcess.
			Debugger logDebuggerStackToFile
				ifTrue: [Smalltalk
						logError: title
						inContext: context]]
				on: Error
				do: [:ex | Debugger primitiveError: 'Orginal error: ' , title asString , '.
	Debugger error: '
							, ([ex description]
									on: Error
									do: ['a ' , ex class printString]) , ':']].
	process suspend! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/21/2010 17:28'!
openDualChangeSorterAsMorph: aDualChangeSorter

	SMxBrowserWindow openDualChangeSorterAsMorph: aDualChangeSorter! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/28/2010 16:10'!
openFileList: aFileList
	SMxToolWindow openFileList: aFileList! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 15:08'!
openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel
	"(Inspector openAsMorphOn: SystemOrganization withLabel: 'Test') openInWorld"

	^SMxToolWindow openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/26/2010 15:09'!
openProcessBrowserAsMorph: aProcessBrowser
	"Create a pluggable version of aProcessBrowser, answer a window"

	^SMxToolWindow openProcessBrowserAsMorph: aProcessBrowser! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 09:24'!
openTranscript: aTranscript asMorphLabel: aString
	"Build a morph viewing this transcriptStream"

	SMxSystemWindow openTranscript: aTranscript asMorphLabel: aString! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/28/2010 13:10'!
progressInitiationExceptionDefaultAction: anException

	| delta savedArea textFrame barFrame outerFrame result range lastW w f h textWidth currentVal |
	f := StrikeFont default.
	h := f height * 3//2.
	textWidth := (f widthOfString: anException progressTitle) + h.
	w := 150 max: textWidth.
	barFrame := Rectangle center: anException point extent: w@h.
	textFrame := 0@0 extent: w@h.
	textFrame := textFrame align: textFrame bottomCenter
					with: barFrame topCenter + (0@2).
	outerFrame := barFrame merge: textFrame.
	delta := outerFrame amountToTranslateWithin: Display boundingBox.
	barFrame := barFrame translateBy: delta.
	textFrame := textFrame translateBy: delta.
	outerFrame := outerFrame translateBy: delta.
	savedArea := Form fromDisplay: outerFrame.
	Display fillBlack: barFrame; fillWhite: (barFrame insetBy: 2).
	Display fillBlack: textFrame; fillWhite: (textFrame insetBy: 2).
	anException progressTitle displayOn: Display at: textFrame topLeft + (w-textWidth+h//2@4).
	range := anException maxVal = anException minVal ifTrue: [1] ifFalse: [anException maxVal - anException minVal].  "Avoid div by 0"
	lastW := 0.
	result := anException workBlock value:  "Supply the bar-update block for evaluation in the work block"
		[ :barVal |
		barVal 
			ifNotNil: [ currentVal := barVal ]
			ifNil: [		
				currentVal := currentVal + 1.
				currentVal >= anException maxVal
					ifTrue: [ currentVal := anException minVal ]].
		w := ((barFrame width-4) asFloat * ((currentVal-anException minVal) asFloat / range min: 1.0)) asInteger.
		w < lastW ifTrue: [
			Display fillWhite: (barFrame insetBy: 2)].
		w ~= lastW ifTrue: [
			Display fillGray: (barFrame topLeft + (2@2) extent: w@16).
			lastW := w]].
	savedArea displayOn: Display at: outerFrame topLeft.
	anException resume: result! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'StephaneDucasse 12/11/2010 21:05'!
request: queryString initialAnswer: defaultAnswer
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."

	^SMxFillInTheBlankMorph request: queryString initialAnswer: defaultAnswer ! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 11/1/2010 15:35'!
restoreDisplay

	SMxWorld fullRepaintNeeded! !

!SimpleMorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:10'!
resumeUIProcess: aProcess
	"Adopt aProcess as the project process -- probably because of proceeding from a debugger"

	uiProcess := aProcess.
	uiProcess resume! !

!SimpleMorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/2/2010 10:12'!
spawnNewProcess

	uiProcess := [
		[ UIManager default class == SimpleMorphicUIManager ] whileTrue: [
			SMxWorld doOneCycle. Processor yield ].
	] newProcess priority: Processor userSchedulingPriority.
	uiProcess resume! !

!SimpleMorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 10/26/2010 11:10'!
spawnNewProcessIfThisIsUI: suspendedProcess

	self uiProcess == suspendedProcess ifTrue: [
		self spawnNewProcess.
		^true
	].
	^false		"no new process was created"! !

!SimpleMorphicUIManager methodsFor: 'default actions' stamp: 'JuanVuletich 11/1/2010 10:21'!
syntaxErrorNotificationDefaultAction: anException

	Transcript show: '*** SYNTAX ERROR ***'; cr.
	Transcript show: anException; cr.
	Transcript show: (thisContext stack first: (20 min: thisContext stack size)); cr.
	anException return! !

!SimpleMorphicUIManager methodsFor: 'morphic process' stamp: 'JuanVuletich 11/1/2010 10:13'!
uiProcess

	^ uiProcess! !

!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'JuanVuletich 10/22/2010 16:14'!
unhandledErrorDefaultAction: anException

	"The current computation is terminated. The cause of the error should be logged or reported to the user. If the program is operating in an interactive debugging environment the computation should be suspended and the debugger activated."
"	SimpleMorphic := false.
	self halt."
	^ToolSet debugError: anException.! !

!Browser methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:09'!
smxWindowColor
	^Color lightGreen! !

!FileContentsBrowser methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:10'!
smxWindowColor
	^Color tan! !

!StringHolder methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/13/2010 11:05'!
smxEditorClass
	^TextEditor! !

!StringHolder methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/28/2010 15:35'!
smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items in a text pane"
	| donorMenu labels selectors |
	donorMenu := shifted
		ifTrue: [
			anEditorClass shiftedYellowButtonMenu]
		ifFalse: [
			anEditorClass yellowButtonMenu ].
	labels := donorMenu menuItems collect: [ :item | item contents ].
	selectors := donorMenu menuItems collect: [ :item | item selector ].
	aMenu labels: labels lines: #() selections: selectors.
	aMenu addTitle: 'Text Editor'; addStayUpIcons.
	^aMenu! !

!StringHolder methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:09'!
smxWindowColor
	^Color lightYellow! !

!ClassCommentVersionsBrowser methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:14'!
smxWindowColor
	^Color r: 0.769 g: 0.653 b: 1.0! !

!VersionsBrowser methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:14'!
smxWindowColor
	^Color r: 0.869 g: 0.753 b: 1.0! !

!Debugger methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/12/2010 14:26'!
smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass
	aMenu add: 'run to here' target: self selector: #runToSelection: argument: thisContext sender receiver selectionInterval.
	aMenu addLine.
	super smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass.
	^aMenu.! !

!Debugger methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:15'!
smxWindowColor
	^Color lightRed! !

!ChangeList methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:14'!
smxWindowColor
	^Color lightBlue! !

!ObjectExplorer methodsFor: '*SimpleMorphic' stamp: 'StephaneDucasse 12/8/2010 21:45'!
smxEditorClass
	^SmalltalkEditor
! !

!CodeHolder methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/13/2010 11:05'!
smxEditorClass
	^SmalltalkEditor! !

!FileList methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/13/2010 11:05'!
smxEditorClass
	^SmalltalkEditor! !

!FileList methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:15'!
smxWindowColor
	^Color lightMagenta! !

!Model methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 11/1/2010 15:57'!
topView
	"Find the first top view on me. Is there any danger of their being two
	with the same model? Any danger from ungarbage collected old views?
	Ask if schedulled?"
	dependents
		ifNil: [^ nil].
	dependents
		do: [:v | ((v isSystemWindow or: [ v is: #SMxSystemWindow])
					and: [v isInWorld])
				ifTrue: [^ v]].
	^ nil! !

Model subclass: #SMxSwitch
	instanceVariableNames: 'on onAction offAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools-Menu'!

!SMxSwitch commentStamp: 'JuanVuletich 10/9/2010 19:14' prior: 0!
I represent a selection setting and actions to take depending on a change in the setting. An instance has three attributes: state, which is either on or off; on action; and off action. The on and off actions are blocks of code that execute whenever the instance changes state. I am typically used as a menu item in conjunction with a SwitchView and a SwitchController.
1/24/96 sw: made this a subclass of Model, for faster dependents handling!

!SMxSwitch class methodsFor: 'instance creation' stamp: ''!
new
	"Answer an instance of me such that the on and off actions are set to nil
	('no action'), and the state is set to 'off'."

	^self newOff! !

!SMxSwitch class methodsFor: 'instance creation' stamp: ''!
newOff
	"Answer an instance of me such that the on and off actions are set to nil 
	('no action'), and the state is set to 'off'."

	^super new initializeOff! !

!SMxSwitch class methodsFor: 'instance creation' stamp: ''!
newOn
	"Answer an instance of me such that the on and off actions are set to nil 
	('no action'), and the state is set to 'on'."

	^super new initializeOn! !

!SMxSwitch methodsFor: 'state' stamp: ''!
clear
	"Set the state of the receiver to 'off'. If the state of the receiver was 
	previously 'on', then 'self change' is sent. The receiver's off action is 
	NOT executed."

	self isOn
		ifTrue: 
			[on := false.
			self changed]! !

!SMxSwitch methodsFor: 'action' stamp: 'jmv 3/1/2010 13:39'!
doAction: anAction 
	"Execute anAction if it is non-nil."

	anAction
		ifNotNil: [anAction value]! !

!SMxSwitch methodsFor: 'private' stamp: ''!
initializeOff

	on := false. 
	onAction := nil.
	offAction := nil! !

!SMxSwitch methodsFor: 'private' stamp: ''!
initializeOn

	on := true. 
	onAction := nil.
	offAction := nil! !

!SMxSwitch methodsFor: 'state' stamp: ''!
isOff
	"Answer whether the receiver is set off or not."

	^on not! !

!SMxSwitch methodsFor: 'state' stamp: ''!
isOn
	"Answer whether the receiver is set on or not."

	^on! !

!SMxSwitch methodsFor: 'action' stamp: 'jmv 12/30/2009 11:37'!
offAction: anAction 
	"Set the off action of the receiver to anAction."

	offAction := anAction! !

!SMxSwitch methodsFor: 'action' stamp: 'jmv 12/30/2009 11:37'!
onAction: anAction 
	"Set the on action of the receiver to anAction."

	onAction := anAction! !

!SMxSwitch methodsFor: 'state' stamp: ''!
set
	"Set the state of the receiver to 'on'. If the state of the receiver was 
	previously 'off', then 'self change' is sent. The receiver's on action is 
	NOT executed."

	self isOff
		ifTrue: 
			[on := true.
			self changed]! !

!SMxSwitch methodsFor: 'state' stamp: ''!
switch
	"Change the state of the receiver from 'on' to 'off' or from 'off' to 'on' (see 
	SMxSwitch|turnOn, SMxSwitch|turnOff)."

	self isOn
		ifTrue: [self turnOff]
		ifFalse: [self turnOn]! !

!SMxSwitch methodsFor: 'state' stamp: ''!
turnOff
	"Set the state of the receiver to 'off'. If the state of the receiver was 
	previously 'on', then 'self change' is sent and the receiver's off action is 
	executed."

	self isOn
		ifTrue: 
			[on := false.
			self changed.
			self doAction: offAction]! !

!SMxSwitch methodsFor: 'state' stamp: ''!
turnOn
	"Set the state of the receiver to 'on'. If the state of the receiver was 
	previously 'off', then 'self change' is sent and the receiver's on action is 
	executed."

	self isOff
		ifTrue: 
			[on := true.
			self changed.
			self doAction: onAction]! !

!MessageSet methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:13'!
smxWindowColor
	^Color lightBlue! !

!TranscriptStream methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/12/2010 13:36'!
smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items"
	^ StringHolder basicNew smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass! !

!TranscriptStream methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:15'!
smxWindowColor
	^Color lightOrange! !

!Inspector methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/13/2010 11:05'!
smxEditorClass
	^SmalltalkEditor! !

!MessageNames methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:10'!
smxWindowColor
	^Color r: 0.645 g: 1.0 b: 0.452! !

!TestRunner methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:15'!
smxWindowColor
	^Color r: 0.650 g: 0.753 b: 0.976! !

!ThreadSafeTranscript methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 14:48'!
smxEditorClass
	^ SmalltalkEditor! !

!ThreadSafeTranscript methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:26'!
smxWindowColor
	^Color lightOrange! !

!Workspace methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/13/2010 11:05'!
smxEditorClass
	^SmalltalkEditor! !

!ChangeSorter methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:14'!
smxWindowColor
	^Color lightBlue! !

MessageSend subclass: #SMxMorphicAlarm
	instanceVariableNames: 'scheduledTime numArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMorphicAlarm class methodsFor: 'instance creation' stamp: 'ar 9/11/2000 16:44'!
scheduledAt: scheduledTime receiver: aTarget selector: aSelector arguments: argArray
	^(self receiver: aTarget selector: aSelector arguments: argArray)
		scheduledTime: scheduledTime.! !

!SMxMorphicAlarm methodsFor: 'accessing' stamp: 'ar 9/11/2000 16:44'!
scheduledTime
	"Return the time (in milliseconds) that the receiver is scheduled to be executed"
	^scheduledTime! !

!SMxMorphicAlarm methodsFor: 'accessing' stamp: 'ar 9/11/2000 16:45'!
scheduledTime: msecs
	"Set the time (in milliseconds) that the receiver is scheduled to be executed"
	scheduledTime := msecs! !

!SMxMorphicAlarm methodsFor: 'evaluating' stamp: 'jmv 3/2/2010 16:18'!
value: anArgument
	| nArgs |
	numArgs ifNil:[numArgs := selector numArgs].
	nArgs := arguments ifNil:[0] ifNotNil:[arguments size].
	nArgs = numArgs ifTrue:[
		"Ignore extra argument"
		^self value].
	^arguments
		ifNil: [ receiver perform: selector with: anArgument]
		ifNotNil: [ receiver perform: selector withArguments: (arguments copyWith: anArgument)]! !

SMxMorphicAlarm subclass: #SMxStepMessage
	instanceVariableNames: 'stepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxStepMessage class methodsFor: 'instance creation' stamp: 'ar 10/22/2000 15:48'!
scheduledAt: scheduledTime stepTime: stepTime receiver: aTarget selector: aSelector arguments: argArray
	^(self receiver: aTarget selector: aSelector arguments: argArray)
		scheduledTime: scheduledTime;
		stepTime: stepTime! !

!SMxStepMessage methodsFor: 'printing' stamp: 'ar 10/22/2000 15:59'!
printOn: aStream
	super printOn: aStream.
	aStream 
		nextPut: $(;
		print: receiver;
		space;
		print: selector;
		space;
		print: scheduledTime;
		nextPut: $).! !

!SMxStepMessage methodsFor: 'testing' stamp: 'ar 10/22/2000 16:56'!
stepTime
	"Return the step time for this message. If nil, the receiver of the message will be asked for its #stepTime."
	^stepTime! !

!SMxStepMessage methodsFor: 'accessing' stamp: 'ar 10/22/2000 16:56'!
stepTime: aNumber
	"Set the step time for this message. If nil, the receiver of the message will be asked for its #stepTime."
	stepTime := aNumber! !

!DualChangeSorter methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:08'!
smxWindowColor
	^Color lightBlue! !

!Object methodsFor: '*SimpleMorphic' stamp: 'JuanVuletich 10/18/2010 16:07'!
smxWindowColor
	^Color white! !

Object subclass: #SMxBorderStyle
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'SimpleMorphic-Borders'!

!SMxBorderStyle commentStamp: 'kfr 10/27/2003 10:19' prior: 0!
See SMxBorderedMorph

BorderedMorh new borderStyle: (SMxBorderStyle inset width: 2); openInWorld.!

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'jmv 8/26/2008 10:20'!
borderStyleChoices
	"Answer the superset of all supported borderStyle symbols"

	^ #(simple inset raised)! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'sw 11/26/2001 15:58'!
borderStyleForSymbol: sym
	"Answer a border style corresponding to the given symbol"

	| aSymbol |
	aSymbol := sym == #none ifTrue: [#simple] ifFalse: [sym].
	^ self perform: aSymbol! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'ar 8/25/2001 17:26'!
default
	^Default ifNil:[Default := self new]! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'ar 11/26/2001 14:59'!
inset
	^SMxInsetBorder new! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'ar 11/26/2001 14:59'!
raised
	^SMxRaisedBorder new! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'sw 11/27/2001 15:22'!
simple
	"Answer a simple border style"

	^ SMxSimpleBorder new! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'ar 8/25/2001 16:19'!
width: aNumber
	^self width: aNumber color: Color black! !

!SMxBorderStyle class methodsFor: 'instance creation' stamp: 'ar 8/25/2001 16:19'!
width: aNumber color: aColor
	^SMxSimpleBorder new color: aColor; width: aNumber; yourself! !

!SMxBorderStyle methodsFor: 'comparing' stamp: 'ar 8/25/2001 18:38'!
= aBorderStyle
	^self species = aBorderStyle species
		and:[self style == aBorderStyle style
		and:[self width = aBorderStyle width
		and:[self color = aBorderStyle color]]].! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 18:15'!
baseColor
	^Color transparent! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 18:15'!
baseColor: aColor
	"Ignored"! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:07'!
color
	^Color transparent! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:07'!
color: aColor
	"Ignored"! !

!SMxBorderStyle methodsFor: 'drawing' stamp: 'ar 8/25/2001 17:01'!
drawLineFrom: startPoint to: stopPoint on: aCanvas
	^aCanvas line: startPoint to: stopPoint width: self width color: self color! !

!SMxBorderStyle methodsFor: 'drawing' stamp: 'ar 8/25/2001 16:24'!
frameRectangle: aRectangle on: aCanvas
	"Frame the given rectangle on aCanvas"
	aCanvas frameRectangle: aRectangle width: self width color: self color! !

!SMxBorderStyle methodsFor: 'comparing' stamp: 'ar 8/25/2001 16:08'!
hash
	"hash is implemented because #= is implemented"
	^self species hash bitXor: (self width hash bitXor: self color hash)! !

!SMxBorderStyle methodsFor: 'testing' stamp: 'ar 8/26/2001 19:30'!
isComplex
	^false! !

!SMxBorderStyle methodsFor: 'initialize' stamp: 'ar 8/25/2001 16:06'!
releaseCachedState
	"Release any associated cached state"! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 17:51'!
style
	^#none! !

!SMxBorderStyle methodsFor: 'color tracking' stamp: 'ar 8/25/2001 17:29'!
trackColorFrom: aMorph
	"If necessary, update our color to reflect a change in aMorphs color"! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:07'!
width
	^0! !

!SMxBorderStyle methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:07'!
width: aNumber
	"Ignored"! !

SMxBorderStyle subclass: #SMxSimpleBorder
	instanceVariableNames: 'baseColor color width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Borders'!

!SMxSimpleBorder commentStamp: 'kfr 10/27/2003 10:17' prior: 0!
see SMxBorderedMorph!

SMxSimpleBorder subclass: #SMxInsetBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Borders'!

!SMxInsetBorder commentStamp: 'kfr 10/27/2003 09:32' prior: 0!
see SMxBorderedMorph!

!SMxInsetBorder methodsFor: 'accessing' stamp: 'jmv 9/10/2009 18:47'!
bottomRightColor
	^color quiteWhiter! !

!SMxInsetBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 17:51'!
style
	^#inset! !

!SMxInsetBorder methodsFor: 'accessing' stamp: 'jmv 9/10/2009 18:46'!
topLeftColor
	^color quiteBlacker! !

!SMxInsetBorder methodsFor: 'color tracking' stamp: 'ar 8/25/2001 18:17'!
trackColorFrom: aMorph
	baseColor ifNil:[self color: aMorph insetColor].! !

SMxSimpleBorder subclass: #SMxRaisedBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Borders'!

!SMxRaisedBorder commentStamp: 'kfr 10/27/2003 09:32' prior: 0!
see SMxBorderedMorph!

!SMxRaisedBorder methodsFor: 'accessing' stamp: 'jmv 9/10/2009 18:47'!
bottomRightColor
	^color quiteBlacker! !

!SMxRaisedBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 17:51'!
style
	^#raised! !

!SMxRaisedBorder methodsFor: 'accessing' stamp: 'jmv 9/10/2009 18:47'!
topLeftColor
	^color quiteWhiter! !

!SMxRaisedBorder methodsFor: 'color tracking' stamp: 'ar 8/25/2001 18:17'!
trackColorFrom: aMorph
	baseColor ifNil:[self color: aMorph raisedColor].! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 18:19'!
baseColor
	^baseColor ifNil:[Color transparent]! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 18:23'!
baseColor: aColor
	| cc |
	cc := aColor isTransparent ifTrue:[nil] ifFalse:[aColor].
	baseColor = cc ifTrue:[^self].
	baseColor := cc.
	self releaseCachedState.
	self color: cc.
! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:09'!
bottomRightColor
	^color! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 18:19'!
color
	^color ifNil:[Color transparent]! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:10'!
color: aColor
	color = aColor ifTrue:[^self].
	color := aColor.
	self releaseCachedState.! !

!SMxSimpleBorder methodsFor: 'drawing' stamp: 'aoy 2/17/2003 01:14'!
drawLineFrom: startPoint to: stopPoint on: aCanvas 
	| lineColor |
	lineColor := (stopPoint truncated quadrantOf: startPoint truncated) > 2 
				ifTrue: [self topLeftColor]
				ifFalse: [self bottomRightColor].
	aCanvas 
		line: startPoint
		to: stopPoint 
		width: self width
		color: lineColor! !

!SMxSimpleBorder methodsFor: 'drawing' stamp: 'ar 8/25/2001 16:27'!
frameRectangle: aRectangle on: aCanvas
	aCanvas frameAndFillRectangle: aRectangle
		fillColor: Color transparent
		borderWidth: self width
		topLeftColor: self topLeftColor
		bottomRightColor: self bottomRightColor.! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 17:52'!
style
	^#simple! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:09'!
topLeftColor
	^color! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:35'!
width
	^width! !

!SMxSimpleBorder methodsFor: 'accessing' stamp: 'ar 8/25/2001 16:10'!
width: aNumber
	width = aNumber ifTrue:[^self].
	width := aNumber truncated max: (width isPoint ifTrue:[0@0] ifFalse:[0]).
	self releaseCachedState.! !

Object subclass: #SMxCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Support'!

!SMxCanvas commentStamp: '<historical>' prior: 0!
A canvas is a two-dimensional medium on which morphs are drawn in a device-independent manner. Canvases keep track of the origin and clipping rectangle, as well as the underlying drawing medium (such as a window, pixmap, or postscript script).

Subclasses must implement (at least) the following methods:
	* Drawing:
		#fillOval:color:borderWidth:borderColor:
		#frameAndFillRectangle:fillColor:borderWidth:borderColor:
		#drawPolygon:color:borderWidth:borderColor:
		#image:at:sourceRect:rule:
		#stencil:at:sourceRect:rule:
		#line:to:width:color:
		#paragraph:bounds:color:
		#text:bounds:font:color:
	* Support
		#clipBy:during:
		#translateBy:during:
		#translateBy:clippingTo:during:
		#transformBy:clippingTo:during:
!

!SMxCanvas methodsFor: 'drawing-support' stamp: 'ar 6/17/1999 02:53'!
clipBy: aRectangle during: aBlock
	"Set a clipping rectangle active only during the execution of aBlock.
	Note: In the future we may want to have more general clip shapes - not just rectangles"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 6/22/1999 14:07'!
clipRect
	"Return the currently active clipping rectangle"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 2/12/2000 18:17'!
contentsOfArea: aRectangle into: aForm
	"Return the contents of the given area"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'copying' stamp: 'JuanVuletich 11/1/2010 15:50'!
copy

	^ self shallowCopy
! !

!SMxCanvas methodsFor: 'accessing' stamp: ''!
depth

	^ Display depth
! !

!SMxCanvas methodsFor: 'drawing-general' stamp: 'jmv 6/14/2007 22:27'!
draw: anObject
	^self clipBy: anObject bounds during: [ :c | anObject drawOn: c]! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 2/16/2000 23:45'!
drawImage: aForm at: aPoint
	"Draw the given Form, which is assumed to be a Form or ColorForm"

	self drawImage: aForm
		at: aPoint
		sourceRect: aForm boundingBox! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 2/17/2000 01:47'!
drawImage: aForm at: aPoint sourceRect: sourceRect
	"Draw the given form."
	self shadowColor ifNotNil:[
		^self fillRectangle: ((aForm boundingBox intersect: sourceRect) translateBy: aPoint)
				color: self shadowColor].
	^self image: aForm
		at: aPoint
		sourceRect: sourceRect
		rule: Form over! !

!SMxCanvas methodsFor: 'drawing-general' stamp: 'ar 12/30/2001 15:23'!
drawMorph: aMorph
	self draw: aMorph! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/30/2001 20:35'!
drawString: s at: pt

	^ self drawString: s from: 1 to: s size at: pt font: nil color: Color black! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/31/2001 02:25'!
drawString: s at: pt font: aFont color: aColor

	^ self drawString: s from: 1 to: s size at: pt font: aFont color: aColor! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/30/2001 20:36'!
drawString: s from: firstIndex to: lastIndex at: pt font: font color: aColor
	self drawString: s from: firstIndex to: lastIndex in: (pt extent: 10000@10000) font: font color: aColor! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/30/2001 20:37'!
drawString: s from: firstIndex to: lastIndex in: boundsRect font: fontOrNil color: c
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/31/2001 02:39'!
drawString: s in: boundsRect
	^self drawString: s from: 1 to: s size in: boundsRect font: nil color: Color black! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'ar 12/31/2001 02:13'!
drawString: s in: boundsRect font: fontOrNil color: c
	^self drawString: s from: 1 to: s size in: boundsRect font: fontOrNil color: c! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'jmv 7/8/2010 11:36'!
drawStringOutline: s at: pt font: aFont color: aColor
	"
	Display getCanvas drawStringOutline: 'Outlined text' at: 10@10 font: nil color: Color red
	Display getCanvas drawString: 'Outlined text' at: 10@10 font: nil color: Color red
	"

	self drawStringOutline: s at: pt font: aFont color: aColor outlineColor: Color black! !

!SMxCanvas methodsFor: 'drawing-text' stamp: 'jmv 10/29/2009 14:10'!
drawStringOutline: s at: pt font: aFont color: aColor outlineColor: borderColor

	self
		drawString: s at: pt-(1@0) font: aFont color: borderColor;
		drawString: s at: pt+(1@0) font: aFont color: borderColor;
		drawString: s at: pt-(0@1) font: aFont color: borderColor;
		drawString: s at: pt+(0@1) font: aFont color: borderColor;
		drawString: s at: pt font: aFont color: aColor! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 6/22/1999 14:15'!
extent
	"Return the physical extent of the output device"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing' stamp: 'ar 6/17/1999 01:18'!
fillColor: aColor
	"Fill the receiver with the given color.
	Note: This method should be named differently since it is intended to fill the background and thus fills even if the color is transparent"
	^self fillRectangle: self clipRect color: (aColor alpha: 1.0).! !

!SMxCanvas methodsFor: 'drawing-ovals' stamp: 'ar 6/18/1999 08:45'!
fillOval: r color: c

	self fillOval: r color: c borderWidth: 0 borderColor: Color transparent.
! !

!SMxCanvas methodsFor: 'drawing-ovals' stamp: 'ar 6/18/1999 08:45'!
fillOval: r color: c borderWidth: borderWidth borderColor: borderColor
	"Fill the given oval."
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/18/1999 07:32'!
fillRectangle: r color: c
	"Fill the rectangle using the given color"
	^self 
		frameAndFillRectangle: r
		fillColor: c
		borderWidth: 0
		borderColor: Color transparent! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'jmv 8/26/2008 11:44'!
fillRectangle: aRectangle color: aColor borderStyle: aBorderStyle
	"Fill the given rectangle."
	self fillRectangle: (aRectangle insetBy: aBorderStyle width) color: aColor.
	aBorderStyle frameRectangle: aRectangle on: self! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/18/1999 07:34'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle.
	Note: The default implementation does not recognize any enhanced fill styles"
	self fillRectangle: aRectangle color: aFillStyle asColor.! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 8/25/2001 17:27'!
fillRectangle: aRectangle fillStyle: aFillStyle borderStyle: aBorderStyle
	"Fill the given rectangle."
	self fillRectangle: (aRectangle insetBy: aBorderStyle width) fillStyle: aFillStyle.
	aBorderStyle frameRectangle: aRectangle on: self! !

!SMxCanvas methodsFor: 'initialization' stamp: 'ar 5/27/2000 21:50'!
finish
	"If there are any pending operations on the receiver complete them. Do not return before all modifications have taken effect."
	^self flush! !

!SMxCanvas methodsFor: 'initialization' stamp: 'ar 2/9/1999 06:29'!
flush! !

!SMxCanvas methodsFor: 'other' stamp: ''!
flushDisplay
		" Dummy ."! !

!SMxCanvas methodsFor: 'other' stamp: ''!
forceToScreen:rect
	" dummy "
! !

!SMxCanvas methodsFor: 'accessing' stamp: 'jm 6/2/1998 06:39'!
form

	^ Display
! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/18/1999 07:32'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth borderColor: borderColor
	"Draw the rectangle using the given attributes"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'RAA 8/14/2000 14:22'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor
	"Draw the rectangle using the given attributes.
	Note: This is a *very* simple implementation"
	| bw pt |
	self frameAndFillRectangle: r
		fillColor: fillColor
		borderWidth: borderWidth
		borderColor: bottomRightColor.
	bottomRightColor = topLeftColor ifFalse: [
		bw := borderWidth asPoint.
		pt := r topLeft + (bw // 2).
		self line: pt to: pt + ((r extent x - bw x)@0) width: borderWidth color: topLeftColor.
		self line: pt to: pt + (0@(r extent y - bw y)) width: borderWidth color: topLeftColor.
	].! !

!SMxCanvas methodsFor: 'drawing-ovals' stamp: 'ar 6/18/1999 08:45'!
frameOval: r color: c

	self fillOval: r color: Color transparent borderWidth: 1 borderColor: c.
! !

!SMxCanvas methodsFor: 'drawing-ovals' stamp: 'ar 6/18/1999 08:45'!
frameOval: r width: w color: c

	self fillOval: r color: Color transparent borderWidth: w borderColor: c.
! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/18/1999 07:33'!
frameRectangle: r color: c

	self frameRectangle: r width: 1 color: c.
! !

!SMxCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/18/1999 07:33'!
frameRectangle: r width: w color: c
	^self frameAndFillRectangle: r fillColor: Color transparent borderWidth: w borderColor: c.! !

!SMxCanvas methodsFor: 'drawing-general' stamp: ''!
fullDraw: anObject
	^anObject fullDrawOn: self! !

!SMxCanvas methodsFor: 'drawing-general' stamp: 'StephaneDucasse 2/8/2011 09:30'!
fullDrawMorph: aMorph
	"Hook method for potential other canvases. In the core, this method looks supefluous but PostscriptCanvases and other canvases can specialized it for Morph rendering. Therefore it should not be merged with fullDraw:."
	
	self fullDraw: aMorph! !

!SMxCanvas methodsFor: 'drawing-obsolete' stamp: 'ar 2/12/2000 18:10'!
image: aForm at: aPoint
	"Note: This protocol is deprecated. Use #paintImage: instead."
	self image: aForm
		at: aPoint
		sourceRect: aForm boundingBox
		rule: Form paint.
! !

!SMxCanvas methodsFor: 'private' stamp: 'ar 2/12/2000 18:12'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Note: The public use of this protocol is deprecated. It will become private. Nobody in the outside world must assume that a thing like a combination rule has any specific effect."
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'private' stamp: 'ar 8/8/2001 14:21'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule alpha: sourceAlpha
	"Privately used for blending forms w/ constant alpha. Fall back to simpler case by defaul."
	^self image: aForm at: aPoint sourceRect: sourceRect rule: rule! !

!SMxCanvas methodsFor: 'testing' stamp: 'ar 6/22/1999 19:03'!
isShadowDrawing
	^false! !

!SMxCanvas methodsFor: 'testing' stamp: 'ar 6/22/1999 14:10'!
isVisible: aRectangle
	"Return true if the given rectangle is (partially) visible"
	^self clipRect intersects: aRectangle
! !

!SMxCanvas methodsFor: 'drawing' stamp: 'ar 6/17/1999 01:30'!
line: pt1 to: pt2 brushForm: brush
	"Obsolete - will be removed in the future"! !

!SMxCanvas methodsFor: 'drawing' stamp: 'jm 8/2/97 13:54'!
line: pt1 to: pt2 color: c

	self line: pt1 to: pt2 width: 1 color: c.
! !

!SMxCanvas methodsFor: 'drawing' stamp: 'ar 6/17/1999 01:31'!
line: pt1 to: pt2 width: w color: c
	"Draw a line using the given width and color"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing' stamp: 'aoy 2/15/2003 21:41'!
line: pt1 to: pt2 width: width color: color1 dashLength: s1 secondColor: color2 secondDashLength: s2 startingOffset: startingOffset 
	"Draw a line using the given width, colors and dash lengths.
	Originally written by Stephan Rudlof; tweaked by Dan Ingalls
	to use startingOffset for sliding offset as in 'ants' animations.
	Returns the sum of the starting offset and the length of this line."

	| dist deltaBig colors nextPhase segmentOffset phase segmentLength startPoint distDone endPoint segLens |
	dist := pt1 dist: pt2.
	dist = 0 ifTrue: [^startingOffset].
	s1 = 0 & (s2 = 0) ifTrue: [^startingOffset].
	deltaBig := pt2 - pt1.
	colors := { 
				color1.
				color2}.
	segLens := { 
				s1 asFloat.
				s2 asFloat}.
	nextPhase := { 
				2.
				1}.

	"Figure out what phase we are in and how far, given startingOffset."
	segmentOffset := startingOffset \\ (s1 + s2).
	segmentLength := segmentOffset < s1 
		ifTrue: 
			[phase := 1.
			s1 - segmentOffset]
		ifFalse: 
			[phase := 2.
			 s1 + s2 - segmentOffset].
	startPoint := pt1.
	distDone := 0.0.
	[distDone < dist] whileTrue: 
			[segmentLength := segmentLength min: dist - distDone.
			endPoint := startPoint + (deltaBig * segmentLength / dist).
			self 
				line: startPoint truncated
				to: endPoint truncated
				width: width
				color: (colors at: phase).
			distDone := distDone + segmentLength.
			phase := nextPhase at: phase.
			startPoint := endPoint.
			segmentLength := segLens at: phase].
	^startingOffset + dist! !

!SMxCanvas methodsFor: 'drawing' stamp: 'sr 4/27/2000 03:31'!
line: pt1 to: pt2 width: w1 color: c1 stepWidth: s1 secondWidth: w2 secondColor: c2 secondStepWidth: s2 
	"Draw a line using the given width, colors and steps; both steps can  
	have different stepWidths (firstStep, secondStep), draw widths and  
	colors."
	| bigSteps offsetPoint dist p1p2Vec deltaBig delta1 delta2 lastPoint bigStep |
	s1 = 0 & (s2 = 0) ifTrue: [^ self].
	dist := pt1 dist: pt2.
	dist = 0 ifTrue: [^ self].
	bigStep := s1 + s2.
	bigSteps := dist / bigStep.
	p1p2Vec := pt2 - pt1.
	deltaBig := p1p2Vec / bigSteps.
	delta1 := deltaBig * (s1 / bigStep).
	delta2 := deltaBig * (s2 / bigStep).
	dist <= s1
		ifTrue: 
			[self
				line: pt1 rounded
				to: pt2 rounded
				width: w1
				color: c1.
			^ self].
	0 to: bigSteps truncated - 1 do: 
		[:bigStepIx | 
		self
			line: (pt1 + (offsetPoint := deltaBig * bigStepIx)) rounded
			to: (pt1 + (offsetPoint := offsetPoint + delta1)) rounded
			width: w1
			color: c1.
		self
			line: (pt1 + offsetPoint) rounded
			to: (pt1 + (offsetPoint + delta2)) rounded
			width: w2
			color: c2].
	"if there was no loop, offsetPoint is nil"
	lastPoint := pt1 + ((offsetPoint ifNil: [0 @ 0])
					+ delta2).
	(lastPoint dist: pt2)
		<= s1
		ifTrue: [self
				line: lastPoint rounded
				to: pt2 rounded
				width: w1
				color: c1]
		ifFalse: 
			[self
				line: lastPoint rounded
				to: (lastPoint + delta1) rounded
				width: w1
				color: c1.
			self
				line: (lastPoint + delta1) rounded
				to: pt2
				width: w1
				color: c2]! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 6/22/1999 14:11'!
origin
	"Return the current origin for drawing operations"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 2/16/2000 23:48'!
paintImage: aForm at: aPoint
	"Draw the given Form, which is assumed to be a Form or ColorForm following the convention that zero is the transparent pixel value."

	self paintImage: aForm
		at: aPoint
		sourceRect: aForm boundingBox
! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'jmv 8/27/2009 13:33'!
paintImage: aForm at: aPoint sourceRect: sourceRect
	"Draw the given Form, which is assumed to be a Form or ColorForm following the convention that zero is the transparent pixel value."
	self shadowColor ifNotNil: [ :c |
		^self stencil: aForm at: aPoint sourceRect: sourceRect color: c ].
	^self image: aForm
		at: aPoint
		sourceRect: sourceRect
		rule: Form paint! !

!SMxCanvas methodsFor: 'drawing' stamp: 'jmv 9/21/2009 09:42'!
paragraph: paragraph bounds: bounds color: c
	"Draw the given paragraph"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing' stamp: 'ar 6/17/1999 01:32'!
point: p color: c
	"Obsolete - will be removed in the future"! !

!SMxCanvas methodsFor: 'initialization' stamp: 'jmv 5/14/2009 22:07'!
reset! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 2/17/2000 01:46'!
shadowColor
	"Return the current override color or nil if no such color exists"
	^nil! !

!SMxCanvas methodsFor: 'accessing' stamp: 'ar 2/17/2000 01:46'!
shadowColor: aColor
	"Set a shadow color. If set this color overrides any client-supplied color."! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 6/25/1999 12:17'!
stencil: stencilForm at: aPoint color: aColor
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	^self stencil: stencilForm
		at: aPoint
		sourceRect: stencilForm boundingBox
		color: aColor! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 6/25/1999 12:17'!
stencil: stencilForm at: aPoint sourceRect: sourceRect color: aColor
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	^self subclassResponsibility! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'ar 2/17/2000 14:05'!
translucentImage: aForm at: aPoint
	"Draw a translucent image using the best available way of representing translucency."
	self translucentImage: aForm
		at: aPoint
		sourceRect: aForm boundingBox! !

!SMxCanvas methodsFor: 'drawing-images' stamp: 'jmv 1/12/2010 12:30'!
translucentImage: aForm at: aPoint sourceRect: sourceRect
	"Draw a translucent image using the best available way of representing translucency.
	Note: This will be fixed in the future."
	self shadowColor ifNotNil: [ :c |
		^self stencil: aForm at: aPoint sourceRect: sourceRect color: c ].
	(self depth < 32 or: [ aForm mightBeTranslucent not]) 
		ifTrue: [ ^self paintImage: aForm at: aPoint sourceRect: sourceRect].
	self image: aForm
		at: aPoint
		sourceRect: sourceRect
		rule: Form blend! !

SMxCanvas subclass: #SMxFormCanvas
	instanceVariableNames: 'origin clipRect form port shadowColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Support'!

!SMxFormCanvas commentStamp: '<historical>' prior: 0!
Note that when shadowDrawing is true, shadowStipple may be either a color, for a solid shadow of the given color, or it may be a stipple used to simulate gray shading when the display cannot support alpha blending.!

!SMxFormCanvas class methodsFor: 'instance creation' stamp: 'jmv 3/11/2010 11:22'!
depth: depth over: aRectangle
	"Color black represents one for 1bpp"

	^ self new
		setForm: (Form extent: aRectangle extent depth: depth);
		setOrigin: aRectangle topLeft negated! !

!SMxFormCanvas class methodsFor: 'instance creation' stamp: ''!
extent: aPoint

	^ self extent: aPoint depth: Display depth
! !

!SMxFormCanvas class methodsFor: 'instance creation' stamp: ''!
extent: extent depth: depth

	^ self new setForm: (Form extent: extent depth: depth)! !

!SMxFormCanvas class methodsFor: 'instance creation' stamp: 'jmv 3/11/2010 11:21'!
forShadowOver: aRectangle
	"Color black represents one for 1bpp"

	^ self new
		setForm: (Form extent: aRectangle extent depth: 1);
		shadowColor: Color black;
		setOrigin: aRectangle topLeft negated! !

!SMxFormCanvas class methodsFor: 'instance creation' stamp: 'jm 8/2/97 13:54'!
on: aForm

	^ self new setForm: aForm
! !

!SMxFormCanvas class methodsFor: 'testing' stamp: 'JuanVuletich 10/10/2010 08:16'!
test1
	"SMxFormCanvas test1"

	| canvas |
	canvas := SMxFormCanvas extent: 200@200.
	canvas fillColor: (Color black).
	canvas line: 10@10 to: 50@30 width: 1 color: (Color red).
	canvas frameRectangle: ((20@20) corner: (120@120)) width: 4 color: (Color green).
	canvas point: 100@100 color: (Color black).
	canvas drawString: 'Hello, World!!' at: 40@40 font: nil color: (Color cyan).
	canvas fillRectangle: ((10@80) corner: (31@121)) color: (Color magenta).
	canvas fillOval: ((10@80) corner: (31@121)) color: (Color cyan).
	canvas frameOval: ((40@80) corner: (61@121)) color: (Color blue).
	canvas frameOval: ((70@80) corner: (91@121)) width: 3 color: (Color red alpha: 0.2).
	canvas fillRectangle: ((130@30) corner: (170@80)) color: (Color lightYellow).
	canvas showAt: 0@0.
! !

!SMxFormCanvas class methodsFor: 'testing' stamp: 'JuanVuletich 10/10/2010 08:17'!
test2
	"SMxFormCanvas test2"

	| baseCanvas p canvas |
	baseCanvas := SMxFormCanvas extent: 200@200.
	p := Sensor cursorPoint.
	[Sensor anyButtonPressed] whileFalse: [
		canvas := baseCanvas copyOffset: (Sensor cursorPoint - p).
		canvas fillColor: Color white.
		canvas line: 10@10 to: 50@30 width: 1 color: Color red.
		canvas frameRectangle: ((20@20) corner: (120@120)) width: 4 color: Color green.
		canvas point: 100@100 color: Color black.
		canvas drawString: 'Hello, World!!' at: 40@40 font: nil color: Color cyan.
		canvas fillRectangle: ((10@80) corner: (31@121)) color: Color magenta.
		canvas fillOval: ((10@80) corner: (31@121)) color: Color cyan.
		canvas frameOval: ((40@80) corner: (61@121)) color: Color blue.
		canvas frameOval: ((70@80) corner: (91@121)) width: 3 color: Color red.
		canvas fillRectangle: ((130@30) corner: (170@80)) color: Color lightYellow.
		canvas showAt: 0@0]! !

!SMxFormCanvas class methodsFor: 'testing' stamp: 'JuanVuletich 10/10/2010 08:17'!
test3
	"SMxFormCanvas test3"

	| baseCanvas canvas |
	baseCanvas := SMxFormCanvas extent: 200@200.
	baseCanvas fillColor: Color white.
	canvas := baseCanvas copyOffset: 10@10.
	canvas shadowColor: (Color black alpha: 0.5).
	canvas line: 10@10 to: 50@30 width: 1 color: Color red.
	canvas frameRectangle: ((20@20) corner: (120@120)) width: 4 color: Color green.
	canvas point: 100@100 color: Color black.
	canvas drawString: 'Hello, World!!' at: 40@40 font: nil color: Color cyan.
	canvas fillRectangle: ((10@80) corner: (31@121)) color: Color magenta.
	canvas fillOval: ((10@80) corner: (31@121)) color: Color cyan.
	canvas frameOval: ((40@80) corner: (61@121)) color: Color blue.
	canvas frameOval: ((70@80) corner: (91@121)) width: 3 color: Color red.
	canvas fillRectangle: ((130@30) corner: (170@80)) color: Color lightYellow.
	canvas showAt: 0@0! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 5/28/2000 17:11'!
allocateForm: extentPoint
	"Allocate a new form which is similar to the receiver"
	^form allocateForm: extentPoint! !

!SMxFormCanvas methodsFor: 'drawing-support' stamp: 'ar 6/17/1999 03:02'!
clipBy: aRectangle during: aBlock
	"Set a clipping rectangle active only during the execution of aBlock.
	Note: In the future we may want to have more general clip shapes - not just rectangles"
	^aBlock value: (self copyClipRect: aRectangle)! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 6/22/1999 14:06'!
clipRect
	"Return the currently active clipping rectangle"
	^ clipRect translateBy: origin negated! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 12/31/2001 03:26'!
contentsOfArea: aRectangle into: aForm
	| bb |
	self flush.
	bb := BitBlt toForm: aForm.
	bb sourceForm: form; combinationRule: Form over;
		sourceX: (aRectangle left + origin x); sourceY: (aRectangle top + origin y);
		width: aRectangle width; height: aRectangle height;
		copyBits.
	^aForm! !

!SMxFormCanvas methodsFor: 'copying' stamp: 'JuanVuletich 11/1/2010 15:49'!
copy
	"Make a copy the receiver on the same underlying Form but with its own grafPort."

	^ self shallowCopy resetGrafPort
! !

!SMxFormCanvas methodsFor: 'copying' stamp: 'ar 6/17/1999 02:51'!
copyClipRect: aRectangle
	^ self copyOrigin: origin clipRect: (aRectangle translateBy: origin)
! !

!SMxFormCanvas methodsFor: 'copying' stamp: 'ar 6/17/1999 02:52'!
copyOffset: aPoint
	^ self copyOrigin: origin + aPoint clipRect: clipRect! !

!SMxFormCanvas methodsFor: 'copying' stamp: 'ar 6/17/1999 02:52'!
copyOffset: aPoint clipRect: sourceClip
	"Make a copy of me offset by aPoint, and further clipped
	by sourceClip, a rectangle in the un-offset coordinates"
	^ self copyOrigin: aPoint + origin
		clipRect: ((sourceClip translateBy: origin) intersect: clipRect)! !

!SMxFormCanvas methodsFor: 'copying' stamp: 'ar 6/17/1999 02:52'!
copyOrigin: aPoint clipRect: aRectangle
	"Return a copy of this canvas with the given origin. The clipping rectangle of this canvas is the intersection of the given rectangle and the receiver's current clipping rectangle. This allows the clipping rectangles of nested clipping morphs to be composed."
	^ self copy
		setOrigin: aPoint
		clipRect: (clipRect intersect: aRectangle)! !

!SMxFormCanvas methodsFor: 'accessing' stamp: ''!
depth

	^ form depth
! !

!SMxFormCanvas methodsFor: 'drawing-text' stamp: 'JuanVuletich 10/11/2010 20:34'!
drawString: aString from: firstIndex to: lastIndex at: aPoint font: fontOrNil color: c
	| font |
	port colorMap: nil.
	font := fontOrNil ifNil: [StrikeFont default].
	font installOn: port foregroundColor: (self shadowColor ifNil:[c]) backgroundColor: nil.
	font displayString: aString on: port 
		from: firstIndex to: lastIndex at: (origin + aPoint) kern: font baseKern negated.! !

!SMxFormCanvas methodsFor: 'drawing-text' stamp: 'JuanVuletich 10/11/2010 20:34'!
drawString: aString from: firstIndex to: lastIndex in: bounds font: fontOrNil color: c
	| font portRect |
	port colorMap: nil.
	portRect := port clipRect.
	port clipByX1: bounds left + origin x 
		y1: bounds top + origin y 
		x2: bounds right + origin x 
		y2: bounds bottom + origin y.
	font := fontOrNil ifNil: [StrikeFont default].
	font installOn: port foregroundColor: (self shadowColor ifNil:[c]) backgroundColor: nil.
	font displayString: aString asString on: port 
		from: firstIndex to: lastIndex at: (bounds topLeft + origin) kern: font baseKern negated.
	port clipRect: portRect.! !

!SMxFormCanvas methodsFor: 'accessing' stamp: ''!
extent

	^ form extent! !

!SMxFormCanvas methodsFor: 'drawing' stamp: 'ar 5/14/2000 15:50'!
fillColor: c
	"Note: This always fills, even if the color is transparent."
	self setClearColor: c.
	port fillRect: form boundingBox offset: origin.! !

!SMxFormCanvas methodsFor: 'drawing-ovals' stamp: 'jmv 1/12/2010 12:31'!
fillOval: r color: fillColor borderWidth: borderWidth borderColor: borderColor
	| rect |
	"draw the border of the oval"
	rect := (r translateBy: origin) truncated.
	(borderWidth = 0 or: [borderColor isTransparent]) ifFalse:[
		self setFillColor: borderColor.
		(r area > 10000 or: [fillColor isOpaque not]) 
			ifTrue: [port frameOval: rect borderWidth: borderWidth]
			ifFalse: [port fillOval: rect]]. "faster this way"
	"fill the inside"
	fillColor isTransparent ifFalse:
		[self setFillColor: fillColor.
		port fillOval: (rect insetBy: borderWidth)].
! !

!SMxFormCanvas methodsFor: 'drawing-rectangles' stamp: 'jmv 8/26/2008 10:50'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle."
	| pattern |
	self shadowColor ifNotNil:
		[^self fillRectangle: aRectangle color: aFillStyle asColor].

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	(aFillStyle isSolidFill) 
		ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].
	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern := aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].
	self fillRectangle: aRectangle color: aFillStyle asColor! !

!SMxFormCanvas methodsFor: 'initialization' stamp: 'ar 5/27/2000 21:51'!
finish
	"If there are any pending operations on the receiver complete them. Do not return before all modifications have taken effect."
	form finish! !

!SMxFormCanvas methodsFor: 'other' stamp: ''!
flushDisplay
		Display deferUpdates: false; forceDisplayUpdate.! !

!SMxFormCanvas methodsFor: 'other' stamp: ''!
forceToScreen:rect
	^Display forceToScreen:rect.
! !

!SMxFormCanvas methodsFor: 'accessing' stamp: ''!
form

	^ form! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'jmv 3/11/2010 11:03'!
formWithOffset

	^ form offset: origin negated! !

!SMxFormCanvas methodsFor: 'drawing-rectangles' stamp: 'jmv 1/12/2010 12:31'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth borderColor: borderColor
	| rect |
	rect := r translateBy: origin.
	"draw the border of the rectangle"
	borderColor isTransparent ifFalse:[
		self setFillColor: borderColor.
		(r area > 10000 or: [fillColor isOpaque not]) ifTrue: [
			port frameRect: rect borderWidth: borderWidth.
		] ifFalse: ["for small rectangles, it's faster to fill the entire outer rectangle
					than to compute and fill the border rects"
					port fillRect: rect offset: origin]].

	"fill the inside"
	fillColor isTransparent ifFalse:
		[self setFillColor: fillColor.
		port fillRect: (rect insetBy: borderWidth) offset: origin].! !

!SMxFormCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 2/16/2000 22:07'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor

	| w h rect |
	"First use quick code for top and left borders and fill"
	self frameAndFillRectangle: r
		fillColor: fillColor
		borderWidth: borderWidth
		borderColor: topLeftColor.

	"Now use slow code for bevelled bottom and right borders"
	bottomRightColor isTransparent ifFalse: [
		borderWidth isNumber
			ifTrue: [w := h := borderWidth]
			ifFalse: [w := borderWidth x.   h := borderWidth y].
		rect := r translateBy: origin.
		self setFillColor: bottomRightColor.
		port 
			 frameRectRight: rect width: w;
			 frameRectBottom: rect height: h].
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 5/14/2001 23:34'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule 
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	port colorMap: (aForm colormapIfNeededFor: form); fillColor: nil.
	port image: aForm at: aPoint + origin sourceRect: sourceRect rule: rule.! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 8/8/2001 14:21'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule alpha: sourceAlpha
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	port colorMap: (aForm colormapIfNeededFor: form); fillColor: nil.
	port image: aForm at: aPoint + origin sourceRect: sourceRect rule: rule alpha: sourceAlpha.! !

!SMxFormCanvas methodsFor: 'drawing-rectangles' stamp: 'RAA 2/6/2001 14:00'!
infiniteFillRectangle: aRectangle fillStyle: aFillStyle

	| additionalOffset rInPortTerms clippedPort targetTopLeft clipOffset ex |

	"this is a bit of a kludge to get the form to be aligned where I *think* it should be.
	something better is needed, but not now"

	additionalOffset := 0@0.
	ex := aFillStyle form extent.
	rInPortTerms := aRectangle translateBy: origin.
	clippedPort := port clippedBy: rInPortTerms.
	targetTopLeft := clippedPort clipRect topLeft truncateTo: ex.
	clipOffset := rInPortTerms topLeft - targetTopLeft.
	additionalOffset := (clipOffset \\ ex) - ex.
	^aFillStyle
		displayOnPort: clippedPort
		offsetBy: additionalOffset
! !

!SMxFormCanvas methodsFor: 'testing' stamp: 'ar 2/17/2000 00:24'!
isShadowDrawing
	^ self shadowColor notNil! !

!SMxFormCanvas methodsFor: 'testing' stamp: 'ar 6/22/1999 14:08'!
isVisible: aRectangle
	"Optimization"
	(aRectangle right + origin x) < clipRect left	ifTrue: [^ false].
	(aRectangle left + origin x) > clipRect right	ifTrue: [^ false].
	(aRectangle bottom + origin y) < clipRect top	ifTrue: [^ false].
	(aRectangle top + origin y) > clipRect bottom	ifTrue: [^ false].
	^ true
! !

!SMxFormCanvas methodsFor: 'drawing' stamp: 'ar 5/14/2001 23:34'!
line: pt1 to: pt2 brushForm: brush
	| offset |
	offset := origin.
	self setPaintColor: Color black.
	port sourceForm: brush; fillColor: nil;
		sourceRect: brush boundingBox;
		colorMap: (brush colormapIfNeededFor: form);
		drawFrom: (pt1 + offset) to: (pt2 + offset)! !

!SMxFormCanvas methodsFor: 'drawing' stamp: 'ar 2/16/2000 22:07'!
line: pt1 to: pt2 width: w color: c
	| offset |
	offset := origin - (w // 2) asPoint.
	self setFillColor: c.
	port width: w; height: w;
		drawFrom: (pt1 + offset) to: (pt2 + offset)! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 6/22/1999 14:10'!
origin
	"Return the current origin for drawing operations"
	^ origin! !

!SMxFormCanvas methodsFor: 'drawing' stamp: 'JuanVuletich 10/13/2010 11:10'!
paragraph: para bounds: bounds color: c
	| scanner |
	self setPaintColor: c.
	scanner := (port clippedBy: (bounds translateBy: origin))
		displayScannerFor: para
		foreground: (self shadowColor ifNil: [c])
		background: Color transparent
		ignoreColorChanges: self shadowColor notNil.
	para
		displayOn: (self copyClipRect: bounds)
		using: scanner
		at: origin+ bounds topLeft! !

!SMxFormCanvas methodsFor: 'drawing' stamp: ''!
point: pt color: c

	form colorAt: (pt + origin) put: c.! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 5/28/2000 14:52'!
portClass
	"Return the class used as port"
	^Display defaultBitBltClass asGrafPort! !

!SMxFormCanvas methodsFor: 'printing' stamp: 'ar 5/28/2000 17:07'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll:' on: '; print: form.! !

!SMxFormCanvas methodsFor: 'initialization' stamp: 'ar 2/17/2000 00:21'!
reset

	origin := 0@0.							"origin of the top-left corner of this cavas"
	clipRect := (0@0 corner: 10000@10000).		"default clipping rectangle"
	self shadowColor: nil.! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 5/25/2000 17:25'!
resetGrafPort
	"Private!! Create a new grafPort for a new copy."

	port := self portClass toForm: form.
	port clipRect: clipRect.
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:52'!
setClearColor: aColor
	"Install a new clear color - e.g., a color is used for clearing the background"
	| clearColor |
	clearColor := aColor ifNil:[Color transparent].
	(clearColor isColor) ifFalse: [
		(clearColor isKindOf: InfiniteForm) ifFalse:[^self error:'Cannot install color'].
		^port fillPattern: clearColor; combinationRule: Form over].
	"Okay, so clearColor really *is* a color"
	port sourceForm: nil.
	port combinationRule: Form over.
	port fillPattern: clearColor.
	self depth = 8 ifTrue:[
		"Use a stipple pattern"
		port fillColor: (form balancedPatternFor: clearColor)].
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:52'!
setFillColor: aColor
	"Install a new color used for filling."
	| screen patternWord fillColor |
	fillColor := self shadowColor ifNil:[aColor].
	fillColor ifNil: [ fillColor := Color transparent].
	(fillColor isColor) ifFalse:[
		(fillColor isKindOf: InfiniteForm) ifFalse:[^self error:'Cannot install color'].
		^port fillPattern: fillColor; combinationRule: Form over].
	"Okay, so fillColor really *is* a color"
	port sourceForm: nil.
	fillColor isOpaque ifTrue: [
		port combinationRule: Form over.
		port fillPattern: fillColor.
		self depth = 8 ifTrue:[
			"In 8 bit depth it's usually a good idea to use a stipple pattern"
			port fillColor: (form balancedPatternFor: fillColor)].
		^self].

	self depth > 8 ifTrue:[
		"BitBlt setup for alpha masked transfer"
		port fillPattern: fillColor.
		self depth = 16
			ifTrue:[port alphaBits: fillColor privateAlpha; combinationRule: 30]
			ifFalse:[port combinationRule: Form blend].
		^self].
	"Can't represent actual transparency -- use stipple pattern"
	screen := Color translucentMaskFor: fillColor alpha depth: self depth.
	patternWord := form pixelWordFor: fillColor.
	port fillPattern: (screen collect: [:maskWord | maskWord bitAnd: patternWord]).
	port combinationRule: Form paint.
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 5/25/2000 17:25'!
setForm: aForm

	self reset.
	form := aForm.
	port := self portClass toForm: form.
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'jmv 3/11/2010 10:59'!
setOrigin: aPoint

	origin := aPoint! !

!SMxFormCanvas methodsFor: 'private' stamp: 'ar 6/22/1999 14:06'!
setOrigin: aPoint clipRect: aRectangle

	origin := aPoint.
	clipRect := aRectangle.
	port clipRect: aRectangle.
! !

!SMxFormCanvas methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:52'!
setPaintColor: aColor
	"Install a new color used for filling."
	| paintColor screen patternWord |
	paintColor := self shadowColor ifNil:[aColor].
	paintColor ifNil: [ paintColor := Color transparent].
	(paintColor isColor) ifFalse:[
		(paintColor isKindOf: InfiniteForm) ifFalse:[^self error:'Cannot install color'].
		^port fillPattern: paintColor; combinationRule: Form paint].
	"Okay, so paintColor really *is* a color"
	port sourceForm: nil.
	(paintColor isOpaque) ifTrue: [
		port fillPattern: paintColor.
		port combinationRule: Form paint.
		self depth = 8 ifTrue:[
			port fillColor: (form balancedPatternFor: paintColor)].
		^self].

	self depth > 8 ifTrue:[
		"BitBlt setup for alpha mapped transfer"
		port fillPattern: paintColor.
		self depth = 16
			ifTrue:[port alphaBits: paintColor privateAlpha; combinationRule: 31]
			ifFalse:[port combinationRule: Form blend].
		^self].

	"Can't represent actual transparency -- use stipple pattern"
	screen := Color translucentMaskFor: paintColor alpha depth: self depth.
	patternWord := form pixelWordFor: paintColor.
	port fillPattern: (screen collect: [:maskWord | maskWord bitAnd: patternWord]).
	port combinationRule: Form paint
! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 2/17/2000 00:26'!
shadowColor
	^shadowColor! !

!SMxFormCanvas methodsFor: 'accessing' stamp: 'ar 2/17/2000 00:26'!
shadowColor: aColor
	shadowColor := aColor! !

!SMxFormCanvas methodsFor: 'other' stamp: ''!
showAt: pt

	^ form displayAt: pt! !

!SMxFormCanvas methodsFor: 'other' stamp: 'ar 5/28/2000 12:09'!
showAt: pt invalidRects: updateRects
	| blt |
	blt := (BitBlt current toForm: Display)
		sourceForm: form;
		combinationRule: Form over.
	updateRects do:
		[:rect |
		blt sourceRect: rect;
			destOrigin: rect topLeft + pt;
			copyBits]! !

!SMxFormCanvas methodsFor: 'drawing-images' stamp: 'jmv 4/6/2009 17:03'!
stencil: stencilForm at: aPoint sourceRect: sourceRect color: aColor
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	self setPaintColor: aColor.
	port colorMap: stencilForm maskingMap.
	port stencil: stencilForm
		at: aPoint + origin
		sourceRect: sourceRect.! !

!SMxFormCanvas methodsFor: 'other' stamp: 'ar 5/28/2000 12:12'!
warpFrom: sourceQuad toRect: destRect
        ^ (WarpBlt current toForm: port destForm)
                combinationRule: Form paint;
                sourceQuad: sourceQuad destRect: (destRect translateBy: origin);
                clipRect: clipRect! !

Object subclass: #SMxDamageRecorder
	instanceVariableNames: 'invalidRects totalRepaint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Support'!

!SMxDamageRecorder class methodsFor: 'instance creation' stamp: ''!
new

	^ super new reset
! !

!SMxDamageRecorder methodsFor: 'recording' stamp: ''!
doFullRepaint
	"Record that a full redisplay is needed. No further damage rectangles will be recorded until after the next reset."

	^ totalRepaint := true.
! !

!SMxDamageRecorder methodsFor: 'recording' stamp: ''!
invalidRectsFullBounds: aRectangle
	"Return a collection of damaged rectangles for the given canvas. If a total repaint has been requested, return the given rectangle."

	totalRepaint
		ifTrue: [^ Array with: aRectangle]
		ifFalse: [^ invalidRects copy].

! !

!SMxDamageRecorder methodsFor: 'recording' stamp: 'jmv 10/2/2009 09:49'!
recordInvalidRect: newRect
	"Record the given rectangle in my damage list, a list of rectangular areas of the display that should be redraw on the next display cycle."
	"Details: Damaged rectangles are often identical or overlap significantly. In these cases, we merge them to reduce the number of damage rectangles that must be processed when the display is updated. Moreover, above a certain threshold, we ignore the individual rectangles completely, and simply do a complete repaint on the next cycle."

	| mergeRect a |
	totalRepaint ifTrue: [^ self].  "planning full repaint; don't bother collecting damage"

	invalidRects do: [ :rect |
		(newRect origin = rect origin and: [ newRect corner = rect corner ])
			ifTrue: [
				^ self ].
		((a := (rect intersect: newRect) area) > 40
			and: ["Avoid combining a vertical and horizontal rects.
				  Can make a big diff and we only test when likely."
				  a > (newRect area // 4) or: [ a > (rect area // 4)]])
			ifTrue: [
				"merge rectangle in place (see note below) if there is significant overlap"
				rect
					setOrigin: (rect origin min: newRect origin) truncated
					corner: (rect corner max: newRect corner) truncated.
				^ self]].

	invalidRects size >= 15 ifTrue: [
		"if there are too many separate areas, merge them all"
		mergeRect := Rectangle merging: invalidRects.
		self reset.
		invalidRects addLast: mergeRect].

	"add the given rectangle to the damage list"
	"Note: We make a deep copy of all rectangles added to the damage list,
		since rectangles in this list may be extended in place."
	invalidRects addLast:
		(newRect topLeft truncated corner: newRect bottomRight truncated)! !

!SMxDamageRecorder methodsFor: 'initialization' stamp: 'sma 6/5/2000 11:55'!
reset
	"Clear the damage list."

	invalidRects := OrderedCollection new: 15.
	totalRepaint := false
! !

!SMxDamageRecorder methodsFor: 'testing' stamp: 'dgd 2/22/2003 14:43'!
updateIsNeeded
	"Return true if the display needs to be updated."

	^totalRepaint or: [invalidRects notEmpty]! !

Object subclass: #SMxEllipseMidpointTracer
	instanceVariableNames: 'rect x y a b aSquared bSquared d1 d2 inFirstRegion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Support'!

!SMxEllipseMidpointTracer methodsFor: 'initialize' stamp: 'ar 6/28/1999 15:33'!
on: aRectangle
	rect := aRectangle.
	a := rect width // 2.
	b := rect height // 2.
	x := 0.
	y := b.
	aSquared := a * a.
	bSquared := b * b.
	d1 := bSquared - (aSquared * b) + (0.25 * aSquared).
	d2 := nil.
	inFirstRegion := true.! !

!SMxEllipseMidpointTracer methodsFor: 'computing' stamp: 'ar 6/28/1999 15:35'!
stepInY
	"Step to the next y value"
	inFirstRegion ifTrue:[
		"In the upper region we must step until we reach the next y value"
		[(aSquared * (y-0.5)) > (bSquared * (x+1))] whileTrue:[
			d1 < 0.0
				ifTrue:[d1 := d1 + (bSquared * (2*x+3)).
						x := x + 1]
				ifFalse:[d1 := d1 + (bSquared * (2*x+3)) + (aSquared * (-2*y+2)).
						y := y - 1.
						^x := x + 1]].
		"Stepping into second region"
		d2 := (bSquared * (x + 0.5) squared) + (aSquared * (y-1) squared) - (aSquared * bSquared).
		inFirstRegion := false.
	].
	"In the lower region each step is a y-step"
	d2 < 0.0
		ifTrue:[d2 := d2 + (bSquared * (2*x+2)) + (aSquared * (-2*y+3)).
				x := x + 1]
		ifFalse:[d2 := d2 + (aSquared * (-2*y+3))].
	y := y - 1.
	^x! !

Object subclass: #SMxEventHandler
	instanceVariableNames: 'mouseDownRecipient mouseDownSelector mouseMoveRecipient mouseMoveSelector mouseStillDownRecipient mouseStillDownSelector mouseUpRecipient mouseUpSelector mouseEnterRecipient mouseEnterSelector mouseLeaveRecipient mouseLeaveSelector mouseEnterDraggingRecipient mouseEnterDraggingSelector mouseLeaveDraggingRecipient mouseLeaveDraggingSelector keyStrokeRecipient keyStrokeSelector valueParameter startDragRecipient startDragSelector doubleClickSelector doubleClickRecipient doubleClickTimeoutSelector doubleClickTimeoutRecipient clickSelector clickRecipient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxEventHandler commentStamp: '<historical>' prior: 0!
Events in Morphic originate in a Hand, pass to a target morph, and are then dispatched by an SMxEventHandler.  EventHandlers support redirection of mouse and keyboard activity by specifying and independent recipient object and message selector for each of the possible events.  In addition each eventHandler can supply an optional value parameter for distinguishing between, eg, events from a number of otherwise identical source morphs.

The basic protocol of an event handler is to receive a message of the form
	mouseDown: event in: targetMorph
and redirect this as one of
	mouseDownRecipient perform: mouseDownSelector0
	mouseDownRecipient perform: mouseDownSelector1 with: event
	mouseDownRecipient perform: mouseDownSelector2 with: event with: targetMorph
	mouseDownRecipient perform: mouseDownSelector3 with: event with: targetMorph with: valueParameter
depending on the arity of the mouseDownSelector.
!

!SMxEventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 17:33'!
allRecipients
	"Answer a list, without duplication, of all the objects serving as recipients to any of the events I handle.  Intended for debugging/documentation use only"
	| aList |
	aList := OrderedCollection with: mouseDownRecipient with: mouseStillDownRecipient with: mouseUpRecipient with: mouseEnterRecipient with: mouseLeaveRecipient.
	aList addAll: (OrderedCollection with:  mouseEnterDraggingRecipient with: mouseLeaveDraggingRecipient with: doubleClickRecipient with: keyStrokeRecipient).
	aList add: mouseMoveRecipient.
	^ (aList copyWithout: nil) asSet asArray! !

!SMxEventHandler methodsFor: 'events' stamp: 'ar 10/7/2000 22:55'!
click: event fromMorph: sourceMorph 
	"This message is sent only when double clicks are handled."
	^ self
		send: clickSelector
		to: clickRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: 'LC 2/14/2000 08:38'!
doubleClick: event fromMorph: sourceMorph 
	^ self
		send: doubleClickSelector
		to: doubleClickRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: 'jcg 9/21/2001 13:06'!
doubleClickTimeout: event fromMorph: sourceMorph 
	^ self
		send: doubleClickTimeoutSelector
		to: doubleClickTimeoutRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 17:34'!
firstMouseSelector
	"Answer the selector corresponding to the first mouse-handling selector fielded.  Created in support of providing balloon-help for halo handles, triggered by the selector handled"

	mouseDownSelector ifNotNil: [^ mouseDownSelector].
	mouseMoveSelector ifNotNil:[^mouseMoveSelector].
	mouseStillDownSelector ifNotNil: [^ mouseStillDownSelector].
	mouseUpSelector ifNotNil: [^ mouseUpSelector].
	mouseEnterSelector ifNotNil: [^ mouseEnterSelector].
	mouseLeaveSelector ifNotNil: [^ mouseLeaveSelector].
	mouseEnterDraggingSelector ifNotNil: [^ mouseEnterDraggingSelector].
	mouseLeaveDraggingSelector ifNotNil: [^ mouseLeaveDraggingSelector].
	doubleClickSelector ifNotNil: [^ doubleClickSelector].
	^ nil! !

!SMxEventHandler methodsFor: 'testing' stamp: 'ar 10/7/2000 22:56'!
handlesClickOrDrag: evt
	clickRecipient ifNotNil:[^true].
	doubleClickRecipient ifNotNil:[^true].
	startDragRecipient ifNotNil:[^true].
	^false! !

!SMxEventHandler methodsFor: 'testing' stamp: 'nk 2/15/2004 08:57'!
handlesGestureStart: evt
	"Does the associated morph want to handle gestures?"
	^false! !

!SMxEventHandler methodsFor: 'testing' stamp: 'jmv 11/10/2008 12:57'!
handlesKeyboard
	keyStrokeRecipient ifNotNil: [^ true].
	^ false! !

!SMxEventHandler methodsFor: 'testing' stamp: 'nk 2/15/2004 08:13'!
handlesMouseDown: evt
	mouseDownRecipient ifNotNil: [^ true].
	mouseStillDownRecipient ifNotNil: [^ true].
	mouseUpRecipient ifNotNil: [^ true].
	(self handlesClickOrDrag: evt) ifTrue:[^true].
	^self handlesGestureStart: evt! !

!SMxEventHandler methodsFor: 'testing' stamp: 'ar 10/25/2000 17:33'!
handlesMouseMove: evt
	^mouseMoveRecipient notNil and:[mouseMoveSelector notNil]! !

!SMxEventHandler methodsFor: 'testing' stamp: ''!
handlesMouseOver: evt
	mouseEnterRecipient ifNotNil: [^ true].
	mouseLeaveRecipient ifNotNil: [^ true].
	^ false! !

!SMxEventHandler methodsFor: 'testing' stamp: 'di 9/15/1998 16:35'!
handlesMouseOverDragging: evt
	mouseEnterDraggingRecipient ifNotNil: [^ true].
	mouseLeaveDraggingRecipient ifNotNil: [^ true].
	^ false! !

!SMxEventHandler methodsFor: 'testing' stamp: 'ar 10/22/2000 17:05'!
handlesMouseStillDown: evt
	^mouseStillDownRecipient notNil and:[mouseStillDownSelector notNil]! !

!SMxEventHandler methodsFor: 'events' stamp: ''!
keyStroke: event fromMorph: sourceMorph
	^ self send: keyStrokeSelector to: keyStrokeRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'access' stamp: 'StephaneDucasse 1/7/2011 18:05'!
methodRefList
	"Return a MethodReference for each message I can send. tk 9/13/97, raa 
	5/29/01 "
	| list adder |
	list := SortedCollection new.
	adder := [:recip :sel | recip
				ifNotNil: [list
						add: (SourcedMethodReference new
								setStandardClass: (recip class whichClassIncludesSelector: sel)
								methodSymbol: sel)]].
	adder value: mouseDownRecipient value: mouseDownSelector.
	adder value: mouseMoveRecipient value: mouseMoveSelector.
	adder value: mouseStillDownRecipient value: mouseStillDownSelector.
	adder value: mouseUpRecipient value: mouseUpSelector.
	adder value: mouseEnterRecipient value: mouseEnterSelector.
	adder value: mouseLeaveRecipient value: mouseLeaveSelector.
	adder value: mouseEnterDraggingRecipient value: mouseEnterDraggingSelector.
	adder value: mouseLeaveDraggingRecipient value: mouseLeaveDraggingSelector.
	adder value: doubleClickRecipient value: doubleClickSelector.
	adder value: keyStrokeRecipient value: keyStrokeSelector.
	^ list! !

!SMxEventHandler methodsFor: 'events' stamp: 'ar 10/7/2000 22:54'!
mouseDown: event fromMorph: sourceMorph 
	"Take double-clicks into account."
	((self handlesClickOrDrag: event) and:[event redButtonPressed]) ifTrue:[
		event hand waitForClicksOrDrag: sourceMorph event: event.
	].
	^self
		send: mouseDownSelector
		to: mouseDownRecipient
		withEvent: event
		fromMorph: sourceMorph.
! !

!SMxEventHandler methodsFor: 'access' stamp: 'di 9/14/1998 08:32'!
mouseDownSelector
	^ mouseDownSelector! !

!SMxEventHandler methodsFor: 'events' stamp: ''!
mouseEnter: event fromMorph: sourceMorph
	^ self send: mouseEnterSelector to: mouseEnterRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: 'di 9/15/1998 16:35'!
mouseEnterDragging: event fromMorph: sourceMorph
	^ self send: mouseEnterDraggingSelector to: mouseEnterDraggingRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: ''!
mouseLeave: event fromMorph: sourceMorph
	^ self send: mouseLeaveSelector to: mouseLeaveRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: 'di 9/15/1998 16:35'!
mouseLeaveDragging: event fromMorph: sourceMorph
	^ self send: mouseLeaveDraggingSelector to: mouseLeaveDraggingRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: 'ar 10/25/2000 17:32'!
mouseMove: event fromMorph: sourceMorph
	^ self send: mouseMoveSelector to: mouseMoveRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'events' stamp: ''!
mouseStillDown: event fromMorph: sourceMorph
	^ self send: mouseStillDownSelector to: mouseStillDownRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 18:27'!
mouseStillDownRecipient
	^mouseStillDownRecipient! !

!SMxEventHandler methodsFor: 'access' stamp: 'ar 10/25/2000 18:27'!
mouseStillDownSelector
	^mouseStillDownSelector! !

!SMxEventHandler methodsFor: 'events' stamp: ''!
mouseUp: event fromMorph: sourceMorph
	^ self send: mouseUpSelector to: mouseUpRecipient withEvent: event fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'access' stamp: 'di 9/14/1998 08:32'!
mouseUpSelector
	^ mouseUpSelector! !

!SMxEventHandler methodsFor: 'initialization' stamp: 'JuanVuletich 10/10/2010 08:15'!
on: eventName send: selector to: recipient
	eventName == #mouseDown ifTrue:
		[mouseDownRecipient := recipient.  mouseDownSelector := selector. ^ self].
	eventName == #mouseMove ifTrue:
		[mouseMoveRecipient := recipient.  mouseMoveSelector := selector. ^ self].
	eventName == #mouseStillDown ifTrue:
		[mouseStillDownRecipient := recipient.  mouseStillDownSelector := selector. ^ self].
	eventName == #mouseUp ifTrue:
		[mouseUpRecipient := recipient.  mouseUpSelector := selector. ^ self].
	eventName == #mouseEnter ifTrue:
		[mouseEnterRecipient := recipient.  mouseEnterSelector := selector. ^ self].
	eventName == #mouseLeave ifTrue:
		[mouseLeaveRecipient := recipient.  mouseLeaveSelector := selector. ^ self].
	eventName == #mouseEnterDragging ifTrue:
		[mouseEnterDraggingRecipient := recipient.  mouseEnterDraggingSelector := selector. ^ self].
	eventName == #mouseLeaveDragging ifTrue:
		[mouseLeaveDraggingRecipient := recipient.  mouseLeaveDraggingSelector := selector. ^ self].
	eventName == #click ifTrue:
		[clickRecipient := recipient. clickSelector := selector. ^ self].
	eventName == #doubleClick ifTrue:
		[doubleClickRecipient := recipient. doubleClickSelector := selector. ^ self].
	eventName == #doubleClickTimeout ifTrue:
		[doubleClickTimeoutRecipient := recipient. doubleClickTimeoutSelector := selector. ^ self].
	eventName == #startDrag ifTrue:
		[startDragRecipient := recipient. startDragSelector := selector. ^ self].
	eventName == #keyStroke ifTrue:
		[keyStrokeRecipient := recipient.  keyStrokeSelector := selector. ^ self].
	eventName == #gesture ifTrue:
		[ ^self onGestureSend: selector to: recipient ].
	self error: 'Event name, ' , eventName , ' is not recognizable.'
! !

!SMxEventHandler methodsFor: 'initialization' stamp: 'JuanVuletich 10/10/2010 08:15'!
on: eventName send: selector to: recipient withValue: value
	selector numArgs = 3 ifFalse:
		[self halt: 'Warning: value parameters are passed as last of 3 arguments'].
	self on: eventName send: selector to: recipient.
	valueParameter := value
! !

!SMxEventHandler methodsFor: 'initialization' stamp: 'nk 2/15/2004 08:59'!
onGestureSend: selector to: recipient! !

!SMxEventHandler methodsFor: 'printing' stamp: 'jmv 3/2/2010 17:01'!
printOn: aStream 
	| aVal recipients |
	super printOn: aStream.
	#('mouseDownSelector' 'mouseStillDownSelector' 'mouseUpSelector' 'mouseEnterSelector' 'mouseLeaveSelector' 'mouseEnterDraggingSelector' 'mouseLeaveDraggingSelector' 'doubleClickSelector' 'keyStrokeSelector') 
		do: [ :aName | 
			(aVal := self instVarNamed: aName) ifNotNil: [ 
				aStream nextPutAll: '; ' , aName , '=' , aVal]].
	(recipients := self allRecipients) notEmpty 
		ifTrue: [
			aStream nextPutAll: ' recipients: '.
			recipients printOn: aStream]! !

!SMxEventHandler methodsFor: 'events' stamp: 'JuanVuletich 10/10/2010 08:15'!
send: selector to: recipient withEvent: event fromMorph: sourceMorph
	| arity |
	recipient ifNil: [^ self].
	arity := selector numArgs.
	arity = 0 ifTrue:
		[^ recipient perform: selector].
	arity = 1 ifTrue:
		[^ recipient perform: selector with: event].
	arity = 2 ifTrue:
		[^ recipient perform: selector with: event with: sourceMorph].
	arity = 3 ifTrue:
		[^ recipient perform: selector with: valueParameter with: event with: sourceMorph].
	self error: 'Event handling selectors must be Symbols and take 0-3 arguments'! !

!SMxEventHandler methodsFor: 'events' stamp: 'mir 5/23/2000 17:43'!
startDrag: event fromMorph: sourceMorph 
	^ self
		send: startDragSelector
		to: startDragRecipient
		withEvent: event
		fromMorph: sourceMorph! !

!SMxEventHandler methodsFor: 'copying' stamp: 'tk 1/22/2001 17:43'!
veryDeepFixupWith: deepCopier
	| old |
	"ALL inst vars were weakly copied.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
1 to: self class instSize do:
	[:ii | old := self instVarAt: ii.
	self instVarAt: ii put: (deepCopier references at: old ifAbsent: [old])].

! !

!SMxEventHandler methodsFor: 'copying' stamp: 'JuanVuletich 10/9/2010 19:06'!
veryDeepInner: deepCopier
	"ALL fields are weakly copied!!  Can't duplicate an object by duplicating a button that activates it.  See DeepCopier."

	super veryDeepInner: deepCopier.
	"just keep old pointers to all fields"
! !

Object subclass: #SMxHaloSpec
	instanceVariableNames: 'addHandleSelector horizontalPlacement verticalPlacement color iconSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxHaloSpec commentStamp: 'kfr 10/27/2003 16:23' prior: 0!
Sets spec's for how handles are layed out in a halo.!

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 19:54'!
addHandleSelector
	^ addHandleSelector! !

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
color
	^ color! !

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
horizontalPlacement
	^ horizontalPlacement! !

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 19:54'!
horizontalPlacement: hp verticalPlacement: vp color: col iconSymbol: is addHandleSelector: sel
	horizontalPlacement := hp.
	verticalPlacement := vp.
	color:= col.
	iconSymbol := is asSymbol.
	addHandleSelector := sel! !

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
iconSymbol
	^ iconSymbol! !

!SMxHaloSpec methodsFor: 'printing' stamp: 'sw 11/15/2001 16:31'!
printOn: aStream
	"Add a textual printout representing the receiver to a stream"

	super printOn: aStream.
	aStream nextPutAll: ' (', addHandleSelector asString, ' ', iconSymbol asString, ')'! !

!SMxHaloSpec methodsFor: 'as yet unclassified' stamp: 'sw 1/25/2000 18:41'!
verticalPlacement
	^ verticalPlacement! !

Object subclass: #SMxLayoutFrame
	instanceVariableNames: 'leftFraction leftOffset topFraction topOffset rightFraction rightOffset bottomFraction bottomOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Layouts'!

!SMxLayoutFrame commentStamp: '<historical>' prior: 0!
I define a frame for positioning some morph in a proportional layout.

Instance variables:
	leftFraction 
	topFraction 
	rightFraction 
	bottomFraction 	<Float>		The fractional distance (between 0 and 1) to place the morph in its owner's bounds
	leftOffset 
	topOffset 
	rightOffset 
	bottomOffset 	<Integer>	Fixed pixel offset to apply after fractional positioning (e.g., "10 pixel right of the center of the owner")!

!SMxLayoutFrame class methodsFor: 'accessing' stamp: 'JW 2/1/2001 12:48'!
classVersion
	^1 "changed treatment of bottomOffset and rightOffset"
! !

!SMxLayoutFrame class methodsFor: 'as yet unclassified' stamp: 'jmv 5/28/2009 14:02'!
fractions: fractionsOrNil
	^self new fractions: fractionsOrNil! !

!SMxLayoutFrame class methodsFor: 'as yet unclassified' stamp: 'jmv 5/28/2009 00:53'!
fractions: fractionsOrNil offsets: offsetsOrNil

	^self new fractions: fractionsOrNil offsets: offsetsOrNil! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
bottomFraction
	^bottomFraction! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
bottomFraction: aNumber
	bottomFraction := aNumber! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
bottomOffset
	^bottomOffset! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
bottomOffset: anInteger
	bottomOffset := anInteger! !

!SMxLayoutFrame methodsFor: 'initialization' stamp: 'jmv 10/7/2009 10:38'!
fractions: fractions

	topFraction := fractions top.
	leftFraction := fractions left.
	bottomFraction := fractions bottom.
	rightFraction := fractions right.

	leftOffset := topOffset := 0.
	rightOffset := bottomOffset := 0! !

!SMxLayoutFrame methodsFor: 'initialization' stamp: 'jmv 5/28/2009 00:52'!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	topFraction := fractions top.
	leftFraction := fractions left.
	bottomFraction := fractions bottom.
	rightFraction := fractions right.

	offsets := offsetsOrNil ifNil: [0].
	offsets isNumber
		ifTrue: [
			leftOffset := topOffset := offsets.
			rightOffset := bottomOffset := offsets negated ]
		ifFalse: [
			offsets isPoint
				ifTrue: [
					leftOffset := offsets x.
					rightOffset := offsets x negated.
					topOffset := offsets y.
					bottomOffset := offsets y negated  ]
				ifFalse: [
					leftOffset := offsets left.
					rightOffset := offsets right.
					topOffset := offsets top.
					bottomOffset := offsets bottom ]]! !

!SMxLayoutFrame methodsFor: 'testing' stamp: 'jmv 8/23/2010 13:34'!
is: aSymbol
	^ aSymbol = #SMxLayoutFrame or: [ super is: aSymbol ]! !

!SMxLayoutFrame methodsFor: 'layout' stamp: 'JW 2/1/2001 13:04'!
layout: oldBounds in: newBounds
	"Return the proportional rectangle insetting the given bounds"
	| left right top bottom |
	leftFraction ifNotNil:[
		left := newBounds left + (newBounds width * leftFraction).
		leftOffset ifNotNil:[left := left + leftOffset]].
	rightFraction ifNotNil:[
		right := newBounds right - (newBounds width * (1.0 - rightFraction)).
		rightOffset ifNotNil:[right := right + rightOffset]].
	topFraction ifNotNil:[
		top := newBounds top + (newBounds height * topFraction).
		topOffset ifNotNil:[top := top + topOffset]].
	bottomFraction ifNotNil:[
		bottom := newBounds bottom - (newBounds height * (1.0 - bottomFraction)).
		bottomOffset ifNotNil:[bottom := bottom + bottomOffset]].
	left ifNil:[ right 
			ifNil:[left := oldBounds left. right := oldBounds right]
			ifNotNil:[left := right - oldBounds width]].
	right ifNil:[right := left + oldBounds width].
	top ifNil:[ bottom 
			ifNil:[top := oldBounds top. bottom := oldBounds bottom]
			ifNotNil:[top := bottom - oldBounds height]].
	bottom ifNil:[bottom := top + oldBounds height].
	^(left rounded @ top rounded) corner: (right rounded @ bottom rounded)! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
leftFraction: aNumber
	leftFraction := aNumber! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:35'!
leftOffset
	^leftOffset! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:36'!
rightFraction: aNumber
	rightFraction := aNumber! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:36'!
rightOffset
	^rightOffset! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:36'!
topFraction
	^topFraction! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:36'!
topFraction: aNumber
	topFraction := aNumber! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:37'!
topOffset
	^topOffset! !

!SMxLayoutFrame methodsFor: 'accessing' stamp: 'ar 10/23/2000 19:37'!
topOffset: anInteger
	topOffset := anInteger! !

Object subclass: #SMxMenuIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons TranslatedIcons'
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxMenuIcons commentStamp: 'sd 11/9/2003 14:09' prior: 0!
I represent a registry for icons.  You can see the icons I contain using the following script:

| dict methods |
dict := Dictionary new. 
methods := SMxMenuIcons class selectors select: [:each | '*Icon' match: each asString].
methods do: [:each | dict at: each put: (SMxMenuIcons perform: each)].
GraphicalDictionaryMenu openOn: dict withLabel: 'SMxMenuIcons'!

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:40'!
appearanceIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'appearanceIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #appearanceIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABrElEQVR4Xo1TIdOkMAxFIvkL
SORKbCUSiUUiK2uRyEpsJbISi6ysrEUiK9+XtMu3s3O3t9eZN0kh76VJ2uLTsqoHw5sJt198
W2aRMFLAykciuHVMAsfSJ8zDA1qN+JyRiJczsO7CcQI2ABee6wy4gk0xahDvIpw1mIGjUqzY
gMYCtQF254B1IkcDRqUYvw6QffsSOZY2HZ2P6HSPxXv0LqLbz5QVc4241oCsED2pXzsO9cgC
7LCAGjtwD2TXIIYZ8aT0QWccMiHuY/rH5fCeYwtvuvRxkw22qUli8DKDiX4kOz3RU2Po//VI
1ogSRdC0iQupPoNvghVPgsgwbcZRZQGydqxQcN1BNznYUyOPLmexmRBNkwBd5T6QTUK6hB3K
3Id57KH6Bk7VL4H9Rcwo4ZYSu9cJYamgu+p9nNxIVn3Lyv5GJa00/6VAfbaoo0j+LKo/LxWL
OFn9Crh5RTioOh2wqxLirBOWqfh8tXk897HtsGGj+7P2EddY0p0oEFUB2Vb/fhtcHwdG6su5
zjSkNu8p89yW3x/WfRKuU9O8WYDtJJr/I9+LCbfI38g/PS/7Fs4fl/oAAAAASUVORK5CYII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:40'!
backAndForthIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'backAndForthIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #backAndForthIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAwElEQVR4XmPABoLq+v9jwwyE
AExh4vQ1/+UeLEXBIDG8BuHSiMsgrJpV/+8EKzr7//X/nLVHUTSCxDb8fwAWxzAExIEpBCn6
//49hgEgMWRD4AYgOx2mGWYAiI9sAFZDYLaDBEGSyAphbHQMMwRuALpmYjDIUqfUYogBpGhE
xnADkP0OcyIyxqYZpAduAHoAwgIRGaNrBulBiQlssYAejVg144pKbAbANONNjdiSLyiFwlIp
Vs1UyUwIwPiflOwMAFFXgLlnDom+AAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:40'!
backIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'backIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #backIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAArklEQVR4XmPABoLq+v9jwwyE
AExh4vQ1/+UeLEXBIDG8BuHSiMsgrJpV/+8EKzr7/zUY56w9SpwhIA5McsP/B2DN/9+/x2kA
CMMNQHY6smZCBsANgdmOrhkXhnkPxQBiNSMbAnKdU2oxxABSNGM1AMRBNgTmTBjG5gUUA0D+
QTcEFojYMCi60/6fQY0JbIagxwJII4Zm9KhENgSXAXhTI8wQGEa3GatmqmQmcrMzACmnbrB3
L5QVAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:21'!
blankIcon
	^ Icons
		at: #blankIcon
		ifAbsentPut: [
			Form
				extent: 16 @ 16
				depth: 32 ] ! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:40'!
cancelIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'cancelIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #cancelIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABWElEQVR4XoVSLZODMBREVlZi
kUgktrKysrY/AYmNRCKxSCQytrISiUVGRr7bTQjHlHD3ZnaSSd7u+0xiNuSZjJeLjEniMODe
4y35z0h8gzAXhZjXS0xVeeD+KUsZ8NedCY1ZKhMiWaVEtHaw8+yRZWJAtk0jGvcWvofIH5Cl
rkX63pPhGIz3ICJtKzpNpd1noqn+eDiB4BwT2DJBSR3OLfp0vTqBveOZgHtHjzQybpgFux0j
/yVAzMhAgZtwTBYZSCChvnCelUAsFGAZHI1lc9jEHdxbpIlHATi77n5hoYgxvwJrILv+s4Sa
JXDDpoiAc+RIu+7wR3ByKoxy2CnvBeb7XczzGRVXYYw0ricVhc0kkNqCUVlrfRNuN9+b9b9n
+t8rzfXkbC27zynk+bbSUpR+Svjr4VN9r/ImAlVu2BtRDAnMAlhA1HhTscgx44ZxSdRaK7ut
Tog/dRDXpR1GWiIAAAAASUVORK5CYII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:39'!
copyIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'copyIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #copyIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAA40lEQVR4Xp2Tqw7DMAxF+237
l33B4Ghh4WBoYWBgaWBgYGigoaEXNw95aptUs3QjS+49fkidlCey0Je2gaar2AINA5BoMYEe
zxcNAYgs/FFMhDWNMgRwfkdKW7oApI50ZyWkWW30FwALYHWYV6oA7ACwKj18j5+bMKAWjT8C
zswsJQFQitrh/mHPHGJWA3DXWtQOGgDbvkezj0CfLWYAH6MW1wKoXUGMLM0+CMDbwD4Oi3PA
477ZDM3skhZTAPxUZQAOzdYLgAwGsEGOXM1OmK2PNJ/9Gwzgm7A470qfAOQ6d/UFXEMnr16j
834AAAAASUVORK5CYII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:39'!
cutIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'cutIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #cutIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABJklEQVR4Xp2TLY+EMBRF5y+t
XDsSiRxLViErsStHIrEjVyKxlchKbGVl5d13+yjhczNZkpO+tL2ntJRb5wAb3qefgGf7wi0/
g3REvEnUdnARTZasBWi7yzDHQiogbUQ7eNy/DBYB6gb4LICqPoalj2OxNioQ02sMO4EdgY+7
TCw3Eg2XaSwMFl7C/kxwJrkKJ4E9ESwSbqV4JKLU+zDprgSJsgIeCut1cPJB+EtQGQ0WZYJ1
kK0wpGGls/5EwFPmAUrQ87WFJJE+L7g5zPbwGaNptuH0ukK/lhgVTCcChoIcGFsG8365mut1
zP0MqW8UwTMLeLfDfEXzsz2wI0nQZ4HTyXEO6mGtVp80QKwjPvEtKy8C3qo9/EyEe81wVcIf
iSwCFv/lF3T9Q/syI7PrAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'menu decoration' stamp: 'nk 5/1/2004 16:50'!
decorateMenu: aMenu 
	"decorate aMenu with icons"
	| numberAdded |
	SMxPreferences menuWithIcons
		ifFalse: [^ self].
	numberAdded := 0.
	aMenu items do: [ :item | | icon |
		icon := self iconForMenuItem: item.
		icon ifNotNil: [
			item icon: icon.
			numberAdded := numberAdded + 1. ]].

	numberAdded isZero ifTrue: [^ self].
	aMenu addBlankIconsIfNecessary: self blankIcon! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:39'!
deleteIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'deleteIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #deleteIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABJklEQVR4Xp2TLY+EMBRF5y+t
XDsSiRxLViErsStHIrEjVyKxlchKbGVl5d13+yjhczNZkpO+tL2ntJRb5wAb3qefgGf7wi0/
g3REvEnUdnARTZasBWi7yzDHQiogbUQ7eNy/DBYB6gb4LICqPoalj2OxNioQ02sMO4EdgY+7
TCw3Eg2XaSwMFl7C/kxwJrkKJ4E9ESwSbqV4JKLU+zDprgSJsgIeCut1cPJB+EtQGQ0WZYJ1
kK0wpGGls/5EwFPmAUrQ87WFJJE+L7g5zPbwGaNptuH0ukK/lhgVTCcChoIcGFsG8365mut1
zP0MqW8UwTMLeLfDfEXzsz2wI0nQZ4HTyXEO6mGtVp80QKwjPvEtKy8C3qo9/EyEe81wVcIf
iSwCFv/lF3T9Q/syI7PrAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:38'!
doItIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'doItIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #doItIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABQklEQVR4Xo1TIZCDMBC8usjI
2EhkZCwSWVn7svIlFllZiUVWImsrkS+xSGTk/l1Cf+BboJnZYSawe3d7C+2d3BOMXkLuBLR/
Drg1BKBitEDg52gYFLEqIi9ORyEeGVf+uGDoSA69QvlNUOoN+dkagmdiw8+SSW4ia9RXgp7G
eCFmGRMHnSqGCxO4+pjFu6ZWsHalZbkcfqRdqWwTaQHPAhmM0VvGHZDnhPZGqV2YiSzt58k8
MZKNa2oH5+y6eQJrCI9WTwIiZP98kG7PX7QtEEmhmI1h0N0JRSHEw3sfnBMfuCLqhPEUyfVF
I7M7O+87IavUsmxiZqAIVZXjXPhtEyU43V0lgYXIBN7S2FMM0WZ0wzA3T6N7JNO03hjD8/ze
TWNwFmSkqkzbENGX5P0nxxAx2iYJxVx89rclged6PibNzi927HLoudKjegAAAABJRU5ErkJg
gg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'import/export' stamp: 'JuanVuletich 10/10/2010 08:26'!
exportAllIconsAsPNG
	"self exportAllIconsAsPNG"

	| sels | 
	sels := self class selectors select: [:each |  '*Icon' match: each asString].
	sels do: [:each | self exportIcon: (SMxMenuIcons perform: each) asPNGNamed: each asString].
! !

!SMxMenuIcons class methodsFor: 'import/export' stamp: 'nk 2/16/2004 13:38'!
exportIcon: image asPNGNamed: aString
	"self exportIcon: self newIcon asPNGNamed: 'newIcon'"

	| writer |
	writer := PNGReadWriter on: (FileStream newFileNamed: aString, '.png').
	[ writer nextPutImage: image]	
		ensure: [writer close]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:38'!
findIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'findIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #findIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAiElEQVR4XmOgEmD8D8Fkar72
/Pv/pceeYzGEKIMZwZqrl95DU4zPYKK8gMtg+oUNyYbCJPDZijNcGP+DwLl77//vvfb+/9Zz
uAIOZ7gwomgGKerZeg+nIVjEGVE0z9mLzwAcfkPXXL2WRAPQNWcvvUZKymTE0Jw85xqpKRM9
GmmQMjUtvTA0AwCM28nOh7q2tQAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:37'!
forwardIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'forwardIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #forwardIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAqElEQVR4XmPABoLq+v9jwwyE
AExh4vQ1/+UeLEXBIDG8BuHSiMsgrJpV/+/E0JCz9uj/s/9fgzGMj2EIiIPLRpCG/+/fgzGy
IXADkJ0OcgE6RjYAqyEw2zf8fwCWhCmCYWTN6IbADUDWTCwGqXdKLYYYQIpGZAw3AOQCdNPx
eQMkBgoDuAGwQMGFsWmGhwGp0YihmVAqhBmArBlvasRlCF7NVMlM5GZnALH/cNqKV3sRAAAA
AElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:37'!
helpIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'helpIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #helpIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABh0lEQVR4XoVSIdeCQBAkGo1W
otFoNRqNVn+C0XrRSKQSicSrRCKRSry4cb6Z8+Ch4vv2vXkP7m5nZ2c3W4t6n6PZbNBkWUTN
74pn2X+hxJYJw+GAcLsh3O8v8Ls7HlHzrvxF1OQ79KxkzgHew9oWNgwR+sfzCSN8nqPg26/K
HZPxeABVBWsaIAS8hRnQdUBRwO92KJZKPKXZ5QKwemCVOeo6JqDvX/+TErZUMmeu3m+3wPUa
YVQQQyp0dj5HH+bgP+iRp+KnVMjtIILTCaBRMUlVpYgPx/0eQZUTaWBlYSAcczONyURAc8De
lghMlpkx6InpLBGMIlAbGo0RkIkL6CxM7dC8ZfI7gVoQwQdGkaRJGNVZKmTpXi081II2rF8h
iA+loCy/7gRNzk2jrBfMS4JBE5CpK3duGqNC6ylGyEyB0kZOwLQ8Ck1I3qT7SvI/V1rrqdnK
rDgRTiAujnA4xjPdVXxz/1zlmYSs2rCWVYISpEK7wETPM7dWeS20YVoSl3qV2+5H4h90kvM7
UUdqOAAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'menu decoration' stamp: 'jmv 3/2/2010 08:57'!
iconForMenuItem: anItem
	"Answer the icon (or nil) corresponding to the (translated) string."

	^TranslatedIcons at: anItem contents asString asLowercase ifAbsent: nil! !

!SMxMenuIcons class methodsFor: 'class initialization' stamp: 'JuanVuletich 10/10/2010 08:26'!
initialize
	"self initialize"

	| methods |
	Icons := IdentityDictionary new.

	methods := self class selectors select: [:each | '*Icon' match: each asString].
	methods do: [:each | Icons at: each put: ((SMxMenuIcons perform: each) asFormOfDepth: 32)].

	self initializeTranslations.

	Smalltalk addToStartUpList: self.! !

!SMxMenuIcons class methodsFor: 'class initialization' stamp: 'nk 5/1/2004 16:49'!
initializeTranslations
	"Initialize the dictionary of <translated menu string>-><icon>"

	TranslatedIcons := Dictionary new.
	self itemsIcons do: [ :assoc |
		assoc key do: [ :str | TranslatedIcons at: str translated asLowercase put: assoc value ]
	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:37'!
inspectIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'inspectIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #inspectIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAA1klEQVR4XqWSLRLDIBCFm+NU
VtbmCJGxHCEyV0BWxlYikbFIJBK7Eonc8hNKMukEmuzMU8z39i27t201uFd1NSikRDAWNViU
GpDNstakCaCxEVZOQhtkEvDtVDCJnQPsTCQY5CrCSRM/TOK7mxgbctcgEfWa4dhAhZkzPIks
D1NWSCAUhNi/YC8mCwkmLkLUL7iCKwwWE6E3MF1gn8y/k67F4ir9rAlOG8hw1WHtLzHBtLsj
Je2/17lK52DLx4sm/SOaDORaEsMGHEl33mTsn6uPPVV5Ix+CDziYsh+QTAAAAABJRU5ErkJg
gg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'menu decoration' stamp: 'JuanVuletich 10/10/2010 08:28'!
itemsIcons
	"answer a collection of associations wordings -> icon to decorate 
	the menus all over the image"
	| icons |
	icons := OrderedCollection new.
	" 
	world menu"
	icons add: #('previous project' ) -> self backIcon.
	icons add: #('jump to project...' ) -> self forwardIcon.
	icons add: #('open...' ) -> self openIcon.
	icons add: #('appearance...' ) -> self appearanceIcon.
	icons add: #('help...' ) -> self helpIcon.
	icons add: #('windows...' ) -> self windowIcon.
	icons add: #('print PS to file...' ) -> self printIcon.
	icons add: #('save' 'save project on file...' ) -> self saveIcon.
	icons add: #('save as...' 'save as new version' ) -> self saveAsIcon.
	icons add: #('quit' 'save and quit' ) -> self quitIcon.
	""
	icons add: #('do it (d)' ) -> self doItIcon.
	icons add: #('inspect it (i)' 'explore it (I)' 'inspect world' 'explore world' 'inspect model' 'inspect morph' 'explore morph' 'inspect owner chain' 'explore' 'inspect' 'explore (I)' 'inspect (i)' 'basic inspect' ) -> self inspectIcon.
	icons add: #('print it (p)' ) -> self printIcon.
	""
	icons add: #('copy (c)' ) -> self copyIcon.
	icons add: #('paste (v)' 'paste...' ) -> self pasteIcon.
	icons add: #('cut (x)' ) -> self cutIcon.
	""
	icons add: #('accept (s)' ) -> self okIcon.
	icons add: #('cancel (l)' ) -> self cancelIcon.
	""
	icons add: #('do again (j)' ) -> self redoIcon.
	icons add: #('undo (z)' ) -> self undoIcon.
	""
	icons add: #('find...(f)' 'find again (g)' 'find class... (f)' 'find method...' ) -> self findIcon.
	""
	icons add: #('remove' 'remove class (x)' 'delete method from changeset (d)' 'remove method from system (x)' 'delete class from change set (d)' 'remove class from system (x)' 'destroy change set (X)' ) -> self deleteIcon.
	icons add: #('add item...' 'new category...' ) -> self newIcon.
	""
	icons add: #('new morph...' 'objects (o)' ) -> self morphsIcon.
	""
	^ icons! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:36'!
morphsIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'morphsIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #morphsIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABQ0lEQVR4XpWSIZPDIBCFIysr
a09Gnqw9mZ9QG1l5sn+hMjK2MjISG4lEYpFI5LvdBVJIm87czryBQN7HS9gmF/wFCI2o2am7
AlgvGwjfgO8AqKjQ4q15MiSHn35EYY6nwveQFJLkSqBnkmi2uI1aIIMqIBHQQlJIEpp7GnGS
UcxzENNDO0zGY9Ke5oiQCPhKgHOCbACkxQM6PPUwKFIQBzhHgI8ptt8/qGgkjozVf4iQE7L2
bmBcyOzfmHPxxu5mgnza/wj4pZCXthXx/F8ANriernlZENQMnWAv5v6ucR1MBWGzSQDTdavm
tF4BBuXrJqFS3OXHI+zhAEtzPl3TM48qA9hADSZ3Pdt4ZRnCLzmSTTIZsgVQY8EmUQj6FLWm
CAniCvNUmakxyCNN4lKjcJKc4pZOLhOsP7EEuB1Arnx6ufYHLNbV0oO6vBUAAAAASUVORK5C
YII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:36'!
newIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'newIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #newIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAA4UlEQVR4Xq1SOw7CMAzNMTgP
R2DiApyAhYmVkYWJvXfgBB07MHTM2jGjR9NH/KJ8WgmkRnp6cfr86jh2+bq83prjeHsWOFzv
BVy9kCSqi9AqhsH+dNZtDOSxU7KqU3CYVWAIgzmAiWTAJO1meBf33mIzgxhrmjOJogKKdQD3
xtEEQj9Jg7ICnyUTQ6yEFQw+FEgG3z9plZwQv0Hcj6HAdhXk3V/qAUT1/cemB9bt1MzOYjuH
kK8Ag+YVWGaexBiiYIMAJhYnEQecc7FhAYsNEvciK6PMqfsFqwb/oDHgNf7BB8ocs/BSJIBk
AAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:36'!
okIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'okIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #okIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAA9ElEQVR4XtWTIY7EMAxFPSyw
sNTQ0LA0sLBXCOwRShcuHDi0sDAwdGCOMLTH+Js00Uqz6sy2y9aSpQC/b39bof8ZLAy59fgT
LL3ius6gRc4LyNBB5wE0M+jK5wTUWdjgCpyTLs8C2ld1IezBfYYXrqP/gJkZzdxhWT3IPQvI
2MH6scA+wYZ2Rh+araD1Wserwq4rnX3t3NIL34MBBYYJAvsYt6Lp8wMuTgX27+AcNglE2dKt
EyIe9VQVZvPLxjVZSN3pnqaIiuaerIS2wGIOnIurQM7I9a0HOn/HpSwvFBsb/NbzXjQJmJLI
TV+c6uAnyXmG+QILa5nAxB34LQAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:36'!
openIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'openIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #openIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAB5klEQVR4Xq2TLYylMBSFkU8i
sUgkEotEIrFIJLK2EllZW4lE1iIrK2srkcizp2Vn5k1mk80m2+TkEV7vd+4fxd+O2QTEqrGs
BzSfi385SkpIecC5CyHcWBf9EzDMOxZpMScJi34ySK5SKGjtESNwX8BFKeWxCfkd0q0BB//U
gRc8sJgLizizazr3jQxJSlnMyw4l3krphcfJi4YXNpKUCdntIzg9fwSf7obYPOZ5g5Yi6xOw
7RHWRvw496NFBnSzxygC2ulkqQeazhCwPgBJ95mX5H5Bsgyh4yMVMSwezeQxbEAnKf5WY0TV
ENAR4AjoZcREgLY3FCUPdt2wZn1j2igNNAKoV6AcIoryQE9iBvA+GqbnWa+LN3zqCZvK0WfX
lkHVdOPVBRTViVe5Zz1NJECQMDIDxkB7ultgNkw1OabA/kJRe7qeKF42B1e1/gIMTF3ZK4+T
E8zpjuoBJOeiZcoVAZX7DdnRtuoB1JNDLyIOOp8EGOa/MQPB+hd1Y1gjux7QjGxk71B3FmW9
Y0z1/xfAiy/m7fv88wKxmSFc8Oysc2lHuLGHx757tMPxts6NxW6vPy5QhvgIdwbYHOxgzMn5
v31Ur4YbxTK62THVLzXjiWawqPsDVceutzvK1qDk8nTd9gn4BWSIc0d4GJZuAAAAAElFTkSu
QmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:35'!
pasteIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'pasteIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #pasteIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABSklEQVR4XpWTIXPDMAyFAwcL
B0b2EwZLAwcLC0Z2Q4WBpYGBhqaGhYGGEzQUNDU0NHyTnbR1trS96e6FSO+TYsvNWhjVwzmH
k1ZoHkU8vgL6fVYLr/bgEOFFznuw6YB+I3oCDg1OQ7eEwuwwRQQzwToGMWMkhiUHkknIGoC2
gNrA9rvfgH0xIzHgB4ClIx8A9zlL8iRNdJ6iWQNIMnkgaAH0Yj5OEIERe1hJrUkbgysgjGJQ
8wT9JK+lMOFW5Fz7JedRDi/IP3pTTEWsik4uLkwZl+QTYyq5hwBDcdUcRDl3H+D6JaAy+/AI
IOYsZcOle6jMeUdy7j5gfCtF2RzT1ZyXjP09AO2L+QxYM7ubACcLNG4XgNrsZjNxqAHtdO8k
W2fbP4CRkyjCyLXlg9OUu1cTxE4e03DWs6xrrU0puqXLOn9/vOA/qp/CD3vY3Zl/lljmAAAA
AElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:35'!
printIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'printIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #printIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABsklEQVR4Xo2TL3PlIBTFK/sR
aitX7ld48snI2EhkJBaJRGKRyEhsZCQSi0RGnp5Lkr433e1uM3NnmAznx7n/Xp4/ZzRmbTHp
gEEFvPz0E6F1C3zM2HLD3oC0FkzK/B/iwobadlzfzmOte49JR3jC/wmwLuLSi7i1E1Aa4pJ/
5iKk/OngAhQCJMTFqDxB/nuQseHhgodGQBYHmWkswLuqeL1nvN1W3Ie/gLw1iKcL6rAUQK/A
PQC/9I7XoRBQcNMNfmkYvkKMcTAspiBCBaYE3LyIG34zVNiRymeWMDZjvmozzQmOFza+HBmK
L4+REIbfWI9Hg3qRC39I54b7CRh1Zs/Zd15m6xEY8tpzZyrBK19Iq3SmYPT2K2DHkugiH8JL
VMohXJaKQLI2KzsSoWx6AsyZtuSiQBohew+BRgo9hcZt0Hbt1tet9vMw2rMGnHnja4dksU+I
gC5xoOVEkcxHH7R6tFlSGSZ3QJRyUHrrtiUFScWFjJV78ajgWUT2WZzIcKnnKdUzt1ClXijr
SB8DZhOxlQNSz+pPs2cLv9kPo00fEjVZuHOJ+oz4lWvOVPWfe/EB9UZdEBKq1AEAAAAASUVO
RK5CYII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:35'!
quitIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'quitIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #quitIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABP0lEQVR4Xp1SobLCMBCMRCJr
K5FIfgHJL/AJlbWRSGRtZGRlLBJZiUVGRt7bTUlfGsJ7M9zMzbSXu729u1U1s7tWxs1GRqWi
W3wbxNR/xsIbCh77vfjzWeR4FN918ft+OIjF2/AJaGwbmdApaD0XO7dyxuiubeWK3LfOdxRL
34sYMxeVxhjeI0jTyDVn4kAtnE4zQCoGfcZiHN85SADIgJql+7TdzolFcWQDX4BeIJEFGF/I
gtteFVv7yyYZuxYgDzDQqFU8UwCDBBATsag3AMRygCcBOAZPE+DfA4CGzwDyEYL3f47QcwQq
bMLPcvtyicNQXyIZpFOmMWog5RmZExL9ZJQnEQXLXIEUQopvyDGkX0qa8uRtA1RWSjnJmG8G
OV0p5QUEqFTYjUy49cwdYrrWuWZUGEWiX7Ny2/pD4Q9XcC9XBIlD8gAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:34'!
redoIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'redoIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #redoIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAoklEQVR4XmOgI2D8T5Hm///v
/SfSEMb/2PD352v/f/9+jZAhEJvQMUjz/+9LCRkCtOWeEwTv5UCwofj/+yn4DAFqPqaI0Axi
A/H/c5b//1/zAjoi+f//59UQQ/YqYnMBkgFQzc/nMKCGwbVkXJrRnI+iGSlscGvGNAC7QgKh
j+wFMhMNI9z/FKQ6UIJhwBoGCD5Bw9ENQeVjGo43OZPlAtIAAGld7eI92Wb6AAAAAElFTkSu
QmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:34'!
saveAsIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'saveAsIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #saveAsIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAB0UlEQVR4XpWTIZSmIBSFjUaj
9Y/GP1qNRiPVaDRSiUYilUg0UolEo9VoNN65MDuzy+6W4Zx78Bx837vcp9VPF84R8BXc9EL1
4+KjQgboOuv7wJgd1noY46H1jm1zkNJgXTTmecM0bbCqRQbYCvdSlw6sDXge5LURMgqNEE98
rzt8FtN66vyPfa09zhtIjIldu0HC/wk4pk+Aq/HIBquYS0CyfJBw3w+Mi9B0dD9f3Q8W035s
aL+FXzoMkyoBSlmE40akzuvJSsBIXWFhcAT4F+137C7wpsMCsK6Gli/Y/YCmg40OlKY2S8Cb
AMr37P5GPyzo+qUELLy382cGJKVrbCbCGXa/Bl6BcgOkmPAeJV6dKAFpVMYdRfLPc+M5BAFU
FLj0hLAHzGzWtEMJmBiKthE+nLhSBueDGA48URKgAObg5II0rXGSqJu+BIy0pXjoaP9KxfGG
3yPHbwgI8GqGkhpKOQzjiqp+l4BhWLHwMI3v4CQ889hdgF0FdrVCrhqrtNxNDrGquxLQ9zME
Dze6COGCYx6WX+Q2i1yUipeFO5/fCVD9BeiY6igUX+Q4PYvp5Ou/UPm/sLk4qcsTaEtA2wxo
GExSy4TbX8//U53t/wZ8AFlABk2B5AZzAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:34'!
saveIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'saveIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #saveIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABqklEQVR4Xq1TIZSrMBBEViKx
J5GVschIJBaJRGIjIyNjkUhkbCQSiUUikXOzaXvl7t93l9cRKdnZ2dndTI73M8YxwPsA52ZY
O2EYPPrOoW0tmsagrgdo3UOpDkVRIbuecYw4T4A/WJLoxiEuW7r/xLodaHuP/HZ/kzgXwP/T
g5pZy2pA+A9BiBuaTgjUm0AkC/NxnPDTAkdFx4lfCeawQukBt6sCY0bE9cBCbPuZIISCZd0T
IhHiip5v7/ThG0HPmsKyY5xXOCqwVGBY1mBndGZCO4zQrUuZ7zSyVC0Jyj8k6GjcFLZEIHj5
YNjSXgiYoGY7NdupSPBRNn9MIMPip/Wf3h9s7S6GisH8JmiZLC80btmFoK4NMy6pxxKwifvL
gRjpPJVNJB/5XdAw2S2XSbwQaJojpk2Uv28ngx+BM+8Ty/E+QoZNoJksS0P08Saoqj65LXWL
3N+CrZ0TKnqQpfovBIptaWiU5UOR/ZL8CjZm5nKNxARVdc/gC0FJV8XhnhsYggTHr800VCaT
KrMikLdZVjzxPAVNyXOVIKtaFOrr/hOP9hVcpoeJn4bWV8zBUWNOAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'class initialization' stamp: 'nk 5/1/2004 16:41'!
startUp
	self initializeTranslations.! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:33'!
undoIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'undoIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #undoIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAoUlEQVR4XmOgEWD8T5Hm///v
/SfTEMb/379f+//9+VqoAdgwEZr/f18KoYEuQcc4DEHV/P/9lP/f7zmh4r0ccDZOQ/7vVQRr
/v+8GmhZ8v//17z+/z9n+f/7MUUIhhkCZOM15Pu1ZBR/P5/DgDAEvwEIQ1AVIBmC3xv40gEj
KQbgiCXivEDAAEL+R9BYwuA5A37NIEWYionSTNgFFGYw3AAAZy3t4hva3csAAAAASUVORK5C
YII=' base64Decoded asByteArray readStream

	]! !

!SMxMenuIcons class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/10/2010 08:33'!
windowIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (Form fromFileNamed: 'windowIcon.png')
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #windowIcon ifAbsentPut: [

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAABGElEQVR4XpWSIYyEMBBFu+4k
cpNTSCSyyalKJBKLrERikSuR2JVIJObESiQSW1mJ/Ddt09C97HHbJi9MAv/NlAzLOgXRa/Be
Iac6bxWyZkMqN1zrFddqRVIu+BAEf4DlRGaYwdIBTAwa31+fluoOi7iBREAmQRKQAGDs4siC
Op3Ayvsh6GagnYBmBCSJ6p6EJCs7uG4El0edcBK0k7ZBz18CjxF4Sjk7QczZd8NuqniBD3tK
OcVPEJ4oQdhd68gJfoetgCicQL0RxlPY4wSjig4rpempUdQngrOwFai3BM/3VuoQqDPBq+5h
eNv+EZgtQ7Awu5W4sXV4BfMT83ZB1a+ouoV2nWgfKJqZXs4Q9IGgLrwaX5LwAT9EoFuWxosR
6wAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream

	]! !

Object subclass: #SMxMorph
	instanceVariableNames: 'bounds owner submorphs fullBounds color extension'
	classVariableNames: 'EmptyArray'
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxMorph commentStamp: 'efc 2/26/2003 20:01' prior: 0!
A SMxMorph (from the Greek "shape" or "form") is an interactive graphical object. General information on the Morphic system can be found at http://minnow.cc.gatech.edu/squeak/30. 

Morphs exist in a tree, rooted at a World (generally a SMxPasteUpMorph). The morphs owned by a morph are its submorphs. Morphs are drawn recursively; if a SMxMorph has no owner it never gets drawn. To hide a SMxMorph and its submorphs, set its #visible property to false using the #visible: method. 

The World (screen) coordinate system is used for most coordinates, but can be changed if there is a SMxTransformMorph somewhere in the owner chain. 

My instance variables have accessor methods (e.g., #bounds, #bounds:). Most users should use the accessor methods instead of using the instance variables directly.

Structure:
instance var 	Type 			Description 
bounds 			Rectangle 		A Rectangle indicating my position and a size that will enclose 									me. 
owner 			SMxMorph		 	My parent SMxMorph, or nil for the top-level SMxMorph, which is a
 				or nil			world, typically a SMxPasteUpMorph.
submorphs 		Array 			My child Morphs. 
fullBounds 		Rectangle 		A Rectangle minimally enclosing me and my submorphs. 
color 			Color 			My primary color. Subclasses can use this in different ways. 
extension 		SMxMorphExtension Allows extra properties to be stored without adding a
				or nil  				storage burden to all morphs. 

By default, Morphs do not position their submorphs. Morphs may position their submorphs directly or use a LayoutPolicy to automatically control their submorph positioning.

Although SMxMorph has some support for SMxBorderStyle, most users should use SMxBorderedMorph if they want borders.!

SMxMorph subclass: #SMxBorderedMorph
	instanceVariableNames: 'borderWidth borderColor borderStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxBorderedMorph commentStamp: 'kfr 10/27/2003 11:17' prior: 0!
SMxBorderedMorph introduce borders to morph. Borders have the instanceVariables borderWidth and borderColor.
 
SMxBorderedMorph new borderColor: Color red; borderWidth: 10; openInWorld.

SMxBorderedMorph also have a varaity of border styles: simple, inset, raised, complexAltFramed, complexAltInset, complexAltRaised, complexFramed, complexInset, complexRaised.
These styles are set using the classes SMxBorderStyle, SMxSimpleBorder, SMxRaisedBorder, SMxInsetBorder and ComplexBorder.

SMxBorderedMorph new borderStyle: (SMxSimpleBorder width: 1 color: Color white); openInWorld.
SMxBorderedMorph new borderStyle: (SMxBorderStyle inset width: 2); openInWorld.


!

SMxBorderedMorph subclass: #SMxAlignmentMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxAlignmentMorph commentStamp: 'kfr 10/27/2003 10:25' prior: 0!
Used for layout.
Since all morphs now support layoutPolicy the main use of this class is no longer needed.
Kept around for compability. 
Supports a few methods not found elsewhere that can be convenient, eg. newRow
!

!SMxAlignmentMorph class methodsFor: 'instance creation' stamp: 'jmv 5/7/2009 21:48'!
proportional

	^ self new! !

!SMxAlignmentMorph methodsFor: 'construction' stamp: 'jmv 5/28/2009 13:50'!
addInProportionalRow: morphs
	"Honors proportions between current width of morphs"
	
	self addInRow: morphs widthProportionalTo: (morphs collect: [ :m | m width])! !

!SMxAlignmentMorph methodsFor: 'construction' stamp: 'jmv 5/28/2009 13:51'!
addInRow: morphs
	"All morphs are made equal width"
	
	self addInRow: morphs widthProportionalTo: (morphs collect: [ :m | 1])! !

!SMxAlignmentMorph methodsFor: 'construction' stamp: 'jmv 10/4/2009 15:03'!
addInRow: morphs atFractions: fractions
	"Please ensure:
	fractions size = (morphs size + 1)
	fractions first = 0.0
	fractions last = 1.0"

	morphs doWithIndex: [ :morph :i |
		self
			addMorph: morph
			fullFrame: (SMxLayoutFrame
				fractions: ((fractions at: i)@0 corner: (fractions at: i + 1)@1)) ]! !

!SMxAlignmentMorph methodsFor: 'construction' stamp: 'jmv 2/6/2010 08:30'!
addInRow: morphs widthProportionalTo: widths
	"Widths can be in any arbitrary unit. The actual widths will be proportional to them."

	| fractions totalWidth |
	totalWidth := widths sum * 1.0.
	fractions := OrderedCollection new.
	widths inject: 0.0 into: [  :previousValue :w  |
		fractions add: previousValue.
		w / totalWidth + previousValue ].
	fractions add: 1.0.
	self addInRow: morphs atFractions: fractions! !

!SMxAlignmentMorph methodsFor: 'construction' stamp: 'jmv 8/2/2010 10:24'!
addInRow: morphs widths: widths leftMargins: leftMargins topOffsets: topOffsets
	"Each morph can have a fixed width, or proportional to row width.
	for each width,
		width = 0 => Use actual morph width
		width < 1, => a fraction of row where widget should end,
		width > 1 => width in pixels."

	| currentFraction currentOffset layout w |
	currentFraction := 0.0.
	currentOffset := 0.
	morphs doWithIndex: [ :morph :i |
		layout := SMxLayoutFrame new.
		layout
			topFraction: 0 offset: (topOffsets at: i);
			bottomFraction: 1 offset: 0.
		currentOffset := currentOffset + (leftMargins at: i).
		layout
			leftFraction: currentFraction offset: currentOffset.
		w := widths at: i.
		w = 0
			ifTrue: [ currentOffset := currentOffset + morph width ]
			ifFalse: [
				w > 1
					ifTrue: [ currentOffset := currentOffset + w ]
					ifFalse: [
						currentFraction := w.
						currentOffset := 0 ]].
		layout rightFraction: currentFraction offset: currentOffset.
		self
			addMorph: morph
			fullFrame: layout ]! !

!SMxAlignmentMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:37'!
clipsSubmorphs
	^true! !

!SMxAlignmentMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!SMxAlignmentMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.8
		g: 1.0
		b: 0.8! !

!SMxAlignmentMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:27'!
initialize
	"initialize the state of the receiver"
	super initialize.

	self extent: 1@1! !

!SMxAlignmentMorph methodsFor: 'classification' stamp: 'jmv 12/5/2009 20:09'!
is: aSymbol
	^ aSymbol = #SMxAlignmentMorph or: [ super is: aSymbol ]! !

SMxAlignmentMorph subclass: #SMxFillInTheBlankMorph
	instanceVariableNames: 'response done textPane responseUponCancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxFillInTheBlankMorph class methodsFor: 'default constants' stamp: 'dgd 4/27/2003 17:10'!
defaultAnswerExtent
	^  (200@60 * (SMxPreferences standardMenuFont height / 12)) rounded! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 11/1/2010 15:27'!
request: queryString
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"SMxFillInTheBlankMorph request: 'What is your favorite color?'"

	^ self
		request: queryString
		initialAnswer: ''
		centerAt: (SimpleMorphicUIManager smxActiveHand ifNil:[Sensor]) cursorPoint! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 11/1/2010 15:27'!
request: queryString initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels."
	"SMxFillInTheBlankMorph
		request: 'What is your favorite color?'
		initialAnswer: 'red, no blue. Ahhh!!'"

	^ self
		request: queryString
		initialAnswer: defaultAnswer
		centerAt: SimpleMorphicUIManager smxActiveHand cursorPoint! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 11/1/2010 15:32'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts. Answer the empty string if the user cancels.
	This variant is only for calling from within a Morphic project."
	"SMxFillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	 ^ self 
		request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		inWorld: SimpleMorphicUIManager smxActiveWorld
! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'sw 1/31/2000 11:03'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.  Answer the empty string if the user cancels."
	"SMxFillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: ''! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'sw 2/2/2000 22:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel.  If user hits cr, treat it as a normal accept."

	"SMxFillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: true! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:44'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel 
		acceptOnCR: acceptBoolean answerExtent: self defaultAnswerExtent! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:39'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"SMxFillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	aWorld addMorph: aFillInTheBlankMorph centeredNear: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'NS 8/1/2000 11:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerHeight: answerHeight
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	^ self request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
		inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean 
		answerExtent: self defaultAnswerExtent x @ answerHeight! !

!SMxFillInTheBlankMorph methodsFor: 'menu' stamp: 'jm 5/4/1998 14:21'!
accept
	"Sent by the accept button."

	textPane accept.
! !

!SMxFillInTheBlankMorph methodsFor: 'menu' stamp: 'sw 1/31/2000 11:11'!
cancel
	"Sent by the cancel button."

	response := responseUponCancel.
	done := true.
! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/10/2010 08:15'!
createAcceptButton
	"create the [accept] button"

	| result frame |
	result := (SMxSimpleButtonMorph new)
				target: self;
				color: Color lightGreen.
	result
		label: 'Accept(s)' translated;
		actionSelector: #accept.
	frame := SMxLayoutFrame fractions: (0.1@0.75 corner: 0.45@0.98).
	result layoutFrame: frame.
	self addMorph: result.
	^result! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/10/2010 08:16'!
createCancelButton
	"create the [cancel] button"

	| result frame |
	result := (SMxSimpleButtonMorph new)
				target: self;
				color: Color lightRed.
	result
		label: 'Cancel(l)' translated;
		actionSelector: #cancel.
		frame := SMxLayoutFrame fractions: (0.55@0.75 corner: 0.9@0.98).

	result layoutFrame: frame.
	self addMorph: result.
	^result! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 5/28/2009 00:38'!
createQueryTextMorph: queryString 
	"create the queryTextMorph"
	| result frame |
	result := SMxTextMorph new contents: queryString.
	result lock.
	frame := SMxLayoutFrame new.
	frame topFraction: 0.02.
	frame leftFraction: 0.05.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/13/2010 11:05'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean
	"create the textPane"
	| result frame |
	result := SMxPluggableTextMorph
				model: self
				editorClass: TextEditor
				textGetter: #response
				textSetter: #response:
				selectionGetter: #selectionInterval
				menuGetter: #smxPaneMenu:shifted:editorClass:.
	result extent: answerExtent.
	result borderWidth: 1.
	result hasUnacceptedEdits: true.
	result acceptOnCR: acceptBoolean.
	frame := SMxLayoutFrame new.
	frame leftFraction: 0.0;
		 rightFraction: 1.0;
		 topFraction: 0.2;
		 bottomFraction: 0.7.
	result layoutFrame: frame.
	self addMorph: result.
	^ result! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'ar 10/10/2000 22:35'!
delete

	self breakDependents.
	super delete.! !

!SMxFillInTheBlankMorph methodsFor: 'geometry' stamp: 'sd 11/8/2003 15:56'!
extent: aPoint 
	"change the receiver's extent"

	super extent: aPoint .
	self updateColor! !

!SMxFillInTheBlankMorph methodsFor: 'invoking' stamp: 'jmv 11/11/2008 16:37'!
getUserResponse
	"Wait for the user to accept or cancel, and answer the result string. Answers the empty string if the user cancels."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	w := self world.
	w ifNil: [^ response].
	done := false.
	textPane focusText.
	[done] whileFalse: [w doOneCycle].
	self delete.
	w doOneCycle.
	^ response
! !

!SMxFillInTheBlankMorph methodsFor: 'event handling' stamp: 'ar 10/7/2000 15:47'!
handlesMouseDown: evt
	^true! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 5/14/2009 14:56'!
initialize

	super initialize.
	self setDefaultParameters.
	self extent: 400 @ 150.
	responseUponCancel := ''
	! !

!SMxFillInTheBlankMorph methodsFor: 'invoking' stamp: 'RAA 7/19/2000 20:40'!
morphicLayerNumber

	^10.6! !

!SMxFillInTheBlankMorph methodsFor: 'event handling' stamp: 'md 10/22/2003 16:20'!
mouseDown: evt
	(self containsPoint: evt position) ifFalse:[^ Beeper beep]. "sent in response to outside modal click"
	evt hand grabMorph: self. "allow repositioning"! !

!SMxFillInTheBlankMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 14:03'!
response

	^ response
! !

!SMxFillInTheBlankMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 14:22'!
response: aText
	"Sent when text pane accepts."

	response := aText asString.
	done := true.
	^ true
! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'sw 1/31/2000 11:01'!
responseUponCancel: anObject
	responseUponCancel := anObject
! !

!SMxFillInTheBlankMorph methodsFor: 'accessing' stamp: 'di 5/22/1998 00:58'!
selectionInterval
	^ 1 to: response size
! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'JuanVuletich 11/1/2010 15:52'!
setDefaultParameters
	"change the receiver's appareance parameters"
	| colorFromMenu worldColor menuColor menuBorderColor |
	colorFromMenu := SMxPreferences menuColorFromWorld
				and: [Display depth > 4
				and: [(worldColor := self currentWorld color) isColor]].
	menuColor := colorFromMenu
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white]]
				ifFalse: [SMxPreferences menuColor].
	menuBorderColor := #raised.
	self
		setColor: menuColor
		borderWidth: SMxPreferences menuBorderWidth
		borderColor: menuBorderColor! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 5/28/2009 00:43'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	| query topOffset accept cancel buttonAreaHeight |
	response := initialAnswer.
	done := false.
	self removeAllMorphs.
	query := self createQueryTextMorph: queryString.
	topOffset := query height + 4.
	accept := self createAcceptButton.
	cancel := self createCancelButton.
	buttonAreaHeight := (accept height max: cancel height)
				+ 4.
	textPane := self
				createTextPaneExtent: answerExtent
				acceptBoolean: acceptBoolean.
	self extent: (query extent x max: answerExtent x)
			+ 4 @ (topOffset + answerExtent y + 4 + buttonAreaHeight).
	! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'NS 8/1/2000 11:44'!
setQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	self setQuery: queryString initialAnswer: initialAnswer 
		answerExtent: (self class defaultAnswerExtent x @ answerHeight) 
		acceptOnCR: acceptBoolean
! !

!SMxFillInTheBlankMorph methodsFor: 'menu' stamp: 'JuanVuletich 10/12/2010 14:27'!
smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass

	^ StringHolder new smxPaneMenu: aMenu shifted: shifted editorClass: anEditorClass! !

!SMxFillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 3/2/2010 16:01'!
updateColor
	"update the recevier's fillStyle"

	textPane ifNil: [
		^ self].
	textPane borderColor: #inset! !

!SMxBorderedMorph methodsFor: 'menu' stamp: 'jmv 5/17/2009 23:40'!
addBorderStyleMenuItems: aMenu hand: aHandMorph
	"Add border-style menu items"

	| subMenu |
	subMenu := SMxMenuMorph new defaultTarget: self.
	subMenu addTitle: 'border' translated.
	subMenu addStayUpIcons.
	subMenu addList: 
		{{'border color...' translated. #changeBorderColor:}.
		{'border width...' translated. #changeBorderWidth:}}.
	subMenu addLine.
	SMxBorderStyle borderStyleChoices do:
		[:sym | (self borderStyleForSymbol: sym)
			ifNotNil:
				[subMenu add: sym target: self selector: #setBorderStyle: argument: sym]].
	aMenu add: 'border style...' translated subMenu: subMenu
! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'sw 8/6/97 14:34'!
borderColor
	^ borderColor! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:54'!
borderColor: colorOrSymbolOrNil
	self doesBevels ifFalse:[
		(colorOrSymbolOrNil isColor) ifFalse: [^self]].
	borderColor = colorOrSymbolOrNil ifFalse: [
		borderColor := colorOrSymbolOrNil.
		self changed].
! !

!SMxBorderedMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:53'!
borderInitialize
	"initialize the receiver state related to border"
	borderColor:= self defaultBorderColor.
	borderWidth := self defaultBorderWidth! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'di 6/20/97 11:24'!
borderInset
	self borderColor: #inset! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'di 6/20/97 11:25'!
borderRaised
	self borderColor: #raised! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:51'!
borderStyle
	"Work around the borderWidth/borderColor pair"

	| style |
	borderColor ifNil: [^SMxBorderStyle default].
	borderWidth isZero ifTrue: [^SMxBorderStyle default].
	style := borderStyle ifNil: [SMxBorderStyle default].
	(borderWidth = style width and: 
			["Hah!! Try understanding this..."

			borderColor == style style or: 
					["#raised/#inset etc"

					#simple == style style and: [borderColor = style color]]]) 
		ifFalse: [
			style := (borderColor isColor)
				ifTrue: [SMxBorderStyle width: borderWidth color: borderColor]
				ifFalse: [(SMxBorderStyle perform: borderColor) width: borderWidth	"argh."].
			borderStyle := style].
	^style trackColorFrom: self! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'jmv 5/17/2009 22:57'!
borderStyle: aBorderStyle 
	"Work around the borderWidth/borderColor pair"

	aBorderStyle = self borderStyle ifTrue: [^self].
	"secure against invalid border styles"
	(self canDrawBorder: aBorderStyle) 
		ifFalse: 
			["Replace the suggested border with a simple one"

			^self borderStyle: (SMxBorderStyle width: aBorderStyle width
						color: (aBorderStyle trackColorFrom: self) color)].
	aBorderStyle width = self borderStyle width ifFalse: [self changed].
	(aBorderStyle isNil or: [aBorderStyle == SMxBorderStyle default]) 
		ifTrue: [
			borderStyle := nil.
			borderWidth := 0.
			^self changed].
	borderStyle := aBorderStyle.
	borderStyle := aBorderStyle.
	borderWidth := aBorderStyle width.
	borderColor := aBorderStyle style == #simple 
				ifTrue: [aBorderStyle color]
				ifFalse: [aBorderStyle style].
	self changed! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'jmv 5/17/2009 23:01'!
borderStyleForSymbol: aStyleSymbol
	"Answer a suitable SMxBorderStyle for me of the type represented by a given symbol"

	| aStyle existing |
	aStyle := SMxBorderStyle borderStyleForSymbol: aStyleSymbol asSymbol.
	aStyle ifNil: [self error: 'bad style'].
	existing := self borderStyle.
	aStyle width: existing width;
		baseColor: existing baseColor.
	^ (self canDrawBorder: aStyle)
		ifTrue:
			[aStyle]
		ifFalse:
			[nil]! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'di 6/20/97 11:09'!
borderWidth
	^ borderWidth! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'jmv 10/2/2009 09:54'!
borderWidth: anInteger
	borderWidth = anInteger ifFalse: [
		borderColor ifNil: [borderColor := Color black].
		borderWidth := anInteger max: 0.
		self changed ]! !

!SMxBorderedMorph methodsFor: 'menu' stamp: 'ar 10/5/2000 18:50'!
changeBorderColor: evt
	| aHand |
	aHand := evt ifNotNil: [evt hand] ifNil: [self primaryHand].
	self changeColorTarget: self selector: #borderColor: originalColor: self borderColor hand: aHand! !

!SMxBorderedMorph methodsFor: 'menu' stamp: 'JuanVuletich 10/10/2010 08:12'!
changeBorderWidth: evt 
	| handle origin aHand |
	aHand := evt ifNil: [self primaryHand] ifNotNil: [evt hand].
	origin := aHand position.
	handle := SMxHandleMorph new.
	handle forEachPointDo: [ :newPoint | | newWidth |
					handle removeAllMorphs.
					handle addMorph: (SMxLineMorph 
								from: origin
								to: newPoint
								color: Color black
								width: 1).
					newWidth := (newPoint - origin) r asInteger // 5.
					self borderWidth: newWidth]
			lastPointDo: [ :newPoint | 
					handle deleteBalloon.
					self halo ifNotNil: [ :halo | halo addHandles]].
	aHand attachMorph: handle.
	handle 
		showBalloon: 'Move cursor farther from
this point to increase border width.
Click when done.'
		hand: evt hand.
	handle startStepping! !

!SMxBorderedMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:33'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!SMxBorderedMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'di 6/20/97 11:19'!
doesBevels
	"To return true means that this object can show bevelled borders, and
	therefore can accept, eg, #raised or #inset as valid borderColors.
	Must be overridden by subclasses that do not support bevelled borders."

	^ true! !

!SMxBorderedMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:25'!
drawOn: aCanvas

	aCanvas fillRectangle: bounds fillStyle: self fillStyle borderStyle: self borderStyle.
! !

!SMxBorderedMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:07'!
initialize
	"initialize the state of the receiver"
	super initialize.
""
	self borderInitialize! !

!SMxBorderedMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:26'!
innerBounds
	"Return the inner rectangle enclosed by the bounds of this morph excluding the space taken by its borders. For an unbordered morph, this is just its bounds."

	^ bounds insetBy: self borderWidth! !

!SMxBorderedMorph methodsFor: 'testing' stamp: 'jmv 9/17/2009 10:39'!
is: aSymbol
	^ aSymbol = #SMxBorderedMorph or: [ super is: aSymbol ]! !

!SMxBorderedMorph methodsFor: 'testing' stamp: 'JuanVuletich 11/1/2010 15:54'!
isOpaqueMorph
	"Any submorph that answers true to #isOrthoRectangularMorph (to optimize #containsPoint:)
	but is not an opaque rectangle covering bounds MUST answer false to this message"
	((color isColor) and: [ color isOpaque not ]) ifTrue: [
		^false ].
	self borderWidth > 0 ifTrue: [
		((self borderColor isColor) and: [ self borderColor  isOpaque not]) ifTrue: [
			^false ]].
	^true! !

!SMxBorderedMorph methodsFor: 'caching' stamp: 'jmv 5/17/2009 23:04'!
releaseCachedState
	"Release any state that can be recomputed on demand, such as the pixel values for a color gradient or the editor state for a SMxTextMorph. This method may be called to save space when a morph becomes inaccessible. Implementations of this method should do 'super releaseCachedState'."
	
	super releaseCachedState.
	self borderStyle releaseCachedState.
! !

!SMxBorderedMorph methodsFor: 'accessing' stamp: 'jmv 5/17/2009 23:08'!
setBorderStyle: aSymbol
	"Set the border style of my costume"

	| aStyle |
	aStyle := self borderStyleForSymbol: aSymbol.
	aStyle ifNil: [^ self].
	(self canDrawBorder: aStyle)
		ifTrue:
			[self borderStyle: aStyle]! !

!SMxBorderedMorph methodsFor: 'private' stamp: 'di 6/20/97 11:21'!
setBorderWidth: w borderColor: bc
	self borderWidth: w.
	self borderColor: bc.! !

!SMxBorderedMorph methodsFor: 'private' stamp: 'di 6/20/97 11:22'!
setColor: c borderWidth: w borderColor: bc
	self color: c.
	self borderWidth: w.
	self borderColor: bc.! !

SMxBorderedMorph subclass: #SMxBorderedSubpaneDividerMorph
	instanceVariableNames: 'resizingEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxBorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'jmv 5/28/2009 00:07'!
forBottomEdge
	^self new resizingEdge: #bottom! !

!SMxBorderedSubpaneDividerMorph class methodsFor: 'as yet unclassified' stamp: 'jmv 5/28/2009 00:07'!
forTopEdge
	^self new resizingEdge: #top! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:09'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 0! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:09'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color black! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'JuanVuletich 10/22/2010 11:23'!
firstEnter: evt
	"The first time this divider is activated, find its window and redirect further interaction there."
	| window |

	window := self firstOwnerSuchThat: [ :m | m is: #SMxSystemWindow ].
	window ifNil: [ self suspendEventHandler. ^ self ]. "not working out"
	window secondaryPaneTransition: evt divider: self.
	self on: #mouseEnter send: #secondaryPaneTransition:divider: to: window.
! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:09'!
initialize
	"initialize the state of the receiver"
	super initialize.
""
	self extent: 1 @ 1! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
resizingEdge

	^resizingEdge
! !

!SMxBorderedSubpaneDividerMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/15/2001 23:24'!
resizingEdge: edgeSymbol

	(#(top bottom) includes: edgeSymbol) ifFalse:
		[ self error: 'resizingEdge must be #top or #bottom' ].
	resizingEdge := edgeSymbol.
	self on: #mouseEnter send: #firstEnter: to: self.
! !

SMxBorderedMorph subclass: #SMxEllipseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxEllipseMorph commentStamp: 'kfr 10/27/2003 10:32' prior: 0!
A round SMxBorderedMorph. Supports borderWidth and borderColor. 
Only simple borderStyle is implemented.

SMxEllipseMorph new borderWidth:10; borderColor: Color green; openInWorld.
SMxEllipseMorph new borderStyle:(SMxSimpleBorder width: 5 color: Color blue); openInWorld.!

!SMxEllipseMorph methodsFor: 'testing' stamp: 'ar 8/25/2001 19:08'!
canDrawBorder: aBorderStyle
	^aBorderStyle style == #simple! !

!SMxEllipseMorph methodsFor: 'geometry testing' stamp: 'di 11/14/97 13:50'!
containsPoint: aPoint

	| radius other delta xOverY |
	(bounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"
	(bounds width = 1 or: [bounds height = 1])
		ifTrue: [^ true].  "Degenerate case -- code below fails by a bit"

	radius := bounds height asFloat / 2.
	other := bounds width asFloat / 2.
	delta := aPoint - bounds topLeft - (other@radius).
	xOverY := bounds width asFloat / bounds height asFloat.
	^ (delta x asFloat / xOverY) squared + delta y squared <= radius squared! !

!SMxEllipseMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:37'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxEllipseMorph methodsFor: 'visual properties' stamp: 'ar 6/25/1999 11:14'!
defaultColor
	"Return the default fill style for the receiver"
	^Color yellow! !

!SMxEllipseMorph methodsFor: 'accessing' stamp: 'di 6/20/97 11:29'!
doesBevels
	^ false! !

!SMxEllipseMorph methodsFor: 'drawing' stamp: 'jmv 8/26/2008 11:31'!
drawOn: aCanvas 

	aCanvas isShadowDrawing
		ifTrue: [^ aCanvas fillOval: bounds color:  color borderWidth: 0 borderColor: nil].
	aCanvas fillOval: bounds color: color borderWidth: borderWidth borderColor: borderColor.
! !

!SMxEllipseMorph methodsFor: 'geometry testing' stamp: 'jmv 10/7/2009 23:21'!
isOrthoRectangularMorph
	^false! !

SMxEllipseMorph subclass: #SMxHandleMorph
	instanceVariableNames: 'pointBlock lastPointBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxHandleMorph commentStamp: '<historical>' prior: 0!
A SMxHandleMorph provides mouse-up control behavior.!

!SMxHandleMorph methodsFor: 'initialize' stamp: 'di 11/3/97 16:34'!
forEachPointDo: aBlock
	pointBlock := aBlock! !

!SMxHandleMorph methodsFor: 'initialize' stamp: 'di 8/30/2000 21:48'!
forEachPointDo: aBlock lastPointDo: otherBlock
	pointBlock := aBlock.
	lastPointBlock := otherBlock! !

!SMxHandleMorph methodsFor: 'initialization' stamp: 'jmv 10/13/2009 08:46'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self extent: 12 @ 12! !

!SMxHandleMorph methodsFor: 'dropping/grabbing' stamp: 'ar 9/15/2000 23:30'!
justDroppedInto: aMorph event: anEvent
	"So that when the hand drops me (into the world) I go away"
	lastPointBlock ifNotNil: [lastPointBlock value: self center].
	self flag: #arNote. "Probably unnecessary"
	anEvent hand releaseKeyboardFocus: self.
	self changed.
	self delete.
! !

!SMxHandleMorph methodsFor: 'event handling' stamp: 'jmv 1/12/2010 11:08'!
keyStroke: evt
	"Check for cursor keys"
	| keyValue |
	(owner is: #SMxHandMorph) ifFalse: [ ^self ].
	keyValue := evt keyValue.
	keyValue = 28 ifTrue:[^self position: self position - (1@0)].
	keyValue = 29 ifTrue:[^self position: self position + (1@0)].
	keyValue = 30 ifTrue:[^self position: self position - (0@1)].
	keyValue = 31 ifTrue:[^self position: self position + (0@1)].
	"Special case for return"
	keyValue = 13 ifTrue:[
		"Drop the receiver and be done"
	self flag: #arNote. "Probably unnecessary"
		owner releaseKeyboardFocus: self.
		self delete].
! !

!SMxHandleMorph methodsFor: 'stepping and presenter' stamp: 'ar 9/15/2000 23:24'!
startStepping
	"Make the receiver the keyboard focus for editing"
	super startStepping.
	"owner isHandMorph ifTrue:[owner newKeyboardFocus: self]."
self flag: #arNote. "make me #handleKeyboard:"! !

!SMxHandleMorph methodsFor: 'stepping and presenter' stamp: 'di 11/3/97 16:34'!
step
	pointBlock value: self center! !

!SMxHandleMorph methodsFor: 'testing' stamp: 'JMM 10/21/2003 18:15'!
stepTime
	"Update every hundredth of a second."
	^ 10
! !

SMxHandleMorph subclass: #SMxNewHandleMorph
	instanceVariableNames: 'hand waitingForClickInside'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxNewHandleMorph class methodsFor: 'new-morph participation' stamp: 'di 5/3/1998 10:08'!
includeInNewMorphMenu
	^ false! !

!SMxNewHandleMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 8/16/2001 15:38'!
delete
	hand ifNotNil:[
		hand showTemporaryCursor: nil.
	].
	super delete.! !

!SMxNewHandleMorph methodsFor: 'all' stamp: 'di 5/18/1998 15:27'!
followHand: aHand forEachPointDo: block1 lastPointDo: block2
	hand := aHand.
	pointBlock := block1.
	lastPointBlock := block2.
	self position: hand lastEvent cursorPoint - (self extent // 2)! !

!SMxNewHandleMorph methodsFor: 'all' stamp: 'ar 8/16/2001 15:48'!
followHand: aHand forEachPointDo: block1 lastPointDo: block2 withCursor: aCursor
	hand := aHand.
	hand showTemporaryCursor: aCursor "hotSpotOffset: aCursor offset negated".
	borderWidth := 0.
	color := Color transparent.
	pointBlock := block1.
	lastPointBlock := block2.
	self position: hand lastEvent cursorPoint - (self extent // 2)! !

!SMxNewHandleMorph methodsFor: 'initialization' stamp: 'jmv 5/11/2009 23:53'!
initialize
"initialize the state of the receiver"

	super initialize.
""
	waitingForClickInside := true! !

!SMxNewHandleMorph methodsFor: 'dropping/grabbing' stamp: 'di 4/30/1999 14:06'!
justDroppedInto: aMorph event: anEvent
	"No dropping behavior because stepping will delete me.
	Moreover it needs to be done that way to evaluate lastPointBlock"
! !

!SMxNewHandleMorph methodsFor: 'WiW support' stamp: 'RAA 1/10/2001 10:15'!
morphicLayerNumber

	^1		"handles are very front-like - e.g. the spawn reframe logic actually asks if the first submorph of the world is one of us before deciding to create one"! !

!SMxNewHandleMorph methodsFor: 'stepping and presenter' stamp: 'jmv 8/23/2010 11:20'!
step
	| ev |
	ev := hand lastEvent.
	ev anyButtonPressed
		ifTrue: [
			waitingForClickInside := false.
			self position: ev cursorPoint - (self extent // 2).
			pointBlock value: self center ]
		ifFalse: [
			waitingForClickInside
				ifTrue: [
					(self containsPoint: ev cursorPoint) ifFalse: [
						"mouse wandered out before clicked"
						^ self delete ]]
				ifFalse: [
					lastPointBlock value: self center.
					^ self delete ]].! !

SMxBorderedMorph subclass: #SMxMenuMorph
	instanceVariableNames: 'defaultTarget selectedItem stayUp popUpOwner activeSubMenu titleMorph'
	classVariableNames: 'CloseBoxImage PushPinImage'
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxMenuMorph commentStamp: '<historical>' prior: 0!
Instance variables:
	defaultTarget 		<Object>				The default target for creating menu items
	selectedItem		<SMxMenuItemMorph> 	The currently selected item in the receiver
	stayUp 			<Boolean>				True if the receiver should stay up after clicks
	popUpOwner 		<SMxMenuItemMorph>		The menu item that automatically invoked the receiver, if any.
	activeSubMenu 	<SMxMenuMorph>			The currently active submenu.!

SMxMenuMorph subclass: #SMxMVCMenuMorph
	instanceVariableNames: 'done mvcSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxMVCMenuMorph commentStamp: '<historical>' prior: 0!
I simulate the MVC menu classes SMxPopUpMenu, SMxSelectionMenu, and SMxCustomMenu when running in a Morphic world. I am also used to implement Utilities>informUser:during:.!

!SMxMVCMenuMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/12/2010 23:46'!
from: aPopupMenu title: titleStringOrNil
	"Answer a SMxMenuMorph constructed from the given SMxPopUpMenu. Used to simulate MVC-style menus in a Morphic-only world."

	| menu items lines selections labelString j emphasis |
	menu := self new.
	titleStringOrNil ifNotNil: [
		titleStringOrNil isEmpty ifFalse: [menu addTitle: titleStringOrNil]].
	labelString := aPopupMenu labelString.
	items := labelString asString findTokens: String cr.
	labelString isText ifTrue: [
		"Pass along text emphasis if present"
		j := 1.
		items := items collect:
			[:item | j := labelString asString findString: item startingAt: j.
			emphasis := TextEmphasis new emphasisCode: (labelString emphasisAt: j).
			item asText addAttribute: emphasis]].
	lines := aPopupMenu lineArray.
	lines ifNil: [lines := #()].
	menu cancelValue: 0.
	menu defaultTarget: menu.
	selections := (1 to: items size) asArray.
	1 to: items size do: [:i |
		menu add: (items at: i) selector: #selectMVCItem: argument: (selections at: i).
		(lines includes: i) ifTrue: [menu addLine]].
	^ menu
! !

!SMxMVCMenuMorph methodsFor: 'private' stamp: 'ar 9/18/2000 12:10'!
cancelValue: selectionOrNil
	"Set the value to be returned if the user cancels without making a selection."

	mvcSelection := selectionOrNil.
! !

!SMxMVCMenuMorph methodsFor: 'invoking' stamp: 'JuanVuletich 11/1/2010 15:33'!
displayAt: aPoint during: aBlock
	"Add this menu to the Morphic world during the execution of the given block."

	SimpleMorphicUIManager smxActiveWorld addMorph: self centeredNear: aPoint.
	self world displayWorld.  "show myself"
	aBlock value.
	self delete! !

!SMxMVCMenuMorph methodsFor: 'invoking' stamp: 'JuanVuletich 11/1/2010 15:33'!
informUserAt: aPoint during: aBlock
	"Add this menu to the Morphic world during the execution of the given block."

	| w titleString |

	titleString := titleMorph submorphs first.
	self visible: false.
	w := SimpleMorphicUIManager smxActiveWorld.
	aBlock value:[:string|
		self visible ifFalse:[
			w addMorph: self centeredNear: aPoint.
			self visible: true].
		titleString contents: string.
		titleMorph width: titleString width + 8.
		self setConstrainedPosition: Sensor cursorPoint hangOut: false.
		self adjustSubmorphsLayout.
		self changed.
		w displayWorld		 "show myself"
	]. 
	self delete.
	w displayWorld! !

!SMxMVCMenuMorph methodsFor: 'invoking' stamp: 'ar 12/27/2001 22:46'!
invokeAt: aPoint in: aWorld
	"Add this menu to the given world centered at the given point. Wait for the user to make a selection and answer it. The selection value returned is an integer in keeping with SMxPopUpMenu, if the menu is converted from an MVC-style menu."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	^ self invokeAt: aPoint in: aWorld allowKeyboard: SMxPreferences menuKeyboardControl! !

!SMxMVCMenuMorph methodsFor: 'invoking' stamp: 'jmv 7/23/2008 12:24'!
invokeAt: aPoint in: aWorld allowKeyboard: aBoolean
	"Add this menu to the given world centered at the given point. Wait for the user to make a selection and answer it. The selection value returned is an integer in keeping with SMxPopUpMenu, if the menu is converted from an MVC-style menu."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop." 
	| w oldFocus |
	self flag: #bob.		"is <aPoint> global or local?"
	self flag: #arNote.	"<aPoint> is local to aWorld"
	oldFocus := aWorld primaryHand keyboardFocus.
	self popUpAt: aPoint forHand: aWorld primaryHand in: aWorld allowKeyboard: aBoolean.
	done := false.
	w := aWorld outermostWorldMorph. "containing hand"
	[self isInWorld & done not] whileTrue: [w doOneSubCycle].
	self delete.
	oldFocus ifNotNil: [ aWorld primaryHand newKeyboardFocus: oldFocus ].
	^ mvcSelection ! !

!SMxMVCMenuMorph methodsFor: 'private' stamp: 'ar 9/18/2000 12:16'!
selectMVCItem: item
	"Called by the SMxMenuItemMorph that the user selects.
	Record the selection and set the done flag to end this interaction."

	mvcSelection := item.
	done := true.
! !

!SMxMenuMorph class methodsFor: 'images' stamp: 'nk 8/1/2002 17:06'!
closeBoxImage
	"Supplied here because we don't necessarily have ComicBold"

	^ CloseBoxImage ifNil: [CloseBoxImage := (Form
	extent: 10@16
	depth: 2
	fromArray: #( 0 0 0 0 1342259200 1409630208 353697792 89391104 22020096 89391104 353697792 1409630208 1342259200 0 0 0)
	offset: 0@0)]! !

!SMxMenuMorph class methodsFor: 'instance creation' stamp: 'jm 5/14/1998 17:21'!
entitled: aString
	"Answer a new instance of me with the given title."

	^ self new addTitle: aString
! !

!SMxMenuMorph class methodsFor: 'example' stamp: 'jmv 5/17/2009 23:42'!
example
	"SMxMenuMorph example openInWorld"

	| menu |
	menu := SMxMenuMorph new.
	menu addStayUpIcons.
	menu add: 'apples' action: #apples.
	menu add: 'oranges' action: #oranges.
	menu addLine.
	menu addLine.  "extra lines ignored"
	menu add: 'peaches' action: #peaches.
	menu addLine.
	menu add: 'pears' action: #pears.
	menu addLine.
	^ menu
! !

!SMxMenuMorph class methodsFor: 'example' stamp: 'jmv 5/17/2009 23:42'!
example2
	"SMxMenuMorph example2 openInWorld"

	| menu |
	menu := SMxMenuMorph entitled: 'sdfasdfa sfda sdf as df as fd'.
	menu addStayUpIcons.
	menu add: 'apples' action: #apples.
	menu add: 'oranges' action: #oranges.
	menu addLine.
	menu addLine.  "extra lines ignored"
	menu add: 'peaches' action: #peaches.
	menu addLine.
	menu add: 'pears' action: #pears.
	menu addLine.
	^ menu
! !

!SMxMenuMorph class methodsFor: 'as yet unclassified' stamp: 'jmv 2/23/2010 16:54'!
initialize
	PushPinImage := nil! !

!SMxMenuMorph class methodsFor: 'images' stamp: 'JuanVuletich 10/11/2010 22:20'!
pushPinImage
	"Answer the push-pin image, creating and caching it at this time if it is absent"
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s |
			PNGReadWriter
				putForm: (Form fromFileNamed: 'pushPinImage.png')
				onStream: s]) asString base64Encoded)
	"
	^ PushPinImage ifNil: [ PushPinImage := (

Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAAA0AAAAOCAYAAAD0f5bSAAACGklEQVR4XoWSX0hTYRjGT+d8
5ztnZ1qToGJQoankAtuaIyGsnBdR3mQSFtMIAonSWRcy0quu8ioc2lxeCGIQSRetckNG2FUX
lnZZMeefOfFmdWMQdfPruK7EQS+8Nx/83ud53vdTStX0i2lqa2tobmnhdMtFBgYHUf5Xbreb
V6kUrYl1jNFlZOt96k/6WVldKQ1nMhl0XedzZg0tnkexWx3LoZ+9QcDvLw3lcjkcpsHrmRTV
Uzn2xDdQY+vIoY8Iy0U0Gv0HFgoFEokEi4uLTE5O4nBaXLt+laGF7za0rZS3VTcxPefwnvKh
5PN5fD4fgUAATdOQmo44UInp3Etv/A3mUxuKbaDbLZq7MGwXSiQSobOzk46ODhyG5HZPL+6x
rxiPFhBPsojYKjL6DTm6hKz04XK5UNraLtNz9w7J2STJ5Ax/fv+i6eUmIm7nGF7CrGlEN8rQ
rH1FJ+FwGKW/P0KV/wwP53/wLveTBx8KOGJryMdfMLwXcDrK6bvXRygUYmJigq2tLZT5Twuo
uoEcmLWt5JHbCpG3iEPVqKqGbk+fmnq2e9UnPB5E/XnU0RXE2DLm8SZ0Vdh2dBtUCQaDO6Fs
Nkt5WRlSGBjBW4jhTDG06HuOrA8ihChudgfU3d2NZVm0t1+xj2qhH6zC9F5CHvMiDGfxd4yM
jOyE6urqSKfTxcf3c3N0dd3kyOGj7K+ooKGhkfHx8V15/gJScSdVQWdhoAAAAABJRU5ErkJg
gg==' base64Decoded asByteArray readStream

	)]! !

!SMxMenuMorph methodsFor: 'events' stamp: 'ar 10/10/2000 01:35'!
activate: evt
	"Receiver should be activated; e.g., so that control passes correctly."
	evt hand newMouseFocus: self.! !

!SMxMenuMorph methodsFor: 'control' stamp: 'ar 9/17/2000 20:38'!
activeSubmenu: aSubmenu
	activeSubMenu ifNotNil:[activeSubMenu delete].
	activeSubMenu := aSubmenu.! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jm 11/4/97 07:46'!
add: aString action: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the default target object."
	"Details: Note that the menu item added captures the default target object at the time the item is added; the default target can later be changed before added additional items without affecting the targets of previously added entries. The model is that each entry is like a button that knows everything it needs to perform its action."

	self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: EmptyArray.
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 5/1/1998 00:48'!
add: aString selector: aSymbol argument: arg

	self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: (Array with: arg)
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jm 11/4/97 07:46'!
add: aString subMenu: aMenuMorph
	"Append the given submenu with the given label."

	| item |
	item := SMxMenuItemMorph new.
	item contents: aString;
		subMenu: aMenuMorph.
	self addMorphBack: item.
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'ar 12/16/2001 16:53'!
add: aString subMenu: aMenuMorph target: target selector: aSymbol argumentList: argList
	"Append the given submenu with the given label."

	| item |
	item := SMxMenuItemMorph new.
	item 
		contents: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray;
		subMenu: aMenuMorph.
	self addMorphBack: item.
	^item! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 4/17/1998 22:45'!
add: aString target: aTarget action: aSymbol
	self add: aString
		target: aTarget
		selector: aSymbol
		argumentList: EmptyArray
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jm 11/4/97 07:46'!
add: aString target: anObject selector: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self add: aString
		target: anObject
		selector: aSymbol
		argumentList: EmptyArray.
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jm 11/4/97 07:46'!
add: aString target: target selector: aSymbol argument: arg
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given argument."

	self add: aString
		target: target
		selector: aSymbol
		argumentList: (Array with: arg)
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 11/6/2000 13:44'!
add: aString target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  Answer the appended menu item."

	| item |
	item := SMxMenuItemMorph new
		contents: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'nk 3/10/2004 15:20'!
addBlankIconsIfNecessary: anIcon
	"If any of my items have an icon, ensure that all do by using anIcon for those that don't"

	| withIcons withoutIcons |
	withIcons := Set new.
	withoutIcons := Set new.
	self items do: [ :item |
		item hasIconOrMarker
			ifTrue: [ withIcons add: item ]
			ifFalse: [ withoutIcons add: item ].
		item hasSubMenu ifTrue: [ item subMenu addBlankIconsIfNecessary: anIcon ]].
	(withIcons isEmpty or: [ withoutIcons isEmpty ]) ifTrue: [ ^self ].
	withoutIcons do: [ :item | item icon: anIcon ].! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'jmv 4/15/2009 22:23'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'add title...' translated action: #addTitle.
	aCustomMenu add: 'sight target' translated action: #sightTarget:.
	defaultTarget ifNotNil: [
		aCustomMenu add: 'add item...' translated action: #addItem].
	aCustomMenu add: 'add line' translated action: #addLine! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:04'!
addItem

	| string sel |
	string := SMxFillInTheBlankMorph request: 'Label for new item?'.
	string isEmpty ifTrue: [^ self].
	sel := SMxFillInTheBlankMorph request: 'Selector?'.
	sel isEmpty ifFalse: [sel := sel asSymbol].
	self add: string action: sel.
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jm 5/20/1998 10:50'!
addLine
	"Append a divider line to this menu. Suppress duplicate lines."

	submorphs isEmpty ifTrue: [^ self].
	(self lastSubmorph isKindOf: SMxMenuLineMorph)
		ifFalse: [self addMorphBack: SMxMenuLineMorph new].
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 2/27/2001 07:50'!
addList: aList
	"Add the given items to this menu, where each item is a pair (<string> <actionSelector>)..  If an element of the list is simply the symobl $-, add a line to the receiver.  The optional third element of each entry, if present, provides balloon help."

	aList do: [:tuple |
		(tuple == #-)
			ifTrue: [self addLine]
			ifFalse:
				[self add: tuple first action: tuple second.
				tuple size > 2 ifTrue:
					[self balloonTextForLastItem: tuple third]]]! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'nk 2/15/2004 16:19'!
addService: aService for: serviceUser
	"Append a menu item with the given service. If the item is selected, it will perform the given service."

	aService addServiceFor: serviceUser toMenu: self.! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'nk 2/15/2004 16:11'!
addServices2: services for: served extraLines: linesArray

	services withIndexDo: [:service :i |
		service addServiceFor: served toMenu: self.
		self lastItem setBalloonText: service description.
		(linesArray includes: i)  ifTrue: [self addLine] ]
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'nk 11/26/2002 13:53'!
addServices: services for: served extraLines: linesArray

	services withIndexDo: [:service :i |
		self addService: service for: served.
		submorphs last setBalloonText: service description.
		(linesArray includes: i) | service useLineAfter 
			ifTrue: [self addLine]].
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jmv 5/17/2009 23:38'!
addStayUpIcons
	| closeBox pinBox w |
	(self valueOfProperty: #hasStayUpIcons ifAbsent: [ false ])
		ifTrue: [
		 	self removeProperty: #needsStayUpIcons.
			^self ].
	titleMorph ifNil: [
		"Title not yet there. Flag ourself, so this method is called again when adding title."
		self setProperty: #needsStayUpIcons toValue: true.
		^ self].
	closeBox := SMxIconicButton new target: self;
		actionSelector: #delete;
		labelGraphic: self class closeBoxImage;
		color: Color transparent;
		extent: 14 @ 16;
		borderWidth: 0.
	pinBox := SMxIconicButton new target: self;
		actionSelector: #stayUp:;
		arguments: {true};
		labelGraphic: self class pushPinImage;
		color: Color transparent;
		extent: 14 @ 15;
		borderWidth: 0.
	w := (titleMorph hasSubmorphs ifTrue: [ titleMorph firstSubmorph width ] ifFalse: [ 0 ]) + 42.
	self addMorphFront: 
		(SMxAlignmentMorph proportional
			height: (titleMorph height max: 19);
			width: w;	"Make room for buttons"
			color: Color transparent;
			addMorph: closeBox
				fullFrame: (SMxLayoutFrame fractions: (0@0 corner: 0@1) offsets: (0@0 corner: 16@0));
			addMorph: titleMorph
				fullFrame: (SMxLayoutFrame fractions: (0@0 corner: 1@1) offsets: (17@0 corner: -17@0));
			addMorph: pinBox
				fullFrame: (SMxLayoutFrame fractions: (1@0 corner: 1@1) offsets: (-16@0 corner: 0@0))).

	self setProperty: #hasStayUpIcons toValue: true.
	self removeProperty: #needsStayUpIcons! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'JuanVuletich 10/26/2010 18:25'!
addStayUpItem
	"Append a menu item that can be used to toggle this menu's persistence."

	self addStayUpIcons.! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'JuanVuletich 10/28/2010 15:38'!
addStayUpItemSpecial
	"Append a menu item that can be used to toggle this menu's persistent."
	self addStayUpIcons.! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:04'!
addTitle

	| string |
	string := SMxFillInTheBlankMorph request: 'Title for this menu?'.
	string isEmpty ifTrue: [^ self].
	self addTitle: string.
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'jmv 5/17/2009 23:36'!
addTitle: aString
	"Add a title line at the top of this menu Make aString its initial 
	contents.  
	If aSelector is not nil, then periodically obtain fresh values for its 
	contents by sending aSelector to aTarget.."

	| s p w |
	
	titleMorph := SMxRectangleMorph new.
	self setTitleParametersFor: titleMorph.
	p := titleMorph position + (4@2).
	(aString asString findTokens: String cr) do: [ :line | 
		s := SMxStringMorph new
			contents: line;
			font: SMxPreferences standardMenuFont.
		s position: p.
		titleMorph addMorphBack: s.
		p := p + (0@s height) ].
	w := titleMorph submorphs inject: 0 into: [ :prev :each |
		prev max: each width ].
	titleMorph height: p y; width: w + 8.
	self addMorphFront: titleMorph.
	
	(self hasProperty: #needsStayUpIcons) ifTrue: [ self addStayUpIcons ]! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'nk 11/25/2003 09:59'!
addTranslatedList: aList
	"Add the given items to this menu, where each item is a pair (<string> <actionSelector>)..  If an element of the list is simply the symobl $-, add a line to the receiver.  The optional third element of each entry, if present, provides balloon help.
	The first and third items will be translated."

	aList do: [:tuple |
		(tuple == #-)
			ifTrue: [self addLine]
			ifFalse:
				[self add: tuple first translated action: tuple second.
				tuple size > 2 ifTrue:
					[self balloonTextForLastItem: tuple third translated ]]]! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 6/11/1999 16:49'!
addUpdating: aWordingSelector action: aSymbol

	self addUpdating: aWordingSelector target: defaultTarget selector: aSymbol argumentList: EmptyArray
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 11/6/2000 13:39'!
addUpdating: wordingSelector enablementSelector: enablementSelector target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by sending the wordingSelector to the target, and the optional enablementSelector determines whether or not the item should be enabled.  Answer the item itself."

	| item |
	item := SMxUpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: target wordingSelector: wordingSelector;
		enablementSelector: enablementSelector;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 6/11/1999 17:26'!
addUpdating: aWordingSelector target: aTarget action: aSymbol

	self addUpdating: aWordingSelector target: aTarget selector: aSymbol argumentList: EmptyArray
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 11/6/2000 13:43'!
addUpdating: wordingSelector target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by sending the wordingSelector to the target,  Answer the item added."

	| item |
	item := SMxUpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: target wordingSelector: wordingSelector;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 8/28/2000 18:02'!
addWithLabel: aLabel enablement: anEnablementSelector action: aSymbol

	self addWithLabel: aLabel enablementSelector: anEnablementSelector target: defaultTarget selector: aSymbol argumentList: EmptyArray
! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 8/28/2000 18:01'!
addWithLabel: aLabel enablementSelector: enablementSelector target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is constant, and the optional enablementSelector determines whether or not the item should be enabled."

	| item |
	item := SMxUpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		contents: aLabel;
		wordingProvider: target wordingSelector: nil;
		enablementSelector: enablementSelector;
		arguments: argList asArray.
	self addMorphBack: item.
! !

!SMxMenuMorph methodsFor: 'private' stamp: 'JuanVuletich 10/22/2010 11:28'!
adjustSubmorphsLayout
	"Enlarge the width of submorphs as needed
	so all of them are have the same width, and no less than #minWidth.
	Also adjust their vertical position.
	Finally, set our own extent."
	
	| w p tl |
	
	submorphs isEmpty ifTrue: [ ^self ].
	w := submorphs inject: 0 into: [ :prev :each |
		prev max: (
			(each is: #answersminItemWidth)
				ifTrue: [each minItemWidth]
				ifFalse: [each width])].

	tl := bounds topLeft.
	p := tl + 5.
	submorphs do: [ :m |
		m width: w.
		m position: p.
		p := m bounds bottomLeft + (0@2) ].
	
	self extent: submorphs last bottomRight - tl + 5! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 11/5/1998 21:13'!
balloonTextForLastItem: balloonText
	submorphs last setBalloonText: balloonText! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'jmv 3/2/2010 09:56'!
commandKeyHandler
	"Answer the receiver's commandKeyHandler"

	^ self valueOfProperty: #commandKeyHandler ifAbsent: nil! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'sw 12/4/2001 21:23'!
commandKeyHandler: anObject
	"Set the receiver's commandKeyHandler.  Whatever you set here needs to be prepared to respond to the message #commandKeyTypedIntoMenu: "

	self setProperty: #commandKeyHandler toValue: anObject! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'ar 9/18/2000 13:19'!
defaultTarget
	^defaultTarget! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'JuanVuletich 10/29/2010 10:43'!
defaultTarget: anObject
	"Set the default target for adding menu items."

	defaultTarget := anObject! !

!SMxMenuMorph methodsFor: 'initialization' stamp: 'ar 10/10/2000 01:57'!
delete
	activeSubMenu ifNotNil:[activeSubMenu delete].
	^super delete! !

!SMxMenuMorph methodsFor: 'control' stamp: 'jmv 3/2/2010 17:08'!
deleteIfPopUp: evt
	"Remove this menu from the screen if stayUp is not true. If it is a submenu, also remove its owning menu."

	stayUp ifFalse: [self delete].
	popUpOwner ifNotNil: [
		popUpOwner isSelected: false.
		popUpOwner deleteIfPopUp: evt].
	evt ifNotNil:[evt hand releaseMouseFocus: self].! !

!SMxMenuMorph methodsFor: 'keyboard control' stamp: 'jmv 5/7/2009 08:36'!
displayFiltered: evt 
	| matchStr allItems isMatch matches feedbackMorph |
	matchStr := self valueOfProperty: #matchString.
	allItems := self submorphs select: [:m | m isKindOf: SMxMenuItemMorph].
	matches := allItems select: 
					[:m | 
					isMatch := matchStr isEmpty 
								or: [m contents includesSubstring: matchStr caseSensitive: false].
					m isEnabled: isMatch.
					isMatch].
	feedbackMorph := self valueOfProperty: #feedbackMorph.
	feedbackMorph ifNil: 
			[feedbackMorph := (SMxTextMorph new)
						autoFit: true;
						color: Color darkGray.
			self
				addLine;
				addMorphBack: feedbackMorph lock.
			self setProperty: #feedbackMorph toValue: feedbackMorph].
	feedbackMorph contents: '<' , matchStr , '>'.
	matchStr isEmpty 
		ifTrue: 
			[feedbackMorph delete.
			self submorphs last delete.
			self removeProperty: #feedbackMorph].
	matches size = 1 ifTrue: [self selectItem: matches first event: evt]! !

!SMxMenuMorph methodsFor: 'events' stamp: 'di 12/5/2001 10:26'!
handleFocusEvent: evt
	"Handle focus events. Valid menu transitions are determined based on the menu currently holding the focus after the mouse went down on one of its children."
	self processEvent: evt.

	"Need to handle keyboard input if we have the focus."
	evt isKeyboard ifTrue: [^ self handleEvent: evt].

	"We need to handle button clicks outside and transitions to local popUps so throw away everything else"
	(evt isMouseOver or:[evt isMouse not]) ifTrue:[^self].
	"What remains are mouse buttons and moves"
	evt isMove ifFalse:[^self handleEvent: evt]. "handle clicks outside by regular means"
	"Now it's getting tricky. On #mouseMove we might transfer control to *either* the currently active submenu or the pop up owner, if any. Since the active sub menu is always displayed upfront check it first."
	selectedItem ifNotNil:[(selectedItem activateSubmenu: evt) ifTrue:[^self]].
	"Note: The following does not traverse upwards but it's the best I can do for now"
	popUpOwner ifNotNil:[(popUpOwner activateOwnerMenu: evt) ifTrue:[^self]].! !

!SMxMenuMorph methodsFor: 'keyboard control' stamp: 'jmv 11/18/2008 13:53'!
handlesKeyboard
	"Answer whether the receiver handle keyboard events"

	^self visible! !

!SMxMenuMorph methodsFor: 'events' stamp: 'ar 9/18/2000 10:13'!
handlesMouseDown: evt
	^true! !

!SMxMenuMorph methodsFor: 'initialization' stamp: 'jmv 5/9/2009 14:47'!
initialize
	super initialize.
	bounds := 0@0 corner: 40@10.
	self setDefaultParameters.
	defaultTarget := nil.
	selectedItem := nil.
	stayUp := false.
	popUpOwner := nil
! !

!SMxMenuMorph methodsFor: 'initialization' stamp: 'jmv 5/7/2009 08:31'!
intoWorld: aWorld

	super intoWorld: aWorld.
	self adjustSubmorphsLayout! !

!SMxMenuMorph methodsFor: 'private' stamp: 'ar 10/7/2000 21:08'!
invokeMetaMenu: evt
	stayUp ifFalse:[^self]. "Don't allow this"
	^super invokeMetaMenu: evt! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'sw 2/3/2002 14:26'!
invokeModal
	"Invoke this menu and don't return until the user has chosen a value.
	See example below on how to use modal menu morphs."
	^ self invokeModal: SMxPreferences menuKeyboardControl

	"Example:
	| menu sub entry |
	menu := SMxMenuMorph new.
	1 to: 3 do: [:i |
		entry := 'Line', i printString.
		sub := SMxMenuMorph new.
		menu add: entry subMenu: sub.
		#('Item A' 'Item B' 'Item C')  do:[:subEntry|
			sub add: subEntry target: menu 
				selector: #modalSelection: argument: {entry. subEntry}]].
	menu invokeModal.
"

! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'JuanVuletich 11/1/2010 15:33'!
invokeModal: allowKeyboardControl
	"Invoke this menu and don't return until the user has chosen a value.  If the allowKeyboarControl boolean is true, permit keyboard control of the menu"

	^ self invokeModalAt: SimpleMorphicUIManager smxActiveHand position in: SimpleMorphicUIManager smxActiveWorld allowKeyboard: allowKeyboardControl! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'jmv 7/23/2008 12:29'!
invokeModalAt: aPoint in: aWorld allowKeyboard: aBoolean
	"Invoke this menu and don't return until the user has chosen a value.
	See senders of this method for finding out how to use modal menu morphs."
	| w oldFocus |
	oldFocus := aWorld primaryHand keyboardFocus.
	self popUpAt: aPoint forHand: aWorld primaryHand in: aWorld allowKeyboard: aBoolean.
	self isModalInvokationDone: false.
	w := aWorld outermostWorldMorph. "containing hand"
	[self isInWorld & self isModalInvokationDone not] whileTrue: [w doOneSubCycle].
	self delete.
	oldFocus ifNotNil: [ aWorld primaryHand newKeyboardFocus: oldFocus ].
	^ self modalSelection! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'ar 1/5/2002 21:33'!
isModalInvokationDone
	^self valueOfProperty: #isModalInvokationDone ifAbsent:[false]! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'ar 1/5/2002 21:34'!
isModalInvokationDone: aBool
	self setProperty: #isModalInvokationDone toValue: aBool
! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
items

	^ submorphs select: [:m | m isKindOf: SMxMenuItemMorph]
! !

!SMxMenuMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 14:23'!
justDroppedInto: aMorph event: evt
	| halo |
	super justDroppedInto: aMorph event: evt.
	halo := evt hand halo.
	(halo notNil and:[halo target hasOwner: self]) ifTrue:[
		"Grabbed single menu item"
		self addHalo: evt.
	].
	stayUp ifFalse:[evt hand newMouseFocus: self].! !

!SMxMenuMorph methodsFor: 'keyboard control' stamp: 'JuanVuletich 10/18/2010 09:04'!
keyStroke: evt 
	| matchString char asc selectable help |
	help := SMxBalloonMorph string: 'Enter text to\narrow selection down\to matching items ' withCRs for: self corner: #topLeft.
	help popUpForHand: self activeHand.
	(evt commandKeyPressed and: [self commandKeyHandler notNil]) 
		ifTrue: 
			[self commandKeyHandler commandKeyTypedIntoMenu: evt.
			^self deleteIfPopUp: evt].
	char := evt keyCharacter.
	asc := char asciiValue.
	char = Character cr 
		ifTrue: 
			[selectedItem ifNotNil: 
					[selectedItem hasSubMenu 
						ifTrue: 
							[evt hand newMouseFocus: selectedItem subMenu.
							^evt hand newKeyboardFocus: selectedItem subMenu]
						ifFalse: 
							["self delete."

							^selectedItem invokeWithEvent: evt]].
			(selectable := self items) size = 1 
				ifTrue: [^selectable first invokeWithEvent: evt].
			^self].
	asc = 27 
		ifTrue: 
			["escape key"

			self valueOfProperty: #matchString
				ifPresentDo: 
					[:str | 
					str isEmpty 
						ifFalse: 
							["If filtered, first ESC removes filter"

							self setProperty: #matchString toValue: String new.
							self selectItem: nil event: evt.
							^self displayFiltered: evt]].
			"If a stand-alone menu, just delete it"
			popUpOwner ifNil: [^self delete].
			"If a sub-menu, then deselect, and return focus to outer menu"
			self selectItem: nil event: evt.
			evt hand newMouseFocus: popUpOwner owner.
			^evt hand newKeyboardFocus: popUpOwner owner].
	(asc = 28 or: [asc = 29]) 
		ifTrue: 
			["left or right arrow key"

			(selectedItem notNil and: [selectedItem hasSubMenu]) 
				ifTrue: 
					[evt hand newMouseFocus: selectedItem subMenu.
					selectedItem subMenu moveSelectionDown: 1 event: evt.
					^evt hand newKeyboardFocus: selectedItem subMenu]].
	asc = 30 ifTrue: [^self moveSelectionDown: -1 event: evt].	"up arrow key"
	asc = 31 ifTrue: [^self moveSelectionDown: 1 event: evt].	"down arrow key"
	asc = 11 ifTrue: [^self moveSelectionDown: -5 event: evt].	"page up key"
	asc = 12 ifTrue: [^self moveSelectionDown: 5 event: evt].	"page down key"
	matchString := self valueOfProperty: #matchString ifAbsentPut: [String new].
	matchString := char = Character backspace 
				ifTrue: 
					[matchString isEmpty ifTrue: [matchString] ifFalse: [matchString allButLast]]
				ifFalse: [matchString copyWith: evt keyCharacter].
	self setProperty: #matchString toValue: matchString.
	self displayFiltered: evt.
	help := SMxBalloonMorph string: 'Enter text to\narrow selection down\to matching items ' withCRs for: self corner: #topLeft.
	help popUpForHand: self activeHand.
! !

!SMxMenuMorph methodsFor: 'keyboard control' stamp: 'di 12/5/2001 11:41'!
keyboardFocusChange: aBoolean
	"Notify change due to green border for keyboard focus"

	self changed! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'JuanVuletich 10/21/2010 11:39'!
labels: labelList lines: linesArray selections: selectionsArray 
	"This method allows the receiver to accept old-style SMxSelectionMenu creation messages. It should be used only for backward compatibility during the MVC-to-Morphic transition. New code should be written using the other menu construction protocol such as addList:."

	"Labels can be either a sting with embedded crs, or a collection of strings."

	| labelArray |
	labelArray := labelList isString
				ifTrue: [ labelList lines ]
				ifFalse: [ labelList ].
	1 to: labelArray size
		do: 
			[:i | 
			self add: (labelArray at: i) action: (selectionsArray at: i).
			(linesArray includes: i) ifTrue: [self addLine]]! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'nk 6/8/2004 16:52'!
lastItem
	^ submorphs reverse
		detect: [ :m | m isKindOf: SMxMenuItemMorph ]
		ifNone: [ submorphs last ]! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'jmv 3/2/2010 09:57'!
modalSelection
	^self valueOfProperty: #modalSelection ifAbsent: nil! !

!SMxMenuMorph methodsFor: 'modal control' stamp: 'ar 1/5/2002 21:34'!
modalSelection: anObject
	self setProperty: #modalSelection toValue: anObject.
	self isModalInvokationDone: true! !

!SMxMenuMorph methodsFor: 'private' stamp: 'ar 2/10/2001 00:37'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"
	^self valueOfProperty: #morphicLayerNumber  ifAbsent: [
		stayUp ifTrue:[100] ifFalse:[10]
	]! !

!SMxMenuMorph methodsFor: 'events' stamp: 'RAA 12/16/2000 11:20'!
mouseDown: evt
	"Handle a mouse down event."
	(stayUp or:[self fullContainsPoint: evt position]) 
		ifFalse:[^self deleteIfPopUp: evt]. "click outside"
	self isSticky ifTrue: [^self].
	"Grab the menu and drag it to some other place"
	evt hand grabMorph: self.! !

!SMxMenuMorph methodsFor: 'events' stamp: 'ar 10/10/2000 01:57'!
mouseUp: evt
	"Handle a mouse up event.
	Note: This might be sent from a modal shell."
	(self fullContainsPoint: evt position) ifFalse:[
		"Mouse up outside. Release eventual focus and delete if pop up."
		evt hand releaseMouseFocus: self.
		^self deleteIfPopUp: evt].
	stayUp ifFalse:[
		"Still in pop-up transition; keep focus"
		evt hand newMouseFocus: self].! !

!SMxMenuMorph methodsFor: 'keyboard control' stamp: 'di 12/10/2001 22:52'!
moveSelectionDown: direction event: evt
	"Move the current selection up or down by one, presumably under keyboard control.
	direction = +/-1"

	| index m |
	index := (submorphs indexOf: selectedItem ifAbsent: [1-direction]) + direction.
	submorphs do: "Ensure finite"
		[:unused | m := submorphs atWrap: index.
		((m isKindOf: SMxMenuItemMorph) and: [m isEnabled]) ifTrue:
			[^ self selectItem: m event: evt].
		"Keep looking for an enabled item"
		index := index + direction sign].
	^ self selectItem: nil event: evt! !

!SMxMenuMorph methodsFor: 'control' stamp: 'jmv 4/27/2010 11:44'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem
	"Present this menu at the given point under control of the given hand."

	| delta tryToPlace selectedOffset |

	hand world startSteppingSubmorphsOf: self.
	popUpOwner := sourceItem.
	selectedOffset := (selectedItem ifNil:[self items first]) position - self position.

	tryToPlace :=
		[ :where :mustFit |
		self position: where - selectedOffset.
		delta := self fullDisplayBounds amountToTranslateWithin: sourceItem world bounds.
		(delta x = 0 or: [mustFit]) ifTrue:
			[delta = (0@0) ifFalse: [self position: self position + delta].
			sourceItem owner owner addMorphFront: self.
			^ self]].
	tryToPlace 
		value: rightOrLeftPoint first value: false;
		value: rightOrLeftPoint last  - (self width @ 0) value: false;
		value: rightOrLeftPoint first value: true

	! !

!SMxMenuMorph methodsFor: 'control' stamp: 'ar 12/27/2001 22:46'!
popUpAt: aPoint forHand: hand in: aWorld
	"Present this menu at the given point under control of the given hand.  Allow keyboard input into the menu."

	^ self popUpAt: aPoint forHand: hand in: aWorld allowKeyboard: SMxPreferences menuKeyboardControl! !

!SMxMenuMorph methodsFor: 'control' stamp: 'jmv 10/2/2009 09:53'!
popUpAt: aPoint forHand: hand in: aWorld allowKeyboard: aBoolean 
	"Present this menu at the given point under control of the given hand."

	| evt |
	self items isEmpty ifTrue: [^self].
	SMxMenuIcons decorateMenu: self.
	(self submorphs select: [:m | m isKindOf: SMxUpdatingMenuItemMorph]) 
		do: [:m | m updateContents].
	self 
		positionAt: aPoint
		relativeTo: (selectedItem ifNil: [self items first])
		inWorld: aWorld.
	aWorld addMorphFront: self.
	"Acquire focus for valid pop up behavior"
	hand newMouseFocus: self.
	aBoolean ifTrue: [hand newKeyboardFocus: self].
	evt := hand lastEvent.
	(evt isKeyboard or: [evt isMouse and: [evt anyButtonPressed not]]) 
		ifTrue: [
			"Select first item if button not down"
			self moveSelectionDown: 1 event: evt]! !

!SMxMenuMorph methodsFor: 'control' stamp: 'ar 3/18/2001 00:33'!
popUpForHand: hand in: aWorld
	| p |
	"Present this menu under control of the given hand."

	p := hand position truncated.
	^self popUpAt: p forHand: hand in: aWorld
! !

!SMxMenuMorph methodsFor: 'control' stamp: 'sw 2/18/2001 00:52'!
popUpInWorld
	"Present this menu in the current World"

	^ self popUpInWorld: self currentWorld! !

!SMxMenuMorph methodsFor: 'control' stamp: 'ar 10/5/2000 19:31'!
popUpInWorld: aWorld
	"Present this menu under control of the given hand."
	^self popUpAt: aWorld primaryHand position forHand: aWorld primaryHand in: aWorld
! !

!SMxMenuMorph methodsFor: 'control' stamp: 'JuanVuletich 11/1/2010 15:33'!
popUpNoKeyboard
	"Present this menu in the current World, *not* allowing keyboard input into the menu"
	^ self popUpAt: SimpleMorphicUIManager smxActiveHand position forHand: SimpleMorphicUIManager smxActiveHand in: SimpleMorphicUIManager smxActiveWorld allowKeyboard: false! !

!SMxMenuMorph methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:28'!
positionAt: aPoint relativeTo: aMenuItem inWorld: aWorld
	"Note: items may not be laid out yet (I found them all to be at 0@0),  
	so we have to add up heights of items above the selected item."

	| i yOffset sub delta |
	self adjustSubmorphsLayout.
	i := 0.
	yOffset := 0.
	[(sub := self submorphs at: (i := i + 1)) == aMenuItem]
		whileFalse: [yOffset := yOffset + sub height].

	self position: aPoint - (2 @ (yOffset + 8)).

	"If it doesn't fit, show it to the left, not to the right of the hand."
	self right > aWorld world bounds right
		ifTrue:
			[self right: aPoint x + 1].

	"Make sure that the menu fits in the world."
	delta := bounds amountToTranslateWithin:
		(aWorld world bounds withHeight: ((aWorld world bounds height - 18) max: (SimpleMorphicUIManager smxActiveHand position y) + 1)).
	delta = (0 @ 0) ifFalse: [self position: self position + delta]! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'jmv 12/5/2009 20:09'!
removeStayUpBox
	| box |
	submorphs isEmpty ifTrue: [^self].
	(submorphs first is: #SMxAlignmentMorph) ifFalse: [^self].
	box := submorphs first submorphs first.
	(box isKindOf: SMxIconicButton) 
		ifTrue: [
			box
				labelGraphic: (Form extent: box extent depth: 8);
				shedSelvedge;
				borderWidth: 0;
				lock]! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'di 12/10/2001 22:11'!
rootMenu
	popUpOwner ifNil: [^ self].
	popUpOwner owner ifNil: [^ self].
	^ popUpOwner owner rootMenu! !

!SMxMenuMorph methodsFor: 'control' stamp: 'ar 9/18/2000 12:16'!
selectItem: aMenuItem event: anEvent
	selectedItem ifNotNil:[selectedItem deselect: anEvent].
	selectedItem := aMenuItem.
	selectedItem ifNotNil:[selectedItem select: anEvent].! !

!SMxMenuMorph methodsFor: 'private' stamp: 'ar 9/18/2000 12:12'!
selectedItem
	^selectedItem! !

!SMxMenuMorph methodsFor: 'initialization' stamp: 'JuanVuletich 11/1/2010 15:52'!
setDefaultParameters
	| colorFromMenu worldColor menuColor menuBorderColor |
	colorFromMenu := SMxPreferences menuColorFromWorld
				and: [Display depth > 4
				and: [(worldColor := self currentWorld color) isColor]].
	""
	menuColor := colorFromMenu
				ifTrue: [worldColor luminance > 0.7
						ifTrue: [worldColor mixed: 0.85 with: Color black]
						ifFalse: [worldColor mixed: 0.4 with: Color white]]
				ifFalse: [SMxPreferences menuColor].
	""
	menuBorderColor := #raised.
	""
	self
		setColor: menuColor
		borderWidth: SMxPreferences menuBorderWidth
		borderColor: menuBorderColor! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'di 4/11/98 14:25'!
setInvokingView: invokingView
	"Re-work every menu item of the form
		<target> perform: <selector>
	to the form
		<target> perform: <selector> orSendTo: <invokingView>.
	This supports MVC's vectoring of non-model messages to the editPane."
	self items do:
		[:item |
		item arguments isEmpty ifTrue:  "only the simple messages"
			[item arguments: (Array with: item selector with: invokingView).
			item selector: #perform:orSendTo:]]! !

!SMxMenuMorph methodsFor: 'initialization' stamp: 'jmv 9/10/2009 08:54'!
setTitleParametersFor: aMenuTitle 
	| menuTitleColor menuTitleBorderColor |
	""
	menuTitleColor := SMxPreferences menuColorFromWorld
				ifTrue: [self color darker]
				ifFalse: [SMxPreferences menuTitleColor].
	""
	menuTitleBorderColor := #inset.
	""
	aMenuTitle
		setColor: menuTitleColor
		borderWidth: SMxPreferences menuTitleBorderWidth
		borderColor: menuTitleBorderColor! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'JuanVuletich 11/1/2010 15:28'!
sightTarget: event 
	| bullseye menu newTarget |
	owner
		ifNil: [^ self ].
	bullseye := Point fromUserWithCursor: Cursor target.
	SimpleMorphicUIManager smxActiveHand position: bullseye.
	menu := SMxCustomMenu new.
	(owner morphsAt: bullseye) do: [ :m |
		menu add: m printString action: m ].
	menu title: self printString, ' targets... '.
	newTarget := menu startUp.
	newTarget
		ifNil: [^ self].
	self target: newTarget! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
stayUp

	^ stayUp
! !

!SMxMenuMorph methodsFor: 'accessing' stamp: 'nk 3/31/2002 15:13'!
stayUp: aBoolean

	stayUp := aBoolean.
	aBoolean ifTrue: [ self removeStayUpBox ].! !

!SMxMenuMorph methodsFor: 'menu' stamp: 'jmv 1/12/2010 11:09'!
target: anObject
	"Set the default target object to be used for add item commands, and re-target all existing items to the new target or the the invoking hand."

	defaultTarget == anObject 
		ifTrue: [ ^self ].
		
	defaultTarget := anObject.
	"re-target all existing items"
	self items do: [ :item | 
		(item target is: #SMxHandMorph)
			ifFalse: [ item target: defaultTarget ]]! !

!SMxMenuMorph methodsFor: 'construction' stamp: 'sw 7/1/1999 22:21'!
title: aString
	"Add a title line at the top of this menu."

	self addTitle: aString! !

!SMxMenuMorph methodsFor: 'copying' stamp: 'ar 9/18/2000 09:34'!
veryDeepFixupWith: deepCopier
	"If fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals."

super veryDeepFixupWith: deepCopier.
defaultTarget := deepCopier references at: defaultTarget ifAbsent: [defaultTarget].
popUpOwner := deepCopier references at: popUpOwner ifAbsent: [popUpOwner].
activeSubMenu := deepCopier references at: activeSubMenu ifAbsent:[activeSubMenu].! !

!SMxMenuMorph methodsFor: 'copying' stamp: 'jmv 5/22/2009 23:29'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"defaultTarget := defaultTarget.		Weakly copied"
selectedItem := selectedItem veryDeepCopyWith: deepCopier.
stayUp := stayUp veryDeepCopyWith: deepCopier.
popUpOwner := popUpOwner.		"Weakly copied"
activeSubMenu := activeSubMenu. "Weakly copied"
titleMorph := deepCopier references at: titleMorph ifAbsent: [titleMorph].! !

!SMxMenuMorph methodsFor: 'control' stamp: 'jmv 12/8/2008 15:41'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph.  A single-item SMxMenuMorph is in effect a button rather than a menu, and as such should not be reluctant to be dropped into another object."

	^ (aMorph isWorldMorph or: [submorphs size = 1]) or:
		[SMxPreferences systemWindowEmbedOK]! !

SMxBorderedMorph subclass: #SMxPasteUpMorph
	instanceVariableNames: 'cursor backgroundMorph worldState'
	classVariableNames: 'DisableDeferredUpdates WindowEventHandler'
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxPasteUpMorph commentStamp: 'jmv 11/27/2008 14:56' prior: 0!
A morph whose submorphs comprise a paste-up of rectangular subparts which "show through".

A World, the entire Smalltalk screen, is a SMxPasteUpMorph.  A World responds true to isWorld.  A SMxPasteUpMorph that is a world, builds its menu in SMxHandMorph buildWorldMenu.

cursor		??
backgroundMorph		A Form that covers the background.
worldState		If I am also a World, keeps the hands, damageRecorder, stepList etc.

!

!SMxPasteUpMorph class methodsFor: 'project' stamp: 'RAA 5/25/2000 15:26'!
disableDeferredUpdates

	^DisableDeferredUpdates ifNil: [DisableDeferredUpdates := false]
! !

!SMxPasteUpMorph class methodsFor: 'project' stamp: 'di 7/15/1999 09:51'!
disableDeferredUpdates: aBoolean
	"If the argument is true, disable deferred screen updating."
	"Details: When deferred updating is used, Morphic performs double-buffered screen updates by telling the VM to de-couple the Display from the hardware display buffer, drawing directly into the Display, and then forcing the changed regions of the Display to be copied to the screen. This saves both time (an extra BitBlt is avoided) and space (an extra display buffer is avoided). However, on platforms on which the Display points directly to the hardware screen buffer, deferred updating can't be used (you'd see ugly flashing as the layers of the drawing were assembled). In this case, the drawing is composited into an offscreen SMxFormCanvas  and then copied to the hardware display buffer."

	DisableDeferredUpdates := aBoolean.
! !

!SMxPasteUpMorph class methodsFor: 'system startup' stamp: 'JuanVuletich 11/1/2010 15:36'!
shutDown
	
	SimpleMorphicUIManager smxWorld ifNotNil:[
		SimpleMorphicUIManager smxWorld triggerEvent: #aboutToLeaveWorld.
	].! !

!SMxPasteUpMorph class methodsFor: 'system startup' stamp: 'JuanVuletich 11/1/2010 15:37'!
startUp
	
	SimpleMorphicUIManager smxWorld ifNotNil: [ :w |
		w restoreMorphicDisplay.
		w triggerEvent: #aboutToEnterWorld.
	].! !

!SMxPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 4/27/2010 11:31'!
acceptDroppingMorph: dropped event: evt 
	"The supplied morph, known to be acceptable to the receiver, is now to be assimilated; the precipitating event is supplied"

	| aMorph |
	aMorph := self morphToDropFrom: dropped.
	self isWorldMorph 
		ifTrue: 
			["Add the given morph to this world and start stepping it if it wants to be."

			self addMorphFront: aMorph.
			(aMorph fullDisplayBounds intersects: self viewBox) 
				ifFalse: 
					[Beeper beep.
					aMorph position: bounds center]]
		ifFalse: [super acceptDroppingMorph: aMorph event: evt].
	aMorph submorphsDo: [:m | (m isKindOf: SMxHaloMorph) ifTrue: [m delete]].
	self world startSteppingSubmorphsOf: aMorph! !

!SMxPasteUpMorph methodsFor: 'structure' stamp: 'di 7/27/1999 10:46'!
activeHand

	^ worldState ifNotNil: [worldState activeHand] ifNil: [super activeHand]! !

!SMxPasteUpMorph methodsFor: 'alarms-scheduler' stamp: 'ar 9/11/2000 16:40'!
addAlarm: aSelector withArguments: argArray for: aTarget at: scheduledTime
	"Add a new alarm with the given set of parameters"
	worldState addAlarm: aSelector withArguments: argArray for: aTarget at: scheduledTime.! !

!SMxPasteUpMorph methodsFor: 'submorphs-add/remove' stamp: 'di 7/15/1999 09:51'!
addAllMorphs: array

	super addAllMorphs: array.
	self isWorldMorph
		ifTrue: [array do: [:m | self startSteppingSubmorphsOf: m]].
! !

!SMxPasteUpMorph methodsFor: 'menu & halo' stamp: 'jmv 5/24/2006 17:19'!
addCustomMenuItems: menu hand: aHandMorph 
	"Add morph-specific menu itemns to the menu for the hand"

	super addCustomMenuItems: menu hand: aHandMorph.
	self isWorldMorph 
		ifTrue: [
			menu 
				add: 'desktop menu...' translated
				target: self
				action: #putUpDesktopMenu:].
	menu addLine! !

!SMxPasteUpMorph methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 23:00'!
addKnownFailing: aMorph
	worldState addKnownFailing: aMorph! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'jmv 4/27/2010 10:54'!
addMorph: aMorph centeredNear: aPoint
	"Add the given morph to this world, attempting to keep its center as close to the given point possible while also keeping the it entirely within the bounds of this world."

	| trialRect delta |
	trialRect := Rectangle center: aPoint extent: aMorph fullDisplayBounds extent.
	delta := trialRect amountToTranslateWithin: bounds.
	aMorph position: trialRect origin + delta.
	self addMorph: aMorph.
! !

!SMxPasteUpMorph methodsFor: 'submorphs-add/remove' stamp: 'RAA 12/16/2000 18:37'!
addMorphFront: aMorph

	^self addMorphInFrontOfLayer: aMorph
! !

!SMxPasteUpMorph methodsFor: 'menu & halo' stamp: 'jmv 5/11/2009 23:53'!
addWorldHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu, given that the receiver is a World"

	| unlockables |
	self addFillStyleMenuItems: aMenu hand: aHandMorph.

	aMenu addLine.
	self addWorldToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.

	self addDebuggingItemsTo: aMenu hand: aHandMorph.

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables := self submorphs select:
		[:m | m isLocked].
	unlockables size = 1 ifTrue:
		[aMenu add: ('unlock "{1}"' translated format:{unlockables first externalName})action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!SMxPasteUpMorph methodsFor: 'menu & halo' stamp: 'jmv 5/28/2006 14:23'!
addWorldToggleItemsToHaloMenu: aMenu
	"Add toggle items for the world to the halo menu"

	#(
	(hasDragAndDropEnabledString changeDragAndDrop 'whether I am open to having objects dropped into me')) do:

		[:trip | aMenu addUpdating: trip first action: trip second.
			aMenu balloonTextForLastItem: trip third]! !

!SMxPasteUpMorph methodsFor: 'submorphs-accessing' stamp: 'RAA 5/24/2000 12:09'!
allMorphsDo: aBlock
	"Enumerate all morphs in the world, including those held in hands."

	super allMorphsDo: aBlock.
	self isWorldMorph
		ifTrue: [worldState handsReverseDo: [:h | h allMorphsDo: aBlock]].
! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'jmv 1/12/2010 10:59'!
allNonFlapRelatedSubmorphs
	"Answer all non-window submorphs that are not flap-related"

	^submorphs 
		select: [:m | (m is: #SMxSystemWindow) not ]! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/24/2000 10:45'!
assuredCanvas
	
	^worldState assuredCanvas! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'JuanVuletich 11/1/2010 15:34'!
becomeActiveDuring: aBlock
	"Make the receiver the ActiveWorld during the evaluation of aBlock.
	Note that this method does deliberately *not* use #ensure: to prevent
	re-installation of the world on project switches."
	| priorWorld priorHand priorEvent |
	priorWorld := SimpleMorphicUIManager smxActiveWorld.
	priorHand := SimpleMorphicUIManager smxActiveHand.
	priorEvent := SimpleMorphicUIManager smxActiveEvent.
	SimpleMorphicUIManager smxActiveWorld: self.
	SimpleMorphicUIManager smxActiveHand: self hands first. "default"
	SimpleMorphicUIManager smxActiveEvent: nil. "not in event cycle"
	[aBlock value]
		on: Error
		do: [:ex | 
			SimpleMorphicUIManager smxActiveWorld: priorWorld.
			SimpleMorphicUIManager smxActiveEvent: priorEvent.
			SimpleMorphicUIManager smxActiveHand: priorHand.
			ex pass]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'sw 1/30/2001 20:37'!
bringWindowsFullOnscreen
	"Make ever SMxSystemWindow on the desktop be totally on-screen, whenever possible."
	
	(SMxSystemWindow windowsIn: self satisfying: [:w | true]) do:
		[:aWindow | 
			aWindow right: (aWindow right min: bounds right).
			aWindow bottom: (aWindow bottom min: bounds bottom).
			aWindow left: (aWindow left max: bounds left).
			aWindow top: (aWindow top max: bounds top)]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 5/20/2006 16:38'!
buildWorldMenu: evt 
	^(SMxTheWorldMenu new 
		world: self
		hand: evt hand) buildWorldMenu	"mvc??"! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'di 7/27/1999 10:46'!
canvas

	^ worldState canvas! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'RAA 5/24/2000 11:10'!
cleanseStepList
	"Remove morphs from the step list that are not in this World.  Often were in a flap that has moved on to another world."

	worldState cleanseStepListForWorld: self! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'jmv 1/2/2010 23:15'!
clearWaitDelay
	worldState clearWaitDelay! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'dgd 9/21/2003 17:39'!
closeUnchangedWindows
	"Present a menu of window titles for all windows with changes,
	and activate the one that gets chosen."
	(SMxSelectionMenu confirm:
'Do you really want to close all windows
except those with unaccepted edits?' translated)
		ifFalse: [^ self].

	(SMxSystemWindow windowsIn: self satisfying: [:w | w model canDiscardEdits])
		do: [:w | w delete]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'ar 10/5/2000 17:27'!
collapseAll
	"Collapse all windows"
	(SMxSystemWindow windowsIn: self satisfying: [:w | w isCollapsed not])
		reverseDo: [:w | w collapseOrExpand.  self displayWorld].
	self collapseNonWindows! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'ar 10/5/2000 17:27'!
collapseNonWindows
	self allNonFlapRelatedSubmorphs do:
		[:m | m collapse]! !

!SMxPasteUpMorph methodsFor: 'misc' stamp: 'JuanVuletich 11/2/2010 10:07'!
currentWindow
	"Answer the top window."

	^SMxSystemWindow topWindow! !

!SMxPasteUpMorph methodsFor: 'cursor' stamp: 'sw 4/21/1998 16:05'!
cursor
	^ cursor
! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color
		r: 0.861
		g: 1.0
		b: 0.722! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:29'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.8
		g: 1.0
		b: 0.6! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'ar 9/17/2000 15:33'!
deleteAllHalos
	self haloMorphs do:
		[:m | (m target isKindOf: SMxSelectionMorph) ifTrue: [m target delete].
		m delete].
! !

!SMxPasteUpMorph methodsFor: 'menu & halo' stamp: 'ar 10/3/2000 17:02'!
deleteBalloonTarget: aMorph
	"Delete the balloon help targeting the given morph"
	self handsDo:[:h| h deleteBalloonTarget: aMorph].! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'dgd 9/21/2003 17:40'!
deleteNonWindows
	(SMxSelectionMenu confirm:
'Do you really want to discard all objects
that are not in windows?' translated)
		ifFalse: [^ self].

	self allNonFlapRelatedSubmorphs do:
		[:m | m delete]! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/25/2000 15:43'!
displayWorld

	self outermostWorldMorph privateOuterDisplayWorld
! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/24/2000 12:23'!
displayWorldSafely

	worldState displayWorldSafely: self.
! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'ls 5/6/2003 16:51'!
doOneCycle
	"see the comment in doOneCycleFor:"

	worldState doOneCycleFor: self! !

!SMxPasteUpMorph methodsFor: 'interaction loop' stamp: 'ls 5/6/2003 16:51'!
doOneCycleNow
	"see the comment in doOneCycleNowFor:"
	worldState doOneCycleNowFor: self.
! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/24/2000 11:59'!
doOneSubCycle
	"Like doOneCycle, but preserves activeHand."

	worldState doOneSubCycleFor: self! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'di 9/19/2000 22:17'!
dragThroughOnDesktop: evt
	"Draw out a selection rectangle"
	| selection |
	selection := SMxSelectionMorph newBounds: (evt cursorPoint extent: 8@8).
	self addMorph: selection.
	^ selection extendByHand: evt hand
! !

!SMxPasteUpMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/10/2010 22:47'!
drawOn: aCanvas 
	"Draw in order:
	- background color
	- grid, if any
	- background sketch, if any
	- Update and draw the turtleTrails form. See the comment in updateTrailsForm.
	- cursor box if any

	Later (in drawSubmorphsOn:) I will skip drawing the background sketch."

	"draw background fill"
	(self isWorldMorph and: [aCanvas form == Display and: [(color := self fillStyle) class == TranslucentColor]])
		ifTrue: [
			(BitBlt current toForm: Display)
				clipRect: aCanvas clipRect;
				copy: bounds
				from: 0@0 in: nil
				fillColor: color rule: Form over]
		ifFalse: [ super drawOn: aCanvas]. 

	"draw background sketch."
	backgroundMorph ifNotNil: [
		self clipsSubmorphs ifTrue: [
			aCanvas clipBy: self clippingBounds
				during: [ :canvas | canvas fullDrawMorph: backgroundMorph ]]
			ifFalse: [ aCanvas fullDrawMorph: backgroundMorph ]]! !

!SMxPasteUpMorph methodsFor: 'painting' stamp: 'jmv 10/8/2009 09:39'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front, but skip my background sketch."

	| drawBlock |
	submorphs isEmpty ifTrue: [^self].
	drawBlock := [:canvas | submorphs reverseDo: [:m | m ~~ backgroundMorph ifTrue: [ canvas fullDrawMorph: m ]]].
	self clipsSubmorphs 
		ifTrue: [aCanvas clipBy: self clippingBounds during: drawBlock]
		ifFalse: [drawBlock value: aCanvas]! !

!SMxPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 2/4/2001 00:54'!
dropEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."

	^ (self valueOfProperty: #dropEnabled) ~~ false
! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'ar 10/5/2000 17:33'!
expandAll
	"Expand all windows"
	(SMxSystemWindow windowsIn: self satisfying: [:w | w isCollapsed])
		reverseDo: [:w | w collapseOrExpand.  self displayWorld]! !

!SMxPasteUpMorph methodsFor: 'geometry' stamp: 'RAA 6/20/2000 12:42'!
extent: aPoint

	super extent: aPoint.
	worldState ifNotNil: [
		worldState viewBox ifNotNil: [
			worldState canvas: nil.
			worldState viewBox: bounds
		].
	].! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/13/2010 14:48'!
findAChangeSorter: evt
	"Locate a change sorter, open it, and bring it to the front.  Create one if necessary"

	self findAWindowSatisfying:
		[:aWindow | (aWindow model isMemberOf: ChangeSorter) or:
				[aWindow model isKindOf: DualChangeSorter]] orMakeOneUsing: [DualChangeSorter new morphicWindow openInWorld]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/28/2010 16:11'!
findAFileList: evt 
	"Locate a file list, open it, and bring it to the front.
	Create one if necessary, respecting the SMxPreference."

	self
		findAWindowSatisfying: [:aWindow | aWindow model isKindOf: FileList]
		orMakeOneUsing: [UIManager default openFileList: (FileList new directory: FileDirectory default)]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/15/2010 21:48'!
findAMessageNamesWindow: evt
	"Locate a MessageNames tool, open it, and bring it to the front. Create one if necessary"

	self findAWindowSatisfying:
		[:aWindow | aWindow model isKindOf: MessageNames] orMakeOneUsing: [
			(MessageNames new inMorphicWindowLabeled: 'Message Names') openInWorld]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/15/2010 21:47'!
findATranscript: evt
	"Locate a transcript, open it, and bring it to the front.  Create one if necessary"

	self
		findAWindowSatisfying: [ :aWindow | aWindow model == Transcript ]
		orMakeOneUsing: [
			SMxSystemWindow
				openStringHolder: Transcript
				asMorphLabel: 'Transcript'
				inWorld: self
				wrap: true ]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/13/2010 14:50'!
findAWindowSatisfying: qualifyingBlock orMakeOneUsing: makeBlock 
	"Locate a window satisfying a block, open it, and bring it to the front.
	Create one if necessary, by using the makeBlock"

	| aWindow |
	submorphs do: [ :aMorph | 
		(((aWindow := aMorph) is: #SMxSystemWindow) 
			and: [ qualifyingBlock value: aWindow ]) 
				ifTrue: [
					aWindow isCollapsed ifTrue: [ aWindow expand ].
					aWindow activateAndForceLabelToShow.
					^self]].
	"None found, so create one"
	makeBlock value! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/14/2010 09:06'!
findDirtyBrowsers: evt 
	"Present a menu of window titles for browsers with changes,
	and activate the one that gets chosen."

	| menu |
	menu := SMxMenuMorph new.
	(SMxBrowserWindow windowsIn: self
		satisfying: [:w | (w model isKindOf: Browser) and: [w model canDiscardEdits not]]) 
			do: 
				[:w | 
				menu 
					add: w label
					target: w
					action: #activate].
	menu submorphs notEmpty ifTrue: [menu popUpInWorld: self]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 5/8/2009 18:55'!
findDirtyWindows: evt 
	"Present a menu of window titles for all windows with changes,
	and activate the one that gets chosen."

	| menu |
	menu := SMxMenuMorph new.
	(SMxSystemWindow windowsIn: self
		satisfying: [:w | w model canDiscardEdits not]) do: 
				[:w | 
				menu 
					add: w label
					target: w
					action: #activate].
	menu submorphs notEmpty ifTrue: [menu popUpInWorld: self]! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 8/23/2010 10:13'!
findWindow: evt 
	"Present a menu names of windows and naked morphs, and activate the one that gets chosen.  Collapsed windows appear below line, expand if chosen; naked morphs appear below second line; if any of them has been given an explicit name, that is what's shown, else the class-name of the morph shows; if a naked morph is chosen, bring it to front and have it don a halo."

	| menu expanded collapsed nakedMorphs |
	menu := SMxMenuMorph new.
	expanded := SMxSystemWindow windowsIn: self
				satisfying: [:w | w isCollapsed not].
	collapsed := SMxSystemWindow windowsIn: self
				satisfying: [:w | w isCollapsed].
	nakedMorphs := self submorphsSatisfying: [:m | (m is: #SMxSystemWindow) not].
	expanded isEmpty & (collapsed isEmpty & nakedMorphs isEmpty) 
		ifTrue: [^Beeper beep].
	(expanded 
		asArray sort: [:w1 :w2 | w1 label caseInsensitiveLessOrEqual: w2 label]) 
			do: 
				[:w | 
				menu 
					add: w label
					target: w
					action: #activateAndForceLabelToShow.
				w model canDiscardEdits ifFalse: [menu lastItem color: Color red]].
	expanded isEmpty | (collapsed isEmpty & nakedMorphs isEmpty) 
		ifFalse: [menu addLine].
	(collapsed 
		asArray sort: [:w1 :w2 | w1 label caseInsensitiveLessOrEqual: w2 label]) 
			do: 
				[:w | 
				menu 
					add: w label
					target: w
					action: #collapseOrExpand.
				w model canDiscardEdits ifFalse: [menu lastItem color: Color red]].
	nakedMorphs isEmpty ifFalse: [menu addLine].
	(nakedMorphs asArray sort: 
			[:w1 :w2 | 
			w1 nameForFindWindowFeature 
				caseInsensitiveLessOrEqual: w2 nameForFindWindowFeature]) 
		do: 
			[:w | 
			menu 
				add: w nameForFindWindowFeature
				target: w
				action: #comeToFrontAndAddHalo].
	menu addTitle: 'find window' translated.
	menu popUpInWorld: self! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'di 7/27/1999 10:46'!
firstHand

	^ worldState hands first! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'ar 5/28/2000 12:10'!
flashRects: rectangleList color: aColor
	"For testing. Flashes the given list of rectangles on the Display so you can watch incremental redisplay at work."
	"Details: Uses two reverses so that the display is restored to its original state. This is necessary when in deferred update mode."

	| blt screenRect |
	blt := (BitBlt current toForm: Display)
		sourceForm: nil;
		sourceOrigin: 0@0;
		clipRect: self viewBox;
		combinationRule: Form reverse.
	rectangleList do: [:r |
		screenRect := r translateBy: self viewBox origin.
		blt destRect: screenRect; copyBits.
		Display forceToScreen: screenRect; forceDisplayUpdate.
		(Delay forMilliseconds: 15) wait.
		blt destRect: screenRect; copyBits.
		Display forceToScreen: screenRect; forceDisplayUpdate].
! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/25/2000 15:12'!
fullRepaintNeeded

	worldState doFullRepaint.
	SMxSystemWindow windowsIn: self
		satisfying: [:w | w makeMeVisible. false].

! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'ar 9/28/2000 18:00'!
haloMorphs
	^ self hands collect:[:h| h halo] thenSelect:[:halo| halo notNil]! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'jmv 2/12/2008 19:09'!
handleFatalDrawingError: errMsg
	"Handle a fatal drawing error."
	
	Display deferUpdates: false. "Just in case"
	self primitiveError: errMsg.

	"Hm... we should jump into a 'safe' worldState here, but how do we find it?!!"! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'ar 10/3/2000 22:46'!
handlesMouseDown: evt
	^true! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'di 7/27/1999 10:46'!
hands

	^ worldState hands! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'nk 7/4/2003 16:47'!
handsDo: aBlock

	^ worldState ifNotNil: [ worldState handsDo: aBlock ]! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'nk 7/4/2003 16:46'!
handsReverseDo: aBlock

	^ worldState ifNotNil: [ worldState handsReverseDo: aBlock ]! !

!SMxPasteUpMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/11/2010 20:03'!
initialize
"initialize the state of the receiver"
	| h |
	super initialize.
""

	worldState := SMxWorldState new.
	h := SMxHandMorph new.
	h instVarNamed: 'owner' put: self.
	worldState instVarNamed: 'hands' put: {h}.
	cursor := 1.
	self enableDragNDrop.
	self clipSubmorphs: true! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'JuanVuletich 11/1/2010 15:36'!
install
	owner := nil.	"since we may have been inside another world previously"
	SimpleMorphicUIManager smxWorld: self.
	SimpleMorphicUIManager smxActiveWorld: self.
	SimpleMorphicUIManager smxActiveHand: self hands first.	"default"
	SimpleMorphicUIManager smxActiveEvent: nil.
	submorphs do: [:ss | ss owner ifNil: [ss privateOwner: self]].
	"Transcript that was in outPointers and then got deleted."
	self viewBox: Display boundingBox.
	Sensor flushAllButDandDEvents.
	worldState handsDo: [:h | h initForEvents].
	self borderWidth: 0.	"default"
	SMxSystemWindow noteTopWindowIn: self.
	self displayWorldSafely! !

!SMxPasteUpMorph methodsFor: 'change reporting' stamp: 'jmv 4/27/2010 11:31'!
invalidRect: damageRect from: aMorph
        "Clip damage reports to my bounds, since drawing is clipped to my bounds."

        self == self outermostWorldMorph 
                ifTrue: [worldState recordDamagedRect: (damageRect intersect: bounds)]
                ifFalse: [super invalidRect: damageRect from: aMorph]
! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 12/24/2004 14:54'!
invokeWorldMenu: evt
	"Put up the world menu, triggered by the passed-in event.
	Perhaps a good place to disable it if needed"

	self putUpWorldMenu: evt! !

!SMxPasteUpMorph methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 23:00'!
isKnownFailing: aMorph
	^worldState isKnownFailing: aMorph! !

!SMxPasteUpMorph methodsFor: 'classification' stamp: 'sw 1/29/98 21:50'!
isPlayfieldLike
	^ true! !

!SMxPasteUpMorph methodsFor: 'classification' stamp: 'di 7/27/1999 10:46'!
isWorldMorph

	^ worldState notNil! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 06:45'!
listOfSteppingMorphs
	^ worldState listOfSteppingMorphs

"self currentWorld listOfSteppingMorphs"! !

!SMxPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 12/19/2004 09:18'!
morphToDropFrom: aMorph 
	"Given a morph being carried by the hand, which the hand is about to drop, answer the actual morph to be deposited.  Normally this would be just the morph itself, but several unusual cases arise, which this method is designed to service."

	^aMorph! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'ar 2/23/2001 16:44'!
morphToGrab: event
	"Return the morph to grab from a mouse down event. If none, return nil."
	self submorphsDo:[:m|
		((m rejectsEvent: event) not and:[m fullContainsPoint: event cursorPoint]) ifTrue:[^m].
	].
	^nil! !

!SMxPasteUpMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 4/27/2010 10:23'!
morphsInFrontOf: someMorph overlapping: aRectangle do: aBlock
	"Include hands if the receiver is the World"
	self handsDo:[:m|
		m == someMorph ifTrue:["Try getting out quickly"
			owner ifNil:[^self].
			^owner morphsInFrontOf: self overlapping: aRectangle do: aBlock].
		"The hand only overlaps if it's not the hardware cursor"
		m needsToBeDrawn ifTrue:[
			(m fullDisplayBounds intersects: aRectangle)
				ifTrue:[aBlock value: m]]].
	^super morphsInFrontOf: someMorph overlapping: aRectangle do: aBlock! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'jmv 5/11/2009 23:38'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos handler |
	grabbedMorph := self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		grabbedMorph isSticky ifTrue:[^self].
		^evt hand grabMorph: grabbedMorph].

	handler := self eventHandler.
	(handler notNil and: [handler handlesMouseDown: evt])
		ifTrue: [^handler mouseDown: evt fromMorph: self].
		
	handHadHalos := evt hand halo notNil.
	evt hand halo: nil. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"
	evt shiftPressed ifTrue:[
		^evt hand 
			waitForClicksOrDrag: self 
			event: evt 
			clkSel: #findWindow:
			dblClkSel: nil
			dblClkTimeoutSel: nil
			dragSel: #dragThroughOnDesktop:].
	self isWorldMorph ifTrue: [
		handHadHalos ifTrue: [^self addAlarm: #invokeWorldMenu: with: evt after: 200].
		^self invokeWorldMenu: evt
	].
	"otherwise, explicitly ignore the event if we're not the world,
	so that we could be picked up if need be"
	self isWorldMorph ifFalse:[evt wasHandled: false].
! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'ar 10/6/2000 00:04'!
mouseUp: evt
	self isWorldMorph ifTrue:[self removeAlarm: #invokeWorldMenu:].
	super mouseUp: evt.! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'jmv 12/20/2004 22:27'!
open
	"Open a view on this WorldMorph."
	self halt.
"	MorphWorldView openOn: self."! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'JuanVuletich 10/13/2010 14:49'!
openRecentSubmissionsBrowser: evt
	"Locate a recent-submissions browser, open it, and bring it to the front.  Create one if necessary.  Only works in morphic"

	self findAWindowSatisfying:
		[:aWindow | aWindow model isKindOf: RecentMessageSet] orMakeOneUsing: [
			(RecentMessageSet recentSubmissionsWindow) openInWorld ]
! !

!SMxPasteUpMorph methodsFor: 'geometry' stamp: 'RAA 6/1/2000 10:28'!
position: aPoint
	"Prevent moving a world (e.g. via SMxHandMorph>>specialGesture:)"

	"for now, let's allow it and see what happens"

	self isWorldMorph ifFalse: [^super position: aPoint].
	super position: aPoint.
	self viewBox ifNotNil: [self viewBox: (aPoint extent: self viewBox extent)].

! !

!SMxPasteUpMorph methodsFor: 'printing' stamp: 'sw 10/18/2000 10:54'!
printOn: aStream
	"Reimplemented to add a tag showing that the receiver is currently functioning as a 'world', if it is"

	super printOn: aStream.
	self isWorldMorph ifTrue: [aStream nextPutAll: ' [world]']! !

!SMxPasteUpMorph methodsFor: 'private' stamp: 'RAA 6/1/2000 14:23'!
privateMoveBy: delta

	super privateMoveBy: delta.
	worldState ifNotNil: [
		worldState viewBox ifNotNil: [
			worldState viewBox: bounds
		].
	].! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 5/25/2000 15:43'!
privateOuterDisplayWorld

	worldState displayWorld: self submorphs: submorphs
! !

!SMxPasteUpMorph methodsFor: 'events-processing' stamp: 'JuanVuletich 11/1/2010 15:34'!
processEvent: anEvent using: defaultDispatcher
	"Reimplemented to install the receiver as the new ActiveWorld if it is one"
	| priorWorld result |
	self isWorldMorph ifFalse:[^super processEvent: anEvent using: defaultDispatcher].
	priorWorld := SimpleMorphicUIManager smxActiveWorld.
	SimpleMorphicUIManager smxActiveWorld: self.
	result := super processEvent: anEvent using: defaultDispatcher.
	SimpleMorphicUIManager smxActiveWorld: priorWorld.
	^result! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'dgd 8/26/2003 21:10'!
putUpDesktopMenu: evt
	"Put up the desktop menu"
	^ ((self buildWorldMenu: evt) addTitle: SMxPreferences desktopMenuTitle translated) popUpAt: evt position forHand: evt hand in: self! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 5/8/2009 18:55'!
putUpWorldMenu: evt
	"Put up a menu in response to a click on the desktop, triggered by evt."

	| menu |
	evt isMouse ifTrue:
		[evt yellowButtonPressed
			ifTrue: [^ self yellowButtonClickOnDesktopWithEvent: evt].
		evt shiftPressed ifTrue:[^ self findWindow: evt]].
	"put up screen menu"
	menu := self buildWorldMenu: evt.
	menu addTitle: SMxPreferences desktopMenuTitle translated.
	menu popUpInWorld: self.
	^ menu! !

!SMxPasteUpMorph methodsFor: 'caching' stamp: 'jmv 12/2/2004 22:57'!
releaseCachedState
	super releaseCachedState.
	self isWorldMorph ifTrue:[self cleanseStepList].! !

!SMxPasteUpMorph methodsFor: 'alarms-scheduler' stamp: 'ar 9/11/2000 16:39'!
removeAlarm: aSelector for: aTarget
	"Remove the alarm with the given selector"
	worldState removeAlarm: aSelector for: aTarget! !

!SMxPasteUpMorph methodsFor: 'errors on draw' stamp: 'jmv 7/20/2009 17:22'!
removeAllKnownFailing
	worldState removeAllKnownFailing.
	self changed! !

!SMxPasteUpMorph methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 23:00'!
removeKnownFailing: aMorph
	worldState removeKnownFailing: aMorph! !

!SMxPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:22'!
repelsMorph: aMorph event: ev
	(aMorph wantsToBeDroppedInto: self) ifFalse: [^ false].
	self dropEnabled ifFalse: [^ true].
	(self wantsDroppedMorph: aMorph event: ev) ifFalse: [^ true].
	^ super repelsMorph: aMorph event: ev "consults #repelling flag"! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'JuanVuletich 11/1/2010 15:36'!
restoreDisplay

	SimpleMorphicUIManager smxWorld restoreMorphicDisplay.	"I don't actually expect this to be called"! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'jmv 1/15/2005 20:25'!
restoreMorphicDisplay
	DisplayScreen startUp.
	self
		extent: Display extent;
		viewBox: Display boundingBox;
		handsDo: 
				[:h | 
				h
					visible: true;
					showTemporaryCursor: nil];
		fullRepaintNeeded.
	SMxWorldState addDeferredUIMessage: [Cursor normal show]! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'RAA 6/7/2000 10:12'!
runLocalStepMethods

	worldState runLocalStepMethodsIn: self
! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'RAA 5/24/2000 10:27'!
runStepMethods

	worldState runStepMethodsIn: self
! !

!SMxPasteUpMorph methodsFor: 'WiW support' stamp: 'RAA 8/14/2000 12:10'!
shouldGetStepsFrom: aWorld

	(self isWorldMorph and: [owner notNil]) ifTrue: [
		^self outermostWorldMorph == aWorld
	].
	^super shouldGetStepsFrom: aWorld! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 7/16/2000 00:36'!
sleep

	self flag: #bob.		"Alan wanted this"

	worldState canvas ifNil: [^ self  "already called (clean this up)"].
	Cursor normal show.	"restore the normal cursor"

">>>> Alan wanted this out
	(turtleTrailsForm ~~ nil and: [self confirm: 'May I clear the pen trails
in this worldState to save space?']) ifTrue: [self clearTurtleTrails].
<<<<<"

	worldState canvas: nil.		"free my canvas to save space"
	self fullReleaseCachedState.
! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:39'!
startStepping: aMorph
	"Add the given morph to the step list. Do nothing if it is already being stepped."
	^self startStepping: aMorph at: Time millisecondClockValue selector: #stepAt: arguments: nil stepTime: nil! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:36'!
startStepping: aMorph at: scheduledTime selector: aSelector arguments: args stepTime: stepTime
	worldState startStepping: aMorph at: scheduledTime selector: aSelector arguments: args stepTime: stepTime.! !

!SMxPasteUpMorph methodsFor: 'world state' stamp: 'RAA 6/1/2000 19:01'!
startSteppingSubmorphsOf: aMorph

	"Ensure that all submorphs of the given morph that want to be stepped are added to the step list.   Typically used after adding a morph to the world."

	aMorph allMorphsDo: [:m |
		m wantsSteps ifTrue: [m arrangeToStartSteppingIn: m world].
	]

! !

!SMxPasteUpMorph methodsFor: 'stepping and presenter' stamp: 'RAA 8/14/2000 11:50'!
step

	(self isWorldMorph and: [owner notNil]) ifTrue: [
		^self runLocalStepMethods
	].
	super step! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 09:56'!
stepListSize
	^ worldState stepListSize

"Transcript cr; show: self currentWorld stepListSize printString, ' items on steplist as of ', Date dateAndTimeNow printString"! !

!SMxPasteUpMorph methodsFor: 'testing' stamp: 'RAA 8/14/2000 11:50'!
stepTime

	(self isWorldMorph and: [owner notNil]) ifTrue: [
		^1
	].
	^super stepTime! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'sw 9/5/2000 09:59'!
steppingMorphsNotInWorld
	| all |
	all := self allMorphs.
	^ self listOfSteppingMorphs select: [:m | (all includes: m) not]

	"self currentWorld steppingMorphsNotInWorld do: [:m | m delete]"! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'RAA 5/24/2000 11:08'!
stopStepping: aMorph
	"Remove the given morph from the step list."

	worldState stopStepping: aMorph
! !

!SMxPasteUpMorph methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:40'!
stopStepping: aMorph selector: aSelector
	"Remove the given morph from the step list."

	worldState stopStepping: aMorph selector: aSelector
! !

!SMxPasteUpMorph methodsFor: 'misc' stamp: 'sw 1/1/1999 16:04'!
unhideHiddenObjects
	self allMorphsDo:
		[:m | m show]! !

!SMxPasteUpMorph methodsFor: 'copying' stamp: 'tk 7/30/2001 09:26'!
veryDeepCopyWith: deepCopier
	"See storeDataOn:"

	^ self isWorldMorph
		ifTrue: [self]	"never copy the World"
		ifFalse: [super veryDeepCopyWith: deepCopier]! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'sw 12/13/1999 12:26'!
viewBox
	"This tortured workaround arises from a situation encountered in which a SMxPasteUpMorph was directliy lodged as a submorph of another SMxPasteUpMorph of identical size, with the former bearing flaps but the latter being the world"
	^ worldState ifNotNil: [worldState viewBox] ifNil: [self pasteUpMorph viewBox]! !

!SMxPasteUpMorph methodsFor: 'project state' stamp: 'jmv 8/23/2010 18:41'!
viewBox: newViewBox
	self isWorldMorph ifTrue: [
		(self viewBox isNil or: [ self viewBox extent ~= newViewBox extent ])
			ifTrue: [ worldState canvas: nil ].
		worldState viewBox: newViewBox ].
	super position: newViewBox topLeft.
	fullBounds := bounds := newViewBox.! !

!SMxPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'JuanVuletich 10/12/2010 12:37'!
visibleClearArea
	"Answer the receiver visible clear area. The intersection 
	between the clear area and the viewbox."
	^ self viewBox! !

!SMxPasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:22'!
wantsDroppedMorph: aMorph event: evt
	self isWorldMorph ifTrue:[^true]. "always"
	self visible ifFalse: [^ false].  "will be a call to #hidden again very soon"
	self dropEnabled ifFalse: [^ false].
	^ true! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'bf 8/30/2007 17:59'!
wantsWindowEvent: anEvent
	^self isWorldMorph or: [self windowEventHandler notNil]! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'jmv 10/7/2010 11:38'!
windowEvent: anEvent
	self windowEventHandler
		ifNotNil: [^self windowEventHandler windowEvent: anEvent].

	anEvent type == #windowClose
		ifTrue: [
			^SMxTheWorldMenu basicNew quitSession]
! !

!SMxPasteUpMorph methodsFor: 'event handling' stamp: 'bf 8/30/2007 18:18'!
windowEventHandler
	"This is a class variable so it is global to all projects and does not get saved"
	^WindowEventHandler! !

!SMxPasteUpMorph methodsFor: 'as yet unclassified' stamp: 'JuanVuletich 10/12/2010 12:39'!
windowsSatisfying: windowBlock

	| windows |
	windows := OrderedCollection new.
	self submorphs do:
		[:m | | s |
		((m is: #SMxSystemWindow) and: [windowBlock value: m])
			ifTrue: [windows addLast: m]].
	^ windows! !

!SMxPasteUpMorph methodsFor: 'structure' stamp: 'jmv 3/2/2010 16:10'!
world
	worldState ifNil: [^super world].
	^self! !

!SMxPasteUpMorph methodsFor: 'world menu' stamp: 'jmv 5/8/2009 18:55'!
yellowButtonClickOnDesktopWithEvent: evt 
	"Put up either the personalized menu or the world menu when 
	the user clicks on the morphic desktop with the yellow button. 
	The preference 'personalizedWorldMenu' governs which one 
	is used"
	| aMenu |
	SMxPreferences personalizedWorldMenu
		ifTrue: [aMenu := SMxMenuMorph new defaultTarget: self.
			SMxPreferences personalizeUserMenu: aMenu.
			aMenu addLine.
			aMenu
				add: 'personalize...' translated
				target: SMxPreferences
				action: #letUserPersonalizeMenu]
		ifFalse: [aMenu := self buildWorldMenu: evt.
			aMenu addTitle: 'World' translated].
	aMenu popUpInWorld: self! !

SMxBorderedMorph subclass: #SMxPluggableMorph
	instanceVariableNames: 'model slotName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxPluggableMorph commentStamp: '<historical>' prior: 0!
MorphicModels are used to represent structures with state and behavior as well as graphical structure.  A morphicModel is usually the root of a morphic tree depicting its appearance.  The tree is constructed concretely by adding its consituent morphs to a world.

When a part is named in a world, it is given a new slot in the model.  When a part is sensitized, it is named, and a set of mouse-driven methods is also generated in the model.  These may be edited to induce particular behavior.  When a variable is added through the morphic world, it is given a slot in the model, along with a set of access methods.

In addition for public variables (and this is the default for now), methods are generated and called in any outer model in which this model gets embedded, thus propagating variable changes outward.!

SMxPluggableMorph subclass: #SMxPluggableButtonMorph
	instanceVariableNames: 'label font getStateSelector actionSelector getLabelSelector getMenuSelector shortcutCharacter askBeforeChanging triggerOnMouseDown offColor onColor feedbackColor showSelectionFeedback allButtons arguments argumentsProvider argumentsSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxPluggableButtonMorph commentStamp: '<historical>' prior: 0!
A SMxPluggableButtonMorph is a combination of an indicator for a boolean value stored in its model and an action button. The action of a button is often, but not always, to toggle the boolean value that it shows. Its pluggable selectors are:

		getStateSelector		fetch a boolean value from the model
		actionSelector		invoke this button's action on the model
		getLabelSelector		fetch this button's lable from the model
		getMenuSelector		fetch a pop-up menu for this button from the model

Any of the above selectors can be nil, meaning that the model does not supply behavior for the given action, and the default behavior should be used. For example, if getStateSelector is nil, then this button shows the state of a read-only boolean that is always false.

The model informs its view(s) of changes by sending #changed: to itself with getStateSelector as a parameter. The view tells the model when the button is pressed by sending actionSelector.

If the actionSelector takes one or more arguments, then the following are relevant:
		arguments			A list of arguments to provide when the actionSelector is called.
		argumentsProvider	The object that is sent the argumentSelector to obtain arguments, if dynamic
		argumentsSelector	The message sent to the argumentProvider to obtain the arguments.

Options:
	askBeforeChanging		have model ask user before allowing a change that could lose edits
	triggerOnMouseDown	do this button's action on mouse down (vs. up) transition
	shortcutCharacter		a place to record an optional shortcut key
!

!SMxPluggableButtonMorph class methodsFor: 'example' stamp: 'jmv 9/21/2009 18:17'!
example
	"SMxPluggableButtonMorph example openInWorld"

	| s1 s2 s3 b1 b2 b3 row |
	s1 := SMxSwitch new.
	s2 := SMxSwitch new turnOn.
	s3 := SMxSwitch new.
	s2 onAction: [s3 turnOff].
	s3 onAction: [s2 turnOff].
	b1 := (SMxPluggableButtonMorph model: s1 stateGetter: #isOn action: #switch) label: 'S1'.
	b2 := (SMxPluggableButtonMorph model: s2 stateGetter: #isOn action: #turnOn) label: 'S2'.
	b3 := (SMxPluggableButtonMorph model: s3 stateGetter: #isOn action: #turnOn) label: 'S3'.

	row := SMxAlignmentMorph proportional
		addInRow: (Array with: b1 with: b2 with: b3);
		extent: 120@35.
	^ row
! !

!SMxPluggableButtonMorph class methodsFor: 'instance creation' stamp: 'jmv 9/21/2009 18:15'!
model: anObject stateGetter: getStateSel action: actionSel

	^ self new
		model: anObject
		stateGetter: getStateSel
		action: actionSel
		labelOrGetter: nil
		menuGetter: nil
! !

!SMxPluggableButtonMorph class methodsFor: 'instance creation' stamp: 'jmv 9/21/2009 18:18'!
model: anObject stateGetter: getStateSel action: actionSel labelOrGetter: labelSelOrString

	^ self new
		model: anObject
		stateGetter: getStateSel
		action: actionSel
		labelOrGetter: labelSelOrString
		menuGetter: nil! !

!SMxPluggableButtonMorph class methodsFor: 'instance creation' stamp: 'jmv 9/21/2009 18:15'!
model: anObject stateGetter: getStateSel action: actionSel labelOrGetter: labelSelOrString menuGetter: menuSel

	^ self new
		model: anObject
		stateGetter: getStateSel
		action: actionSel
		labelOrGetter: labelSelOrString
		menuGetter: menuSel! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: ''!
action: aSymbol 
	"Set actionSelector to be the action defined by aSymbol."

	actionSelector := aSymbol.
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'sw 12/28/2000 16:17'!
actionSelector
	"Answer the receiver's actionSelector"

	^ actionSelector! !

!SMxPluggableButtonMorph methodsFor: 'arguments' stamp: 'sw 2/17/2002 01:03'!
arguments: args
	"If the receiver takes argument(s) that are static, they can be filled by calling this.  If its argument(s) are to be dynamically determined, then use an argumentProvider and argumentSelector instead"

	arguments := args! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/2/98 18:53'!
askBeforeChanging

	^ askBeforeChanging
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/7/98 19:17'!
askBeforeChanging: aBoolean
	"If this preference is turned on, then give the model an opportunity to ask the user before accepting a change that might cause unaccepted edits to be lost."

	askBeforeChanging := aBoolean.
! !

!SMxPluggableButtonMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:37'!
clipsSubmorphs
	^true! !

!SMxPluggableButtonMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:39'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!SMxPluggableButtonMorph methodsFor: 'initialization' stamp: 'jmv 5/28/2009 13:02'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!SMxPluggableButtonMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 10:09'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!SMxPluggableButtonMorph methodsFor: 'drawing' stamp: 'jmv 5/20/2009 10:04'!
drawOn: aCanvas 

	| w f center x y |
	super drawOn: aCanvas.
	f := self fontToUse.
	center := bounds center.

	label ifNotNil: [
		w := f widthOfString: label.
		x := bounds width > w
			ifTrue: [ center x - (w // 2) ]
			ifFalse: [ bounds left +4].
		y := center y - (f height // 2).
		aCanvas drawString: label at: x@y font: f color: Color black ].

	showSelectionFeedback ifTrue: [
		aCanvas frameRectangle: self innerBounds width: 2 color: feedbackColor].! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 17:47'!
feedbackColor: aColor
	"Set the color of this button's selection feedback border."

	feedbackColor := aColor.
	self changed.
! !

!SMxPluggableButtonMorph methodsFor: 'drawing' stamp: 'jmv 5/6/2009 08:33'!
fontToUse
	| fontToUse |
	fontToUse := font ifNil: [SMxPreferences standardButtonFont].
	"
	Could add emphasis...
	^(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [fontToUse]
		ifFalse: [fontToUse emphasized: emphasis]
	"
	^fontToUse! !

!SMxPluggableButtonMorph methodsFor: 'private' stamp: 'jmv 3/2/2010 16:20'!
getMenu: shiftPressed 
	"Answer the menu for this button, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."

	| menu |
	getMenuSelector ifNil: [^nil].
	menu := SMxMenuMorph new defaultTarget: model.
	getMenuSelector numArgs = 1 
		ifTrue: [^model perform: getMenuSelector with: menu].
	getMenuSelector numArgs = 2 
		ifTrue: [
			^model 
				perform: getMenuSelector
				with: menu
				with: shiftPressed].
	^self error: 'The getMenuSelector must be a 1- or 2-keyword symbol'! !

!SMxPluggableButtonMorph methodsFor: 'private' stamp: 'jmv 3/2/2010 16:21'!
getModelState
	"Answer the result of sending the receiver's model the getStateSelector message."

	^ getStateSelector 
		ifNil: [false]
		ifNotNil: [model perform: getStateSelector]! !

!SMxPluggableButtonMorph methodsFor: 'event handling' stamp: 'jm 5/4/1998 16:57'!
handlesMouseDown: evt

	^ true
! !

!SMxPluggableButtonMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:31'!
initialize
	"initialize the state of the receiver"
	super initialize.

	model := nil.
	getStateSelector := nil.
	actionSelector := nil.
	getLabelSelector := nil.
	getMenuSelector := nil.
	shortcutCharacter := nil.
	askBeforeChanging := false.
	triggerOnMouseDown := false.
	onColor := Color transparent.
	offColor := Color transparent.
	feedbackColor := Color red.
	showSelectionFeedback := false.
	allButtons := nil.
	argumentsProvider := nil.
	argumentsSelector := nil.
	self extent: 20 @ 15! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 08:18'!
label: aString
	"Label this button with the given string."

	self label: aString font: nil! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 08:27'!
label: aString font: aFont
	"Label this button with the given string."

	label := aString asString.
	font := aFont! !

!SMxPluggableButtonMorph methodsFor: 'initialize-release' stamp: 'jmv 9/21/2009 18:14'!
model: anObject stateGetter: getStateSel action: actionSel labelOrGetter: labelSelOrString menuGetter: menuSel

	self model: anObject.
	getStateSelector := getStateSel.
	actionSelector := actionSel.
	getMenuSelector := menuSel.
	labelSelOrString isSymbol ifTrue: [
		getLabelSelector := labelSelOrString.
		self update: labelSelOrString ]
	ifFalse: [
		self label: labelSelOrString ]
! !

!SMxPluggableButtonMorph methodsFor: 'event handling' stamp: 'jmv 6/30/2010 23:24'!
mouseDown: evt
	"Details: If this button is triggered on mouse down or the event is the menu gesture, handle it immediately. Otherwise, make a list of buttons (including the receiver) for mouseMove feedback. This allows a simple radio-button effect among the button submorphs of a given morph."

	allButtons := nil.
	evt yellowButtonPressed ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	triggerOnMouseDown
		ifTrue: [self performAction]
		ifFalse: [
			allButtons := owner submorphs select: [:m | m class = self class].
			self updateFeedbackForEvt: evt].
	evt hand
		waitForSimulatedYellow: self
		event: evt
		dblClkSel: #doubleClick:! !

!SMxPluggableButtonMorph methodsFor: 'event handling' stamp: 'jm 5/4/1998 17:30'!
mouseMove: evt

	allButtons ifNil: [^ self].
	allButtons do: [:m | m updateFeedbackForEvt: evt].
! !

!SMxPluggableButtonMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:53'!
mouseUp: evt

	showSelectionFeedback := false.
	(borderColor isColor) ifFalse:[borderColor := #raised].
	allButtons ifNil: [^ self].
	allButtons do: [:m |
		(m containsPoint: evt cursorPoint) ifTrue: [m performAction]].
	allButtons := nil.
	self changed.
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'sw 10/25/1999 14:36'!
offColor
	^ offColor
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'sw 12/28/2000 16:19'!
offColor: colorWhenOff
	"Set the fill colors to be used when this button is off."

	self onColor: onColor offColor: colorWhenOff
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 5/4/1998 16:29'!
onColor: colorWhenOn offColor: colorWhenOff
	"Set the fill colors to be used when this button is on/off."

	onColor := colorWhenOn.
	offColor := colorWhenOff.
	self update: nil.
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jmv 12/8/2008 15:41'!
performAction
	"Inform the model that this button has been pressed. Sent by the controller when this button is pressed. If the button's actionSelector takes any arguments, they are obtained dynamically by sending the argumentSelector to the argumentsProvider"

	askBeforeChanging ifTrue: [model okToChange ifFalse: [^ self]].
	actionSelector ifNotNil:
		[actionSelector numArgs = 0
			ifTrue:
				[model perform: actionSelector]
			ifFalse:
				[argumentsProvider ifNotNil:
					[arguments := argumentsProvider perform: argumentsSelector].
					model perform: actionSelector withArguments: arguments]]! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/2/98 17:43'!
shortcutCharacter
	"Return the Character to be used as a shortcut to turn on this switch, or nil if this switch doesn't have a keyboard shortcut."

	^ shortcutCharacter
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/2/98 17:43'!
shortcutCharacter: aCharacter 
	"Set the character to be used as a keyboard shortcut for turning on this switch."

	shortcutCharacter := aCharacter.
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/2/98 19:26'!
triggerOnMouseDown

	^ triggerOnMouseDown
! !

!SMxPluggableButtonMorph methodsFor: 'accessing' stamp: 'jm 4/7/98 19:16'!
triggerOnMouseDown: aBoolean
	"If this preference is turned on, then trigger my action immediately when the mouse goes down."

	triggerOnMouseDown := aBoolean.
! !

!SMxPluggableButtonMorph methodsFor: 'updating' stamp: 'jm 5/4/1998 17:53'!
update: aParameter 

	getLabelSelector ifNotNil: [
		aParameter == getLabelSelector ifTrue: [
			self label: (model perform: getLabelSelector)]].
	self getModelState
		ifTrue: [self color: onColor]
		ifFalse: [self color: offColor].
! !

!SMxPluggableButtonMorph methodsFor: 'events' stamp: 'JuanVuletich 11/1/2010 15:53'!
updateFeedbackForEvt: evt

	| newState |
	newState := self containsPoint: evt cursorPoint.
	newState = showSelectionFeedback ifFalse: [
		(borderColor isColor)
			ifTrue:[showSelectionFeedback := newState]
			ifFalse:[borderColor := newState ifTrue:[#inset] ifFalse:[#raised]].
		self changed].
! !

!SMxPluggableButtonMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 16:53'!
veryDeepFixupWith: deepCopier
	"If fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
model := deepCopier references at: model ifAbsent: [model].
! !

!SMxPluggableButtonMorph methodsFor: 'copying' stamp: 'jmv 5/6/2009 08:19'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"model := model.		Weakly copied"
"getStateSelector := getStateSelector.		a Symbol"
"actionSelector := actionSelector.		a Symbol"
"getLabelSelector := getLabelSelector.		a Symbol"
"getMenuSelector := getMenuSelector.		a Symbol"
shortcutCharacter := shortcutCharacter veryDeepCopyWith: deepCopier.
askBeforeChanging := askBeforeChanging veryDeepCopyWith: deepCopier.
triggerOnMouseDown := triggerOnMouseDown veryDeepCopyWith: deepCopier.
offColor := offColor veryDeepCopyWith: deepCopier.
onColor := onColor veryDeepCopyWith: deepCopier.
feedbackColor := feedbackColor veryDeepCopyWith: deepCopier.
showSelectionFeedback := showSelectionFeedback veryDeepCopyWith: deepCopier.
allButtons := nil.		"a cache"
arguments := arguments veryDeepCopyWith: deepCopier.
argumentsProvider := argumentsProvider veryDeepCopyWith: deepCopier.
argumentsSelector := argumentsSelector.  " a Symbol" ! !

!SMxPluggableButtonMorph methodsFor: 'private' stamp: 'jmv 5/8/2009 18:55'!
yellowButtonActivity: shiftKeyState
	"Invoke my menu in response to the given event."
	| menu |
	menu := self getMenu: shiftKeyState.
	menu ifNotNil: [menu popUpInWorld: self world]! !

!SMxPluggableMorph class methodsFor: 'new-morph participation' stamp: 'JuanVuletich 10/9/2010 19:14'!
includeInNewMorphMenu
	"Only include Models that are appropriate"
	^ false! !

!SMxPluggableMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color yellow! !

!SMxPluggableMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 200 @ 100! !

!SMxPluggableMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!SMxPluggableMorph methodsFor: 'classification' stamp: 'jmv 9/16/2009 09:50'!
hasModel
	^true! !

!SMxPluggableMorph methodsFor: 'access' stamp: ''!
model 
	^ model! !

!SMxPluggableMorph methodsFor: 'initialization' stamp: 'jm
 8/20/1998 09:08'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
! !

!SMxPluggableMorph methodsFor: 'initialization' stamp: 'jmv 9/16/2009 09:41'!
model: thang slotName: nameOfThisPart
	model := thang.
	slotName := nameOfThisPart! !

!SMxPluggableMorph methodsFor: 'geometry' stamp: ''!
newBounds: newBounds
	self bounds: newBounds! !

!SMxPluggableMorph methodsFor: 'caching' stamp: 'sw 3/6/2001 11:22'!
releaseCachedState
	"Release cached state of the receiver"

	(model ~~ self and: [model respondsTo: #releaseCachedState]) ifTrue:
		[model releaseCachedState].
	super releaseCachedState! !

!SMxPluggableMorph methodsFor: 'compilation' stamp: ''!
use: cachedSelector orMakeModelSelectorFor: selectorBody in: selectorBlock
	| selector |
	model ifNil: [^ nil].
	cachedSelector ifNil:
			["Make up selector from slotname if any"
			selector := (slotName ifNil: [selectorBody]
								ifNotNil: [slotName , selectorBody]) asSymbol.
			(model class canUnderstand: selector) ifFalse:
				[(self confirm: 'Shall I compile a null response for'
							, Character cr asString
							, model class name , '>>' , selector)
						ifFalse: [self halt].
				model class compile: (String streamContents:
								[:s | selector keywords doWithIndex:
										[:k :i | s nextPutAll: k , ' arg' , i printString].
								s cr; nextPutAll: '"Automatically generated null response."'.
								s cr; nextPutAll: '"Add code below for appropriate behavior..."'.])
							classified: 'input events'
							notifying: nil]]
		ifNotNil:
			[selector := cachedSelector].
	^ selectorBlock value: selector! !

SMxPluggableMorph subclass: #SMxScrollBar
	instanceVariableNames: 'slider value setValueSelector sliderShadow sliderColor menuButton upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay scrollBarAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxScrollBar commentStamp: '<historical>' prior: 0!
Inspired by an oiginal design of Hans-Martin Mosner, this SMxScrollBar is intended to exercise the handling of input events in Morphic.  With sufficient flexibility in this area, all particular behavior can be concentrated in this single class with no need to specialize any other morphs to achieve button, slider and menu-button behavior.

Once we have this working, put in logic for horizontal operation as well.

CachedImages was added to reduce the number of forms created and thrown away. This will be helpful for Nebraska and others as well.!

!SMxScrollBar methodsFor: 'accessing' stamp: 'jmv 4/3/2009 17:10'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'jmv 4/5/2009 16:23'!
buttonExtent
	^SMxPreferences scrollbarThickness! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'jmv 4/5/2009 20:16'!
computeSlider
	| r |
	r := self roomToMove.
	slider position: (bounds isWide
		ifTrue: [r topLeft + ((r width * value) asInteger @ 0)]
		ifFalse: [r topLeft + (0 @ (r height * value)  asInteger)]).
	slider extent: self sliderExtent! !

!SMxScrollBar methodsFor: 'initialization' stamp: 'jmv 4/5/2009 20:23'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #inset! !

!SMxScrollBar methodsFor: 'initialization' stamp: 'jmv 4/5/2009 20:23'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxScrollBar methodsFor: 'initialization' stamp: 'jmv 4/5/2009 20:23'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 extent: SMxPreferences scrollbarThickness @ 100! !

!SMxScrollBar methodsFor: 'initialization' stamp: 'jmv 4/5/2009 20:23'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:13'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'jmv 4/5/2009 20:18'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r := self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: 7) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: 7)])! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:45'!
extent: p
        | newExtent |
	newExtent := p x > p y
                ifTrue: [(p max: 42@8)]
                ifFalse: [(p max: 8@42)].
	newExtent = bounds extent ifTrue: [^ self].
	bounds isWide
		ifTrue: [super extent: (newExtent x max: 14) @ newExtent y]
		ifFalse: [super extent: newExtent x @ (newExtent y max: 14)].

	"Most times it is not necessary to recreate the buttons"
	self removeAllMorphs.
	self
		initializeMenuButton;
		initializeUpButton;
		initializeDownButton;
		initializePagingArea.
	self initializeSlider! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:06'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	downButton borderRaised.
	upButton borderRaised.! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'jmv 4/5/2009 16:13'!
initialize
	super initialize.
	value := 0.0.
	self
		initializeMenuButton;
		initializeUpButton;
		initializeDownButton;
		initializePagingArea.
	self initializeSlider.
	scrollDelta := 0.02.
	pageDelta := 0.2! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'jmv 4/5/2009 19:23'!
initializeDownButton
	"initialize the receiver's downButton"

	| e |
	e := self buttonExtent.
	downButton := SMxScrollbarButton 
				newBounds: (self innerBounds bottomRight - e extent: e)
				color: self thumbColor.
	downButton 
		on: #mouseDown
		send: #scrollDownInit
		to: self.
	downButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	bounds isWide
		ifTrue: [ downButton updateRightButtonImage ]
		ifFalse: [ downButton updateDownButtonImage ].
	self addMorph: downButton! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'jmv 4/5/2009 19:07'!
initializeMenuButton
	"initialize the receiver's menuButton"

	(SMxPreferences valueOfFlag: #scrollBarsWithoutMenuButton) ifTrue: [^self].
	menuButton := SMxScrollbarButton 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)
						color: self thumbColor.
	menuButton 
		on: #mouseEnter
		send: #menuButtonMouseEnter:
		to: self.
	menuButton 
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	menuButton 
		on: #mouseLeave
		send: #menuButtonMouseLeave:
		to: self.
	menuButton updateMenuButtonImage.
	self addMorph: menuButton! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'ar 10/7/2000 15:07'!
initializePagingArea
	pagingArea := SMxRectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'jmv 4/5/2009 16:13'!
initializeSlider
	"initialize the receiver's slider"
		
	slider := SMxRectangleMorph newBounds: self totalSliderArea color: self thumbColor.
	sliderShadow := SMxRectangleMorph newBounds: self totalSliderArea
						color: self pagingArea color.
	slider on: #mouseMove send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.
	slider setBorderWidth: 1 borderColor: #raised.
	sliderShadow setBorderWidth: 1 borderColor: #inset.
	"(the shadow must have the pagingArea as its owner to highlight properly)"
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
	self computeSlider.
	
	
	self sliderColor: self sliderColor! !

!SMxScrollBar methodsFor: 'initialize' stamp: 'jmv 4/5/2009 19:24'!
initializeUpButton
	"initialize the receiver's upButton"

	upButton := SMxScrollbarButton 
						newBounds: ((menuButton ifNil: [self innerBounds topLeft]
								ifNotNil: 
									[bounds isWide 
										ifTrue: [menuButton bounds topRight]
										ifFalse: [menuButton bounds bottomLeft]]) 
									extent: self buttonExtent).
	upButton color: self thumbColor.
	upButton 
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	bounds isWide
		ifTrue: [ upButton updateLeftButtonImage ]
		ifFalse: [ upButton updateUpButtonImage ].
	self addMorph: upButton! !

!SMxScrollBar methodsFor: 'access' stamp: 'dew 2/21/1999 03:08'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval := d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!SMxScrollBar methodsFor: 'other events' stamp: 'JuanVuletich 10/12/2010 11:50'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector := sel.  model perform: sel with: event]! !

!SMxScrollBar methodsFor: 'other events' stamp: 'jmv 4/5/2009 20:21'!
mouseDownInSlider: event
	interval = 1.0 ifTrue: [
		"make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBars.].

	slider borderStyle style == #raised
		ifTrue: [slider borderColor: #inset].
	
	sliderShadow color: self sliderShadowColor.
	sliderShadow bounds: slider bounds.
	sliderShadow show! !

!SMxScrollBar methodsFor: 'other events' stamp: 'jmv 4/5/2009 20:21'!
mouseUpInSlider: event 

	slider borderStyle style == #inset
		ifTrue: [slider borderColor: #raised].
	
	sliderShadow hide! !

!SMxScrollBar methodsFor: 'access' stamp: 'dew 2/15/1999 18:25'!
pagingArea
	^pagingArea! !

!SMxScrollBar methodsFor: 'scroll timing' stamp: 'di 8/17/1998 09:22'!
resetTimer
	timeOfMouseDown := Time millisecondClockValue.
	timeOfLastScroll := timeOfMouseDown - 1000 max: 0.
	nextPageDirection := nil.
	currentScrollDelay := nil! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'jmv 4/5/2009 20:17'!
roomToMove
	^ self totalSliderArea insetBy: (0@0 extent: self sliderExtent)! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'jmv 4/5/2009 20:21'!
scrollAbsolute: event
	| r p |
	r := self roomToMove.
	bounds isWide
		ifTrue: [r width = 0 ifTrue: [^ self]]
		ifFalse: [r height = 0 ifTrue: [^ self]].
	p := event targetPoint adhereTo: r.
	self setValue: (bounds isWide 
		ifTrue: [(p x - r left) asFloat / r width]
		ifFalse: [(p y - r top) asFloat / r height])! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'jmv 4/3/2009 17:24'!
scrollBarAction
	^scrollBarAction! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'jmv 4/3/2009 17:24'!
scrollBarAction: aSymbol
	scrollBarAction := aSymbol! !

!SMxScrollBar methodsFor: 'access' stamp: ''!
scrollDelta
	^ scrollDelta! !

!SMxScrollBar methodsFor: 'access' stamp: ''!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta := d1.
	pageDelta := d2.! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!SMxScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
setNextDirectionFromEvent: event

	nextPageDirection := bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!SMxScrollBar methodsFor: 'model access' stamp: 'JuanVuletich 10/12/2010 11:50'!
setValue: newValue
	"Called internally for propagation to model"
	self value: newValue.
	self use: setValueSelector orMakeModelSelectorFor: 'Value:'
		in: [:sel | setValueSelector := sel.  model perform: sel with: value]! !

!SMxScrollBar methodsFor: 'access' stamp: 'jmv 4/5/2009 20:15'!
sliderColor
	"color scheme for the whole slider widget"
	sliderColor ifNil: [^ (color alphaMixed: 0.7 with: Color white) slightlyLighter].
	^ sliderColor! !

!SMxScrollBar methodsFor: 'access' stamp: 'jmv 4/5/2009 20:15'!
sliderColor: aColor 
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	sliderColor := aColor.
	slider ifNotNil: [slider color: sliderColor].
	buttonColor := self thumbColor.
	menuButton
		ifNotNil: [menuButton color: buttonColor].
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor slightlyLighter.
	pagingArea color: (aColor alphaMixed: 0.3 with: Color white).
	self borderWidth: 0! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'dew 2/21/1999 03:08'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!SMxScrollBar methodsFor: 'access' stamp: 'jmv 4/5/2009 20:15'!
sliderShadowColor
	^ self sliderColor alphaMixed: 0.2 with: self pagingArea color! !

!SMxScrollBar methodsFor: 'stepping and presenter' stamp: 'ar 10/7/2000 15:02'!
step
	| action |
	action := self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!SMxScrollBar methodsFor: 'testing' stamp: 'di 4/22/2001 18:30'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!SMxScrollBar methodsFor: 'access' stamp: 'jmv 4/3/2009 17:10'!
thumbColor
	"Problem: Part of the SMxScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self sliderColor alphaMixed: 0.7 with: (Color gray: 0.95)! !

!SMxScrollBar methodsFor: 'geometry' stamp: 'hpt 4/3/2003 19:18'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton := menuButton ifNil: [upButton].
	bounds isWide
		ifTrue: [
			upButton right > upperBoundsButton right
				ifTrue: [upperBoundsButton := upButton].
			^upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse:[
			upButton bottom > upperBoundsButton bottom
				ifTrue: [upperBoundsButton := upButton].
			^upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!SMxScrollBar methodsFor: 'access' stamp: 'jmv 4/5/2009 20:16'!
value
	^ value! !

!SMxScrollBar methodsFor: 'model access' stamp: 'jmv 4/5/2009 20:20'!
value: newValue
	"Drive the slider position externally..."
	value := newValue min: 1.0 max: 0.0.
	self computeSlider! !

!SMxScrollBar methodsFor: 'scroll timing' stamp: 'jmv 3/2/2010 16:29'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll ifNil: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!SMxScrollBar methodsFor: 'testing' stamp: 'ar 10/7/2000 15:02'!
wantsSteps
	^self scrollBarAction notNil! !

SMxPluggableMorph subclass: #SMxScrollPane
	instanceVariableNames: 'scrollBar scroller retractableScrollBar scrollBarOnLeft getMenuSelector getMenuTitleSelector hasFocus hScrollBar hideScrollBars currentScrollRange drawKeyboardFocusIndicator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxScrollPane commentStamp: '<historical>' prior: 0!
The scroller (a transform) of a scrollPane is driven by the scrollBar.  The scroll values vary from 0.0, meaning zero offset to 1.0 meaning sufficient offset such that the bottom of the scrollable material appears 3/4 of the way down the pane.  The total distance to achieve this range is called the totalScrollRange.!

SMxScrollPane subclass: #SMxPluggableListMorph
	instanceVariableNames: 'list getListSelector getListSizeSelector getIndexSelector setIndexSelector keystrokeActionSelector autoDeselect lastKeystrokeTime lastKeystrokes doubleClickSelector handlesBasicKeys potentialDropRow listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxPluggableListMorph commentStamp: '<historical>' prior: 0!
...

When a SMxPluggableListMorph is in focus, type in a letter (or several
letters quickly) to go to the next item that begins with that letter.
Special keys (up, down, home, etc.) are also supported.!

!SMxPluggableListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 11:05'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		model: anObject 
		listGetter: getListSel 
		indexGetter: getSelectionSel 
		indexSetter: setSelectionSel 
		menuGetter: nil
		keystrokeAction: #arrowKey:from:		"default"! !

!SMxPluggableListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 11:09'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		model: anObject
		listGetter: getListSel 
		indexGetter: getSelectionSel 
		indexSetter: setSelectionSel 
		menuGetter: getMenuSel
		keystrokeAction: #arrowKey:from:		"default"! !

!SMxPluggableListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 10:41'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel! !

!SMxPluggableListMorph methodsFor: 'drag and drop' stamp: 'ls 6/22/2001 23:56'!
acceptDroppingMorph: aMorph event: evt 
	"This message is sent when a morph is dropped onto a morph that has     
	agreed to accept the dropped morph by responding 'true' to the     
	wantsDroppedMorph:Event: message. The default implementation just     
	adds the given morph to the receiver."
	"Here we let the model do its work."

	self model
		acceptDroppingMorph: aMorph
		event: evt
		inMorph: self.
	self resetPotentialDropRow.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!SMxPluggableListMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 21:56'!
addCustomMenuItems:  aMenu hand: aHandMorph
	"Add halo menu items to be handled by the invoking hand. The halo menu is invoked by clicking on the menu-handle of the receiver's halo."

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu add: 'list font...' translated target: self action: #setListFont.
	aMenu add: 'copy list to clipboard' translated target: self action: #copyListToClipboard.
	aMenu add: 'copy selection to clipboard' translated target: self action: #copySelectionToClipboard! !

!SMxPluggableListMorph methodsFor: 'updating' stamp: 'jmv 9/10/2010 14:48'!
alertUserContentsChanged
	self flash! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'di 4/10/98 16:20'!
autoDeselect: trueOrFalse
	"Enable/disable autoDeselect (see class comment)"
	autoDeselect := trueOrFalse.! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'ls 6/23/2001 00:45'!
basicKeyPressed: aChar 
	| oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionText |
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	max := self maximumSelection.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self getList copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self getList copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionText := nextSelectionList detect: [:a | a asString withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self flash"match not found"].
	model okToChange ifFalse: [^ self].
	nextSelection := self getList findFirst: [:a | a == nextSelectionText].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'di 5/6/1998 21:18'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."

	setIndexSelector ifNotNil:
		[model perform: setIndexSelector with: anInteger].! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'sw 12/4/2001 20:51'!
commandKeyTypedIntoMenu: evt
	"The user typed a command-key into a menu which has me as its command-key handler"

	^ self modifierKeyPressed: evt keyCharacter! !

!SMxPluggableListMorph methodsFor: 'menus' stamp: 'nk 3/26/2002 08:49'!
copyListToClipboard
	"Copy my items to the clipboard as a multi-line string"

	| stream |
	stream := WriteStream on: (String new: list size * 40).
	list do: [:ea | stream nextPutAll: ea asString] separatedBy: [stream nextPut: Character cr].
	Clipboard clipboardText: stream contents! !

!SMxPluggableListMorph methodsFor: 'menus' stamp: 'sw 3/31/2002 02:38'!
copySelectionToClipboard
	"Copy my selected item to the clipboard as a string"

	self selection
		ifNotNil:
			[Clipboard clipboardText: self selection asString]
		ifNil:
			[self flash]! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'jmv 3/2/2010 16:21'!
doubleClick: event
	| index |
	doubleClickSelector ifNil: [^super doubleClick: event].
	index := self rowAtLocation: event position.
	index = 0 ifTrue: [^super doubleClick: event].
	"selectedMorph ifNil: [self setSelectedMorph: aMorph]."
	^ self model perform: doubleClickSelector! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'sw 1/12/2000 16:22'!
doubleClickSelector: aSymbol
	doubleClickSelector := aSymbol! !

!SMxPluggableListMorph methodsFor: 'drawing' stamp: 'jmv 9/10/2010 09:55'!
drawOn: aCanvas
	super drawOn: aCanvas.

	(drawKeyboardFocusIndicator and: [ self hasKeyboardFocus ]) ifTrue: [
		aCanvas
			frameRectangle: self focusIndicatorRectangle
			width: SMxPreferences focusIndicatorWidth
			color: SMxPreferences focusIndicatorColor ].! !

!SMxPluggableListMorph methodsFor: 'geometry' stamp: 'jmv 10/7/2009 12:27'!
extent: newExtent
	super extent: newExtent.
	
	"Change listMorph's bounds to the new width. It is either the size
	of the widest list item, or the size of self, whatever is bigger"
	self listMorph adjustWidth! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'ls 5/15/2001 22:21'!
font

	^ self listMorph font
! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'ls 5/15/2001 22:21'!
font: aFontOrNil
	self listMorph font: aFontOrNil.
! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'jmv 3/2/2010 16:21'!
getCurrentSelectionIndex
	"Answer the index of the current selection."

	getIndexSelector ifNil: [^0].
	^model perform: getIndexSelector! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'jmv 3/1/2010 11:56'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"
	getListSelector
		ifNil: [^ #()].
	list := model perform: getListSelector.
	list
		ifNil: [^ #()].
	list := list collect: [ :item | item asStringOrText ].
	^ list! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'jmv 9/18/2009 00:56'!
getListItem: index
	"get the index-th item in the displayed list"
	list ifNotNil: [ ^list at: index ].
	^self getList at: index! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'di 6/21/1998 22:19'!
getListSelector
	^ getListSelector! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'ls 5/17/2001 22:04'!
getListSize
	"return the current number of items in the displayed list"
	getListSizeSelector ifNotNil: [ ^model perform: getListSizeSelector ].
	^self getList size! !

!SMxPluggableListMorph methodsFor: 'menu' stamp: 'tk 12/10/2001 20:33'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."

	| aMenu |
	aMenu := super getMenu: shiftKeyState.
	aMenu ifNotNil: [aMenu commandKeyHandler: self].
	^ aMenu! !

!SMxPluggableListMorph methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 09:48'!
hTotalScrollRange
"Return the width of the widest item in the list"

	^self listMorph hTotalScrollRange
! !

!SMxPluggableListMorph methodsFor: 'events-processing' stamp: 'ar 3/17/2001 16:16'!
handleMouseMove: anEvent
	"Reimplemented because we really want #mouseMove when a morph is dragged around"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'ls 10/14/2001 13:09'!
handlesBasicKeys
	" if ya don't want the list to automatically handle non-modifier key 
	(excluding shift key) input, return false"
	^ handlesBasicKeys ifNil: [ true ]! !

!SMxPluggableListMorph methodsFor: 'accessing' stamp: 'jmv 9/10/2010 14:42'!
handlesBasicKeys: aBoolean

	handlesBasicKeys := aBoolean! !

!SMxPluggableListMorph methodsFor: 'event handling' stamp: 'jmv 11/18/2008 13:53'!
handlesKeyboard

	^self visible! !

!SMxPluggableListMorph methodsFor: 'event handling' stamp: 'ar 3/17/2001 16:05'!
handlesMouseOverDragging: evt
	^self dropEnabled! !

!SMxPluggableListMorph methodsFor: 'drawing' stamp: 'ls 5/17/2001 20:53'!
highlightSelection! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'di 10/11/1999 08:45'!
initForKeystrokes
	lastKeystrokeTime := 0.
	lastKeystrokes := ''! !

!SMxPluggableListMorph methodsFor: 'accessing' stamp: 'jmv 3/8/2010 14:27'!
itemFromPoint: aPoint
	"Return the list element (morph) at the given point or nil if outside"
	| ptY |
	scroller hasSubmorphs ifFalse:[^nil].
	(scroller fullBounds containsPoint: aPoint) ifFalse:[^nil].
	ptY := (scroller firstSubmorph internalizePositionToOwner: aPoint from: self) y.
	"note: following assumes that submorphs are vertical, non-overlapping, and ordered"
	scroller firstSubmorph top > ptY ifTrue:[^nil].
	scroller lastSubmorph bottom < ptY ifTrue:[^nil].
	"now use binary search"
	^scroller 
		findSubmorphBinary:[:item|
			(item top <= ptY and:[item bottom >= ptY])
				ifTrue:[0] "found"
				ifFalse:[ (item top + item bottom // 2) > ptY ifTrue:[-1] ifFalse:[1]]]! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'ls 6/10/2001 12:26'!
itemSelectedAmongMultiple: index
	"return whether the index-th row is selected.  Always false in SMxPluggableListMorph, but sometimes true in SMxPluggableListMorphOfMany"
	^false! !

!SMxPluggableListMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:57'!
keyStroke: event 
	"Process keys 
	specialKeys are things like up, down, etc. ALWAYS HANDLED 
	modifierKeys are regular characters either 1) accompanied with ctrl, 
	cmd or 2) any character if the list doesn't want to handle basic 
	keys (handlesBasicKeys returns false) 
	basicKeys are any characters"
	
	| aChar aSpecialKey |
	(self focusKeyboardFor: event)
		ifTrue: [ ^ self ].
	super keyStroke: event.
	(self scrollByKeyboard: event) 
		ifTrue: [^self].
	aChar := event keyCharacter.
	aSpecialKey := aChar asciiValue.
	aSpecialKey < 32 ifTrue: [^ self specialKeyPressed: aSpecialKey].
	(event anyModifierKeyPressed or: [self handlesBasicKeys not])
		ifTrue: [^ self modifierKeyPressed: aChar].
	^ self basicKeyPressed: aChar! !

!SMxPluggableListMorph methodsFor: 'event handling' stamp: 'jmv 4/9/2009 14:29'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"

	self invalidateBorderFeedback! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'sw 1/18/2001 13:08'!
keystrokeActionSelector: keyActionSel
	"Set the keystroke action selector as specified"

	keystrokeActionSelector := keyActionSel! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'di 5/22/1998 00:32'!
listItemHeight
	"This should be cleaned up.  The list should get spaced by this parameter."
	^ 12! !

!SMxPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'jmv 9/10/2009 08:38'!
listMorph
	listMorph ifNil: [
		"crate this lazily"
		listMorph := SMxLazyListMorph new.
		listMorph listSource: self.
		listMorph width: scroller width.
		listMorph color: self textColor.
		scroller removeAllMorphs.
		scroller addMorph: listMorph ].
	^listMorph! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 5/17/2001 23:06'!
maximumSelection
	^ self getListSize! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'di 5/22/1998 00:20'!
minimumSelection
	^ 1! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'jmv 9/16/2009 10:40'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel

	self model: anObject.
	getListSelector := getListSel.
	getIndexSelector := getSelectionSel.
	setIndexSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	autoDeselect := true.
	self borderWidth: 1.
	self updateList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'jmv 3/2/2010 16:21'!
modifierKeyPressed: aChar 
	| args |
	keystrokeActionSelector ifNil: [^nil].
	args := keystrokeActionSelector numArgs.
	args = 1 ifTrue: [^model perform: keystrokeActionSelector with: aChar].
	args = 2 
		ifTrue: [
			^model 
				perform: keystrokeActionSelector
				with: aChar
				with: self].
	^self error: 'keystrokeActionSelector must be a 1- or 2-keyword symbol'! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'jmv 5/11/2009 23:39'!
mouseDown: evt

	| row |
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	self hasKeyboardFocus ifFalse: [
		evt hand newKeyboardFocus: self.
		"If we are focusing, deselect, so that later selection doesn't result in deselect."
		self listMorph noSelection].
	row := self rowAtLocation: evt position.
	row = 0  ifTrue: [^super mouseDown: evt].
	"self dragEnabled ifTrue: [aMorph highlightForMouseDown]."
	evt hand 
		waitForClicksOrDragOrSimulatedYellow: self
		event: evt
		clkSel: #click:
		dblClkSel: (doubleClickSelector ifNotNil:[#doubleClick:])
		dblClkTimeoutSel: nil
		dragSel: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil])! !

!SMxPluggableListMorph methodsFor: 'event handling' stamp: 'jmv 4/12/2009 22:13'!
mouseEnter: event
	super mouseEnter: event.
	SMxPreferences focusFollowsMouse
		ifTrue: [ event hand newKeyboardFocus: self ]! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'ls 6/22/2001 23:58'!
mouseEnterDragging: evt

	(evt hand hasSubmorphs and:[self dropEnabled]) ifFalse: ["no d&d"
		^super mouseEnterDragging: evt].

	(self wantsDroppedMorph: evt hand firstSubmorph event: evt )
		ifTrue:[
			potentialDropRow := self rowAtLocation: evt position.
			evt hand newMouseFocus: self.
			self changed.
			"above is ugly but necessary for now"
		].
! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'ls 6/22/2001 23:56'!
mouseLeaveDragging: anEvent
	(self dropEnabled and:[anEvent hand hasSubmorphs]) ifFalse: ["no d&d"
		^ super mouseLeaveDragging: anEvent].
	self resetPotentialDropRow.
	anEvent hand releaseMouseFocus: self.
	"above is ugly but necessary for now"
! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'ls 6/22/2001 23:55'!
mouseMove: evt

	(self dropEnabled and:[evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropRow ifNotNil:[
		potentialDropRow = (self rowAtLocation: evt position)
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].! !

!SMxPluggableListMorph methodsFor: 'events' stamp: 'jmv 12/8/2008 15:41'!
mouseUp: event
	"The mouse came up within the list; take appropriate action"

	| row |
	row := self rowAtLocation: event position.
	"aMorph ifNotNil: [aMorph highlightForMouseDown: false]."
	model okToChange ifFalse:
		[^ self].
	(autoDeselect == false and: [row = 0]) ifTrue: [^ self].  "work-around the no-mans-land bug"
	"No change if model is locked"
	((autoDeselect == nil or: [autoDeselect]) and: [row == self selectionIndex])
		ifTrue: [self changeModelSelection: 0]
		ifFalse: [self changeModelSelection: row].
	Cursor normal show.
! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'jmv 4/5/2009 23:23'!
numSelectionsInView
	^ self viewableHeight // self listItemHeight! !

!SMxPluggableListMorph methodsFor: 'drag and drop' stamp: 'ls 6/23/2001 00:01'!
potentialDropItem
	"return the item that the most recent drop hovered over, or nil if there is no potential drop target"
	self potentialDropRow = 0 ifTrue: [ ^self ].
	^self getListItem: self potentialDropRow! !

!SMxPluggableListMorph methodsFor: 'drag and drop' stamp: 'ls 6/23/2001 00:10'!
potentialDropRow
	"return the row of the item that the most recent drop hovered over, or 0 if there is no potential drop target"
	^potentialDropRow ifNil: [ 0 ].
! !

!SMxPluggableListMorph methodsFor: 'drag and drop' stamp: 'ls 6/23/2001 00:01'!
resetPotentialDropRow
	potentialDropRow ifNotNil: [
	potentialDropRow ~= 0 ifTrue: [
		potentialDropRow := 0.
		self changed. ] ]! !

!SMxPluggableListMorph methodsFor: 'accessing' stamp: 'jmv 3/8/2010 14:24'!
rowAtLocation: aPoint
	"Return the row at the given point or 0 if outside"
	| pointInListMorphCoords |
	pointInListMorphCoords := scroller internalizePosition: aPoint from: self.
	^self listMorph rowAtLocation: pointInListMorphCoords.! !

!SMxPluggableListMorph methodsFor: 'geometry' stamp: 'ls 5/17/2001 21:01'!
scrollDeltaHeight
	"Return the increment in pixels which this pane should be scrolled."
	^ self font height! !

!SMxPluggableListMorph methodsFor: 'geometry' stamp: 'sps 3/9/2004 17:31'!
scrollDeltaWidth
"A guess -- assume that the width of a char is approx 1/2 the height of the font"
	^ self scrollDeltaHeight // 2

! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'jmv 4/5/2009 22:53'!
scrollSelectionIntoView
	"make sure that the current selection is visible"
	| row |
	row := self getCurrentSelectionIndex.
	row = 0 ifTrue: [ ^ self ].
	self scrollToShow: (self listMorph drawBoundsForRow: row)! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 4/18/2002 00:35'!
selectedMorph: aMorph
"this shouldn't be used any longer"
"self isThisEverCalled ."
Smalltalk beep.
true ifTrue: [ ^self ].
! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 8/19/2001 14:29'!
selection 
	self selectionIndex = 0 ifTrue: [ ^nil ].
	list ifNotNil: [ ^list at: self selectionIndex ].
	^ self getListItem: self selectionIndex! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 6/22/2001 22:49'!
selection: item
	"Called from outside to request setting a new selection."

	self selectionIndex: (self getList indexOf: item)! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 6/22/2001 22:49'!
selectionIndex
	"return the index we have currently selected, or 0 if none"
	^self listMorph selectedRow ifNil: [ 0 ]! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'ls 6/22/2001 22:50'!
selectionIndex: index
	"Called internally to select the index-th item."
	| row |
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self getListSize.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.! !

!SMxPluggableListMorph methodsFor: 'menus' stamp: 'laza 3/25/2004 23:10'!
setListFont
	"set the font for the list"

	SMxPreferences chooseFontWithPrompt: 'choose the font for this list' andSendTo: self withSelector: #font: highlight: self listMorph font! !

!SMxPluggableListMorph methodsFor: 'selection' stamp: 'di 5/6/1998 21:20'!
setSelectedMorph: aMorph
	self changeModelSelection: (scroller submorphs indexOf: aMorph)! !

!SMxPluggableListMorph methodsFor: 'model access' stamp: 'JuanVuletich 11/1/2010 15:25'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ SimpleMorphicUIManager smxActiveEvent shiftPressed
			ifFalse:
				[self yellowButtonActivity: false]].

	max := self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		nextSelection := oldSelection + 1.
		nextSelection > max ifTrue: [nextSelection := 1]].
	asciiValue = 30 ifTrue: 
		[" up arrow"
		nextSelection := oldSelection - 1.
		nextSelection < 1 ifTrue: [nextSelection := max]].
	asciiValue = 1 ifTrue:
		[" home"
		nextSelection := 1].
	asciiValue = 4 ifTrue:
		[" end"
		nextSelection := max].
	howManyItemsShowing := self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		nextSelection := 1 max: oldSelection - howManyItemsShowing].
	asciiValue = 12 ifTrue:
		[" page down"
		nextSelection := oldSelection + howManyItemsShowing min: max].
	model okToChange ifFalse: [^ self].
	"No change if model is locked"
	oldSelection = nextSelection ifTrue: [^ self "flash"	"ugly"].
	^ self changeModelSelection: nextSelection! !

!SMxPluggableListMorph methodsFor: 'drag and drop' stamp: 'jmv 4/1/2009 21:46'!
startDrag: evt 
"
	| ddm draggedItem draggedItemMorph passenger |
	evt hand hasSubmorphs ifTrue: [^self].
	
	[(self dragEnabled and: [model okToChange]) ifFalse: [^self].
	(draggedItem := self selection) ifNil: [^self].
	draggedItemMorph := SMxStringMorph contents: draggedItem asStringOrText.
	passenger := self model dragPassengerFor: draggedItemMorph inMorph: self.
	passenger ifNil: [^self].
	ddm := TransferMorph withPassenger: passenger from: self.
	ddm dragTransferType: (self model dragTransferTypeForMorph: self).
	SMxPreferences dragNDropWithAnimation 
		ifTrue: [self model dragAnimationFor: draggedItemMorph transferMorph: ddm].
	evt hand grabMorph: ddm] 
			ensure: 
				[Cursor normal show.
				evt hand releaseMouseFocus: self]"! !

!SMxPluggableListMorph methodsFor: 'initialization' stamp: 'jmv 9/18/2009 00:51'!
textColor
	"Answer my default text color."
	^Color black! !

!SMxPluggableListMorph methodsFor: 'drawing' stamp: 'ls 5/17/2001 20:53'!
unhighlightSelection
! !

!SMxPluggableListMorph methodsFor: 'updating' stamp: 'ls 5/15/2001 22:31'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector ifTrue: 
		[self updateList.
		^ self].
	aSymbol == getIndexSelector ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self].
! !

!SMxPluggableListMorph methodsFor: 'updating' stamp: 'ls 6/22/2001 23:56'!
updateList
	| index |
	"the list has changed -- update from the model"
	self listMorph listChanged.
	self setScrollDeltas.
	scrollBar setValue: 0.0.
	index := self getCurrentSelectionIndex.
	self resetPotentialDropRow.
	self selectionIndex: index.
! !

!SMxPluggableListMorph methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 09:50'!
vTotalScrollRange
	"Return the height extent of the receiver's submorphs."
	(scroller submorphs size > 0) ifFalse:[ ^0 ].
	^(scroller submorphs last fullBounds bottom)
! !

!SMxPluggableListMorph methodsFor: 'updating' stamp: 'jmv 9/10/2010 14:48'!
verifyContents
	"Verify the contents of the receiver, reconstituting if necessary.  Called whenever window is reactivated, to react to possible structural changes.  Also called periodically in morphic if the smartUpdating preference is true"
	| newList existingSelection anIndex oldList |
	oldList := list ifNil: [ #() ].
	newList := self getList.
	((oldList == newList) "fastest" or: [oldList = newList]) ifTrue: [^ self].
	self alertUserContentsChanged.  "list has changed beneath us; give the user a little visual feedback that the contents of the pane are being updated."
	existingSelection := self selectionIndex > 0 ifTrue: [ oldList at: self selectionIndex ].
	self updateList.
	(existingSelection notNil and: [(anIndex := list indexOf: existingSelection asStringOrText ifAbsent: nil) notNil])
		ifTrue: [
			model noteSelectionIndex: anIndex for: getListSelector.
			self selectionIndex: anIndex]
		ifFalse: [
			self changeModelSelection: 0]! !

!SMxPluggableListMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 5/27/2006 17:49'!
wantsDroppedMorph: aMorph event: anEvent 
	^false! !

SMxPluggableListMorph subclass: #SMxPluggableListMorphByItem
	instanceVariableNames: 'itemList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxPluggableListMorphByItem methodsFor: 'model access' stamp: 'ls 8/19/2001 15:58'!
changeModelSelection: anInteger
	"Change the model's selected item to be the one at the given index."

	| item |
	setIndexSelector ifNotNil: [
		item := (anInteger = 0 ifTrue: [nil] ifFalse: [itemList at: anInteger]).
		model perform: setIndexSelector with: item].
	self update: getIndexSelector.
! !

!SMxPluggableListMorphByItem methodsFor: 'model access' stamp: 'jmv 3/1/2010 11:57'!
getCurrentSelectionIndex
	"Answer the index of the current selection."
	| item |
	getIndexSelector ifNil: [^ 0].
	item := model perform: getIndexSelector.
	^ list findFirst: [ :x | x = item]
! !

!SMxPluggableListMorphByItem methodsFor: 'as yet unclassified' stamp: 'ls 8/19/2001 15:57'!
getList
	"cache the raw items in itemList"
	itemList := getListSelector ifNil: [ #() ] ifNotNil: [ model perform: getListSelector ].
	^super getList! !

SMxPluggableListMorph subclass: #SMxPluggableListMorphOfMany
	instanceVariableNames: 'dragOnOrOff getSelectionListSelector setSelectionListSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxPluggableListMorphOfMany commentStamp: 'hpt 4/5/2004 11:21' prior: 0!
A variant of its superclass that allows multiple items to be selected simultaneously.  There is still a distinguished element which is selected, but each other element in the list may be flagged on or off.
!

!SMxPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 11:16'!
model: anObject listGetter: listSel primarySelectionGetter: getSelectionSel primarySelectionSetter: setSelectionSel listSelectionGetter: getListSel listSelectionSetter: setListSel menuGetter: getMenuSel

	^ self new
		model: anObject
		listGetter: listSel
		primarySelectionGetter: getSelectionSel
		primarySelectionSetter: setSelectionSel
		listSelectionGetter: getListSel
		listSelectionSetter: setListSel
		menuGetter: getMenuSel
		keystrokeAction: #arrowKey:from:		"default"! !

!SMxPluggableListMorphOfMany class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 11:16'!
model: anObject listGetter: listSel primarySelectionGetter: getSelectionSel primarySelectionSetter: setSelectionSel listSelectionGetter: getListSel listSelectionSetter: setListSel menuGetter: getMenuSel keystrokeAction: keyActionSel

	^ self new
		model: anObject
		listGetter: listSel
		primarySelectionGetter: getSelectionSel
		primarySelectionSetter: setSelectionSel
		listSelectionGetter: getListSel
		listSelectionSetter: setListSel
		menuGetter: getMenuSel
		keystrokeAction: keyActionSel! !

!SMxPluggableListMorphOfMany methodsFor: 'model access' stamp: 'hpt 4/5/2004 11:00'!
itemSelectedAmongMultiple: index
	^self listSelectionAt: index! !

!SMxPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'tpr 10/4/2001 21:26'!
listSelectionAt: index
	getSelectionListSelector ifNil:[^false].
	^model perform: getSelectionListSelector with: index! !

!SMxPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'tpr 10/4/2001 21:27'!
listSelectionAt: index put: value
	setSelectionListSelector ifNil:[^false].
	^model perform: setSelectionListSelector with: index with: value! !

!SMxPluggableListMorphOfMany methodsFor: 'initialization' stamp: 'jmv 9/16/2009 11:13'!
model: anObject listGetter: listSel primarySelectionGetter: getSelectionSel primarySelectionSetter: setSelectionSel listSelectionGetter: getListSel listSelectionSetter: setListSel menuGetter: getMenuSel keystrokeAction: keyActionSel
	"setup a whole load of pluggability options"
	getSelectionListSelector := getListSel.
	setSelectionListSelector := setListSel.
	self 
		model: anObject 
		listGetter: listSel 
		indexGetter: getSelectionSel 
		indexSetter: setSelectionSel 
		menuGetter: getMenuSel 
		keystrokeAction: keyActionSel
! !

!SMxPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'jmv 6/30/2010 23:24'!
mouseDown: event

	| oldIndex oldVal row |
	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].

	self hasKeyboardFocus ifFalse: [
		event hand newKeyboardFocus: self ].

	row := self rowAtLocation: event position.

	row = 0 ifTrue: [^super mouseDown: event].

	model okToChange ifTrue: ["No change if model is locked"

		"Set meaning for subsequent dragging of selection"
		dragOnOrOff := (self listSelectionAt: row) not.
		oldIndex := self getCurrentSelectionIndex.
		oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

		"Set or clear new primary selection (listIndex)"
		dragOnOrOff
			ifTrue: [self changeModelSelection: row]
			ifFalse: [self changeModelSelection: 0].

		"Need to restore the old one, due to how model works, and set new one."
		oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
		self listSelectionAt: row put: dragOnOrOff.
		"event hand releaseMouseFocus: aMorph."
		"aMorph changed"
	].
	event hand
		waitForSimulatedYellow: self
		event: event
		dblClkSel: #doubleClick:! !

!SMxPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'nk 10/14/2003 22:19'!
mouseMove: event 
	"The mouse has moved, as characterized by the event provided.  Adjust the scrollbar, and alter the selection as appropriate"

	| oldIndex oldVal row |
	event position y < self top 
		ifTrue: 
			[scrollBar scrollUp: 1.
			row := self rowAtLocation: scroller topLeft + (1 @ 1)]
		ifFalse: 
			[row := event position y > self bottom 
				ifTrue: 
					[scrollBar scrollDown: 1.
					self rowAtLocation: scroller bottomLeft + (1 @ -1)]
				ifFalse: [ self rowAtLocation: event position]].
	row = 0 ifTrue: [^super mouseDown: event].

	model okToChange ifFalse: [^self].	"No change if model is locked"

	dragOnOrOff ifNil: 
			["Was not set at mouse down, which means the mouse must have gone down in an area where there was no list item"
			dragOnOrOff := (self listSelectionAt: row) not].

	"Set meaning for subsequent dragging of selection"
	oldIndex := self getCurrentSelectionIndex.
	oldIndex ~= 0 ifTrue: [oldVal := self listSelectionAt: oldIndex].

	"Set or clear new primary selection (listIndex)"
	dragOnOrOff 
		ifTrue: [self changeModelSelection: row]
		ifFalse: [self changeModelSelection: 0].

	"Need to restore the old one, due to how model works, and set new one."
	oldIndex ~= 0 ifTrue: [self listSelectionAt: oldIndex put: oldVal].
	self listSelectionAt: row put: dragOnOrOff.
	row changed! !

!SMxPluggableListMorphOfMany methodsFor: 'event handling' stamp: 'ar 3/17/2001 16:23'!
mouseUp: event

	dragOnOrOff := nil.  "So improperly started drags will have not effect"! !

!SMxPluggableListMorphOfMany methodsFor: 'updating' stamp: 'di 11/10/1998 14:44'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	^ super update: aSymbol! !

SMxPluggableListMorph subclass: #SMxPluggableMessageCategoryListMorph
	instanceVariableNames: 'getRawListSelector priorRawList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxPluggableMessageCategoryListMorph commentStamp: '<historical>' prior: 0!
A variant of SMxPluggableListMorph designed specially for efficient handling of the --all-- feature in message-list panes.  In order to be able *quickly* to check whether there has been an external change to the list, we cache the raw list for identity comparison (the actual list is a combination of the --all-- element and the the actual list).!

!SMxPluggableMessageCategoryListMorph class methodsFor: 'as yet unclassified' stamp: 'jmv 9/17/2009 23:33'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel rawListGetter: getRawSel
	^ self new model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel rawListGetter: getRawSel! !

!SMxPluggableMessageCategoryListMorph methodsFor: 'model access' stamp: 'jmv 3/1/2010 11:57'!
getList
	"Differs from the generic in that here we obtain and cache the raw list, then cons it together with the special '-- all --' item to produce the list to be used in the browser.  This special handling is done in order to avoid excessive and unnecessary reformulation of the list in the step method"

	getRawListSelector ifNil: ["should not happen!!" priorRawList := nil.  ^ #()].
	model classListIndex = 0 ifTrue: [^ priorRawList := list := Array new].
	priorRawList := model perform: getRawListSelector.
	list := (Array with: ClassOrganizer allCategory), priorRawList.
	^list! !

!SMxPluggableMessageCategoryListMorph methodsFor: 'as yet unclassified' stamp: 'jmv 9/17/2009 23:33'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel rawListGetter: getRawSel
	self model: anObject.
	getListSelector := getListSel.
	getIndexSelector := getSelectionSel.
	setIndexSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	autoDeselect := true.
	self borderWidth: 1.
	getRawListSelector := getRawSel.
	self updateList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !

!SMxPluggableMessageCategoryListMorph methodsFor: 'updating' stamp: 'jmv 3/2/2010 10:02'!
verifyContents
	
	| newList existingSelection anIndex newRawList |
	(model editSelection == #editComment) ifTrue: [^ self].
	model classListIndex = 0 ifTrue: [^ self].
	newRawList := model perform: getRawListSelector.
	newRawList == priorRawList ifTrue: [^ self].  "The usual case; very fast"
	priorRawList := newRawList.
	newList := (Array with: ClassOrganizer allCategory), priorRawList.
	list = newList ifTrue: [^ self].
	self flash.  "could get annoying, but hell"
	existingSelection := self selection.
	self updateList.
	(anIndex := newList indexOf: existingSelection ifAbsent: nil)
		ifNotNil: [
			model noteSelectionIndex: anIndex for: getListSelector.
			self selectionIndex: anIndex]
		ifNil: [
			self changeModelSelection: 0]! !

SMxScrollPane subclass: #SMxPluggableTextMorph
	instanceVariableNames: 'textMorph getTextSelector setTextSelector getSelectionSelector hasUnacceptedEdits askBeforeDiscardingEdits selectionInterval hasEditingConflicts editorClass styler unstyledAcceptText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxPluggableTextMorph commentStamp: '<historical>' prior: 0!
Comment about Shout specifics:
Instances of me are usually created using my #on:text:accept:readSelection:menu: class method.

In order to colour the text, I use an instance of SHTextStylerST80, which I store in my 'styler' instance variable.

When my setText: method is called, I use my styler to ...
	a) optionally set all assignments to ansi or leftArrow. 
	b) Colour my text (immediately, if the text is less than 4096 chars in length, or in a backgroundProcess otherwise)

	When my text is changed, my hasUnacceptedEdits: method is called with true, and I ask my styler to re-colour my text. This is performed in a background process so that typing remains responsive regardless of the length of the text.

	Just before my styler is about to format/style the text, I send #stylerAboutToStyle:  to my model. This gives my model a chance to veto the styling (by answering false), or to initialize the styler with information it needs in order to parse the text correctly (e.g. the class to which a method belongs, or the workspace in which I am contained).

	My styler informs me that it has finished styling by triggering the #stylerStyled: and #stylerStyledInBackground: events which I handle. I then update the textAttributes of my text and refresh the display.
 
	My 'unstyledAcceptText' instance variable is used in conjunction with my #acceptTextInModel and #correctFrom:to:with: methods to ensure that when my text is modified during a method compilation (removing unused vars etc), I do not lose those changes.
	
!

SMxPluggableTextMorph subclass: #SMxAcceptableCleanTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxAcceptableCleanTextMorph methodsFor: 'menu commands' stamp: 'dgd 2/21/2003 22:50'!
accept
	"Overridden to allow accept of clean text"

	| textToAccept ok |
	textToAccept := textMorph asText.
	ok := setTextSelector isNil or: 
					[setTextSelector numArgs = 2 
						ifTrue: 
							[model 
								perform: setTextSelector
								with: textToAccept
								with: self]
						ifFalse: [model perform: setTextSelector with: textToAccept]].
	ok 
		ifTrue: 
			[self setText: self getText.
			self hasUnacceptedEdits: false]! !

!SMxAcceptableCleanTextMorph methodsFor: 'shout' stamp: 'jmv 8/19/2009 23:36'!
okToStyle
	^false! !

SMxPluggableTextMorph subclass: #SMxBrowserCommentTextMorph
	instanceVariableNames: 'browserWindow browserLowerPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxBrowserCommentTextMorph methodsFor: 'displaying' stamp: 'JuanVuletich 10/12/2010 14:00'!
hideOrShowPane
	(self model editSelection == #editClass)
		ifTrue: [ self showPane ]
		ifFalse: [ self hidePane ]! !

!SMxBrowserCommentTextMorph methodsFor: 'displaying' stamp: 'JuanVuletich 10/12/2010 14:00'!
hidePane
	| win |
	self lowerPane ifNotNil: [ :lp | lp layoutFrame bottomFraction: self layoutFrame bottomFraction ].
	win := self window ifNil: [ ^self ].
	self delete.
	win updatePanesFromSubmorphs.! !

!SMxBrowserCommentTextMorph methodsFor: 'acceesing' stamp: 'JuanVuletich 10/12/2010 14:01'!
lowerPane
	"Answer the AlignmentMorph that I live beneath"
	^browserLowerPane! !

!SMxBrowserCommentTextMorph methodsFor: 'acceesing' stamp: 'JuanVuletich 10/12/2010 14:01'!
lowerPane: aMorph

	"Set the AlignmentMorph that I live beneath"
	browserLowerPane := aMorph! !

!SMxBrowserCommentTextMorph methodsFor: 'updating' stamp: 'JuanVuletich 10/12/2010 14:01'!
noteNewOwner: win
	super noteNewOwner: win.
	browserWindow := win.
	win ifNil: [ ^self ].
	"#browserClassCommentPane has no other sender.
	However, don't remove this.
	We need some kind of reference to me, otherwise I'll get collected, when I am
	removed from my owner (the window) when not shown, and no other reference
	to me exists."
	win setProperty: #browserClassCommentPane toValue: self! !

!SMxBrowserCommentTextMorph methodsFor: 'shout' stamp: 'JuanVuletich 10/12/2010 14:02'!
okToStyle
	^false! !

!SMxBrowserCommentTextMorph methodsFor: 'displaying' stamp: 'JuanVuletich 10/12/2010 14:01'!
showPane
	owner ifNil: [
		| win |
		win := self window ifNil: [ ^self ].
		win addMorph: self fullFrame: self layoutFrame.
		win updatePanesFromSubmorphs ].

	self lowerPane ifNotNil: [ :lp | lp layoutFrame bottomFraction: self layoutFrame topFraction ]! !

!SMxBrowserCommentTextMorph methodsFor: 'updating' stamp: 'JuanVuletich 10/12/2010 14:01'!
update: anAspect
	super update: anAspect.
	anAspect == #editSelection ifFalse: [ ^self ].
	self hideOrShowPane! !

!SMxBrowserCommentTextMorph methodsFor: 'acceesing' stamp: 'JuanVuletich 10/12/2010 14:02'!
window
	^self owner ifNil: [ browserWindow ].! !

!SMxPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'jmv 9/21/2009 18:11'!
model: anObject editorClass: anEditorClass textGetter: getTextSel textSetter: setTextSel

	^ self
		model: anObject
		editorClass: anEditorClass
		textGetter: getTextSel
		textSetter: setTextSel
		selectionGetter: nil
		menuGetter: nil! !

!SMxPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'JuanVuletich 10/13/2010 13:12'!
model: anObject editorClass: anEditorClass textGetter: getTextSel textSetter: setTextSel selectionGetter: getSelectionSel menuGetter: getMenuSel
"
on: anObject editorClass: anEditorClass text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
"

	|styler answer |
	answer := self new.
	answer
		model: anObject
		editorClass: anEditorClass
		textGetter: getTextSel
		textSetter: setTextSel
		selectionGetter: getSelectionSel
		menuGetter: getMenuSel.
	^answer! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'JuanVuletich 10/22/2010 10:09'!
accept
	"Inform the model of text to be accepted, and return true if OK."

	"sps 8/13/2001 22:41: save selection and scroll info"

	| textToAccept ok saveSelection saveScrollerOffset |
	saveSelection := self selectionInterval copy.
	saveScrollerOffset := scroller offset copy.
	(self canDiscardEdits and: [(self hasProperty: #alwaysAccept) not]) 
		ifTrue: [^self flash].
	self hasEditingConflicts 
		ifTrue: [
			(self 
				confirm: 'Caution!! This method may have been
changed elsewhere since you started
editing it here.  Accept anyway?' 
						translated) 
					ifFalse: [^self flash]].
	textToAccept := textMorph asText.
	ok := setTextSelector isNil or: [
					setTextSelector numArgs = 2 
						ifTrue: [
							model 
								perform: setTextSelector
								with: textToAccept
								with: self]
						ifFalse: [model perform: setTextSelector with: textToAccept]].
	ok == true 
		ifTrue: [
			self setText: self getText.
			self hasUnacceptedEdits: false.
			(model dependents detect: [ :dep | 
					(dep isKindOf: SMxPluggableTextMorph) 
						and: [dep getTextSelector == #annotation]]
				ifNone: nil) ifNotNil: [ :aPane | model changed: #annotation]].

	"sps 8/13/2001 22:41: restore selection and scroll info"
	
	[
		"During the step for the browser, updateCodePaneIfNeeded is called, and 
		invariably resets the contents of the codeholding SMxPluggableTextMorph
		at that time, resetting the cursor position and scroller in the process.
		The following line forces that update without waiting for the step, 		then restores the cursor and scrollbar"

		ok 
			ifTrue: [
				"(don't bother if there was an error during compile)"
				(model isKindOf: CodeHolder) ifTrue: [ model updateCodePaneIfNeeded ].
				"jmv - moved this outside the deferred message.
				See 'Re: [squeak-dev] scrambled input fields'
				from Gary Chambers on Nov 14, 2008."
				self selectFrom: saveSelection first to: saveSelection last.
				SMxWorldState addDeferredUIMessage: [
						self currentHand newKeyboardFocus: textMorph.
						scroller offset: saveScrollerOffset.
						self setScrollDeltas.
						"self selectFrom: saveSelection first to: saveSelection last"]]
	]
			on: Error
			do: nil! !

!SMxPluggableTextMorph methodsFor: 'layout' stamp: 'jcg 7/7/2000 11:08'!
acceptDroppingMorph: aMorph event: evt 
	"This message is sent when a morph is dropped onto a morph that has     
	agreed to accept the dropped morph by responding 'true' to the     
	wantsDroppedMorph:Event: message. The default implementation just     
	adds the given morph to the receiver."
	"Here we let the model do its work."

	self model
		acceptDroppingMorph: aMorph
		event: evt
		inMorph: self.

! !

!SMxPluggableTextMorph methodsFor: 'initialization' stamp: 'di 9/11/1998 15:46'!
acceptOnCR: trueOrFalse
	textMorph acceptOnCR: trueOrFalse! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
again
	self handleEdit: [textMorph editor again]! !

!SMxPluggableTextMorph methodsFor: 'transcript' stamp: 'JuanVuletich 10/12/2010 23:40'!
appendEntry
	"Append the text in the model's writeStream to the editable text. "
	textMorph asText size > model characterLimit ifTrue:
		["Knock off first half of text"
		self selectInvisiblyFrom: 1 to: textMorph asText size // 2.
		self replaceSelectionWith: Text new].
	self selectInvisiblyFrom: textMorph asText size + 1 to: textMorph asText size.
	self replaceSelectionWith: model contents asText.
	self selectInvisiblyFrom: textMorph asText size + 1 to: textMorph asText size! !

!SMxPluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'di 4/20/1998 18:53'!
askBeforeDiscardingEdits: aBoolean
	"Set the flag that determines whether the user should be asked before discarding unaccepted edits."

	askBeforeDiscardingEdits := aBoolean! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'jmv 9/30/2009 11:16'!
basicSetText: aText
	scrollBar setValue: 0.0.
	textMorph 
		ifNil: [
			textMorph := SMxTextMorphForEditView new
				contents: aText wrappedTo: self viewableWidth.
			textMorph setEditView: self.
			scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 4/24/2001 12:24'!
browseChangeSetsWithSelector
	"Help the user track down which change sets mention a particular selector"

	self handleEdit: [textMorph editor browseChangeSetsWithSelector]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 7/13/2000 20:04'!
browseIt
	self handleEdit: [textMorph editor browseIt]! !

!SMxPluggableTextMorph methodsFor: 'transcript' stamp: 'sma 3/15/2000 21:40'!
bsText
	self changeText: (self text copyFrom: 1 to: (self text size - 1 max: 0))! !

!SMxPluggableTextMorph methodsFor: 'dependents access' stamp: 'di 4/20/1998 18:52'!
canDiscardEdits
	"Return true if this view either has no text changes or does not care."

	^ (hasUnacceptedEdits & askBeforeDiscardingEdits) not
! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'jmv 3/2/2010 10:03'!
cancel
	self setText: self getText.
	self setSelection: self getSelection.
	getTextSelector == #annotation ifFalse: [
		(model dependents detect: [:dep | (dep isKindOf: SMxPluggableTextMorph) and: [
				dep getTextSelector == #annotation]] ifNone: nil)
					ifNotNil: [:aPane | 
						model changed: #annotation]]! !

!SMxPluggableTextMorph methodsFor: 'transcript' stamp: 'di 5/8/1998 21:22'!
changeText: aText
	"The paragraph to be edited is changed to aText."
	self setText: aText! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 9/27/1999 11:57'!
chooseAlignment
	self handleEdit: [textMorph editor changeAlignment]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 5/1/2001 21:37'!
classCommentsContainingIt
	self handleEdit: [textMorph editor classCommentsContainingIt]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 7/31/2002 01:48'!
classNamesContainingIt
	self handleEdit: [textMorph editor classNamesContainingIt]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 7/13/2000 20:04'!
copySelection
	self handleEdit: [textMorph editor copySelection]! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'jmv 8/18/2009 22:42'!
correctFrom: start to: stop with: aString
	unstyledAcceptText ifNotNil: [ unstyledAcceptText replaceFrom: start to: stop with: aString ].
	^ self handleEdit: [textMorph editor correctFrom: start to: stop with: aString]! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'jcg 11/5/2000 22:25'!
correctSelectionWithString: aString
	| result newPosition |

	"I can't tell if this is a hack or if it's the right thing to do."
	self setSelection: selectionInterval. 

	result := self correctFrom: selectionInterval first to: selectionInterval last with: aString.
	newPosition := selectionInterval first + aString size.
	self setSelection: (newPosition to: newPosition - 1).
	^ result! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
cut
	self handleEdit: [textMorph editor cut]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'jmv 8/12/2009 22:50'!
debugIt
	self handleEdit: [textMorph editor debugIt]! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:16'!
deselect
	^ textMorph editor deselect! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 22:04'!
doIt
	self handleEdit: [textMorph editor evaluateSelection]! !

!SMxPluggableTextMorph methodsFor: 'event handling' stamp: 'jmv 6/30/2010 23:21'!
doubleClick: event
	textMorph doubleClick: event! !

!SMxPluggableTextMorph methodsFor: 'drawing' stamp: 'JuanVuletich 11/1/2010 15:55'!
drawOn: aCanvas 
	"Include a thin red inset border for unaccepted edits, or, if the unaccepted edits are known to conflict with a change made somewhere else to the same method (typically), put a thick red frame"

	| bw bc |
	super drawOn: aCanvas.
	bw := SMxPreferences focusIndicatorWidth.
	bc := nil.
	self wantsFrameAdornments ifTrue: [
		((model isKindOf: CodeHolder) and: [model refusesToAcceptCode])
			ifTrue: [  "Put up feedback showing that code cannot be submitted in this state"
				bc := Color tan]
			ifFalse: [
				self hasEditingConflicts
					ifTrue: [
						bw := 3.
						bc := Color red ] 
					ifFalse: [
						self hasUnacceptedEdits
							ifTrue: [
								model wantsDiffFeedback
									ifTrue: [
										bw := 4.
										bc := Color green]
									ifFalse: [
										bc := Color red]]
							ifFalse: [
								model wantsDiffFeedback
									ifTrue: [
										bc := Color green]
									ifFalse: []]]]].

	(drawKeyboardFocusIndicator and: [ textMorph hasKeyboardFocus ]) ifTrue: [
		bc ifNil: [
			bc := SMxPreferences focusIndicatorColor ]]
	ifFalse: [
		bc ifNotNil: [
			bc := bc alphaMixed: 0.4 with: Color white ]].
	bc ifNotNil: [
		aCanvas frameRectangle: self focusIndicatorRectangle width: bw color: bc ]! !

!SMxPluggableTextMorph methodsFor: 'initialization' stamp: 'di 5/4/1998 15:55'!
editString: aString 
	"Jam some text in.  This is treated as clean text by default."

	self setText: aString asText! !

!SMxPluggableTextMorph methodsFor: 'accessing' stamp: 'jmv 7/30/2009 11:36'!
editorClass
	^editorClass! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
explain
	self handleEdit: [textMorph editor explain]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'rhi 12/6/2001 11:06'!
exploreIt

	| result |
	self handleEdit: [
		result := textMorph editor evaluateSelection.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [self flash]
			ifFalse: [result explore]].! !

!SMxPluggableTextMorph methodsFor: 'geometry' stamp: 'jmv 8/30/2010 10:40'!
extent: newExtent 
	super extent: newExtent.
	textMorph ifNotNil: [ textMorph extent: self viewableWidth @ self height ].
	self setScrollDeltas! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
fileItIn
	self handleEdit: [textMorph editor fileItIn]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:42'!
find
	self handleEdit: [textMorph editor find]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:42'!
findAgain
	self handleEdit: [textMorph editor findAgain]! !

!SMxPluggableTextMorph methodsFor: 'focus handling' stamp: 'jmv 11/12/2008 10:16'!
focusText

	self activeHand newKeyboardFocus: textMorph! !

!SMxPluggableTextMorph methodsFor: 'menu' stamp: 'jmv 3/1/2010 11:59'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key. The third argument, if required, is the editorClass."
	| menu aMenu aTitle |
	getMenuSelector
		ifNil: [^ nil].
	getMenuSelector numArgs = 3 ifFalse: [
		^super getMenu: shiftKeyState ].
	
	menu := SMxMenuMorph new defaultTarget: model.
	aTitle := getMenuTitleSelector ifNotNil: [model perform: getMenuTitleSelector].
	aMenu := model perform: getMenuSelector with: menu with: shiftKeyState with: editorClass.
	aTitle ifNotNil:  [aMenu addTitle: aTitle].
	^ aMenu! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'jmv 3/2/2010 16:21'!
getSelection
	"Answer the model's selection interval."

	getSelectionSelector ifNil: [^1 to: 0].	"null selection"
	^model perform: getSelectionSelector! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'JuanVuletich 10/12/2010 23:40'!
getText
	"Retrieve the current model text"

	| newText |
	getTextSelector ifNil: [^Text new].
	newText := model perform: getTextSelector.
	newText ifNil: [^Text new].
	^newText shallowCopy! !

!SMxPluggableTextMorph methodsFor: 'accessing' stamp: 'sr 4/25/2000 07:21'!
getTextSelector
	^getTextSelector! !

!SMxPluggableTextMorph methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 09:48'!
hTotalScrollRange
"Return the width of the widest item in the list"

	textMorph ifNil: [ ^0 ].
	textMorph isWrapped ifTrue:[ ^0 ].

	^super hTotalScrollRange
! !

!SMxPluggableTextMorph methodsFor: 'editor access' stamp: 'di 11/2/1998 15:57'!
handleEdit: editBlock
	| result |
	textMorph editor selectFrom: selectionInterval first to: selectionInterval last;
						model: model.  "For, eg, evaluateSelection"
	textMorph handleEdit: [result := editBlock value].   "Update selection after edit"
	self scrollSelectionIntoView.
	^ result! !

!SMxPluggableTextMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:44'!
handlesKeyboard

	"Not answering true helps not hitting pluggable texts twice during navigation. Only the internal text morph will receive it.
	If some problem is found, introduce a new selector, that answers ^self handlesKeyboard in morph 
	and only in this class it will answer false"
"	^self visible" 
	^ super handlesKeyboard! !

!SMxPluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'sw 10/10/1999 22:55'!
hasEditingConflicts
	"Return true if a conflicting edit to the same code (typically) is known to have occurred after the current contents started getting edited"

	^ hasEditingConflicts == true! !

!SMxPluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'sw 10/10/1999 22:55'!
hasEditingConflicts: aBoolean

	hasEditingConflicts := aBoolean! !

!SMxPluggableTextMorph methodsFor: 'dependents access' stamp: 'di 4/20/1998 18:56'!
hasUnacceptedEdits
	"Return true if this view has unaccepted edits."

	^ hasUnacceptedEdits! !

!SMxPluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'jmv 8/18/2009 22:44'!
hasUnacceptedEdits: aBoolean
	"Set the hasUnacceptedEdits flag to the given value. "
	aBoolean == hasUnacceptedEdits ifFalse:
		[hasUnacceptedEdits := aBoolean.
		self changed].
	aBoolean ifFalse: [hasEditingConflicts := false].

	"shout:  re-style the text iff aBoolean is true"
	(aBoolean and: [self okToStyle])
		ifTrue: [ styler styleInBackgroundProcess: textMorph contents ]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
implementorsOfIt
	self handleEdit: [textMorph editor implementorsOfIt]! !

!SMxPluggableTextMorph methodsFor: 'initialization' stamp: 'sw 10/10/1999 23:01'!
initialize
	super initialize.
	hasUnacceptedEdits := false.
	hasEditingConflicts := false.
	askBeforeDiscardingEdits := true! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 22:07'!
inspectIt
	| result |
	self handleEdit:
		[result := textMorph editor evaluateSelection.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [self flash]
			ifFalse: [result inspect]]! !

!SMxPluggableTextMorph methodsFor: 'testing' stamp: 'jmv 12/5/2009 19:47'!
is: aSymbol
	^aSymbol = #HasTextSelector or: [ super is: aSymbol ]! !

!SMxPluggableTextMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:58'!
keyStroke: evt
	"A keystroke was hit while the receiver had keyboard focus.  Pass the keywtroke on to my textMorph, and and also, if I have an event handler, pass it on to that handler"

	(self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].
	textMorph keyStroke: evt.
	self eventHandler ifNotNil: [
		self eventHandler keyStroke: evt fromMorph: self ]
! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodNamesContainingIt
	self handleEdit: [textMorph editor methodNamesContainingIt]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodSourceContainingIt
	self handleEdit: [textMorph editor methodSourceContainingIt]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodStringsContainingit
	self handleEdit: [textMorph editor methodStringsContainingit]! !

!SMxPluggableTextMorph methodsFor: 'scrolling' stamp: 'jmv 9/30/2009 11:46'!
mightNeedHorizontalScrollBar

	textMorph ifNil: [ ^false ].
	textMorph isWrapped ifTrue: [ ^false ].

	^super mightNeedHorizontalScrollBar
! !

!SMxPluggableTextMorph methodsFor: 'initialization' stamp: 'jmv 9/21/2009 17:51'!
model: anObject editorClass: anEditorClass textGetter: getTextSel textSetter: setTextSel selectionGetter: getSelectionSel menuGetter: getMenuSel
"
on: anObject editorClass: anEditorClass text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
"
	editorClass := anEditorClass.
	self model: anObject.
	getTextSelector := getTextSel.
	setTextSelector := setTextSel.
	getSelectionSelector := getSelectionSel.
	getMenuSelector := getMenuSel.
	self borderWidth: 1.
	self setText: self getText.
	self setSelection: self getSelection.! !

!SMxPluggableTextMorph methodsFor: 'event handling' stamp: 'jmv 9/10/2010 22:53'!
mouseEnter: event
	super mouseEnter: event.
	SMxPreferences focusFollowsMouse
		ifTrue: [ event hand newKeyboardFocus: textMorph ]! !

!SMxPluggableTextMorph methodsFor: 'event handling' stamp: 'jmv 11/7/2008 14:18'!
mouseLeave: event
	"The mouse has left the area of the receiver"

	textMorph ifNotNil: [selectionInterval := textMorph editor selectionInterval].
	super mouseLeave: event! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:26'!
nextTokenFrom: start direction: dir
	^ textMorph editor nextTokenFrom: start direction: dir! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/20/1998 08:32'!
notify: aString at: anInteger in: aStream
	^ textMorph editor notify: aString at: anInteger in: aStream! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'ar 12/17/2001 13:00'!
offerFontMenu
	self handleEdit: [textMorph editor changeTextFont]! !

!SMxPluggableTextMorph methodsFor: 'shout' stamp: 'jmv 8/19/2009 18:18'!
okToStyle
	styler ifNil: [ ^false ].
	^model shoutAboutToStyle: styler
! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:44'!
paste
	self handleEdit: [textMorph editor paste]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'ar 1/15/2001 18:36'!
pasteRecent
	"Paste an item chosen from RecentClippings."

	| clipping |
	(clipping := Clipboard chooseRecentClipping) ifNil: [^ self].
	Clipboard clipboardText: clipping.
	^ self handleEdit: [textMorph editor paste]! !

!SMxPluggableTextMorph methodsFor: 'notifications' stamp: 'jmv 9/18/2009 14:02'!
possiblyChanged
	"A hook for notificating possible interested parties
	Not used in base system"! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 11/7/1999 00:01'!
prettyPrint
	self handleEdit: [textMorph editor prettyPrint]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 7/13/2000 20:07'!
printIt
	| result oldEditor |

	textMorph editor selectFrom: selectionInterval first to: selectionInterval last;
						model: model.  "For, eg, evaluateSelection"
	textMorph handleEdit: [result := (oldEditor := textMorph editor) evaluateSelection].
	((result isKindOf: FakeClassPool) or: [result == #failedDoit]) ifTrue: [^self flash].
	selectionInterval := oldEditor selectionInterval.
	textMorph installEditorToReplace: oldEditor.
	textMorph handleEdit: [oldEditor afterSelectionInsertAndSelect: result printString].
	selectionInterval := oldEditor selectionInterval.
	
	textMorph editor selectFrom: selectionInterval first to: selectionInterval last.
	self scrollSelectionIntoView.

! !

!SMxPluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'JuanVuletich 10/29/2010 10:59'!
promptForCancel
	"Ask if it is OK to cancel changes to text"
	(self confirm:
'Changes have not been saved.
Is it OK to cancel those changes?' translated)
		ifTrue: [model clearUserEditFlag].
! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:59'!
referencesToIt
	self handleEdit: [textMorph editor referencesToIt]! !

!SMxPluggableTextMorph methodsFor: 'transcript' stamp: 'di 5/9/1998 21:40'!
replaceSelectionWith: aText
	^ textMorph editor replaceSelectionWith: aText! !

!SMxPluggableTextMorph methodsFor: 'geometry' stamp: 'jmv 3/2/2010 17:12'!
resetExtent
	"Reset the extent while maintaining the current selection.  Needed when resizing while the editor is active (when inside the pane)."
	| tempSelection |
	textMorph ifNotNil: [
		"the current selection gets munged by resetting the extent, so store it"
		tempSelection := self selectionInterval.
		
		"don't reset it if it's not active"
		tempSelection = (Interval from: 1 to: 0) 
						ifTrue: [retractableScrollBar
							ifTrue:[ ^ self]].
		self extent: self extent.
		self setSelection: tempSelection]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'dew 3/7/2000 21:15'!
saveContentsInFile
	self handleEdit: [textMorph editor saveContentsInFile]! !

!SMxPluggableTextMorph methodsFor: 'scroll bar events' stamp: 'rr 3/10/2004 09:30'!
scrollBarMenuButtonPressed: event
	"The menu button in the scrollbar was pressed; put up the menu"

	| menu |
	(menu := self getMenu: event shiftPressed) ifNotNil:
		["Set up to use perform:orSendTo: for model/view dispatch"
		menu setInvokingView: self.
		menu invokeModal]! !

!SMxPluggableTextMorph methodsFor: 'geometry' stamp: 'jmv 7/2/2009 12:44'!
scrollDeltaHeight
	"Return the increment in pixels which this pane should be scrolled."
	scroller hasSubmorphs ifFalse: [ ^1].
	^ scroller firstSubmorph defaultLineHeight
! !

!SMxPluggableTextMorph methodsFor: 'editor access' stamp: 'di 5/22/1998 12:35'!
scrollSelectionIntoView
	"Scroll my text into view if necessary and return true, else return false"
	^ self scrollSelectionIntoView: nil! !

!SMxPluggableTextMorph methodsFor: 'editor access' stamp: 'jmv 6/30/2010 23:44'!
scrollSelectionIntoView: event
	"Scroll my text into view if necessary and return true, else return false"
	| selRects delta selRect rectToTest cpHere |
	selectionInterval := textMorph editor selectionInterval.
	selRects := textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest := selRects first merge: selRects last.
	(event notNil and: [event anyButtonPressed]) ifTrue: [  "Check for autoscroll"
		cpHere := scroller externalizePosition: event cursorPoint to: self.
		cpHere y <= self top
			ifTrue: [rectToTest := selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest := selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect := textMorph bounds: rectToTest in: self.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta := selRect amountToTranslateWithin: self viewableBounds) y ~= 0 ifTrue: [
		"Scroll end of selection into view if necessary"
		self scrollBy: 0@delta y.
		^ true].
	^ false! !

!SMxPluggableTextMorph methodsFor: 'editor access' stamp: 'jmv 9/10/2010 09:10'!
selectAll
	"Tell my textMorph's editor to select all"

	textMorph selectAll! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 14:58'!
selectFrom: start to: stop
	^ textMorph editor selectFrom: start to: stop! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:18'!
selectInvisiblyFrom: start to: stop
	^ textMorph editor selectInvisiblyFrom: start to: stop! !

!SMxPluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 14:56'!
selectionInterval
	^ textMorph editor selectionInterval! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'di 6/22/1998 01:32'!
selectionInterval: sel
	selectionInterval := sel! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:31'!
sendersOfIt
	self handleEdit: [textMorph editor sendersOfIt]! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 7/13/2000 20:09'!
setSearchString
	self handleEdit: [textMorph editor setSearchString]! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'wod 5/26/1998 17:03'!
setSelection: sel
	selectionInterval := sel.
	textMorph editor selectFrom: sel first to: sel last.
	self scrollSelectionIntoView ifFalse: [scroller changed].! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'jmv 8/18/2009 22:51'!
setText: aText
	self okToStyle ifFalse: [ ^self basicSetText: aText ].
	self basicSetText: (styler format: aText asText).
	aText size < 4096
		ifTrue: [ styler style: textMorph contents ]
		ifFalse: [ styler styleInBackgroundProcess:  textMorph contents ]! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'sw 2/6/2001 01:24'!
setTextColor: aColor
	"Set the color of my text to the given color"

	textMorph color: aColor! !

!SMxPluggableTextMorph methodsFor: 'editor access' stamp: 'sw 7/24/2001 02:24'!
setTextMorphToSelectAllOnMouseEnter
	"Tell my textMorph's editor to select all when the mouse enters"

	textMorph on: #mouseEnter send: #selectAll to: textMorph! !

!SMxPluggableTextMorph methodsFor: 'shout' stamp: 'jmv 8/18/2009 22:47'!
styler: anObject
	
	styler := anObject! !

!SMxPluggableTextMorph methodsFor: 'shout' stamp: 'JuanVuletich 10/13/2010 09:48'!
stylerStyled: styledCopyOfText

	textMorph contents runs: styledCopyOfText runs.

	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."
	"caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	
	textMorph updateFromParagraph.
	selectionInterval 
		ifNotNil: [
			textMorph editor
				selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				storeSelectionInParagraph;
				setEmphasisHereFromText].
	textMorph editor blinkParen.
	self scrollSelectionIntoView! !

!SMxPluggableTextMorph methodsFor: 'shout' stamp: 'jmv 8/19/2009 15:38'!
stylerStyledInBackground: styledCopyOfText 
	"It is possible that the text string has changed since the styling began. Disregard the styles if styledCopyOfText's string differs with the current textMorph contents string"
	
	textMorph contents string = styledCopyOfText string
		ifTrue: [self stylerStyled: styledCopyOfText]! !

!SMxPluggableTextMorph methodsFor: 'model access' stamp: 'di 4/20/1998 07:59'!
text
	^ textMorph contents! !

!SMxPluggableTextMorph methodsFor: 'accessing' stamp: 'jmv 4/11/2010 22:21'!
textMorph
	^ textMorph! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'tk 7/13/2000 20:13'!
undo
	self handleEdit: [textMorph editor undo]! !

!SMxPluggableTextMorph methodsFor: 'updating' stamp: 'JuanVuletich 10/13/2010 11:06'!
update: aSymbol 
	aSymbol ifNil: [^self].
	aSymbol == #flash ifTrue: [^self flash].
	aSymbol == getTextSelector 
		ifTrue: 
			[self setText: self getText.
			^self setSelection: self getSelection].
	aSymbol == getSelectionSelector 
		ifTrue: [^self setSelection: self getSelection].
	(aSymbol == #autoSelect and: [getSelectionSelector notNil]) 
		ifTrue: 
			[self handleEdit: 
					[TextEditor abandonChangeText.	"no replacement!!"
					(textMorph editor)
						setSearch: model autoSelectString;
						againOrSame: true]].
	aSymbol == #clearUserEdits ifTrue: [^self hasUnacceptedEdits: false].
	aSymbol == #wantToChange 
		ifTrue: 
			[self canDiscardEdits ifFalse: [^self promptForCancel].
			^self].
	aSymbol == #appendEntry 
		ifTrue: 
			[self handleEdit: [self appendEntry].
			^self refreshWorld].
	aSymbol == #clearText 
		ifTrue: 
			[self handleEdit: [self changeText: Text new].
			^self refreshWorld].
	aSymbol == #bs 
		ifTrue: 
			[self handleEdit: [self bsText].
			^self refreshWorld].
	aSymbol == #codeChangedElsewhere 
		ifTrue: 
			[self hasEditingConflicts: true.
			^self changed]! !

!SMxPluggableTextMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 5/27/2006 17:49'!
wantsDroppedMorph: aMorph event: anEvent 
	^false! !

!SMxPluggableTextMorph methodsFor: 'drawing' stamp: 'JuanVuletich 11/1/2010 15:55'!
wantsFrameAdornments
	"Answer whether the receiver wishes to have red borders, etc., used to show editing state"

	"A 'long-term temporary workaround': a nonmodular, unsavory, but expedient way to get the desired effect, sorry.  Clean up someday."

	(model isKindOf: CodeHolder) ifFalse: [^false].
	^ (#(annotation searchString infoViewContents) includes: getTextSelector) not! !

!SMxPluggableTextMorph methodsFor: 'accessing' stamp: 'jmv 5/10/2009 09:42'!
wrapFlag: aBoolean
	textMorph wrapFlag: aBoolean! !

!SMxPluggableTextMorph methodsFor: 'menu commands' stamp: 'rr 3/10/2004 09:29'!
yellowButtonActivity
	"Called when the shifted-menu's 'more' item is chosen"

	| menu |
	(menu := self getMenu: false) ifNotNil:
		["Set up to use perform:orSendTo: for model/view dispatch"
		menu setInvokingView: self.
		menu invokeModal]! !

!SMxPluggableTextMorph methodsFor: 'scroll bar events' stamp: 'rr 3/10/2004 09:29'!
yellowButtonActivity: shiftKeyState
	"Invoke the text-editing menu"

	| menu |
	(menu := self getMenu: shiftKeyState) ifNotNil:
		[menu setInvokingView: self.
		menu invokeModal]! !

!SMxScrollPane class methodsFor: 'new-morph participation' stamp: 'di 2/21/98 11:02'!
includeInNewMorphMenu
	"OK to instantiate"
	^ true! !

!SMxScrollPane methodsFor: 'menu' stamp: 'jmv 4/6/2009 08:23'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	retractableScrollBar
		ifTrue: [aCustomMenu add: 'make scrollbar inboard' translated action: #retractableOrNot]
		ifFalse: [aCustomMenu add: 'make scrollbar retractable' translated action: #retractableOrNot].
	scrollBarOnLeft
		ifTrue: [aCustomMenu add: 'scroll bar on right' translated action: #leftOrRight]
		ifFalse: [aCustomMenu add: 'scroll bar on left' translated action: #leftOrRight]! !

!SMxScrollPane methodsFor: 'access' stamp: 'sps 12/28/2002 01:07'!
adoptPaneColor: paneColor
	super adoptPaneColor: paneColor.
	scrollBar adoptPaneColor: paneColor.
	hScrollBar adoptPaneColor: paneColor.
! !

!SMxScrollPane methodsFor: 'geometry testing' stamp: 'jmv 1/8/2010 15:28'!
containsPoint: aPoint

	(bounds containsPoint: aPoint) ifTrue: [^ true].
	
	"Also include v scrollbar when it is extended..."
	((retractableScrollBar and: [ self vIsScrollbarShowing ]) and:
		[scrollBar containsPoint: aPoint])
			ifTrue:[ ^true ].
		
	"Also include hScrollbar when it is extended..."
	^(retractableScrollBar and: [self hIsScrollbarShowing]) and:
		[hScrollBar containsPoint: aPoint]
! !

!SMxScrollPane methodsFor: 'initialization' stamp: 'jmv 4/5/2009 15:09'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!SMxScrollPane methodsFor: 'access' stamp: 'jmv 9/10/2010 09:55'!
drawKeyboardFocusIndicator: aBoolean

	drawKeyboardFocusIndicator := aBoolean! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 4/5/2009 15:42'!
extent: newExtent
	
	| oldW oldH wasHShowing wasVShowing minH minW |
	
	oldW := self width.
	oldH := self height.
	wasHShowing := self hIsScrollbarShowing.
	wasVShowing := self vIsScrollbarShowing.

	"Figure out the minimum width and height for this pane so that scrollbars will appear"
	hideScrollBars 
		ifTrue: [ 
			minH := 1.
			minW := 1 ]
		ifFalse: [
			minH := SMxPreferences scrollbarThickness + 16.
			minW := minH + 4].
	super extent: (newExtent max: (minW@minH)).

	"Now reset widget sizes"
	self resizeScroller; hideOrShowScrollBars.
	
	"Now resetScrollDeltas where appropriate, first the vScrollBar..."
	((self height ~= oldH) or: [ wasHShowing ~~ self hIsScrollbarShowing]) ifTrue:
		[(retractableScrollBar or: [ self vIsScrollbarShowing ]) ifTrue:
			[ self vSetScrollDelta ]].
			
	"...then the hScrollBar"
	((self width ~= oldW) or: [wasVShowing ~~ self vIsScrollbarShowing]) ifTrue:
		[(retractableScrollBar or: [ self hIsScrollbarShowing ]) ifTrue:
			[ self hSetScrollDelta ]].

! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 10:22'!
focusIndicatorRectangle

	| b topLeft bottomRight |
	b := self innerBounds.
	topLeft := b topLeft .
	bottomRight := b bottomRight.
	self vIsScrollbarShowing ifTrue: [
		scrollBarOnLeft
			ifTrue: [ topLeft := scrollBar right @ topLeft y]
			ifFalse: [ bottomRight := scrollBar left @ bottomRight y]].
	self hIsScrollbarShowing
		ifTrue: [ bottomRight := bottomRight x @ (bottomRight y - SMxPreferences scrollbarThickness)].
	^topLeft corner: bottomRight! !

!SMxScrollPane methodsFor: 'menu' stamp: 'jmv 3/1/2010 13:18'!
getMenu: shiftKeyState
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."
	| menu aMenu aTitle |
	getMenuSelector ifNil: [^ nil].
	menu := SMxMenuMorph new defaultTarget: model.
	aTitle := getMenuTitleSelector ifNotNil: [model perform: getMenuTitleSelector].
	getMenuSelector numArgs = 1 ifTrue: [
		aMenu := model perform: getMenuSelector with: menu.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	getMenuSelector numArgs = 2 ifTrue: [
		aMenu := model perform: getMenuSelector with: menu with: shiftKeyState.
		aTitle ifNotNil:  [aMenu addTitle: aTitle].
		^ aMenu].
	^ self error: 'The getMenuSelector has an unsupported number of arguments'! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/7/2009 12:31'!
hHideScrollBar
	self hIsScrollbarShowing ifFalse: [
		^scroller offset: 0@scroller offset y ].
	self removeMorph: hScrollBar.
	scroller offset: 0@scroller offset y.
	retractableScrollBar ifFalse: [ self resetExtent ]! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 10:19'!
hIsScrollbarNeeded: havingVerticalScrollbar
"Return whether the horz scrollbar is needed"

	"Don't do anything with the retractable scrollbar unless we have focus"
	| w |
	retractableScrollBar & hasFocus not ifTrue: [^false].
	
	"Don't show it if we were told not to."
	hideScrollBars ifTrue: [^false].

	scroller hasSubmorphs ifFalse: [^false].

	"If the contents of the pane are too small to scroll, return false."
	w := self innerBounds width - (2*self xtraBorder).
	"Compute the need of the horizontal scrollbar honoring the havingVerticalScrollbar argument"
	havingVerticalScrollbar ifTrue: [
		w := w - SMxPreferences scrollbarThickness ].
	^self hTotalScrollRange > w! !

!SMxScrollPane methodsFor: 'geometry testing' stamp: 'jmv 9/30/2009 12:59'!
hIsScrollbarShowing
	"Return true if a horizontal scroll bar is currently showing"

	^hScrollBar owner == self! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 08:40'!
hLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."

	scroller hasSubmorphs ifFalse: [^0].
	^ (self hTotalScrollRange - self viewableWidth) max: 0! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'jmv 4/4/2009 17:03'!
hScrollBarMenuButtonPressed: event
	^ self scrollBarMenuButtonPressed: event
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/7/2009 12:31'!
hScrollBarValue: scrollValue

	| x |
	self hIsScrollbarShowing ifFalse: [
		^scroller offset: 0@scroller offset y ].
	(x := self hLeftoverScrollRange * scrollValue) <= 0
		ifTrue: [ x := 0 ].
	scroller offset: x@scroller offset y! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 9/30/2009 13:01'!
hScrollBarWidth
	"Return the width of the horizontal scrollbar"

	| w |	
	w := bounds width - (2 * borderWidth).
	self vIsScrollbarShowing
		ifTrue: [ w := w - SMxPreferences scrollbarThickness ].
	^w! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 10:30'!
hSetScrollDelta
	"Set the SMxScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	| range delta w |

	scroller hasSubmorphs ifFalse:[scrollBar interval: 1.0. ^self].
	
	delta := self scrollDeltaWidth.
	range := self hLeftoverScrollRange.
	range = 0 ifTrue: [ hScrollBar scrollDelta: 0.02 pageDelta: 0.2; interval: 1.0; setValue: 0. ^self].

	"Set up for one line (for arrow scrolling), or a full pane less one line (for paging)."
	w := self viewableWidth.
	hScrollBar scrollDelta: (delta / range) asFloat pageDelta: (w - delta / range) asFloat.
	hScrollBar interval: (w / self hTotalScrollRange) asFloat.
	hScrollBar setValue: ((scroller offset x / range) min: 1.0) asFloat.
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 4/5/2009 15:08'!
hShowScrollBar

	self hIsScrollbarShowing ifTrue: [^self].
	self privateAddMorph: hScrollBar atIndex: 1.
	retractableScrollBar ifFalse: [
		self resetExtent ].
! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 09:47'!
hTotalScrollRange
	"Return the width extent of the receiver's submorphs."

	| submorphBounds |
	submorphBounds := scroller localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds right
! !

!SMxScrollPane methodsFor: 'pane events' stamp: 'di 5/7/1998 09:52'!
handlesMouseDown: evt
	^ true! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'ar 9/18/2000 22:11'!
handlesMouseOver: evt
	"Could just ^ true, but this ensures that scroll bars won't flop out
	if you mouse-over appendages such as connecting pins."
	self flag: #arNote. "I have no idea how the code below could've ever worked. If the receiver does not handle mouse over events then it should not receive any #mouseLeave if the mouse leaves the receiver for real. This is because 'evt cursorPoint' describes the *end* point of the movement and considering that the code would return false if the move ends outside the receiver the scroll bars should never pop back in again. Which is exactly what happens with the new event logic if you don't just ^true. I'm leaving the code in for reference - perhaps somebody can make sense from it; I sure cannot."
	^true
"
	| cp |
	cp := evt cursorPoint.
	(bounds containsPoint: cp)
		ifTrue: [^ true]			
		ifFalse: [self submorphsDo:
					[:m | (m containsPoint: cp) ifTrue:
							[m == scrollBar
								ifTrue: [^ true]
								ifFalse: [^ false]]].
				^ false]
"! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 9/30/2009 14:41'!
hideOrShowScrollBars

	| wasHShowing wasVShowing useVerticalScrollbar useHorizontalScrollbar |

	wasVShowing := self vIsScrollbarShowing.
	wasHShowing := self hIsScrollbarShowing.

	"Assume for a moment we don't need an horizontal scrollbar"
	useHorizontalScrollbar := false.
	useVerticalScrollbar := self vIsScrollbarNeeded: useHorizontalScrollbar.
	
	"Avoid all this if we know for sure we won't need an horizontal scrollbar"
	self mightNeedHorizontalScrollBar ifTrue: [
		
		"We are cheating here. May be useVerticalScrollbar is false, and we later need it."
		useHorizontalScrollbar := self hIsScrollbarNeeded: useVerticalScrollbar.
				
		"If horizontal scrollbar is needed, maybe vertical scrollbar will be needed too."
		(useVerticalScrollbar not and: [ useHorizontalScrollbar ]) ifTrue: [
			
			"In this case, there is no chance of modifying the need of horizontal scrollbar: it was already needed.
			Therefore, there is no circularity here."
			useVerticalScrollbar := self vIsScrollbarNeeded: useHorizontalScrollbar ]].

	wasVShowing = useVerticalScrollbar ifFalse: [
		useVerticalScrollbar
			ifTrue: [ self vShowScrollBar ]
			ifFalse: [ self vHideScrollBar ]].

	wasHShowing = useHorizontalScrollbar ifFalse: [
		useHorizontalScrollbar
			ifTrue: [ self hShowScrollBar ]
			ifFalse: [ self hHideScrollBar ]]! !

!SMxScrollPane methodsFor: 'access options' stamp: 'jmv 4/3/2009 17:48'!
hideScrollBarsIndefinitely

	hideScrollBars := true.
	self vHideScrollBar.
	self hHideScrollBar.! !

!SMxScrollPane methodsFor: 'initialization' stamp: 'jmv 9/10/2010 09:31'!
initialize
	
	"initialize the state of the receiver"
	super initialize.
	hideScrollBars := false.
	retractableScrollBar := SMxPreferences inboardScrollbars not.
	scrollBarOnLeft := SMxPreferences scrollBarsOnRight not.
	scrollBarOnLeft ifTrue: [
		retractableScrollBar := true ].
	hasFocus := false.
	self initializeScrollBars.
	self extent: 150 @ 120.
	drawKeyboardFocusIndicator := true.


! !

!SMxScrollPane methodsFor: 'initialization' stamp: 'jmv 9/30/2009 14:20'!
initializeScrollBars
	"initialize the receiver's scrollBars"

	(scrollBar := SMxScrollBar new model: self slotName: 'vScrollBar')
		borderWidth: 1;
		borderColor: Color black.
	(hScrollBar := SMxScrollBar new model: self slotName: 'hScrollBar')
		borderWidth: 1;
		borderColor: Color black.

	scroller := SMxTransformMorph new color: Color transparent.
	scroller offset: 0@ 0.
	self addMorph: scroller
! !

!SMxScrollPane methodsFor: 'change reporting' stamp: 'jmv 9/10/2010 09:55'!
invalidateBorderFeedback

	| r |
	drawKeyboardFocusIndicator ifTrue: [
		r := self focusIndicatorRectangle.
		(r areasOutside: (r insetBy: SMxPreferences focusIndicatorWidth))
			do: [ :rect | self invalidRect: rect ]]! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:59'!
keyStroke: evt
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	( self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].
	super keyStroke: evt.
	(self scrollByKeyboard: evt)
		ifTrue: [ ^self ].
	scroller submorphs last keyStroke: evt! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 7/6/2009 14:39'!
layoutChanged
	| t topLeft newScrollRange |
	super layoutChanged.
	
	hideScrollBars ifTrue: [^self].
	
	newScrollRange := self hTotalScrollRange @ self vTotalScrollRange.
	currentScrollRange = newScrollRange ifFalse: [
		SMxWorldState addDeferredUIMessage: [ self setScrollDeltas ].
		currentScrollRange := newScrollRange ].
	
	t := SMxPreferences scrollbarThickness.

	topLeft := scrollBarOnLeft ifTrue: [
		"scrollbarOnLeft => retractableScrollBar"
		bounds topLeft + (0-t @ borderWidth)]
	ifFalse: [
		retractableScrollBar 
			ifTrue: [bounds topRight + (0-borderWidth @ borderWidth)]
			ifFalse: [bounds topRight + (0-t-borderWidth @ borderWidth)]].
	scrollBar 
		bounds: (topLeft extent: t @ self vScrollBarHeight).

	topLeft := retractableScrollBar
				ifTrue: [bounds bottomLeft + (borderWidth @ borderWidth negated)]
				ifFalse: [bounds bottomLeft + (borderWidth @ (t + borderWidth) negated)].
	hScrollBar bounds: (topLeft extent: self hScrollBarWidth@ t)! !

!SMxScrollPane methodsFor: 'menu' stamp: 'jmv 4/6/2009 08:59'!
leftOrRight
	"Change scroll bar operation"

	scrollBarOnLeft := scrollBarOnLeft not.
	scrollBarOnLeft ifTrue: [
		retractableScrollBar := true.
		self removeMorph: scrollBar ].
	self layoutChanged
! !

!SMxScrollPane methodsFor: 'menu' stamp: 'sw 8/18/1998 12:38'!
menuTitleSelector: aSelector
	getMenuTitleSelector := aSelector! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 9/30/2009 12:43'!
mightNeedHorizontalScrollBar
	"If not sure, answer true. Only answer false when the horizontal scrollbar will not be needed, regardless of contents, for example, when showing wrapped text.
	This method is called for deciding if a vertical scroll bar is needed. Therefore if the need of an horizontal scrollbar might depend on the vertical scrollbar being there (and taking space) or not, just answer true."
	^true! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 6/30/2010 23:23'!
mouseDown: evt

	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue: [
		scroller submorphs last mouseDown:
			(evt internalizedTo: scroller from: self)].
	evt hand 
		waitForSimulatedYellow: self 
		event: evt
		dblClkSel: #doubleClick:! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 9/10/2010 22:53'!
mouseEnter: event
	super mouseEnter: event.
	hasFocus := true.
	(owner is: #SMxSystemWindow) ifTrue: [ owner paneTransition: event ].
	retractableScrollBar ifTrue: [ self hideOrShowScrollBars ].! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 9/10/2010 12:09'!
mouseLeave: event
	super mouseLeave: event.
	hasFocus := false.
	retractableScrollBar ifTrue: [
		self
			vHideScrollBar;
			hHideScrollBar].
	(owner is: #SMxSystemWindow) ifTrue: [ owner paneTransition: event ]
! !

!SMxScrollPane methodsFor: 'pane events' stamp: 'jmv 6/30/2010 22:25'!
mouseMove: evt
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue: [
		scroller submorphs last mouseMove: 
		(evt internalizedTo: scroller from: self)]! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 9/10/2010 12:09'!
mouseUp: evt
	super mouseUp: evt.
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue: [
		scroller submorphs last mouseUp: 
		(evt internalizedTo: scroller from: self)]! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'dew 10/17/1999 19:41'!
resetExtent
	"Reset the extent. (may be overridden by subclasses which need to do more than this)"
	self resizeScroller! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/7/2009 12:30'!
resizeScroller

	scroller bounds: self viewableBounds! !

!SMxScrollPane methodsFor: 'menu' stamp: 'jmv 4/6/2009 08:59'!
retractableOrNot
	"Change scroll bar operation"

	retractableScrollBar := retractableScrollBar not.
	retractableScrollBar ifFalse: [
		scrollBarOnLeft := false ].
	retractableScrollBar
		ifTrue: [ self removeMorph: scrollBar]
		ifFalse: [ self vIsScrollbarShowing
					ifFalse: 
						[self privateAddMorph: scrollBar atIndex: 1.
						self privateAddMorph: hScrollBar atIndex: 1]].
	self layoutChanged
! !

!SMxScrollPane methodsFor: 'access' stamp: 'LC 6/12/2000 09:28'!
retractableScrollBar
	^ retractableScrollBar! !

!SMxScrollPane methodsFor: 'geometry testing' stamp: 'jmv 4/3/2009 11:48'!
scrollBarFills: aRectangle
	"Return true if a flop-out scrollbar fills the rectangle"

	retractableScrollBar ifFalse:[^false].
	
	(self vIsScrollbarShowing and: [scrollBar bounds containsRect: aRectangle])
				ifTrue:[ ^true ].
	^(self hIsScrollbarShowing and: [hScrollBar bounds containsRect: aRectangle])
! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:31'!
scrollBarMenuButtonPressed: event
	^ self yellowButtonActivity: event shiftPressed! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/7/2009 12:14'!
scrollBy: delta
	"Move the contents in the direction delta."

	| newYoffset r newXoffset |
	
	"Set the offset on the scroller"
	newYoffset := scroller offset y - delta y max: 0.
	newXoffset := scroller offset x - delta x max: 0.
	
	scroller offset: newXoffset@ newYoffset.

	"Update the scrollBars"
	(r := self vLeftoverScrollRange) = 0
		ifTrue: [scrollBar value: 0.0]
		ifFalse: [scrollBar value: newYoffset asFloat / r].
	(r := self hLeftoverScrollRange) = 0
		ifTrue: [hScrollBar value: 0.0]
		ifFalse: [hScrollBar value: newXoffset asFloat / r]
! !

!SMxScrollPane methodsFor: 'event handling' stamp: 'jmv 9/17/2010 13:59'!
scrollByKeyboard: event
	"If event is ctrl+up/down then scroll and answer true"
	event controlKeyPressed ifFalse: [ ^ false ].
	event keyValue = 30 ifTrue: [
		scrollBar scrollUp: 3.
		^ true ].
	event keyValue = 31 ifTrue: [
		scrollBar scrollDown: 3.
		^ true ].
	^ false.! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'sps 3/10/2004 13:26'!
scrollDeltaHeight
	"Return the increment in pixels which this pane should be scrolled (normally a subclass responsibility)."
	^ 10
! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'sps 3/9/2004 17:29'!
scrollDeltaWidth
	"Return the increment in pixels which this pane should be scrolled (normally a subclass responsibility)."
	
	^10
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/7/2009 12:31'!
scrollToShow: aRectangle
	"scroll to include as much of aRectangle as possible, where aRectangle is in the scroller's local space"
	| range scrollValue |
	((aRectangle top - scroller offset y) >= 0 and: [
		(aRectangle bottom - scroller offset y) <= self viewableHeight ])
		ifTrue: [
			"already visible"
			^self ].

	range := self vLeftoverScrollRange.
	scrollValue := range > 0
		ifTrue: [
			(aRectangle top / range
				truncateTo: scrollBar scrollDelta) min: 1]
		ifFalse: [0].
	scrollBar value: scrollValue.
	scroller offset: 0 @ (range * scrollValue).! !

!SMxScrollPane methodsFor: 'access' stamp: ''!
scroller
	^ scroller! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'sps 3/10/2004 11:46'!
setScrollDeltas
	"Set the SMxScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."

	scroller hasSubmorphs ifFalse: 
		[scrollBar interval: 1.0. 
		hScrollBar interval: 1.0. 
		^ self].
	
"NOTE: fullbounds commented out now -- trying to find a case where this expensive step is necessary -- perhaps there is a less expensive way to handle that case."
	"scroller fullBounds." "force recompute so that leftoverScrollRange will be up-to-date"
	self hideOrShowScrollBars.
	
	(retractableScrollBar or: [ self vIsScrollbarShowing ]) ifTrue:[ self vSetScrollDelta ].
	(retractableScrollBar or: [ self hIsScrollbarShowing ]) ifTrue:[ self hSetScrollDelta ].
! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'sw 3/22/2001 12:03'!
shiftedTextPaneMenuRequest
	"The more... button was hit from the text-pane menu"

	^ self yellowButtonActivity: true! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:31'!
shiftedYellowButtonActivity
	^ self yellowButtonActivity: true! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:32'!
unshiftedYellowButtonActivity
	^ self yellowButtonActivity: false! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'JuanVuletich 10/18/2010 15:14'!
vHideScrollBar
	self vIsScrollbarShowing ifFalse: [^self].
	self removeMorph: scrollBar.
	scroller offset: scroller offset x@0.
	retractableScrollBar ifFalse: [self resetExtent].
	
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 10:19'!
vIsScrollbarNeeded: havingHorizontalScrollbar
"Return whether the vertical scrollbar is needed"

	"Don't do anything with the retractable scrollbar unless we have focus"
	| h |
	retractableScrollBar & hasFocus not ifTrue: [^false].
	
	"Don't show it if we were told not to."
	hideScrollBars ifTrue: [^false].
	
	scroller hasSubmorphs ifFalse: [^false].	

	"If the contents of the pane are too small to scroll, return false."
	h := self innerBounds height - (2*self xtraBorder).
	"Compute the need of the vertical scrollbar honoring the havingHorizontalScrollbar argument"
	havingHorizontalScrollbar ifTrue: [
		h := h - SMxPreferences scrollbarThickness ].
	^ self vTotalScrollRange > h! !

!SMxScrollPane methodsFor: 'geometry testing' stamp: 'jmv 9/30/2009 12:59'!
vIsScrollbarShowing
	"Return true if a retractable (or not) vertical scroll bar is currently showing"

	^scrollBar owner == self! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 08:41'!
vLeftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."

	scroller hasSubmorphs ifFalse: [^0].
	^ (self vTotalScrollRange - self viewableHeight) max: 0! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 4/3/2009 17:18'!
vScrollBarHeight
	^bounds height - (2 * borderWidth)! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'sps 12/27/2002 00:13'!
vScrollBarMenuButtonPressed: event
	^ self scrollBarMenuButtonPressed: event
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 10/7/2009 12:31'!
vScrollBarValue: scrollValue
	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: (scroller offset x @ (self vLeftoverScrollRange * scrollValue) rounded)
! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 10:30'!
vSetScrollDelta
	"Set the SMxScrollBar deltas, value and interval, based on the current scroll pane size, offset and range."
	| range delta h |

	scroller hasSubmorphs ifFalse:[scrollBar interval: 1.0. ^self].
	
	delta := self scrollDeltaHeight.
	range := self vLeftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar scrollDelta: 0.02 pageDelta: 0.2; interval: 1.0; setValue: 0].

	"Set up for one line (for arrow scrolling), or a full pane less one line (for paging)."
	h := self viewableHeight.
	scrollBar scrollDelta: (delta / range) asFloat pageDelta: (h - delta / range) asFloat.
	scrollBar interval: (h / self vTotalScrollRange) asFloat.
	scrollBar setValue: (scroller offset y / range min: 1.0) asFloat.
! !

!SMxScrollPane methodsFor: 'scrolling' stamp: 'jmv 4/5/2009 15:08'!
vShowScrollBar

	self vIsScrollbarShowing ifTrue: [^ self].
	self privateAddMorph: scrollBar atIndex: 1.
	retractableScrollBar ifFalse: [
		self resetExtent ]
! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 09:50'!
vTotalScrollRange
	"Return the height extent of the receiver's submorphs."
	| submorphBounds |
	submorphBounds := scroller localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds bottom
! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 10:25'!
viewableBounds

	^self focusIndicatorRectangle insetBy: self xtraBorder! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 9/30/2009 11:56'!
viewableHeight
	"Viewable height.
	Leave room for horizontal scrollbar if present"

	^self viewableBounds height! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 9/30/2009 11:56'!
viewableWidth
	"Viewable width.
	Leave room for vertical scrollbar if present"

	^self viewableBounds width! !

!SMxScrollPane methodsFor: 'geometry' stamp: 'jmv 10/1/2009 10:19'!
xtraBorder
	"Answer the width of an extra white border to look nicer"
	^3! !

!SMxScrollPane methodsFor: 'scroll bar events' stamp: 'jmv 5/8/2009 18:55'!
yellowButtonActivity: shiftKeyState
	| menu |
	(menu := self getMenu: shiftKeyState) ifNotNil: [
		menu setInvokingView: self.
		menu popUpInWorld: self world]! !

SMxScrollPane subclass: #SMxSimpleHierarchicalListMorph
	instanceVariableNames: 'selectedMorph getListSelector keystrokeActionSelector autoDeselect columns sortingSelector getSelectionSelector setSelectionSelector potentialDropMorph lineColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

SMxSimpleHierarchicalListMorph class
	instanceVariableNames: 'expandedForm notExpandedForm'!

!SMxSimpleHierarchicalListMorph commentStamp: 'ls 3/1/2004 12:15' prior: 0!
Display a hierarchical list of items.  Each item should be wrapped with a ListItemWrapper.

For a simple example, look at submorphsExample.  For beefier examples, look at ObjectExplorer or FileList2.!

SMxSimpleHierarchicalListMorph class
	instanceVariableNames: 'expandedForm notExpandedForm'!

!SMxSimpleHierarchicalListMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/26/2010 14:38'!
expandedForm

	expandedForm ifNotNil: [ expandedForm depth ~= Display depth ifTrue: [ expandedForm := nil ]].

	^expandedForm ifNil: [expandedForm := 
			(Form
				extent: 10@9
				depth: 8
				fromArray: #( 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4278255873 16843009 16842752 4294902089 1229539657 33488896 4294967041 1229539585 4294901760 4294967295 21561855 4294901760 4294967295 4278321151 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760)
				offset: 0@0)
					asFormOfDepth: Display depth;
					replaceColor: Color white withColor: Color transparent;
					yourself
	]! !

!SMxSimpleHierarchicalListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 11:05'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		model: anObject 
		listGetter: getListSel 
		indexGetter: getSelectionSel 
		indexSetter: setSelectionSel 
		menuGetter: nil
		keystrokeAction: #arrowKey:from:		"default"! !

!SMxSimpleHierarchicalListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/22/2009 15:01'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		model: anObject
		listGetter: getListSel 
		indexGetter: getSelectionSel 
		indexSetter: setSelectionSel 
		menuGetter: getMenuSel
		keystrokeAction: #arrowKey:from:		"default"! !

!SMxSimpleHierarchicalListMorph class methodsFor: 'instance creation' stamp: 'jmv 9/16/2009 10:41'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors."

	^ self new
		model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel! !

!SMxSimpleHierarchicalListMorph class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/26/2010 14:35'!
notExpandedForm

	notExpandedForm ifNotNil: [ notExpandedForm depth ~= Display depth ifTrue: [ notExpandedForm := nil ]].

	^notExpandedForm ifNil: [notExpandedForm := 
			(Form
				extent: 10@9
				depth: 8
				fromArray: #( 4294967041 4294967295 4294901760 4294967041 33554431 4294901760 4294967041 1224867839 4294901760 4294967041 1229521407 4294901760 4294967041 1229539585 4294901760 4294967041 1229521407 4294901760 4294967041 1224867839 4294901760 4294967041 33554431 4294901760 4294967041 4294967295 4294901760)
				offset: 0@0)
					asFormOfDepth: Display depth;
					replaceColor: Color white withColor: Color transparent;
					yourself
	].
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'JuanVuletich 10/26/2010 14:36'!
acceptDroppingMorph: aMorph event: evt

	self model
		acceptDroppingMorph: aMorph
		event: evt
		inMorph: self.
	self resetPotentialDropMorph.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'private' stamp: 'jmv 8/23/2010 10:11'!
addMorphsTo: morphList from: aCollection allowSorting: sortBoolean withExpandedItems: expandedItems atLevel: newIndent

	| priorMorph newCollection firstAddition |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		aCollection asOrderedCollection sort: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]
	] ifFalse: [
		aCollection
	].
	firstAddition := nil.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass basicNew 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: newIndent.
		firstAddition ifNil: [firstAddition := priorMorph].
		morphList add: priorMorph.
		((item hasEquivalentIn: expandedItems) or: [priorMorph isExpanded]) ifTrue: [
			priorMorph isExpanded: true.
			priorMorph 
				addChildrenForList: self 
				addingTo: morphList
				withExpandedItems: expandedItems.
		].
	].
	^firstAddition
	
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'private' stamp: 'JuanVuletich 10/26/2010 14:37'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean

	| priorMorph morphList newCollection |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		aCollection asOrderedCollection sort: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]
	] ifFalse: [
		aCollection
	].
	morphList := OrderedCollection new.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass basicNew 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: parentMorph indentLevel + 1.
		morphList add: priorMorph.
	].
	scroller addAllMorphs: morphList after: parentMorph.
	^morphList
	
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'private' stamp: 'RAA 6/21/1999 11:25'!
adjustSubmorphPositions

	| p h |

	p := 0@0.
	scroller submorphsDo: [ :each |
		h := each height.
		each privateBounds: (p extent: 9999@h).
		p := p + (0@h)
	].
	self 
		changed;
		layoutChanged;
		setScrollDeltas.
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'keyboard navigation' stamp: 'jmv 12/8/2008 15:42'!
arrowKey: aChar
	"Handle a keyboard navigation character. Answer true if handled, false if not."
	| keyEvent |
	keyEvent := aChar asciiValue.
     keyEvent = 31 ifTrue:["down"
		self setSelectionIndex: self getSelectionIndex+1.
		^true].
     keyEvent = 30 ifTrue:["up"
		self setSelectionIndex: (self getSelectionIndex-1 max: 1).
		^true].
     keyEvent = 1  ifTrue: ["home"
		self setSelectionIndex: 1.
		^true].
     keyEvent = 4  ifTrue: ["end"
		self setSelectionIndex: scroller submorphs size.
		^true].
      keyEvent = 11 ifTrue: ["page up"
		self setSelectionIndex: (self getSelectionIndex - self numSelectionsInView max: 1).
		^true].
     keyEvent = 12  ifTrue: ["page down"
		self setSelectionIndex: self getSelectionIndex + self numSelectionsInView.
		^true].
	keyEvent = 29 ifTrue:["right"
		selectedMorph ifNotNil:[
			(selectedMorph canExpand and:[selectedMorph isExpanded not])
				ifTrue:[self toggleExpandedState: selectedMorph]
				ifFalse:[self setSelectionIndex: self getSelectionIndex+1].
		].
		^true].
	keyEvent = 28 ifTrue:["left"
		selectedMorph ifNotNil:[
			(selectedMorph isExpanded)
				ifTrue:[self toggleExpandedState: selectedMorph]
				ifFalse:[self setSelectionIndex: (self getSelectionIndex-1 max: 1)].
		].
		^true].
	^false! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'di 4/10/98 16:20'!
autoDeselect: trueOrFalse
	"Enable/disable autoDeselect (see class comment)"
	autoDeselect := trueOrFalse.! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'RAA 7/24/1998 22:52'!
columns

	^columns! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'RAA 7/18/1998 23:18'!
columns: anArray

	columns := anArray! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'RAA 3/30/1999 22:29'!
currentlyExpanded

	^(scroller submorphs select: [ :each | each isExpanded]) collect: [ :each |
		each complexContents
	].
	! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 10:42'!
drawLinesOn: aCanvas 
	| lColor clippedCanvas |
	lColor := self lineColor.
	clippedCanvas := aCanvas
		copyOffset: scroller txOffset negated truncated
		clipRect: scroller innerBounds.
	scroller submorphs do:
		[ : submorph | 
		(submorph isExpanded or:
			[ (clippedCanvas isVisible: submorph fullBounds) or:		"needs #fullBounds 'in Owner'"
				"strange!! #isVisible expects a rectangle, and #nextSibling answers a SMxMorph... Looks like it never gets here!! (jmv)"
				[ submorph nextSibling notNil and: [ clippedCanvas isVisible: submorph nextSibling ] ] ]) ifTrue:
			[ submorph
				drawLinesOn: clippedCanvas
				lineColor: lColor ] ]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'jmv 9/10/2010 09:55'!
drawOn: aCanvas

	super drawOn: aCanvas.

	(drawKeyboardFocusIndicator and: [ self hasKeyboardFocus ]) ifTrue: [
		aCanvas
			frameRectangle: self focusIndicatorRectangle 
			width: SMxPreferences focusIndicatorWidth
			color: SMxPreferences focusIndicatorColor ].

	selectedMorph  ifNotNil:
		[aCanvas fillRectangle:
			((selectedMorph bounds: selectedMorph bounds in: self)
						intersect: scroller bounds)
				color: color blacker].

	SMxPreferences showLinesInHierarchyViews ifTrue:[
		self drawLinesOn: aCanvas.
	].


! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events' stamp: 'JuanVuletich 10/26/2010 14:37'!
expand: aMorph to: level
	| allChildren |
	aMorph toggleExpandedState.
	allChildren := OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		((each canExpand
			and: [each isExpanded not])
			and: [level > 0])
			ifTrue: [self expand: each to: level-1]].! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events' stamp: ''!
expandAll
	(selectedMorph isNil
		or: [selectedMorph isExpanded])
		ifTrue: [^self].
	self expandAll: selectedMorph.
	self adjustSubmorphPositions! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events' stamp: 'JuanVuletich 10/26/2010 14:37'!
expandAll: aMorph
	| allChildren |
	aMorph toggleExpandedState.
	allChildren := OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded not])
			ifTrue: [self expandAll: each]].
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events' stamp: 'dgd 9/26/2004 18:24'!
expandRoots
	"Expand all the receiver's roots"
	self roots
		do: [:each |
			(each canExpand and: [each isExpanded not])
				ifTrue: [each toggleExpandedState]].
	self adjustSubmorphPositions! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 10:05'!
expandedForm

	^self class expandedForm! !

!SMxSimpleHierarchicalListMorph methodsFor: 'geometry' stamp: ''!
extent: newExtent
	super extent: newExtent.
	self setScrollDeltas ! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 8/1/1998 00:19'!
getCurrentSelectionItem

	^model perform: (getSelectionSelector ifNil: [^nil])
	! !

!SMxSimpleHierarchicalListMorph methodsFor: 'model access' stamp: 'RAA 8/1/1998 00:10'!
getList 
	"Answer the list to be displayed."

	^(model perform: (getListSelector ifNil: [^#()])) ifNil: [#()]

! !

!SMxSimpleHierarchicalListMorph methodsFor: 'keyboard navigation' stamp: 'ar 10/14/2003 23:38'!
getSelectionIndex
	^scroller submorphs indexOf: selectedMorph! !

!SMxSimpleHierarchicalListMorph methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 09:47'!
hTotalScrollRange
"Return the width of the widest item in the list"

	| max right stringW count |

	max := 0.
	count := 0.
	scroller submorphsDo: [ :each |
		stringW := each font widthOfStringOrText: each contents.
		right := (each toggleRectangle right + stringW + 10).
		max := max max: right.
		
"NOTE: need to optimize this method by caching list item morph widths (can init that cache most efficiently in the #list: method before the item widths are reset to 9999).  For now, just punt on really long lists"
		((count := count + 1) > 200) ifTrue:[ ^max * 3].
	].

	^max 
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events-processing' stamp: 'JuanVuletich 10/26/2010 14:38'!
handleMouseMove: anEvent
	"Reimplemented because we really want #mouseMove when a morph is dragged around"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 11/18/2008 13:53'!
handlesKeyboard

	^self visible! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'ar 3/17/2001 17:27'!
handlesMouseOverDragging: evt
	^self dropEnabled! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'RAA 8/3/1999 09:44'!
highlightSelection

	selectedMorph ifNotNil: [selectedMorph highlight]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/26/2010 14:42'!
indentingItemClass
	
	^SMxIndentingListItemMorph! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'ar 10/25/2000 17:50'!
initialize
	super initialize.
	self on: #mouseMove send: #mouseStillDown:onItem: to: self! !

!SMxSimpleHierarchicalListMorph methodsFor: 'private' stamp: 'RAA 4/2/1999 15:33'!
insertNewMorphs: morphList

	scroller addAllMorphs: morphList.
	self adjustSubmorphPositions.
	self selection: self getCurrentSelectionItem.
	self setScrollDeltas.
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 3/8/2010 14:27'!
itemFromPoint: aPoint
	"Return the list element (morph) at the given point or nil if outside"
	| ptY |
	scroller hasSubmorphs ifFalse:[^nil].
	(scroller fullBounds containsPoint: aPoint) ifFalse:[^nil].
	ptY := (scroller firstSubmorph internalizePositionToOwner: aPoint from: self) y.
	"note: following assumes that submorphs are vertical, non-overlapping, and ordered"
	scroller firstSubmorph top > ptY ifTrue:[^nil].
	scroller lastSubmorph bottom < ptY ifTrue:[^nil].
	"now use binary search"
	^scroller 
		findSubmorphBinary:[:item|
			(item top <= ptY and:[item bottom >= ptY])
				ifTrue:[0] "found"
				ifFalse:[ (item top + item bottom // 2) > ptY ifTrue:[-1] ifFalse:[1]]]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:59'!
keyStroke: event 
	"Process potential command keys"

	| args aCharacter |
	(self focusKeyboardFor: event)
		ifTrue: [ ^ self ].
	(self scrollByKeyboard: event)
		ifTrue: [ ^self ].
	aCharacter := event keyCharacter.
	keystrokeActionSelector ifNil: [^self arrowKey: aCharacter].
	(args := keystrokeActionSelector numArgs) = 1 
		ifTrue: [^model perform: keystrokeActionSelector with: aCharacter].
	args = 2 
		ifTrue: [
			^model 
				perform: keystrokeActionSelector
				with: aCharacter
				with: self].
	^self 
		error: 'The keystrokeActionSelector must be a 1- or 2-keyword symbol'! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 4/9/2009 14:59'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"

	self invalidateBorderFeedback! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/26/2010 14:38'!
lineColor
	"Answer a good color to use for drawing the lines that connect members of the hierarchy view.
	Used the cached color, or derive it if necessary by finding the first owner (up to my root) that is not transparent, then picking a contrasting color.
	Fall back to veryLightGray if all my owners are transparent."

	| coloredOwner targetLuminance ownerColor darken |
	lineColor ifNotNil: [ ^lineColor ].
	coloredOwner := self firstOwnerSuchThat: [ :o |
		(o isWorldMorph not and: [ (o is: #SMxHandMorph) not ]) and: [ o color isTransparent not ]].
	coloredOwner ifNil: [ ^Color veryLightGray ].
	ownerColor := coloredOwner color.
	darken := ownerColor luminance > 0.5.
	targetLuminance := ownerColor luminance + (darken ifTrue: [ -0.2 ] ifFalse: [ 0.2 ]).
	^darken
		ifTrue: [ ownerColor atMostAsLuminentAs: targetLuminance ]
		ifFalse: [ ownerColor atLeastAsLuminentAs: targetLuminance ]
	
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'sps 12/28/2002 02:27'!
lineColor: aColor
	^lineColor := aColor
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'JuanVuletich 10/26/2010 14:37'!
list: aCollection

	| wereExpanded morphList |
	wereExpanded := self currentlyExpanded.
	scroller removeAllMorphs.
	(aCollection isNil or: [aCollection isEmpty]) ifTrue: [^ self selectedMorph: nil].
	morphList := OrderedCollection new.
	self 
		addMorphsTo: morphList
		from: aCollection 
		allowSorting: false
		withExpandedItems: wereExpanded
		atLevel: 0.
	self insertNewMorphs: morphList.! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'di 5/22/1998 00:32'!
listItemHeight
	"This should be cleaned up.  The list should get spaced by this parameter."
	^ 12! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 7/31/1998 00:25'!
maximumSelection

	^ scroller submorphs size
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'di 5/22/1998 00:20'!
minimumSelection
	^ 1! !

!SMxSimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'jmv 9/16/2009 10:40'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel

	self model: anObject.
	getListSelector := getListSel.
	getSelectionSelector := getSelectionSel.
	setSelectionSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	autoDeselect := true.
	self borderWidth: 1.
	self list: self getList.! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 3/8/2010 14:27'!
mouseDown: evt

	| aMorph |
	evt hand newKeyboardFocus: self.
	aMorph := self itemFromPoint: evt position.
	(aMorph notNil and:[aMorph inToggleArea: (aMorph internalizePositionToOwner: evt position from: self)])
		ifTrue:[^self toggleExpandedState: aMorph event: evt]. 
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	aMorph ifNil:[^super mouseDown: evt].
	aMorph highlightForMouseDown.
	evt hand 
		waitForClicksOrDragOrSimulatedYellow: self 
		event: evt 
		clkSel: #click:
		dblClkSel: nil
		dblClkTimeoutSel: nil
		dragSel:  (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil])! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 4/12/2009 22:14'!
mouseEnter: event
	super mouseEnter: event.
	SMxPreferences focusFollowsMouse
		ifTrue: [ event hand newKeyboardFocus: self ]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'ar 3/17/2001 17:26'!
mouseEnterDragging: evt
	| aMorph |
	(evt hand hasSubmorphs and:[self dropEnabled]) ifFalse: ["no d&d"
		^super mouseEnterDragging: evt].
	(self wantsDroppedMorph: evt hand firstSubmorph event: evt )
		ifTrue:[
			aMorph := self itemFromPoint: evt position.
			aMorph ifNotNil:[self potentialDropMorph: aMorph].
			evt hand newMouseFocus: self.
			"above is ugly but necessary for now"
		].! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'ar 3/17/2001 17:27'!
mouseLeaveDragging: anEvent
	(self dropEnabled and:[anEvent hand hasSubmorphs]) ifFalse: ["no d&d"
		^ super mouseLeaveDragging: anEvent].
	self resetPotentialDropMorph.
	anEvent hand releaseMouseFocus: self.
	"above is ugly but necessary for now"
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 3/8/2010 14:27'!
mouseMove: evt

	(self dropEnabled and:[evt hand hasSubmorphs]) 
		ifFalse:[^super mouseMove: evt].
	potentialDropMorph ifNotNil:[
		(potentialDropMorph containsPoint: (potentialDropMorph internalizePositionToOwner: evt position from: self))
			ifTrue:[^self].
	].
	self mouseLeaveDragging: evt.
	(self containsPoint: evt position) 
		ifTrue:[self mouseEnterDragging: evt].! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'JuanVuletich 10/26/2010 14:36'!
mouseUp: event 
	| aMorph |
	aMorph := self itemFromPoint: event position.
	aMorph ifNil: [^self].
	aMorph highlightedForMouseDown ifFalse: [^self].
	aMorph highlightForMouseDown: false.
	model okToChange ifFalse: [^self].
	"No change if model is locked"
	((autoDeselect isNil or: [autoDeselect]) and: [aMorph == selectedMorph]) 
		ifTrue: [self setSelectedMorph: nil]
		ifFalse: [self setSelectedMorph: aMorph].
	Cursor normal show! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 10:06'!
notExpandedForm

	^self class notExpandedForm! !

!SMxSimpleHierarchicalListMorph methodsFor: 'private' stamp: 'RAA 8/2/1999 12:42'!
noteRemovalOfAll: aCollection

	scroller removeAllMorphsIn: aCollection.
	(aCollection includes: selectedMorph) ifTrue: [self setSelectedMorph: nil].! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'jmv 4/5/2009 23:23'!
numSelectionsInView
	^ self viewableHeight // self listItemHeight! !

!SMxSimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'mir 5/8/2000 15:37'!
potentialDropMorph: aMorph
	potentialDropMorph := aMorph.
	aMorph highlightForDrop! !

!SMxSimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'mir 5/8/2000 15:38'!
resetPotentialDropMorph
	potentialDropMorph ifNotNil: [
		potentialDropMorph resetHighlightForDrop.
		potentialDropMorph := nil]
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'dgd 9/26/2004 18:23'!
roots
	"Answer the receiver's roots"
	^ scroller submorphs
		select: [:each | each indentLevel isZero]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'geometry' stamp: 'jmv 7/2/2009 12:56'!
scrollDeltaHeight
	scroller hasSubmorphs ifFalse: [ ^1].
	^ scroller firstSubmorph height! !

!SMxSimpleHierarchicalListMorph methodsFor: 'geometry' stamp: 'sps 3/9/2004 17:31'!
scrollDeltaWidth
"A guess -- assume that the width of a char is approx 1/2 the height of the font"
	^ self scrollDeltaHeight // 2


! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 8/1/1998 00:13'!
selectedMorph: aMorph

	self unhighlightSelection.
	selectedMorph := aMorph.
	self highlightSelection! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 8/31/1999 08:36'!
selection: item
	"Called from outside to request setting a new selection.
	Assumes scroller submorphs is exactly our list.
	Note: MAY NOT work right if list includes repeated items"

	| i |
	item ifNil: [^self selectionIndex: 0].
	i := scroller submorphs findFirst: [:m | m complexContents == item].
	i > 0 ifTrue: [^self selectionIndex: i].
	i := scroller submorphs findFirst: [:m | m withoutListWrapper = item withoutListWrapper].
	self selectionIndex: i! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'jmv 4/5/2009 23:23'!
selectionIndex: idx
	"Called internally to select the index-th item."
	| theMorph range index |
	idx ifNil: [^ self].
	index := idx min: scroller submorphs size max: 0.
	(theMorph := index = 0 ifTrue: [nil] ifFalse: [scroller submorphs at: index])
		ifNotNil:
		[((theMorph bounds top - scroller offset y) >= 0
			and: [(theMorph bounds bottom - scroller offset y) <= self viewableHeight]) ifFalse:
			["Scroll into view -- should be elsewhere"
			range := self vTotalScrollRange.
			scrollBar value: (range > 0
				ifTrue: [((index-1 * theMorph height) / self vTotalScrollRange)
									truncateTo: scrollBar scrollDelta]
				ifFalse: [0]).
			scroller offset: -3 @ (range * scrollBar value)]].
	self selectedMorph: theMorph! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 3/31/1999 12:15'!
selectionOneOf: aListOfItems
	"Set the selection to the first item in the list which is represented by one of my submorphs"

	| index |
	aListOfItems do: [ :item |
		index := scroller submorphs findFirst: [:m | 
			m withoutListWrapper = item withoutListWrapper
		].
		index > 0 ifTrue: [^self selectionIndex: index].
	].
	self selectionIndex: 0.! !

!SMxSimpleHierarchicalListMorph methodsFor: 'selection' stamp: 'RAA 3/31/1999 21:28'!
setSelectedMorph: aMorph

	model 
		perform: (setSelectionSelector ifNil: [^self]) 
		with: aMorph complexContents	"leave last wrapper in place"

 ! !

!SMxSimpleHierarchicalListMorph methodsFor: 'keyboard navigation' stamp: 'ar 10/14/2003 23:39'!
setSelectionIndex: idx
	"Called internally to select the index-th item."
	| theMorph index |
	idx ifNil: [^ self].
	index := idx min: scroller submorphs size max: 0.
	theMorph := index = 0 ifTrue: [nil] ifFalse: [scroller submorphs at: index].
	self setSelectedMorph: theMorph.! !

!SMxSimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'RAA 7/20/1998 12:09'!
sortingSelector: s

	sortingSelector := s! !

!SMxSimpleHierarchicalListMorph methodsFor: 'event handling' stamp: 'jmv 4/1/2009 21:48'!
startDrag: evt 
"
	| ddm itemMorph passenger |
	self dragEnabled 
		ifTrue: 
			[itemMorph := scroller submorphs 
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil or: [evt hand hasSubmorphs]) ifTrue: [^self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model dragPassengerFor: itemMorph inMorph: self.
	passenger ifNotNil: 
			[ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: (self model dragTransferTypeForMorph: self).
			SMxPreferences dragNDropWithAnimation 
				ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self
	"! !

!SMxSimpleHierarchicalListMorph methodsFor: 'keyboard navigation' stamp: 'ar 10/14/2003 23:39'!
toggleExpandedState: aMorph
	aMorph toggleExpandedState.
	self adjustSubmorphPositions.
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'events' stamp: 'ar 3/17/2001 17:39'!
toggleExpandedState: aMorph event: event
	| oldState |
	"self setSelectedMorph: aMorph."
	event yellowButtonPressed ifTrue: [
		oldState := aMorph isExpanded.
		scroller submorphs copy do: [ :each |
			(each canExpand and: [each isExpanded = oldState]) ifTrue: [
				each toggleExpandedState.
			].
		].
	] ifFalse: [
		aMorph toggleExpandedState.
	].
	self adjustSubmorphPositions.
	! !

!SMxSimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'RAA 8/3/1999 09:44'!
unhighlightSelection
	selectedMorph ifNotNil: [selectedMorph unhighlight]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'updating' stamp: 'JuanVuletich 10/26/2010 14:37'!
update: aSymbol 
	aSymbol == getSelectionSelector 
		ifTrue: 
			[self selection: self getCurrentSelectionItem.
			^self].
	aSymbol == getListSelector 
		ifTrue: 
			[self list: self getList.
			^self].
	((aSymbol isKindOf: Array) 
		and: [aSymbol notEmpty and: [aSymbol first == #openPath]]) 
			ifTrue: 
				[^(scroller submorphs at: 1 ifAbsent: [^self]) 
					openPath: aSymbol allButFirst]! !

!SMxSimpleHierarchicalListMorph methodsFor: 'scrolling' stamp: 'jmv 10/1/2009 09:50'!
vTotalScrollRange
"Return the width of the widest item in the list"

	(scroller submorphs size > 0) ifFalse:[ ^0 ].
	^scroller submorphs last fullBounds bottom
! !

!SMxSimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 5/27/2006 17:49'!
wantsDroppedMorph: aMorph event: anEvent 
	^false! !

SMxPluggableMorph subclass: #SMxSystemWindow
	instanceVariableNames: 'labelString paneMorphs collapsedFrame fullFrame isCollapsed updatablePanes paneColor'
	classVariableNames: 'CloseIcon CollapseIcon ExpandIcon MenuIcon TopWindow'
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxSystemWindow commentStamp: '<historical>' prior: 0!
SMxSystemWindow is the Morphic equivalent of StandardSystemView -- a labelled container for rectangular views, with iconic facilities for close, collapse/expand, and resizing.

The attribute onlyActiveOnTop, if set to true (and any call to activate will set this), determines that only the top member of a collection of such windows on the screen shall be active.  To be not active means that a mouse click in any region will only result in bringing the window to the top and then making it active.!

SMxSystemWindow subclass: #SMxBrowserWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxBrowserWindow commentStamp: 'JuanVuletich 10/14/2010 08:59' prior: 0!
A BrowserWindow is a SystemWindow that knows how to build and manage a browser.!

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/21/2010 11:53'!
addClassAndSwitchesTo: window at: nominalFractions plus: verticalOffset forBrowser: browser

	| column |
	column := self morphicClassColumnForBrowser: browser.	

	window addMorph: column
		fullFrame: (SMxLayoutFrame fractions: nominalFractions
				offsets: (0 @ verticalOffset corner: 0 @ 0)).
	column 
		on: #mouseEnter
		send: #paneTransition:
		to: window.
	column 
		on: #mouseLeave
		send: #paneTransition:
		to: window! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:01'!
addLowerPanesTo: window at: nominalFractions with: editString for: model

	(model isKindOf: FileContentsBrowser)
		ifTrue: [ ^self addLowerPanesTo: window at: nominalFractions with: editString forFileContentsBrowser: model ].

	(model isKindOf: Browser)
		ifTrue: [ ^self addLowerPanesTo: window at: nominalFractions with: editString forBrowser: model ].

	^self addLowerPanesTo: window at: nominalFractions with: editString forCodeHolder: model! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/29/2010 10:54'!
addLowerPanesTo: window at: nominalFractions with: editString forBrowser: browser
	| commentPane column |
	column := self addLowerPanesTo: window at: nominalFractions with: editString forCodeHolder: browser.
	commentPane := self buildMorphicCommentPaneForBrowser: browser.
	window addMorph: commentPane fullFrame: (SMxLayoutFrame fractions: (0@0.75 corner: 1@1)).
	commentPane lowerPane: column.
	browser changed: #editSelection! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:01'!
addLowerPanesTo: window at: nominalFractions with: editString forCodeHolder: codeHolder

	| verticalOffset column innerFractions |
	column := SMxAlignmentMorph proportional.
	verticalOffset := 0.
	innerFractions := 0@0 corner: 1@0.
	verticalOffset := self addOptionalAnnotationsTo: column at: innerFractions plus: verticalOffset forCodeHolder: codeHolder.
	verticalOffset := (codeHolder isKindOf: Debugger)
		ifTrue: [ self addOptionalButtonsTo: column  at: innerFractions plus: verticalOffset forDebugger: codeHolder ]
		ifFalse: [ self addOptionalButtonsTo: column  at: innerFractions plus: verticalOffset forCodeHolder: codeHolder ].

	column 
		addMorph: ((
			(codeHolder isKindOf: ChangeList)
				ifTrue: [self buildMorphicCodePaneWith: editString forChangeList: codeHolder]
				ifFalse: [self buildMorphicCodePaneWith: editString forCodeHolder: codeHolder]) borderWidth: 0)
		fullFrame: (
			SMxLayoutFrame 
				fractions: (innerFractions withBottom: 1) 
				offsets: (0@verticalOffset corner: 0@0)
		).
	window 
		addMorph: column
		frame: nominalFractions.

	column on: #mouseEnter send: #paneTransition: to: window.
	column on: #mouseLeave send: #paneTransition: to: window.
	^column! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/15/2010 21:44'!
addLowerPanesTo: window at: nominalFractions with: editString forFileContentsBrowser: fileContentsBrowser

	| verticalOffset column codePane infoPane infoHeight divider |


	column := SMxAlignmentMorph proportional.

	codePane := SMxPluggableTextMorph 
		model: fileContentsBrowser 
		editorClass: fileContentsBrowser smxEditorClass
		textGetter: #contents 
		textSetter: #contents:notifying:
		selectionGetter: #contentsSelection 
		menuGetter: #smxPaneMenu:shifted:editorClass:.
	infoPane := SMxPluggableTextMorph 
		model: fileContentsBrowser 
		editorClass: fileContentsBrowser smxEditorClass
		textGetter: #infoViewContents 
		textSetter: nil
		selectionGetter: nil 
		menuGetter: nil.
	infoPane askBeforeDiscardingEdits: false.
	verticalOffset := 0.

	infoHeight := 20.
	column 
		addMorph: (codePane borderWidth: 0)
		fullFrame: (
			SMxLayoutFrame 
				fractions: (0@0 corner: 1@1) 
				offsets: (0@verticalOffset corner: 0@infoHeight negated)
		).
	divider := SMxBorderedSubpaneDividerMorph forTopEdge.
	divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	column 
		addMorph: divider
		fullFrame: (
			SMxLayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@infoHeight negated corner: 0@(1-infoHeight))
		).
	column 
		addMorph: (infoPane borderWidth: 0; hideScrollBarsIndefinitely)
		fullFrame: (
			SMxLayoutFrame 
				fractions: (0@1 corner: 1@1) 
				offsets: (0@(1-infoHeight) corner: 0@0)
		).
	window 
		addMorph: column
		frame: nominalFractions.

	column on: #mouseEnter send: #paneTransition: to: window.
	column on: #mouseLeave send: #paneTransition: to: window! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:01'!
addOptionalAnnotationsTo: window at: fractions plus: verticalOffset forCodeHolder: codeHolder
	"Add an annotation pane to the window if preferences indicate a desire for it, and return the incoming verticalOffset plus the height of the added pane, if any"

	| aTextMorph divider delta |
	"self wantsAnnotationPane ifFalse: [^ verticalOffset]."
	aTextMorph := SMxPluggableTextMorph 
		model: codeHolder
		editorClass: codeHolder smxEditorClass
		textGetter: #annotation 
		textSetter: nil.
	aTextMorph
		askBeforeDiscardingEdits: false;
		borderWidth: 0;
		hideScrollBarsIndefinitely.
	divider := SMxBorderedSubpaneDividerMorph forBottomEdge.
	divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	delta := self defaultAnnotationPaneHeight.
	window 
		addMorph: aTextMorph 
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta - 1))).
	window 
		addMorph: divider
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@(verticalOffset + delta - 1) corner: 0@(verticalOffset + delta))).
	^ verticalOffset + delta! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/18/2010 16:23'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset forCodeHolder: codeHolder
	"If the receiver wishes it, add a button pane to the window, and answer the verticalOffset plus the height added"

	| delta buttons divider |
	codeHolder wantsOptionalButtons ifFalse: [^verticalOffset].
	delta := self defaultButtonPaneHeight.
	buttons := ((codeHolder isKindOf: ChangeList)
			ifTrue: [ self optionalButtonRowForChangeList: codeHolder ]
			ifFalse: [ self optionalButtonRowForCodeHolder: codeHolder ]) 
		color: (Display depth <= 8 ifTrue: [Color transparent] ifFalse: [(codeHolder smxWindowColor adjustSaturation: -0.03 brightness: -0.2) paler]).
	divider := SMxBorderedSubpaneDividerMorph forBottomEdge.
	divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	window 
		addMorph: buttons
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@verticalOffset corner: 0@(verticalOffset + delta - 1))).
	window 
		addMorph: divider
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@(verticalOffset + delta - 1) corner: 0@(verticalOffset + delta))).
	^ verticalOffset + delta! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/18/2010 16:23'!
addOptionalButtonsTo: window at: fractions plus: verticalOffset forDebugger: debugger
	"Add button panes to the window.  A row of custom debugger-specific buttons (Proceed, Restart, etc.) is always added, and if optionalButtons is in force, then the standard code-tool buttons are also added.  Answer the verticalOffset plus the height added."

	| delta buttons divider anOffset |
	anOffset := ("SMxPreferences optionalButtons" true and: ["SMxPreferences extraDebuggerButtons |" true])
		ifTrue:
			[self addOptionalButtonsTo: window at: fractions plus: verticalOffset forCodeHolder: debugger]
		ifFalse:
			[verticalOffset].

	delta := self defaultButtonPaneHeight.
	buttons := self customButtonRowForDebugger: debugger.
	buttons color: (Display depth <= 8 ifTrue: [Color transparent] ifFalse: [(debugger smxWindowColor adjustSaturation: -0.03 brightness: -0.2) paler]).
	divider := SMxBorderedSubpaneDividerMorph forBottomEdge.
	divider extent: 4@4; color: Color transparent; borderColor: #raised; borderWidth: 2.
	window 
		addMorph: buttons
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@anOffset corner: 0@(anOffset + delta - 1))).
	window 
		addMorph: divider
		fullFrame: (SMxLayoutFrame 
				fractions: fractions 
				offsets: (0@(anOffset + delta - 1) corner: 0@(anOffset + delta))).
	^ anOffset + delta! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:02'!
buildMorphicClassListForBrowser: browser
	| myClassList |
	(myClassList := SMxPluggableListMorph new)
		model: browser
		listGetter: #classList
		indexGetter: #classListIndex
		indexSetter: #classListIndex:
		menuGetter: #classListMenu:shifted:
		keystrokeAction: #classListKey:from:.
	myClassList borderWidth: 0.
	myClassList enableDragNDrop: false.
	myClassList doubleClickSelector: #browseSelectionInPlace.
	^myClassList! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/15/2010 21:44'!
buildMorphicCodePaneWith: editString forChangeList: changeList

	| codePane |
	codePane := SMxAcceptableCleanTextMorph
		model: changeList
		editorClass: changeList smxEditorClass
		textGetter: #contents 
		textSetter: #contents:
		selectionGetter: #contentsSelection 
		menuGetter: #smxPaneMenu:shifted:editorClass:.
	editString ifNotNil: [
		codePane editString: editString.
		codePane hasUnacceptedEdits: true
	].
	^codePane! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/15/2010 21:45'!
buildMorphicCodePaneWith: editString forCodeHolder: codeHolder
	"Construct the pane that shows the code.
	Respect the Preference for standardCodeFont."

	| codePane |
	codePane := SMxPluggableTextMorph
				model: codeHolder
				editorClass: codeHolder smxEditorClass
				textGetter: #contents
				textSetter: #contents:notifying:
				selectionGetter: #contentsSelection
				menuGetter: #smxPaneMenu:shifted:editorClass:.
	editString
		ifNotNil: [
			codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	^ codePane! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/15/2010 21:45'!
buildMorphicCommentPaneForBrowser: browser
	"Construct the pane that shows the class comment.
	Respect the setting StandardFonts codeFont."

	| commentPane |
	commentPane := SMxBrowserCommentTextMorph
				model: browser
				editorClass: browser smxEditorClass
				textGetter: #classCommentText
				textSetter: #classComment:notifying:
				selectionGetter: nil
				menuGetter: #smxPaneMenu:shifted:editorClass:.
	^ commentPane! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:02'!
buildMorphicMessageCatListForBrowser: browser
	| myMessageCatList |
	(myMessageCatList := SMxPluggableMessageCategoryListMorph new)
		model: browser
		listGetter: #messageCategoryList
		indexGetter: #messageCategoryListIndex
		indexSetter: #messageCategoryListIndex:
		menuGetter: #messageCategoryMenu:
		keystrokeAction: #arrowKey:from:
		rawListGetter: #rawMessageCategoryList.
	myMessageCatList enableDragNDrop: false.
	^myMessageCatList! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:02'!
buildMorphicMessageListForBrowser: browser
	"Build a morphic message list, with #messageList as its list-getter"

	| aListMorph |
	(aListMorph := SMxPluggableListMorph new)
		model: browser
		listGetter: #messageList
		indexGetter: #messageListIndex
		indexSetter: #messageListIndex:
		menuGetter: #messageListMenu:shifted:
		keystrokeAction: #messageListKey:from:.
	aListMorph enableDragNDrop: false.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^aListMorph! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/22/2010 14:18'!
buildMorphicNotifierFor: aDebugger labelled: label message: messageString
	| notifyPane window contentTop extentToUse |
	aDebugger expandStack.
	window := (SMxPreDebugWindow labelled: label) model: aDebugger.
	contentTop := 0.2.
	extentToUse := 650 @ 320.	"nice and wide to show plenty of the error msg"
	window addMorph: (self buttonRowFor: aDebugger preDebugWindow: window)
		frame: (0 @ 0 corner: 1 @ contentTop).
	messageString 
		ifNil: [
			notifyPane := SMxPluggableListMorph 
						model: aDebugger
						listGetter: #contextStackList
						indexGetter: #contextStackIndex
						indexSetter: #debugAt:
						menuGetter: nil
						keystrokeAction: nil]
		ifNotNil: [
			notifyPane := SMxPluggableTextMorph 
						model: aDebugger
						editorClass: aDebugger smxEditorClass
						textGetter: nil
						textSetter: nil
						selectionGetter: nil
						menuGetter: #debugProceedMenu:.
			notifyPane
				editString: messageString;
				askBeforeDiscardingEdits: false].
	window addMorph: notifyPane frame: (0 @ contentTop corner: 1 @ 1).
	^window openInWorldExtent: extentToUse! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/18/2010 16:24'!
buildMorphicSwitchesForBrowser: browser
	| instanceSwitch commentSwitch classSwitch row aColor |
	instanceSwitch := SMxPluggableButtonMorph 
				model: browser
				stateGetter: #instanceMessagesIndicated
				action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		borderWidth: 0.
	commentSwitch := SMxPluggableButtonMorph 
				model: browser
				stateGetter: #classCommentIndicated
				action: #plusButtonHit.
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		borderWidth: 0.
	classSwitch := SMxPluggableButtonMorph 
				model: browser
				stateGetter: #classMessagesIndicated
				action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		borderWidth: 0.
	row := SMxAlignmentMorph proportional.
	row
		addMorph: instanceSwitch fullFrame: (SMxLayoutFrame fractions: (0@0 corner: 0.5@1));
		addMorph: commentSwitch fullFrame: (SMxLayoutFrame fractions: (0.51@0 corner: 0.65@1));
		addMorph: classSwitch fullFrame: (SMxLayoutFrame fractions: (0.66@0 corner: 1@1)).
	aColor := Color colorFrom: browser smxWindowColor.
	row color: (aColor adjustSaturation: -0.03 brightness: -0.2).	"ensure matching button divider color. (see #paneColor)"
	aColor := aColor muchLighter.
	{ 
		instanceSwitch.
		commentSwitch.
		classSwitch} do: [:m | 
				m
					color: aColor;
					onColor: aColor twiceDarker offColor: aColor].
	^row! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:02'!
buildMorphicSystemCatListForBrowser: browser
	| dragNDropFlag myCatList |
	dragNDropFlag := false.
	(myCatList := SMxPluggableListMorph new)
		model: browser
		listGetter: #systemCategoryList
		indexGetter: #systemCategoryListIndex
		indexSetter: #systemCategoryListIndex:
		menuGetter: #systemCategoryMenu:
		keystrokeAction: #systemCatListKey:from:.
	myCatList enableDragNDrop: dragNDropFlag.
	^myCatList! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/22/2010 14:18'!
buttonRowFor: aDebugger preDebugWindow: aDebugWindow
	| row aButton quads buttons |
	buttons := OrderedCollection new.
	quads := OrderedCollection withAll: self preDebugButtonQuads.
	(aDebugger interruptedContext selector == #doesNotUnderstand:) ifTrue: [
		quads add: { 'Create'. #createMethod. #magenta. 'create the missing method' }
	].
	quads do: [ :quad |
		aButton := SMxSimpleButtonMorph new target: aDebugWindow.
		aButton color: Color transparent.
		aButton actionSelector: quad second.
		aButton label: quad first.
		aButton color: (Color colorFrom: quad third) muchLighter.
		aButton setBalloonText: quad fourth.
		buttons add: aButton].
	
	row := SMxAlignmentMorph proportional.
	row addInRow: buttons.
	^row! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
buttonSpecsForChangeList

	^#(
		(11		'select all' 			selectAll			'select all entries')
		(14		'deselect all'		deselectAll			'deselect all entries')
		(18		'select conflicts'	selectAllConflicts	'select all methods that occur in any change set')
		(19		'file in selections' 	fileInSelections		'file in all selected entries')
	)! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
buttonSpecsForVersionsBrowser

	^#(
		(22
		'compare to current'
		compareToCurrentVersion
		'opens a separate window which shows the text differences between the selected version and the current version')

		(9
		'revert'
		fileInSelections
		'reverts the method to the version selected')

		(24
		'remove from changes'
		removeMethodFromChanges
		'remove this method from the current change set')

		(6
		'help'
		offerVersionsHelp
		'further explanation about use of Versions browsers')
	)! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:05'!
createBrowser: browser asMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac := 0.4.
	window := SMxBrowserWindow new model: browser.
	
"The method SystemWindow>>addMorph:fullFrame: checks scrollBarsOnRight, then adds the morph at the back if true, otherwise it is added in front. But flopout hScrollbars need the lowerpanes to be behind the upper ones in the draw order. Hence the value of scrollBarsOnRight affects the order in which the lowerpanes are added. "
	SMxPreferences scrollBarsOnRight ifFalse: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString
			for: browser ].
		
	window 
		addMorph: (self buildMorphicSystemCatListForBrowser: browser)
		frame: (0@0 corner: 0.25@hSepFrac).
	self 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0
		forBrowser: browser.
	window 
		addMorph: (self buildMorphicMessageCatListForBrowser: browser)
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window
		addMorph: (self buildMorphicMessageListForBrowser: browser)
		frame: (0.75@0 extent: 0.25@hSepFrac).
		
	SMxPreferences scrollBarsOnRight ifTrue: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString
			for: browser ].
		
	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/21/2010 12:20'!
createBrowser: browser asMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."

	| window hSepFrac switchHeight mySingletonList nextOffsets |
	window := SMxBrowserWindow new model: browser.
	hSepFrac := 0.3.
	switchHeight := SMxPreferences standardCodeFont height + 10.
	mySingletonList := SMxPluggableListMorph 
				model: browser
				listGetter: #systemCategorySingleton
				indexGetter: #indexIsOne
				indexSetter: #indexIsOne:
				menuGetter: #systemCatSingletonMenu:
				keystrokeAction: #systemCatSingletonKey:from:.
	mySingletonList enableDragNDrop: false.
	mySingletonList hideScrollBarsIndefinitely.
	window addMorph: mySingletonList
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ switchHeight)).
	self 
		addClassAndSwitchesTo: window
		at: (0 @ 0 corner: 0.3333 @ hSepFrac)
		plus: switchHeight
		forBrowser: browser.
	nextOffsets := 0 @ switchHeight corner: 0 @ 0.
	window
		addMorph: (self buildMorphicMessageCatListForBrowser: browser)
		fullFrame: (SMxLayoutFrame 
				fractions: (0.3333 @ 0 corner: 0.6666 @ hSepFrac)
				offsets: nextOffsets).
	window
		addMorph: (self buildMorphicMessageListForBrowser: browser)
		fullFrame: (SMxLayoutFrame fractions: (0.6666 @ 0 corner: 1 @ hSepFrac)
				offsets: nextOffsets).
	self 
		addLowerPanesTo: window
		at: (0 @ hSepFrac corner: 1 @ 1)
		with: editString
		for: browser.
	window 
		setUpdatablePanesFrom: #(#classList #messageCategoryList #messageList).
	^window! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
customButtonRowForDebugger: debugger
	"Answer a button pane affording the user one-touch access to certain functions; the pane is given the formal name 'customButtonPane' by which it can be retrieved by code wishing to send messages to widgets residing on the pane"

	| aButton buttons row |
	buttons := OrderedCollection new.
	debugger customButtonSpecs do: [ :tuple | 
		aButton := SMxPluggableButtonMorph 
					model: debugger
					stateGetter: nil
					action: tuple second.
		(#(#proceed #restart #send #doStep #stepIntoBlock #fullStack #where) 
			includes: tuple second) ifTrue: [aButton askBeforeChanging: true].
		aButton label: tuple first asString.
		tuple size > 2 ifTrue: [aButton setBalloonText: tuple third].
		buttons add: aButton].
		
	row := SMxAlignmentMorph proportional.
	row addInProportionalRow: buttons.
	^row! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
defaultAnnotationPaneHeight
	"Answer the receiver's preferred default height for new annotation panes."

	^ StrikeFont default height * 2 + 8! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
defaultButtonPaneHeight
	"Answer the user's preferred default height for new button panes."

	^SMxPreferences standardButtonFont height * 8 // 5! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/26/2010 15:23'!
lineDiffButtonForCodeHolder: codeHolder
	"Return a checkbox that lets the user decide whether regular diffs should be shown or not"
	| outerButton button |
	outerButton := SMxAlignmentMorph proportional.
	outerButton
		 borderWidth: 2;
		 borderColor: #raised.
	outerButton color: Color transparent.
	button := SMxUpdatingThreePhaseButtonMorph checkBox.
	button
		 target: codeHolder;
		 actionSelector: #toggleRegularDiffing "#toggleLineDiffing";
		 getSelector: #showingRegularDiffs "#showingLineDiffs".
	outerButton
		addMorph: button
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (2 @ 3 corner: 18 @ 0));
		addMorph: (SMxStringMorph contents: 'lineDiffs') lock
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (18 @ 2 corner: 0 @ 0)).
	outerButton setBalloonText: 'Show code differences from the previous version, line by line.'.
	^ outerButton! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
menuButtonForCodeHolder: codeHolder
	"Answer a button that brings up a menu.  Useful when adding new features, but at present is between uses"

	| aButton |
	aButton := SMxIconicButton new target: codeHolder;
		labelGraphic: SMxSystemWindow menuIcon;
		color: Color transparent; 
		actWhen: #buttonDown;
		actionSelector: #offerMenu;
		yourself.
	aButton setBalloonText: 'click here to get a menu with further options'.
	^ aButton
! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/22/2010 09:52'!
messageNames: aMessageNames inMorphicWindowWithInitialSearchString: initialString
	"Answer a morphic window with the given initial search string, nil if none"

"MessageNames openMessageNames"

	| window selectorListView firstDivider secondDivider horizDivider typeInPane searchButton plugTextMor |
	window := (SMxBrowserWindow labelled: 'Message Names') model: aMessageNames.
	firstDivider := 0.07.
	secondDivider := 0.5.
	horizDivider := 0.5.
	typeInPane := SMxAlignmentMorph proportional height: 14.

	plugTextMor := SMxPluggableTextMorph 
		model: aMessageNames
		editorClass: aMessageNames smxEditorClass
		textGetter: #searchString 
		textSetter: #searchString:from:
		selectionGetter: nil 
		menuGetter: nil.
	plugTextMor setProperty: #alwaysAccept toValue: true.
	plugTextMor askBeforeDiscardingEdits: false.
	plugTextMor acceptOnCR: true.
	plugTextMor setTextColor: Color brown.
	plugTextMor hideScrollBarsIndefinitely.
	plugTextMor setTextMorphToSelectAllOnMouseEnter.

	searchButton := SMxSimpleButtonMorph new 
		target: aMessageNames;
		beTransparent;
		label: 'Search';
		actionSelector: #doSearchFrom:;
		arguments: {plugTextMor}.
	searchButton setBalloonText: 'Type some letters into the pane at right, and then press this Search button (or hit RETURN) and all method selectors that match what you typed will appear in the list pane below.  Click on any one of them, and all the implementors of that selector will be shown in the right-hand pane, and you can view and edit their code without leaving this tool.'.

	typeInPane addInProportionalRow: { searchButton. plugTextMor. }.
	initialString isEmptyOrNil ifFalse:
		[plugTextMor setText: initialString].

	window addMorph: typeInPane frame: (0@0 corner: horizDivider @ firstDivider).

	selectorListView := SMxPluggableListMorph 
		model: aMessageNames
		listGetter: #selectorList
		indexGetter: #selectorListIndex
		indexSetter: #selectorListIndex:
		menuGetter: #selectorListMenu:
		keystrokeAction: #selectorListKey:from:.
	selectorListView menuTitleSelector: #selectorListMenuTitle.
	window addMorph: selectorListView frame: (0 @ firstDivider corner: horizDivider @ secondDivider).

	window addMorph: (self buildMorphicMessageListForBrowser: aMessageNames) frame: (horizDivider @ 0 corner: 1@ secondDivider).

	self 
		addLowerPanesTo: window 
		at: (0 @ secondDivider corner: 1@1) 
		with: nil
		for: aMessageNames.

	initialString isEmptyOrNil ifFalse: [
		aMessageNames searchString: initialString notifying: nil].
	^ window! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/22/2010 09:24'!
messageSet: aMessageSet inMorphicWindowLabeled: labelString
	| window listFraction |
	window := (SMxBrowserWindow labelled: labelString) model: aMessageSet.
	listFraction := 0.4.
	window
		addMorph: (SMxBrowserWindow buildMorphicMessageListForBrowser: aMessageSet)
		frame: (0@0 extent: 1@listFraction).
	SMxBrowserWindow
		addLowerPanesTo: window
		at: (0@listFraction corner: 1@1)
		with: nil
		forBrowser: aMessageSet.
	window setUpdatablePanesFrom: #(messageList).
	^ window! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:03'!
morphicClassColumnForBrowser: browser
	| column switchHeight divider |
	column := SMxAlignmentMorph proportional.
	switchHeight := StrikeFont default height + 4.
	column 
		addMorph: (self buildMorphicSwitchesForBrowser: browser)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ (1 - switchHeight) corner: 0 @ 0)).
	divider := SMxBorderedSubpaneDividerMorph forTopEdge.
	divider
		extent: 4 @ 4;
		color: Color transparent;
		borderColor: #raised;
		borderWidth: 2.
	column addMorph: divider
		fullFrame: (SMxLayoutFrame fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ switchHeight negated corner: 0 @ (1 - switchHeight))).
	column addMorph: (self buildMorphicClassListForBrowser: browser)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ switchHeight negated)).
	^column! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 11:54'!
openBrowser
	| browser window |
	browser := Browser new.
	window := self createBrowser: browser asMorphEditing: nil.
	window setLabel: browser defaultBrowserTitle.
	window openInWorld.
	^browser! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 15:37'!
openBrowser: aBrowser asMorphClassEditing: editString
	"Create a pluggable version a Browser on just a single class."

	| window dragNDropFlag hSepFrac switchHeight mySingletonClassList switches c |
	window := SMxSystemWindow new model: aBrowser.
	dragNDropFlag := false.
	hSepFrac := 0.3.
	switchHeight := StrikeFont default height + 10.
	mySingletonClassList := SMxPluggableListMorph 
				model: aBrowser
				listGetter: #classListSingleton
				indexGetter: #indexIsOne
				indexSetter: #indexIsOne:
				menuGetter: #classListMenu:shifted:
				keystrokeAction: #classListKey:from:.
	mySingletonClassList enableDragNDrop: dragNDropFlag.
	self 
		addLowerPanesTo: window
		at: (0 @ hSepFrac corner: 1 @ 1)
		with: editString
		for: aBrowser.
	window
		addMorph: mySingletonClassList
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 0.5 @ 0)
				offsets: (0 @ 0 corner: 0 @ switchHeight)).
	switches := self buildMorphicSwitchesForBrowser: aBrowser.
	c := switches color.
	window
		addMorph: switches
		fullFrame: (SMxLayoutFrame fractions: (0.5 @ 0 corner: 1.0 @ 0)
				offsets: (0 @ 0 corner: 0 @ switchHeight)).
	switches color: c.
	window
		addMorph: (self buildMorphicMessageCatListForBrowser: aBrowser)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 0.5 @ hSepFrac)
				offsets: (0 @ switchHeight corner: 0 @ 0)).
	window
		addMorph: (self buildMorphicMessageListForBrowser: aBrowser)
		fullFrame: (SMxLayoutFrame fractions: (0.5 @ 0 corner: 1.0 @ hSepFrac)
				offsets: (0 @ switchHeight corner: 0 @ 0)).
	window setUpdatablePanesFrom: #(#messageCategoryList #messageList).
	^window! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 15:35'!
openBrowser: aBrowser asMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac := 0.4.
	window := SMxSystemWindow new model: aBrowser.
	
"The method SMxSystemWindow>>addMorph:fullFrame: checks scrollBarsOnRight, then adds the morph at the back if true, otherwise it is added in front. But flopout hScrollbars need the lowerpanes to be behind the upper ones in the draw order. Hence the value of scrollBarsOnRight affects the order in which the lowerpanes are added. "
	SMxPreferences scrollBarsOnRight ifFalse: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString
			for: aBrowser ].
		
	window 
		addMorph: (self buildMorphicSystemCatListForBrowser: aBrowser)
		frame: (0@0 corner: 0.25@hSepFrac).
	self 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0
		forBrowser: aBrowser.
	window 
		addMorph: (self buildMorphicMessageCatListForBrowser: aBrowser)
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window
		addMorph: (self buildMorphicMessageListForBrowser: aBrowser)
		frame: (0.75@0 extent: 0.25@hSepFrac).
		
	SMxPreferences scrollBarsOnRight ifTrue: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString
			forBrowser: aBrowser ].
		
	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 15:39'!
openBrowser: aBrowser asMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"

	| window mySingletonMessageList verticalOffset nominalFractions |
	window := SMxSystemWindow new model: aBrowser.
	mySingletonMessageList := SMxPluggableListMorph 
				model: aBrowser
				listGetter: #messageListSingleton
				indexGetter: #indexIsOne
				indexSetter: #indexIsOne:
				menuGetter: #messageListMenu:shifted:
				keystrokeAction: #messageListKey:from:.
	mySingletonMessageList enableDragNDrop: false.
	verticalOffset := 25.
	nominalFractions := 0 @ 0 corner: 1 @ 0.
	window
		addMorph: mySingletonMessageList
		fullFrame: (SMxLayoutFrame fractions: nominalFractions
				offsets: (0 @ 0 corner: 0 @ verticalOffset)).
	verticalOffset := self 
				addOptionalAnnotationsTo: window
				at: nominalFractions
				plus: verticalOffset
				forCodeHolder: aBrowser.
	verticalOffset := self 
				addOptionalButtonsTo: window
				at: nominalFractions
				plus: verticalOffset
				forCodeHolder: aBrowser.
	window
		addMorph: (self buildMorphicCodePaneWith: editString forCodeHolder: aBrowser)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ verticalOffset corner: 0 @ 0)).
	^window! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 15:42'!
openBrowser: aBrowser asMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a message category."

	| window hSepFrac |
	window := SMxSystemWindow new model: aBrowser.
	hSepFrac := 0.3.
	window 
		addMorph: ((SMxPluggableListMorph 
				model: aBrowser
				listGetter: #messageCatListSingleton
				indexGetter: #indexIsOne
				indexSetter: #indexIsOne:
				menuGetter: #messageCategoryMenu:) 
					enableDragNDrop: false)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ 25)).
	window
		addMorph: (self buildMorphicMessageListForBrowser: aBrowser)
		fullFrame: (SMxLayoutFrame fractions: (0 @ 0 corner: 1 @ hSepFrac)
				offsets: (0 @ 25 corner: 0 @ 0)).
	self 
		addLowerPanesTo: window
		at: (0 @ hSepFrac corner: 1 @ 1)
		with: editString
		for: aBrowser.
	window setUpdatablePanesFrom: #(#messageCatListSingleton #messageList).
	^window! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 12:14'!
openBrowser: aBrowser asMorphSysCatEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	^self createBrowser: aBrowser asMorphSysCatEditing: editString! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/26/2010 15:04'!
openChangeList: aChangeList asMorphName: labelString multiSelect: multiSelect
	"Open a morphic view for the messageSet, whose label is labelString. 
	The listView may be either single or multiple selection type"
	| window listHeight listPane |
	listHeight := 0.4.
	window := (SMxBrowserWindow labelled: labelString)
				model: aChangeList.
	listPane := multiSelect
				ifTrue: [SMxPluggableListMorphOfMany
						model: aChangeList
						listGetter: #list
						primarySelectionGetter: #listIndex
						primarySelectionSetter: #toggleListIndex:
						listSelectionGetter: #listSelectionAt:
						listSelectionSetter: #listSelectionAt:put:
						menuGetter: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])]
				ifFalse: [SMxPluggableListMorph
						model: aChangeList
						listGetter: #list
						indexGetter: #listIndex
						indexSetter: #toggleListIndex:
						menuGetter: (aChangeList showsVersions
								ifTrue: [#versionsMenu:]
								ifFalse: [#changeListMenu:])].
	listPane keystrokeActionSelector: #changeListKey:from:.
	window
		addMorph: listPane
		frame: (0 @ 0 extent: 1 @ listHeight).
	self
		addLowerPanesTo: window
		at: (0 @ listHeight corner: 1 @ 1)
		with: nil
		for: aChangeList.
	^ window openInWorld! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/21/2010 17:28'!
openChangeSorter: aChangeSorter asMorphIn: window rect: rect
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 0.5@0."

	| csListHeight msgListHeight csMsgListHeight |
	aChangeSorter contents: ''.
	csListHeight := 0.25.
	msgListHeight := 0.25.
	csMsgListHeight := csListHeight + msgListHeight.
	aChangeSorter addDependent: window.		"so it will get changed: #relabel"

	window addMorph: ((SMxPluggableListMorphByItem 
				model: aChangeSorter
				listGetter: #changeSetList
				indexGetter: #currentChangeSet
				indexSetter: #showChangeSetNamed:
				menuGetter: #changeSetMenu:shifted:
				keystrokeAction: #changeSetListKey:from:)
			autoDeselect: false)
		frame: (((0@0 extent: 0.5@csListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (SMxPluggableListMorphByItem 
				model: aChangeSorter
				listGetter: #classList
				indexGetter: #currentClassName
				indexSetter: #currentClassName:
				menuGetter: #classListMenu:shifted:
				keystrokeAction: #classListKey:from:)
		frame: (((0.5@0 extent: 0.5@csListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	window addMorph: (SMxPluggableListMorphByItem 
				model: aChangeSorter
				listGetter: #messageList
				indexGetter: #currentSelector
				indexSetter: #currentSelector:
				menuGetter: #messageMenu:shifted:
				keystrokeAction: #messageListKey:from:)
		frame: (((0@csListHeight extent: 1@msgListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	 self
		addLowerPanesTo: window
		at: (((0@csMsgListHeight corner: 1@1) scaleBy: rect extent) translateBy: rect origin)
		with: nil
		for: aChangeSorter.! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 17:27'!
openChangeSorterAsMorph: aChangeSorter
	"ChangeSorter new openAsMorph"
	|  window |

	aChangeSorter assureChangeSet.
	window := (SMxSystemWindow labelled: aChangeSorter labelString) model: aChangeSorter.
	self openChangeSorter: aChangeSorter asMorphIn: window rect: (0@0 extent: 1@1).
	window openInWorld! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/29/2010 10:58'!
openDebugger: aDebugger fullMorphicLabel: aLabelString
	"Open a full morphic debugger with the given label"

	| window aListMorph oldContextStackIndex |
	oldContextStackIndex := aDebugger contextStackIndex.
	aDebugger expandStack. "Sets contextStackIndex to zero."

	window := (SMxBrowserWindow labelled: aLabelString) model: aDebugger.
	aListMorph := SMxPluggableListMorph
		model: aDebugger 
		listGetter: #contextStackList
		indexGetter: #contextStackIndex
		indexSetter: #toggleContextStackIndex:
		menuGetter: #contextStackMenu:shifted:
		keystrokeAction: #contextStackKey:from:.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph
		frame: (0@0 corner: 1@0.25).

	self addLowerPanesTo: window at: (0@0.25 corner: 1@0.8) with: nil for: aDebugger.

	window addMorph: (
		SMxPluggableListMorph new
			doubleClickSelector: #inspectSelection;
			model: aDebugger receiverInspector
			listGetter: #fieldList
			indexGetter: #selectionIndex 
			indexSetter: #toggleIndex:
			menuGetter: #fieldListMenu: 
			keystrokeAction: #inspectorKey:from:)
		frame: (0@0.8 corner: 0.2@1).
	window addMorph: (SMxPluggableTextMorph 
			model: aDebugger receiverInspector
			editorClass: aDebugger receiverInspector smxEditorClass
			textGetter: #contents 
			textSetter: #accept:
			selectionGetter: #contentsSelection 
			menuGetter: #smxPaneMenu:shifted:editorClass:)
		frame: (0.2@0.8 corner: 0.5@1).
	window addMorph: (
		SMxPluggableListMorph new
			doubleClickSelector: #inspectSelection;
			model: aDebugger contextVariablesInspector 
			listGetter: #fieldList
			indexGetter: #selectionIndex 
			indexSetter: #toggleIndex:
			menuGetter: #fieldListMenu: 
			keystrokeAction: #inspectorKey:from:)
		frame: (0.5@0.8 corner: 0.7@1).
	window addMorph: (SMxPluggableTextMorph 
			model: aDebugger contextVariablesInspector
			editorClass: aDebugger contextVariablesInspector smxEditorClass
			textGetter: #contents 
			textSetter: #accept:
			selectionGetter: #contentsSelection 
			menuGetter: #smxPaneMenu:shifted:editorClass:)
		frame: (0.7@0.8 corner: 1@1).
	window openInWorld.
	aDebugger toggleContextStackIndex: oldContextStackIndex.
	^ window ! !

!SMxBrowserWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/21/2010 17:39'!
openDualChangeSorterAsMorph: aDualChangeSorter
	
	| window |
	aDualChangeSorter setDefaultChangeSorters.

	window := (SMxSystemWindow labelled:  aDualChangeSorter leftCngSorter label) model: aDualChangeSorter.
	"topView minimumSize: 300 @ 200."
	self openChangeSorter: aDualChangeSorter leftCngSorter asMorphIn: window rect: (0@0 extent: 0.5@1).
	self openChangeSorter: aDualChangeSorter rightCngSorter asMorphIn: window rect: (0.5@0 extent: 0.5@1).
	window openInWorld! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/26/2010 15:21'!
optionalButtonRowForChangeList: changeList
	"Answer a row of buttons to occur in a tool pane"

	| row buttons widths |
	buttons := OrderedCollection new.
	widths := OrderedCollection new.
	((changeList isKindOf: VersionsBrowser)
			ifTrue: [ self buttonSpecsForVersionsBrowser ]
			ifFalse: [ self buttonSpecsForChangeList ]) do: [ :tuple | | button |
		widths add: tuple first.
		button := SMxPluggableButtonMorph 
					model: changeList
					stateGetter: nil
					action: tuple third.
		button
			label: tuple second asString;
			askBeforeChanging: true.
		buttons add: button.
		button setBalloonText: tuple fourth].
	buttons add: (self lineDiffButtonForCodeHolder: changeList).
	widths add: 14.
"	buttons add: (self wordDiffButtonForCodeHolder: changeList).
	widths add: 16."
	changeList wantsPrettyDiffOption ifTrue: [
		buttons add:  (self prettyLineDiffButtonForCodeHolder: changeList).
		widths add: 21.
"		buttons add:  (self prettyWordDiffButtonForCodeHolder: changeList).
		widths add: 23" ].
	row := SMxAlignmentMorph proportional.
	row addInRow: buttons widthProportionalTo: widths.
	^row! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:04'!
optionalButtonRowForCodeHolder: codeHolder
	"Answer a row of control buttons"

	| row buttons widths |
	buttons := OrderedCollection new.
	widths := OrderedCollection new.
	SMxPreferences menuButtonInToolPane ifTrue: [
		buttons add: (self menuButtonForCodeHolder: codeHolder).
		widths add: 4 ].
	((codeHolder isKindOf: Debugger)
			ifTrue: [ self optionalButtonTuplesForDebugger ]
			ifFalse: [ self optionalButtonTuplesForCodeHolder ]) do: [ :tuple | | button |
		widths add: tuple first.
		button := SMxPluggableButtonMorph 
					model: codeHolder
					stateGetter: nil
					action: tuple third.
		button label: tuple second asString.
		tuple size > 3 ifTrue: [button setBalloonText: tuple fourth].
		tuple size > 4 ifTrue: [button triggerOnMouseDown: tuple fifth].
		buttons add: button ].
	row := SMxAlignmentMorph proportional.
	row addInRow: buttons widthProportionalTo: widths.
	^row! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:04'!
optionalButtonTuplesForCodeHolder
	"Answer a tuple buttons, in the format:
			button label
			selector to send
			help message"

	| aList |

	aList := #(
	(10	'browse'			browseMethodFull				'view this method in a browser')
	(11	'senders' 			browseSendersOfMessages	'browse senders of...')
	(16	'implementors'		browseMessages				'browse implementors of...')
	(11	'versions'			browseVersions					'browse versions')), 

	("Preferences decorateBrowserButtons" true
		ifTrue:
			[{#(13	'inheritance'		methodHierarchy 	'browse method inheritance
green: sends to super
tan: has override(s)
mauve: both of the above
pink: is an override but doesn''t call super
pinkish tan: has override(s), also is an override but doesn''t call super' )}]
		ifFalse:
			[{#(13	'inheritance'		methodHierarchy	'browse method inheritance')}]),

	#(
	(12	'hierarchy'			classHierarchy					'browse class hierarchy')
	(11	'inst vars'			browseInstVarRefs				'inst var refs...')
	(13	'class vars'			browseClassVarRefs			'class var refs...')
	(9	'show...'				offerWhatToShowMenu		'menu of what to show in lower pane')).

	^ aList! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:04'!
optionalButtonTuplesForDebugger
	"No [show...] button in debugger"
	^self optionalButtonTuplesForCodeHolder reject: [ :tuple |
		tuple third = #offerWhatToShowMenu ]! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/22/2010 14:17'!
preDebugButtonQuads

	^{
	{'Proceed'.		#proceed. 	#blue. 	'continue execution'}.
	{'Abandon'.		#delete.	 	#black.	'abandon this execution by closing this window'}.
	{'Debug'.		#debug.		#red. 		'bring up a debugger'}}! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/26/2010 15:23'!
prettyLineDiffButtonForCodeHolder: codeHolder
	"Return a checkbox that lets the user decide whether prettyDiffs should be shown or not"
	| outerButton button |
	outerButton := SMxAlignmentMorph proportional.
	outerButton
		 borderWidth: 2;
		 borderColor: #raised.
	outerButton color: Color transparent.
	button := SMxUpdatingThreePhaseButtonMorph checkBox.
	button
		 target: codeHolder;
		 actionSelector: #togglePrettyDiffing "#togglePrettyLineDiffing";
		 getSelector: #showingPrettyDiffs "#showingPrettyLineDiffs".
	outerButton
		addMorph: button
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (2 @ 3 corner: 18 @ 0));
		addMorph: (SMxStringMorph contents: 'linePrettyDiffs') lock
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (18 @ 2 corner: 0 @ 0)).
	(codeHolder isKindOf: VersionsBrowser)
		ifTrue: [ outerButton setBalloonText: 'Show pretty-printed code differences from the previous version, line by line.' ]
		ifFalse: [ outerButton setBalloonText: 'Show pretty-printed code differences between the file-based method and the in-memory version, line by line.' ].
	^ outerButton.! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/21/2010 12:20'!
prettyWordDiffButtonForCodeHolder: codeHolder
	"Return a checkbox that lets the user decide whether prettyDiffs should be shown or not"
	| outerButton button |
	outerButton := SMxAlignmentMorph proportional.
	outerButton
		 borderWidth: 2;
		 borderColor: #raised.
	outerButton color: Color transparent.
	button := SMxUpdatingThreePhaseButtonMorph checkBox.
	button
		 target: codeHolder;
		 actionSelector: #togglePrettyWordDiffing;
		 getSelector: #showingPrettyWordDiffs.
	outerButton
		addMorph: button
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (2 @ 3 corner: 18 @ 0));
		addMorph: (SMxStringMorph contents: 'wordPrettyDiffs') lock
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (18 @ 2 corner: 0 @ 0)).
	(codeHolder isKindOf: VersionsBrowser)
		ifTrue: [ outerButton setBalloonText: 'Show pretty-printed code differences from the previous version, word by word.' ]
		ifFalse: [ outerButton setBalloonText: 'Show pretty-printed code differences between the file-based method and the in-memory version, word by word.' ].
	^ outerButton.! !

!SMxBrowserWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/14/2010 09:04'!
wordDiffButtonForCodeHolder: codeHolder
	"Return a checkbox that lets the user decide whether regular diffs should be shown or not"
	| outerButton button |
	outerButton := SMxAlignmentMorph proportional.
	outerButton
		 borderWidth: 2;
		 borderColor: #raised.
	outerButton color: Color transparent.
	button := SMxUpdatingThreePhaseButtonMorph checkBox.
	button
		 target: codeHolder;
		 actionSelector: #toggleWordDiffing;
		 getSelector: #showingWordDiffs.
	outerButton
		addMorph: button
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 0 @ 1)
				offsets: (2 @ 3 corner: 18 @ 0));
		addMorph: (SMxStringMorph contents: 'wordDiffs') lock
		fullFrame:
			(SMxLayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (18 @ 2 corner: 0 @ 0)).
	outerButton setBalloonText: 'Show code differences (better algorithm) from the previous version.'.
	^ outerButton.! !

SMxSystemWindow subclass: #SMxPreDebugWindow
	instanceVariableNames: 'proceedButton debugButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxPreDebugWindow class methodsFor: 'new-morph participation' stamp: 'sw 11/4/1998 09:20'!
includeInNewMorphMenu
	^ false! !

!SMxPreDebugWindow methodsFor: 'as yet unclassified' stamp: 'nk 2/12/2003 23:00'!
createMethod
	model createMethod! !

!SMxPreDebugWindow methodsFor: 'as yet unclassified' stamp: 'sw 10/15/1998 13:00'!
debug
	model debug! !

!SMxPreDebugWindow methodsFor: 'as yet unclassified' stamp: 'sw 10/15/1998 13:00'!
proceed
	model proceed! !

!SMxPreDebugWindow methodsFor: 'as yet unclassified' stamp: 'mir 11/10/2003 15:15'!
storeLog
	model storeLog! !

!SMxSystemWindow class methodsFor: 'accessing' stamp: 'RAA 12/21/2000 12:01'!
classVersion
	"Changed to 1 for SMxSystemWindow Dec 2000 - see if this helps loading old ones"
	^ 1! !

!SMxSystemWindow class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/18/2010 15:54'!
closeIcon
	"Supplied here because we don't necessarily have ComicBold"

	CloseIcon ifNil: [
		CloseIcon := (Form
			extent: 9@9
			depth: 32
			fromArray: #(4278190088 4278190088 0 0 0 0 0 4278190088 4278190088 4278190088 4278190088 4278190088 0 0 0 4278190088 4278190088 4278190088 0 4278190088 4278190088 4278190088 0 4278190088 4278190088 4278190088 0 0 0 4278190088 4278190088 4278190088 4278190088 4278190088 0 0 0 0 0 4278190088 4278190088 4278190088 0 0 0 0 0 4278190088 4278190088 4278190088 4278190088 4278190088 0 0 0 4278190088 4278190088 4278190088 0 4278190088 4278190088 4278190088 0 4278190088 4278190088 4278190088 0 0 0 4278190088 4278190088 4278190088 4278190088 4278190088 0 0 0 0 0 4278190088 4278190088)
			offset: 0@0)].
	^CloseIcon! !

!SMxSystemWindow class methodsFor: 'top window' stamp: 'sw 12/6/2000 20:13'!
closeTopWindow
	"Try to close the top window.  It may of course decline"

	TopWindow ifNotNil:
		[TopWindow delete]! !

!SMxSystemWindow class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/18/2010 15:56'!
collapseIcon
	"Supplied here because we don't necessarily have ComicBold"

	CollapseIcon ifNil: [
		CollapseIcon := (Form
			extent: 10@10
			depth: 32
			fromArray:  #(0 0 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 0 0 0 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 0 4278190096 4278190096 4278190096 0 0 0 0 4278190096 4278190096 4278190096 4278190096 4278190096 0 0 0 0 0 0 4278190096 4278190096 4278190096 4278190096 0 0 0 0 0 0 4278190096 4278190096 4278190096 4278190096 0 0 0 0 0 0 4278190096 4278190096 4278190096 4278190096 0 0 0 0 0 0 4278190096 4278190096 4278190096 4278190096 4278190096 0 0 0 0 4278190096 4278190096 4278190096 0 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 0 0 0 4278190096 4278190096 4278190096 4278190096 4278190096 4278190096 0 0)
			offset: 0@0)].
	CollapseIcon := (CollapseIcon asFormOfDepth: 32) fixAlpha.
	^CollapseIcon! !

!SMxSystemWindow class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:17'!
expandIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ ExpandIcon ifNil: [  ExpandIcon := Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAJ0lEQVR4XmNgYOD4jx1jAGyC
JCnEsIEYE0lXSMgzKHysHqCfQtwYAJeTKiCsUgn2AAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxSystemWindow class methodsFor: 'instance creation' stamp: 'di 2/3/98 11:54'!
includeInNewMorphMenu
	"Include my subclasses but not me"
	^ self ~~ SMxSystemWindow! !

!SMxSystemWindow class methodsFor: 'instance creation' stamp: 'di 6/18/97 05:31'!
labelled: labelString
	^ (self basicNew setLabel: labelString) initialize! !

!SMxSystemWindow class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:17'!
menuIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ MenuIcon ifNil: [ MenuIcon := Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAAAsAAAAKCAYAAABi8KSDAAAALUlEQVR4XmNgYGD8TzyGEEQA
FMXImuAm4VJMtMmETEdxM+09iO4MDJosDxLGAMTrOwH2L4NmAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxSystemWindow class methodsFor: 'top window' stamp: 'jmv 3/1/2010 13:43'!
noteTopWindowIn: aWorld
	| newTop |
	"TopWindow must be nil or point to the top window in this project."
	TopWindow := nil.
	aWorld ifNil: [^ self].
	newTop := aWorld findA: SMxSystemWindow.
	newTop ifNotNil: [ newTop activate]! !

!SMxSystemWindow class methodsFor: 'gui building - general' stamp: 'JuanVuletich 10/13/2010 17:18'!
openStringHolder: model asMorphLabel: labelString inWorld: aWorld
	self openStringHolder: model asMorphLabel: labelString inWorld: aWorld wrap: nil! !

!SMxSystemWindow class methodsFor: 'gui building - general' stamp: 'JuanVuletich 10/15/2010 21:45'!
openStringHolder: stringHolder asMorphLabel: labelString inWorld: aWorld wrap: aBoolean
	| window textMorph |
	window := (SMxSystemWindow labelled: labelString) model: stringHolder.
	textMorph := SMxPluggableTextMorph 
		model: stringHolder 
		editorClass: stringHolder smxEditorClass
		textGetter: #contents 
		textSetter: #acceptContents:
		selectionGetter: nil 
		menuGetter: #smxPaneMenu:shifted:editorClass:.
	aBoolean ifNotNil: [
		textMorph wrapFlag: aBoolean ].
	window addMorph: textMorph frame: (0@0 corner: 1@1).
	window openInWorld: aWorld! !

!SMxSystemWindow class methodsFor: 'gui building - general' stamp: 'JuanVuletich 10/29/2010 10:58'!
openTranscript: aTranscript asMorphLabel: aString
	"Build a morph viewing this transcriptStream"
	| window |
	window := (SMxSystemWindow labelled: aString) model: aTranscript.
	window addMorph: (SMxPluggableTextMorph 
			model: aTranscript 
			editorClass: aTranscript smxEditorClass
			textGetter: nil 
			textSetter: nil
			selectionGetter: nil 
			menuGetter: #smxPaneMenu:shifted:editorClass:)
		frame: (0@0 corner: 1@1).
	^ window openInWorld! !

!SMxSystemWindow class methodsFor: 'class initialization' stamp: 'JuanVuletich 10/18/2010 15:18'!
recreateBoxes
	CloseIcon := nil.
	CollapseIcon := nil! !

!SMxSystemWindow class methodsFor: 'top window' stamp: 'sw 12/6/2000 19:43'!
sendTopWindowToBack
	"Send the top window of the world to the back, activating the one just beneath it"

	TopWindow ifNotNil:
		[TopWindow sendToBack]! !

!SMxSystemWindow class methodsFor: 'accessing' stamp: 'JuanVuletich 11/2/2010 10:07'!
topWindow
	^ TopWindow! !

!SMxSystemWindow class methodsFor: 'top window' stamp: 'sw 1/4/2000 15:22'!
wakeUpTopWindowUponStartup
	TopWindow ifNotNil:
		[TopWindow isCollapsed ifFalse:
			[TopWindow model ifNotNil:
				[TopWindow model modelWakeUpIn: TopWindow]]]! !

!SMxSystemWindow class methodsFor: 'top window' stamp: 'jmv 12/5/2009 20:39'!
windowsIn: aWorld satisfying: windowBlock 
	| windows |
	windows := OrderedCollection new.
	aWorld ifNil: [^windows].	"opening MVC in Morphic - WOW!!"
	aWorld submorphs do: [ :m | 
			((m is: #SMxSystemWindow) and: [windowBlock value: m]) 
				ifTrue: [windows addLast: m]].
	^windows! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'jmv 4/9/2009 13:33'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"

	| candidate |
	self activateAndSendTopToBack: false.
	
	candidate := self.
	candidate handlesKeyboard ifFalse: [
		[
			candidate := candidate nextMorph.
			candidate handlesKeyboard not and: [ candidate ~~  self ] ] whileTrue ].

	candidate handlesKeyboard ifTrue: [
		self world primaryHand newKeyboardFocus: candidate ]! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'sw 5/10/1999 15:42'!
activateAndForceLabelToShow
	self activate.
	bounds top < 0 ifTrue:
		[self position: (self position x @ 0)]! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'jmv 9/12/2009 22:26'!
activateAndSendTopToBack: aBoolean
	"Bring me to the front and make me able to respond to mouse and keyboard"

	| oldTop |
	self owner 
		ifNil: [^self	"avoid spurious activate when drop in trash"].
	oldTop := TopWindow.
	TopWindow := self.

	oldTop ifNotNil: [
		oldTop passivate.
		aBoolean ifTrue: [
			oldTop owner addMorphBack: oldTop ]].

	self owner firstSubmorph == self 
		ifFalse: [
			"Bring me (with any flex) to the top if not already"
			self owner addMorphFront: self].
	self invalidateTitleArea.
	self isCollapsed 
		ifFalse: [
			model modelWakeUpIn: self]! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'md 11/14/2003 17:30'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
"template..."
	aCustomMenu addLine.
	aCustomMenu add: 'edit label...' translated action: #relabel.
! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'RAA 1/8/2001 20:37'!
addMorph: aMorph frame: relFrame
	| frame |
	frame := SMxLayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	self addMorph: aMorph fullFrame: frame.

! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'jmv 9/17/2009 10:38'!
addMorph: aMorph fullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs := paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	aMorph adoptPaneColor: self paneColor.
	(aMorph is: #SMxBorderedMorph) ifTrue: [
		aMorph borderWidth: 2; borderColor: #inset; color: Color transparent ].
	"reorder panes so flop-out right-side scrollbar is visible"
	SMxPreferences scrollBarsOnRight
		ifTrue: [ self addMorphBack: aMorph ]! !

!SMxSystemWindow methodsFor: 'stepping' stamp: 'sw 10/19/1999 09:30'!
amendSteppingStatus
	"Circumstances having changed, find out whether stepping is wanted and assure that the new policy is carried out"

	self wantsSteps
		ifTrue:
			[self arrangeToStartStepping]
		ifFalse:
			[self stopStepping]! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'sw 3/6/1999 10:52'!
applyModelExtent
	self extent: model initialExtent! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 8/21/2009 09:17'!
boxExtent
	"answer the extent to use in all the buttons. 
	 
	the label height is used to be proportional to the fonts preferences"
	| e |
	e := SMxPreferences windowTitleFont height.
	^e@e! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 5/11/2009 23:44'!
buildWindowMenu
	| aMenu |
	aMenu := SMxMenuMorph new defaultTarget: self.
	aMenu add: 'change title...' translated action: #relabel.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	aMenu addLine.
	aMenu add: 'full screen' translated action: #fullScreen.
	self isCollapsed ifFalse: [aMenu add: 'window color...' translated action: #setWindowColor].
	^aMenu! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 4/27/2010 10:23'!
changeColor
	"Change the color of the receiver -- triggered, e.g. from a menu.  This variant allows the recolor triggered from the window's halo recolor handle to have the same result as choosing change-window-color from the window-title menu"

	SMxColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #setWindowColor:;
		originalColor: self color;
		putUpFor: self near: self fullDisplayBounds! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'JuanVuletich 10/18/2010 09:02'!
closeBoxHit
	"The user clicked on the close-box control in the window title."
	self delete
! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'ar 2/10/1999 04:19'!
collapse
	self isCollapsed ifFalse:[self collapseOrExpand]! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 4/27/2010 11:41'!
collapseOrExpand
	"Collapse or expand the window, depending on existing state"
	| cf |
	isCollapsed
		ifTrue: [
			"Expand -- restore panes to morphics structure"
			isCollapsed := false.
			self activate.  "Bring to frint first"
			SMxPreferences collapseWindowsInPlace
				ifTrue: [
					fullFrame := fullFrame align: fullFrame topLeft with: bounds topLeft]
				ifFalse: [
					collapsedFrame := bounds].
			self bounds: fullFrame.
			paneMorphs reverseDo: [ :m |  
				self addMorph: m.
				self world startSteppingSubmorphsOf: m]]
		ifFalse: [
			"Collapse -- remove panes from morphics structure"
			isCollapsed := true.
			fullFrame := bounds.
			"First save latest fullFrame"
			paneMorphs do: [:m | m delete; releaseCachedState].
			model modelSleep.
			cf := self getCollapsedFrame.
			(collapsedFrame isNil and: [SMxPreferences collapseWindowsInPlace not]) ifTrue:
				[collapsedFrame := cf].
			self bounds: cf].
	self layoutChanged! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 5/12/2009 17:38'!
collapsedExtent
	^ (SMxPreferences windowTitleFont widthOfString: labelString) + (self boxExtent x *4 + 20 ) @ (self labelHeight + 2)! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'di 5/20/1998 08:25'!
collapsedFrame
	^ collapsedFrame! !

!SMxSystemWindow methodsFor: 'drawing' stamp: 'ar 8/15/2001 21:55'!
colorForInsets
	^self paneColor colorForInsets! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:52'!
createBox
	"create a button with default to be used in the label area"

	| box |
	box := SMxIconicButton new.
	box
		color: Color transparent;
		target: self.
		
	^box! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'JuanVuletich 10/18/2010 15:17'!
createCloseBox
	^ self createBox labelGraphic: self class closeIcon;
		 extent: self boxExtent;
		 actionSelector: #closeBoxHit;
		 setBalloonText: 'close this window' translated! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'JuanVuletich 10/18/2010 15:17'!
createCollapseBox
	^ self createBox labelGraphic: self class collapseIcon;
		 extent: self boxExtent;
		 actionSelector: #collapseOrExpand;
		 setBalloonText: 'collapse this window'! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/12/2010 00:00'!
createExpandBox
	^ self createBox 
		
		labelGraphic: self class expandIcon;
	
		 extent: self boxExtent;
		 actWhen: #buttonUp;
		 actionSelector: #expandBoxHit;

		 setBalloonText: 'expand to full screen' translated! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/12/2010 00:00'!
createMenuBox
	^ self createBox 
		
		labelGraphic: self class menuIcon;

		 extent: self boxExtent;
		 actWhen: #buttonDown;
		 actionSelector: #offerWindowMenu;
		 setBalloonText: 'window menu' translated! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/7/2009 11:15'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/7/2009 11:12'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/7/2009 11:12'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'jmv 9/18/2009 00:24'!
delete
	| thisWorld |
	model okToChange ifFalse: [^self].
	thisWorld := self world.
	super delete.
	model windowIsClosing.
	model := nil.
	SMxSystemWindow noteTopWindowIn: thisWorld! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 4/27/2010 10:19'!
doFastFrameDrag: grabPoint
	"Do fast frame dragging from the given point"
	"modified from doFastFrameDrag."

	| offset newBounds outerWorldBounds |
	outerWorldBounds := self displayBounds.
	offset := outerWorldBounds origin - grabPoint.
	newBounds := outerWorldBounds newRectFrom: [:f | 
		Sensor cursorPoint + offset extent: outerWorldBounds extent].
	self position: (self internalizePositionToOwner: newBounds topLeft from: nil); comeToFront! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 4/27/2010 11:32'!
doFastWindowReframe: ptName

	| newBounds |
	"For fast display, only higlight the rectangle during loop"
	newBounds := bounds newRectButtonPressedDo: [:f | 
		f 
			withSideOrCorner: ptName
			setToPoint: (self internalizePositionFromWorld: Sensor cursorPoint)
			minExtent: self minimumExtent].
	self bounds: newBounds! !

!SMxSystemWindow methodsFor: 'drawing' stamp: 'jmv 5/19/2009 11:19'!
drawOn: aCanvas

	| titleColor |
	super drawOn: aCanvas.

	titleColor := self isTopWindow
		ifTrue: [ self paneColorToUse paler ]
		ifFalse: [ self paneColorToUse ].

	aCanvas
		frameAndFillRectangle: self titleAreaRect
		fillColor: titleColor
		borderWidth: borderWidth
		borderColor: titleColor.

	aCanvas
		drawString: labelString
		in: self labelRectangle
		font: SMxPreferences windowTitleFont
		color: Color black! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'ar 2/10/1999 04:20'!
expand
	self isCollapsed ifTrue:[self collapseOrExpand]! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 5/11/2009 23:51'!
expandBoxHit
	"The full screen expand box has been hit"

	isCollapsed
		ifTrue: [
			self hide.
			self collapseOrExpand.
			self unexpandedFrame ifNil: [ self unexpandedFrame: fullFrame. ].
			self fullScreen.
			^ self show].
	self unexpandedFrame
		ifNil: [
			self unexpandedFrame: fullFrame.
			self fullScreen]
		ifNotNil: [
			self bounds: self unexpandedFrame.
			self unexpandedFrame: nil]! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:32'!
extent: aPoint 
	"Set the receiver's extent to value provided. Respect my minimumExtent."

	| newExtent |
	newExtent := self isCollapsed
		ifTrue: [aPoint]
		ifFalse: [aPoint max: self minimumExtent].
	newExtent = self extent ifTrue: [^ self].

	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	isCollapsed
		ifTrue: [collapsedFrame := bounds]
		ifFalse: [fullFrame := bounds]! !

!SMxSystemWindow methodsFor: 'label' stamp: 'jmv 9/17/2009 09:53'!
externalName
	"Answer the name by which the receiver is known in the UI"

	^ 'SMxSystemWindow labelled: ', labelString! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 5/27/2006 17:00'!
fastFramingOn

	^ SMxPreferences fastDragWindowForMorphic! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 4/5/2009 15:43'!
fullScreen
	"Zoom Window to Full World size with possible DeskMargins"

	"SMxSystemWindow fullScreen"

	| left right possibleBounds |
	left := right := 0.
	self paneMorphs do: 
			[:pane | 
			((pane isKindOf: SMxScrollPane) and: [pane retractableScrollBar]) 
				ifTrue: [
					right := right max: SMxPreferences scrollbarThickness]].
	possibleBounds := (RealEstateAgent maximumUsableAreaInWorld: self world) 
				insetBy: (left @ 0 corner: right @ 0).
	SMxPreferences fullScreenLeavesDeskMargins 
		ifTrue: [possibleBounds := possibleBounds insetBy: 22].
	self bounds: possibleBounds! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 5/12/2009 17:19'!
getCollapsedFrame

	^SMxPreferences collapseWindowsInPlace
		ifTrue: [ bounds topLeft extent: self collapsedExtent]
		ifFalse: [ RealEstateAgent assignCollapseFrameFor: self ]! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'JuanVuletich 10/29/2010 11:20'!
getRawLabel
	"Pharo compatibility"
	^self topLeft extent:  (SMxPreferences windowTitleFont widthOfString: labelString) @ (self labelHeight + 2)! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 11/7/2008 12:36'!
handleListenEvent: evt

	evt isMouse ifFalse: [^self].
	evt hand hasSubmorphs ifTrue: [^self]. "still dragging"
	evt hand removeMouseListener: self.! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 5/17/2009 22:35'!
handlesMouseDown: evt 
	"If I am not the topWindow, then I will only respond to dragging by the title bar.
	Any other click will only bring me to the top"

	(self titleAreaRect containsPoint: evt cursorPoint)
		ifTrue: [^ true].
	^ false! !

!SMxSystemWindow methodsFor: 'events' stamp: 'ar 1/31/2001 21:02'!
handlesMouseOverDragging: evt
	^true! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'di 5/20/1998 09:14'!
initialExtent
	^ model initialExtent! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 10/7/2009 11:13'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	super initialize.
	labelString ifNil: [labelString := 'Untitled Window' translated].
	isCollapsed := false.
	paneMorphs := Array new.
	borderColor := #raised.
	borderWidth := 2.
	color := Color white.
	
	self wantsLabel ifTrue: [self initializeLabelArea].
	self 
		on: #mouseEnter
		send: #spawnReframeHandle:
		to: self.
	self 
		on: #mouseLeave
		send: #spawnReframeHandle:
		to: self.
	self extent: 300 @ 200.
	updatablePanes := Array new! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'jmv 5/17/2009 22:40'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."

	| spacing |
	spacing := self boxExtent x + 2.

	self
		addMorph: (self createCloseBox position: 2@2);
		addMorph: (self createMenuBox position: spacing+2@2);
		addMorph: (self createExpandBox position: spacing*2+2@2);
		addMorph: (self createCollapseBox position: spacing*3+2@2)! !

!SMxSystemWindow methodsFor: 'change reporting' stamp: 'jmv 5/17/2009 22:35'!
invalidateTitleArea
	
	bounds ifNotNil: [
		self invalidRect: self titleAreaRect ]! !

!SMxSystemWindow methodsFor: 'testing' stamp: 'jmv 12/5/2009 20:37'!
is: aSymbol
	^ aSymbol = #SMxSystemWindow or: [ super is: aSymbol ]! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'di 5/19/1998 09:34'!
isCollapsed
	^ isCollapsed! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'jmv 11/7/2008 13:15'!
isTopWindow

	^ self == TopWindow! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:33'!
justDroppedInto: aMorph event: anEvent
	isCollapsed
		ifTrue: [
			self position: ((self position max: 0@0) grid: 8@8).
			collapsedFrame := bounds]
		ifFalse: [
			fullFrame := bounds.
			TopWindow ~~ self ifTrue: [self activate]].
	^super justDroppedInto: aMorph event: anEvent! !

!SMxSystemWindow methodsFor: 'label' stamp: 'di 5/4/1998 23:42'!
label
	^ labelString! !

!SMxSystemWindow methodsFor: 'label' stamp: 'jmv 5/12/2009 17:43'!
labelHeight
	"Answer the height for the window label."

	^ self boxExtent y+1! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 5/17/2009 22:38'!
labelRectangle
	"Actually the whole label area"

	| tl br e x0 y0 x1 y1 |
	tl := bounds topLeft.
	br := bounds bottomRight.
	e := self boxExtent.
	x0 := tl x + ( e x * 4 + 14).
	y0 := tl y + 2.
	x1 := br x - 1.
	y1 := tl y + e y + 1.
	^x0@y0 corner: x1@y1
	
	
	
! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'JuanVuletich 10/29/2010 11:20'!
labelWidgetAllowance
	"Pharo compatibility"
	^ self boxExtent x *4 + 20! !

!SMxSystemWindow methodsFor: 'layout' stamp: 'JW 1/30/2001 22:45'!
layoutBounds
	"Bounds of pane area only."
	| box |

	box := super layoutBounds.
	^box withTop: box top + self labelHeight! !

!SMxSystemWindow methodsFor: 'drawing' stamp: 'jmv 4/29/2010 08:59'!
makeMeVisible 

	self world extent > (0@0) ifFalse: [^ self].

	(self position >= (0@0) and: [ self position < (self world extent-self labelHeight)]) ifTrue: [
		^ self "OK -- at least my top left is visible"].

	"window not on screen (probably due to reframe) -- move it now"
	self isCollapsed
		ifTrue: [self position: (RealEstateAgent assignCollapsePointFor: self)]
		ifFalse: [self position: (RealEstateAgent initialFrameFor: self initialExtent: self extent world: self world) topLeft].

! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 12/5/2009 20:39'!
makeSecondTopmost
	| aWorld nextWindow |
	aWorld := self world.
	nextWindow := aWorld submorphs 
				detect: [:m | (m is: #SMxSystemWindow) and: [m ~~ self]]
				ifNone: [^self].
	nextWindow activate.
	aWorld addMorph: self behind: nextWindow! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 3/10/2010 10:37'!
minPaneHeightForReframe
	^StrikeFont default height + 10! !

!SMxSystemWindow methodsFor: 'initialization' stamp: 'ar 8/15/2001 22:16'!
model: anObject
	super model: anObject.
	self paneColor: nil.! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 11/7/2008 13:55'!
mouseDown: evt
	"If we get #mouseDown:, essentially it means click on the label area. Activate self."

	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse: [
		evt hand releaseKeyboardFocus.
		self activate]! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 11/7/2008 12:44'!
mouseEnterDragging: evt

	(self ~~ TopWindow and:[evt hand hasSubmorphs]) ifTrue:[
		evt hand addMouseListener: self. "for drop completion on submorph"
	].! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 11/7/2008 12:36'!
mouseLeaveDragging: evt
	"lock children after drop operations"
	
	(self ~~ TopWindow and: [evt hand hasSubmorphs]) ifTrue:[
		evt hand removeMouseListener: self].! !

!SMxSystemWindow methodsFor: 'events' stamp: 'jmv 5/17/2009 22:35'!
mouseMove: evt
	"Handle a mouse-move event"

	| cp |
	cp := evt cursorPoint.
	self valueOfProperty: #clickPoint ifPresentDo: [:firstClick |
		((self titleAreaRect containsPoint: firstClick) and: [(cp dist: firstClick) > 3]) ifTrue: [
			"If this is a drag that started in the title bar, then pick me up"
			^ self isSticky ifFalse: [
				self fastFramingOn 
					ifTrue: [self doFastFrameDrag: firstClick]
					ifFalse: [evt hand grabMorph: self]]]]! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 5/8/2009 18:55'!
offerWindowMenu
	| aMenu |
	aMenu := self buildWindowMenu.
	model ifNotNil: [
		model addModelItemsToWindowMenu: aMenu].
	aMenu popUpInWorld: self world! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'ar 5/11/2001 23:46'!
openAsIsIn: aWorld
	"This msg and its callees result in the window being activeOnlyOnTop"
	aWorld addMorph: self.
	self activate.
	aWorld startSteppingSubmorphsOf: self.
! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'ar 5/11/2001 23:47'!
openInWorld: aWorld
	"This msg and its callees result in the window being activeOnlyOnTop"
	self bounds: (RealEstateAgent initialFrameFor: self world: aWorld).
	^self openAsIsIn: aWorld! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'ar 5/11/2001 23:47'!
openInWorld: aWorld extent: extent
	"This msg and its callees result in the window being activeOnlyOnTop"
	self position: (RealEstateAgent initialFrameFor: self world: aWorld) topLeft; extent: extent.
	^self openAsIsIn: aWorld! !

!SMxSystemWindow methodsFor: 'open/close' stamp: 'jmv 11/7/2006 21:12'!
openInWorldExtent: extent
	"This msg and its callees result in the window being activeOnlyOnTop"
	self openInWorld: self currentWorld extent: extent! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'JuanVuletich 10/18/2010 16:22'!
paneColor
	| cc |
	(cc := paneColor) ifNotNil: [^cc].
	Display depth > 2 
		ifTrue: [
			model ifNotNil: [
							cc := Color colorFrom: model smxWindowColor.
							cc := (cc = Color lightYellow or: [cc = Color white]) 
								ifTrue: [Color gray: 0.67]
								ifFalse: [cc adjustSaturation: -0.03 brightness: -0.2]].
			cc ifNil: [cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color]]].
	cc ifNil: [cc := Color white].
	self paneColor: cc.
	^cc! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'jmv 3/2/2010 17:17'!
paneColor: aColor
	paneColor := aColor.
	aColor
		ifNotNil: [ self color: aColor veryMuchLighter ].
	self adoptPaneColor: aColor.! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'ar 8/15/2001 22:14'!
paneColorToUse
	^ Display depth <= 2
		ifTrue:
			[Color white]
		ifFalse:
			[self paneColor]! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'jmv 3/2/2010 10:13'!
paneMorphSatisfying: aBlock
	^ paneMorphs detect: [:aPane | aBlock value: aPane] ifNone: nil! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'sw 2/16/1999 15:23'!
paneMorphs
	"Nominally private but a need for obtaining this from the outside arose"
	^ paneMorphs copy! !

!SMxSystemWindow methodsFor: 'events' stamp: 'di 10/23/1998 09:22'!
paneTransition: event
	"Mouse has entered or left a pane"
	^ self spawnReframeHandle: event! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'di 10/21/1998 16:12'!
paneWithLongestSide: sideBlock near: aPoint 
	| thePane theSide theLen box |
	theLen := 0.
	paneMorphs do:
		[:pane | box := pane bounds.
		box forPoint: aPoint closestSideDistLen:
			[:side :dist :len |
			(dist <= 5 and: [len > theLen]) ifTrue:
				[thePane := pane.
				theSide := side.
				theLen := len]]].
	sideBlock value: theSide.
	^ thePane! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'sma 2/5/2000 14:09'!
panelRect
	"Answer the area below the title bar which is devoted to panes."

	^ self innerBounds insetBy: (0 @ self labelHeight corner: 0 @ 0)! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'JuanVuletich 11/1/2010 15:37'!
passivate
	"Make me unable to respond to mouse and keyboard"

	| focus |
	focus := SimpleMorphicUIManager smxActiveHand keyboardFocus.
	focus ifNotNil: [
		(focus ownerThatIsA: SMxSystemWindow) == self
			ifTrue: [ SimpleMorphicUIManager smxActiveHand releaseKeyboardFocus ]].

	model modelSleep.
	
	self world ifNotNil:  "clean damage now, so dont merge this rect with new top window"
		[self world == SimpleMorphicUIManager smxWorld ifTrue: [self world displayWorld]].

	self invalidateTitleArea! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:33'!
position: newPos
	super position: newPos.
	isCollapsed
		ifTrue: [collapsedFrame := bounds]
		ifFalse: [fullFrame := bounds].
! !

!SMxSystemWindow methodsFor: 'printing' stamp: 'jmv 5/17/2009 08:03'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream
		print: labelString asString;
		nextPutAll: ')'! !

!SMxSystemWindow methodsFor: 'drawing' stamp: 'ar 8/16/2001 12:47'!
raisedColor
	^self paneColor raisedColor! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 9/17/2009 10:11'!
reframePanesAdjoining: growingPane along: side to: aDisplayBox 
	| delta newRect minDim theMin horiz |
	growingPane ifNil: [^ self].  "As from click outside"
	newRect := aDisplayBox.
	horiz := #(left right) includes: side.
	theMin := horiz ifTrue: [40] ifFalse: [self minPaneHeightForReframe].

	"First check that this won't make any pane smaller than theMin screen dots"
	minDim := (((paneMorphs select: [:pane | pane bounds bordersOn: growingPane bounds along: side])
		collect: [:pane | pane bounds adjustTo: newRect along: side]) copyWith: aDisplayBox)
			inject: 999 into:
				[:was :rect | was min: (horiz ifTrue: [rect width] ifFalse: [rect height])].
	"If so, amend newRect as required"
	minDim > theMin ifFalse:
		[delta := minDim - theMin.
		newRect := newRect withSide: side setTo: 
				((newRect perform: side) > (growingPane bounds perform: side)
					ifTrue: [(newRect perform: side) + delta]
					ifFalse: [(newRect perform: side) - delta])].

	"Now adjust all adjoining panes for real"
	paneMorphs do:
		[:pane | (pane bounds bordersOn: growingPane bounds along: side) ifTrue:
			[pane bounds: (pane bounds adjustTo: newRect along: side)]].
	"And adjust the growing pane itself"
	growingPane bounds: newRect.

	"Finally force a recomposition of the whole window"
	self setPaneRectsFromBounds.
	self extent: self extent! !

!SMxSystemWindow methodsFor: 'label' stamp: 'StephaneDucasse 12/11/2010 21:05'!
relabel
	| newLabel |
	newLabel := SMxFillInTheBlankMorph 
		request: 'New title for this window'
		initialAnswer: labelString.
	newLabel isEmpty ifTrue: [^self].
	self setLabel: newLabel! !

!SMxSystemWindow methodsFor: 'events' stamp: 'JW 2/2/2001 12:26'!
secondaryPaneTransition: event divider: aMorph
	"Mouse has entered or left a pane"
	^ self spawnOffsetReframeHandle: event divider: aMorph! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 12/5/2009 20:39'!
sendToBack
	| aWorld nextWindow |
	aWorld := self world.
	nextWindow := aWorld submorphs 
				detect: [:m | (m is: #SMxSystemWindow) and: [m ~~ self]]
				ifNone: [^self].
	nextWindow activate.
	aWorld addMorphBack: self! !

!SMxSystemWindow methodsFor: 'label' stamp: 'jmv 5/13/2009 17:33'!
setLabel: aString

	labelString := aString.
	self invalidateTitleArea! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'JW 2/1/2001 13:15'!
setPaneRectsFromBounds
	"Reset proportional specs from actual bounds, eg, after reframing panes"
	| layoutBounds box frame left right top bottom |
	layoutBounds := self layoutBounds.
	paneMorphs do:[:m|
		frame := m layoutFrame.
		box := m bounds.
		frame ifNotNil:[
			left := box left - layoutBounds left - (frame leftOffset ifNil:[0]).
			right := box right - layoutBounds left - (frame rightOffset ifNil:[0]).
			top := box top - layoutBounds top - (frame topOffset ifNil:[0]).
			bottom := box bottom - layoutBounds top - (frame bottomOffset ifNil:[0]).
			frame leftFraction: (left / layoutBounds width asFloat).
			frame rightFraction: (right / layoutBounds width asFloat).
			frame topFraction: (top / layoutBounds height asFloat).
			frame bottomFraction: (bottom / layoutBounds height asFloat).
		].
	].! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'jmv 3/2/2010 10:13'!
setUpdatablePanesFrom: getSelectors
	| aList aPane possibles |
	"Set my updatablePanes inst var to the list of panes which are list panes with the given get-list selectors.  Order is important here!!  Note that the method is robust in the face of panes not found, but a warning is printed in the transcript in each such case"

	aList := OrderedCollection new.
	possibles := OrderedCollection new.
	self allMorphsDo: [ :pane | 
		(pane isKindOf: SMxPluggableListMorph) ifTrue: [
			possibles add: pane.
		].
	].

	getSelectors do: [:sel | 
		aPane := possibles detect: [ :pane | pane getListSelector == sel] ifNone: nil.
		aPane
			ifNotNil:
				[aList add: aPane]
			ifNil:
				[Transcript cr; show: 'Warning: pane ', sel, ' not found.']].
	updatablePanes := aList asArray! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 4/27/2010 11:19'!
setWindowColor
	"Allow the user to select a new basic color for the window"

	SMxColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #setWindowColor:;
		originalColor: self paneColorToUse;
		putUpFor: self
			near: self fullDisplayBounds! !

!SMxSystemWindow methodsFor: 'menu' stamp: 'jmv 10/7/2009 11:14'!
setWindowColor: incomingColor
	| existingColor aColor |
	incomingColor ifNil: [^ self].  "it happens"
	aColor := incomingColor asNontranslucentColor.
	(aColor = SMxColorPickerMorph perniciousBorderColor 
		or: [aColor = Color black]) ifTrue: [^ self].
	existingColor := self paneColorToUse.
	existingColor ifNil: [^ Beeper beep].
	self paneColor: aColor.
	self changed! !

!SMxSystemWindow methodsFor: 'testing' stamp: 'ar 12/2/2001 21:43'!
shouldDropOnMouseUp
	"Return true for consistency with fastdrag"
	^true! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 3/3/2010 10:45'!
spawnOffsetReframeHandle: event divider: divider
	"The mouse has crossed a secondary (fixed-height) pane divider.  Spawn a reframe handle."
	"Only supports vertical adjustments."

	| siblings topAdjustees bottomAdjustees topOnly bottomOnly resizer pt delta minY maxY cursor minFreeHeight |
	owner ifNil: [^self	"Spurious mouseLeave due to delete"].
	self isCollapsed ifTrue: [^self].
	((self world ifNil: [^self]) firstSubmorph isKindOf: SMxNewHandleMorph) 
		ifTrue: [^self	"Prevent multiple handles"].
	divider layoutFrame ifNil: [^self].
	(#(#top #bottom) includes: divider resizingEdge) ifFalse: [^self].
	siblings := divider owner submorphs select: [:m | m layoutFrame notNil].
	divider resizingEdge = #bottom 
		ifTrue: 
			[cursor := Cursor resizeTop.
			topAdjustees := siblings select: 
							[:m | 
							m layoutFrame topFraction = divider layoutFrame bottomFraction 
								and: [m layoutFrame topOffset >= divider layoutFrame topOffset]].
			bottomAdjustees := siblings select: 
							[:m | 
							m layoutFrame bottomFraction = divider layoutFrame topFraction 
								and: [m layoutFrame bottomOffset >= divider layoutFrame topOffset]]].
	divider resizingEdge = #top 
		ifTrue: 
			[cursor := Cursor resizeBottom.
			topAdjustees := siblings select: 
							[:m | 
							m layoutFrame topFraction = divider layoutFrame bottomFraction 
								and: [m layoutFrame topOffset <= divider layoutFrame bottomOffset]].
			bottomAdjustees := siblings select: 
							[:m | 
							m layoutFrame bottomFraction = divider layoutFrame topFraction 
								and: [m layoutFrame bottomOffset <= divider layoutFrame bottomOffset]]].
	topOnly := topAdjustees copyWithoutAll: bottomAdjustees.
	bottomOnly := bottomAdjustees copyWithoutAll: topAdjustees.
	(topOnly isEmpty or: [bottomOnly isEmpty]) ifTrue: [^self].
	minFreeHeight := StrikeFont default height + 6.
	minY := bottomOnly inject: -9999 into: [ :y :m |
		y max: m top - m bottom + minFreeHeight + divider bottom ].
	maxY := topOnly inject: 9999 into: [ :y :m | 
		y min: m bottom - m top - minFreeHeight  + divider top].
	pt := event cursorPoint.
	resizer := SMxNewHandleMorph new 
				followHand: event hand
				forEachPointDo: 
					[:p | 
					delta := (p y min: maxY max: minY) - pt y.
					topAdjustees 
						do: [:m | m layoutFrame topOffset: m layoutFrame topOffset + delta].
					bottomAdjustees 
						do: [:m | m layoutFrame bottomOffset: m layoutFrame bottomOffset + delta].
					divider layoutChanged.
					pt := pt + delta]
				lastPointDo: [:p | ]
				withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 8/23/2010 11:23'!
spawnPaneFrameHandle: event 
	| resizer localPt side growingPane newBounds adjoiningPanes limit cursor |
	(self world firstSubmorph isKindOf: SMxNewHandleMorph) 
		ifTrue: [^self	"Prevent multiple handles"].
	((self innerBounds withHeight: self labelHeight + 4) 
		containsPoint: event cursorPoint) 
			ifTrue: [^self	"in label or top of top pane"].
	growingPane := self paneWithLongestSide: [:s | side := s]
				near: event cursorPoint.
	growingPane ifNil: [^self].
	"don't resize pane side coincident with window side - RAA 5 jul 2000"
	(growingPane perform: side) = (self innerBounds perform: side) 
		ifTrue: [^self].
	(side == #top and: [growingPane top = self panelRect top]) ifTrue: [^self].
	adjoiningPanes := paneMorphs 
				select: [ :pane | pane bounds bordersOn: growingPane bounds along: side ].
	limit := adjoiningPanes isEmpty 
				ifFalse: [
					(adjoiningPanes collect: [:pane | pane bounds perform: side]) 
						perform: ((#(#top #left) includes: side) ifTrue: [#max] ifFalse: [#min])]
				ifTrue: [ bounds perform: side].
	cursor := Cursor resizeForEdge: side.
	resizer := SMxNewHandleMorph new
				followHand: event hand
					forEachPointDo: [ :p | 
						localPt := self internalizePositionFromWorld: p.
						newBounds := growingPane bounds 
							withSideOrCorner: side
							setToPoint: localPt
							minExtent: 40 @ self minPaneHeightForReframe
							limit: limit.
						self fastFramingOn 
							ifTrue: [
								"For fast display, only higlight the rectangle during loop"
								Cursor currentCursor == cursor 
									ifFalse: [
										event hand
											visible: false;
											refreshWorld;
											visible: true.
										cursor show].
								newBounds := growingPane bounds newRectButtonPressedDo: [ :f | 
									growingPane bounds 
										withSideOrCorner: side
										setToPoint: (self internalizePositionFromWorld: Sensor cursorPoint)
										minExtent: 40 @ self minPaneHeightForReframe
										limit: limit ]].
								self 
									reframePanesAdjoining: growingPane
									along: side
									to: newBounds]
					lastPointDo: [:p | ]
					withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jmv 8/23/2010 11:24'!
spawnReframeHandle: event
	"The mouse has crossed a pane border.  Spawn a reframe handle."

	| resizer localPt pt ptName newBounds cursor |
	owner ifNil: [^self	"Spurious mouseLeave due to delete"].
	self isCollapsed ifTrue: [^self].
	((self world ifNil: [^self]) firstSubmorph isKindOf: SMxNewHandleMorph) 
		ifTrue: [^self	"Prevent multiple handles"].
	pt := event cursorPoint.
	"prevent spurios mouse leave when dropping morphs"
	owner 
		morphsInFrontOf: self
		overlapping: (pt - 2 extent: 4 @ 4)
		do: [:m | (m is: #SMxHandMorph) ifFalse: [(m fullContainsPoint: pt) ifTrue: [^self]]].
	bounds forPoint: pt
		closestSideDistLen: [ :side :dist :len | 
			"Check for window side adjust"
			dist <= 2 ifTrue: [ptName := side]].
	ptName ifNil: ["Check for pane border adjust"

			^self spawnPaneFrameHandle: event].
	#(#topLeft #bottomRight #bottomLeft #topRight) do: [ :corner | 
			"Check for window corner adjust"
			(pt dist: (bounds perform: corner)) < 20 ifTrue: [ptName := corner]].
	cursor := Cursor resizeForEdge: ptName.
	resizer := SMxNewHandleMorph new
				followHand: event hand
					forEachPointDo: [ :p | 
						localPt := self internalizePositionFromWorld: p.
						newBounds := bounds 
									withSideOrCorner: ptName
									setToPoint: localPt
									minExtent: self minimumExtent.
						self fastFramingOn 
							ifTrue: [
								Cursor currentCursor == cursor 
									ifFalse: [
										event hand
											visible: false;
											refreshWorld;
											visible: true.
										cursor show].
								self doFastWindowReframe: ptName]
							ifFalse: [
								self bounds: newBounds]]
					lastPointDo: [ :p | ]
					withCursor: cursor.
	event hand world addMorphInLayer: resizer.
	resizer startStepping! !

!SMxSystemWindow methodsFor: 'stepping' stamp: 'di 4/9/2001 17:04'!
stepAt: millisecondClockValue
	"If the receiver is not collapsed, step it, after first stepping the model."

	(isCollapsed not or: [self wantsStepsWhenCollapsed]) ifTrue:
		[model ifNotNil: [model stepAt: millisecondClockValue in: self].
		super stepAt: millisecondClockValue "let player, if any, step"]

"Since this method ends up calling step, the model-stepping logic should not be duplicated there."! !

!SMxSystemWindow methodsFor: 'stepping' stamp: 'sw 10/19/1999 08:22'!
stepTime
	^ model
		ifNotNil:
			[model stepTimeIn: self]
		ifNil:
			[200] "milliseconds"! !

!SMxSystemWindow methodsFor: 'geometry' stamp: 'jmv 5/17/2009 22:35'!
titleAreaRect

	^ self innerBounds withHeight: self labelHeight.
! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/29/2001 23:06'!
unexpandedFrame
	"Return the frame size of an unexpanded window"

	^ self valueOfProperty: #unexpandedFrame! !

!SMxSystemWindow methodsFor: 'resize/collapse' stamp: 'jlb 5/29/2001 23:07'!
unexpandedFrame: aRectangle
	"Set the frame size of an unexpanded window"

	^ self setProperty: #unexpandedFrame toValue: aRectangle! !

!SMxSystemWindow methodsFor: 'panes' stamp: 'sw 10/19/1999 09:53'!
updatablePanes
	"Answer the list of panes, in order, which should be sent the #verifyContents message"
	^ updatablePanes ifNil: [updatablePanes := #()]! !

!SMxSystemWindow methodsFor: 'label' stamp: 'nk 4/26/2003 11:31'!
update: aSymbol
	aSymbol = #relabel
		ifTrue: [^ model ifNotNil: [ self setLabel: model labelString ] ].! !

!SMxSystemWindow methodsFor: 'top window' stamp: 'nk 8/6/2003 10:53'!
updatePanesFromSubmorphs
	"Having removed some submorphs, make sure this is reflected in my paneMorphs."
	paneMorphs := paneMorphs select: [ :pane | submorphs includes: pane ].! !

!SMxSystemWindow methodsFor: 'label' stamp: 'sw 5/18/2001 16:01'!
wantsLabel
	"Answer whether the receiver wants a label.  At the moment, the only way to suppress this at initialization is to call SMxSystemWindow newWithoutLabel"

	^ (self hasProperty: #suppressLabel) not! !

!SMxSystemWindow methodsFor: 'stepping' stamp: 'jmv 1/6/2005 23:43'!
wantsSteps
	"Return true if the model wants its view to be stepped.  For an open system window, we give the model to offer an opinion"

	^ isCollapsed not and: [model wantsStepsIn: self]! !

!SMxSystemWindow methodsFor: 'stepping' stamp: 'di 4/9/2001 16:45'!
wantsStepsWhenCollapsed
	"Default is not to bother updating collapsed windows"

	^ false! !

!SMxSystemWindow methodsFor: 'events' stamp: 'ar 9/18/2000 18:34'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph"
	^aMorph isWorldMorph or:[SMxPreferences systemWindowEmbedOK]! !

SMxSystemWindow subclass: #SMxToolWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools'!

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:14'!
addFullPanesTo: window from: aCollection

	| frame |
	aCollection do: [ :each |
		frame := SMxLayoutFrame 
			fractions: each second 
			offsets: each third.
		window addMorph: each first fullFrame: frame.
	]! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:46'!
buttonToTriggerIn: aFileList for: service
	"Answer a button that will trigger the receiver service in a file list"

	| aButton |
	aButton := SMxPluggableButtonMorph 
				model: service
				stateGetter: nil
				action: #performServiceFor:.
	aButton arguments: { 
				aFileList}.
	aButton
		color: Color transparent;
		label: service buttonLabel;
		askBeforeChanging: true.
	aButton color: aFileList class smxWindowColor duller paler.
	aButton setBalloonText: service description.
	^aButton! !

!SMxToolWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/29/2010 10:58'!
explorer: anObjectExplorer for: anObject withLabel: label
	| window listMorph |
	anObjectExplorer rootObject: anObject.
	window := (SMxSystemWindow labelled: label) model: anObjectExplorer.
	window addMorph: (listMorph := SMxSimpleHierarchicalListMorph 
						model: anObjectExplorer
						listGetter: #getList
						indexGetter: #getCurrentSelection
						indexSetter: #noteNewSelection:
						menuGetter: #genericMenu:
						keystrokeAction: #explorerKey:from:)
		frame: (0 @ 0 corner: 1 @ 0.8).
	window 
		addMorph: ((SMxPluggableTextMorph 
				model: anObjectExplorer
				editorClass: anObjectExplorer smxEditorClass
				textGetter: #trash
				textSetter: #trash:
				selectionGetter: #contentsSelection
				menuGetter: #smxPaneMenu:shifted:editorClass:) askBeforeDiscardingEdits: false)
		frame: (0 @ 0.8 corner: 1 @ 1).
	listMorph autoDeselect: false.
	^window! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:30'!
morphicDirectoryTreePaneForFileList: aFileList

	^(SMxSimpleHierarchicalListMorph 
		model: aFileList
		listGetter: #initialDirectoryList
		indexGetter: #currentDirectorySelected
		indexSetter: #setSelectedDirectoryTo:
		menuGetter: #volumeMenu:
		keystrokeAction: nil)
			autoDeselect: false;
			enableDrag: false;
			enableDrop: true;
			yourself
		! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:31'!
morphicFileContentsPaneForFileList: aFileList

	^SMxPluggableTextMorph 
		model: aFileList 
		editorClass: aFileList smxEditorClass
		textGetter: #contents 
		textSetter: #put:
		selectionGetter: #contentsSelection 
		menuGetter: #fileContentsMenu:shifted:

		! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:30'!
morphicFileListPaneForFileList: aFileList

	^(SMxPluggableListMorph 
		model: aFileList 
		listGetter: #fileList 
		indexGetter: #fileListIndex
		indexSetter: #fileListIndex: 
		menuGetter: #fileListMenu:)
			enableDrag: true;
			enableDrop: false;
			yourself

! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:19'!
morphicPatternPaneForFileList: aFileList

	^SMxPluggableTextMorph 
		model: aFileList 
		editorClass: aFileList smxEditorClass
		textGetter: #pattern 
		textSetter: #pattern:! !

!SMxToolWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/28/2010 16:47'!
openFileList: aFileList

	| window fileListBottom midLine fileListTopOffset |
	window := (SMxSystemWindow labelled: aFileList directory pathName) model: aFileList.

	fileListTopOffset := (StrikeFont default pointSize * 2) + 14.
	fileListBottom := 0.4.
	midLine := 0.4.
	
	self addFullPanesTo: window from: {
		{self morphicPatternPaneForFileList: aFileList.
			0@0 corner: 0.3@0. 							0@0 corner: 0@fileListTopOffset}.
		{self optionalButtonRowForFileList: aFileList.
			0.3 @ 0 corner: 1@0. 							0@0 corner: 0@fileListTopOffset}.
		{self morphicDirectoryTreePaneForFileList: aFileList.
			0@0 corner: midLine@fileListBottom. 			0@fileListTopOffset corner: 0@0}.
		{self morphicFileListPaneForFileList: aFileList.
			midLine @ 0 corner: 1@fileListBottom. 			0@fileListTopOffset corner: 0@0}.
		{self morphicFileContentsPaneForFileList: aFileList.
			0@fileListBottom corner: 1@1. 					nil}.
	}.

	aFileList postOpen.
	^ window openInWorld! !

!SMxToolWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/29/2010 10:59'!
openInspector: inspectorClass asMorphOn: anObject withLabel: aLabel 
	"(Inspector openAsMorphOn: SystemOrganization withLabel: 'Test') openInWorld"
	| window inspector |
	inspector := inspectorClass inspect: anObject.
	window := (SMxSystemWindow labelled: aLabel) model: inspector.
	window addMorph: (
		SMxPluggableListMorph new
			doubleClickSelector: #inspectSelection;
			model: inspector 
			listGetter: #fieldList
			indexGetter: #selectionIndex
			indexSetter: #toggleIndex:
			menuGetter: #fieldListMenu:
			keystrokeAction: #inspectorKey:from:)
		frame: (0@0 corner: inspectorClass horizontalDividerProportion @ inspectorClass verticalDividerProportion).
	window addMorph: (SMxPluggableTextMorph
			model: inspector 
			editorClass: inspector smxEditorClass 
			textGetter: #contents 
			textSetter: #accept:
			selectionGetter: #contentsSelection 
			menuGetter: #smxPaneMenu:shifted:editorClass:)
		frame: (inspectorClass horizontalDividerProportion @0 corner: 1@inspectorClass verticalDividerProportion).
	window addMorph: ((SMxPluggableTextMorph 
			model: inspector 
			editorClass: inspector smxEditorClass
			textGetter: #trash 
			textSetter: #trash:
			selectionGetter: #contentsSelection 
			menuGetter: #smxPaneMenu:shifted:editorClass:)
					askBeforeDiscardingEdits: false)
		frame: (0@inspectorClass verticalDividerProportion corner: 1@1).
	window setUpdatablePanesFrom: #(fieldList).
	^ window! !

!SMxToolWindow class methodsFor: 'public' stamp: 'JuanVuletich 10/26/2010 15:12'!
openProcessBrowserAsMorph: aProcessBrowser
	"Create a pluggable version of aProcessBrowser, answer a window"
	| window aTextMorph |
	window := SMxSystemWindow new model: aProcessBrowser.

	aProcessBrowser deferredMessageRecipient: SMxWorldState.
	window
		addMorph: ((SMxPluggableListMorph
				model: aProcessBrowser
				listGetter: #processNameList
				indexGetter: #processListIndex
				indexSetter: #processListIndex:
				menuGetter: #processListMenu:
				keystrokeAction: #processListKey:from:)
				enableDragNDrop: false)
		frame: (0 @ 0 extent: 0.5 @ 0.5).
	window
		addMorph: ((SMxPluggableListMorph
				model: aProcessBrowser
				listGetter: #stackNameList
				indexGetter: #stackListIndex
				indexSetter: #stackListIndex:
				menuGetter: #stackListMenu:
				keystrokeAction: #stackListKey:from:)
				enableDragNDrop: false)
		frame: (0.5 @ 0.0 extent: 0.5 @ 0.5).
	aTextMorph := SMxPluggableTextMorph
				model: aProcessBrowser
				editorClass: TextEditor
				textGetter: #selectedMethod
				textSetter: nil
				selectionGetter: nil
				menuGetter: nil.
	aTextMorph askBeforeDiscardingEdits: false.
	window
		addMorph: aTextMorph
		frame: (0 @ 0.5 corner: 1 @ 1).
	window setUpdatablePanesFrom: #(#processNameList #stackNameList ).
	(window setLabel: 'Process Browser') openInWorld.
	aProcessBrowser mayBeStartCPUWatcher.
	^ window! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:25'!
optionalButtonRowForFileList: aFileList

	| row |
	row := SMxAlignmentMorph proportional.
	row setProperty: #buttonRow toValue: true.  "Used for dynamic retrieval later on"
	self updateButtonRow: row forFileList: aFileList.
	^row! !

!SMxToolWindow class methodsFor: 'gui building' stamp: 'JuanVuletich 10/28/2010 16:26'!
updateButtonRow: row forFileList: aFileList
	"Dynamically update the contents of the button row, if any."

	| buttons |
	row removeAllMorphs.
	buttons := OrderedCollection new.
	aFileList universalButtonServices do: [ :service |
		buttons add: (self buttonToTriggerIn: aFileList for: service) ].
	aFileList dynamicButtonServices do: [ :service | 
		buttons add: (self buttonToTriggerIn: aFileList for: service).
		service addDependent: aFileList].
	row addInRow: buttons.! !

SMxBorderedMorph subclass: #SMxPolygonMorph
	instanceVariableNames: 'vertices closed filledForm arrows arrowForms smoothCurve curveState borderDashSpec handles borderForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxPolygonMorph commentStamp: '<historical>' prior: 0!
This class combines the old Polygon and Curve classes.

The 1-bit fillForm to make display and containment tests reasonably fast.  However, this functionality is in the process of being supplanted by balloon capabilities, which should eventually provide anti-aliasing as well.

Warning: Balloon was removed from Cuis.!

SMxPolygonMorph subclass: #SMxBalloonMorph
	instanceVariableNames: 'target offsetFromTarget'
	classVariableNames: 'BalloonColor BalloonFont'
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxBalloonMorph commentStamp: '<historical>' prior: 0!
A balloon with text used for the display of explanatory information.

Balloon help is integrated into Morphic as follows:
If a SMxMorph has the property #balloonText, then it will respond to #showBalloon by adding a text balloon to the world, and to #deleteBalloon by removing the balloon.

Moreover, if mouseOverEnabled is true (see class msg), then the Hand will arrange to cause display of the balloon after the mouse has lingered over the morph for a while, and removal of the balloon when the mouse leaves the bounds of that morph.  In any case, the Hand will attempt to remove any such balloons before handling mouseDown events, or displaying other balloons.

Balloons should not be duplicated with veryDeepCopy unless their target is also duplicated at the same time.!

!SMxBalloonMorph class methodsFor: 'utility' stamp: 'sma 11/11/2000 14:59'!
balloonColor
	^ BalloonColor! !

!SMxBalloonMorph class methodsFor: 'utility' stamp: 'sw 1/31/2000 15:43'!
balloonFont
	^ BalloonFont! !

!SMxBalloonMorph class methodsFor: 'utility' stamp: 'JuanVuletich 10/10/2010 08:12'!
chooseBalloonFont
	"SMxBalloonMorph chooseBalloonFont"

	SMxPreferences chooseFontWithPrompt:  'Select the font to be
used for balloon help'
		andSendTo: self withSelector: #setBalloonFontTo: highlight: BalloonFont! !

!SMxBalloonMorph class methodsFor: 'private' stamp: 'jmv 4/5/2010 11:23'!
getBestLocation: vertices for: morph corner: cornerName
	"Experimental. Just use the hand position. This should be cleaned up and perhaps enhanced."
	^vertices collect: [ :p | p + morph activeHand position - vertices first ]! !

!SMxBalloonMorph class methodsFor: 'private' stamp: 'JuanVuletich 10/13/2010 09:30'!
getTextMorph: aStringOrMorph for: balloonOwner
	"Construct text morph."
	| m text |
	(aStringOrMorph is: #SMxMorph)
		ifTrue: [ m := aStringOrMorph ]
		ifFalse: [
			text := balloonOwner balloonFont
				ifNil: [ Text string: aStringOrMorph attribute: TextAlignment centered ]
				ifNotNil: [ :fontToUse |
					Text string: aStringOrMorph attributes: {TextFontReference toFont: fontToUse. TextAlignment centered} ].
			m := SMxTextMorph new contents: text].
	^ m! !

!SMxBalloonMorph class methodsFor: 'private' stamp: 'sma 12/23/1999 15:34'!
getVertices: bounds
	"Construct vertices for a balloon up and to left of anchor"

	| corners |
	corners := bounds corners atAll: #(1 4 3 2).
	^ (Array
		with: corners first + (0 - bounds width // 3 @ 0)
		with: corners first + (0 - bounds width // 6 @ (bounds height // 2))) , corners! !

!SMxBalloonMorph class methodsFor: 'utility' stamp: 'sw 1/31/2000 15:40'!
setBalloonFontTo: aFont
	aFont ifNotNil: [BalloonFont := aFont]! !

!SMxBalloonMorph class methodsFor: 'instance creation' stamp: 'sma 12/23/1999 20:05'!
string: str for: morph
	^ self string: str for: morph corner: #bottomLeft! !

!SMxBalloonMorph class methodsFor: 'instance creation' stamp: 'jmv 4/27/2010 11:25'!
string: str for: morph corner: cornerName 
	"Make up and return a balloon for morph. Find the quadrant that 
	clips the text the least, using cornerName as a tie-breaker. tk 9/12/97"
	| tm vertices instance |
	tm := self getTextMorph: str for: morph.
	vertices := self getVertices: tm displayBounds.
	vertices := self
				getBestLocation: vertices
				for: morph
				corner: cornerName.
	instance := self new
		color: morph balloonColor;
		 setVertices: vertices;
		 addMorph: tm;
		 setTarget: morph.
	tm center: instance adjustedCenter.
	^instance! !

!SMxBalloonMorph methodsFor: 'menus' stamp: 'sw 2/7/2000 01:49'!
adjustedCenter
	"This horizontal adjustment is needed because we want the interior SMxTextMorph to be centered within the visual balloon rather than simply within the SMxBalloonMorph's bounding box.  Without this, balloon-help text would be a bit off-center"

	^ self center + (offsetFromTarget x sign * (5 @ 0))! !

!SMxBalloonMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:33'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!SMxBalloonMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxBalloonMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ self class balloonColor! !

!SMxBalloonMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:20'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self beSmoothCurve.

	offsetFromTarget := 0 @ 0! !

!SMxBalloonMorph methodsFor: 'WiW support' stamp: 'RAA 6/27/2000 18:07'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^5		"Balloons are very front-like things"! !

!SMxBalloonMorph methodsFor: 'initialization' stamp: 'jmv 4/27/2010 11:25'!
popUpForHand: aHand
	"Pop up the receiver as balloon help for the given hand"

	self lock.
	self doLayoutIfNeeded. "force layout"
	self setProperty: #morphicLayerNumber toValue: self morphicLayerNumber.
	aHand world addMorphFront: self.
	aHand balloonHelp: self.
! !

!SMxBalloonMorph methodsFor: 'private' stamp: 'sma 12/23/1999 14:06'!
setTarget: aMorph
	(target := aMorph) ifNotNil: [offsetFromTarget := self position - target position]! !

!SMxBalloonMorph methodsFor: 'stepping and presenter' stamp: 'sma 12/23/1999 14:05'!
step
	"Move with target."

	target ifNotNil: [self position: target position + offsetFromTarget].
! !

!SMxBalloonMorph methodsFor: 'testing' stamp: 'di 9/18/97 10:10'!
stepTime
	^ 0  "every cycle"! !

SMxPolygonMorph subclass: #SMxCurveMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxCurveMorph commentStamp: '<historical>' prior: 0!
This is really only a shell for creating Shapes with smooth outlines.!

!SMxCurveMorph class methodsFor: 'parts bin' stamp: 'tk 11/14/2001 17:47'!
arrowPrototype

	| aa |
	aa := SMxPolygonMorph vertices: (Array with: 5@40 with: 5@8 with: 35@8 with: 35@40) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	aa beSmoothCurve; makeOpen; makeForwardArrow.		"is already open"
	aa dashedBorder: {10. 10. Color red}.
		"A dash spec is a 3- or 5-element array with
		{ length of normal border color.
		length of alternate border color.
		alternate border color}"
	aa computeBounds.
	^ aa! !

!SMxCurveMorph methodsFor: 'initialization' stamp: 'di 9/10/2000 14:28'!
initialize

	super initialize.
	self beSmoothCurve.
! !

SMxPolygonMorph subclass: #SMxLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxLineMorph commentStamp: '<historical>' prior: 0!
This is really only a shell for creating single-segment straight-line Shapes.!

!SMxLineMorph class methodsFor: 'as yet unclassified' stamp: 'di 8/20/2000 12:18'!
from: startPoint to: endPoint color: lineColor width: lineWidth

	^ SMxPolygonMorph vertices: {startPoint. endPoint}
			color: Color black borderWidth: lineWidth borderColor: lineColor! !

!SMxLineMorph class methodsFor: 'instance creation' stamp: 'di 8/20/2000 12:16'!
new
	^ self from: 0@0 to: 50@50 color: Color black width: 2! !

!SMxPolygonMorph class methodsFor: 'instance creation' stamp: 'sw 10/3/2002 02:19'!
arrowPrototype
	"Answer an instance of the receiver that will serve as a prototypical arrow"

	| aa |
	aa := self new. 
	aa vertices: (Array with: 0@0 with: 40@40) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	aa setProperty: #noNewVertices toValue: true.
	aa makeForwardArrow.		"is already open"
	aa computeBounds.
	^ aa! !

!SMxPolygonMorph class methodsFor: 'instance creation' stamp: 'di 10/18/2001 03:56'!
fromHand: hand
	"Let the user draw a polygon, clicking at each vertex, and ending
		by clicking within 5 of the first point..."
	| p1 poly oldVerts pN opposite |
	Cursor crossHair showWhile:
		[[Sensor anyButtonPressed] whileFalse:
			[self currentWorld displayWorldSafely; runStepMethods].
		p1 := Sensor cursorPoint].
	opposite := (Display colorAt: p1) negated.
	opposite = Color transparent ifTrue: [opposite := Color red].
	(poly := SMxLineMorph from: p1 to: p1 color: opposite width: 2) openInWorld.
	oldVerts := {p1}.
	self currentWorld displayWorldSafely; runStepMethods.
	[true] whileTrue:
		[[Sensor anyButtonPressed] whileTrue:
			[pN := Sensor cursorPoint.
			poly setVertices: (oldVerts copyWith: pN).
			self currentWorld displayWorldSafely; runStepMethods].
		(oldVerts size > 1 and: [(pN dist: p1) < 5]) ifTrue:
			[hand position: Sensor cursorPoint.  "Done -- update hand pos"
			^ (poly setVertices: (poly vertices copyWith: p1)) delete].
		oldVerts := poly vertices.
		[Sensor anyButtonPressed] whileFalse:
			[pN := Sensor cursorPoint.
			poly setVertices: (oldVerts copyWith: pN).
			self currentWorld displayWorldSafely; runStepMethods]].
! !

!SMxPolygonMorph class methodsFor: 'instance creation' stamp: 'di 9/7/2000 17:05'!
vertices: verts color: c borderWidth: bw borderColor: bc
	^ self basicNew beStraightSegments vertices: verts color: c borderWidth: bw borderColor: bc! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'jmv 4/13/2009 14:41'!
addCustomMenuItems: aMenu hand: aHandMorph
	| lineName |
	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addUpdating: #handlesShowingPhrase target: self action: #showOrHideHandles.
	vertices size > 2 ifTrue:
		[aMenu addUpdating: #openOrClosePhrase target: self action: #makeOpenOrClosed.
		lineName := (closed ifTrue: ['outline'] ifFalse: ['line']) translated.
		self isCurve
			ifTrue: [aMenu add: ('make segmented {1}' translated format: {lineName}) action: #toggleSmoothing]
			ifFalse: [aMenu add: ('make smooth {1}' translated format: {lineName}) action: #toggleSmoothing]]. 
	aMenu add: 'specify dashed line' translated action:  #specifyDashedLine.

	self isOpen ifTrue: [
		aMenu addLine.
		aMenu addWithLabel: '---' enablement: [self isOpen and: [arrows ~~ #none]] action:  #makeNoArrows.
		aMenu addWithLabel: '-->' enablement: [self isOpen and: [arrows ~~ #forward]] action:  #makeForwardArrow.
		aMenu addWithLabel: '<--' enablement: [self isOpen and: [arrows ~~ #back]] action:  #makeBackArrow.
		aMenu addWithLabel: '<->' enablement: [self isOpen and: [arrows ~~ #both]] action:  #makeBothArrows ]! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:32'!
addHandles
	| handle newVert tri |
	self removeHandles.
	handles := OrderedCollection new.
	tri := Array with: 0 @ -4 with: 4@3 with: -3@3.
	vertices withIndexDo:
		[:vertPt :vertIndex |
		handle := SMxEllipseMorph newBounds: (Rectangle center: vertPt extent: 8@8)
				color: Color yellow.
		handle on: #mouseMove send: #dragVertex:event:fromHandle:
				to: self withValue: vertIndex.
		handle on: #mouseUp send: #dropVertex:event:fromHandle:
				to: self withValue: vertIndex.
		self addMorph: handle.
		handles addLast: handle.
		(closed or: [vertIndex < vertices size]) ifTrue:
			[newVert := SMxPolygonMorph
					vertices: (tri collect: [:p | p + (vertPt + (vertices atWrap: vertIndex+1) // 2)])
					color: Color green borderWidth: 1 borderColor: Color black.
			newVert on: #mouseDown send: #newVertex:event:fromHandle:
					to: self withValue: vertIndex.
			self addMorph: newVert.
			handles addLast: newVert]].
	smoothCurve ifTrue: [self updateHandles; layoutChanged].
	self changed! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 12/17/1998 12:31'!
arrowForms
	"ArrowForms are computed only upon demand"
	arrowForms ifNotNil: [^ arrowForms].

	arrowForms := Array new.
	(closed or: [arrows == #none or: [vertices size < 2]]) ifTrue:
		[^ arrowForms].
	(arrows == #forward or: [arrows == #both]) ifTrue:
		[arrowForms := arrowForms copyWith:
			(self computeArrowFormAt: vertices last from: self nextToLastPoint)].
	(arrows == #back or: [arrows == #both]) ifTrue:
		[arrowForms := arrowForms copyWith:
			(self computeArrowFormAt: vertices first from: self nextToFirstPoint)].
	^ arrowForms! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'sw 9/24/2002 19:23'!
arrowLength: aLength
	"Assumes that I have exactly two vertices"

	| theta horizontalOffset verticalOffset newTip delta |
	delta := vertices second - vertices first.
	theta := delta theta.
	horizontalOffset := aLength * (theta cos).
	verticalOffset := aLength * (theta sin).
	newTip := vertices first + (horizontalOffset @ verticalOffset).
	self verticesAt: 2 put: newTip! !

!SMxPolygonMorph methodsFor: 'initialization' stamp: 'di 9/8/2000 09:44'!
beSmoothCurve

	smoothCurve == true ifFalse:
		[smoothCurve := true.
		self computeBounds]! !

!SMxPolygonMorph methodsFor: 'initialization' stamp: 'di 9/8/2000 09:45'!
beStraightSegments

	smoothCurve == false ifFalse:
		[smoothCurve := false.
		self computeBounds]! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'JuanVuletich 11/1/2010 15:53'!
borderColor: aColor 

	super borderColor: aColor.
	((borderColor isColor) and: [ borderColor isOpaque ]) 
		== ((aColor isColor) and: [ aColor isOpaque ]) 
			ifFalse: [
				"Need to recompute fillForm and borderForm
					if translucency of border changes."

				self releaseCachedState]! !

!SMxPolygonMorph methodsFor: 'dashes' stamp: 'dgd 2/22/2003 18:55'!
borderDashOffset
	borderDashSpec size < 4 ifTrue: [^0.0].
	^(borderDashSpec fourth) asFloat! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'JuanVuletich 10/12/2010 11:49'!
borderForm
	"A form must be created for drawing the border whenever the borderColor is translucent."

	| borderCanvas |
	borderForm ifNotNil: [^ borderForm].
	borderCanvas := "Display defaultCanvasClass" SMxFormCanvas forShadowOver: bounds.
	self drawBorderOn: borderCanvas.
	borderForm := borderCanvas form.
	self arrowForms do:
		[:f |  "Eliminate overlap between line and arrowheads if transparent."
		borderForm copy: f boundingBox from: f to: f offset - self position rule: Form erase].
	^ borderForm! !

!SMxPolygonMorph methodsFor: 'accessing' stamp: 'di 6/8/97 15:43'!
borderWidth: anInteger

	borderColor ifNil: [borderColor := Color black].
	borderWidth := anInteger.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'geometry' stamp: 'jmv 4/9/2009 09:32'!
closestPointTo: aPoint
	| curvePoint closestPoint dist minDist |
	closestPoint := minDist := nil.
	self lineSegmentsDo:
		[:p1 :p2 | 
		curvePoint := aPoint nearestPointOnLineFrom: p1 to: p2.
		dist := curvePoint dist: aPoint.
		(closestPoint isNil or: [dist < minDist])
			ifTrue: [closestPoint := curvePoint.
					minDist := dist]].
	^ closestPoint! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'dgd 2/22/2003 14:14'!
coefficients
	"Compute an array for the coefficients.  This is copied from Flegal's old
	code in the Spline class."

	| length extras verts coefficients |
	curveState ifNotNil: [^curveState first].
	verts := closed 
				ifTrue: [vertices copyWith: vertices first]
				ifFalse: [vertices].
	length := verts size.
	extras := 0.
	coefficients := Array new: 8.
	1 to: 8 do: [:i | coefficients at: i put: (Array new: length + extras)].
	1 to: 5
		by: 4
		do: 
			[:k | 
			1 to: length
				do: 
					[:i | 
					(coefficients at: k) at: i
						put: (k = 1 
								ifTrue: [(verts at: i) x asFloat]
								ifFalse: [(verts at: i) y asFloat])].
			1 to: extras
				do: 
					[:i | 
					(coefficients at: k) at: length + i put: ((coefficients at: k) at: i + 1)].
			self 
				derivs: (coefficients at: k)
				first: (coefficients at: k + 1)
				second: (coefficients at: k + 2)
				third: (coefficients at: k + 3)].
	extras > 0 
		ifTrue: 
			[1 to: 8
				do: 
					[:i | 
					coefficients at: i put: ((coefficients at: i) copyFrom: 2 to: length + 1)]].
	curveState := { 
				coefficients.
				nil.
				nil}.
	self computeNextToEndPoints.
	^coefficients! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 6/13/97 07:21'!
computeArrowFormAt: endPoint from: priorPoint
	"Compute a triangle oriented along the line from priorPoint to endPoint.
	Then draw those lines in a form and return that form, with appropriate offset"
	| d v p1 pts box arrowForm bb origin angle |
	d := borderWidth max: 1.
	v := endPoint - priorPoint.
	angle := v theta radiansToDegrees.
	pts := Array with: (endPoint + (borderWidth//2) + (Point r: d*5 degrees: angle))
				with: (endPoint + (borderWidth//2) + (Point r: d*4 degrees: angle + 135.0))
				with: (endPoint + (borderWidth//2) + (Point r: d*4 degrees: angle - 135.0)).

	box := ((pts first rect: pts last) encompass: (pts at: 2)) expandBy: 1.
	arrowForm := ColorForm extent: box extent asIntegerPoint.
	bb := (BitBlt toForm: arrowForm) sourceForm: nil; fillColor: Color black;
			combinationRule: Form over; width: 1; height: 1.
	origin := box topLeft.
	p1 := pts last - origin.
	pts do: [:p | bb drawFrom: p1 to: p-origin.  p1 := p-origin].
	arrowForm convexShapeFill: Color black.
	^ arrowForm offset: box topLeft! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'ar 2/6/2002 12:18'!
computeBounds
	| oldBounds delta excludeHandles |
	vertices ifNil: [^ self].

	self changed.
	oldBounds := bounds.
	self releaseCachedState.
	bounds := self curveBounds truncated.
	self arrowForms do:
		[:f | bounds := bounds merge: (f offset extent: f extent)].
	handles ifNotNil: [self updateHandles].

	"since we are directly updating bounds, see if any ordinary submorphs exist and move them accordingly"
	(oldBounds notNil and: [(delta := bounds origin - oldBounds origin) ~= (0@0)]) ifTrue: [
		excludeHandles := IdentitySet new.
		handles ifNotNil: [excludeHandles addAll: handles].
		self submorphsDo: [ :each |
			(excludeHandles includes: each) ifFalse: [
				each position: each position + delta
			].
		].
	].
	self layoutChanged.
	self changed.
! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'jmv 3/2/2010 16:22'!
computeNextToEndPoints
	| pointAfterFirst pointBeforeLast |
	pointAfterFirst := nil.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			pointAfterFirst ifNil: [pointAfterFirst := p2 asIntegerPoint].
			pointBeforeLast := p1 asIntegerPoint].
	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast! !

!SMxPolygonMorph methodsFor: 'geometry testing' stamp: 'jmv 1/8/2010 15:28'!
containsPoint: aPoint

	(bounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"

	closed & color isTransparent not ifTrue:
		[^ (self filledForm pixelValueAt: aPoint - bounds topLeft + 1) > 0].

	self lineSegmentsDo:
		[:p1 :p2 |
		(aPoint onLineFrom: p1 to: p2 within: (3 max: borderWidth+1//2) asFloat)
				ifTrue: [^ true]].

	self arrowForms do:
		[:f | (f pixelValueAt: aPoint - f offset) > 0 ifTrue: [^ true]].

	^ false! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'jmv 3/2/2010 16:23'!
curveBounds
	| curveBounds pointAfterFirst pointBeforeLast |
	smoothCurve 
		ifFalse: [
			^(Rectangle encompassing: vertices) expandBy: (borderWidth + 1) // 2].

	"Compute the bounds from actual curve traversal, with leeway for borderWidth.
	Also note the next-to-first and next-to-last points for arrow directions."
	curveState := nil.	"Force recomputation"
	curveBounds := vertices first corner: vertices last.
	pointAfterFirst := nil.
	self lineSegmentsDo: [ :p1 :p2 | 
			pointAfterFirst 
				ifNil: [ 
					pointAfterFirst := p2 asIntegerPoint.
					curveBounds := curveBounds encompass: p1 asIntegerPoint].
			curveBounds := curveBounds encompass: p2 asIntegerPoint.
			pointBeforeLast := p1 asIntegerPoint].
	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast.
	^curveBounds expandBy: (borderWidth + 1) // 2! !

!SMxPolygonMorph methodsFor: 'dashes' stamp: 'di 9/9/2000 09:20'!
dashedBorder: dashSpec
	"A dash spec is a 3- or 5-element array with
		{ length of normal border color.
		length of alternate border color.
		alternate border color.
		starting offset.
		amount to add to offset at each step }
	Starting offset is usually = 0, but changing it moves the dashes along the curve."

	borderDashSpec := dashSpec.
	self changed! !

!SMxPolygonMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color
		r: 0.0
		g: 0.419
		b: 0.935! !

!SMxPolygonMorph methodsFor: 'visual properties' stamp: 'ar 6/25/1999 11:17'!
defaultColor
	"Return the default fill style for the receiver"
	^Color orange! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'dgd 2/22/2003 14:16'!
derivs: a first: point1 second: point2 third: point3 
	"Compute the first, second and third derivitives (in coeffs) from
	the Points in this Path (coeffs at: 1 and coeffs at: 5)."

	| len v anArray |
	len := a size.
	len < 2 ifTrue: [^self].
	len > 2 
		ifTrue: 
			[v := Array new: len.
			v at: 1 put: 4.0.
			anArray := Array new: len.
			anArray at: 1 put: 6.0 * (a first - (a second * 2.0) + (a third)).
			2 to: len - 2
				do: 
					[:i | 
					v at: i put: 4.0 - (1.0 / (v at: i - 1)).
					anArray at: i
						put: 6.0 * ((a at: i) - ((a at: i + 1) * 2.0) + (a at: i + 2)) 
								- ((anArray at: i - 1) / (v at: i - 1))].
			point2 at: len - 1 put: (anArray at: len - 2) / (v at: len - 2).
			len - 2 to: 2
				by: 0 - 1
				do: 
					[:i | 
					point2 at: i
						put: ((anArray at: i - 1) - (point2 at: i + 1)) / (v at: i - 1)]].
	point2 at: 1 put: (point2 at: len put: 0.0).
	1 to: len - 1
		do: 
			[:i | 
			point1 at: i
				put: (a at: i + 1) - (a at: i) 
						- (((point2 at: i) * 2.0 + (point2 at: i + 1)) / 6.0).
			point3 at: i put: (point2 at: i + 1) - (point2 at: i)]! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'jmv 12/8/2004 12:30'!
dragVertex: ix event: evt fromHandle: handle
	| p |
	p := evt cursorPoint.
	handle position: p - (handle extent//2).
	self verticesAt: ix put: p.
! !

!SMxPolygonMorph methodsFor: 'drawing' stamp: 'ar 11/26/2001 23:15'!
drawBorderOn: aCanvas 
	self
		drawClippedBorderOn: aCanvas
		usingEnds: (Array with: vertices first with: vertices last)! !

!SMxPolygonMorph methodsFor: 'drawing' stamp: 'ar 11/26/2001 14:53'!
drawBorderOn: aCanvas usingEnds: anArray 
	"Display my border on the canvas."
	"NOTE: Much of this code is also copied in drawDashedBorderOn:  
	(should be factored)"
	| bigClipRect p1i p2i style |
	borderDashSpec
		ifNotNil: [^ self drawDashedBorderOn: aCanvas usingEnds: anArray].
	style := self borderStyle.
	bigClipRect := aCanvas clipRect expandBy: self borderWidth + 1 // 2.
	self lineSegmentsDo: [:p1 :p2 | 
		p1i := p1 asIntegerPoint.
		p2i := p2 asIntegerPoint.
		(arrows ~= #none and: [closed not])
			ifTrue: ["Shorten line ends so as not to interfere with tip of arrow."
					((arrows == #back
								or: [arrows == #both])
							and: [p1 = vertices first])
						ifTrue: [p1i := anArray first asIntegerPoint].
					((arrows == #forward
								or: [arrows == #both])
							and: [p2 = vertices last])
						ifTrue: [p2i := anArray last asIntegerPoint]].
		(closed or: ["bigClipRect intersects: (p1i rect: p2i) optimized:"
			((p1i min: p2i) max: bigClipRect origin)
				<= ((p1i max: p2i) min: bigClipRect corner)])
				ifTrue: [style drawLineFrom: p1i to: p2i on: aCanvas]]! !

!SMxPolygonMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:31'!
drawClippedBorderOn: aCanvas usingEnds: anArray 
	aCanvas clipBy: bounds during:[:cc| self drawBorderOn: cc usingEnds: anArray].! !

!SMxPolygonMorph methodsFor: 'drawing' stamp: 'JuanVuletich 11/1/2010 15:53'!
drawDashedBorderOn: aCanvas usingEnds: anArray 
	"Display my border on the canvas. NOTE: mostly copied from  
	drawBorderOn:"

	| lineColor bevel topLeftColor bottomRightColor bigClipRect p1i p2i segmentOffset |
	(borderColor isNil 
		or: [(borderColor isColor) and: [borderColor isTransparent]]) ifTrue: [^self].
	lineColor := borderColor.
	bevel := false.
	"Border colors for bevelled effects depend on CW ordering of  
	vertices"
	borderColor == #raised 
		ifTrue: 
			[topLeftColor := color lighter.
			bottomRightColor := color darker.
			bevel := true].
	borderColor == #inset 
		ifTrue: 
			[topLeftColor := owner colorForInsets darker.
			bottomRightColor := owner colorForInsets lighter.
			bevel := true].
	bigClipRect := aCanvas clipRect expandBy: (self borderWidth + 1) // 2.
	segmentOffset := self borderDashOffset.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			p1i := p1 asIntegerPoint.
			p2i := p2 asIntegerPoint.
			(arrows ~= #none and: [closed not]) 
				ifTrue: 
					["Shorten line ends so as not to interfere with tip  
					of arrow."

					((arrows == #back or: [arrows == #both]) and: [p1 = vertices first]) 
						ifTrue: [p1i := anArray first asIntegerPoint].
					((arrows == #forward or: [arrows == #both]) and: [p2 = vertices last]) 
						ifTrue: [p2i := anArray last asIntegerPoint]].
			(closed or: 
					["bigClipRect intersects: (p1i rect: p2i) optimized:"

					((p1i min: p2i) max: bigClipRect origin) 
						<= ((p1i max: p2i) min: bigClipRect corner)]) 
				ifTrue: 
					[bevel 
						ifTrue: 
							[lineColor := (p1i quadrantOf: p2i) > 2 
										ifTrue: [topLeftColor]
										ifFalse: [bottomRightColor]].
					segmentOffset := aCanvas 
								line: p1i
								to: p2i
								width: borderWidth
								color: lineColor
								dashLength: borderDashSpec first
								secondColor: borderDashSpec third
								secondDashLength: borderDashSpec second
								startingOffset: segmentOffset]]! !

!SMxPolygonMorph methodsFor: 'drawing' stamp: 'StephaneDucasse 2/7/2011 21:46'!
drawOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight line segments."
	| lineColor bevel topLeftColor bottomRightColor bigClipRect brush p1i p2i |
	vertices size < 1 ifTrue: [self error: 'a polygon must have at least one point'].
	closed & color isTransparent not ifTrue:
		[self filledForm colors: (Array with: Color transparent with: color).
		aCanvas paintImage: self filledForm at: bounds topLeft-1].
	lineColor := borderColor.  bevel := false.
	"Border colors for bevelled effects depend on CW ordering of vertices"
	borderColor == #raised ifTrue: [topLeftColor := color lighter.
						bottomRightColor := color darker.  bevel := true].
	borderColor == #inset ifTrue: [topLeftColor := owner colorForInsets darker.
						bottomRightColor := owner colorForInsets lighter.  bevel := true].
	bigClipRect := aCanvas clipRect expandBy: self borderWidth+1//2.
	brush := nil.
	self lineSegmentsDo:
		[:p1 :p2 | p1i := p1 asIntegerPoint.  p2i := p2 asIntegerPoint.
		(closed or: ["bigClipRect intersects: (p1i rect: p2i) optimized:"
					((p1i min: p2i) max: bigClipRect origin) <=
					((p1i max: p2i) min: bigClipRect corner)]) ifTrue:
			[bevel ifTrue: [((p1i quadrantOf: p2i) > 2)
						ifTrue: [lineColor := topLeftColor]
						ifFalse: [lineColor := bottomRightColor]].
			(borderWidth > 3 and: [borderColor isColor])
			ifTrue: [brush ifNil: [
						brush := (ColorForm dotOfSize: borderWidth)
								colors: (Array with: Color transparent with: borderColor)].
					aCanvas line: p1i to: p2i brushForm: brush]
			ifFalse: [aCanvas line: p1i to: p2i
							width: borderWidth color: lineColor]]].
	self arrowForms ifNotNil:
		[self arrowForms do:
			[:f | f colors: (Array with: Color transparent with: borderColor).
			aCanvas paintImage: f at: f offset]]
! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:31'!
dropVertex: ix event: evt fromHandle: handle
	| p |
	p := vertices at: ix.
	(((vertices atWrap: ix-1) dist: p) < 3 or:
		[((vertices atWrap: ix+1) dist: p) < 3])
		ifTrue: ["Drag a vertex onto its neighbor means delete"
				self setVertices: (vertices copyReplaceFrom: ix to: ix with: Array new)].
	evt shiftPressed
		ifTrue: [self removeHandles]
		ifFalse: [self addHandles "remove then add to recreate"]! !

!SMxPolygonMorph methodsFor: 'geometry' stamp: 'di 9/24/2000 08:44'!
extent: newExtent 
	"Not really advisable, but we can preserve most of the geometry if we don't
	shrink things too small."
	| safeExtent center |
	center := self referencePosition.
	safeExtent := newExtent max: 20@20.
	self setVertices: (vertices collect:
		[:p | p - center * (safeExtent asFloatPoint / (bounds extent max: 1@1)) + center])! !

!SMxPolygonMorph methodsFor: 'visual properties' stamp: 'di 9/19/2000 22:00'!
fillStyle

	self isOpen
		ifTrue: [^ self borderColor  "easy access to line color from halo"]
		ifFalse: [^ super fillStyle]! !

!SMxPolygonMorph methodsFor: 'visual properties' stamp: 'di 9/19/2000 22:00'!
fillStyle: newColor

	self isOpen
		ifTrue: [^ self borderColor: newColor  "easy access to line color from halo"]
		ifFalse: [^ super fillStyle: newColor]! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:54'!
filledForm
	"Note: The filled form is actually 2 pixels bigger than bounds, and the point corresponding to this morphs' position is at 1@1 in the form.  This is due to the details of the fillig routines, at least one of which requires an extra 1-pixel margin around the outside.  Computation of the filled form is done only on demand."
	| bb origin |
	closed ifFalse: [^ filledForm := nil].
	filledForm ifNotNil: [^ filledForm].
	filledForm := ColorForm extent: bounds extent+2.

	"Draw the border..."
	bb := (BitBlt current toForm: filledForm) sourceForm: nil; fillColor: Color black;
			combinationRule: Form over; width: 1; height: 1.
	origin := bounds topLeft asIntegerPoint-1.
	self lineSegmentsDo: [:p1 :p2 | bb drawFrom: p1 asIntegerPoint-origin
										to: p2 asIntegerPoint-origin].

	"Fill it in..."
	filledForm := ColorForm mappingWhiteToTransparentFrom: filledForm anyShapeFill.

	((borderColor isColor) and: [ borderColor isOpaque not ]) ifTrue: [
		"If border is stored as a form, then erase any overlap now."
		filledForm
			copy: self borderForm boundingBox
			from: self borderForm
			to: 1@1
			rule: Form erase ].

	^ filledForm! !

!SMxPolygonMorph methodsFor: 'halo control' stamp: 'jmv 5/23/2009 00:28'!
forwardDirection
	"Return the receiver's forward direction (in eToy terms)"
	^self valueOfProperty: #forwardDirection ifAbsent:[0.0]! !

!SMxPolygonMorph methodsFor: 'halo control' stamp: 'jmv 5/23/2009 00:28'!
forwardDirection: newDirection
	"Set the receiver's forward direction (in eToy terms)"
	self setProperty: #forwardDirection toValue: newDirection.! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 9/7/2000 16:17'!
getVertices

	smoothCurve ifFalse: [^ vertices].

	"For curves, enumerate the full set of interpolated points"
	^ Array streamContents:
		[:s | self lineSegmentsDo: [:pt1 :pt2 | s nextPut: pt1]]! !

!SMxPolygonMorph methodsFor: 'event handling' stamp: 'di 8/20/2000 14:29'!
handlesMouseDown: evt

	^ (super handlesMouseDown: evt) or: [evt shiftPressed]! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:57'!
handlesShowingPhrase
	^ (self showingHandles
		ifTrue: ['hide handles']
		ifFalse: ['show handles']) translated! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 8/31/2000 13:46'!
includesHandle: aMorph

	handles ifNil: [^ false].
	^ handles includes: aMorph! !

!SMxPolygonMorph methodsFor: 'initialization' stamp: 'jmv 4/9/2009 09:47'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	vertices := Array
				with: 15 @ 10
				with: 30 @ 20
				with: 10 @ 30.
	closed := true.
	smoothCurve := false.
	arrows := #none.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'sw 8/25/2000 22:37'!
isClosed
	^ closed! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'di 9/7/2000 16:18'!
isCurve
	^ smoothCurve! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'jm 11/19/97 18:55'!
isOpen
	^ closed not! !

!SMxPolygonMorph methodsFor: 'geometry testing' stamp: 'jmv 10/7/2009 23:21'!
isOrthoRectangularMorph
	^false! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 11/21/97 21:29'!
lineSegments
	| lineSegments |
	lineSegments := OrderedCollection new.
	self lineSegmentsDo: [:p1 :p2 | lineSegments addLast: (Array with: p1 with: p2)].
	^ lineSegments! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'dgd 2/22/2003 14:21'!
lineSegmentsDo: endPointsBlock 
	"Emit a sequence of segment endpoints into endPointsBlock."

	| n t x y x1 x2 x3 y1 y2 y3 beginPoint endPoint cs |
	smoothCurve 
		ifFalse: 
			[beginPoint := nil.
			vertices do: 
					[:vert | 
					beginPoint ifNotNil: [endPointsBlock value: beginPoint value: vert].
					beginPoint := vert].
			(closed or: [vertices size = 1]) 
				ifTrue: [endPointsBlock value: beginPoint value: vertices first].
			^self].

	"For curves we include all the interpolated sub segments."
	vertices size < 1 ifTrue: [^self].
	cs := self coefficients.
	beginPoint := (x := cs first first) @ (y := cs fifth first).
	1 to: cs first size - 1
		do: 
			[:i | 
			"taylor series coefficients"

			x1 := cs second at: i.
			y1 := cs sixth at: i.
			x2 := (cs third at: i) / 2.0.
			y2 := (cs seventh at: i) / 2.0.
			x3 := (cs fourth at: i) / 6.0.
			y3 := ((cs eighth) at: i) / 6.0.
			"guess n"
			n := 5 
						max: (((x2 abs + y2 abs) * 2.0 + (cs third at: i + 1) abs 
								+ (cs seventh at: i + 1) abs) / 100.0) 
								rounded.
			1 to: n - 1
				do: 
					[:j | 
					t := j asFloat / n.
					endPoint := (((x3 * t + x2) * t + x1) * t + x) 
								@ (((y3 * t + y2) * t + y1) * t + y).
					endPointsBlock value: beginPoint value: endPoint.
					beginPoint := endPoint].
			endPoint := (x := cs first at: i + 1) @ (y := cs fifth at: i + 1).
			endPointsBlock value: beginPoint value: endPoint.
			beginPoint := endPoint]! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 6/9/97 21:32'!
makeBackArrow
	arrows := #back.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 6/9/97 21:32'!
makeBothArrows
	arrows := #both.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 8/20/2000 14:27'!
makeClosed
	closed := true.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 6/9/97 21:32'!
makeForwardArrow
	arrows := #forward.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 6/9/97 21:32'!
makeNoArrows
	arrows := #none.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 8/20/2000 14:27'!
makeOpen
	closed := false.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'sw 8/23/2000 16:16'!
makeOpenOrClosed
	"toggle the open/closed status of the receiver"
	closed ifTrue: [self makeOpen] ifFalse: [self makeClosed]! !

!SMxPolygonMorph methodsFor: 'geometry' stamp: 'sw 9/14/97 18:22'!
merge: aPolygon
	"Expand myself to enclose the other polygon.  (Later merge overlapping or disjoint in a smart way.)  For now, the two polygons must share at least two vertices.  Shared vertices must come one after the other in each polygon.  Polygons must not overlap."

	| shared mv vv hv xx |
	shared := vertices select: [:mine | 
		(aPolygon vertices includes: mine)].
	shared size < 2 ifTrue: [^ nil].	"not sharing a segment"
	mv := vertices asOrderedCollection.
	[shared includes: mv first] whileFalse: ["rotate them"
		vv := mv removeFirst.
		mv addLast: vv].
	hv := aPolygon vertices asOrderedCollection.
	[mv first = hv first] whileFalse: ["rotate him until same shared vertex is first"
		vv := hv removeFirst.
		hv addLast: vv].
	[shared size > 2] whileTrue: [
		shared := shared asOrderedCollection.
		(self mergeDropThird: mv in: hv from: shared) ifNil: [^ nil]].
		"works by side effect on the lists"
	(mv at: 2) = hv last ifTrue: [mv removeFirst; removeFirst.
		^ self setVertices: (hv, mv) asArray].
	(hv at: 2) = mv last ifTrue: [hv removeFirst; removeFirst.
		^ self setVertices: (mv, hv) asArray].
	(mv at: 2) = (hv at: 2) ifTrue: [hv removeFirst.  mv remove: (mv at: 2).
		xx := mv removeFirst.
		^ self setVertices: (hv, (Array with: xx), mv reversed) asArray].
	mv last = hv last ifTrue: [mv removeLast.  hv removeFirst.
		^ self setVertices: (mv, hv reversed) asArray].
	^ nil
! !

!SMxPolygonMorph methodsFor: 'geometry' stamp: 'sw 9/14/97 18:22'!
mergeDropThird: mv in: hv from: shared
	"We are merging two polygons.  In this case, they have at least three identical shared vertices.  Make sure they are sequential in each, and drop the middle one from vertex lists mv, hv, and shared.  First vertices on lists are identical already."

	"know (mv first = hv first)"
	| mdrop vv |
	(shared includes: (mv at: mv size - 2)) 
		ifTrue: [(shared includes: (mv last)) ifTrue: [mdrop := mv last]]
		ifFalse: [(shared includes: (mv last)) ifTrue: [
			(shared includes: (mv at: 2)) ifTrue: [mdrop := mv first]]].
	(shared includes: (mv at: 3)) ifTrue: [
		(shared includes: (mv at: 2)) ifTrue: [mdrop := mv at: 2]].
	mdrop ifNil: [^ nil].
	mv remove: mdrop.
	hv remove: mdrop.
	shared remove: mdrop.
	[shared includes: mv first] whileFalse: ["rotate them"
		vv := mv removeFirst.
		mv addLast: vv].
	[mv first = hv first] whileFalse: ["rotate him until same shared vertex is first"
		vv := hv removeFirst.
		hv addLast: vv].
! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'nk 8/8/2001 12:13'!
mouseDown: evt

	^ evt shiftPressed
		ifTrue: [((owner isKindOf: SMxPolygonMorph) and: [owner includesHandle: self])
					ifTrue: ["Prevent insertion handles from getting edited"
							^ super mouseDown: evt].
				self toggleHandles.
				handles ifNil: [^ self].
				vertices withIndexDo:  "Check for click-to-drag at handle site"
					[:vertPt :vertIndex |
					((handles at: vertIndex*2-1 ifAbsent: [ ^self ]) containsPoint: evt cursorPoint) ifTrue:
						["If clicked near a vertex, jump into drag-vertex action"
						evt hand newMouseFocus: (handles at: vertIndex*2-1)]]]
		ifFalse: [super mouseDown: evt]! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'sw 9/25/2002 01:16'!
newVertex: ix event: evt fromHandle: handle
	"Insert a new vertex and fix everything up!! Install the drag-handle of the new vertex as recipient of further mouse events."

	| pt |
	(self hasProperty: #noNewVertices) ifFalse:
		[pt := evt cursorPoint.
		self setVertices: (vertices copyReplaceFrom: ix + 1 to: ix with: (Array with: pt)).
		evt hand newMouseFocus: (handles at: ((ix + 1) * 2) - 1)]
! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'dgd 2/22/2003 18:57'!
nextToFirstPoint
	"For arrow direction"

	smoothCurve 
		ifTrue: 
			[curveState ifNil: [self coefficients].
			^curveState second]
		ifFalse: [^vertices second]! !

!SMxPolygonMorph methodsFor: 'smoothing' stamp: 'dgd 2/22/2003 18:58'!
nextToLastPoint
	"For arrow direction"

	smoothCurve 
		ifTrue: 
			[curveState ifNil: [self coefficients].
			^curveState third]
		ifFalse: [^vertices at: vertices size - 1]! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'dgd 12/11/2003 13:14'!
openOrClosePhrase
	| curveName |
	curveName := (self isCurve
				ifTrue: ['curve']
				ifFalse: ['polygon']) translated.
	^ closed
		ifTrue: ['make open {1}' translated format: {curveName}]
		ifFalse: ['make closed {1}' translated format: {curveName}]! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'jmv 5/19/2009 23:35'!
privateMoveBy: delta
	super privateMoveBy: delta.
	vertices := vertices collect: [:p | p + delta].
	self arrowForms do: [:f | f offset: f offset + delta].
	curveState := nil.  "Force recomputation"! !

!SMxPolygonMorph methodsFor: 'caching' stamp: 'di 9/4/2000 13:36'!
releaseCachedState
	super releaseCachedState.
	filledForm := nil.
	arrowForms := nil.
	borderForm := nil.
	curveState := nil.
	(self hasProperty: #flex) ifTrue:
		[self removeProperty: #unflexedVertices;
			removeProperty: #flex].
! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'tk 9/2/97 16:04'!
removeHandles
	"tk 9/2/97 allow it to be called twice (when nil already)"

	handles ifNotNil: [
		handles do: [:h | h delete].
		handles := nil].! !

!SMxPolygonMorph methodsFor: 'rotate scale and flex' stamp: 'di 9/24/2000 08:42'!
rotationDegrees

	^ self forwardDirection! !

!SMxPolygonMorph methodsFor: 'halo control' stamp: 'JuanVuletich 10/11/2010 20:25'!
rotationDegrees: degrees 
	| center |
	center := self center.
	self setVertices: (vertices collect: [ :v |
		v rotateBy: (degrees - self forwardDirection) degreesToRadians about: center ]).
	self forwardDirection: degrees! !

!SMxPolygonMorph methodsFor: 'private' stamp: 'di 9/8/2000 10:36'!
setVertices: newVertices
	vertices := newVertices.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'sw 8/19/2000 15:16'!
showOrHideHandles
	self showingHandles
		ifTrue:	[self removeHandles]
		ifFalse:	[self addHandles]! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'sw 8/19/2000 15:17'!
showingHandles
	^ handles notNil! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:05'!
specifyDashedLine

	| executableSpec newSpec |
	executableSpec := SMxFillInTheBlankMorph
		request:
'Enter a dash specification as
{ major dash length. minor dash length. minor dash color }
The major dash will have the normal border color.
A blank response will remove the dash specification.
[Note: You may give 5 items as, eg, {10. 5. Color white. 0. 3}
where the 4th ityem is zero, and the 5th is the number of pixels
by which the dashes will move in each step of animation]'
		initialAnswer: '{ 10. 5. Color red }'.
	executableSpec isEmpty ifTrue:
		[^ self stopStepping; dashedBorder: nil].
	newSpec := [Compiler evaluate: executableSpec] ifError:
		[^ self stopStepping; dashedBorder: nil].
	newSpec first isNumber & newSpec second isNumber & (newSpec third isColor) ifFalse:
		[^ self stopStepping; dashedBorder: nil].
	newSpec size = 3 ifTrue:
		[^ self stopStepping; dashedBorder: newSpec].
	(newSpec size = 5 and: [newSpec fourth isNumber & newSpec fifth isNumber]) ifTrue:
		[^ self dashedBorder: newSpec; startStepping].
! !

!SMxPolygonMorph methodsFor: 'stepping and presenter' stamp: 'dgd 2/22/2003 18:58'!
step
	borderDashSpec ifNil: [^super step].
	borderDashSpec size < 5 ifTrue: [^super step].

	"Only for dashed lines with creep"
	borderDashSpec at: 4 put: (borderDashSpec fourth) + borderDashSpec fifth.
	self changed.
	^super step! !

!SMxPolygonMorph methodsFor: 'testing' stamp: 'di 9/9/2000 09:24'!
stepTime

	^ 100! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 8/20/2000 14:31'!
toggleHandles

	handles ifNil: [self addHandles] ifNotNil: [self removeHandles].

! !

!SMxPolygonMorph methodsFor: 'menu' stamp: 'di 9/7/2000 15:43'!
toggleSmoothing

	smoothCurve := smoothCurve not.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'nk 10/4/2000 12:56'!
updateHandles
	| newVert oldVert midPts nextVertIx tweens |
	smoothCurve
		ifTrue: [
			handles first center: vertices first.
			handles last center: vertices last.
			midPts := OrderedCollection new.
			nextVertIx := 2.
			tweens := OrderedCollection new.
			self
				lineSegmentsDo: [:p1 :p2 | 
					tweens addLast: p2 asIntegerPoint.
					p2
							= (vertices atWrap: nextVertIx)
						ifTrue: ["Found endPoint."
							midPts addLast: (tweens at: tweens size // 2)
									+ (tweens at: tweens size + 1 // 2) // 2.
							tweens := OrderedCollection new.
							nextVertIx := nextVertIx + 1]].
			midPts
				withIndexDo: [:midPt :vertIndex | (closed
							or: [vertIndex < vertices size])
						ifTrue: [newVert := handles at: vertIndex * 2.
							newVert position: midPt - (newVert extent // 2)]]]
		ifFalse: [vertices
				withIndexDo: [:vertPt :vertIndex | 
					oldVert := handles at: vertIndex * 2 - 1.
					oldVert position: vertPt - (oldVert extent // 2).
					(closed
							or: [vertIndex < vertices size])
						ifTrue: [newVert := handles at: vertIndex * 2.
							newVert position: vertPt
									+ (vertices atWrap: vertIndex + 1) - newVert extent // 2 + (1 @ -1)]]]! !

!SMxPolygonMorph methodsFor: 'access' stamp: 'sw 9/14/97 18:22'!
vertices
	^ vertices! !

!SMxPolygonMorph methodsFor: 'initialization' stamp: 'di 9/7/2000 13:28'!
vertices: verts color: c borderWidth: bw borderColor: bc
	super initialize.
	vertices := verts.
	color := c.
	borderWidth := bw.
	borderColor := bc.
	closed := vertices size > 2.
	arrows := #none.
	self computeBounds.
! !

!SMxPolygonMorph methodsFor: 'editing' stamp: 'di 9/8/2000 10:39'!
verticesAt: ix put: newPoint
	vertices at: ix put: newPoint.
	self computeBounds! !

!SMxPolygonMorph methodsFor: 'testing' stamp: 'dgd 2/22/2003 18:58'!
wantsSteps
	super wantsSteps ifTrue: [^true].

	"For crawling ants effect of dashed line."
	borderDashSpec ifNil: [^false].
	^borderDashSpec size = 5 and: [(borderDashSpec fifth) > 0]! !

SMxPolygonMorph subclass: #SMxStarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxStarMorph methodsFor: 'handles' stamp: 'ar 3/17/2001 14:33'!
addHandles
	| center | 
	self removeHandles.
	center := vertices sum // vertices size.   "Average vertices to get the center"
	handles := {center. vertices second} with: {#center. #outside} collect:
		[:p :which | (SMxEllipseMorph newBounds: (Rectangle center: p extent: 8@8)
							color: Color yellow)
				on: #mouseDown send: #dragVertex:event:fromHandle:
						to: self withValue: which;
				on: #mouseMove send: #dragVertex:event:fromHandle:
						to: self withValue: which].
	self addAllMorphs: handles.
	self changed! !

!SMxStarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!SMxStarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxStarMorph methodsFor: 'initialization' stamp: 'ar 6/25/1999 11:18'!
defaultColor
	"Return the default fill style for the receiver"
	^Color lightBlue! !

!SMxStarMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:30'!
dragVertex: label event: evt fromHandle: handle
	| ext oldR pt center |
	label == #center ifTrue:
		[self position: self position + (evt cursorPoint - handle center)].

	label == #outside ifTrue:
		[center := handles first center.
		pt := center - evt cursorPoint.
		ext := pt r.
		oldR := ext.
		vertices := (0 to: 359 by: (360//vertices size)) collect:
			[:angle |
			(Point r: (oldR := oldR = ext ifTrue: [ext*5//12] ifFalse: [ext])
					degrees: angle + pt degrees)
				+ center].
		handle align: handle center with: evt cursorPoint].

	self computeBounds.
! !

!SMxStarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:12'!
initialize
"initialize the state of the receiver"
	| pt ext oldR points |
	super initialize.
	""
	pt := 10 @ 10.
	ext := pt r.
	oldR := ext.
	points := 5.
	vertices := (0 to: 359 by: 360 // points // 2)
				collect: [:angle | (Point r: (oldR := oldR = ext
									ifTrue: [ext * 5 // 12]
									ifFalse: [ext]) degrees: angle + pt degrees)
						+ (45 @ 45)].
	self computeBounds! !

!SMxStarMorph methodsFor: 'editing' stamp: 'di 9/26/97 11:11'!
updateHandles! !

SMxBorderedMorph subclass: #SMxProgressBarMorph
	instanceVariableNames: 'value progressColor lastValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxProgressBarMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:43'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addList: {
		{'progress color...' translated. #changeProgressColor:}.
		{'progress value...' translated. #changeProgressValue:}.
		}! !

!SMxProgressBarMorph methodsFor: 'menu' stamp: 'ar 10/5/2000 18:51'!
changeProgressColor: evt
	| aHand |
	aHand := evt ifNotNil: [evt hand] ifNil: [self primaryHand].
	self changeColorTarget: self selector: #progressColor: originalColor: self progressColor hand: aHand.! !

!SMxProgressBarMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:05'!
changeProgressValue: evt
	| answer |
	answer := SMxFillInTheBlankMorph
		request: 'Enter new value (0 - 1.0)'
		initialAnswer: self value contents asString.
	answer isEmptyOrNil ifTrue: [^ self].
	self value contents: answer asNumber! !

!SMxProgressBarMorph methodsFor: 'drawing' stamp: 'sma 3/3/2000 18:54'!
drawOn: aCanvas
	| width inner |
	super drawOn: aCanvas.
	inner := self innerBounds.
	width := (inner width * lastValue) truncated min: inner width.
	aCanvas fillRectangle: (inner origin extent: width @ inner height) color: progressColor.! !

!SMxProgressBarMorph methodsFor: 'initialization' stamp: 'sma 3/3/2000 18:55'!
initialize
	super initialize.
	progressColor := Color green.
	self value: (ValueHolder new contents: 0.0).
	lastValue := 0.0! !

!SMxProgressBarMorph methodsFor: 'accessing' stamp: 'ar 11/18/1998 22:14'!
progressColor
	^progressColor! !

!SMxProgressBarMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 18:52'!
progressColor: aColor
	progressColor = aColor
		ifFalse:
			[progressColor := aColor.
			self changed]! !

!SMxProgressBarMorph methodsFor: 'updating' stamp: 'sma 3/3/2000 18:51'!
update: aSymbol 
	aSymbol == #contents
		ifTrue: 
			[lastValue := value contents.
			self changed]! !

!SMxProgressBarMorph methodsFor: 'accessing' stamp: 'ar 11/18/1998 22:09'!
value
	^value! !

!SMxProgressBarMorph methodsFor: 'accessing' stamp: 'sma 3/3/2000 18:53'!
value: aModel
	value ifNotNil: [value removeDependent: self].
	value := aModel.
	value ifNotNil: [value addDependent: self]! !

SMxBorderedMorph subclass: #SMxRectangleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxRectangleMorph commentStamp: '<historical>' prior: 0!
A subclass of SMxBorderedMorph.!

!SMxRectangleMorph methodsFor: 'initialization' stamp: 'tk 11/6/2001 08:20'!
defaultColor
	"Answer the color that should be set for the receiver by default"

	^ Color r: 0.613 g: 0.903 b: 1.0! !

SMxBorderedMorph subclass: #SMxScrollbarButton
	instanceVariableNames: 'image'
	classVariableNames: 'Arrows Box CurrentSize'
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxScrollbarButton commentStamp: '<historical>' prior: 0!
A very simple button to be used in ScrollBars!

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 9/17/2009 10:58'!
arrowOfDirection: aSymbol
	"answer a form with an arrow based on the parameters, of the current size"
	^Arrows at: aSymbol! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:58'!
arrowOfDirection: aSymbol size: finalSizeInteger
	"answer a form with an arrow based on the parameters"
	CurrentSize = finalSizeInteger ifFalse: [
		self initializeArrowsAndBox: finalSizeInteger ].
	^Arrows at: aSymbol! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:57'!
boxOfSize: finalSizeInteger
	"answer a form with an box based on the parameters"
	CurrentSize = finalSizeInteger ifFalse: [
		self initializeArrowsAndBox: finalSizeInteger ].
	^Box! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:58'!
createArrowIn: aRectangle 
	"PRIVATE - create an arrow bounded in aRectangle"
	"
	(self createArrowOfDirection: #up in: (0@0 extent: 20@20)) openInWorld
	"

	| arrow vertices |
	vertices := self verticesForSimpleArrow: aRectangle.
	arrow := SMxPolygonMorph 
				vertices: vertices
				color: Color darkGray
				borderWidth: 0
				borderColor: Color black.
	arrow bounds: (arrow bounds insetBy: (aRectangle width / 6) rounded).
	^arrow! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 19:41'!
createArrowOfDirection: aSymbolDirection size: finalSizeInteger
	"PRIVATE - create an arrow with aSymbolDirectionDirection,  
	finalSizeInteger and aColor  
	 
	aSymbolDirectionDirection = #top, #bottom. #left or #right  
	 (self createArrowOfDirection: #up size: 120) display
	"

	| resizeFactor outerBox arrowMorph resizedForm |
	resizeFactor := 4.
	outerBox := SMxRectangleMorph new.
	outerBox
		extent: finalSizeInteger asPoint * resizeFactor;
		borderWidth: 0;
		color: Color transparent.
	
	arrowMorph := self createArrowIn: outerBox bounds.
	outerBox addMorphCentered: arrowMorph.
	
	resizedForm := outerBox imageForm 
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.

	aSymbolDirection == #right
		ifTrue: [resizedForm := resizedForm rotateBy: 90].
	aSymbolDirection == #bottom
		ifTrue: [resizedForm := resizedForm rotateBy:  180].
	aSymbolDirection == #left
		ifTrue: [resizedForm := resizedForm rotateBy:  270].
		
	aSymbolDirection == #up
		ifFalse: [ resizedForm := resizedForm
			copy: (resizedForm boundingBox insetBy: (resizedForm width - finalSizeInteger/ 2.0) rounded) ].
		
	^resizedForm! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:58'!
createBoxIn: aRectangle 
	"PRIVATE - create an box bounded in aRectangle"
	| box |
	box := SMxRectangleMorph new.
	box extent: (aRectangle scaleBy: 1 / 2) extent rounded;
		 borderWidth: 0.
	box color: Color darkGray.
	^ box! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 19:39'!
createBoxOfSize: finalSizeInteger
	"PRIVATE - create a box with finalSizeInteger and aColor  
	 
	Try with:  
	(SMxScrollBar createBoxOfSize: 32) display
	"

	| resizeFactor outerBox innerBox resizedForm |
	resizeFactor := 4.
	outerBox := SMxRectangleMorph new.
	outerBox
		extent: finalSizeInteger asPoint * resizeFactor;
		borderWidth: 0;
		color: Color transparent.

	innerBox := self createBoxIn: outerBox bounds.
	outerBox addMorphCentered: innerBox.

	resizedForm := outerBox imageForm 
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.

	^resizedForm! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:57'!
initializeArrowsAndBox: finalSizeInteger
	Arrows := Dictionary new.
	#(#top #bottom #left #right ) do: [ :dir |
		Arrows at: dir put: (self createArrowOfDirection: dir size: finalSizeInteger) ].
	Box := self createBoxOfSize: finalSizeInteger.
	CurrentSize := finalSizeInteger! !

!SMxScrollbarButton class methodsFor: 'images' stamp: 'jmv 4/5/2009 18:58'!
verticesForSimpleArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a simple arrow"
	| vertices |
	vertices := OrderedCollection new.
	
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle center x @ (aRectangle top + (aRectangle width / 8)).
	vertices add: aRectangle bottomRight.
	
	^ vertices! !

!SMxScrollbarButton methodsFor: 'drawing' stamp: 'jmv 4/5/2009 19:41'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas translucentImage: image at: self position! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:09'!
initialize
	super initialize.
	self setBorderWidth: 1 borderColor: #raised.! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:25'!
updateDownButtonImage
	"update the receiver's as a downButton.  put a new image inside"

	image := self class arrowOfDirection: #bottom size: self extent.
	self changed! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:26'!
updateLeftButtonImage
	"update the receiver's as a downButton.  put a new image inside"

	image := self class arrowOfDirection: #left size: self extent.
	self changed! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:26'!
updateMenuButtonImage
	"update the receiver's as a menuButton. put a new image inside"

	image := self class boxOfSize: self extent.
	self changed! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:26'!
updateRightButtonImage
	"update the receiver's as a downButton.  put a new image inside"

	image := self class arrowOfDirection: #right size: self extent.
	self changed! !

!SMxScrollbarButton methodsFor: 'initialization' stamp: 'jmv 4/5/2009 19:26'!
updateUpButtonImage
	"update the receiver's as a upButton. put a new image inside"

	image := self class arrowOfDirection: #top size: self extent.
	self changed! !

SMxBorderedMorph subclass: #SMxSelectionMorph
	instanceVariableNames: 'selectedItems slippage dupLoc dupDelta itemsAlreadySelected otherSelection undoProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Support'!

!SMxSelectionMorph commentStamp: '<historical>' prior: 0!
A selectionMorph supports the selection of multiple objects in a morphic world or pasteUp.

Structure:
	selectedItems	an OrderedCollection of Morphs
					These are the morphs that have been selected
	slippage		a Point
					Keeps track of actual movement between the 
					steps of gridded movement
	dupLoc		a Point
					Notes the position when first duplicate request occurs from halo
	dupDelta	a Point
					Holds the final delta of the first duplicate plus subsequent moves.
!

!SMxSelectionMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/10/2000 15:02'!
aboutToBeGrabbedBy: aHand
	slippage := 0@0.
	^ super aboutToBeGrabbedBy: aHand
! !

!SMxSelectionMorph methodsFor: 'halo commands' stamp: 'jmv 5/27/2006 21:26'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add custom menu items to the menu"

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu add: 'add or remove items' translated target: self selector: #addOrRemoveItems: argument: aHandMorph


! !

!SMxSelectionMorph methodsFor: 'halos and balloon help' stamp: 'JuanVuletich 10/13/2010 09:57'!
addHandlesTo: aHaloMorph box: box
	| onlyThese |
	aHaloMorph haloBox: box.
	onlyThese := #(addDismissHandle: addMenuHandle: addGrabHandle: addDragHandle: addDupHandle: addHelpHandle: addGrowHandle: addFontSizeHandle: addFontEmphHandle: addRecolorHandle:).
	SMxPreferences haloSpecifications do:
		[:aSpec | (onlyThese includes: aSpec addHandleSelector) ifTrue:
				[aHaloMorph perform: aSpec addHandleSelector with: aSpec]].
	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!SMxSelectionMorph methodsFor: 'halos and balloon help' stamp: 'di 8/31/2000 22:59'!
addOptionalHandlesTo: aHalo box: box
	aHalo addHandleAt: box leftCenter color: Color blue icon: nil
		on: #mouseUp send: #addOrRemoveItems: to: self.! !

!SMxSelectionMorph methodsFor: 'halos and balloon help' stamp: 'di 8/31/2000 22:59'!
balloonHelpTextForHandle: aHandle
	aHandle eventHandler firstMouseSelector == #addOrRemoveItems:
		ifTrue: [^'Add items to, or remove them from, this selection.'].
	^ super balloonHelpTextForHandle: aHandle! !

!SMxSelectionMorph methodsFor: 'halo commands' stamp: 'di 9/19/2000 18:25'!
borderColor: aColor

	| bordered |
	bordered := selectedItems select: [:m | m isKindOf: SMxBorderedMorph].
	undoProperties ifNil: [undoProperties := bordered collect: [:m | m borderColor]].
	bordered do: [:m | m borderColor: aColor]! !

!SMxSelectionMorph methodsFor: 'halo commands' stamp: 'di 9/19/2000 18:25'!
borderWidth: aWidth

	| bordered |
	bordered := selectedItems select: [:m | m isKindOf: SMxBorderedMorph].
	undoProperties ifNil: [undoProperties := bordered collect: [:m | m borderWidth]].
	bordered do: [:m | m borderWidth: aWidth]! !

!SMxSelectionMorph methodsFor: 'geometry' stamp: 'jcg 2/14/2001 08:58'!
bounds: newBounds
	"Make sure position: gets called before extent:; Andreas' optimization for growing/shrinking in ChangeSet 3119 screwed up selection of morphs from underlying pasteup."

	selectedItems := OrderedCollection new.  "Avoid repostioning items during super position:"
	self position: newBounds topLeft; extent: newBounds extent
! !

!SMxSelectionMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color blue! !

!SMxSelectionMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:39'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SMxSelectionMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!SMxSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'di 8/23/2000 17:06'!
dismissViaHalo

	super dismissViaHalo.
	selectedItems do: [:m | m dismissViaHalo]! !

!SMxSelectionMorph methodsFor: 'halo commands' stamp: 'jmv 3/2/2010 16:30'!
doDup: evt fromHalo: halo handle: dupHandle

	selectedItems := self duplicateMorphCollection: selectedItems.
	selectedItems do: [:m | self owner addMorph: m].
	dupDelta
		ifNil: [	"First duplicate operation -- note starting location"
				dupLoc := self position.
				evt hand grabMorph: self.
				halo removeAllHandlesBut: dupHandle]
		ifNotNil: ["Subsequent duplicate does not grab, but only moves me and my morphs"
				dupLoc := nil.
				self position: self position + dupDelta]! !

!SMxSelectionMorph methodsFor: 'private' stamp: 'jmv 4/27/2010 11:40'!
doneExtending

	otherSelection ifNotNil:
		[selectedItems := otherSelection selectedItems , selectedItems.
		otherSelection delete.
		self setOtherSelection: nil].
	self changed; layoutChanged.
	super privateBounds:
		((Rectangle merging: (selectedItems collect: [:m | m displayBounds]))
			expandBy: 8).
	self changed.
	self addHalo.! !

!SMxSelectionMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/12/2010 11:49'!
drawOn: aCanvas

	| canvas form1 form2 box |
	super drawOn: aCanvas.
	box := bounds.
	selectedItems do: [:m | box := box merge: m fullDisplayBounds].
	box := box expandBy: 1.
	canvas := "Display defaultCanvasClass" SMxFormCanvas depth: 8 over: box.
	selectedItems do: [:m | canvas fullDrawMorph: m].
	form1 := (Form extent: box extent) copyBits: (0@0 extent: box extent) from: canvas form at: 0@0 colorMap: (Color maskingMap: 8).
	form2 := Form extent: box extent.
	(0@0) fourNeighbors do: [:d | form1 displayOn: form2 at: d rule: Form under].
	form1 displayOn: form2 at: 0@0 rule: Form erase.
	aCanvas stencil: form2
		at: box topLeft
		sourceRect: form2 boundingBox
		color: self borderColor
! !

!SMxSelectionMorph methodsFor: 'initialization' stamp: 'jmv 3/8/2010 14:24'!
extendByHand: aHand
	"Assumes selection has just been created and added to some pasteUp or world"
	| startPoint handle |
	startPoint := self position.
	handle := SMxNewHandleMorph new followHand: aHand
		forEachPointDo: [:newPoint | | localPt |
			localPt := self internalizePosition: newPoint from: self world.
			self bounds: (startPoint rect: localPt)]
		lastPointDo: [:newPoint | selectedItems isEmpty ifTrue: [self delete]
												ifFalse: [self doneExtending]].
	aHand attachMorph: handle.
	handle startStepping.! !

!SMxSelectionMorph methodsFor: 'geometry' stamp: 'di 8/31/2000 18:39'!
extent: newExtent

	super extent: newExtent.
	self selectSubmorphsOf: self pasteUpMorph! !

!SMxSelectionMorph methodsFor: 'visual properties' stamp: 'di 9/19/2000 21:53'!
fillStyle: aColor
	undoProperties ifNil: [undoProperties := selectedItems collect: [:m | m fillStyle]].
	selectedItems do: [:m | m fillStyle: aColor]! !

!SMxSelectionMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:23'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	selectedItems := OrderedCollection new.
	itemsAlreadySelected := OrderedCollection new.
	slippage := 0 @ 0! !

!SMxSelectionMorph methodsFor: 'drag and drop' stamp: 'jmv 3/8/2010 14:19'!
justDroppedInto: newOwner event: evt

	selectedItems isEmpty ifTrue:
		["Hand just clicked down to draw out a new selection"
		^ self extendByHand: evt hand].
	dupLoc ifNotNil: [dupDelta := self position - dupLoc].
	selectedItems reverseDo: [:m | 
		SMxWorldState addDeferredUIMessage:
			[m referencePosition: (newOwner externalizePositionFromOwner: m referencePosition to: nil).
			newOwner handleDropMorph:
				(SMxDropEvent new setPosition: evt cursorPoint contents: m hand: evt hand)]].
	selectedItems := nil.
	self removeHalo; delete.
	evt wasHandled: true! !

!SMxSelectionMorph methodsFor: 'menus' stamp: 'di 8/31/2000 20:50'!
maybeAddCollapseItemTo: aMenu
	"... don't "! !

!SMxSelectionMorph methodsFor: 'private' stamp: 'jmv 4/27/2010 10:56'!
selectSubmorphsOf: aMorph

	| newItems removals |
	newItems := aMorph submorphs select:
		[:m | (bounds containsRect: m fullDisplayBounds) 
					and: [m~~self
					and: [(m isKindOf: SMxHaloMorph) not]]].
	otherSelection ifNil: [^ selectedItems := newItems].

	removals := newItems intersection: itemsAlreadySelected.
	otherSelection setSelectedItems: (itemsAlreadySelected copyWithoutAll: removals).
	selectedItems := (newItems copyWithoutAll: removals).
! !

!SMxSelectionMorph methodsFor: 'private' stamp: 'di 8/31/2000 21:36'!
selectedItems

	^ selectedItems! !

!SMxSelectionMorph methodsFor: 'private' stamp: 'jmv 3/2/2010 16:30'!
setOtherSelection: otherOrNil 
	otherSelection := otherOrNil.
	otherOrNil 
		ifNil: [super borderColor: Color blue]
		ifNotNil: [
			itemsAlreadySelected := otherSelection selectedItems.
			super borderColor: Color green]! !

!SMxSelectionMorph methodsFor: 'private' stamp: 'di 8/31/2000 21:45'!
setSelectedItems: items

	selectedItems := items.
	self changed! !

SMxBorderedMorph subclass: #SMxSimpleButtonMorph
	instanceVariableNames: 'target actionSelector arguments actWhen oldColor label font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxSimpleButtonMorph commentStamp: 'efc 3/7/2003 17:46' prior: 0!
I am labeled, rectangular morph which allows the user to click me. I can be configured to send my "target" the message "actionSelector" with "arguments" when I am clicked. I may have a label, implemented as a SMxStringMorph.

Example:

	SMxSimpleButtonMorph new
		target: Smalltalk;
		label: 'Beep!!';
		actionSelector: #beep; 
		openInWorld

Structure:
instance var 	Type		Description 
target 			Object 		The Object to notify upon a click 
actionSelector 	Symbol 		The message to send to Target (#messageName) 
arguments 		Array 		Arguments to send with #actionSelection (optional) 
actWhen 		Symbol 		When to take action: may be #buttonUp (default), #buttonDown,
								#whilePressed, or #startDrag 
oldColor 		Color 		Used to restore color after click 

Another example: a button which quits the image without saving it.

	SMxSimpleButtonMorph new
		target: Smalltalk;
		label: 'quit';
		actionSelector: #snapshot:andQuit:;
		arguments: (Array with: false with: true); 
		openInWorld

!

SMxSimpleButtonMorph subclass: #SMxIconicButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxIconicButton commentStamp: '<historical>' prior: 0!
A "Simple Button" in which the appearance is provided by a Form.!

!SMxIconicButton methodsFor: 'menu' stamp: 'sw 9/28/1999 20:42'!
addLabelItemsTo: aCustomMenu hand: aHandMorph
	"don't do the inherited behavior, since there is no textual label in this case"! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'ar 12/12/2001 01:38'!
borderInset
	self borderStyle: (SMxBorderStyle inset width: 2).! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'ar 12/12/2001 01:38'!
borderNormal
	self borderStyle: (SMxBorderStyle width: 2 color: Color transparent).! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'ar 12/12/2001 01:41'!
borderRaised
	self borderStyle: (SMxBorderStyle raised width: 2).! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'ar 12/17/2001 21:17'!
borderThick
	self borderStyle: (SMxBorderStyle width: 2 color: self raisedColor twiceDarker).! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'jmv 5/28/2006 14:42'!
buttonSetup
	self actWhen: #buttonUp.
	self borderNormal.
	self on: #mouseEnter send: #borderRaised to: self.
	self on: #mouseLeave send: #borderNormal to: self.
	self on: #mouseLeaveDragging send: #borderNormal to: self.
	self on: #mouseDown send: #borderInset to: self.
	self on: #mouseUp send: #borderRaised to: self.! !

!SMxIconicButton methodsFor: 'geometry' stamp: 'jmv 5/6/2009 12:21'!
extent: newExtent
	| i |
	super extent: newExtent.
	submorphs size = 1 ifTrue:
		["keep the icon centered"
		"NOTE: may want to test more that it IS an icon..."
		i := self firstSubmorph.
		i position: self center - (i extent // 2)]! !

!SMxIconicButton methodsFor: 'as yet unclassified' stamp: 'jmv 9/17/2009 10:59'!
labelGraphic: aForm
	| oldLabel graphicalMorph |
	(oldLabel := self findA: SMxSketchMorph)
		ifNotNil: [oldLabel delete].
	graphicalMorph := SMxSketchMorph withForm: aForm.
	"this could use a #fitContents method, like the superclass..."
"	self extent: graphicalMorph extent + (borderWidth + 6)."
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock
! !

!SMxIconicButton methodsFor: 'initialization' stamp: 'jmv 10/11/2010 23:54'!
setDefaultLabel
	self labelGraphic: SMxHaloMorph paintIcon! !

!SMxIconicButton methodsFor: 'as yet unclassified' stamp: 'sw 11/29/1999 20:56'!
shedSelvedge
	self extent: (self extent - (6@6))! !

!SMxSimpleButtonMorph class methodsFor: 'as yet unclassified' stamp: 'di 6/5/2000 08:42'!
newWithLabel: labelString

	^ self basicNew initializeWithLabel: labelString
! !

!SMxSimpleButtonMorph methodsFor: 'submorphs-add/remove' stamp: 'sw 10/8/2000 08:14'!
actWhen
	"acceptable symbols:  #buttonDown, #buttonUp, and #whilePressed"

	^ actWhen! !

!SMxSimpleButtonMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 12/17/2001 21:15'!
actWhen: condition
	"Accepts symbols:  #buttonDown, #buttonUp, and #whilePressed, #startDrag"
	actWhen := condition.
	actWhen == #startDrag ifTrue:[self on: #startDrag send: #doButtonAction to: self].! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
actionSelector

	^ actionSelector
! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
actionSelector: aSymbolOrString

	(nil = aSymbolOrString or:
	 ['nil' = aSymbolOrString or:
	 [aSymbolOrString isEmpty]])
		ifTrue: [^ actionSelector := nil].

	actionSelector := aSymbolOrString asSymbol.
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'jmv 4/15/2009 22:04'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addLabelItemsTo: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'change action selector' translated action: #setActionSelector.
	aCustomMenu add: 'change arguments' translated action: #setArguments.
	aCustomMenu add: 'change when to act' translated action: #setActWhen.
	aCustomMenu add: 'sight target' translated action: #sightTarget:.
	target ifNotNil: [aCustomMenu add: 'clear target' translated action: #clearTarget]
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:06'!
addLabelItemsTo: aCustomMenu hand: aHandMorph 
	aCustomMenu add: 'change label' translated action: #setLabel! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
arguments

	^ arguments
! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
arguments: aCollection

	arguments := aCollection asArray copy.
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'wiz 1/16/2006 20:05'!
clearTarget

	target := nil.
! !

!SMxSimpleButtonMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:37'!
clipsSubmorphs
	^true! !

!SMxSimpleButtonMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:43'!
defaultBorderColor
	^#raised! !

!SMxSimpleButtonMorph methodsFor: 'button' stamp: 'dgd 2/22/2003 18:53'!
doButtonAction
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	(target notNil and: [actionSelector notNil]) 
		ifTrue: 
			[Cursor normal 
				showWhile: [target perform: actionSelector withArguments: arguments]].
	actWhen == #startDrag ifTrue: [oldColor ifNotNil: [self color: oldColor]]! !

!SMxSimpleButtonMorph methodsFor: 'drawing' stamp: 'jmv 5/6/2009 09:10'!
drawOn: aCanvas 

	| w f center x y |
	super drawOn: aCanvas.
	label ifNotNil: [
		f := self fontToUse.
		center := bounds center.
		w := f widthOfString: label.
		x := bounds width > w
			ifTrue: [ center x - (w // 2) ]
			ifFalse: [ bounds left +4].
		y := center y - (f height // 2).
		aCanvas drawString: label at: x@y font: f color: Color black ]! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 12:09'!
fitContents
	| aCenter f w e |
	aCenter := self center.
	label ifNil: [^self].
	f := self fontToUse.
	w := f widthOfString: label.
	e := w@f height.
	self extent: e + (borderWidth + 6).
	self center: aCenter! !

!SMxSimpleButtonMorph methodsFor: 'drawing' stamp: 'jmv 5/6/2009 08:55'!
fontToUse
	| fontToUse |
	fontToUse := font ifNil: [SMxPreferences standardButtonFont].
	"
	Could add emphasis...
	^(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [fontToUse]
		ifFalse: [fontToUse emphasized: emphasis]
	"
	^fontToUse! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'jmv 1/6/2005 23:43'!
handlesMouseDown: evt
	^  true
! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:15'!
handlesMouseStillDown: evt
	^actWhen == #whilePressed! !

!SMxSimpleButtonMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 09:08'!
initialize

	self initializeAllButLabel; setDefaultLabel! !

!SMxSimpleButtonMorph methodsFor: 'initialization' stamp: 'jmv 7/9/2009 09:45'!
initializeAllButLabel

	super initialize.
	self color: (Color r: 0.4 g: 0.8 b: 0.6).
	self borderColor: self defaultBorderColor.
	target := nil.
	actionSelector := #flash.
	arguments := EmptyArray.
	actWhen := #buttonUp
! !

!SMxSimpleButtonMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 09:09'!
initializeWithLabel: labelString

	self initializeAllButLabel; label: labelString
! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 09:09'!
label

	^label ifNil: ['']! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 08:55'!
label: aString
	"Label this button with the given string."

	self label: aString font: nil! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: 'jmv 5/6/2009 12:11'!
label: aString font: aFont
	"Label this button with the given string."

	label := aString asString.
	font := aFont.
	self fitContents! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'jmv 9/16/2009 11:36'!
mouseDown: evt

	| now dt |
	super mouseDown: evt.
	now := Time millisecondClockValue.
	oldColor := self fillStyle. 
	actWhen == #buttonDown
		ifTrue: [ self doButtonAction ]
		ifFalse: [ self updateVisualState: evt; refreshWorld ].
	dt := Time millisecondClockValue - now max: 0.  "Time it took to do"
	dt < 200 ifTrue: [(Delay forMilliseconds: 200-dt) wait].
	self mouseStillDown: evt.! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:10'!
mouseMove: evt
	actWhen == #buttonDown ifTrue: [^ self].
	self updateVisualState: evt.! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:15'!
mouseStillDown: evt
	actWhen == #whilePressed ifFalse:[^self].
	(self containsPoint: evt cursorPoint) ifTrue:[self doButtonAction].! !

!SMxSimpleButtonMorph methodsFor: 'event handling' stamp: 'ar 12/12/2001 01:39'!
mouseUp: evt
	super mouseUp: evt.
	oldColor ifNotNil:
		["if oldColor nil, it signals that mouse had not gone DOWN
		inside me, e.g. because of a cmd-drag; in this case we want
		to avoid triggering the action!!"
		self color: oldColor.
		oldColor := nil.
		(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint])
			ifTrue: [self doButtonAction]].
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: ''!
setActWhen
	actWhen := (SMxSelectionMenu selections: #(buttonDown buttonUp whilePressed))
		startUpWithCaption: 'Choose one of the following conditions'
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:05'!
setActionSelector

	| newSel |
	newSel := SMxFillInTheBlankMorph
		request:
'Please type the selector to be sent to
the target when this button is pressed'
		initialAnswer: actionSelector.
	newSel isEmpty ifFalse: [self actionSelector: newSel].
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:05'!
setArguments

	| s newArgs newArgsArray |
	s := WriteStream on: ''.
	arguments do: [:arg | arg printOn: s. s nextPutAll: '. '].
	newArgs := SMxFillInTheBlankMorph
		request:
'Please type the arguments to be sent to the target
when this button is pressed separated by periods'
		initialAnswer: s contents.
	newArgs isEmpty ifFalse: [
		newArgsArray := Compiler evaluate: '{', newArgs, '}' for: self logged: false.
		self arguments: newArgsArray].
! !

!SMxSimpleButtonMorph methodsFor: 'initialization' stamp: 'sw 9/28/1999 14:05'!
setDefaultLabel
	self label: 'Flash'.
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'StephaneDucasse 12/11/2010 21:05'!
setLabel

	| newLabel |
	newLabel := SMxFillInTheBlankMorph
		request: 'Please enter a new label for this button'
		initialAnswer: self label.
	newLabel isEmpty ifFalse: [self label: newLabel].
! !

!SMxSimpleButtonMorph methodsFor: 'menu' stamp: 'JuanVuletich 11/1/2010 15:29'!
sightTarget: event 
	| bullseye menu newTarget |
	owner
		ifNil: [^ self ].
	bullseye := Point fromUserWithCursor: Cursor target.
	SimpleMorphicUIManager smxActiveHand position: bullseye.
	menu := SMxCustomMenu new.
	(owner morphsAt: bullseye) do: [ :m |
		menu add: m printString action: m ].
	menu title: self printString, ' targets... '.
	newTarget := menu startUp.
	newTarget
		ifNil: [^ self].
	self target: newTarget! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
target

	^ target
! !

!SMxSimpleButtonMorph methodsFor: 'accessing' stamp: ''!
target: anObject

	target := anObject
! !

!SMxSimpleButtonMorph methodsFor: 'visual properties' stamp: 'jmv 3/23/2009 19:37'!
updateVisualState: evt
	
	oldColor ifNotNil: [
		 self color: 
			((self containsPoint: evt cursorPoint)
				ifTrue: [oldColor mixed: 0.5 with: Color white]
				ifFalse: [oldColor])]
! !

!SMxSimpleButtonMorph methodsFor: 'copying' stamp: 'tk 1/6/1999 17:55'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].
arguments := arguments collect: [:each |
	deepCopier references at: each ifAbsent: [each]].
! !

!SMxSimpleButtonMorph methodsFor: 'copying' stamp: 'jmv 5/6/2009 09:16'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"target := target.		Weakly copied"
"actionSelector := actionSelector.		a Symbol"
"arguments := arguments.		All weakly copied"
actWhen := actWhen veryDeepCopyWith: deepCopier.
oldColor := oldColor veryDeepCopyWith: deepCopier.

"shared"
label := label.
font := font! !

SMxBorderedMorph subclass: #SMxTextMorph
	instanceVariableNames: 'text wrapFlag paragraph editor backgroundColor pauseBlinking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Text Support'!

!SMxTextMorph commentStamp: 'KLC 12/19/2003 10:35' prior: 0!
TextMorphs support display of text with emphasis.  They also support reasonable text-editing capabilities, as well as embedded hot links, and the ability to embed submorphs in the text.

Late in life, SMxTextMorph was made a subclass of SMxBorderedMorph to provide border and background color if desired.  In order to keep things compatible, protocols have been redirected so that color (preferably textColor) relates to the text, and backgroundColor relates to the inner fill color.

Text display is clipped to the innerBounds of the rectangle, and text composition is normally performed within a rectangle which is innerBounds inset by the margins parameter.

If text has been embedded in another object, one can elect to fill the owner's shape, in which case the text will be laid out in the shape of the owner's shadow image (including any submorphs other than the text).  One can also elect to have the text avoid occlusions, in which case it will avoid the bounds of any sibling morphs that appear in front of it.  It may be necessary to update bounds in order for the text runaround to notice the presence of a new occluding shape.

The optional autoFitContents property enables the following feature:  if the text contents changes, then the bounds of the morph will be adjusted to fit the minimum rectangle that encloses the text (plus any margins specified).  Similarly, any attempt to change the size of the morph will be resisted if this parameter is set.  Except...

If the wrapFlag parameter is true, then text will be wrapped at word boundaries based on the composition width (innerBounds insetBy: margins) width.  Thus an attempt to resize the morph in autofit mode, if it changes the width, will cause the text to be recomposed with the new width, and then the bounds will be reset to the minimum enclosing rectangle.  Similarly, if the text contents are changed with the wrapFlag set to true, word wrap will be performed based on the current compostion width, after which the bounds will be set (or not), based on the autoFitcontents property.

Note that fonts can only be applied to the SMxTextMorph as a whole.  While you can change the size, color, and emphasis of a subsection of the text and have it apply to only that subsection, changing the font changes the font for the entire contents of the SMxTextMorph. 

Yet to do:
Make a comprehensive control for the eyedropper, with border width and color, inner color and text color, and margin widths.!

SMxTextMorph subclass: #SMxStringMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Text Support'!

!SMxStringMorphEditor commentStamp: '<historical>' prior: 0!
I am a textMorph used as a pop-up editor for StringMorphs.  I present a yellow background and I go away when a CR is typed or when the user clicks elsewhere.!

!SMxStringMorphEditor class methodsFor: 'new-morph participation' stamp: 'kfr 5/1/2000 13:41'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!SMxStringMorphEditor methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:32'!
drawOn: aCanvas

	aCanvas fillRectangle: bounds color: Color yellow muchLighter.
	^ super drawOn: aCanvas! !

!SMxStringMorphEditor methodsFor: 'display' stamp: 'sw 4/20/2003 15:46'!
initialize
	"Initialize the receiver.  Give it a white background"

	super initialize.
	self backgroundColor: Color white.
	self color: Color red! !

!SMxStringMorphEditor methodsFor: 'event handling' stamp: 'JuanVuletich 10/18/2010 09:04'!
keyStroke: evt
	"This is hugely inefficient, but it seems to work, and it's unlikely it will ever need
	to be any more efficient -- it's only intended to edit single-line strings."

	| char priorEditor oldSel newSel |

	(self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].

	(((char := evt keyCharacter) = Character enter) or: [(char = Character cr)
			or: [char = $s and: [evt commandKeyPressed]]])
				ifTrue: [owner doneWithEdits; acceptContents.
	self flag: #arNote. "Probably unnecessary"
						evt hand releaseKeyboardFocus.
						^ self delete].
	
	(char = $l and: [evt commandKeyPressed]) ifTrue:   "cancel"
		[owner cancelEdits.
		evt hand releaseKeyboardFocus.
		^ self delete].

	oldSel := self editor selectionInterval.
	super keyStroke: evt.
	owner interimContents: self contents asString.
	newSel := self editor selectionInterval.

	priorEditor := self editor.  "Save editor state"
	self releaseParagraph.  "Release paragraph so it will grow with selection."
	self paragraph.      "Re-instantiate to set new bounds"
	self installEditorToReplace: priorEditor.  "restore editor state"

	oldSel = newSel ifTrue:
		["There is a bug that causes characters to be misplaced when the second
		character typed is wider than the first.  This fixes it (ugh)."
		self editor selectFrom: newSel first + 1 to: newSel last + 1].

! !

!SMxStringMorphEditor methodsFor: 'event handling' stamp: 'jmv 2/3/2009 15:51'!
keyboardFocusChange: aBoolean
	| hadFocus |
	hadFocus := owner notNil and: [ owner hasFocus ].
	super keyboardFocusChange: aBoolean.
	aBoolean ifFalse: [
		hadFocus ifTrue: [
			owner lostFocusWithoutAccepting; doneWithEdits].
		^ self delete]! !

!SMxTextMorph class methodsFor: 'new-morph participation' stamp: 'kfr 5/1/2000 13:42'!
includeInNewMorphMenu
	^ true! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 4/22/1998 10:57'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S.
	Accept the current contents and end editing.
	This default implementation does nothing."
	self updateFromParagraph! !

!SMxTextMorph methodsFor: 'layout' stamp: 'tk 6/30/1998 17:06'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto me."

	self addMorphFront: aMorph fromWorldPosition: aMorph position.
		"Make a TextAnchor and install it in a run."! !

!SMxTextMorph methodsFor: 'editing' stamp: 'sw 8/12/2002 01:10'!
acceptOnCR
	"Answer whether the receiver wants to accept when the Return key is hit.  Generic SMxTextMorph has no such feature, but subclasses may."

	^ false! !

!SMxTextMorph methodsFor: 'menu' stamp: 'jmv 9/12/2009 23:19'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	"Add text-related menu items to the menu"

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu 
		addUpdating: #autoFitString
		target: self
		action: #autoFitOnOff.
	aCustomMenu 
		addUpdating: #wrapString
		target: self
		action: #wrapOnOff.
	SMxPreferences simpleMenus
		ifFalse: [
			aCustomMenu add: 'code pane menu...' translated
				action: #yellowButtonActivity.
			aCustomMenu add: 'code pane shift menu....' translated
				action: #shiftedYellowButtonActivity]! !

!SMxTextMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 12/17/2001 13:21'!
addMorphFront: aMorph fromWorldPosition: wp 
	"Overridden for more specific re-layout and positioning"
	aMorph textAnchorType == #document 
		ifFalse:[^self anchorMorph: aMorph at: wp type: aMorph textAnchorType].
	self addMorphFront: aMorph.
! !

!SMxTextMorph methodsFor: 'anchors' stamp: 'JuanVuletich 10/12/2010 23:48'!
anchorMorph: aMorph at: aPoint type: anchorType
	| relPt index newText block |
	aMorph owner == self ifTrue:[self removeMorph: aMorph].
	aMorph textAnchorType: nil.
	aMorph relativeTextAnchorPosition: nil.
	self addMorphFront: aMorph.
	aMorph textAnchorType: anchorType.
	aMorph relativeTextAnchorPosition: nil.
	anchorType == #document ifTrue:[^self].
	relPt := self internalizePosition: aPoint from: self world.
	index := (self paragraph characterBlockAtPoint: relPt) stringIndex.
	newText := Text string: (String value: 1) attribute: (TextAnchor new anchoredMorph: aMorph).
	anchorType == #inline ifTrue:[
		self paragraph replaceFrom: index to: index-1 with: newText.
	] ifFalse:[
		index := index min: paragraph text size.
		index := paragraph text string lastIndexOf: Character cr startingAt: index ifAbsent:[0].
		block := paragraph characterBlockForIndex: index+1.
		aMorph relativeTextAnchorPosition: (relPt x - bounds left) @ (relPt y - block top ).
		self paragraph replaceFrom: index+1 to: index with: newText.
	].
	self fit.! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'sw 1/12/98 23:40'!
asText
	^ text! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/12/2001 22:25'!
autoFit: trueOrFalse
	self isAutoFit = trueOrFalse ifTrue: [^ self].
	self autoFitOnOff! !

!SMxTextMorph methodsFor: 'menu' stamp: 'di 7/27/2001 13:19'!
autoFitOnOff
	self setProperty: #autoFitContents toValue: self isAutoFit not.
	self isAutoFit ifTrue: [self fit]! !

!SMxTextMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:06'!
autoFitString
	"Answer the string to put in a menu that will invite the user to 
	switch autoFit mode"
	^ (self isAutoFit
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'text auto fit' translated! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 6/22/2001 09:33'!
backgroundColor
	^ backgroundColor! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'jmv 10/2/2009 09:55'!
backgroundColor: newColor
	backgroundColor = newColor ifFalse: [
		backgroundColor := newColor.
		self changed ]! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/19/2001 11:08'!
borderWidth: newWidth
	super borderWidth: newWidth.
	paragraph ifNotNil: [self composeToBounds].! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 4/22/1998 11:00'!
cancelEdits
	"The message is sent when the user hits enter or Cmd-L.
	Cancel the current contents and end editing.
	This default implementation does nothing."
	self releaseParagraph! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 10/5/1998 13:55'!
chooseAlignment
	self editor changeAlignment.
	self updateFromParagraph! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 10/5/1998 13:55'!
chooseEmphasis
	self editor changeEmphasis.
	self updateFromParagraph! !

!SMxTextMorph methodsFor: 'editing' stamp: 'sw 9/27/1999 12:13'!
chooseEmphasisOrAlignment
	self editor changeEmphasisOrAlignment.
	self updateFromParagraph! !

!SMxTextMorph methodsFor: 'editing' stamp: 'ar 12/17/2001 13:09'!
chooseFont
	self editor changeTextFont.
	self updateFromParagraph.! !

!SMxTextMorph methodsFor: 'private' stamp: 'di 6/22/2001 09:10'!
clippingRectangle
	^ self innerBounds! !

!SMxTextMorph methodsFor: 'private' stamp: 'jmv 9/12/2009 23:16'!
composeToBounds
	"Compose my text to fit my bounds.
	If any text lies outside my bounds, it will be clipped, or
	if I have successors, it will be shown in the successors."

	self releaseParagraph.
	self paragraph positionWhenComposed: self position! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'jmv 9/12/2009 23:30'!
container
	"Return the container for composing this text.  There are 2 cases:
	1.  container is nil, and wrap is true -- grow downward as necessary,
	2.  container is nil, and wrap is false -- grow in 2D as necessary."

	wrapFlag ifTrue: [
		^ self innerBounds withHeight: 9999999].
	^ self innerBounds topLeft extent: 9999999@9999999! !

!SMxTextMorph methodsFor: 'accessing' stamp: ''!
contents

	^ text! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 9/30/97 15:48'!
contents: stringOrText
	^ self contentsAsIs: stringOrText! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'jmv 8/2/2010 16:29'!
contents: stringOrText wrappedTo: width
	"Accept new text contents.  Lay it out, wrapping to width.
	Then fit my height to the result."
"Why was this ever needed?"
"	self newContents: ''."
	wrapFlag := true.
	self basicExtent: width truncated@self height.
	self newContents: stringOrText! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'jmv 9/12/2009 23:16'!
contentsAsIs: stringOrText
	"Accept new text contents with line breaks only as in the text.
	Fit my width and height to the result."
	wrapFlag := false.
	self newContents: stringOrText! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 9/30/97 09:51'!
contentsWrapped: stringOrText
	"Accept new text contents.  Lay it out, wrapping within my current width.
	Then fit my height to the result."
	wrapFlag := true.
	self newContents: stringOrText! !

!SMxTextMorph methodsFor: 'copying' stamp: 'jmv 8/12/2009 19:16'!
copy
	"jmv note We don't copy TextStyles anymore. We want to preserve their identity."
	^ super copy
		text: text copy
		wrap: wrapFlag 
		color: color! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'ar 8/23/2001 21:23'!
crAction
	"Return the action to perform when encountering a CR in the input"
	^self valueOfProperty: #crAction! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'ar 8/23/2001 21:23'!
crAction: aMessageSend
	"Return the action to perform when encountering a CR in the input"
	^self setProperty: #crAction toValue: aMessageSend! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'sw 5/22/2003 02:39'!
cursor
	"Answer the receiver's logical cursor position"

	| loc |
	loc := self valueOfProperty: #textCursorLocation  ifAbsentPut: [1].
	loc := loc min: text string size.
	^ loc rounded
	! !

!SMxTextMorph methodsFor: 'drawing' stamp: 'di 7/12/2001 10:45'!
debugDrawLineRectsOn: aCanvas
	"Shows where text line rectangles are"
	self paragraph lines do:
		[:line | aCanvas frameRectangle: line rectangle color: Color brown]
! !

!SMxTextMorph methodsFor: 'initialization' stamp: 'di 6/22/2001 09:36'!
defaultColor
	"Return the default fill style for the receiver"
	^ Color black! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'JuanVuletich 10/13/2010 10:19'!
defaultLineHeight
	^ text initialStyle lineGrid! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 6/29/2010 20:58'!
doubleClick: evt
	self handleInteraction: [editor doubleClick: evt]! !

!SMxTextMorph methodsFor: 'drawing' stamp: 'jmv 6/29/2010 12:47'!
drawNullTextOn: aCanvas
	"make null text frame visible"

	aCanvas fillRectangle: bounds color: 
		((Color black) alpha: 0.1)! !

!SMxTextMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:33'!
drawOn: aCanvas
	"Draw the receiver on a canvas"

	| fauxBounds |
	self setDefaultContentsIfNil.
	super drawOn: aCanvas.  "Border and background if any"
	false ifTrue: [self debugDrawLineRectsOn: aCanvas].  "show line rects for debugging"
	text size = 0
		ifTrue: [self drawNullTextOn: aCanvas].
	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := bounds topLeft corner: self innerBounds bottomRight.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: color! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 10/5/1998 13:56'!
editor
	"Return my current editor, or install a new one."
	editor ifNotNil: [^ editor].
	^ self installEditorToReplace: nil! !

!SMxTextMorph methodsFor: 'private' stamp: 'JuanVuletich 10/13/2010 11:06'!
editorClass
	^TextEditor! !

!SMxTextMorph methodsFor: 'editing' stamp: 'jmv 7/29/2009 18:37'!
enterClickableRegion: evt
	| index isLink |
	evt hand hasSubmorphs ifTrue:[^self].
	evt hand temporaryCursor ifNotNil:[^self].
	paragraph ifNotNil:[
		index := (paragraph characterBlockAtPoint: evt position) stringIndex.
		isLink := (paragraph text attributesAt: index) 
					anySatisfy:[:attr| attr mayActOnClick].
		isLink ifTrue:[Cursor webLink show] ifFalse:[Cursor normal show].
	].
! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'jmv 9/12/2009 23:07'!
extent: aPoint 
	| newExtent priorEditor |
	priorEditor := editor.
	self isAutoFit
		ifTrue: [wrapFlag ifFalse: [^ self].  "full autofit can't change"
				newExtent := aPoint truncated max: self minimumExtent.
				newExtent x = self extent x ifTrue: [^ self].  "No change of wrap width"
				self releaseParagraph.  "invalidate the paragraph cache"
				super extent: newExtent.
				priorEditor
					ifNil: [self fit]  "since the width has changed..."
					ifNotNil: [self installEditorToReplace: priorEditor]]
		ifFalse: [super extent: (aPoint truncated max: self minimumExtent).
				wrapFlag ifFalse: [^ self].  "no effect on composition"
				self composeToBounds]
! !

!SMxTextMorph methodsFor: 'visual properties' stamp: 'dgd 2/16/2003 20:03'!
fillStyle
	"Return the current fillStyle of the receiver."
	^ self
		valueOfProperty: #fillStyle
		ifAbsent: [backgroundColor
				ifNil: [Color transparent]]! !

!SMxTextMorph methodsFor: 'visual properties' stamp: 'di 6/22/2001 09:52'!
fillStyle: aFillStyle
	"Set the current fillStyle of the receiver."
	self setProperty: #fillStyle toValue: aFillStyle.
	"Workaround for Morphs not yet converted"
	backgroundColor := aFillStyle asColor.
	self changed.! !

!SMxTextMorph methodsFor: 'private' stamp: 'JuanVuletich 10/13/2010 10:19'!
fit
	"Adjust my bounds to fit the text.  Should be a no-op if autoFit is not specified.
	Required after the text changes,
	or if wrapFlag is true and the user attempts to change the extent."

	| newExtent para |
	self isAutoFit 
		ifTrue: [
			newExtent := (self paragraph extent max: 9 @ text initialStyle lineGrid) + (0 @ 2).
			newExtent := newExtent + (2 * borderWidth).
			newExtent ~= bounds extent 
				ifTrue: [
					para := paragraph.	"Save para (layoutChanged smashes it)"
					self basicExtent: newExtent.
					paragraph := para].
			].

	"These statements should be pushed back into senders"
	self paragraph positionWhenComposed: self position.
	self changed	"Too conservative: only paragraph composition
					should cause invalidation."! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 4/12/98 11:36'!
handleEdit: editBlock
	"Ensure that changed areas get suitably redrawn"
	self selectionChanged.  "Note old selection"
		editBlock value.
	self selectionChanged.  "Note new selection"
	self updateFromParagraph  "Propagate changes as necessary"! !

!SMxTextMorph methodsFor: 'editing' stamp: 'jmv 9/2/2009 13:51'!
handleInteraction: interactionBlock
	"Perform the changes in interactionBlock, noting any change in selection
	and possibly a change in the size of the paragraph (ar 9/22/2001 - added for TextPrintIts)"
	"Also couple ParagraphEditor to Morphic keyboard events"
	| oldEditor oldParagraph oldSize |
	oldEditor := editor.
	oldParagraph := paragraph.
	oldSize := oldParagraph text size.

	self selectionChanged.  "Note old selection"

		interactionBlock value.

	(oldParagraph == paragraph) ifTrue:[
		"this will not work if the paragraph changed"
		editor := oldEditor.     "since it may have been changed while in block"
	].
	self selectionChanged.  "Note new selection"
	(oldSize = paragraph text size)
		ifFalse:[self updateFromParagraph].
! !

!SMxTextMorph methodsFor: 'events-processing' stamp: 'jmv 11/10/2008 13:03'!
handleKeystroke: anEvent
	"System level event handling."

	anEvent wasHandled ifTrue:[^self].
	self handlesKeyboard ifFalse:	[^ self].
	anEvent wasHandled: true.
	self keyStroke: anEvent! !

!SMxTextMorph methodsFor: 'events-processing' stamp: 'ar 9/26/2001 22:21'!
handleMouseMove: anEvent
	"Re-implemented to allow for mouse-up move events"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 11/18/2008 13:53'!
handlesKeyboard

	^self visible! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 1/6/2005 23:43'!
handlesMouseDown: evt
	^ self innerBounds containsPoint: evt cursorPoint! !

!SMxTextMorph methodsFor: 'editing' stamp: 'di 4/21/1998 13:22'!
hasUnacceptedEdits: aBoolean
	"Ignored here, but noted in SMxTextMorphForEditView"
! !

!SMxTextMorph methodsFor: 'initialization' stamp: 'jmv 8/12/2009 19:28'!
initialize
	"jmv note: We don't copy TextStyles all over the place anymore. We want to preserve their identity."
	super initialize.
	borderWidth := 0.
	wrapFlag := true.
! !

!SMxTextMorph methodsFor: 'private' stamp: 'AlainPlantec 12/15/2010 09:18'!
installEditorToReplace: priorEditor 
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [ stateArray := priorEditor stateArray] .
	editor := self editorClass forMorph: self.
	priorEditor ifNotNil: [ editor stateArrayPut: stateArray ].
	self selectionChanged.
	^editor! !

!SMxTextMorph methodsFor: 'classification' stamp: 'jmv 12/5/2009 20:20'!
is: aSymbol
	^ aSymbol = #SMxTextMorph or: [ super is: aSymbol ]! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/12/2001 14:01'!
isAutoFit
	^ self valueOfProperty: #autoFitContents ifAbsent: [true]
! !

!SMxTextMorph methodsFor: 'testing' stamp: 'JuanVuletich 11/1/2010 15:54'!
isOpaqueMorph
	"Overridden from SMxBorderedMorph to test backgroundColor instead of (text) color."
	(backgroundColor isNil or: [ backgroundColor isOpaque not ])
		ifTrue: [^ false].
		
		
	self borderWidth > 0 ifTrue: [
		((self borderColor isColor) and: [ self borderColor isOpaque not]) ifTrue: [
			^false ]].
	^true! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'RAA 8/21/2001 11:18'!
isWrapped
	
	^wrapFlag! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:58'!
keyStroke: evt
	"Handle a keystroke event."
	| action |

	(self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].
	self pauseBlinking.
	evt keyValue = 13 ifTrue: ["CR - check for special action"
		action := self crAction.
		action ifNotNil: [
			^action value]].
	self handleInteraction: [ editor processKeyStroke: evt ].
	self updateFromParagraph.
	super keyStroke: evt  "sends to keyStroke event handler, if any"! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 8/26/2010 10:59'!
keyboardFocusChange: aBoolean
	
	paragraph ifNotNil: [ paragraph focused: aBoolean ].
	aBoolean
		ifTrue: [
			"A hand is wanting to send us characters..."
			editor ifNil: [ self editor ].	"Forces install"
			self startBlinking ]
		ifFalse: [ self stopBlinking ].
	self changed! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'JuanVuletich 10/13/2010 10:19'!
minimumExtent

	borderWidth ifNil: [^ 9@16].
	^(9@(text initialStyle lineGrid+2)) + (borderWidth*2)! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 9/10/2010 11:41'!
mouseDown: evt
	"Make this SMxTextMorph be the keyboard input focus, if it isn't already,
		and repond to the text selection gesture."

	super mouseDown: evt.

	"If we don't focus, Get focus, and do nothing else (the user will need to click again to do further interaction)"
	self hasKeyboardFocus ifFalse: [
		editor disregardNextMouseUp.
		^evt hand newKeyboardFocus: self].
	self handleInteraction: [editor mouseDown: evt]! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 9/2/2009 13:53'!
mouseMove: evt
	evt redButtonPressed ifFalse: [^ self enterClickableRegion: evt].
	self handleInteraction: [editor mouseMove: evt]! !

!SMxTextMorph methodsFor: 'event handling' stamp: 'jmv 9/10/2010 15:49'!
mouseUp: evt
	super mouseUp: evt.
	self pauseBlinking.
	self handleInteraction: [editor mouseUp: evt]! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/13/2010 09:16'!
newContents: stringOrText
	"Accept new text contents."
	"If my text is all the same font, use the font for my new contents"
	| newText oldEmbeddedMorphs |
	newText := stringOrText isString
		ifTrue: [ | textSize |
			(text notNil and: [
				(textSize := text size) > 0 and: [ (text runLengthFor: 1) = textSize ]])
				ifTrue: [ | attribs |
					attribs := text attributesAt: 1.
					Text
						string: stringOrText copy
						attributes: attribs ]
				ifFalse: [ Text fromString: stringOrText copy ]]
		ifFalse: [ stringOrText copy asText ].	"should be veryDeepCopy?"
	(text = newText and: [ text runs = newText runs ]) ifTrue: [ ^ self ].
	text ifNotNil: [
		oldEmbeddedMorphs := text embeddedMorphs.
		self removeAllMorphsIn: oldEmbeddedMorphs.
		oldEmbeddedMorphs do: [ :m |
			m delete ]].
	text := newText.
	"add all morphs off the visible region; they'll be moved into the right 
	place when they become visible. (this can make the scrollable area too 
	large, though)"
	newText embeddedMorphs do: [ :m |
		self addMorph: m.
		m position: -1000 @ 0 ].
	self releaseParagraph.
	"update the paragraph cache"
	self paragraph.
	"re-instantiate to set bounds"
	self world ifNotNil: [ self world startSteppingSubmorphsOf: self ].! !

!SMxTextMorph methodsFor: 'blinking cursor' stamp: 'jmv 8/26/2010 11:36'!
onBlinkCursor
	"Blink the cursor"
	paragraph ifNil: [ ^nil ].
	paragraph showCaret: paragraph showCaret not | pauseBlinking.
	pauseBlinking := false.
	paragraph caretRect ifNotNil: [ :r | self invalidRect: r].! !

!SMxTextMorph methodsFor: 'private' stamp: 'AlainPlantec 12/15/2010 09:11'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed"
	paragraph ifNotNil: [^ paragraph].

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph := self paragraphClass new.
	paragraph focused: self hasKeyboardFocus.
	paragraph
		compose: text
		style: "textStyle copy" TextStyle default copy
		from: 1
		in: self container.
	wrapFlag ifFalse: [
		"Was given huge container at first... now adjust"
		paragraph adjustRightX].
	self fit.

	^ paragraph! !

!SMxTextMorph methodsFor: 'private' stamp: 'AlainPlantec 12/15/2010 09:12'!
paragraphClass
	^ MultiNewParagraph! !

!SMxTextMorph methodsFor: 'blinking cursor' stamp: 'jmv 9/10/2010 10:41'!
pauseBlinking
	"Show a solid cursor (non blinking) for a short while"
	pauseBlinking := true.
	paragraph ifNotNil: [
		"Show cursor right now if needed"
		paragraph showCaret ifFalse: [
			paragraph showCaret: true.
			paragraph caretRect ifNotNil: [ :r | self invalidRect: r ]]]! !

!SMxTextMorph methodsFor: 'notifications' stamp: 'jmv 9/21/2009 14:30'!
possiblyChanged! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'jmv 3/2/2010 16:42'!
privateMoveBy: delta 
	super privateMoveBy: delta.
	editor 
		ifNil: [ paragraph ifNotNil: [paragraph moveBy: delta]]
		ifNotNil: [ 
			"When moving text with an active editor, save and restore all state."
			paragraph moveBy: delta.
			self installEditorToReplace: editor]! !

!SMxTextMorph methodsFor: 'caching' stamp: 'jm 11/13/97 16:32'!
releaseCachedState

	super releaseCachedState.
	self releaseParagraph.
! !

!SMxTextMorph methodsFor: 'private' stamp: 'jmv 9/21/2009 09:23'!
releaseParagraph

	"Paragraph instantiation is lazy -- it will be created only when needed"
	"release editor too"
	editor ifNotNil: [
		self selectionChanged.
		self paragraph selectionStart: nil selectionStop: nil.	"most likely not needed"
		editor := nil].
	paragraph ifNotNil: [
		paragraph := nil]
! !

!SMxTextMorph methodsFor: 'private' stamp: 'JuanVuletich 10/12/2010 23:48'!
removedMorph: aMorph
	| range |
	range := text find: (TextAnchor new anchoredMorph: aMorph).
	range ifNotNil: [
		self paragraph replaceFrom: range first to: range last with: Text new.
		self fit].
	aMorph textAnchorType: nil.
	aMorph relativeTextAnchorPosition: nil.
	super removedMorph: aMorph.! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'AlainPlantec 12/15/2010 09:15'!
selection
	^editor ifNotNil: [ editor selection ]! !

!SMxTextMorph methodsFor: 'private' stamp: 'di 11/30/97 12:13'!
selectionChanged
	self paragraph selectionRects do: [:r | self invalidRect: r]! !

!SMxTextMorph methodsFor: 'private' stamp: 'tk 11/13/2001 01:57'!
setDefaultContentsIfNil
	"Set the default contents"

	| toUse |
	text ifNil:
		[toUse := self valueOfProperty: #defaultContents.
		toUse ifNil: [toUse :='abc' asText "allBold"].	"try it plain for a while"
		text := toUse]! !

!SMxTextMorph methodsFor: 'menu' stamp: 'tk 7/14/2000 12:20'!
shiftedYellowButtonActivity
	"Supply the normal 'code pane' menu to use its text editing commands from a menu."

	self editor pluggableYellowButtonActivity: true.
	self changed.
! !

!SMxTextMorph methodsFor: 'blinking cursor' stamp: 'jmv 9/10/2010 10:40'!
startBlinking
	"And show the cursor"
	pauseBlinking := true.
	"Start blinking in a short while"
	paragraph ifNotNil: [ paragraph showCaret: true ].
	self
		startStepping: #onBlinkCursor
		at: Time millisecondClockValue
		arguments: nil
		stepTime: 500.! !

!SMxTextMorph methodsFor: 'blinking cursor' stamp: 'jmv 9/10/2010 10:42'!
stopBlinking
	"And do not show cursor anymore."
	self stopSteppingSelector: #onBlinkCursor.
	paragraph ifNotNil: [
		"Hide cursor right now if needed"
		paragraph showCaret ifTrue: [
			paragraph showCaret: false.
			paragraph caretRect ifNotNil: [ :r | self invalidRect: r ]]]! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'tk 1/10/2001 13:52'!
text
	^ text! !

!SMxTextMorph methodsFor: 'private' stamp: 'jmv 9/12/2009 23:03'!
text: t wrap: wrap color: c
	"Private -- for use only in morphic duplication"
	text := t.
	wrapFlag := wrap.
	color := c.
	paragraph := editor := nil! !

!SMxTextMorph methodsFor: 'geometry' stamp: 'di 3/1/98 11:40'!
textBounds
	^ bounds! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/21/2001 10:37'!
textColor

	^ color! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/21/2001 10:35'!
textColor: aColor

	color = aColor ifTrue: [^ self].
	color := aColor.
	self changed.
! !

!SMxTextMorph methodsFor: 'private' stamp: 'JuanVuletich 10/13/2010 09:17'!
updateFromParagraph
	"A change has taken place in my paragraph, as a result of editing and I must be updated.  If a line break causes recomposition of the current paragraph, or it the selection has entered a different paragraph, then the current editor will be released, and must be reinstalled with the resulting new paragraph, while retaining any editor state, such as selection, undo state, and current typing emphasis."
	"removed multiple lined paragraph support (predecessor and successor)"

	| newStyle sel oldEditor |
	paragraph ifNil: [ ^self ].
	wrapFlag ifNil: [ wrapFlag := true ].
	editor ifNotNil: [
		oldEditor := editor.
		sel := editor selectionInterval.
		editor storeSelectionInParagraph].
	text := paragraph text.
	self fit.
	self layoutChanged.

	sel ifNotNil: [
		editor ifNil: [
			"Reinstate selection after, eg, style change"
			self installEditorToReplace: oldEditor]]! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'tk 12/16/1998 11:58'!
userString
	"Do I have a text string to be searched on?"

	^ text string! !

!SMxTextMorph methodsFor: 'copying' stamp: 'JuanVuletich 10/9/2010 19:06'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied at all, but shared.
	Warning!!!! Every instance variable defined in this class must be handled.
	We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	text := text veryDeepCopyWith: deepCopier.
	wrapFlag := wrapFlag veryDeepCopyWith: deepCopier.
	paragraph := paragraph veryDeepCopyWith: deepCopier.
	editor := editor veryDeepCopyWith: deepCopier.
	backgroundColor := backgroundColor veryDeepCopyWith: deepCopier! !

!SMxTextMorph methodsFor: 'accessing' stamp: 'di 7/27/2001 13:10'!
wrapFlag: aBoolean
	"Change whether contents are wrapped to the container."

	aBoolean == wrapFlag ifTrue: [^ self].
	wrapFlag := aBoolean.
	self composeToBounds! !

!SMxTextMorph methodsFor: 'menu' stamp: 'di 7/27/2001 13:20'!
wrapOnOff
	self wrapFlag: wrapFlag not! !

!SMxTextMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:18'!
wrapString
	"Answer the string to put in a menu that will invite the user to 
	switch autoFit mode"
	^ (wrapFlag
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'text wrap to bounds' translated! !

!SMxTextMorph methodsFor: 'menu' stamp: 'tk 7/14/2000 12:17'!
yellowButtonActivity
	"Supply the normal 'code pane' menu to use its text editing commands from a menu."

	self editor pluggableYellowButtonActivity: false.
	self changed.
! !

SMxTextMorph subclass: #SMxTextMorphForEditView
	instanceVariableNames: 'editView acceptOnCR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Text Support'!

!SMxTextMorphForEditView class methodsFor: 'new-morph participation' stamp: 'kfr 5/1/2000 13:41'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!SMxTextMorphForEditView methodsFor: 'editing' stamp: 'di 4/22/1998 10:57'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S.
	Accept the current contents and end editing."
	self updateFromParagraph.
	editView accept.! !

!SMxTextMorphForEditView methodsFor: 'editing' stamp: 'sw 8/12/2002 00:02'!
acceptOnCR
	"Answer whether the receiver wants to accept when the Return key is hit"

	^ acceptOnCR == true! !

!SMxTextMorphForEditView methodsFor: 'accept/cancel' stamp: 'di 9/11/1998 15:42'!
acceptOnCR: trueOrFalse
	acceptOnCR := trueOrFalse! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'jmv 10/9/2009 12:50'!
autoScrollView: evt
	"This is kind of a hack because the SMxPluggableTextMorph expects me to first expand the selection before auto scrolling will work."
	| localEvt |
	localEvt := evt internalizedToOwnerOf: self from: editView.
	super mouseMove: localEvt.
	editView scrollSelectionIntoView: localEvt.! !

!SMxTextMorphForEditView methodsFor: 'editing' stamp: 'di 4/22/1998 11:03'!
cancelEdits
	"The message is sent when the user hits enter or Cmd-L.
	Cancel the current contents and end editing."
	self releaseParagraph.
	editView cancel! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'jmv 8/2/2010 14:08'!
doubleClick: evt
	super doubleClick: evt.
	editView scrollSelectionIntoView: evt.
! !

!SMxTextMorphForEditView methodsFor: 'drawing' stamp: 'jmv 6/29/2010 12:42'!
drawNullTextOn: aCanvas
	"No need to draw any visual indicator. We are inside some window."! !

!SMxTextMorphForEditView methodsFor: 'drawing' stamp: 'AlainPlantec 12/15/2010 09:35'!
drawOn: aCanvas
	self useSelectionBar
		ifTrue: [self paragraph displaySelectionBarOn: aCanvas].
	self useExtraSelection 
		ifTrue: [self paragraph displayExtraSelectionOn: aCanvas].
	super drawOn: aCanvas.
! !

!SMxTextMorphForEditView methodsFor: 'edit view' stamp: 'di 6/22/1998 01:31'!
editView
	^ editView! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'jmv 7/30/2009 11:28'!
editorClass

	^editView editorClass! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/20/2010 11:49'!
findAndSelect: aRegex startingAt: anIndex searchBackwards: searchBackwards
	| where |
	self
		handleEdit: [
			where := self editor
				findAndSelect: aRegex
				startingAt: anIndex
				searchBackwards: searchBackwards].
	editView scrollSelectionIntoView.
	^ where! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/13/2010 14:10'!
findNextString: aSubString startingAt: searchIdx
	| where |
	self
		handleEdit: [where := self editor findNextString: aSubString startingAt: searchIdx].
	^ where
! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/11/2010 22:09'!
findRegex
	^ self editor findRegex! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/11/2010 21:49'!
findReplaceDialog
	^ EditorFindReplaceDialogWindow singleton! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/11/2010 22:08'!
findText
	^ self editor findText! !

!SMxTextMorphForEditView methodsFor: 'macpal' stamp: 'di 11/10/1998 10:13'!
flash
	^ editView flash! !

!SMxTextMorphForEditView methodsFor: 'editing' stamp: 'jmv 9/2/2009 13:52'!
handleInteraction: interActionBlock
	"Overridden to pass along a model to the editor for, eg, link resolution, doits, etc"

	self editor model: editView model.  "For evaluateSelection, etc"
	^ super handleInteraction: interActionBlock! !

!SMxTextMorphForEditView methodsFor: 'editing' stamp: 'di 4/21/1998 13:23'!
hasUnacceptedEdits: aBoolean
	"Set the hasUnacceptedEdits flag in my view."

	editView hasUnacceptedEdits: aBoolean! !

!SMxTextMorphForEditView methodsFor: 'initialization' stamp: 'di 9/11/1998 15:43'!
initialize
	super initialize.
	acceptOnCR := false! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:59'!
keyStroke: evt

	| view |
	(self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].
		
	"Maybe disable? Precludes the use of up and down arrows with control,
	that are standard keystrokes in Windows to control the cursor.
	Problem: At least Mac and Win VM generate ctrl-up and ctrl-down for
	mouse wheel events.
	I guess most people would prefer the mouse wheel to work properly..."
	(editView scrollByKeyboard: evt)
		ifTrue: [ ^self ].

	self editor model: editView model.  "For evaluateSelection"
	view := editView.  "Copy into temp for case of a self-mutating doit"
	(acceptOnCR and: [evt keyCharacter = Character cr])
		ifTrue: [^ self editor accept].
	super keyStroke: evt.
	view scrollSelectionIntoView! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'jmv 4/9/2009 14:21'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"

	super keyboardFocusChange: aBoolean.
	editView invalidateBorderFeedback! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'AlainPlantec 12/15/2010 09:38'!
mouseDown: event

	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].

	"If we don't focus, Get focus, and do nothing else (the user will need to click again to do further interaction)"
	self hasKeyboardFocus ifFalse: [
		^event hand newKeyboardFocus: self].

	super mouseDown: event.

	event hand
		waitForSimulatedYellow: self 
		event: event
		dblClkSel: #doubleClick:! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'jmv 10/9/2009 13:01'!
mouseMove: evt
	| editEvt |
	super mouseMove: evt.
	evt redButtonPressed ifFalse: [^ self].
	editEvt := evt externalizedFromOwnerOf: self to: editView.
	(editEvt position y between: editView top and: editView bottom) ifFalse:[
		"Start auto-scrolling"
		self startStepping: #autoScrollView:
			at: Time millisecondClockValue
			arguments: (Array with: editEvt)
			stepTime: 100. "fast enough"
	] ifTrue:[
		self stopSteppingSelector: #autoScrollView:.
	].! !

!SMxTextMorphForEditView methodsFor: 'event handling' stamp: 'ar 11/8/2000 15:10'!
mouseUp: evt
	super mouseUp: evt.
	self stopSteppingSelector: #autoScrollView:.
	editView scrollSelectionIntoView: evt.
! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/11/2010 22:15'!
openFindDialog
	self sharesFindReplace 
		ifTrue: [ (self findReplaceDialog on: self) open]
		ifFalse: [self flash]! !

!SMxTextMorphForEditView methodsFor: 'notifications' stamp: 'jmv 9/21/2009 14:29'!
possiblyChanged
	editView possiblyChanged! !

!SMxTextMorphForEditView methodsFor: 'multi level undo' stamp: 'AlainPlantec 11/8/2010 22:14'!
redoTypeIn: aText interval: anInterval 
	self handleEdit: [self editor redoTypeIn: aText interval: anInterval]! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/17/2010 16:02'!
refreshExtraSelection
	| fullRefreshNeeded |
	fullRefreshNeeded := self useSelectionBar.
	self useFindReplaceSelection
		ifTrue: [fullRefreshNeeded := true.
			self findText isEmpty
				ifTrue: [self paragraph findReplaceSelectionRegex: nil]
				ifFalse: [self paragraph findReplaceSelectionRegex: self findRegex]].
	self useSecondarySelection
		ifTrue: [fullRefreshNeeded := true.
			self  selection isEmptyOrNil
			ifTrue: [self paragraph secondarySelection: nil]
			ifFalse: [self paragraph secondarySelection: self selection asString]].
	fullRefreshNeeded 
		ifTrue: [self paragraph extraSelectionChanged.
			"> Alain: should be that : 
			 > self paragraph extraSelectionRects do: [:r | self invalidRect: r]
			 > but it doesn't work"
			self invalidRect: self bounds]
! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/10/2010 21:30'!
replaceAll: aRegex with: aText
	self
		handleEdit: [self editor replaceAll: aRegex with: aText].
! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/11/2010 23:44'!
replaceAll: aRegex with: aText startingAt: startIdx
	self
		handleEdit: [self editor replaceAll: aRegex with: aText startingAt: startIdx].
! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/10/2010 23:52'!
replaceSelectionWith: aReplacementText
	self handleEdit: [self editor replaceSelectionWith: aReplacementText]! !

!SMxTextMorphForEditView methodsFor: 'miscellaneous' stamp: 'jmv 9/10/2010 09:12'!
selectAll
	"Tell my editor to select all the text"

	self editor selectAll.
	self changed! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/16/2010 12:08'!
selectionChanged
	self sharesFindReplace 
		ifTrue: [self changed: #findReplaceSelection].
	self useExtraSelection
		ifTrue: [self refreshExtraSelection].
	super selectionChanged! !

!SMxTextMorphForEditView methodsFor: 'edit view' stamp: 'di 4/21/1998 13:09'!
setEditView: editPane
	editView := editPane! !

!SMxTextMorphForEditView methodsFor: 'find-replace' stamp: 'AlainPlantec 11/11/2010 21:44'!
sharesFindReplace
	^ true! !

!SMxTextMorphForEditView methodsFor: 'multi level undo' stamp: 'AlainPlantec 11/8/2010 22:14'!
undoRedoExchange: aninterval with: anotherInterval
	self handleEdit: [self editor undoRedoExchange: aninterval with: anotherInterval]! !

!SMxTextMorphForEditView methodsFor: 'multi level undo' stamp: 'AlainPlantec 11/8/2010 22:14'!
undoTypeIn: aText interval: anInterval 
	self handleEdit: [self editor undoTypeIn: aText interval: anInterval]! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/8/2010 22:14'!
updateFromParagraph  
	super updateFromParagraph.
	editView setScrollDeltas.! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/16/2010 12:03'!
useExtraSelection
	^ self useFindReplaceSelection or: [self useSecondarySelection]
! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/12/2010 22:34'!
useFindReplaceSelection
	^ TextEditor useFindReplaceSelection! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/12/2010 11:51'!
useSecondarySelection
	^ TextEditor useSecondarySelection! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'AlainPlantec 11/17/2010 15:26'!
useSelectionBar
	^ TextEditor useSelectionBar! !

!SMxTextMorphForEditView methodsFor: 'private' stamp: 'jmv 5/8/2009 19:00'!
yellowButtonActivity: shiftKeyState
	^ editView yellowButtonActivity: shiftKeyState! !

SMxMorph subclass: #SMxHaloMorph
	instanceVariableNames: 'target innerTarget positionOffset angleOffset growingOrRotating haloBox'
	classVariableNames: 'HandleSize Icons'
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxHaloMorph commentStamp: '<historical>' prior: 0!
This morph provides a halo of handles for its target morph. Dragging, duplicating, rotating, and resizing to be done by mousing down on the appropriate handle. There are also handles for help and for a menu of infrequently used operations.!

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:11'!
collapseIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #collapseIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAAAoAAAAQAQMAAAAVsXwDAAAABlBMVEX///8AAABVwtN+AAAA
HklEQVR4XmNABnIMDPUMDIkNDAcboegxI0jEBqEEAJsXBuQ1QnVfAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
debugIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #debugIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
KklEQVR4XmOAA2YGBsYGBoYDDAIHGCQOMPAfYGB/wMBQwMBgwcAgAVcFAILSBWOb9kW7AAAA
AElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
dismissIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #dismissIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
HklEQVR4XmNABjwGDHwFDOwPGJgPgBCQAeQCBZEAAHDUBMlabZn2AAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
dragIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #dragIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
HklEQVR4XmOAAxkLBgEOBvEXDCwKCATkAgWBUjAAAFCjA2d9sn1WAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
duplicateIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #duplicateIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
IUlEQVR4XmNABvINDAJA9INBoINBkINBnoOBEYh+ICsBAGU3BBJiY6CZAAAAAElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
fontEmphIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #fontEmphIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
IklEQVR4XmNABvJ7GOQXMEgoMEg4MMhVMMg5MEg0QBEMAABvFwTnHxf6BAAAAABJRU5ErkJg
gg==' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:12'!
fontSizeIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #fontSizeIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
IElEQVR4XmNAgA8MDA1QxNfAwPGAgaOBgacBRAIRDAAAkngGC2jZE2AAAAAASUVORK5CYII=' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
fontStyleIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #fontStyleIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
IElEQVR4XmNABvIVDJwODBwODFwODHwFIJIDjGQc4EoASL8DJ688wKQAAAAASUVORK5CYII=' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
grabIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #grabIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
KklEQVR4XmMAAsYGEGJyYGBRYOAQYBDgYFB/wiCiwcBjABIBIvYHDDAAAG8cBEtTRUljAAAA
AElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
helpIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #helpIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
JElEQVR4XmOAAOYDDOwPGHgMQIgBiBIYGA4wMDaAEBDAGQwMAIjBBXexsDsxAAAAAElFTkSu
QmCC' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'class initialization' stamp: 'StephaneDucasse 12/11/2010 18:23'!
initialize
	"SMxHaloMorph initialize"
  
	HandleSize := 16.
	Icons := Dictionary new.
	
! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
menuIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #menuIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
E0lEQVR4XmOAA/4PUMQhgE4iAQClMwZDP3yc0QAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
paintIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #paintIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
KUlEQVR4XmOAAwkGBjkGBu4GBp4DDCwJDGwGDMwSDIwdDAw3GBgK4KoAV3UEFJk+w6QAAAAA
SUVORK5CYII=' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
recolorIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #recolorIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
KElEQVR4XmNAAAEGhgoG5g8MjB8YmBIYWBIYOBYwCDIwCDEwyCAUAQBsPgQaQ/Ai2wAAAABJ
RU5ErkJggg==' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
rotateIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #rotateIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
I0lEQVR4XmOAAMYGBiYwg/0BA4sGg4oKCIkogLgg4ABSAAYAW2gEA7XBkhoAAAAASUVORK5C
YII=' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:13'!
scaleIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ Icons at: #scaleIcon ifAbsentPut: [
		Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAQMAAAAlPW0iAAAABlBMVEX///8AAABVwtN+AAAA
GklEQVR4XmNABvwXGDgCEAjIZRBg4P+ArAQAYQsELjspgUgAAAAASUVORK5CYII=' base64Decoded asByteArray readStream ]! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'jmv 1/12/2010 11:14'!
addCollapseHandle: handleSpec
	"Add the collapse handle, with all of its event handlers set up, unless the target's owner is not the world or the hand."

	| collapseHandle |
	target owner
		ifNil: [ ^self ]	"nil happens, amazingly"
		ifNotNil: [ :to |
			(to isWorldMorph or: [ to is: #SMxHandMorph ])
				ifFalse: [ ^self ]].
		
	collapseHandle := self addHandle: handleSpec
		on: #mouseDown send: #mouseDownInCollapseHandle:with: to: self.
	collapseHandle on: #mouseUp send: #maybeCollapse:with: to: self.
	collapseHandle on: #mouseMove send: #setDismissColor:with: to: self
! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 15:51'!
addDebugHandle: handleSpec
	SMxPreferences debugHaloHandle ifTrue:
		[self addHandle: handleSpec
			on: #mouseDown send: #doDebug:with: to: self]
! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'ar 10/25/2000 17:48'!
addDismissHandle: handleSpec
	| dismissHandle |
	dismissHandle := self addHandle: handleSpec
		on: #mouseDown send: #mouseDownInDimissHandle:with: to: self.
	dismissHandle on: #mouseUp send: #maybeDismiss:with: to: self.
	dismissHandle on: #mouseDown send: #setDismissColor:with: to: self.
	dismissHandle on: #mouseMove send: #setDismissColor:with: to: self.
! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'ar 10/25/2000 17:48'!
addDragHandle: haloSpec
	(self addHandle: haloSpec on: #mouseDown send: #startDrag:with: to: self)
		on: #mouseMove send: #doDrag:with: to: self


! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:15'!
addDupHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doDup:with: to: self

! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'jmv 1/12/2010 11:21'!
addFontEmphHandle: haloSpec 
	(innerTarget is: #SMxTextMorph) 
		ifTrue: [
			self 
				addHandle: haloSpec
				on: #mouseDown
				send: #chooseEmphasisOrAlignment
				to: innerTarget]! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'jmv 1/12/2010 11:21'!
addFontSizeHandle: haloSpec 
	(innerTarget is: #SMxTextMorph) 
		ifTrue: [
			self 
				addHandle: haloSpec
				on: #mouseDown
				send: #chooseFont
				to: innerTarget]! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:11'!
addGrabHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doGrab:with: to: self

! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'jmv 5/27/2006 17:08'!
addGrowHandle: haloSpec
		(self addHandle: haloSpec
				on: #mouseDown send: #startGrow:with: to: self)
				on: #mouseMove send: #doGrow:with: to: self;
				on: #keyStroke send: #strokeGrow:with: to: self
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'JuanVuletich 10/12/2010 09:24'!
addHandle: handleSpec on: eventName send: selector to: recipient 
	"Add a handle within the halo box as per the haloSpec, and set it up to respond to the given event by sending the given selector to the given recipient.  Return the handle."

	| handle aPoint iconName colorToUse |
	aPoint := self 
				positionIn: haloBox
				horizontalPlacement: handleSpec horizontalPlacement
				verticalPlacement: handleSpec verticalPlacement.
	handle := SMxEllipseMorph 
				newBounds: (Rectangle center: aPoint extent: HandleSize asPoint)
				color: (colorToUse := Color colorFrom: handleSpec color).
	self addMorph: handle.
	(iconName := handleSpec iconSymbol) ifNotNil: [
			| form |
			form := Icons at: iconName ifAbsent: [self class perform: iconName].
			form ifNotNil: [
					handle addMorphCentered: (SMxImageMorph new
								image: form;
								color: colorToUse makeForegroundColor;
								lock)]].
	handle 
		on: #mouseUp
		send: #endInteraction
		to: self.
	handle 
		on: eventName
		send: selector
		to: recipient.
	handle 
		setBalloonText: (target balloonHelpTextForHandle: handle) translated.
	^handle! !

!SMxHaloMorph methodsFor: 'private' stamp: 'JuanVuletich 10/12/2010 09:25'!
addHandleAt: aPoint color: aColor icon: iconName on: eventName send: selector to: recipient
	"Add a handle centered at the given point with the given color, and set it up to respond to the given event by sending the given selector to the given recipient.  Return the handle."
	| handle |
	handle := SMxEllipseMorph
		newBounds: (Rectangle center: aPoint extent: self handleSize asPoint)
		color: aColor.
	self addMorph: handle.
	iconName ifNotNil:
		[ | form |
		form := Icons at: iconName ifAbsent: [self class perform: iconName].
		form ifNotNil:
			[handle addMorphCentered: (SMxImageMorph new
				image: form; 
				color: aColor makeForegroundColor;
				lock)]].
	handle on: #mouseUp send: #endInteraction to: self.
	handle on: eventName send: selector to: recipient.
	handle setBalloonText: (target balloonHelpTextForHandle: handle) translated.
	^ handle
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 10/11/2010 23:25'!
addHandles
	| box |
	target isWorldMorph ifTrue: [^ self addHandlesForWorldHalos].

	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target worldBoundsForHalo.  "update my size"
	box := self basicBox.

	target addHandlesTo: self box: box.

	self addName.
	growingOrRotating := false.
	self layoutChanged.
	self changed.
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/15/2009 22:06'!
addHandlesForWorldHalos
	"Add handles for world halos, like the man said"

	| box w |
	w := self world ifNil:[target world].
	self removeAllMorphs.  "remove old handles, if any"
	self bounds: target bounds.
	box := w bounds insetBy: 9.
	target addWorldHandlesTo: self box: box.

	self addNameBeneath: (box insetBy: (0@0 corner: 0@10)) string: innerTarget externalName.
	growingOrRotating := false.
	self layoutChanged.
	self changed.
! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:16'!
addHelpHandle: haloSpec
	target balloonText ifNotNil:
		[(self addHandle: haloSpec on: #mouseDown send: #mouseDownOnHelpHandle: to: innerTarget)
			on: #mouseUp send: #deleteBalloon to: innerTarget]
! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'sw 1/26/2000 16:05'!
addMenuHandle: haloSpec
	self addHandle: haloSpec on: #mouseDown send: #doMenu:with: to: self! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/15/2009 22:06'!
addName
	"Add a name readout at the bottom of the halo."

	self addNameBeneath: self basicBox string: target externalName
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/12/2009 00:10'!
addNameBeneath: outerRectangle string: aString 
	"Add a name display centered beneath the bottom of the outer rectangle. Return the handle."

	| nameMorph namePosition w |
	w := self world ifNil: [target world].
	nameMorph := SMxStringMorph contents: aString.
	nameMorph color: Color magenta.
	namePosition := outerRectangle bottomCenter 
				- ((nameMorph width // 2) @ (self handleSize negated // 2 - 1)).
	nameMorph 
		position: (namePosition min: w viewBox bottomRight - nameMorph extent y + 2).
	self addMorph: nameMorph.
	^nameMorph! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'RAA 3/15/2001 11:24'!
addRecolorHandle: haloSpec
	"Add a recolor handle to the receiver, if appropriate"

	| recolorHandle |

	"since this halo now opens a more general properties panel, allow it in all cases"
	"innerTarget canSetColor ifTrue:"

	recolorHandle := self addHandle: haloSpec on: #mouseUp send: #doRecolor:with: to: self.
	recolorHandle on: #mouseUp send: #doRecolor:with: to: self

! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'ar 10/25/2000 17:49'!
addRotateHandle: haloSpec
	(self addHandle: haloSpec on: #mouseDown send: #startRot:with: to: self)
		on: #mouseMove send: #doRot:with: to: self

! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 10/28/1999 15:39'!
addSimpleHandlesForWorldHalos
	"Nothing special at present here -- just use the regular handles.  Cannot rotate or resize world"

	self addHandlesForWorldHalos
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'ar 10/7/2000 23:36'!
basicBox
	| aBox minSide anExtent w |
	minSide := 4 * self handleSize.
	anExtent := ((self width + self handleSize + 8) max: minSide) @
				((self height + self handleSize + 8) max: minSide).
	aBox := Rectangle center: self center extent: anExtent.
	w := self world ifNil:[target outermostWorldMorph].
	^ w
		ifNil:
			[aBox]
		ifNotNil:
			[aBox intersect: (w viewBox insetBy: 8@8)]
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 11/12/2006 22:07'!
basicBoxForSimpleHalos
	| w |
	w := self world ifNil:[target outermostWorldMorph].
	^ (target worldBoundsForHalo expandBy: self handleAllowanceForIconicHalos)
			intersect: (w bounds insetBy: 8@8)
! !

!SMxHaloMorph methodsFor: 'meta-actions' stamp: 'jmv 3/8/2010 14:19'!
blueButtonDown: event
	"Transfer the halo to the next likely recipient"
	target ifNil:[^self delete].
	event hand obtainHalo: self.
	positionOffset := event position - (target externalizePositionFromOwner: target position to: owner).
	"wait for drags or transfer"
	event hand 
		waitForClicksOrDrag: self 
		event: event
		clkSel: #transferHalo:
		dblClkSel: nil
		dblClkTimeoutSel: nil
		dragSel: #dragTarget:! !

!SMxHaloMorph methodsFor: 'updating' stamp: 'jmv 4/27/2010 10:44'!
changed
	"Quicker to invalidate handles individually if target is large (especially the world)"

	self extent > (200@200)
		ifTrue: [(target notNil and: [target ~~ self world]) ifTrue:
					["Invalidate 4 outer strips first, thus subsuming separate damage."
					(self fullDisplayBounds areasOutside: target bounds) do:
						[:r | self invalidRect: r]].
				self submorphsDo: [:m | m changed]]
		ifFalse: [super changed].
! !

!SMxHaloMorph methodsFor: 'geometry testing' stamp: 'jmv 3/2/2010 16:02'!
containsPoint: aPoint 
	"This method is overridden so that, once up, the handles will stay up as long as the mouse is within the box that encloses all the handles even if it is not over any handle or over its owner."

	^target
		ifNil: [super containsPoint: aPoint] 
		ifNotNil: [false]! !

!SMxHaloMorph methodsFor: 'events-processing' stamp: 'jmv 10/7/2009 22:45'!
containsPoint: aPoint event: anEvent
	"Blue buttons are handled by the halo"
	(anEvent isMouse and:[anEvent isMouseDown and:[anEvent blueButtonPressed]])
		ifFalse:[^super containsPoint: aPoint event: anEvent].
	^self fullBounds containsPoint: anEvent position! !

!SMxHaloMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.6
		g: 0.8
		b: 1.0! !

!SMxHaloMorph methodsFor: 'private' stamp: 'di 9/26/2000 15:16'!
directionArrowLength
	^ 25! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 6/17/1999 16:58'!
dismiss
	"Remove my target from the world."

	| w |
	self isThisEverCalled. "Seemingly no longer enfranchised"
	w := self world.
	w ifNotNil: [w stopStepping: target].
	self delete.
	target dismissViaHalo! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/8/2009 18:54'!
doDebug: evt with: menuHandle
	"Ask hand to invoke the a debugging menu for my inner target.  If shift key is down, immediately put up an inspector on the inner target"

	| menu |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: nil.
	self world displayWorld.
	evt shiftPressed ifTrue: 
		[self delete.
		^ innerTarget inspectInMorphic: evt].

	menu := innerTarget buildDebugMenu: evt hand.
	menu addTitle: (innerTarget externalName truncateWithElipsisTo: 40).
	menu popUpInWorld: self world! !

!SMxHaloMorph methodsFor: 'private' stamp: 'ar 10/24/2000 18:41'!
doDirection: anEvent with: directionHandle
	anEvent hand obtainHalo: self.
	self removeAllHandlesBut: directionHandle! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 3/8/2010 14:26'!
doDrag: evt with: dragHandle
	| thePoint |
	evt hand obtainHalo: self.
	thePoint := target internalizePositionToOwner: evt position - positionOffset from: owner.
	target setConstrainedPosition: thePoint hangOut: true.
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 1/15/2005 20:35'!
doDup: evt with: dupHandle 
	"Ask hand to duplicate my target."

	(target isKindOf: SMxSelectionMorph) 
		ifTrue: 
			[^target 
				doDup: evt
				fromHalo: self
				handle: dupHandle].
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: dupHandle.
	self setTarget: (target duplicateMorph: evt).
	evt hand grabMorph: target.
	self step.	"update position if necessary"
	evt hand addMouseListener: self	"Listen for the drop"! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 10/2/2001 22:35'!
doGrab: evt with: grabHandle
	"Ask hand to grab my target."

	self obtainHaloForEvent: evt andRemoveAllHandlesBut: grabHandle.
	evt hand grabMorph: target.
	self step. "update position if necessary"
	evt hand addMouseListener: self. "Listen for the drop"! !

!SMxHaloMorph methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:41'!
doGrow: evt with: growHandle
	"Called while the mouse is down in the grow handle"

	| newExtent |
	evt hand obtainHalo: self.
newExtent := evt cursorPoint - positionOffset - target bounds topLeft.
	evt shiftPressed ifTrue: [newExtent := (newExtent x max: newExtent y) asPoint].
	(newExtent x = 0 or: [newExtent y = 0]) ifTrue: [^ self].
	target setExtentFromHalo: newExtent.
	growHandle position: evt cursorPoint - (growHandle extent // 2).
	self layoutChanged
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/8/2009 18:54'!
doMenu: evt with: menuHandle
	"Ask hand to invoke the halo menu for my inner target."

	| menu |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: nil.
	self world displayWorld.
	menu := innerTarget buildHandleMenu: evt hand.
	innerTarget addTitleForHaloMenu: menu.
	menu popUpInWorld: self world.
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 5/23/2009 00:50'!
doRecolor: evt with: aHandle
	"The mouse went down in the 'recolor' halo handle.  Allow the user to change the color of the innerTarget"

	evt hand obtainHalo: self.
	(aHandle containsPoint: evt cursorPoint)
		ifFalse:  "only do it if mouse still in handle on mouse up"
			[self delete.
			target addHalo: evt]
		ifTrue:
			[innerTarget changeColor]! !

!SMxHaloMorph methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:41'!
doRot: evt with: rotHandle
	"Update the rotation of my target if it is rotatable.  Keep the relevant command object up to date."

	| degrees |
	evt hand obtainHalo: self.
	degrees := (evt cursorPoint - (target externalizePositionFromOwner: target referencePosition to: target world)) degrees.
	degrees := degrees - angleOffset degrees.
	degrees := degrees detentBy: 10.0 atMultiplesOf: 90.0 snap: false.
	degrees = 0.0
		ifTrue: [rotHandle color: Color lightBlue]
		ifFalse: [rotHandle color: Color blue].
	rotHandle submorphsDo:
		[:m | m color: rotHandle color makeForegroundColor].
	self removeAllHandlesBut: rotHandle.

	target rotationDegrees: degrees.

	rotHandle position: evt cursorPoint - (rotHandle extent // 2).
	self layoutChanged! !

!SMxHaloMorph methodsFor: 'events' stamp: 'jmv 3/8/2010 14:26'!
dragTarget: event
	"Begin dragging the target"
	| thePoint |
	thePoint := target internalizePositionToOwner: event position - positionOffset from: owner.
	target setConstrainedPosition: thePoint hangOut: true.
	event hand newMouseFocus: self.! !

!SMxHaloMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:27'!
drawOn: aCanvas 
	"Draw this morph only if it has no target."

	target ifNil: [^super drawOn: aCanvas].
	SMxPreferences showBoundsInHalo 
		ifTrue: [
			aCanvas 
				frameAndFillRectangle: bounds
				fillColor: Color transparent
				borderWidth: 1
				borderColor: Color blue]! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 8/26/2008 13:11'!
endInteraction
	"Clean up after a user interaction with the a halo control"

	(target isInWorld not or: [owner isNil]) ifTrue: [^self].
	self isInWorld 
		ifTrue: [
			"make sure handles show in front, even if flex shell added"
			self comeToFront.
			self addHandles]! !

!SMxHaloMorph methodsFor: 'accessing' stamp: 'sw 1/26/2000 15:36'!
haloBox: aBox
	haloBox := aBox! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:42'!
handleAllowanceForIconicHalos
	^ 12! !

!SMxHaloMorph methodsFor: 'events-processing' stamp: 'nk 6/26/2002 07:19'!
handleListenEvent: anEvent
	"We listen for possible drop events here to add back those handles after a dup/grab operation"

	(anEvent isMouse and:[anEvent isMove not]) ifFalse:[^ self]. "not interested"
	anEvent hand removeMouseListener: self. "done listening"
	(self world ifNil: [target world]) ifNil: [^ self].
	self addHandles  "and get those handles back"! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 12/21/1999 15:19'!
handleSize
	^ HandleSize! !

!SMxHaloMorph methodsFor: 'meta-actions' stamp: 'ar 9/15/2000 16:42'!
handlerForBlueButtonDown: anEvent
	"Blue button was clicked within the receiver"
	^self! !

!SMxHaloMorph methodsFor: 'initialization' stamp: 'jmv 10/11/2010 23:24'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	growingOrRotating := false! !

!SMxHaloMorph methodsFor: 'accessing' stamp: 'jm 5/22/1998 16:28'!
innerTarget

	^ innerTarget
! !

!SMxHaloMorph methodsFor: 'geometry testing' stamp: 'jmv 10/8/2009 09:02'!
isOrthoRectangularMorph
	^false! !

!SMxHaloMorph methodsFor: 'private' stamp: 'aoy 2/15/2003 21:10'!
maybeCollapse: evt with: collapseHandle 
	"Ask hand to collapse my target if mouse comes up in it."

	evt hand obtainHalo: self.
	self delete.
	(collapseHandle containsPoint: evt cursorPoint) 
		ifFalse: 
			[
			target addHalo: evt]
		ifTrue: 
			[
			target collapse]! !

!SMxHaloMorph methodsFor: 'private' stamp: 'JuanVuletich 10/10/2010 08:18'!
maybeDismiss: evt with: dismissHandle
	"Ask hand to dismiss my target if mouse comes up in it."

	evt hand obtainHalo: self.
	(dismissHandle containsPoint: evt cursorPoint)
		ifFalse:
			[self delete.
			target addHalo: evt]
		ifTrue:
			[target resistsRemoval ifTrue:
				[(SMxPopUpMenu
					confirm: 'Really throw this away' translated
					trueChoice: 'Yes' translated
					falseChoice: 'Um, no, let me reconsider' translated) ifFalse: [^ self]].

			self delete.
			target dismissViaHalo]! !

!SMxHaloMorph methodsFor: 'private' stamp: 'ar 10/24/2000 18:42'!
maybeDoDup: evt with: dupHandle
	evt hand obtainHalo: self.
	^ target okayToDuplicate ifTrue:
		[self doDup: evt with: dupHandle]! !

!SMxHaloMorph methodsFor: 'WiW support' stamp: 'RAA 6/27/2000 19:12'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^7		"Halos are very front-like things"! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 10/3/2001 00:21'!
mouseDownInCollapseHandle: evt with: collapseHandle
	"The mouse went down in the collapse handle; collapse the morph"

	self obtainHaloForEvent: evt andRemoveAllHandlesBut: collapseHandle.
	self setDismissColor: evt with: collapseHandle! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 12/6/2004 09:51'!
mouseDownInDimissHandle: evt with: dismissHandle
	evt hand obtainHalo: self.
	self removeAllHandlesBut: dismissHandle.
	dismissHandle color: Color darkGray.! !

!SMxHaloMorph methodsFor: 'event handling' stamp: 'jmv 3/8/2010 14:26'!
mouseMove: evt
	"Drag our target around"
	| thePoint |
	thePoint := target internalizePositionToOwner: (evt position - positionOffset) from: owner.
	target setConstrainedPosition: thePoint hangOut: true.! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 11/10/2008 13:07'!
obtainHaloForEvent: evt andRemoveAllHandlesBut: aHandle
	"Make sure the event's hand correlates with the receiver, and remove all handles except the given one.  If nil is provided as the handles argument, the result is that all handles are removed.  Note that any pending edits to the name-string in the halo are accepted at this time."

	evt hand obtainHalo: self.
	self removeAllHandlesBut: aHandle! !

!SMxHaloMorph methodsFor: 'events' stamp: 'jmv 3/8/2010 14:19'!
popUpFor: aMorph event: evt
	"This message is sent by morphs that explicitly request the halo on a button click. Note: anEvent is in aMorphs coordinate frame."

	| hand anEvent |
	self flag: #workAround.	"We should really have some event/hand here..."
	anEvent := evt
				ifNil: 
					[hand := aMorph world activeHand.
					hand ifNil: [hand := aMorph world primaryHand]. 
					hand lastEvent internalizedToOwnerOf: aMorph from: nil]
				ifNotNil: 
					[hand := evt hand.
					evt].
	self target: aMorph.
	hand halo: self.
	hand world addMorphFront: self.
	positionOffset := anEvent position 
				- (aMorph externalizePositionFromOwner: aMorph position to: owner).
	self startStepping! !

!SMxHaloMorph methodsFor: 'geometry' stamp: 'di 9/26/2000 21:03'!
position: pos
	"Halos display imprefectly if their coordinates are non-integral
		-- especially the direction handles."

	^ super position: pos asIntegerPoint! !

!SMxHaloMorph methodsFor: 'handles' stamp: 'ar 1/30/2001 23:32'!
positionIn: aBox horizontalPlacement: horiz verticalPlacement: vert
	| xCoord yCoord |

	horiz == #left
		ifTrue:	[xCoord := aBox left].
	horiz == #leftCenter
		ifTrue:	[xCoord := aBox left + (aBox width // 4)].
	horiz == #center
		ifTrue:	[xCoord := (aBox left + aBox right) // 2].
	horiz == #rightCenter
		ifTrue:	[xCoord := aBox left + ((3 * aBox width) // 4)].
	horiz == #right
		ifTrue:	[xCoord := aBox right].

	vert == #top
		ifTrue:	[yCoord := aBox top].
	vert == #topCenter
		ifTrue:	[yCoord := aBox top + (aBox height // 4)].
	vert == #center
		ifTrue:	[yCoord := (aBox top + aBox bottom) // 2].
	vert == #bottomCenter
		ifTrue:	[yCoord := aBox top + ((3 * aBox height) // 4)].
	vert == #bottom
		ifTrue:	[yCoord := aBox bottom].

	^ xCoord asInteger @ yCoord asInteger! !

!SMxHaloMorph methodsFor: 'events-processing' stamp: 'ar 10/10/2000 22:00'!
rejectsEvent: anEvent
	"Return true to reject the given event. Rejecting an event means neither the receiver nor any of it's submorphs will be given any chance to handle it."
	(super rejectsEvent: anEvent) ifTrue:[^true].
	anEvent isDropEvent ifTrue:[^true]. "never attempt to drop on halos"
	^false! !

!SMxHaloMorph methodsFor: 'private' stamp: 'di 9/18/97 08:20'!
removeAllHandlesBut: h
	"Remove all handles except h."
	submorphs copy do:
		[:m | m == h ifFalse: [m delete]].
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'ar 10/24/2000 18:42'!
setDismissColor: evt with: dismissHandle
	"Called on mouseStillDown in the dismiss handle; set the color appropriately."

	| colorToUse |
	evt hand obtainHalo: self.
	colorToUse :=  (dismissHandle containsPoint: evt cursorPoint)
		ifFalse:
			[Color red muchLighter]
		ifTrue:
			[Color lightGray].
	dismissHandle color: colorToUse! !

!SMxHaloMorph methodsFor: 'accessing' stamp: 'jmv 11/12/2006 22:32'!
setTarget: aMorph
	"Private!! Set the target without adding handles."

	target := aMorph.
	innerTarget := target

! !

!SMxHaloMorph methodsFor: 'private' stamp: 'sw 1/27/2000 18:43'!
simpleFudgeOffset
	"account for the difference in basicBoxes between regular and simple handles"

	^ 0@0
! !

!SMxHaloMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 3/8/2010 14:19'!
startDrag: evt with: dragHandle
	"Drag my target without removing it from its owner."

	| |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: dragHandle.
	positionOffset := dragHandle center - (target externalizePositionFromOwner: target position to: owner)! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 3/8/2010 14:19'!
startGrow: evt with: growHandle
	"Initialize resizing of my target.  Launch a command representing it, to support Undo"

	| botRt |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: growHandle.
	botRt := target externalizePositionFromOwner: target bounds bottomRight to: owner.
	positionOffset := (self world viewBox containsPoint: botRt)
		ifTrue: [evt cursorPoint - botRt]
		ifFalse: [0@0]! !

!SMxHaloMorph methodsFor: 'private' stamp: 'jmv 3/8/2010 14:19'!
startRot: evt with: rotHandle
	"Initialize rotation of my target if it is rotatable.  Launch a command object to represent the action"

	self obtainHaloForEvent: evt andRemoveAllHandlesBut: rotHandle.
	growingOrRotating := true.

	self removeAllHandlesBut: rotHandle.  "remove all other handles"
	angleOffset := evt cursorPoint - (target externalizePositionFromOwner: target referencePosition to: target world).
	angleOffset := Point
			r: angleOffset r
			degrees: angleOffset degrees - target rotationDegrees

! !

!SMxHaloMorph methodsFor: 'events' stamp: 'ar 10/4/2000 19:26'!
staysUpWhenMouseIsDownIn: aMorph
	^ ((aMorph == target) or: [aMorph hasOwner: self])! !

!SMxHaloMorph methodsFor: 'stepping' stamp: 'jmv 4/27/2010 11:27'!
step
	| newBounds |
	target
		ifNil: [^ self].
	newBounds := target isWorldMorph
				ifTrue: [target bounds]
				ifFalse: [target worldBoundsForHalo truncated].
	newBounds = bounds
		ifTrue: [^ self].
	newBounds extent = bounds extent
		ifTrue: [^ self position: newBounds origin].
	growingOrRotating
		ifFalse: [submorphs size > 1
				ifTrue: [self addHandles]].
	"adjust halo bounds if appropriate"
	self bounds: newBounds! !

!SMxHaloMorph methodsFor: 'testing' stamp: 'jm 7/16/97 06:54'!
stepTime

	^ 0  "every cycle"
! !

!SMxHaloMorph methodsFor: 'private' stamp: 'ar 10/28/2000 22:25'!
strokeGrow: evt with: growHandle
	| dir |
	evt keyValue = 28 ifTrue:[dir := -1@0].
	evt keyValue = 29 ifTrue:[dir := 1@0].
	evt keyValue = 30 ifTrue:[dir := 0 @ -1].
	evt keyValue = 31 ifTrue:[dir := 0@1].
	dir ifNil:[^self].
	evt hand obtainHalo: self.
	evt hand newKeyboardFocus: growHandle.
	target extent: target extent + dir.
	self layoutChanged.! !

!SMxHaloMorph methodsFor: 'accessing' stamp: 'jm 7/16/97 06:51'!
target

	^ target
! !

!SMxHaloMorph methodsFor: 'accessing' stamp: 'jm 5/7/1998 15:42'!
target: aMorph

	self setTarget: aMorph.
	target ifNotNil: [self addHandles].
! !

!SMxHaloMorph methodsFor: 'events' stamp: 'jmv 10/9/2009 12:50'!
transferHalo: event
	"Transfer the halo to the next likely recipient"
	target ifNil:[^self delete].
	target transferHalo: (event internalizedToOwnerOf: target from: self) from: target.! !

!SMxHaloMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 17:37'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].
innerTarget := deepCopier references at: innerTarget ifAbsent: [innerTarget].
! !

!SMxHaloMorph methodsFor: 'copying' stamp: 'jmv 10/11/2010 23:24'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	"target := target.		Weakly copied"
	"innerTarget := innerTarget.		Weakly copied"
	positionOffset := positionOffset veryDeepCopyWith: deepCopier.
	angleOffset := angleOffset veryDeepCopyWith: deepCopier.
	growingOrRotating := growingOrRotating veryDeepCopyWith: deepCopier.
	haloBox := haloBox! !

SMxMorph subclass: #SMxImageMorph
	instanceVariableNames: 'image opaque'
	classVariableNames: 'DefaultForm'
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxImageMorph commentStamp: 'efc 3/7/2003 17:48' prior: 0!
SMxImageMorph is a morph that displays a picture (Form). My extent is determined by the extent of my form.

Use #image: to set my picture.

Structure:
 instance var		Type 		Description
 image				Form		The Form to use when drawing

Code examples:
	SMxImageMorph new openInWorld; grabFromScreen

	(Form fromFileNamed: 'myGraphicsFileName') asMorph openInWorld

Relationship to SMxSketchMorph: SMxImageMorph should be favored over SMxSketchMorph, a parallel, legacy class -- see the Swiki FAQ for details ( http://minnow.cc.gatech.edu/squeak/1372 ). 
!

!SMxImageMorph class methodsFor: 'instance creation' stamp: 'sw 10/23/2000 18:21'!
fromString: aString 
	"Create a new SMxImageMorph which displays the input string in the standard button font"

	^ self fromString: aString font: SMxPreferences standardButtonFont! !

!SMxImageMorph class methodsFor: 'instance creation' stamp: 'sw 10/23/2000 18:21'!
fromString: aString font: aFont
	"Create a new SMxImageMorph showing the given string in the given font"

	^ self new image: (SMxStringMorph contents: aString font: aFont) imageForm! !

!SMxImageMorph class methodsFor: 'class initialization' stamp: 'jm 4/10/98 01:09'!
initialize
	"SMxImageMorph initialize"

	| h p d |
	DefaultForm := (Form extent: 80@40 depth: 16).
	h := DefaultForm height // 2.
	0 to: h - 1 do: [:i |
		p := (i * 2)@i.
		d := i asFloat / h asFloat.
		DefaultForm fill:
			(p corner: DefaultForm extent - p)
			fillColor: (Color r: d g: 0.5 b: 1.0 - d)].
! !

!SMxImageMorph methodsFor: 'menus' stamp: 'ar 11/7/2000 14:55'!
addCustomMenuItems: aMenu hand: aHand
	super addCustomMenuItems: aMenu hand: aHand.
	aMenu addUpdating: #opacityString action: #changeOpacity! !

!SMxImageMorph methodsFor: 'accessing' stamp: 'jmv 8/2/2010 16:23'!
borderWidth: bw
	| newExtent |
	newExtent := 2 * bw + image extent.
	bounds extent = newExtent ifFalse: [ self basicExtent: newExtent ].
	super borderWidth: bw! !

!SMxImageMorph methodsFor: 'menu' stamp: 'jmv 1/12/2010 12:41'!
changeOpacity
	self opaque: self opaque not! !

!SMxImageMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:52'!
color: aColor
        super color: aColor.
        (image depth = 1 and: [aColor isColor]) ifTrue: [
                image colors: {Color transparent. aColor}.
                self changed]! !

!SMxImageMorph methodsFor: 'drawing' stamp: 'jmv 1/12/2010 12:41'!
drawOn: aCanvas

	self opaque
		ifTrue: [ aCanvas drawImage: image at: self innerBounds origin]
		ifFalse: [ aCanvas translucentImage: image at: self innerBounds origin]! !

!SMxImageMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint
	"Do nothing; my extent is determined by my image Form."
! !

!SMxImageMorph methodsFor: 'accessing' stamp: ''!
form
	"For compatability with SMxSketchMorph."

	^ image
! !

!SMxImageMorph methodsFor: 'menu commands' stamp: ''!
grabFromScreen

	self image: Form fromUser.
! !

!SMxImageMorph methodsFor: 'accessing' stamp: 'jmv 8/2/2010 16:23'!
image: anImage 
	self changed.
	image := anImage depth = 1 
				ifTrue: [ColorForm mappingWhiteToTransparentFrom: anImage]
				ifFalse: [anImage]. 
	self basicExtent: image extent! !

!SMxImageMorph methodsFor: 'initialization' stamp: 'jmv 1/12/2010 12:40'!
initialize

	super initialize.
	opaque := false.
	self image: DefaultForm.
! !

!SMxImageMorph methodsFor: 'testing' stamp: 'jmv 1/12/2010 12:41'!
isOpaqueMorph
	"Cheap optimization here"
	^self opaque! !

!SMxImageMorph methodsFor: 'menu' stamp: 'jmv 1/12/2010 12:42'!
opacityString
	^ (self opaque
		ifTrue: ['<on>']
		ifFalse: ['<off>']), 'opaque' translated! !

!SMxImageMorph methodsFor: 'accessing' stamp: 'jmv 1/12/2010 12:40'!
opaque
	"Return true if the receiver is marked as being completely opaque"
	^ opaque! !

!SMxImageMorph methodsFor: 'accessing' stamp: 'jmv 1/12/2010 12:40'!
opaque: aBool
	"Mark the receiver as being completely opaque or not"
	opaque := aBool.
	self changed! !

!SMxImageMorph methodsFor: 'menu commands' stamp: 'StephaneDucasse 12/11/2010 21:03'!
readFromFile
	| fileName |
	fileName := SMxFillInTheBlankMorph
		request: 'Please enter the image file name'
		initialAnswer: 'fileName'.
	fileName isEmpty ifTrue: [^ self].
	self image: (Form fromFileNamed: fileName).
! !

SMxImageMorph subclass: #SMxThreePhaseButtonMorph
	instanceVariableNames: 'offImage pressedImage state target actionSelector arguments actWhen'
	classVariableNames: 'AuthorModeOwner Icons'
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxThreePhaseButtonMorph commentStamp: '<historical>' prior: 0!
A button morph with separate images for on, off, and pressed with the mouse. 

When the event actWhen occurs, send actionSelector with 'arguments' to target.  For other events, default to my eventHandler.  The current event is not supplied in the arguments to the actionSelector.  

image (a.k.a. onImage) may not be nil.  offImage and pressedImage may be nil.  nil there means be transparent and show the underlying object.  

Tools for debugging:
Display the images momentarily under program control (for positioning) (self is an instance).
	self state: #on.  self state: #off.
	self state: #pressed.  self state: #off.
Display a rectangle where the button is.
	Display fillWithColor: bounds + (self world viewBox origin).
	self invalidRect: bounds.!

!SMxThreePhaseButtonMorph class methodsFor: 'instance creation' stamp: 'jmv 10/11/2010 23:07'!
checkBox
	"Answer a button pre-initialized with checkbox images."
	| f |
	^self new
		onImage: (f := Icons at: #CheckBoxOn);
		pressedImage: (Icons at: #CheckBoxPressed);
		offImage: (Icons at: #CheckBoxOff);
		extent: f extent + (2@0);
		yourself
! !

!SMxThreePhaseButtonMorph class methodsFor: 'class initialization' stamp: 'JuanVuletich 10/26/2010 15:40'!
initialize
	"SMxThreePhaseButtonMorph initialize"
	| extent inset |
	extent := 12@12.
	inset := 3.

	Icons := Dictionary new.
	#(CheckBoxOff CheckBoxOn CheckBoxPressed) do: [:button |
		| f r |
		f := Form extent: extent depth: 32.
		f borderWidth: 1.
		r := f boundingBox insetBy: inset.
		button == #CheckBoxPressed ifTrue: [f border: r width: 1].
		button == #CheckBoxOn ifTrue: [f fillBlack: r].
		Icons at: button put: f ]! !

!SMxThreePhaseButtonMorph methodsFor: 'submorphs-add/remove' stamp: 'tk 6/30/97 10:49'!
actWhen: condition
	"Accepts symbols:  #buttonDown, #buttonUp, and #whilePressed"
	actWhen := condition! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 6/30/97 10:49'!
actionSelector

	^ actionSelector
! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 6/30/97 10:49'!
actionSelector: aSymbolOrString

	(nil = aSymbolOrString or:
	 ['nil' = aSymbolOrString or:
	 [aSymbolOrString isEmpty]])
		ifTrue: [^ actionSelector := nil].

	actionSelector := aSymbolOrString asSymbol.
! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 7/1/97 12:39'!
arguments
	^ arguments! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 7/1/97 08:39'!
arguments: aCollection

	arguments := aCollection asArray copy.
! !

!SMxThreePhaseButtonMorph methodsFor: 'button' stamp: 'jmv 1/12/2010 11:04'!
doButtonAction
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	(target notNil and: [actionSelector notNil]) 
		ifTrue: [
			Cursor normal 
				showWhile: [ target perform: actionSelector withArguments: arguments ].
			(target is: #SMxMorph) ifTrue: [ target changed ]]! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'RAA 8/15/2000 16:27'!
doButtonAction: evt
	| moreArgs |
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	target ifNil: [^self].
	actionSelector ifNil: [^self].
	Cursor normal showWhile: [
		moreArgs := actionSelector numArgs > arguments size ifTrue: [
			arguments copyWith: evt
		] ifFalse: [
			arguments
		].
		target perform: actionSelector withArguments: moreArgs
	]! !

!SMxThreePhaseButtonMorph methodsFor: 'drawing' stamp: 'tk 10/9/2002 10:20'!
drawOn: aCanvas

	state == #off ifTrue: [
		offImage ifNotNil: [aCanvas translucentImage: offImage at: bounds origin]].
	state == #pressed ifTrue: [
		pressedImage ifNotNil: [aCanvas translucentImage: pressedImage at: bounds origin]].
	state == #on ifTrue: [
		image ifNotNil: [aCanvas translucentImage: image at: bounds origin]].! !

!SMxThreePhaseButtonMorph methodsFor: 'geometry' stamp: 'tk 7/1/97 09:14'!
extent: aPoint
	"Do it normally"
	
	self changed.
	bounds := bounds topLeft extent: aPoint.
	self layoutChanged.
	self changed.
! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'tk 6/30/97 10:52'!
handlesMouseDown: evt

	^ true
! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:18'!
handlesMouseStillDown: evt
	^actWhen == #whilePressed! !

!SMxThreePhaseButtonMorph methodsFor: 'initialization' stamp: 'tk 7/1/97 08:34'!
initialize

	super initialize.
	state := #off.
	target := nil.
	actionSelector := #flash.
	arguments := EmptyArray.
	actWhen := #buttonUp.

	"self on: #mouseStillDown send: #dragIfAuthoring: to: self."
		"real move should include a call on dragIfAuthoring: "! !

!SMxThreePhaseButtonMorph methodsFor: 'testing' stamp: 'sw 3/8/1999 13:56'!
isOn
	^ state == #on! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:16'!
mouseDown: evt
	| now dt |
	self state: #pressed.
	actWhen == #buttonDown
		ifTrue:
			[self doButtonAction]
		ifFalse:
			[now := Time millisecondClockValue.
			super mouseDown: evt.
			"Allow on:send:to: to set the response to events other than actWhen"
			dt := Time millisecondClockValue - now max: 0.  "Time it took to do"
			dt < 200 ifTrue: [(Delay forMilliseconds: 200-dt) wait]].
	self mouseStillDown: evt.! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:18'!
mouseMove: evt
	(self containsPoint: evt cursorPoint)
		ifTrue: [self state: #pressed.
				super mouseMove: evt]
				"Allow on:send:to: to set the response to events other than actWhen"
		ifFalse: [self state: #off].
! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:17'!
mouseStillDown: evt
	actWhen == #whilePressed ifFalse:[^self].
	(self containsPoint: evt cursorPoint) ifTrue:[self doButtonAction].! !

!SMxThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'jmv 11/6/2008 14:53'!
mouseUp: evt
	"Allow on:send:to: to set the response to events other than actWhen"
	actWhen == #buttonUp ifFalse: [^super mouseUp: evt].

	(self containsPoint: evt cursorPoint) ifTrue: [
		self state: #on.
		self doButtonAction: evt
	] ifFalse: [
		self state: #off.
		"target ifNotNil: [target mouseUpBalk: evt]"
	].
	"Allow owner to keep it selected for radio buttons"
! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 10/19/97 15:02'!
offImage
	^ offImage! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'jmv 4/27/2010 11:33'!
offImage: aForm
	offImage := aForm.
	self invalidRect: bounds.! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 10/19/97 15:02'!
onImage
	^ image! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'jmv 4/27/2010 11:33'!
onImage: aForm
	image := aForm.
	self invalidRect: bounds.! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'jmv 4/27/2010 11:33'!
pressedImage: aForm
	pressedImage := aForm.
	self invalidRect: bounds.! !

!SMxThreePhaseButtonMorph methodsFor: 'printing' stamp: 'dgd 2/22/2003 18:45'!
printOn: aStream 
	| string |
	aStream nextPutAll: '3PButton'.
	arguments notEmpty 
		ifTrue: [string := arguments at: (2 min: arguments size)].
	aStream nextPutAll: '('.
	(string notNil and: [string ~~ self]) 
		ifTrue: 
			[aStream
				print: string;
				space]
		ifFalse: 
			[aStream
				print: actionSelector;
				space].
	aStream
		print: self identityHash;
		nextPutAll: ')'! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 6/30/97 11:01'!
state: newState
	"Change the image and invalidate the rect."

	newState == state ifTrue: [^ self].
	state := newState.
	self invalidRect: bounds.	"All three images must be the same size"! !

!SMxThreePhaseButtonMorph methodsFor: 'stepping and presenter' stamp: 'ar 10/11/2000 14:05'!
step
	(self hasProperty: #doesButtonAction) ifTrue:[
		self doButtonAction.
		self setProperty: #didButtonAction toValue: true.
	].! !

!SMxThreePhaseButtonMorph methodsFor: 'testing' stamp: 'ar 10/11/2000 14:05'!
stepTime
	(self hasProperty: #doesButtonAction) ifTrue:[^1].
	^super stepTime! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 6/30/97 10:50'!
target

	^ target
! !

!SMxThreePhaseButtonMorph methodsFor: 'accessing' stamp: 'tk 6/30/97 10:50'!
target: anObject

	target := anObject
! !

!SMxThreePhaseButtonMorph methodsFor: 'copying' stamp: 'tk 1/8/1999 09:02'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].
arguments := arguments collect: [:each |
	deepCopier references at: each ifAbsent: [each]].
! !

!SMxThreePhaseButtonMorph methodsFor: 'copying' stamp: 'tk 1/8/1999 09:01'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
offImage := offImage veryDeepCopyWith: deepCopier.
pressedImage := pressedImage veryDeepCopyWith: deepCopier.
state := state veryDeepCopyWith: deepCopier.
"target := target.		Weakly copied"
"actionSelector := actionSelector.		Symbol"
"arguments := arguments.		Weakly copied"
actWhen := actWhen.		"Symbol"! !

!SMxThreePhaseButtonMorph methodsFor: 'testing' stamp: 'ar 10/11/2000 14:06'!
wantsSteps
	^(self hasProperty: #doesButtonAction) or:[super wantsSteps]! !

SMxThreePhaseButtonMorph subclass: #SMxUpdatingThreePhaseButtonMorph
	instanceVariableNames: 'getSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxUpdatingThreePhaseButtonMorph methodsFor: 'button' stamp: 'bf 10/8/1999 15:08'!
doButtonAction
	"Since the action likely changes our state, do a step so we're updated immediately"
	super doButtonAction.
	self step
! !

!SMxUpdatingThreePhaseButtonMorph methodsFor: 'as yet unclassified' stamp: 'sw 3/8/1999 13:50'!
getSelector: sel
	getSelector := sel! !

!SMxUpdatingThreePhaseButtonMorph methodsFor: 'event handling' stamp: 'bf 10/14/1999 21:11'!
mouseUp: evt
	"Since mouseUp likely changes our state, do a step so we're updated immediately"
	super mouseUp: evt.
	self step! !

!SMxUpdatingThreePhaseButtonMorph methodsFor: 'stepping and presenter' stamp: 'tk 7/14/2000 15:27'!
step
	| newBoolean |
	super step.
	state == #pressed ifTrue: [^ self].
	newBoolean := target perform: getSelector.
	newBoolean == self isOn
		ifFalse:
			[self state: (newBoolean == true ifTrue: [#on] ifFalse: [#off])]! !

!SMxUpdatingThreePhaseButtonMorph methodsFor: 'testing' stamp: 'sw 3/8/1999 13:50'!
wantsSteps
	^ true! !

SMxMorph subclass: #SMxLazyListMorph
	instanceVariableNames: 'listItems font selectedRow selectedRows listSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Windows'!

!SMxLazyListMorph commentStamp: 'ls 10/11/2003 13:10' prior: 0!
The morph that displays the list in a SMxPluggableListMorph.  It is "lazy" because it will only request the list items that it actually needs to display.!

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 5/15/2001 22:13'!
adjustHeight
	"private.  Adjust our height to match the length of the underlying list"
	self height: (listItems size max: 1) * font height
! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'jmv 10/1/2009 10:04'!
adjustWidth
	"private.  Adjust our height to match the length of the underlying list,
	but make it wider if neccesary to fill the available width in our SMxPluggableListMorph"
	self width: (listSource viewableWidth max: self hTotalScrollRange)! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 5/17/2001 21:57'!
bottomVisibleRowForCanvas: aCanvas
        "return the bottom visible row in aCanvas's clip rectangle"
        ^self rowAtLocation: aCanvas clipRect bottomLeft.
! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 10/11/2003 13:12'!
colorForRow: 	row
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ Color red ]
		ifFalse: [ self color ].! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/12/2010 23:37'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds f |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: bounds.
	f := item isText ifTrue: [ font emphasized: (item emphasisAt: 1) ] ifFalse: [ font ].
	canvas drawString: item in: drawBounds font: f color: (self colorForRow: row)! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:27'!
drawBackgroundForMulti: row on: aCanvas
	| selectionDrawBounds |
	"shade the background darker, if this row is selected"

	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: bounds.
	aCanvas fillRectangle: selectionDrawBounds color:  self color muchLighter! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'ls 7/5/2000 18:21'!
drawBoundsForRow: row
	"calculate the bounds that row should be drawn at.  This might be outside our bounds!!"
	| topLeft drawBounds |
	topLeft := self topLeft x @ (self topLeft y + ((row - 1) * (font height))).
	drawBounds := topLeft extent: self width @ font height.
	^drawBounds! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 12/6/2001 21:43'!
drawOn: aCanvas
	| |
	listItems size = 0 ifTrue: [ ^self ].
 
	self drawSelectionOn: aCanvas.

	(self topVisibleRowForCanvas: aCanvas) to: (self bottomVisibleRowForCanvas: aCanvas) do: [ :row |
		(listSource itemSelectedAmongMultiple:  row) ifTrue: [
			self drawBackgroundForMulti: row on: aCanvas. ].
		self display: (self item: row) atRow: row on: aCanvas.
	].

	listSource potentialDropRow > 0 ifTrue: [
		self highlightPotentialDropRow: listSource potentialDropRow on: aCanvas ].! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:27'!
drawSelectionOn: aCanvas
	| selectionDrawBounds |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	selectionDrawBounds := self drawBoundsForRow: selectedRow.
	selectionDrawBounds := selectionDrawBounds intersect: bounds.
	aCanvas fillRectangle: selectionDrawBounds color: (
		Display depth = 1 
			ifTrue: [Color lightGray] 
			ifFalse: [
				Display depth = 2 
					ifTrue: [Color black] 
					ifFalse: [Color lightGray alpha: 0.45]])! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 7/5/2000 18:37'!
font
	"return the font used for drawing.  The response is never nil"
	^font! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'jmv 7/27/2009 17:48'!
font: newFont
	font := (newFont ifNil: [ StrikeFont default ]).
	self adjustHeight.
	self changed.! !

!SMxLazyListMorph methodsFor: 'list access' stamp: 'ls 8/19/2001 14:07'!
getListItem: index
	"grab a list item directly from the model"
	^listSource getListItem: index! !

!SMxLazyListMorph methodsFor: 'list access' stamp: 'ls 5/15/2001 22:11'!
getListSize
	"return the number of items in the list"
	listSource ifNil: [ ^0 ].
	^listSource getListSize! !

!SMxLazyListMorph methodsFor: 'scroll range' stamp: 'jmv 10/1/2009 09:47'!
hTotalScrollRange
"Ok, this is a bit messed up. We need to return the width of the widest item in the list. If we grab every item in the list, it defeats the purpose of SMxLazyListMorph. If we don't, then we don't know the size. This is a compromise -- if the list is less then 30 items, we grab them all. If not, we grab currently visible ones, until we've checked itemsToCheck of them, then take the max width out of that 'sampling', then double it. If you know a better way, please chime in."

	| maxW count itemsToCheck item |

	itemsToCheck := 30.
	maxW := 0. 
	count := 0.
	listItems do: 
		[ :each |
			each ifNotNil: 
				[maxW := maxW max: (self widthToDisplayItem: each contents)]].
				
	(count < itemsToCheck) ifTrue:
		[1 to: listItems size do: 
			[:i | (listItems at: i) ifNil: 
							[item := self item: i.
							maxW := maxW max: (self widthToDisplayItem: item contents).
							((count := count + 1) > itemsToCheck) ifTrue:[ ^maxW * 2]]]].
	
	^maxW 
! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:28'!
highlightPotentialDropRow: row  on: aCanvas
	| drawBounds  |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: bounds.
	aCanvas frameRectangle: drawBounds color: Color blue! !

!SMxLazyListMorph methodsFor: 'initialization' stamp: 'nk 10/14/2003 15:24'!
initialize
	super initialize.
	self color: Color black.
	font := SMxPreferences standardListFont.
	listItems := #().
	selectedRow := nil.
	selectedRows := PluggableSet integerSet.
	self adjustHeight.! !

!SMxLazyListMorph methodsFor: 'list access' stamp: 'ls 10/21/2001 20:57'!
item: index
	"return the index-th item, using the 'listItems' cache"
	(index between: 1 and: listItems size)
		ifFalse: [ "there should have been an update, but there wasn't!!"  ^self getListItem: index].
	(listItems at: index) ifNil: [ 
		listItems at: index put: (self getListItem: index). ].
	^listItems at: index! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'sps 3/9/2004 17:06'!
listChanged
	"set newList to be the list of strings to display"
	listItems := Array new: self getListSize withAll: nil.
	selectedRow := nil.
	selectedRows := PluggableSet integerSet.
	self adjustHeight.
	self adjustWidth.
	self changed.
! !

!SMxLazyListMorph methodsFor: 'initialization' stamp: 'ls 5/15/2001 22:12'!
listSource: aListSource
	"set the source of list items -- typically a SMxPluggableListMorph"
	listSource := aListSource.
	self listChanged! !

!SMxLazyListMorph methodsFor: 'private' stamp: 'jmv 11/7/2008 15:14'!
noSelection
	selectedRow := nil.
	selectedRows := PluggableSet integerSet! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'ls 10/20/2001 00:09'!
rowAtLocation: aPoint
	"return the number of the row at aPoint"
	| y |
	y := aPoint y.
	y < self top ifTrue: [ ^ 1 ].
	^((y - self top // (font height)) + 1) min: listItems size max: 0! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'ls 7/13/2000 17:34'!
selectRow: index
	"select the index-th row"
	selectedRows add: index.
	self changed.! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'ls 7/7/2000 10:38'!
selectedRow
	"return the currently selected row, or nil if none is selected"
	^selectedRow! !

!SMxLazyListMorph methodsFor: 'list management' stamp: 'ls 7/5/2000 17:56'!
selectedRow: index
	"select the index-th row.  if nil, remove the current selection"
	selectedRow := index.
	self changed.! !

!SMxLazyListMorph methodsFor: 'drawing' stamp: 'ls 5/17/2001 21:57'!
topVisibleRowForCanvas: aCanvas
        "return the top visible row in aCanvas's clip rectangle"
        ^self rowAtLocation: aCanvas clipRect topLeft.
! !

!SMxLazyListMorph methodsFor: 'scroll range' stamp: 'ls 4/17/2004 12:17'!
widthToDisplayItem: item
	^self font widthOfStringOrText: item
	! !

SMxMorph subclass: #SMxMenuLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxMenuLineMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/29/2010 10:33'!
drawOn: aCanvas 
	| baseColor |
	baseColor := SMxPreferences menuColorFromWorld & false
				ifTrue: [owner color twiceDarker]
				ifFalse: [owner color].
	aCanvas
		fillRectangle: (bounds topLeft corner: bounds rightCenter)
		color: baseColor twiceDarker.
			
	aCanvas
		fillRectangle: (bounds leftCenter corner: bounds bottomRight)
		color: baseColor twiceLighter! !

!SMxMenuLineMorph methodsFor: 'initialization' stamp: 'jmv 5/14/2009 15:48'!
initialize
	super initialize.
	self height: 2! !

!SMxMenuLineMorph methodsFor: 'testing' stamp: 'JuanVuletich 10/22/2010 11:27'!
is: aSymbol
	^aSymbol == #answersminItemWidth or: [ super is: aSymbol ]! !

!SMxMenuLineMorph methodsFor: 'layout' stamp: 'jmv 5/14/2009 15:44'!
minItemWidth
	^ 0
! !

SMxMorph subclass: #SMxMinimalStringMorph
	instanceVariableNames: 'font emphasis contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxMinimalStringMorph commentStamp: 'jmv 4/1/2009 21:43' prior: 0!
A greatly reduced SMxStringMorph. May be of some use.!

!SMxMinimalStringMorph class methodsFor: 'instance creation' stamp: 'jmv 4/1/2009 21:43'!
contents: aString
	" 'SMxStringMorph contents: str' is faster than 'SMxStringMorph new contents: str' 
	(StringEditorMorph contents: 'Some string') openInWorld
	"
	^ self contents: aString font: nil! !

!SMxMinimalStringMorph class methodsFor: 'instance creation' stamp: 'jmv 11/4/2008 12:56'!
contents: aString font: aFont
	^ self basicNew initWithContents: aString font: aFont emphasis: 0! !

!SMxMinimalStringMorph class methodsFor: 'instance creation' stamp: 'jmv 11/4/2008 12:56'!
contents: aString font: aFont emphasis: emphasisCode
	^ self basicNew initWithContents: aString font: aFont emphasis: emphasisCode! !

!SMxMinimalStringMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/12/2010 23:38'!
contents: newContents 
	contents := newContents isText
		ifTrue: [
			emphasis := newContents emphasisAt: 1.
			 newContents string]
		ifFalse: [
			contents = newContents ifTrue: [^self].	"no substantive change"
			newContents].
	self fitContents! !

!SMxMinimalStringMorph methodsFor: 'initialization' stamp: 'jmv 11/4/2008 12:56'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!SMxMinimalStringMorph methodsFor: 'drawing' stamp: 'jmv 11/4/2008 12:56'!
drawOn: aCanvas

	aCanvas drawString: contents in: bounds font: self fontToUse color: color! !

!SMxMinimalStringMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 12:56'!
fitContents

	| newBounds boundsChanged |
	newBounds := self measureContents.
	boundsChanged := bounds extent ~= newBounds.
	self extent: newBounds.		"default short-circuits if bounds not changed"
	boundsChanged ifFalse: [self changed]! !

!SMxMinimalStringMorph methodsFor: 'accessing' stamp: 'jmv 3/2/2010 16:13'!
fontToUse
	| fontToUse |
	fontToUse := font ifNil: [StrikeFont default].
	^(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [fontToUse]
		ifFalse: [fontToUse emphasized: emphasis]! !

!SMxMinimalStringMorph methodsFor: 'initialization' stamp: 'jmv 9/10/2010 22:55'!
initWithContents: aString font: aFont emphasis: emphasisCode 
	self initialize.
	
	font := aFont.
	emphasis := emphasisCode.
	self contents: aString! !

!SMxMinimalStringMorph methodsFor: 'initialization' stamp: 'jmv 9/10/2010 22:55'!
initialize
	super initialize.
	font := nil.
	emphasis := 0! !

!SMxMinimalStringMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 12:56'!
measureContents
	| f |
	f := self fontToUse.
	^(((f widthOfString: contents) max: self minimumWidth)  @ f height).! !

!SMxMinimalStringMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 12:56'!
minimumWidth
	"Answer the minimum width that the receiver can have.  A nonzero value here keeps the receiver from degenerating into something that cannot ever be seen or touched again!!  Obeyed by fitContents."

	^ 3! !

!SMxMorph class methodsFor: 'new-morph participation' stamp: 'di 6/22/97 09:07'!
includeInNewMorphMenu
	"Return true for all classes that can be instantiated from the menu"
	^ true! !

!SMxMorph class methodsFor: 'class initialization' stamp: ''!
initialize
	"SMxMorph initialize"

	"this empty array object is shared by all morphs with no submorphs:"
	EmptyArray := Array new.
! !

!SMxMorph class methodsFor: 'instance creation' stamp: 'jmv 5/27/2006 21:29'!
initializedInstance
	"Answer an instance of the receiver which in some sense is initialized.  In the case of Morphs, this will yield an instance that can be attached to the Hand after having received the same kind of basic initialization that would be obtained from an instance chosen from the 'new morph' menu.
	Return nil if the receiver is reluctant for some reason to return such a thing"

	^ self new! !

!SMxMorph class methodsFor: 'instance creation' stamp: ''!
newBounds: bounds

	^ self new privateBounds: bounds! !

!SMxMorph class methodsFor: 'instance creation' stamp: 'jm 5/29/1998 21:28'!
newBounds: bounds color: color

	^ (self new privateBounds: bounds) privateColor: color
! !

!SMxMorph class methodsFor: 'instance creation' stamp: 'sw 8/4/97 12:05'!
newSticky

	^ self new beSticky! !

!SMxMorph class methodsFor: 'initialize-release' stamp: 'SD 11/15/2001 22:22'!
unload

	FileList unregisterFileReader: self ! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 12/25/2004 14:39'!
aboutToBeGrabbedBy: aHand
	"The receiver is being grabbed by a hand.
	Perform necessary adjustments (if any) and return the actual morph
	that should be added to the hand."
	self formerOwner: owner.
	self formerPosition: self position.
	^self "Grab me"! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 5/10/2009 21:53'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."
	
	self addMorph: aMorph! !

!SMxMorph methodsFor: 'events-accessing' stamp: 'jmv 9/18/2009 00:11'!
actionMap
	"Answer an action map"
	"Do NOT duplicate this in Morphic3 / LightWidgets
	Views should not trigger events!!"

	^self valueOfProperty: #actionMap! !

!SMxMorph methodsFor: 'user interface' stamp: 'jmv 11/10/2008 23:51'!
activateWindow

	self activateWindowAndSendTopToBack: false! !

!SMxMorph methodsFor: 'user interface' stamp: 'jmv 11/10/2008 23:51'!
activateWindowAndSendTopToBack: aBoolean

	| w |
	(w := self ownerThatIsA: SMxSystemWindow) ifNotNil: [
		w isTopWindow ifFalse: [
			w activateAndSendTopToBack: aBoolean]].! !

!SMxMorph methodsFor: 'structure' stamp: 'JuanVuletich 11/1/2010 15:28'!
activeHand
	^SimpleMorphicUIManager smxActiveHand! !

!SMxMorph methodsFor: 'menus' stamp: 'sw 11/27/2001 14:36'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	"The former charter of this method was to add halo menu items that pertained specifically to the hand.  Over time this charter has withered, and most morphs reimplement this method simply to add their morph-specific menu items.  So in the latest round, all other implementors in the standard image have been removed.  However, this is left here as a hook for the benefit of existing code in client uses."

! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector after: delayTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: #() after: delayTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector at: scheduledTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: #() at: scheduledTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector with: arg1 after: delayTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: (Array with: arg1) after: delayTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector with: arg1 at: scheduledTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: (Array with: arg1) at: scheduledTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector with: arg1 with: arg2 after: delayTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: (Array with: arg1 with: arg2) after: delayTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector with: arg1 with: arg2 at: scheduledTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: (Array with: arg1 with: arg2) at: scheduledTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:35'!
addAlarm: aSelector withArguments: args after: delayTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	^self addAlarm: aSelector withArguments: args at: Time millisecondClockValue + delayTime! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/14/2000 12:15'!
addAlarm: aSelector withArguments: args at: scheduledTime
	"Add an alarm (that is an action to be executed once) with the given set of parameters"
	| scheduler |
	scheduler := self alarmScheduler.
	scheduler ifNotNil:[scheduler addAlarm: aSelector withArguments: args for: self at: scheduledTime].! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 8/12/2003 23:28'!
addAllMorphs: aCollection
	^self privateAddAllMorphs: aCollection atIndex: submorphs size! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 8/12/2003 23:29'!
addAllMorphs: aCollection after: anotherMorph
	^self privateAddAllMorphs: aCollection 
			atIndex: (submorphs indexOf: anotherMorph ifAbsent: [submorphs size])! !

!SMxMorph methodsFor: 'menu' stamp: 'sw 11/27/2001 15:21'!
addBorderStyleMenuItems: aMenu hand: aHandMorph
	"Probably one could offer border-style items even if it's not a borderedMorph, so this remains a loose end for the moment"
! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 1/15/2005 20:35'!
addCopyItemsTo: aMenu 
	"Add copy-like items to the halo menu"

	| subMenu |
	subMenu := SMxMenuMorph new defaultTarget: self.
	subMenu add: 'copy to paste buffer' translated action: #copyToPasteBuffer:.
	subMenu add: 'copy text' translated action: #clipText.
	aMenu add: 'copy & print...' translated subMenu: subMenu! !

!SMxMorph methodsFor: 'menus' stamp: 'sw 4/27/1998 03:44'!
addCustomHaloMenuItems: aMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand from the halo.  To get started, we defer to the counterpart method used with the option-menu, but in time we can have separate menu choices for halo-menus and for option-menus"

	self addCustomMenuItems: aMenu hand: aHandMorph! !

!SMxMorph methodsFor: 'menus' stamp: 'sw 11/27/2001 07:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand.  This method provides is invoked both from the halo-menu and from the control-menu regimes."
! !

!SMxMorph methodsFor: 'debug and other' stamp: 'dgd 8/30/2003 20:36'!
addDebuggingItemsTo: aMenu hand: aHandMorph
	aMenu add: 'debug...' translated subMenu:  (self buildDebugMenu: aHandMorph)! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/15/2009 22:33'!
addEmbeddingMenuItemsTo: aMenu hand: aHandMorph
	| menu |
	menu := SMxMenuMorph new defaultTarget: self.
	self potentialEmbeddingTargets reverseDo: [:m | 
		menu 
			add: m class name asString 
			target: m 
			selector: #addMorphFrontFromWorldPosition: 
			argumentList: {self}].
	aMenu ifNotNil:[
		menu submorphCount > 0 
			ifTrue:[aMenu add:'embed into' translated subMenu: menu].
	].
	^menu! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 2/18/2010 10:17'!
addExportMenuItems: aMenu hand: aHandMorph
	"Add export items to the menu"

	aMenu ifNotNil: [
		| aSubMenu |
		aSubMenu := SMxMenuMorph new defaultTarget: self.
		aSubMenu add: 'BMP file' translated action: #exportAsBMP.
		aSubMenu add: 'JPEG file' translated action: #exportAsJPEG.
		aSubMenu add: 'PNG file' translated action: #exportAsPNG.
		aMenu add: 'export...' translated subMenu: aSubMenu]
! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 8/26/2008 11:28'!
addFillStyleMenuItems: aMenu hand: aHand 
	"Add the items for changing the current fill style of the SMxMorph"

	aMenu add: 'change color...' translated action: #changeColor! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 11/7/1999 18:57'!
addHalo
	"Invoke a halo programatically (e.g., not from a meta gesture)"
	^self addHalo: nil! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 10/10/2000 19:03'!
addHalo: evt
	| halo prospectiveHaloClass |
	prospectiveHaloClass := Smalltalk at: self haloClass ifAbsent: [SMxHaloMorph].
	halo := prospectiveHaloClass new bounds: self worldBoundsForHalo.
	halo popUpFor: self event: evt.
	^halo! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 11/7/1999 21:55'!
addHalo: evt from: formerHaloOwner
	"Transfer a halo from the former halo owner to the receiver"
	^self addHalo: evt! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 5/17/2009 23:41'!
addHaloActionsTo: aMenu 
	"Add items to aMenu representing actions requestable via halo"

	| subMenu |
	subMenu := SMxMenuMorph new defaultTarget: self.
	subMenu addTitle: self externalName.
	subMenu addStayUpIcons.
	subMenu addLine.
	subMenu add: 'delete' translated action: #dismissViaHalo.
	subMenu 
		balloonTextForLastItem: 'Delete this object -- warning -- can be destructive!!' 
				translated.
	self maybeAddCollapseItemTo: subMenu.
	subMenu add: 'grab' translated action: #openInHand.
	subMenu 
		balloonTextForLastItem: 'Pick this object up -- warning, since this removes it from its container, it can have adverse effects.' 
				translated.
	subMenu addLine.
	subMenu add: 'resize' translated action: #resizeFromMenu.
	subMenu 
		balloonTextForLastItem: 'Change the size of this object' translated.
	subMenu add: 'duplicate' translated action: #maybeDuplicateMorph.
	subMenu balloonTextForLastItem: 'Hand me a copy of this object' translated.
	subMenu 
		add: 'set color' translated
		target: self
		action: #changeColor.
	subMenu 
		balloonTextForLastItem: 'Change the color of this object' translated.
	subMenu 
		add: 'inspect' translated
		target: self
		action: #inspect.
	subMenu 
		balloonTextForLastItem: 'Open an Inspector on this object' translated.
	aMenu add: 'halo actions...' translated subMenu: subMenu! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 11/15/2001 16:31'!
addHandlesTo: aHaloMorph box: box
	"Add halo handles to the halo.  Apply the halo filter if appropriate"

	| wantIt |
	aHaloMorph haloBox: box.
	SMxPreferences haloSpecifications  do:
		[:aSpec | 
			wantIt := SMxPreferences selectiveHalos
				ifTrue:
					[self wantsHaloHandleWithSelector: aSpec addHandleSelector inHalo: aHaloMorph]
				ifFalse:
					[true].
			wantIt ifTrue:
				[aHaloMorph perform: aSpec addHandleSelector with: aSpec]].

	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: ''!
addMorph: aMorph

	self addMorphFront: aMorph.! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 1/31/2001 12:44'!
addMorph: newMorph behind: aMorph
	"Add a morph to the list of submorphs behind the specified morph"
	^self privateAddMorph: newMorph atIndex: (submorphs indexOf: aMorph) + 1.
! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 5/28/2009 00:30'!
addMorph: aMorph fullFrame: aLayoutFrame

	aMorph layoutFrame: aLayoutFrame.
	self addMorph: aMorph.

! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 1/31/2001 12:45'!
addMorph: newMorph inFrontOf: aMorph
	"Add a morph to the list of submorphs in front of the specified morph"
	^self privateAddMorph: newMorph atIndex: ((submorphs indexOf: aMorph) max: 1).! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 7/9/2009 08:55'!
addMorph: aMorph layoutFractions: aRectangle

	aMorph layoutFrame: (SMxLayoutFrame fractions: aRectangle).
	self addMorph: aMorph.

! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 1/31/2001 12:55'!
addMorphBack: aMorph
	^self privateAddMorph: aMorph atIndex: submorphs size+1! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'RAA 12/15/2000 19:34'!
addMorphCentered: aMorph

	aMorph position: bounds center - (aMorph extent // 2).
	self addMorphFront: aMorph.
! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 1/31/2001 12:54'!
addMorphFront: aMorph
	^self privateAddMorph: aMorph atIndex: 1! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 3/8/2010 14:24'!
addMorphFront: aMorph fromWorldPosition: wp

	self addMorphFront: aMorph.
	aMorph position: (self internalizePosition: wp from: self world)! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 12/16/2001 21:08'!
addMorphFrontFromWorldPosition: aMorph
	^self addMorphFront: aMorph fromWorldPosition: aMorph positionInWorld.! !

!SMxMorph methodsFor: 'WiW support' stamp: 'RAA 2/16/2001 13:57'!
addMorphInFrontOfLayer: aMorph

	| targetLayer layerHere |

	targetLayer := aMorph morphicLayerNumberWithin: self.
	submorphs do: [ :each |
		each == aMorph ifTrue: [^self].
		layerHere := each morphicLayerNumberWithin: self.
		"the <= is the difference - it insures we go to the front of our layer"
		targetLayer <= layerHere ifTrue: [
			^self addMorph: aMorph inFrontOf: each
		].
	].
	self addMorphBack: aMorph.
! !

!SMxMorph methodsFor: 'WiW support' stamp: 'RAA 6/29/2000 10:49'!
addMorphInLayer: aMorph

	submorphs do: [ :each |
		each == aMorph ifTrue: [^self].
		aMorph morphicLayerNumber < each morphicLayerNumber ifTrue: [
			^self addMorph: aMorph inFrontOf: each
		].
	].
	self addMorphBack: aMorph
! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'di 9/18/97 14:01'!
addOptionalHandlesTo: aHalo box: box
	! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 1/12/2010 11:21'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	aMenu add: 'send to back' translated action: #goBehind.
	aMenu add: 'bring to front' translated action: #comeToFront.
	self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
	aMenu addLine.

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addHaloActionsTo: aMenu.
	(owner is: #SMxTextMorph) ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.
	self addDebuggingItemsTo: aMenu hand: aHandMorph.

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables := self submorphs select:
		[:m | m isLocked].
	unlockables size = 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: unlockables first externalName)
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'ar 12/17/2001 12:45'!
addTextAnchorMenuItems: topMenu hand: aHand
	| aMenu |
	aMenu := SMxMenuMorph new defaultTarget: self.
	aMenu addUpdating: #hasInlineAnchorString action: #changeInlineAnchor.
	aMenu addUpdating: #hasParagraphAnchorString action: #changeParagraphAnchor.
	aMenu addUpdating: #hasDocumentAnchorString action: #changeDocumentAnchor.
	topMenu ifNotNil:[topMenu add: 'text anchor' subMenu: aMenu].
	^aMenu! !

!SMxMorph methodsFor: 'menus' stamp: 'sw 6/19/1999 23:15'!
addTitleForHaloMenu: aMenu
	aMenu addTitle: self externalName! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 10/26/2006 22:31'!
addToggleItemsToHaloMenu: aMenu
	"Add standard true/false-checkbox items to the memu"

	#(
	(resistsRemovalString toggleResistsRemoval 'whether I should be reistant to easy deletion via the pink X handle')
	(stickinessString toggleStickiness 'whether I should be resistant to a drag done by mousing down on me')
	(lockedString lockUnlockMorph 'when "locked", I am inert to all user interactions')
	(hasClipSubmorphsString changeClipSubmorphs 'whether the parts of objects within me that are outside my bounds should be masked.')
	(hasDragAndDropEnabledString changeDragAndDrop 'whether I am open to having objects dropped into me')
	) do:

		[:trip | aMenu addUpdating: trip first action: trip second.
			aMenu balloonTextForLastItem: trip third translated]! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 1/26/2000 19:37'!
addWorldHandlesTo: aHaloMorph box: box
	aHaloMorph haloBox: box.
	SMxPreferences haloSpecificationsForWorld do:
		[:aSpec | 
			aHaloMorph perform: aSpec addHandleSelector with: aSpec].
	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!SMxMorph methodsFor: 'change reporting' stamp: 'ar 8/12/2003 21:50'!
addedMorph: aMorph
	"Notify the receiver that the given morph was just added."
! !

!SMxMorph methodsFor: 'accessing' stamp: 'ar 12/18/2001 20:09'!
adoptPaneColor: paneColor
	self submorphsDo:[:m| m adoptPaneColor: paneColor].! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/11/2000 16:34'!
alarmScheduler
	"Return the scheduler being responsible for triggering alarms"
	^self world! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 7/24/97 11:55'!
align: aPoint1 with: aPoint2
	"Translate by aPoint2 - aPoint1."

	^ self position: self position + (aPoint2 - aPoint1)! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: ''!
allMorphs
	"Return a collection containing all morphs in this composite morph (including the receiver)."

	| all |
	all := OrderedCollection new: 100.
	self allMorphsDo: [: m | all add: m].
	^ all! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'dgd 2/22/2003 14:27'!
allMorphsDo: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | m allMorphsDo: aBlock].
	aBlock value: self! !

!SMxMorph methodsFor: 'structure' stamp: 'di 11/13/2000 01:00'!
allOwners
	"Return the owners of the reciever"

	^ Array streamContents: [:strm | self allOwnersDo: [:m | strm nextPut: m]]! !

!SMxMorph methodsFor: 'structure' stamp: 'ar 9/14/2000 16:47'!
allOwnersDo: aBlock
	"Evaluate aBlock with all owners of the receiver"
	owner ifNotNil:[^owner withAllOwnersDo: aBlock].! !

!SMxMorph methodsFor: 'debug and other' stamp: 'jmv 3/2/2010 16:15'!
allStringsAfter: aSubmorph 
	"return an OrderedCollection of strings of text in my submorphs.  If aSubmorph is non-nil, begin with that container."

	| list string ok |
	list := OrderedCollection new.
	ok := aSubmorph isNil.
	self allMorphsDo: [ :sub | 
			ok
				ifFalse: [ok := sub == aSubmorph].	"and do this one too"
			ok
				ifTrue: [
					(string := sub userString) ifNotNil: [
						string isString 
							ifTrue: [list add: string] 
							ifFalse: [list addAll: string]]]].
	^list! !

!SMxMorph methodsFor: 'debug and other' stamp: 'RAA 7/7/2000 16:27'!
altSpecialCursor0
	"an arrow"
	^(Form
	extent: 16@16
	depth: 8
	fromArray: #( 0 0 0 0 14869218 3806520034 3806520034 3791650816 14848144 2425393296 2425393378 0 14848144 2425393296 2425414144 0 14848144 2425393296 2430730240 0 14848144 2425393296 3791650816 0 14848144 2425393378 3791650816 0 14848144 2425414370 3806461952 0 14848144 2430788322 3806519808 0 14848144 3791651042 3806520034 0 14848226 0 3806520034 3791650816 14868992 0 14869218 3806461952 14811136 0 58082 3806519808 0 0 226 3806520034 0 0 0 3806520034 0 0 0 14869218)
	offset: 0@0)
! !

!SMxMorph methodsFor: 'debug and other' stamp: 'RAA 7/7/2000 16:28'!
altSpecialCursor1
	"a star and an arrow"
	^(Form
	extent: 31@26
	depth: 8
	fromArray: #( 14417920 0 0 0 0 0 0 0 3705461980 3705461980 3705405440 0 0 0 0 0 3705461980 3705461980 3705461760 0 0 0 0 0 14474460 3705461980 3705405440 0 0 0 0 0 56540 3705461980 3690987520 0 0 3690987520 0 0 220 3705461980 3705461760 0 0 3690987520 0 0 220 3705405440 3705461980 0 0 3705405440 0 0 0 3705461760 56540 3690987520 220 3705405440 0 0 0 3705405440 220 3705461760 220 3705405440 0 0 0 0 0 14474460 220 3705461760 0 0 0 0 0 56540 3691044060 3705461760 0 0 0 0 0 220 3705461980 3705461760 0 0 0 0 56540 3705461980 3705461980 3705461980 3705461980 3705461760 0 0 220 3705461980 3705461980 3705461980 3705461980 3705461760 0 0 0 3705461980 3705461980 3705461980 3705461980 3705405440 0 0 0 14474460 3705461980 3705461980 3705461980 3690987520 0 0 0 56540 3705461980 3705461980 3705461760 0 0 0 0 220 3705461980 3705461980 3705405440 0 0 0 0 0 3705461980 3705461980 3690987520 0 0 0 0 0 3705461980 3705461980 3705405440 0 0 0 0 220 3705461980 3705461980 3705405440 0 0 0 0 220 3705461980 3705461980 3705405440 0 0 0 0 220 3705461980 14474460 3705405440 0 0 0 0 220 3705405440 220 3705461760 0 0 0 0 56540 3690987520 0 3705461760 0 0 0 0 56540 0 0 14474240 0)
	offset: 0@0)! !

!SMxMorph methodsFor: 'debug and other' stamp: 'RAA 7/7/2000 16:41'!
altSpecialCursor2
	| f |
	"a blue box with transparent center"
	f := Form extent: 32@32 depth: 32.
	f offset: (f extent // 2) negated.
	f fill: f boundingBox rule: Form over fillColor: (Color blue alpha: 0.5).
	f fill: (f boundingBox insetBy: 4) rule: Form over fillColor: Color transparent.
	^f
! !

!SMxMorph methodsFor: 'debug and other' stamp: 'RAA 7/7/2000 16:42'!
altSpecialCursor3
	
	^self altSpecialCursor3: Color blue! !

!SMxMorph methodsFor: 'debug and other' stamp: 'RAA 7/7/2000 16:41'!
altSpecialCursor3: aColor
	| f box |
	"a bulls-eye pattern in this color"
	f := Form extent: 32@32 depth: 32.
	f offset: (f extent // 2) negated.
	box := f boundingBox.
	[ box width > 0] whileTrue: [
		f fill: box rule: Form over fillColor: aColor.
		f fill: (box insetBy: 2) rule: Form over fillColor: Color transparent.
		box := box insetBy: 4.
	].
	^f
! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 8/23/2010 18:44'!
applyLayoutFrameIn: ownerLayoutBounds
	"Layout specific. Apply the given bounds to the receiver.
	newBounds is the bounds of the owner (or its #layoutBounds). 
	This means that we need to compute and apply our own bounds from it
	using our layoutFrame."
	| newBounds myLayoutFrame |
	myLayoutFrame := self layoutFrame ifNil: [ ^self ].

	"compute the cell size the receiver has given its layout frame"
	newBounds := myLayoutFrame layout: bounds in: ownerLayoutBounds.
	^self bounds: newBounds! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:29'!
areasRemainingToFill: aRectangle

	(self isOrthoRectangularMorph and: [ self isOpaqueMorph ]) ifTrue: [
		^aRectangle areasOutside: bounds ].
	^ Array with: aRectangle! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'sw 3/22/2000 14:27'!
arrangeToStartStepping
	"Arrange to start getting sent the 'step' message, but don't do that initial #step call that startStepping does"

	self arrangeToStartSteppingIn: self world! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'sw 3/22/2000 14:26'!
arrangeToStartSteppingIn: aWorld
	"Start getting sent the 'step' message in aWorld.  Like startSteppingIn:, but without the initial one to get started'"
	aWorld ifNotNil:
		[aWorld startStepping: self.
		self changed]! !

!SMxMorph methodsFor: 'creation' stamp: 'tk 2/6/1999 22:43'!
asMorph
	^ self! !

!SMxMorph methodsFor: 'accessing - extension' stamp: 'dgd 2/16/2003 19:55'!
assureExtension
	"creates an extension for the receiver if needed"
	self hasExtension
		ifFalse: [self initializeExtension].
	^ self extension! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 5/23/2009 00:23'!
balloonColor
	^ self defaultBalloonColor! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 5/23/2009 00:24'!
balloonFont
	^ self defaultBalloonFont! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 2/7/2000 11:27'!
balloonHelpAligner
	"Answer the morph to which the receiver's balloon help should point"
	^ (self valueOfProperty: #balloonTarget) ifNil: [self]! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 9/11/2000 21:44'!
balloonHelpDelayTime
	"Return the number of milliseconds before a balloon help should be put up on the receiver. The balloon help will only be put up if the receiver responds to #wantsBalloon by returning true."
	^800! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'JuanVuletich 10/13/2010 09:57'!
balloonHelpTextForHandle: aHandle
	"Answer a string providing balloon help for the given halo handle"

	|  itsSelector |
	itsSelector := aHandle eventHandler firstMouseSelector.
	#(
		(chooseEmphasisOrAlignment			'Emphasis & alignment')
		(chooseFont								'Change font')
		(dismiss									'Remove')
		(doDebug:with:							'Debug')
		(doDirection:with:						'Choose forward direction')
		(doDup:with:								'Duplicate')
		(doMenu:with:							'Menu')
		(doGrab:with:								'Pick up')
		(doRecolor:with:							'Change color')
		(maybeDoDup:with:						'Duplicate')
		(mouseDownInCollapseHandle:with:	'Collapse')
		(mouseDownOnHelpHandle:			'Help')
		(startDrag:with:							'Move')
		(startGrow:with:							'Change size') 
		(startRot:with:							'Rotate')) 


	do:
		[ :pair | itsSelector == pair first ifTrue: [^ pair last]].

	(itsSelector == #mouseDownInDimissHandle:with:) ifTrue: [
			'Remove from screen'].

	^ 'unknown halo handle'! !

!SMxMorph methodsFor: 'accessing' stamp: 'jmv 5/28/2006 23:35'!
balloonText
	"Answer balloon help text or nil, if no help is available.  
	NB: subclasses may override such that they programatically  
	construct the text, for economy's sake, such as model phrases in 
	a Viewer"

	| text |
	self hasExtension ifFalse: [^nil].
	(text := self extension balloonText) ifNotNil: [^text].
	^nil! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 8/2/2010 16:23'!
basicExtent: aPoint

	bounds extent = aPoint ifTrue: [^ self].
	self changed.
	bounds := bounds topLeft extent: aPoint.
	self layoutChanged.
	self changed.
! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:57'!
beSticky
	"make the receiver sticky"
	self assureExtension sticky: true! !

!SMxMorph methodsFor: 'geometry eToy' stamp: 'sw 10/23/1998 12:01'!
beTransparent
	self color: Color transparent! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 10/9/2009 13:03'!
blueButtonDown: anEvent
	"Special gestures (cmd-mouse on the Macintosh; Alt-mouse on Windows and Unix) allow a mouse-sensitive morph to be moved or bring up a halo for the morph."
	| h doNotDrag |
	h := anEvent hand halo.
	"Prevent wrap around halo transfers originating from throwing the event back in"
	doNotDrag := false.
	h ifNotNil:[
		(h innerTarget == self) ifTrue:[doNotDrag := true].
		(h innerTarget hasOwner: self) ifTrue:[doNotDrag := true].
		(self hasOwner: h target) ifTrue:[doNotDrag := true]].

	"cmd-drag on flexed morphs works better this way"
	h := self addHalo: (anEvent externalizedFromOwnerOf: self to: nil).
	doNotDrag ifTrue:[^self].
	"Initiate drag transition if requested"
	anEvent hand 
		waitForClicksOrDrag: h
		event: (anEvent externalizedFromOwnerOf: self to: nil)
		clkSel: nil
		dblClkSel: nil
		dblClkTimeoutSel: nil
		dragSel: #dragTarget:.
	"Pass focus explicitly here"
	anEvent hand newMouseFocus: h.! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 9/15/2000 20:25'!
blueButtonUp: anEvent
	"Ignored. Theoretically we should never get here since control is transferred to the halo on #blueButtonDown: but subclasses may implement this differently."! !

!SMxMorph methodsFor: 'accessing' stamp: 'jmv 5/17/2009 23:14'!
borderWidth
	^0! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
bottom

	^ bounds bottom! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 5/5/1998 01:24'!
bottom: aNumber
	self position: (bounds left @ (aNumber - self height))! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 3/6/2002 13:06'!
bottomCenter

	^ bounds bottomCenter! !

!SMxMorph methodsFor: 'geometry' stamp: 'tk 9/8/97 10:44'!
bottomLeft

	^ bounds bottomLeft! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 6/12/97 11:17'!
bottomRight

	^ bounds bottomRight! !

!SMxMorph methodsFor: 'geometry' stamp: 'jm 8/3/97 15:50'!
bounds
	"Return the bounds of this morph."
	"Note: It is best not to override this method because many methods in SMxMorph and its subclasses use the instance variable directly rather than 'self bounds'. Instead, subclasses should be sure that the bounds instance variable is correct."

	^ bounds
! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 8/23/2010 18:09'!
bounds: newBounds
	| oldExtent newExtent |
	oldExtent := bounds extent.
	newExtent := newBounds extent.
	"Moving stuff around is most likely the most common operation.
	Optimize it"
	oldExtent = newExtent ifTrue: [
		^self position: newBounds topLeft ].
	(oldExtent dotProduct: oldExtent) <= (newExtent dotProduct: newExtent) ifTrue:[
		"We're growing. First move then resize."
		self position: newBounds topLeft; extent: newExtent.
	] ifFalse:[
		"We're shrinking. First resize then move."
		self extent: newExtent; position: newBounds topLeft.
	].! !

!SMxMorph methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:41'!
bounds: aRectangle in: referenceMorph
	"Return the receiver's bounds as seen by aMorphs coordinate frame"
	^(self externalizePositionFromOwner: aRectangle origin to: referenceMorph)
		corner:
	(self externalizePositionFromOwner: aRectangle corner to: referenceMorph)! !

!SMxMorph methodsFor: 'debug and other' stamp: 'jmv 9/16/2009 09:50'!
buildDebugMenu: aHand 
	"Answer a debugging menu for the receiver.  The hand argument is seemingly historical and plays no role presently"

	| aMenu |
	aMenu := SMxMenuMorph new defaultTarget: self.
	aMenu addStayUpIcons.
	self isKnownFailing
		ifTrue: 
			[aMenu add: 'start drawing again' translated action: #resumeAfterDrawError.
			aMenu addLine].
	(self hasProperty: #errorOnStep) 
		ifTrue: 
			[aMenu add: 'start stepping again' translated action: #resumeAfterStepError.
			aMenu addLine].
	aMenu add: 'inspect morph' translated action: #inspectInMorphic:.
	aMenu add: 'inspect owner chain' translated action: #inspectOwnerChain.
	self hasModel 
		ifTrue: 
			[aMenu 
				add: 'inspect model' translated
				target: self model
				action: #inspect].
	aMenu 
		add: 'explore morph' translated
		target: self
		selector: #explore.
	aMenu addLine.
	aMenu 
		add: 'browse morph class' translated
		target: self
		selector: #browseHierarchy.
	self hasModel 
		ifTrue: 
			[aMenu 
				add: 'browse model class'
				target: self model
				selector: #browseHierarchy].
	aMenu addLine.
	aMenu
		add: 'control-menu...' translated
			target: self
			selector: #invokeMetaMenu:;
		add: 'edit balloon help' translated action: #editBalloonHelpText.
	^aMenu! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/17/2009 23:42'!
buildHandleMenu: aHand
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	menu := SMxMenuMorph new defaultTarget: self.
	menu addStayUpIcons.
	menu addLine.
	self addStandardHaloMenuItemsTo: menu hand: aHand.
	menu defaultTarget: aHand.
	self addAddHandMenuItemsForHalo: menu  hand: aHand.
	menu defaultTarget: self.
	self addCustomHaloMenuItems: menu hand: aHand.
	menu defaultTarget: aHand.
	^ menu
! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/17/2009 23:42'!
buildMetaMenu: evt 
	"Build the morph menu. This menu has two sections. The first section contains commands that are handled by the hand; the second contains commands handled by the argument morph."

	| menu |
	menu := SMxMenuMorph new defaultTarget: self.
	menu addStayUpIcons.
	menu add: 'grab' translated action: #grabMorph:.
	menu add: 'copy to paste buffer' translated action: #copyToPasteBuffer:.
	self maybeAddCollapseItemTo: menu.
	menu add: 'delete' translated action: #dismissMorph:.
	menu addLine.
	menu add: 'copy text' translated action: #clipText.
	menu addLine.
	menu add: 'go behind' translated action: #goBehind.
	menu add: 'add halo' translated action: #addHalo:.
	menu add: 'duplicate' translated action: #maybeDuplicateMorph:.
	self addEmbeddingMenuItemsTo: menu hand: evt hand.
	menu add: 'resize' translated action: #resizeMorph:.
	"Give the argument control over what should be done about fill styles"
	self addFillStyleMenuItems: menu hand: evt hand.
	menu 
		addUpdating: #hasClipSubmorphsString
		target: self
		selector: #changeClipSubmorphs
		argumentList: #().
	menu addLine.
	(self morphsAt: evt position) size > 1 
		ifTrue: 
			[menu 
				add: 'submorphs...' translated
				target: self
				selector: #invokeMetaMenuAt:event:
				argument: evt position].
	menu addLine.
	menu 
		add: 'inspect' translated
		selector: #inspectAt:event:
		argument: evt position.
	menu add: 'explore' translated action: #explore.
	menu add: 'browse hierarchy' translated action: #browseHierarchy.
	menu add: 'show actions' translated action: #showActions.
	menu addLine.
	self addDebuggingItemsTo: menu hand: evt hand.
	self addCustomMenuItems: menu hand: evt hand.
	^menu! !

!SMxMorph methodsFor: 'testing' stamp: 'ar 8/25/2001 19:14'!
canDrawBorder: aBorderStyle
	"Return true if the receiver can be drawn with the given border style."
	^true! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
center

	^ bounds center! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 6/11/1999 18:48'!
center: aPoint
	self position: (aPoint - (self extent // 2))! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:38'!
changeClipSubmorphs
	self clipSubmorphs: self clipsSubmorphs not.! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 4/27/2010 10:22'!
changeColor
	"Change the color of the receiver -- triggered, e.g. from a menu"

	SMxColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #fillStyle:;
		originalColor: self color;
		putUpFor: self near: self fullDisplayBounds! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 4/27/2010 10:22'!
changeColorTarget: anObject selector: aSymbol originalColor: aColor hand: aHand
	"Put up a color picker for changing some kind of color.  May be modal or modeless, depending on #modalColorPickers setting"
	self flag: #arNote. "Simplify this due to anObject == self for almost all cases"
	^ SMxColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: aHand;
		target: anObject;
		selector: aSymbol;
		originalColor: aColor;
		putUpFor: anObject near: ((anObject is: #SMxMorph)
					ifTrue:	 [Rectangle center: self position extent: 20]
					ifFalse: [anObject == self world
								ifTrue: [anObject viewBox bottomLeft + (20 @ -20) extent: 200]
								ifFalse: [anObject fullDisplayBounds]]);
		yourself! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'jmv 1/12/2010 11:21'!
changeDocumentAnchor
	"Change the anchor from/to document anchoring"

	| newType |
	newType := self textAnchorType == #document 
		ifTrue: [#paragraph]
		ifFalse: [ #document].
	(owner is: #SMxTextMorph) 
		ifTrue: [
			owner 
				anchorMorph: self
				at: self position
				type: newType]! !

!SMxMorph methodsFor: 'menus' stamp: 'ar 11/2/2000 15:04'!
changeDragAndDrop
	^self enableDragNDrop: self dragNDropEnabled not! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'jmv 1/12/2010 11:21'!
changeInlineAnchor
	"Change the anchor from/to line anchoring"

	| newType |
	newType := self textAnchorType == #inline 
				ifTrue: [#paragraph]
				ifFalse: [#inline]. 
	(owner is: #SMxTextMorph)
		ifTrue: [
			owner
				anchorMorph: self
				at: self position
				type: newType]! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'jmv 1/12/2010 11:22'!
changeParagraphAnchor
	"Change the anchor from/to paragraph anchoring"

	| newType |
	newType := self textAnchorType == #paragraph 
		ifTrue: [#document]
		ifFalse: [#paragraph].
	(owner is: #SMxTextMorph)
		ifTrue: [
			owner 
				anchorMorph: self
				at: self position
				type: newType]! !

!SMxMorph methodsFor: 'updating' stamp: 'jmv 8/24/2010 10:53'!
changed
	"Report that the area occupied by this morph should be redrawn."
	self invalidRect: (fullBounds ifNil: [ bounds ])! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 9/6/2000 12:42'!
click
	"Pretend the user clicked on me."

	(self handlesMouseDown: nil) ifTrue: [
		self mouseDown: nil.
		self mouseUp: nil].! !

!SMxMorph methodsFor: 'event handling' stamp: 'LC 5/18/2000 09:54'!
click: evt
	"Handle a single-click event. This message is only sent to clients that request it by sending #waitForClicksOrDrag:event: to the initiating hand in their mouseDown: method. This default implementation does nothing.
	LC 2/14/2000 08:32 - added: SMxEventHandler notification"

	self eventHandler ifNotNil:
		[self eventHandler click: evt fromMorph: self].! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 9/12/2009 21:10'!
clipSubmorphs: aBoolean
	"Drawing specific. If this property is set, clip the receiver's submorphs to the receiver's clipping bounds."
	self invalidRect: self fullBounds.
	aBoolean
		ifTrue: [ self setProperty: #clipSubmorphs toValue: true ]
		ifFalse: [ self removeProperty: #clipSubmorphs ].
	self invalidRect: self fullBounds! !

!SMxMorph methodsFor: 'printing' stamp: 'bf 7/17/2003 12:53'!
clipText
	"Copy the text in the receiver or in its submorphs to the clipboard"
	| content |
	"My own text"
	content := self userString.
	"Or in my submorphs"
	content ifNil: [
		| list |
		list := self allStringsAfter: nil.
		list notEmpty ifTrue: [
			content := String streamContents: [:stream |
				list do: [:each | stream nextPutAll: each; cr]]]].
	"Did we find something?"
	content
		ifNil: [self flash "provide feedback"]
		ifNotNil: [Clipboard clipboardText: content].! !

!SMxMorph methodsFor: 'drawing' stamp: 'ar 10/29/2000 19:16'!
clippingBounds
	"Return the bounds to which any submorphs should be clipped if the property is set"
	^self innerBounds! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:37'!
clipsSubmorphs
	"Drawing specific. If this property is set, clip the receiver's  
	submorphs to the receiver's clipping bounds."
	^ self
		valueOfProperty: #clipSubmorphs
		ifAbsent: [false]! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 4/1/2009 21:44'!
collapse
self halt"
	CollapsedMorph new beReplacementFor: self"! !

!SMxMorph methodsFor: 'accessing' stamp: 'tk 2/15/2001 15:55'!
color

	^ color 	"has already been set to ((self valueOfProperty: #fillStyle) asColor)"! !

!SMxMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:52'!
color: aColor
	"Set the receiver's color.  Directly set the color if appropriate, else go by way of fillStyle"

	((aColor isColor) or: [aColor isKindOf: InfiniteForm]) ifFalse:[^ self fillStyle: aColor].
	color = aColor ifFalse: [
		self removeProperty: #fillStyle.
		color := aColor.
		self changed]! !

!SMxMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:53'!
colorForInsets
	"Return the color to be used for shading inset borders.  The default is my own color, but it might want to be, eg, my owner's color.  Whoever's color ends up prevailing, the color itself gets the last chance to determine, so that when, for example, an InfiniteForm serves as the color, callers won't choke on some non-Color object being returned"
	((color isColor) and: [ color isTransparent and: [ owner notNil]]) ifTrue:[^owner colorForInsets].
	^ color colorForInsets
! !

!SMxMorph methodsFor: 'printing' stamp: 'jmv 3/2/2010 16:15'!
colorString: aColor 
	aColor ifNil: [^'nil'].
	Color colorNames 
		do: [:colorName | aColor = (Color perform: colorName) ifTrue: [^'Color ' , colorName]].
	^aColor storeString! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 11/12/2006 22:09'!
comeToFront
	(self owner isNil or: [self owner hasSubmorphs not]) 
		ifTrue: [^self].
	self owner firstSubmorph == self 
		ifFalse: [self owner addMorphFront: self]! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 3/1/2000 11:39'!
comeToFrontAndAddHalo
	self comeToFront.
	self addHalo! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 4/27/2010 11:29'!
computeFullBounds
	"Private. Compute the actual full bounds of the receiver"

	(submorphs isEmpty or: [ self clipsSubmorphs ]) ifTrue: [  bounds ].
	^ bounds quickMerge: self submorphBounds! !

!SMxMorph methodsFor: 'e-toy support' stamp: 'jmv 1/15/2005 20:16'!
containingWindow
	"Answer a window or window-with-mvc that contains the receiver"

	^self ownerThatIsA: SMxSystemWindow! !

!SMxMorph methodsFor: 'geometry testing' stamp: 'jmv 4/27/2010 11:29'!
containsPoint: aPoint
	| shadow |
	"Most morphs answer true to to #isOrthoRectangularMorph, or redefine this method..."
	self isOrthoRectangularMorph ifTrue: [
		^ bounds containsPoint: aPoint ].
	
	"...But for those who not, provide correct albeit expensive behavior."
	shadow := self ownShadowForm.
	^(shadow pixelValueAt: aPoint - shadow offset) > 0! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 3/8/2010 14:27'!
containsPoint: aPoint event: anEvent
	"Return true if aPoint is considered to be inside the receiver for the given event.
	The default implementation treats locked children as integral part of their owners."
	(self fullBounds containsPoint: aPoint) ifFalse:[^false].
	(self containsPoint: aPoint) ifTrue:[^true].
	self submorphsDo: [ :m|
		(m isLocked and: [ m fullContainsPoint: (m internalizePositionToOwner: aPoint from: self) ]) ifTrue:[^true]].
	^false! !

!SMxMorph methodsFor: 'copying' stamp: 'tk 2/19/2001 18:21'!
copy

	^ self veryDeepCopy! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 10/5/2000 16:44'!
copyToPasteBuffer: evt
	self okayToDuplicate ifTrue:[evt hand copyToPasteBuffer: self].! !

!SMxMorph methodsFor: 'e-toy support' stamp: 'sw 9/8/2000 16:34'!
cursor
	"vacuous backstop in case it gets sent to a morph that doesn't know what to do with it"

	^ 1! !

!SMxMorph methodsFor: 'event handling' stamp: 'sw 3/8/1999 00:17'!
cursorPoint
	^ self currentHand lastEvent cursorPoint! !

!SMxMorph methodsFor: 'copying' stamp: 'tk 2/14/2001 12:47'!
deepCopy

	self error: 'Please use veryDeepCopy'.
! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sma 11/11/2000 16:15'!
defaultBalloonColor
	^ Display depth <= 2
		ifTrue: [Color white]
		ifFalse: [SMxBalloonMorph balloonColor]! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sd 12/5/2001 20:23'!
defaultBalloonFont
	^ SMxBalloonMorph balloonFont! !

!SMxMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:06'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 50 @ 40! !

!SMxMorph methodsFor: 'visual properties' stamp: 'ar 6/25/1999 11:11'!
defaultColor
	"Return the default fill style for the receiver"
	^Color blue! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/13/2000 14:51'!
defaultEventDispatcher
	"Return the default event dispatcher to use with events that are directly sent to the receiver"
	^SMxMorphicEventDispatcher new! !

!SMxMorph methodsFor: 'user interface' stamp: 'sw 5/29/2000 00:41'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on the receiver."
	^ super printString truncateTo: 40! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'JuanVuletich 11/1/2010 15:36'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	aWorld := self world ifNil: [SimpleMorphicUIManager smxWorld].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil: [
		self activeHand
			releaseKeyboardFocus: self;
			releaseMouseFocus: self].
	owner ifNotNil:[ self privateDelete].! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 10/3/2000 17:03'!
deleteBalloon
	"If I am showing a balloon, delete it."
	| w |
	w := self world ifNil:[^self].
	w deleteBalloonTarget: self.! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 11/6/2008 18:35'!
dismissMorph: evt
	| w |
	w := self world ifNil:[^self].
	w deleteAllHalos; stopStepping: self.
	self delete
! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'JuanVuletich 11/1/2010 15:25'!
dismissViaHalo
	"The user has clicked in the delete halo-handle.  This provides a hook in case some concomitant action should be taken, or if the particular morph is not one which should be put in the trash can, for example."

	^ self dismissMorph: SimpleMorphicUIManager smxActiveEvent! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:29'!
displayBounds
	^self bounds: bounds in: self world! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 8/23/2010 18:39'!
doLayoutIfNeeded
	"Return self. Recompute the layout if necessary."
	fullBounds ifNotNil: [ ^self ].

	"Errors at this point can be critical so make sure we catch 'em all right"
	[self layoutSubmorphsIn: self layoutBounds] on: Error do: [ :ex |
		"This should do it unless you don't screw up the bounds"
		fullBounds := bounds.
		ex pass ]! !

!SMxMorph methodsFor: 'accessing' stamp: 'nk 4/15/2004 07:50'!
doesBevels
	"To return true means that this object can show bevelled borders, and
	therefore can accept, eg, #raised or #inset as valid borderColors.
	Must be overridden by subclasses that do not support bevelled borders."

	^ false! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 10/7/2009 16:57'!
doesLayout
	^true! !

!SMxMorph methodsFor: 'event handling' stamp: 'LC 5/18/2000 09:54'!
doubleClick: evt
	"Handle a double-click event. This message is only sent to clients that request it by sending #waitForClicksOrDrag:event: to the initiating hand in their mouseDown: method. This default implementation does nothing.
	LC 2/14/2000 08:32 - added: SMxEventHandler notification"

	self eventHandler ifNotNil:
		[self eventHandler doubleClick: evt fromMorph: self].! !

!SMxMorph methodsFor: 'event handling' stamp: 'jcg 10/2/2001 09:26'!
doubleClickTimeout: evt
	"Handle a double-click timeout event. This message is only sent to clients that request it by sending #waitForClicksOrDrag:event: to the initiating hand in their mouseDown: method. This default implementation does nothing."

	self eventHandler ifNotNil:
		[self eventHandler doubleClickTimeout: evt fromMorph: self].! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/25/2000 15:50'!
dragEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."
	^(self valueOfProperty: #dragEnabled) == true
! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:18'!
dragEnabled: aBool
	^self enableDrag: aBool! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:20'!
dragNDropEnabled
	"Note: This method is only useful for dragEnabled == dropEnabled at all times"
	self separateDragAndDrop.
	^self dragEnabled and:[self dropEnabled]! !

!SMxMorph methodsFor: 'drawing' stamp: 'panda 4/28/2000 11:59'!
drawDropHighlightOn: aCanvas
	self highlightedForDrop ifTrue: [
		aCanvas frameRectangle: self fullBounds color: self dropHighlightColor].! !

!SMxMorph methodsFor: 'drawing' stamp: 'ar 4/2/1999 13:13'!
drawErrorOn: aCanvas
	"The morph (or one of its submorphs) had an error in its drawing method."
	aCanvas
		frameAndFillRectangle: bounds
		fillColor: Color red
		borderWidth: 1
		borderColor: Color yellow.
	aCanvas line: bounds topLeft to: bounds bottomRight width: 1 color: Color yellow.
	aCanvas line: bounds topRight to: bounds bottomLeft width: 1 color: Color yellow.! !

!SMxMorph methodsFor: 'drawing' stamp: '   9/3/2000 13:55'!
drawMouseDownHighlightOn: aCanvas
	self highlightedForMouseDown ifTrue: [
		aCanvas frameRectangle: self fullBounds color: self color darker darker].! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:30'!
drawOn: aCanvas

	aCanvas fillRectangle: bounds fillStyle: self fillStyle! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 3/11/2010 10:51'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front"
	submorphs isEmpty ifTrue: [ ^ self ].
	self clipsSubmorphs
		ifTrue:
			[ aCanvas
				clipBy: self clippingBounds
				during:
					[ : clippedCanvas | 
					submorphs reverseDo:
						[ : m |  clippedCanvas fullDrawMorph: m ] ] ]
		ifFalse:
			[ submorphs reverseDo:
				[ : m |  aCanvas fullDrawMorph: m ] ]! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 11/5/2007 23:00'!
drawingFails
	self world addKnownFailing: self! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 11/5/2007 23:01'!
drawingFailsNot
	self world removeKnownFailing: self! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/25/2000 15:51'!
dropEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."
	^(self valueOfProperty: #dropEnabled) == true
! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:18'!
dropEnabled: aBool
	^self enableDrop: aBool! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/28/2000 10:52'!
dropHighlightColor
	^ Color blue! !

!SMxMorph methodsFor: 'copying' stamp: 'jmv 5/17/2009 11:26'!
duplicate
	"Make and return a duplicate of the receiver"

	| newMorph |
	self okayToDuplicate ifFalse: [^ self].
	newMorph := self copy.

	newMorph arrangeToStartStepping.
	newMorph privateOwner: nil. "no longer in world"

	^ newMorph! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 11/4/2000 17:56'!
duplicateMorph: evt
	"Make and return a duplicate of the receiver's argument"
	| dup |
	dup := self duplicate.
	evt hand grabMorph: dup from: owner. "duplicate was ownerless so use #grabMorph:from: here"
	^dup! !

!SMxMorph methodsFor: 'copying' stamp: 'jmv 5/15/2009 22:01'!
duplicateMorphCollection: aCollection
	"Make and return a duplicate of the receiver"

	| newCollection |

	newCollection := aCollection veryDeepCopy.
	newCollection do: [ :newMorph |
		newMorph arrangeToStartStepping.
		newMorph privateOwner: nil. "no longer in world"
	].

	^newCollection! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'StephaneDucasse 12/11/2010 21:07'!
editBalloonHelpContent: aString
	| reply |
	reply := SMxFillInTheBlankMorph
				request: 'Edit the balloon help text for ' , self externalName
				initialAnswer: (aString ifNil: [self noHelpString] ifNotNil: [aString])	
				centerAt: Sensor cursorPoint.
	reply ifNil: [^ self].  "User cancelled out of the dialog"
	(reply isEmpty or: [reply asString = self noHelpString])
		ifTrue: [self setBalloonText: nil]
		ifFalse: [self setBalloonText: reply]! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sma 12/23/1999 13:24'!
editBalloonHelpText
	"Modify the receiver's balloon help text."

	self editBalloonHelpContent: self balloonText! !

!SMxMorph methodsFor: 'e-toy support' stamp: 'JuanVuletich 10/18/2010 16:24'!
embeddedInMorphicWindowLabeled: labelString 
	| window |
	window := (SMxSystemWindow labelled: labelString) model: nil.
	window setWindowColor: self smxWindowColor.
	window addMorph: self frame: (0 @ 0 extent: 1 @ 1).
	^window! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/25/2000 15:50'!
enableDrag: aBoolean
	self setProperty: #dragEnabled toValue: aBoolean! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/25/2000 15:41'!
enableDragNDrop
	self enableDragNDrop: true! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:21'!
enableDragNDrop: aBoolean
	"Set both properties at once"
	self separateDragAndDrop.
	self enableDrag: aBoolean.
	self enableDrop: aBoolean.! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/25/2000 15:51'!
enableDrop: aBoolean
	self setProperty: #dropEnabled toValue: aBoolean! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:51'!
eventHandler
	"answer the receiver's eventHandler"
	^ self hasExtension
		ifTrue: [self extension eventHandler] ! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 19:25'!
eventHandler: anEventHandler 
	"Note that morphs can share eventHandlers and all is OK. "
	self assureExtension eventHandler: anEventHandler! !

!SMxMorph methodsFor: 'menus' stamp: 'StephaneDucasse 12/11/2010 21:04'!
exportAsBMP
	| fName |
	fName := SMxFillInTheBlankMorph 
				request:'Please enter the name' 
				initialAnswer: self externalName,'.bmp'.
	fName isEmpty ifTrue:[^self].
	self imageForm writeBMPfileNamed: fName.! !

!SMxMorph methodsFor: 'menus' stamp: 'StephaneDucasse 12/11/2010 21:05'!
exportAsJPEG
	"Export the receiver's image as a JPEG"

	| fName |
	fName := SMxFillInTheBlankMorph
				request: 'Please enter the name' 
				initialAnswer: self externalName,'.jpeg'.
	fName isEmpty ifTrue: [^ self].
	self imageForm writeJPEGfileNamed: fName! !

!SMxMorph methodsFor: 'menus' stamp: 'StephaneDucasse 12/11/2010 21:05'!
exportAsPNG
	| fName |
	fName := SMxFillInTheBlankMorph 
				request:'Please enter the name' 
				initialAnswer: self externalName,'.png'.
	fName isEmpty ifTrue:[^self].
	PNGReadWriter putForm: self imageForm onFileNamed: fName.! !

!SMxMorph methodsFor: 'property extension' stamp: 'di 8/10/1998 14:25'!
extension
	^ extension! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
extent

	^ bounds extent! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 8/2/2010 16:23'!
extent: aPoint

	self basicExtent: aPoint! !

!SMxMorph methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:43'!
externalizePosition: pointInSelf to: aReferenceMorph
	"aPoint is in our coordinate system
	answer is in aReferenceMorph's coordinateSystem"

	self == aReferenceMorph
		ifTrue: [ ^pointInSelf ].
	
	"This might actually indicate an error condition. For now, just answer something!!"
	owner ifNil: [
		^pointInSelf ].
	
	^owner externalizePosition: pointInSelf to: aReferenceMorph! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:19'!
externalizePositionFromOwner: pointInOwner to: aReferenceMorph
	"Translate aPoint that is expressedn in owner's coordinates out up to aReferenceMorph's coordinates"
	owner ifNil: [^ pointInOwner].
	^ owner externalizePosition: pointInOwner to: aReferenceMorph! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/30/2010 13:50'!
externalizePositionToWorld: pointInSelf
	"aPoint is in our coordinate system
	answer is in World's coordinateSystem"

	^self externalizePosition: pointInSelf to: self world! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:33'!
externalizeScalar: distanceInSelf to: aReferenceMorph
	"distanceInSelf is a number, and  is in our coordinate system
	answer is in aReferenceMorph's coordinateSystem"

	| p1 p2 |
	p1 := distanceInSelf@0.
	p2 := (self externalizePosition: p1 to: aReferenceMorph) - (self externalizePosition: 0@0 to: aReferenceMorph).
	^ p2 x! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:17'!
externalizeVector: vectorInSelf to: aReferenceMorph
	"vectorInSelf is a point in our coordinate system that is a distance or difference between 2 positions, and not a position
	answer is in aReferenceMorph's coordinateSystem"

	^(self externalizePosition: vectorInSelf to: aReferenceMorph) - (self externalizePosition: 0@0 to: aReferenceMorph)! !

!SMxMorph methodsFor: 'visual properties' stamp: 'ar 6/25/1999 11:11'!
fillStyle
	"Return the current fillStyle of the receiver."
	^self valueOfProperty: #fillStyle ifAbsent:[
		"Workaround already converted morphs"
		color ifNil:[self defaultColor]].! !

!SMxMorph methodsFor: 'visual properties' stamp: 'ar 6/18/1999 07:05'!
fillStyle: aFillStyle
	"Set the current fillStyle of the receiver."
	self setProperty: #fillStyle toValue: aFillStyle.
	"Workaround for Morphs not yet converted"
	color := aFillStyle asColor.
	self changed.! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 3/2/2010 09:59'!
findA: aClass
	"Return the first submorph of the receiver that is descended from the given class. Return nil if there is no such submorph. Clients of this code should always check for a nil return value so that the code will be robust if the user takes the morph apart."

	^self submorphs
		detect: [:p | p isKindOf: aClass]
		ifNone: nil! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'LC 9/28/1999 19:12'!
findDeepSubmorphThat: block1 ifAbsent: block2 
	self
		allMorphsDo: [:m | (block1 value: m)
				== true ifTrue: [^ m]].
	^ block2 value! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 5/10/2010 14:04'!
findSubmorphBinary: aBlock
	"Use binary search for finding a specific submorph of the receiver. Caller must be certain that the ordering holds for the submorphs."
	^submorphs findBinary: aBlock do: [ :found | found ] ifNone: nil! !

!SMxMorph methodsFor: 'structure' stamp: 'di 11/13/2000 00:48'!
firstOwnerSuchThat: conditionBlock

	self allOwnersDo: [:m | (conditionBlock value: m) ifTrue: [^ m]].
	^ nil
! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'dgd 2/22/2003 14:31'!
firstSubmorph
	^submorphs first! !

!SMxMorph methodsFor: 'macpal' stamp: 'sw 10/10/1999 10:23'!
flash
	| c w |
	c := self color.
	self color: Color black.
	(w := self world) ifNotNil: [w displayWorldSafely].
	self color: c
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'JuanVuletich 10/18/2010 09:04'!
focusKeyboardFor: aKeyboardEvent
	"If aKeyboardEvent is an arrow key, use it to navigate keyboard focus"

	"Keyboard focus navigations with alt/command + control + arrows"
	(aKeyboardEvent commandKeyPressed and: [ aKeyboardEvent controlKeyPressed ])
		ifFalse: [ ^false ].

	^aKeyboardEvent keyValue caseOf: {
		[ 28 ] -> [
			aKeyboardEvent hand keyboardFocusPrevious.
			true ].
		[ 29 ] -> [
			aKeyboardEvent hand keyboardFocusNext.
			true ].
		[ 30 ] -> [
			aKeyboardEvent hand keyboardFocusPrevious.
			true ].
		[ 31 ] -> [
			aKeyboardEvent hand keyboardFocusNext.
			true ] }
		otherwise: [ false ]! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/5/2000 18:13'!
formerOwner
	^self valueOfProperty: #formerOwner! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 3/2/2010 16:16'!
formerOwner: aMorphOrNil 
	aMorphOrNil 
		ifNil: [self removeProperty: #formerOwner]
		ifNotNil: [self setProperty: #formerOwner toValue: aMorphOrNil]! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/5/2000 18:13'!
formerPosition
	^self valueOfProperty: #formerPosition! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 3/2/2010 16:16'!
formerPosition: formerPosition 
	formerPosition 
		ifNil: [self removeProperty: #formerPosition]
		ifNotNil: [self setProperty: #formerPosition toValue: formerPosition]! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 4/27/2010 11:08'!
fullBounds
	"Return the bounding box of the receiver and all its children. Recompute the layout if necessary."
	self doLayoutIfNeeded.
	^fullBounds! !

!SMxMorph methodsFor: 'geometry testing' stamp: 'jmv 10/8/2009 20:26'!
fullContainsPoint: aPoint
"
	This alternative implementation is included in this comment because it could be useful someday.
	If we start to rely heavily on the use of #ownShadowForm in #containsPoint, this could be cheaper.
	
	| shadow |
	self clipSubmorphs
		ifTrue: [ ^self containsPoint: aPoint ]
		ifFalse: [
			(self fullBounds containsPoint: aPoint) ifFalse: [^ false].
			(self containsPoint: aPoint) ifTrue: [^ true].
			shadow := self shadowForm.
			^(shadow pixelValueAt: aPoint - shadow offset) > 0 ]
"
	
	(self fullBounds containsPoint: aPoint) ifFalse: [ ^ false ].  "quick elimination"
	(self containsPoint: aPoint) ifTrue: [ ^ true ].  "quick acceptance"
	submorphs do: [:m | (m fullContainsPoint: aPoint) ifTrue: [ ^ true ]].
	^ false
! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 10:20'!
fullDisplayBounds
	^self bounds: self fullBounds in: self world! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:30'!
fullDrawOn: aCanvas
	"Draw the full Morphic structure on the given SMxCanvas"

	self visible ifFalse: [^ self].
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].		"Needs fullBounds 'in owner' if inside a scroller"
	self isKnownFailing ifTrue: [^self drawErrorOn: aCanvas].

	"Draw receiver itself"
	(aCanvas isVisible: bounds) ifTrue:[aCanvas drawMorph: self].	"Needs bounds 'in owner' if inside a scroller"
	self drawSubmorphsOn: aCanvas.
	self drawDropHighlightOn: aCanvas.
	self drawMouseDownHighlightOn: aCanvas! !

!SMxMorph methodsFor: 'caching' stamp: 'jm 11/13/97 16:34'!
fullReleaseCachedState
	"Release the cached state of the receiver and its full submorph tree."

	self allMorphsDo: [:m | m releaseCachedState].
! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 5/6/2008 23:18'!
goBehind

	owner addMorphBack: self.
! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 10/6/2000 16:37'!
grabMorph: evt

	evt hand grabMorph: self! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 3/17/2001 13:19'!
halo

	(self outermostWorldMorph ifNil: [^nil]) haloMorphs do: [:h | h target == self ifTrue: [^ h]].
	^ nil! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 4/1/2009 21:44'!
haloClass
	"Answer the name of the desired kind of SMxHaloMorph to launch on behalf of the receiver"

	^#SMxHaloMorph! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 3/8/2010 14:27'!
handleDropMorph: anEvent
	"Handle a dropping morph."
	| aMorph localPt |
	aMorph := anEvent contents.
	"Do a symmetric check if both morphs like each other"
	((self wantsDroppedMorph: aMorph event: anEvent)	"I want her"
		and: [aMorph wantsToBeDroppedInto: self])		"she wants me"
		ifFalse: [
				^ self].
	anEvent wasHandled: true.
	"Transform the morph into the receiver's coordinate frame. This is currently incomplete since it only takes the offset into account where it really should take the entire transform."
	localPt := self internalizePositionToOwner: aMorph referencePosition from: anEvent hand world.
	aMorph referencePosition: localPt.
	self acceptDroppingMorph: aMorph event: anEvent.
	aMorph justDroppedInto: self event: anEvent.
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/15/2000 21:13'!
handleEvent: anEvent
	"Handle the given event"
	^anEvent sentTo: self.! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 10/4/2000 18:48'!
handleFocusEvent: anEvent
	"Handle the given event. This message is sent if the receiver currently has the focus and is therefore receiving events directly from some hand."
	^self handleEvent: anEvent! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 11/10/2008 13:03'!
handleKeyDown: anEvent
	"System level event handling."

	anEvent wasHandled ifTrue:[^self].
	self handlesKeyboard ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyDown: anEvent! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 11/10/2008 13:03'!
handleKeyUp: anEvent
	"System level event handling."

	anEvent wasHandled ifTrue:[^self].
	self handlesKeyboard ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyUp: anEvent! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 11/10/2008 13:03'!
handleKeystroke: anEvent
	"System level event handling."

	anEvent wasHandled ifTrue:[^self].
	self handlesKeyboard ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyStroke: anEvent! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/16/2000 14:22'!
handleListenEvent: anEvent
	"Handle the given event. This message is sent if the receiver is a registered listener for the given event."
	^anEvent sentTo: self.! !

!SMxMorph methodsFor: 'event handling' stamp: 'jmv 11/7/2008 13:51'!
handleMouseDown: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand removePendingBalloonFor: self.
	anEvent wasHandled: true.
	self activateWindow.

	(anEvent controlKeyPressed
			and: [SMxPreferences cmdGesturesEnabled])
		ifTrue: [^ self invokeMetaMenu: anEvent].

	"Make me modal during mouse transitions"
	anEvent hand newMouseFocus: self event: anEvent.
	anEvent blueButtonChanged ifTrue:[^self blueButtonDown: anEvent].

	self mouseDown: anEvent.
	anEvent hand removeHaloFromClick: anEvent on: self.

	(self handlesMouseStillDown: anEvent) ifTrue:[
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue + self mouseStillDownThreshold
			arguments: {anEvent copy resetHandlerFields}
			stepTime: self mouseStillDownStepRate ].
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 12/8/2004 12:39'!
handleMouseEnter: anEvent
	"System level event handling."
	(anEvent isDraggingEvent) ifTrue:[
		(self handlesMouseOverDragging: anEvent) ifTrue:[
			anEvent wasHandled: true.
			self mouseEnterDragging: anEvent].
		^self].
	self wantsBalloon
			ifTrue:[anEvent hand triggerBalloonFor: self after: self balloonHelpDelayTime].
	(self handlesMouseOver: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseEnter: anEvent.
	].! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 8/26/2008 13:03'!
handleMouseLeave: anEvent
	"System level event handling."
	anEvent hand removePendingBalloonFor: self.
	anEvent isDraggingEvent ifTrue:[
		(self handlesMouseOverDragging: anEvent) ifTrue:[
			anEvent wasHandled: true.
			self mouseLeaveDragging: anEvent].
		^self].
	(self handlesMouseOver: anEvent) ifTrue:[
		anEvent wasHandled: true.
		self mouseLeave: anEvent.
	].
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'NS 2/18/2001 17:00'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	"Rules say that by default a morph gets #mouseMove iff
		* the hand is not dragging anything,
			+ and some button is down,
			+ and the receiver is the current mouse focus."
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 4/23/2001 17:24'!
handleMouseOver: anEvent
	"System level event handling."
	anEvent hand mouseFocus == self ifTrue:[
		"Got this directly through #handleFocusEvent: so check explicitly"
		(self containsPoint: anEvent position event: anEvent) ifFalse:[^self]].
	anEvent hand noticeMouseOver: self event: anEvent! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 10/22/2000 17:11'!
handleMouseStillDown: anEvent
	"Called from the stepping mechanism for morphs wanting continuously repeated 'yes the mouse is still down, yes it is still down, yes it has not changed yet, no the mouse is still not up, yes the button is down' etc messages"
	(anEvent hand mouseFocus == self) 
		ifFalse:[^self stopSteppingSelector: #handleMouseStillDown:].
	self mouseStillDown: anEvent.
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 10/22/2000 17:09'!
handleMouseUp: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand mouseFocus == self ifFalse:[^self]. "Not interested in other parties"
	anEvent hand releaseMouseFocus: self.
	anEvent wasHandled: true.
	anEvent blueButtonChanged
		ifTrue:[self blueButtonUp: anEvent]
		ifFalse:[self mouseUp: anEvent.
				self stopSteppingSelector: #handleMouseStillDown:].! !

!SMxMorph methodsFor: 'events-processing' stamp: 'md 10/22/2003 15:55'!
handleUnknownEvent: anEvent
	"An event of an unknown type was sent to the receiver. What shall we do?!!"
	Beeper beep. 
	anEvent printString displayAt: 0@0.
	anEvent wasHandled: true.! !

!SMxMorph methodsFor: 'events-processing' stamp: 'bf 8/30/2007 20:18'!
handleWindowEvent: anEvent
	"Handle an event concerning our host window"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(self wantsWindowEvent: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	self windowEvent: anEvent.
! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'StephaneDucasse 2/9/2011 18:05'!
handlerForBlueButtonDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event.
	Note: Halos handle blue button events themselves so we will only be asked if there is currently no halo on top of us."
	self wantsHaloFromClick ifFalse:[^nil].
	anEvent handler ifNil:[^self].
	(anEvent shiftPressed)
		ifFalse:[^nil] "let outer guy have it"
		ifTrue:[^self] "let me have it"
! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 10/12/2000 17:07'!
handlerForMetaMenu: evt
	"Return the prospective handler for invoking the meta menu. By default, the top-most morph in the innermost world gets this menu"
	self isWorldMorph ifTrue:[^self].
	evt handler ifNotNil:[evt handler isWorldMorph ifTrue:[^self]].
	^nil! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 10/7/2000 20:59'!
handlerForMouseDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event"
	anEvent blueButtonPressed ifTrue:[^self handlerForBlueButtonDown: anEvent].
	anEvent controlKeyPressed ifTrue:[^self handlerForMetaMenu: anEvent].
	(self handlesMouseDown: anEvent) ifFalse:[^nil]. "not interested"
	anEvent handler ifNil:[^self]. "Nobody else was interested"
	self mouseDownPriority >= anEvent handler mouseDownPriority 
		ifTrue:[^self] "Same priority but I am innermost"
		ifFalse:[^nil]. "Other guy has higher priority than I"! !

!SMxMorph methodsFor: 'event handling' stamp: 'jmv 11/10/2008 13:40'!
handlesKeyboard
	"Return true if the receiver wishes to handle keyboard events"
	
	self eventHandler ifNotNil: [^ self eventHandler handlesKeyboard].
	^ false
! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 8/10/1998 16:04'!
handlesMouseDown: evt
	"Do I want to receive mouseDown events (mouseDown:, mouseMove:, mouseUp:)?"
	"NOTE: The default response is false, except if you have added sensitivity to mouseDown events using the on:send:to: mechanism.  Subclasses that implement these messages directly should override this one to return true." 

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseDown: evt].
	^ false
! !

!SMxMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:31'!
handlesMouseOver: evt
	"Do I want to receive mouseEnter: and mouseLeave: when the button is up and the hand is empty?  The default response is false, except if you have added sensitivity to mouseEnter: or mouseLeave:, using the on:send:to: mechanism." 

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseOver: evt].
	^ false! !

!SMxMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:31'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient.  The default response is false, except if you have added sensitivity to mouseEnterLaden: or mouseLeaveLaden:, using the on:send:to: mechanism."
	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseOverDragging: evt].
	^ false! !

!SMxMorph methodsFor: 'event handling' stamp: 'ar 10/22/2000 17:06'!
handlesMouseStillDown: evt
	"Return true if the receiver wants to get repeated #mouseStillDown: messages between #mouseDown: and #mouseUp"
	self eventHandler ifNotNil: [^ self eventHandler handlesMouseStillDown: evt].
	^ false
! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 10/8/2009 09:38'!
hasClipSubmorphsString
	"Answer a string that represents the clip-submophs checkbox"
	^ (self clipsSubmorphs
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'provide clipping' translated! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'dgd 9/6/2003 18:14'!
hasDocumentAnchorString
	^ (self textAnchorType == #document
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'Document' translated! !

!SMxMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:24'!
hasDragAndDropEnabledString
	"Answer a string to characterize the drag & drop status of the  
	receiver"
	^ (self dragNDropEnabled
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'accept drops' translated! !

!SMxMorph methodsFor: 'accessing - extension' stamp: 'dgd 2/16/2003 19:55'!
hasExtension
	"answer whether the receiver has extention"
	^ self extension notNil! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'dgd 9/6/2003 18:14'!
hasInlineAnchorString
	^ (self textAnchorType == #inline
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'Inline' translated! !

!SMxMorph methodsFor: 'focus handling' stamp: 'JuanVuletich 11/1/2010 15:28'!
hasKeyboardFocus

	^SimpleMorphicUIManager smxActiveHand notNil and: [SimpleMorphicUIManager smxActiveHand keyboardFocus == self]! !

!SMxMorph methodsFor: 'testing' stamp: 'jmv 9/16/2009 09:50'!
hasModel
	^false! !

!SMxMorph methodsFor: 'structure' stamp: 'ar 10/3/2000 15:36'!
hasOwner: aMorph
	"Return true if the receiver has aMorph in its owner chain"
	aMorph ifNil:[^true].
	self allOwnersDo:[:m| m = aMorph ifTrue:[^true]].
	^false! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'dgd 9/6/2003 18:14'!
hasParagraphAnchorString
	^ (self textAnchorType == #paragraph
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'Paragraph' translated! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 20:58'!
hasProperty: aSymbol 
	"Answer whether the receiver has the property named aSymbol"
	self hasExtension
		ifFalse: [^ false].
	^ self extension hasProperty: aSymbol! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'dgd 2/22/2003 14:32'!
hasSubmorphs
	^submorphs notEmpty! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
height

	^ bounds height! !

!SMxMorph methodsFor: 'geometry' stamp: 'jm 1/29/98 14:26'!
height: aNumber

	self extent: self width@aNumber asInteger.
! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 2/23/2009 14:03'!
hide
	owner ifNil: [^ self].
	self visible: false! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 11/30/1998 12:44'!
highlight
	"The receiver is being asked to appear in a highlighted state.  Mostly used for textual morphs"
	self color: self highlightColor! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 3/6/1999 02:09'!
highlightColor
	
	| val |
	^ (val := self valueOfProperty: #highlightColor)
		ifNotNil:
			[val ifNil: [self error: 'nil highlightColor']]
		ifNil:
			[owner ifNil: [self color] ifNotNil: [owner highlightColor]]! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/28/2000 11:51'!
highlightForDrop
	self highlightForDrop: true! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/28/2000 12:01'!
highlightForDrop: aBoolean
	self setProperty: #highlightedForDrop toValue: aBoolean.
	self changed! !

!SMxMorph methodsFor: 'drawing' stamp: 'LC 5/18/2000 08:51'!
highlightForMouseDown
	self highlightForMouseDown: true! !

!SMxMorph methodsFor: 'drawing' stamp: 'ar 3/17/2001 15:56'!
highlightForMouseDown: aBoolean
	aBoolean 
		ifTrue:[self setProperty: #highlightedForMouseDown toValue: aBoolean]
		ifFalse:[self removeProperty: #highlightedForMouseDown. self resetExtension].
	self changed! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/28/2000 10:53'!
highlightedForDrop
	^(self valueOfProperty: #highlightedForDrop) == true! !

!SMxMorph methodsFor: 'drawing' stamp: 'LC 5/18/2000 08:48'!
highlightedForMouseDown
	^(self valueOfProperty: #highlightedForMouseDown) == true! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 3/11/2010 11:23'!
imageForm

	^ self imageForm: Display depth forRectangle: self fullBounds! !

!SMxMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/12/2010 11:48'!
imageForm: depth forRectangle: rect
	| canvas |
	canvas := "Display defaultCanvasClass" SMxFormCanvas depth: depth over: rect.
	canvas fullDrawMorph: self.
	^ canvas formWithOffset! !

!SMxMorph methodsFor: 'initialization' stamp: 'jmv 1/15/2005 20:35'!
inATwoWayScrollPane
	"Answer a two-way scroll pane that allows the user to scroll the receiver in either direction.  It will have permanent scroll bars unless you take some special action."

	| widget |
	widget := SMxScrollPane new.
	widget
		extent: (self width min: 300 max: 100) @ (self height min: 150 max: 100);
		borderWidth: 0.
	widget scroller addMorph: self.
	widget setScrollDeltas.
	widget color: self color darker darker.
	^widget! !

!SMxMorph methodsFor: 'user interface' stamp: 'sw 10/2/97 23:08'!
initialExtent
	| ext |
	(ext := self valueOfProperty: #initialExtent)
		ifNotNil:
			[^ ext].
	^ super initialExtent! !

!SMxMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 17:30'!
initialize
	"initialize the state of the receiver"
owner := nil.
	submorphs := EmptyArray.
	bounds := self defaultBounds.
	
	color := self defaultColor! !

!SMxMorph methodsFor: 'accessing - extension' stamp: 'dgd 2/16/2003 19:57'!
initializeExtension
	"private - initializes the receiver's extension"
	self privateExtension: SMxMorphExtension new initialize! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:30'!
innerBounds
	"Return the inner rectangle enclosed by the bounds of this morph excluding the space taken by its borders. For an unbordered morph, this is just its bounds."

	^ bounds! !

!SMxMorph methodsFor: 'accessing' stamp: 'tk 1/31/2002 10:25'!
insetColor
	owner ifNil:[^self color].
	^ self colorForInsets! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/15/2009 22:33'!
inspectAt: aPoint event: evt
	| menu morphs target |
	menu := SMxCustomMenu new.
	morphs := self morphsAt: aPoint.
	(morphs includes: self) ifFalse:[morphs := morphs copyWith: self].
	morphs do: [:m | 
		menu 
			add: m class name asString
			action: m].
	target := menu startUpWithCaption: ('inspect whom?
(deepest at top)').
	target ifNil:[^self].
	target inspectInMorphic: evt! !

!SMxMorph methodsFor: 'menus' stamp: 'ar 10/5/2000 16:55'!
inspectInMorphic: evt
	evt hand attachMorph: ((Inspector openAsMorphOn: self) extent: 300@200)! !

!SMxMorph methodsFor: 'debug and other' stamp: 'sw 11/5/1998 20:31'!
inspectOwnerChain
	self ownerChain inspectWithLabel: 'Owner chain for ', self printString! !

!SMxMorph methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:43'!
internalizePosition: pointInReferenceMorph from: aReferenceMorph
	"aPoint is in aReferenceMorph's coordinateSystem
	answer is in our coordinate system"

	self == aReferenceMorph
		ifTrue: [ ^pointInReferenceMorph].

	"This might actually indicate an error condition. For now, just answer something!!"
	owner ifNil: [
		^pointInReferenceMorph].

	^owner internalizePosition: pointInReferenceMorph from: aReferenceMorph! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:25'!
internalizePositionFromWorld: pointInWorld
	"aPoint is in Worlds's coordinateSystem
	answer is in our coordinate system"
	^self internalizePosition: pointInWorld from: self world! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:26'!
internalizePositionToOwner: pointInReferenceMorph from: aReferenceMorph

	owner ifNil: [^ pointInReferenceMorph].
	^ owner internalizePosition: pointInReferenceMorph from: aReferenceMorph! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:38'!
internalizeScalar: distanceInReferenceMorph from: aReferenceMorph
	"distanceInReferenceMorph is a number in aReferenceMorph's coordinateSystem
	answer is in our coordinate system"

	| p1 p2 |
	p1 := distanceInReferenceMorph@0.
	p2 := (self internalizePosition: p1 from: aReferenceMorph) - (self internalizePosition: 0@0 from: aReferenceMorph).
	^ p2 x! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:38'!
internalizeVector: vectorInReferenceMorph from: aReferenceMorph
	"vectorInReferenceMorph is a point in aReferenceMorph's coordinateSystem
	answer is in our coordinate system"

	^(self internalizePosition: vectorInReferenceMorph from: aReferenceMorph) - (self internalizePosition: 0@0 from: aReferenceMorph)! !

!SMxMorph methodsFor: 'initialization' stamp: 'ar 1/31/2001 13:57'!
intoWorld: aWorld
	"The receiver has just appeared in a new world. Note:
		* aWorld can be nil (due to optimizations in other places)
		* owner is already set
		* owner's submorphs may not include receiver yet.
	Important: Keep this method fast - it is run whenever morphs are added."
	aWorld ifNil:[^self].
	self wantsSteps ifTrue:[aWorld startStepping: self].
	self submorphsDo:[:m| m intoWorld: aWorld].
! !

!SMxMorph methodsFor: 'change reporting' stamp: 'ar 11/12/2000 18:50'!
invalidRect: damageRect
	^self invalidRect: damageRect from: self! !

!SMxMorph methodsFor: 'change reporting' stamp: 'jmv 8/24/2010 13:51'!
invalidRect: aRectangle from: aMorph
	| damageRect |
	owner ifNotNil: [
		aRectangle hasPositiveExtent ifFalse: [ ^ self ].
		damageRect := aRectangle.
		aMorph == self ifFalse: [
			"Clip to receiver's clipping bounds if the damage came from a child"
			self clipsSubmorphs ifTrue: [
				damageRect := aRectangle intersect: self clippingBounds ]].
		owner
			invalidRect: damageRect
			from: self ]! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/8/2009 18:54'!
invokeMetaMenu: evt
	| menu |
	menu := self buildMetaMenu: evt.
	menu addTitle: self externalName.
	menu popUpInWorld: self world! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 5/15/2009 22:33'!
invokeMetaMenuAt: aPoint event: evt
	| menu morphs target |
	menu := SMxCustomMenu new.
	morphs := self morphsAt: aPoint.
	(morphs includes: self) ifFalse:[morphs := morphs copyWith: self].
	morphs size = 1 ifTrue:[morphs first invokeMetaMenu: evt].
	morphs do: [:m | 
		menu add: m class name asString action: m].
	target := menu startUp.
	target ifNil:[^self].
	target invokeMetaMenu: evt! !

!SMxMorph methodsFor: 'testing' stamp: 'jmv 12/5/2009 20:30'!
is: aSymbol
	^ aSymbol = #SMxMorph or: [ super is: aSymbol ]! !

!SMxMorph methodsFor: 'structure' stamp: 'dgd 2/22/2003 19:05'!
isInWorld
	"Return true if this morph is in a world."

	^self world notNil! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 11/18/2007 08:57'!
isKnownFailing
	| w |
	w := self world.
	^w notNil and: [ w isKnownFailing: self ]! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:38'!
isLocked
	"answer whether the receiver is Locked"
	self hasExtension
		ifFalse: [^ false].
	^ self extension locked! !

!SMxMorph methodsFor: 'testing' stamp: 'jmv 10/8/2009 20:14'!
isOpaqueMorph
	"Just answer false in the general case, to simplify submorphs.
	See the implementation and comment in SMxBorderedMorph. and see also senders.
	If the answer is true, there is an optimization in world draw"
	^false! !

!SMxMorph methodsFor: 'geometry testing' stamp: 'jmv 10/8/2009 20:10'!
isOrthoRectangularMorph
	"Answer true if I fill my bounds. I.e. I am a rectangle aligned with Display borders and
	specified by my bounds instance variable.
	If true, #containsPoint: can simply check #bounds."
	^true! !

!SMxMorph methodsFor: 'classification' stamp: 'sw 1/29/98 21:51'!
isPlayfieldLike
	^ false! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:37'!
isSticky
	"answer whether the receiver is Sticky"
	self hasExtension
		ifFalse: [^ false].
	^ self extension sticky! !

!SMxMorph methodsFor: 'classification' stamp: ''!
isWorldMorph

	^ false! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 11/7/2008 13:49'!
justDroppedInto: aMorph event: anEvent 
	"This message is sent to a dropped morph after it has been dropped on -- and been accepted by -- a drop-sensitive morph"

	self formerOwner: nil.
	self formerPosition: nil.
	aMorph activateWindow.
	(self isInWorld ) ifTrue: [
		self world startSteppingSubmorphsOf: self].
	"Note an unhappy inefficiency here:  the startStepping... call will often have already been called in the sequence leading up to entry to this method, but unfortunately the isPartsDonor: call often will not have already happened, with the result that the startStepping... call will not have resulted in the startage of the steppage."! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 11/12/2006 22:34'!
justGrabbedFrom: formerOwner
	"The receiver was just grabbed from its former owner and is now attached to the hand."! !

!SMxMorph methodsFor: 'event handling' stamp: 'ar 9/14/2000 18:23'!
keyDown: anEvent
	"Handle a key down event. The default response is to do nothing."! !

!SMxMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:57'!
keyStroke: anEvent
	"Handle a keystroke event.  The default response is to let my eventHandler, if any, handle it."

	(self focusKeyboardFor: anEvent)
		ifTrue: [ ^ self ].

	self eventHandler ifNotNil: [
		self eventHandler keyStroke: anEvent fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'KTT 6/1/2004 11:41'!
keyUp: anEvent
	"Handle a key up event. The default response is to do nothing."! !

!SMxMorph methodsFor: 'focus handling' stamp: 'jmv 11/10/2008 13:40'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus. This default implementation does nothing.
	
	Only morphs that answer true to #handlesKeyboard will ever get keyboard focus!!"! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'dgd 2/22/2003 14:32'!
lastSubmorph
	^submorphs last! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 5/22/2009 23:51'!
layoutBounds
	"Return the bounds for laying out children of the receiver"
	^self innerBounds! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 4/27/2010 11:30'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Note: written so that #layoutBounds can be changed without touching this method"
	| outer inner |
	outer := bounds.
	inner := self layoutBounds.
	bounds := aRectangle origin + (outer origin - inner origin) corner:
				aRectangle corner + (outer corner - inner corner).! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 5/22/2009 23:32'!
layoutChanged
	fullBounds ifNil:[^self]. "layout will be recomputed so don't bother"
	fullBounds := nil.
	owner ifNotNil: [owner layoutChanged].
	"note: does not send #ownerChanged here - we'll do this when computing the new layout"! !

!SMxMorph methodsFor: 'layout-properties' stamp: 'dgd 2/16/2003 20:07'!
layoutFrame
	"Layout specific. Return the layout frame describing where the  
	receiver should appear in a proportional layout"
	^ self hasExtension
		ifTrue: [ self extension layoutFrame]! !

!SMxMorph methodsFor: 'layout-properties' stamp: 'ar 11/14/2000 17:20'!
layoutFrame: aLayoutFrame
	"Layout specific. Return the layout frame describing where the receiver should appear in a proportional layout"
	self layoutFrame == aLayoutFrame ifTrue:[^self].
	self assureExtension layoutFrame: aLayoutFrame.
	self layoutChanged.! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 8/23/2010 22:47'!
layoutSubmorphsIn: layoutBounds
	"Compute a new layout of submorphs based on the given layout bounds."

	submorphs isEmpty ifTrue: [
		^fullBounds := bounds].

	self submorphsDo: [ :m | 
		m doesLayout ifTrue: [
			m applyLayoutFrameIn: layoutBounds ]].
	fullBounds := self computeFullBounds! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
left

	^ bounds left! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 5/5/1998 01:22'!
left: aNumber
	self position: (aNumber @ bounds top)! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 3/6/2002 13:06'!
leftCenter

	^ bounds leftCenter! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 8/4/97 12:05'!
lock
	self lock: true! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:48'!
lock: aBoolean 
	"change the receiver's lock property"
	(self hasExtension not
			and: [aBoolean not])
		ifTrue: [^ self].
	self assureExtension locked: aBoolean! !

!SMxMorph methodsFor: 'menus' stamp: 'sw 9/21/2000 22:50'!
lockUnlockMorph
	"If the receiver is locked, unlock it; if unlocked, lock it"

	self isLocked ifTrue: [self unlock] ifFalse: [self lock]! !

!SMxMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:20'!
lockedString
	"Answer the string to be shown in a menu to represent the 
	'locked' status"
	^ (self isLocked
		ifTrue: ['<on>']
		ifFalse: ['<off>']), 'be locked' translated! !

!SMxMorph methodsFor: 'menus' stamp: 'jmv 11/12/2006 22:09'!
maybeAddCollapseItemTo: aMenu
	"If appropriate, add a collapse item to the given menu"

	| anOwner |
	(anOwner := self owner) ifNotNil:
			[anOwner isWorldMorph ifTrue:
				[aMenu add: 'collapse' translated target: self action: #collapse]]! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'sw 11/27/2001 08:12'!
maybeDuplicateMorph
	"Maybe duplicate the morph"

	self okayToDuplicate ifTrue:
		[self duplicate openInHand]! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 10/5/2000 17:32'!
maybeDuplicateMorph: evt
	self okayToDuplicate ifTrue:[^self duplicateMorph: evt]! !

!SMxMorph methodsFor: 'other events' stamp: 'sw 8/1/2001 14:08'!
menuButtonMouseEnter: event
	"The mouse entered a menu-button area; show the menu cursor temporarily"

	event hand showTemporaryCursor: Cursor menu! !

!SMxMorph methodsFor: 'other events' stamp: 'sw 8/1/2001 14:09'!
menuButtonMouseLeave: event
	"The mouse left a menu-button area; restore standard cursor"

	event hand showTemporaryCursor: nil! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 6/4/2000 21:59'!
minimumExtent
	| ext |
	"This returns the minimum extent that the morph may be shrunk to.  Not honored in too many places yet, but respected by the resizeToFit feature, at least.  copied up from SMxSystemWindow 6/00"
	(ext := self valueOfProperty: #minimumExtent)
		ifNotNil:
			[^ ext].
	^ 100 @ 80! !

!SMxMorph methodsFor: 'WiW support' stamp: 'RAA 7/19/2000 20:44'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^(owner isNil or: [owner isWorldMorph]) ifTrue: [
		self valueOfProperty: #morphicLayerNumber ifAbsent: [100]
	] ifFalse: [
		owner morphicLayerNumber
	].

	"leave lots of room for special things"! !

!SMxMorph methodsFor: 'WiW support' stamp: 'RAA 2/16/2001 13:54'!
morphicLayerNumberWithin: anOwner

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^(owner isNil or: [owner isWorldMorph or: [anOwner == owner]]) ifTrue: [
		self valueOfProperty: #morphicLayerNumber ifAbsent: [100]
	] ifFalse: [
		owner morphicLayerNumber
	].

	"leave lots of room for special things"! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:40'!
morphsAt: aPoint
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	^self morphsAt: aPoint unlocked: false! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 3/8/2010 14:27'!
morphsAt: aPoint behind: aMorph unlocked: aBool 
	"Return all morphs at aPoint that are behind frontMorph; if aBool is true return only unlocked, visible morphs."

	| isBack found all |
	all := (aMorph isNil or: [owner isNil]) 
				ifTrue: ["Traverse down"

					(self fullBounds containsPoint: aPoint) ifFalse: [^#()].
					(aBool and: [self isLocked or: [self visible not]]) ifTrue: [^#()].
					nil]
				ifFalse: ["Traverse up"
					all := owner 
								morphsAt: (self externalizePositionFromOwner: aPoint to: owner)
								behind: self
								unlocked: aBool.
					WriteStream with: all].
	isBack := aMorph isNil.
	self submorphsDo: 
			[:m | 
			isBack 
				ifTrue: [
					found := m 
								morphsAt: (m internalizePositionToOwner: aPoint from: self)
								behind: nil
								unlocked: aBool.
					found notEmpty 
						ifTrue: 
							[all ifNil: [all := WriteStream on: #()].
							all nextPutAll: found]].
			m == aMorph ifTrue: [isBack := true]].
	(isBack and: [self containsPoint: aPoint]) 
		ifTrue: 
			[all ifNil: [^Array with: self].
			all nextPut: self].
	^all ifNil: [#()] ifNotNil: [all contents]! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:40'!
morphsAt: aPoint unlocked: aBool
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	| mList |
	mList := WriteStream on: #().
	self morphsAt: aPoint unlocked: aBool do:[:m| mList nextPut: m].
	^mList contents! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 3/8/2010 14:27'!
morphsAt: aPoint unlocked: aBool do: aBlock
	"Evaluate aBlock with all the morphs starting at the receiver which appear at aPoint. If aBool is true take only visible, unlocked morphs into account."
	| |
	(self fullBounds containsPoint: aPoint) ifFalse:[^self].
	(aBool and:[self isLocked or:[self visible not]]) ifTrue:[^self].
	self submorphsDo: [ :m |
		m morphsAt: (m internalizePositionToOwner: aPoint from: self) unlocked: aBool do: aBlock].
	(self containsPoint: aPoint) ifTrue:[aBlock value: self].! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 4/27/2010 10:22'!
morphsInFrontOf: someMorph overlapping: aRectangle do: aBlock
	"Evaluate aBlock with all top-level morphs in front of someMorph that overlap with the given rectangle. someMorph is either an immediate child of the receiver or nil (in which case all submorphs of the receiver are enumerated)."
	self submorphsDo:[:m|
		m == someMorph ifTrue:["Try getting out quickly"
			owner ifNil:[^self].
			^owner morphsInFrontOf: self overlapping: aRectangle do: aBlock].
		(m fullDisplayBounds intersects: aRectangle)
			ifTrue:[aBlock value: m]].
	owner ifNil:[^self].
	^owner morphsInFrontOf: self overlapping: aRectangle do: aBlock.! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 8/10/1998 16:04'!
mouseDown: evt
	"Handle a mouse down event. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseDown: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 10/3/2000 17:05'!
mouseDownOnHelpHandle: anEvent
	"The mouse went down in the show-balloon handle"
	
	| str |
	anEvent shiftPressed ifTrue: [^ self editBalloonHelpText].
	str := self balloonText.
	str ifNil: [str := self noHelpString].
	self showBalloon: str hand: anEvent hand.
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'jmv 1/6/2005 23:42'!
mouseDownPriority
	"Return the default mouse down priority for the receiver"

	^ ("self isPartsDonor "false)
		ifTrue:	[50]
		ifFalse:	[0]

	"The above is a workaround for the complete confusion between parts donors and parts bins. Morphs residing in a parts bin may or may not have the parts donor property set; if they have they may or may not actually handle events. To work around this, parts bins get an equal priority to parts donors so that when a morph in the parts bin does have the property set but does not handle the event we still get a copy from picking it up through the parts bin. Argh. This just *cries* for a cleanup."
	"And the above comment is Andreas's from 10/2000, which was formerly retrievable by a #flag: call which however caused a problem when trying to recompile the method from decompiled source."! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 8/10/1998 16:00'!
mouseEnter: evt
	"Handle a mouseEnter event, meaning the mouse just entered my bounds with no button pressed. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseEnter: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:33'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event, meaning the mouse just entered my bounds with a button pressed or laden with submorphs.  The default response is to let my eventHandler, if any, handle it, or else to do nothing."

	self eventHandler ifNotNil:
		[^ self eventHandler mouseEnterDragging: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 8/10/1998 16:01'!
mouseLeave: evt
	"Handle a mouseLeave event, meaning the mouse just left my bounds with no button pressed. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseLeave: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:38'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event, meaning the mouse just left my bounds with a button pressed or laden with submorphs. The default response is to let my eventHandler, if any, handle it; else to do nothing."

	self eventHandler ifNotNil:
		[self eventHandler mouseLeaveDragging: evt fromMorph: self]! !

!SMxMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:04'!
mouseMove: evt
	"Handle a mouse move event. The default response is to let my eventHandler, if any, handle it."
	self eventHandler ifNotNil:
		[self eventHandler mouseMove: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'ar 10/22/2000 17:08'!
mouseStillDown: evt
	"Handle a mouse move event. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseStillDown: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'event handling' stamp: 'jmv 11/7/2008 13:51'!
mouseStillDownStepRate
	"At what rate do I want to receive #mouseStillDown: notifications?"
	^1! !

!SMxMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 18:02'!
mouseStillDownThreshold
	"Return the number of milliseconds after which mouseStillDown: should be sent"
	^200! !

!SMxMorph methodsFor: 'event handling' stamp: 'tk 8/10/1998 16:05'!
mouseUp: evt
	"Handle a mouse up event. The default response is to let my eventHandler, if any, handle it."

	self eventHandler ifNotNil:
		[self eventHandler mouseUp: evt fromMorph: self].
! !

!SMxMorph methodsFor: 'naming' stamp: 'jmv 5/15/2009 22:33'!
nameForFindWindowFeature
	"Answer the name to show in a list of windows-and-morphs to represent the receiver"

	^ self class name! !

!SMxMorph methodsFor: 'structure' stamp: 'di 11/12/2000 16:13'!
nearestOwnerThat: conditionBlock
	"Return the first enclosing morph for which aBlock evaluates to true, or nil if none"

	^ self firstOwnerSuchThat: conditionBlock
! !

!SMxMorph methodsFor: 'iteration of all morphs' stamp: 'jmv 11/10/2008 15:51'!
nextMorph
	"Iterate over all morphs in the receiver structure (usually all morphs living in the receiver's world).
	Do a DFS (Depth First Seach) over the morphs tree"
	
	submorphs isEmpty
		ifFalse: [ ^submorphs first ].

	^self nextMorphPart2! !

!SMxMorph methodsFor: 'iteration of all morphs' stamp: 'jmv 11/10/2008 15:51'!
nextMorphPart2
	
	| next |
	owner ifNotNil: [
		next := owner submorphBehind: self.
		next ifNotNil: [ ^ next ].
		
		^ owner nextMorphPart2 ].

	^ self
	! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 9/19/97 13:46'!
noHelpString
	^ 'Help not yet supplied'! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'ar 8/13/2003 11:32'!
noteNewOwner: aMorph
	"I have just been added as a submorph of aMorph"! !

!SMxMorph methodsFor: 'objects from disk' stamp: 'jmv 12/20/2004 21:22'!
objectForDataStream: refStrm 
	"I am being written out on an object file"
	self prepareToBeSaved.	"Amen"
	^self! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 11/27/2001 14:50'!
okayToBrownDragEasily
	"Answer whether it it okay for the receiver to be brown-dragged easily -- i.e. repositioned within its container without extracting it.  At present this is just a hook -- nobody declines."

	^ true



"
	^ (self topRendererOrSelf owner isKindOf: SMxPasteUpMorph) and:
		[self layoutPolicy isNil]"! !

!SMxMorph methodsFor: 'player' stamp: 'sw 1/22/2001 14:25'!
okayToDuplicate
	"Formerly this protocol was used to guard against awkward situations when there were anonymous scripts in the etoy system.  Nowadays we just always allow duplication"

	^ true! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 11/29/2001 06:29'!
okayToResizeEasily
	"Answer whether it is appropriate to have the receiver be easily resized by the user from the halo"

	^ true

	"This one was too jarring, not that it didn't most of the time do the right  thing but because some of the time it didn't, such as in a holder.  If we pursue this path, the test needs to be airtight, obviously...
	^ (self topRendererOrSelf owner isKindOf: SMxPasteUpMorph) and:
		[self layoutPolicy isNil]"! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 11/27/2001 14:44'!
okayToRotateEasily
	"Answer whether it is appropriate for a rotation handle to be shown for the receiver.  This is a hook -- at present nobody declines."

	^ true! !

!SMxMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:44'!
on: eventName send: selector to: recipient
	
	self eventHandler ifNil: [self eventHandler: SMxEventHandler new].
	self eventHandler on: eventName send: selector to: recipient! !

!SMxMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:44'!
on: eventName send: selector to: recipient withValue: value
	"NOTE: selector must take 3 arguments, of which value will be the *** FIRST ***"
	
	self eventHandler ifNil: [self eventHandler: SMxEventHandler new].
	self eventHandler on: eventName send: selector to: recipient withValue: value
! !

!SMxMorph methodsFor: 'initialization' stamp: 'jmv 4/27/2010 11:06'!
openCenteredInWorld

	self 
		doLayoutIfNeeded;
		position: Display extent - self extent // 2;
		openInWorld.! !

!SMxMorph methodsFor: 'initialization' stamp: 'sw 3/21/2000 14:46'!
openInHand
	"Attach the receiver to the current hand in the current morphic world"

	self currentHand attachMorph: self! !

!SMxMorph methodsFor: 'initialization' stamp: 'jmv 11/7/2006 21:09'!
openInWorld
	self openInWorld: self currentWorld! !

!SMxMorph methodsFor: 'initialization' stamp: 'bf 1/5/2000 19:57'!
openInWorld: aWorld
	"Add this morph to the requested World."
	(aWorld viewBox origin ~= (0@0) and: [self position = (0@0)]) ifTrue:
		[self position: aWorld viewBox origin].
	aWorld addMorph: self.
	aWorld startSteppingSubmorphsOf: self! !

!SMxMorph methodsFor: 'structure' stamp: 'JuanVuletich 11/1/2010 15:36'!
outermostWorldMorph
	"Answer the world even if we are not part of it (for example, if we have no owner)"
	^SimpleMorphicUIManager smxWorld! !

!SMxMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/12/2010 11:49'!
ownShadowForm
	"Return a form representing the 'shadow' of the receiver, without including submorphs 
	regardless of clipping"
	| canvas |
	canvas := "Display defaultCanvasClass" SMxFormCanvas forShadowOver: bounds.
	canvas drawMorph: self.
	^ canvas formWithOffset! !

!SMxMorph methodsFor: 'structure' stamp: ''!
owner
	"Returns the owner of this morph, which may be nil."

	^ owner! !

!SMxMorph methodsFor: 'debug and other' stamp: 'dgd 2/22/2003 19:05'!
ownerChain
	"Answer a list of objects representing the receiver and all of its owners.   The first element is the receiver, and the last one is typically the world in which the receiver resides"

	| c next |
	c := OrderedCollection with: self.
	next := self.
	[(next := next owner) notNil] whileTrue: [c add: next].
	^c asArray! !

!SMxMorph methodsFor: 'structure' stamp: 'di 11/12/2000 16:18'!
ownerThatIsA: aClass
	"Return the first enclosing morph that is a kind of aClass, or nil if none"

	^ self firstOwnerSuchThat: [:m | m isKindOf: aClass]! !

!SMxMorph methodsFor: 'structure' stamp: 'sw 7/1/1998 18:02'!
pasteUpMorph
	"Answer the closest containing morph that is a PasteUp morph"
	^ self ownerThatIsA: SMxPasteUpMorph! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
position

	^ bounds topLeft! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/16/2008 04:20'!
position: aPoint
	"Change the position of this morph and and all of its submorphs."

	| delta box |
	delta := aPoint - bounds topLeft.
	(delta x = 0 and: [delta y = 0]) ifTrue: [^ self].  "Null change"
	box := self fullBounds.
	self privateFullMoveBy: delta.
	(delta dotProduct: delta) > 100 ifTrue:[
		"e.g., more than 10 pixels moved"
		self invalidRect: box.
		self invalidRect: (box translateBy: delta).
	] ifFalse:[
		self invalidRect: (box merge: (box translateBy: delta)).
	].
	owner ifNotNil:[owner layoutChanged].! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 3/8/2010 14:19'!
positionInWorld

	^ self externalizePositionFromOwner: self position to: self world! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'ar 10/7/2000 20:56'!
potentialEmbeddingTargets
	"Return the potential targets for embedding the receiver"
	owner ifNil:[^#()].
	^owner morphsAt: self referencePosition behind: self unlocked: true! !

!SMxMorph methodsFor: 'fileIn/out' stamp: 'di 11/14/97 10:24'!
prepareToBeSaved
	"Prepare this morph to be saved to disk. Subclasses should nil out any instance variables that holds state that should not be saved, such as cached Forms. Note that this operation may take more drastic measures than releaseCachedState; for example, it might discard the transcript of an interactive chat session."

	self releaseCachedState.
	fullBounds := nil.
! !

!SMxMorph methodsFor: 'iteration of all morphs' stamp: 'jmv 11/10/2008 22:55'!
previousMorph
	"Iterate over all morphs in the receiver structure (usually all morphs living in the receiver's world),
	in 'backward'  direction.
	Do a DFS (Depth First Seach) over the morphs tree"
	
	| prev |
	owner ifNotNil: [
		prev := owner submorphInFrontOf: self.
		prev ifNotNil: [ ^prev veryLastLeave ].
		^owner ].
	^self veryLastLeave! !

!SMxMorph methodsFor: 'structure' stamp: 'RAA 6/13/2000 15:01'!
primaryHand

        | outer |
        outer := self outermostWorldMorph ifNil: [^ nil].
        ^ outer activeHand ifNil: [outer firstHand]! !

!SMxMorph methodsFor: 'printing' stamp: 'jmv 5/15/2009 22:34'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream
		print: self identityHash;
		nextPutAll: ')'! !

!SMxMorph methodsFor: 'private' stamp: 'jmv 1/19/2005 16:43'!
privateAddAllMorphs: aCollection atIndex: index
	"Private. Add aCollection of morphs to the receiver"
	| myWorld itsWorld otherSubmorphs |
	myWorld := self world.
	otherSubmorphs := submorphs copyWithoutAll: aCollection.
	(index between: 0 and: otherSubmorphs size)
		ifFalse: [^ self error: 'index out of range'].
	index = 0
		ifTrue:[	submorphs := aCollection asArray, otherSubmorphs]
		ifFalse:[	index = otherSubmorphs size
			ifTrue:[	submorphs := otherSubmorphs, aCollection]
			ifFalse:[	submorphs := otherSubmorphs copyReplaceFrom: index + 1 to: index with: aCollection ]].
	aCollection do: [:m | | itsOwner |
		itsOwner := m owner.
		itsOwner ifNotNil: [
			itsWorld := m world.
			(itsWorld == myWorld) ifFalse: [
				itsWorld ifNotNil: [self privateInvalidateMorph: m]].
			(itsOwner ~~ self) ifTrue: [
				m owner privateRemove: m.
				m owner removedMorph: m ]].
		m privateOwner: self.
		myWorld ifNotNil: [self privateInvalidateMorph: m].
		(myWorld == itsWorld) ifFalse: [m intoWorld: myWorld].
		itsOwner == self ifFalse: [
			self addedMorph: m.
			m noteNewOwner: self ].
	].
	self layoutChanged.
! !

!SMxMorph methodsFor: 'private' stamp: 'jmv 1/19/2005 16:43'!
privateAddMorph: aMorph atIndex: index

	| oldIndex myWorld itsWorld oldOwner |
	((index >= 1) and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	myWorld := self world.
	oldOwner := aMorph owner.
	(oldOwner == self and: [(oldIndex := submorphs indexOf: aMorph) > 0]) ifTrue:[
		"aMorph's position changes within in the submorph chain"
		oldIndex < index ifTrue:[
			"moving aMorph to back"
			submorphs replaceFrom: oldIndex to: index-2 with: submorphs startingAt: oldIndex+1.
			submorphs at: index-1 put: aMorph.
		] ifFalse:[
			"moving aMorph to front"
			oldIndex-1 to: index by: -1 do:[:i|
				submorphs at: i+1 put: (submorphs at: i)].
			submorphs at: index put: aMorph.
		].
	] ifFalse:[
		"adding a new morph"
		oldOwner ifNotNil:[
			itsWorld := aMorph world.
			itsWorld ifNotNil: [self privateInvalidateMorph: aMorph].
			oldOwner privateRemove: aMorph.
			oldOwner removedMorph: aMorph.
		].
		aMorph privateOwner: self.
		submorphs := submorphs copyReplaceFrom: index to: index-1 with: (Array with: aMorph).
		(itsWorld == myWorld) ifFalse: [aMorph intoWorld: myWorld].
	].
	myWorld ifNotNil:[self privateInvalidateMorph: aMorph].
	self layoutChanged.
	oldOwner == self ifFalse: [
		self addedMorph: aMorph.
		aMorph noteNewOwner: self ].
! !

!SMxMorph methodsFor: 'private' stamp: 'jmv 8/23/2010 18:39'!
privateBounds: boundsRect
	"Private!! Use position: and/or extent: instead."

	fullBounds := nil.
	bounds := boundsRect! !

!SMxMorph methodsFor: 'private' stamp: 'jm 5/29/1998 21:28'!
privateColor: aColor

	color := aColor.
! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 8/10/2003 18:31'!
privateDelete
	"Remove the receiver as a submorph of its owner"
	owner ifNotNil:[owner removeMorph: self].! !

!SMxMorph methodsFor: 'accessing - extension' stamp: 'dgd 2/16/2003 19:57'!
privateExtension: aMorphExtension
	"private - change the receiver's extension"
	extension := aMorphExtension! !

!SMxMorph methodsFor: 'private' stamp: 'jmv 10/8/2009 10:49'!
privateFullMoveBy: delta
	"Private!! Relocate me and all of my subMorphs by recursion. Subclasses that implement different coordinate systems may override this method."

	self privateMoveBy: delta.
	submorphs do: [ :m |
		m privateFullMoveBy: delta ]! !

!SMxMorph methodsFor: 'change reporting' stamp: 'jmv 4/27/2010 11:06'!
privateInvalidateMorph: aMorph
	"Private. Invalidate the given morph after adding or removing.
	This method is private because a) we're invalidating the morph 'remotely'
	and b) it forces a fullBounds computation which should not be necessary
	for a general morph c) the morph may or may not actually invalidate
	anything (if it's not in the world nothing will happen) and d) the entire
	mechanism should be rewritten."
	aMorph doLayoutIfNeeded.
	aMorph changed! !

!SMxMorph methodsFor: 'private' stamp: 'jmv 8/23/2010 18:41'!
privateMoveBy: delta
	"Private!! Use 'position:' instead."
	bounds := bounds translateBy: delta.
	fullBounds ifNotNil: [ fullBounds := fullBounds translateBy: delta ].! !

!SMxMorph methodsFor: 'private' stamp: ''!
privateOwner: aMorph
	"Private!! Should only be used by methods that maintain the ower/submorph invariant."

	owner := aMorph.! !

!SMxMorph methodsFor: 'private' stamp: 'ar 8/10/2003 18:46'!
privateRemove: aMorph
	"Private!! Should only be used by methods that maintain the ower/submorph invariant."
	submorphs := submorphs copyWithout: aMorph.! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/13/2000 17:14'!
processEvent: anEvent
	"Process the given event using the default event dispatcher."
	^self processEvent: anEvent using: self defaultEventDispatcher! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/18/2000 19:14'!
processEvent: anEvent using: defaultDispatcher
	"This is the central entry for dispatching events in morphic. Given some event and a default dispatch strategy, find the right receiver and let him handle it.
	WARNING: This is a powerful hook. If you want to use a different event dispatcher from the default, here is the place to hook it in. Depending on how the dispatcher is written (e.g., whether it calls simply #processEvent: or #processEvent:using:) you can change the dispatch strategy for entire trees of morphs. Similarly, you can disable entire trees of morphs from receiving any events whatsoever. Read the documentation in class SMxMorphicEventDispatcher before playing with it. "
	(self rejectsEvent: anEvent) ifTrue:[^#rejected].
	^defaultDispatcher dispatchEvent: anEvent with: self! !

!SMxMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:53'!
raisedColor
	"Return the color to be used for shading raised borders. The 
	default is my own color, but it might want to be, eg, my 
	owner's color. Whoever's color ends up prevailing, the color 
	itself gets the last chance to determine, so that when, for 
	example, an InfiniteForm serves as the color, callers won't choke 
	on some non-Color object being returned"
	((color isColor)
			and: [color isTransparent
					and: [owner notNil]])
		ifTrue: [^ owner raisedColor].
	^ color asColor raisedColor! !

!SMxMorph methodsFor: 'geometry eToy' stamp: 'jmv 4/27/2010 11:30'!
referencePosition
	"Return the current reference position of the receiver"

	^bounds origin + (0.5@0.5 * bounds extent).
! !

!SMxMorph methodsFor: 'geometry eToy' stamp: 'ar 9/27/2000 14:04'!
referencePosition: aPosition
	"Move the receiver to match its reference position with aPosition"
	| newPos intPos |
	newPos := self position + (aPosition - self referencePosition).
	intPos := newPos asIntegerPoint.
	newPos = intPos 
		ifTrue:[self position: intPos]
		ifFalse:[self position: newPos].! !

!SMxMorph methodsFor: 'drawing' stamp: 'sw 10/10/1999 23:25'!
refreshWorld
	| aWorld |
	(aWorld := self world) ifNotNil: [aWorld displayWorldSafely]
! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 10/5/2000 19:25'!
rejectDropEvent: anEvent
	"This hook allows the receiver to repel a drop operation currently executed. The method is called prior to checking children so the receiver must validate that the event was really designated for it.
	Note that the ordering of the tests below is designed to avoid a (possibly expensive) #fullContainsPoint: test. If the receiver doesn't want to repel the morph anyways we don't need to check after all."
	(self repelsMorph: anEvent contents event: anEvent) ifFalse:[^self]. "not repelled"
	(self fullContainsPoint: anEvent position) ifFalse:[^self]. "not for me"
	"Throw it away"
	anEvent wasHandled: true.
	anEvent contents rejectDropMorphEvent: anEvent.! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 3/2/2010 17:10'!
rejectDropMorphEvent: evt
	"The receiver has been rejected, and must be put back somewhere.  There are three cases:
	(1)  It remembers its former owner and position, and goes right back there
	(2)  It remembers its former position only, in which case it was torn off from a parts bin, and the UI is that it floats back to its donor position and then vanishes.
	(3)  Neither former owner nor position is remembered, in which case it is whisked to the Trash"

	self formerOwner ifNotNil: [
		^ self slideBackToFormerSituation: evt].

	self formerPosition ifNotNil: [  "Position but no owner -- can just make it vanish"
		^ self vanishAfterSlidingTo: self formerPosition event: evt].
	
	self error: 'Should I delete this morph?'.
	self delete! !

!SMxMorph methodsFor: 'events-processing' stamp: 'ar 9/12/2000 23:40'!
rejectsEvent: anEvent
	"Return true to reject the given event. Rejecting an event means neither the receiver nor any of it's submorphs will be given any chance to handle it."
	^self isLocked or:[self visible not]! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'ar 12/16/2001 19:47'!
relativeTextAnchorPosition
	^self valueOfProperty: #relativeTextAnchorPosition! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'ar 12/16/2001 19:22'!
relativeTextAnchorPosition: aPoint
	^self setProperty: #relativeTextAnchorPosition toValue: aPoint! !

!SMxMorph methodsFor: 'events-removing' stamp: 'rw 4/25/2002 07:18'!
releaseActionMap
	"Release the action map"
	
 	self removeProperty: #actionMap! !

!SMxMorph methodsFor: 'caching' stamp: 'jmv 5/17/2009 23:04'!
releaseCachedState
	"Release any state that can be recomputed on demand, such as the pixel values for a color gradient or the editor state for a SMxTextMorph. This method may be called to save space when a morph becomes inaccessible. Implementations of this method should do 'super releaseCachedState'."! !

!SMxMorph methodsFor: 'events-alarms' stamp: 'ar 9/14/2000 12:14'!
removeAlarm: aSelector
	"Remove the given alarm"
	| scheduler |
	scheduler := self alarmScheduler.
	scheduler ifNotNil:[scheduler removeAlarm: aSelector for: self].! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 8/24/2010 10:52'!
removeAllMorphs
	| oldMorphs myWorld |
	submorphs isEmpty ifTrue: [ ^self ].
	myWorld := self world.
	(fullBounds notNil or: [ myWorld notNil ]) ifTrue: [ self invalidRect: self fullBounds ].
	submorphs do: [ :m |
		m privateOwner: nil ].
	oldMorphs := submorphs.
	submorphs := EmptyArray.
	oldMorphs do: [ :m |
		self removedMorph: m ].
	self layoutChanged.! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 8/24/2010 10:51'!
removeAllMorphsIn: aCollection
	"greatly speeds up the removal of *lots* of submorphs"
	| set myWorld |
	aCollection isEmpty ifTrue: [ ^self ].
	set := IdentitySet new: aCollection size * 4 // 3.
	aCollection do: [ :each | each owner == self ifTrue: [ set add: each]].
	set isEmpty ifTrue: [ ^self ].
	myWorld := self world.
	(fullBounds notNil or: [ myWorld notNil ]) ifTrue: [ self invalidRect: self fullBounds ].
	set do: [:m | m privateOwner: nil].
	submorphs := submorphs reject: [ :each | set includes: each].
	set do: [ :m | self removedMorph: m ].
	self layoutChanged.
! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'di 2/20/98 15:24'!
removeHalo
	| h |
	h := self halo.
	h ifNotNil: [h delete]! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 1/19/2005 16:43'!
removeMorph: aMorph
	"Remove the given morph from my submorphs"
	| aWorld |
	aMorph owner == self ifFalse:[^self].
	aWorld := self world.
	aWorld ifNotNil:[
		self privateInvalidateMorph: aMorph.
	].
	self privateRemove: aMorph.
	aMorph privateOwner: nil.
	self removedMorph: aMorph.
	self layoutChanged.! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 20:56'!
removeProperty: aSymbol 
	"removes the property named aSymbol if it exists"
	self hasExtension
		ifFalse: [^ self].
	self extension removeProperty: aSymbol! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'ar 8/12/2003 22:01'!
removedMorph: aMorph
	"Notify the receiver that aMorph was just removed from its children"
! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'sw 1/11/1999 20:07'!
repelsMorph: aMorph event: ev
	^ false! !

!SMxMorph methodsFor: 'submorphs-add/remove' stamp: 'jmv 10/26/2006 22:43'!
replaceSubmorph: oldMorph by: newMorph
	| index w |
	oldMorph stopStepping.
	index := submorphs indexOf: oldMorph.
	oldMorph privateDelete.
	self privateAddMorph: newMorph atIndex: index.
	(w := newMorph world) ifNotNil:
		[w startSteppingSubmorphsOf: newMorph]! !

!SMxMorph methodsFor: 'accessing - extension' stamp: 'dgd 2/16/2003 19:57'!
resetExtension
	"reset the extension slot if it is not needed"
	(self hasExtension
			and: [self extension isDefault])
		ifTrue: [self privateExtension: nil] ! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'panda 4/28/2000 12:02'!
resetHighlightForDrop
	self highlightForDrop: false! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 11/15/2001 16:33'!
resistsRemoval
	"Answer whether the receiver is marked as resisting removal"

	^ self hasProperty: #resistsRemoval! !

!SMxMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:18'!
resistsRemovalString
	"Answer the string to be shown in a menu to represent the 
	'resistsRemoval' status"
	^ (self resistsRemoval
		ifTrue: ['<on>']
		ifFalse: ['<off>']), 'resist being deleted' translated! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'JuanVuletich 11/1/2010 15:25'!
resizeFromMenu
	"Commence an interaction that will resize the receiver"

	self resizeMorph: SimpleMorphicUIManager smxActiveEvent! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'jmv 4/27/2010 11:31'!
resizeMorph: evt 
	| handle |
	handle := SMxHandleMorph new 
				forEachPointDo: [:newPoint | self extent: newPoint - bounds topLeft].
	evt hand attachMorph: handle.
	handle startStepping! !

!SMxMorph methodsFor: 'debug and other' stamp: 'jmv 11/5/2007 23:04'!
resumeAfterDrawError

	self changed.
	self drawingFailsNot.
	self changed.! !

!SMxMorph methodsFor: 'debug and other' stamp: 'ar 4/2/1999 15:22'!
resumeAfterStepError
	"Resume stepping after an error has occured."
	self startStepping. "Will #step"
	self removeProperty:#errorOnStep. "Will remove prop only if #step was okay"
! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
right

	^ bounds right! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 5/5/1998 01:23'!
right: aNumber
	self position: ((aNumber - bounds width) @ bounds top)! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 3/6/2002 13:06'!
rightCenter

	^ bounds rightCenter! !

!SMxMorph methodsFor: 'structure' stamp: 'jmv 1/12/2010 11:16'!
root
	"Return the root of the composite morph containing the receiver. The owner of the root is either nil, a WorldMorph, or a SMxHandMorph. If the receiver's owner is nil, the root is the receiver itself. This method always returns a morph."

	(owner isNil or: [ owner isWorldMorph or: [ owner is: #SMxHandMorph ] ]) ifTrue: [ ^self ].
	^owner root! !

!SMxMorph methodsFor: 'rotate scale and flex' stamp: 'jm 4/25/1998 05:19'!
rotationDegrees
	"Default implementation."

	^ 0.0
! !

!SMxMorph methodsFor: 'as yet unclassified' stamp: 'jmv 5/27/2006 18:00'!
rotationDegrees: degrees! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:24'!
separateDragAndDrop
	"Conversion only. Separate the old #dragNDropEnabled into #dragEnabled and #dropEnabled and remove the old property."
	| dnd |
	(self hasProperty: #dragNDropEnabled) ifFalse:[^self].
	dnd := (self valueOfProperty: #dragNDropEnabled) == true.
	self dragEnabled: dnd.
	self dropEnabled: dnd.
	self removeProperty: #dragNDropEnabled.
! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sma 12/23/1999 13:32'!
setBalloonText: stringOrText
	"Set receiver's balloon help text. Pass nil to remove the help."

	self setBalloonText: stringOrText maxLineLength: SMxPreferences maxBalloonHelpLineLength! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'dgd 2/16/2003 19:30'!
setBalloonText: stringOrText maxLineLength: aLength 
	"Set receiver's balloon help text. Pass nil to remove the help."
	(self hasExtension not
			and: [stringOrText isNil])
		ifTrue: [^ self].
	self assureExtension
		balloonText: (stringOrText
				ifNotNil: [stringOrText asString withNoLineLongerThan: aLength])! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 11:31'!
setConstrainedPosition: aPoint hangOut: partiallyOutside
	"Change the position of this morph and and all of its submorphs to aPoint, but don't let me go outside my owner's bounds.  Let me go within two pixels of completely outside if partiallyOutside is true."

	| trialRect delta boundingMorph bRect |
	owner ifNil:[^self].
	trialRect := aPoint extent: bounds extent.
	boundingMorph := self owner.
	delta := boundingMorph
			ifNil:    [0@0]
			ifNotNil: [
				bRect := partiallyOutside 
					ifTrue: [boundingMorph bounds insetBy: 
								self extent negated + boundingMorph borderWidth + (2@2)]
					ifFalse: [boundingMorph bounds].
				trialRect amountToTranslateWithin: bRect].
	self position: aPoint + delta.
	self layoutChanged  "So that, eg, surrounding text will readjust"
! !

!SMxMorph methodsFor: 'miscellaneous' stamp: 'sw 7/20/2001 00:15'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"

	self extent: anExtent! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 21:49'!
setProperty: aSymbol toValue: anObject 
	"change the receiver's property named aSymbol to anObject"
	anObject
		ifNil: [^ self removeProperty: aSymbol].
	self assureExtension setProperty: aSymbol toValue: anObject! !

!SMxMorph methodsFor: 'drop shadows' stamp: 'ar 10/26/2000 18:59'!
shadowColor
	^self valueOfProperty: #shadowColor ifAbsent:[Color black]! !

!SMxMorph methodsFor: 'drop shadows' stamp: 'ar 10/26/2000 20:22'!
shadowColor: aColor
	self shadowColor = aColor ifFalse:[self changed].
	self setProperty: #shadowColor toValue: aColor.! !

!SMxMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/12/2010 11:49'!
shadowForm
	"Return a form representing the 'shadow' of the receiver - e.g., all pixels that are occupied by the receiver are one, all others are zero."
	| bnds canvas |
	bnds := self fullBounds.
	canvas := "Display defaultCanvasClass" SMxFormCanvas forShadowOver: bnds.
	canvas fullDrawMorph: self.
	^ canvas formWithOffset! !

!SMxMorph methodsFor: 'testing' stamp: 'ar 12/3/2001 12:33'!
shouldDropOnMouseUp
	| former |
	former := self formerPosition ifNil:[^false].
	^(former dist: self position) > 10! !

!SMxMorph methodsFor: 'WiW support' stamp: 'ar 3/18/2001 00:14'!
shouldGetStepsFrom: aWorld
	^self world == aWorld! !

!SMxMorph methodsFor: 'drawing' stamp: 'jmv 2/23/2009 14:03'!
show
	"Make sure this morph is on-stage."
	self visible: true! !

!SMxMorph methodsFor: 'meta-actions' stamp: 'StephaneDucasse 1/7/2011 18:05'!
showActions
	"Put up a message list browser of all the code that this morph  
	would run for mouseUp, mouseDown, mouseMove, mouseEnter,  
	mouseLeave, and  
	mouseLinger. tk 9/13/97"
	| list cls selector adder |
	list := SortedCollection new.
	adder := [:mrClass :mrSel | list
				add: (SourcedMethodReference new setStandardClass: mrClass methodSymbol: mrSel)].
	"the eventHandler"
	self eventHandler
		ifNotNil: [list := self eventHandler methodRefList.
			(self eventHandler handlesMouseDown: nil)
				ifFalse: [adder value: SMxHandMorph value: #grabMorph:]].
	"If not those, then non-default raw events"
	#(#keyStroke: #mouseDown: #mouseEnter: #mouseLeave: #mouseMove: #mouseUp: #doButtonAction )
		do: [:sel | 
			cls := self class whichClassIncludesSelector: sel.
			cls
				ifNotNil: ["want more than default behavior"
					cls == SMxMorph
						ifFalse: [adder value: cls value: sel]]].
	"The mechanism on a Button"
	(self respondsTo: #actionSelector)
		ifTrue: ["A button"
			selector := self actionSelector.
			cls := self target class whichClassIncludesSelector: selector.
			cls
				ifNotNil: ["want more than default behavior"
					cls == SMxMorph
						ifFalse: [adder value: cls value: selector]]].
	MessageSet openMessageList: list name: 'Actions of ' , self printString! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'ar 10/3/2000 17:06'!
showBalloon: msgString
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."
	| w |
	self showBalloon: msgString hand: ((w := self world) ifNotNil:[w activeHand]).! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 2/22/2010 23:22'!
showBalloon: msgString hand: aHand
	"Pop up a balloon containing the given string,
	first removing any existing BalloonMorphs in the world."

	| w balloon h |
	(w := self world) ifNil: [^ self].
	h := aHand.
	h ifNil:[
		h := w activeHand].
	balloon := SMxBalloonMorph string: msgString for: self balloonHelpAligner.
	balloon popUpForHand: h.! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 3/8/2010 14:19'!
slideBackToFormerSituation: evt 
	| slideForm formerOwner formerPosition aWorld startPoint endPoint |
	formerOwner := self formerOwner.
	formerPosition := self formerPosition.
	aWorld := evt hand world.
	slideForm := self imageForm offset: 0 @ 0.
	startPoint := evt hand fullBounds origin.
	endPoint :=formerOwner externalizePositionFromOwner: formerPosition to: aWorld.
	owner removeMorph: self.
	aWorld displayWorld.
	slideForm 
		slideFrom: startPoint
		to: endPoint
		nSteps: 12
		delay: 15.
	formerOwner addMorph: self.
	self position: formerPosition.
	self justDroppedInto: formerOwner event: evt! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: ''!
start
	"Start running my script. For ordinary morphs, this means start stepping."

	self startStepping.
! !

!SMxMorph methodsFor: 'event handling' stamp: 'mir 5/23/2000 17:43'!
startDrag: evt
	"Handle a double-click event. This message is only sent to clients that request it by sending #waitForClicksOrDrag:event: to the initiating hand in their mouseDown: method. This default implementation does nothing."

	self eventHandler ifNotNil:
		[self eventHandler startDrag: evt fromMorph: self].! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'mir 1/4/2001 11:02'!
startDrag: anItem with: anObject
	self currentHand attachMorph: anObject! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 1/31/2001 13:07'!
startStepping
	"Start getting sent the 'step' message."
	self startStepping: #stepAt: at: Time millisecondClockValue arguments: nil stepTime: nil.! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 10/22/2000 16:36'!
startStepping: aSelector at: scheduledTime arguments: args stepTime: stepTime
	"Start stepping the receiver"
	| w |
	w := self world.
	w ifNotNil: [
		w startStepping: self at: scheduledTime selector: aSelector arguments: args stepTime: stepTime.
		self changed].! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 10/22/2000 16:42'!
startSteppingSelector: aSelector
	"Start getting sent the 'step' message."
	self startStepping: aSelector at: Time millisecondClockValue arguments: nil stepTime: nil.! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 2/12/2001 17:04'!
step
	"Do some periodic activity. Use startStepping/stopStepping to start and stop getting sent this message. The time between steps is specified by this morph's answer to the stepTime message.  The generic version dispatches control to the player, if any.  The nasty circumlocation about owner's transformation is necessitated by the flexing problem that the player remains in the properties dictionary both of the flex and the real morph.  In the current architecture, only the top renderer's pointer to the player should actually be honored for the purpose of firing."
! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'sw 10/20/1999 15:20'!
stepAt: millisecondClockValue
	"Do some periodic activity. Use startStepping/stopStepping to start and stop getting sent this message. The time between steps is specified by this morph's answer to the stepTime message.
	The millisecondClockValue parameter gives the value of the millisecond clock at the moment of dispatch.
	Default is to dispatch to the parameterless step method for the morph, but this protocol makes it possible for some morphs to do differing things depending on the clock value"
	
	self step
! !

!SMxMorph methodsFor: 'testing' stamp: 'jmv 1/6/2005 22:50'!
stepTime
	"Answer the desired time between steps in milliseconds. This default implementation requests that the 'step' method be called once every second."

	^ 1000! !

!SMxMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:19'!
stickinessString
	"Answer the string to be shown in a menu to represent the  
	stickiness status"
	^ (self isSticky
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'resist being picked up' translated! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:47'!
sticky: aBoolean 
	"change the receiver's sticky property"
	self extension sticky: aBoolean! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 12/15/2000 00:00'!
stopStepping
	"Stop getting sent the 'step' message."

	| w |
	w := self world.
	w ifNotNil: [w stopStepping: self].
! !

!SMxMorph methodsFor: 'stepping and presenter' stamp: 'ar 12/15/2000 00:00'!
stopSteppingSelector: aSelector
	"Stop getting sent the given message."
	| w |
	w := self world.
	w ifNotNil: [w stopStepping: self selector: aSelector].
! !

!SMxMorph methodsFor: 'fileIn/out' stamp: 'tk 7/11/1998 18:53'!
storeDataOn: aDataStream
	"Let all Morphs be written out.  All owners are weak references.  They only go out if the owner is in the tree being written."
	| cntInstVars cntIndexedVars ti localInstVars |

	"block my owner unless he is written out by someone else"
	cntInstVars := self class instSize.
	cntIndexedVars := self basicSize.
	localInstVars := SMxMorph instVarNames.
	ti := 2.  
	((localInstVars at: ti) = 'owner') & (SMxMorph superclass == Object) ifFalse:
			[self error: 'this method is out of date'].
	aDataStream
		beginInstance: self class
		size: cntInstVars + cntIndexedVars.
	1 to: ti-1 do:
		[:i | aDataStream nextPut: (self instVarAt: i)].
	aDataStream nextPutWeak: owner.	"owner only written if in our tree"
	ti+1 to: cntInstVars do:
		[:i | aDataStream nextPut: (self instVarAt: i)].
	1 to: cntIndexedVars do:
		[:i | aDataStream nextPut: (self basicAt: i)]! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'JuanVuletich 10/12/2010 17:51'!
submorphBehind: aMorph

	^submorphs after: aMorph ifAbsent: []! !

!SMxMorph methodsFor: 'layout' stamp: 'jmv 9/12/2009 19:21'!
submorphBounds
	"Private. Compute the actual full bounds of the receiver"
	^submorphs inject: nil into: [ :prevBox :m |
		m visible
			ifTrue: [ m fullBounds quickMerge: prevBox ]
			ifFalse: [ prevBox ] ]! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: ''!
submorphCount

	^ submorphs size! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'jmv 11/10/2008 14:59'!
submorphInFrontOf: aMorph

	^submorphs before: aMorph! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'sw 10/26/1999 23:42'!
submorphThat: block1 ifNone: block2
	^ submorphs detect: [:m | (block1 value: m) == true] ifNone: [block2 value]
	! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: ''!
submorphs

	^ submorphs copy! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'di 11/4/97 14:30'!
submorphsBehind: aMorph do: aBlock
	| behind |
	behind := false.
	submorphs do:
		[:m | m == aMorph ifTrue: [behind := true]
						ifFalse: [behind ifTrue: [aBlock value: m]]].
! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: ''!
submorphsDo: aBlock

	submorphs do: aBlock.! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'di 11/4/97 14:29'!
submorphsInFrontOf: aMorph do: aBlock
	| behind |
	behind := false.
	submorphs do:
		[:m | m == aMorph ifTrue: [behind := true]
						ifFalse: [behind ifFalse: [aBlock value: m]]].
! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: ''!
submorphsReverseDo: aBlock

	submorphs reverseDo: aBlock.! !

!SMxMorph methodsFor: 'submorphs-accessing' stamp: 'sw 8/15/97 22:03'!
submorphsSatisfying: aBlock
	^ submorphs select: [:m | (aBlock value: m) == true]! !

!SMxMorph methodsFor: 'event handling' stamp: 'sw 11/16/1998 08:07'!
suspendEventHandler
	self eventHandler ifNotNil:
		[self setProperty: #suspendedEventHandler toValue: self eventHandler.
		self eventHandler: nil].
	submorphs do: [:m | m suspendEventHandler].  "All those rectangles"! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'jmv 9/23/2010 13:16'!
textAnchorType
	^ self
		valueOfProperty: #textAnchorType
		ifAbsent: [
			#inline
			"#document" ].! !

!SMxMorph methodsFor: 'text-anchor' stamp: 'ar 12/16/2001 18:37'!
textAnchorType: aSymbol
	aSymbol == #document
		ifTrue:[^self removeProperty: #textAnchorType]
		ifFalse:[^self setProperty: #textAnchorType toValue: aSymbol].! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 11/15/2001 12:21'!
toggleResistsRemoval
	"Toggle the resistsRemoval property"

	self resistsRemoval
		ifTrue:
			[self removeProperty: #resistsRemoval]
		ifFalse:
			[self setProperty: #resistsRemoval toValue: true]! !

!SMxMorph methodsFor: 'accessing' stamp: 'dgd 2/16/2003 21:40'!
toggleStickiness
	"togle the receiver's Stickiness"
	self hasExtension
		ifFalse: [^ self beSticky].
	self extension sticky: self extension sticky not! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
top

	^ bounds top! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 5/5/1998 01:23'!
top: aNumber
	self position: (bounds left @ aNumber)! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 3/6/2002 13:06'!
topCenter

	^ bounds topCenter! !

!SMxMorph methodsFor: 'geometry' stamp: 'di 6/12/97 11:07'!
topLeft

	^ bounds topLeft! !

!SMxMorph methodsFor: 'geometry' stamp: 'sw 8/20/97 23:04'!
topRight

	^ bounds topRight! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 6/30/2010 22:44'!
transferHalo: event from: formerHaloOwner
	"Progressively transfer the halo to the next likely recipient"
	| localEvt w |

	"Never transfer halo to top-most world"
	(self isWorldMorph and:[owner isNil]) ifFalse:[
		(self wantsHaloFromClick and:[formerHaloOwner ~~ self]) 
			ifTrue:[^self addHalo: event from: formerHaloOwner]].

	event shiftPressed ifTrue:[
		"Pass it outwards"
		owner ifNotNil:[^owner transferHalo: event from: formerHaloOwner].
		"We're at the top level; throw the event back in to find recipient"
		formerHaloOwner removeHalo.
		^self processEvent: event copy resetHandlerFields.
	].
	self submorphsDo:[:m|
		localEvt := event internalizedToOwnerOf: m from: self.
		(m fullContainsPoint: localEvt position) 
			ifTrue:[^m transferHalo: event from: formerHaloOwner].
	].
	"We're at the bottom most level; throw the event back up to the root to find recipient"
	formerHaloOwner removeHalo.
	(w := self world) ifNil: [ ^self ].
	localEvt := event externalizedFromOwnerOf: self to: w.
	^w processEvent: localEvt resetHandlerFields.
! !

!SMxMorph methodsFor: 'accessing' stamp: 'di 8/11/1998 12:33'!
unlock
	self lock: false! !

!SMxMorph methodsFor: 'accessing' stamp: 'sw 8/15/97 23:59'!
unlockContents
	self submorphsDo:
		[:m | m unlock]! !

!SMxMorph methodsFor: 'e-toy support' stamp: 'jmv 3/2/2010 16:16'!
unlockOneSubpart
	| unlockables aMenu reply |
	unlockables := self submorphs select:
		[:m | m isLocked].
	unlockables size <= 1 ifTrue: [^ self unlockContents].
	aMenu := SMxSelectionMenu labelList: (unlockables collect: [:m | m externalName]) selections: unlockables.
	reply := aMenu startUpWithCaption: 'Who should be be unlocked?' translated.
	reply ifNil: [^ self].
	reply unlock! !

!SMxMorph methodsFor: 'events-accessing' stamp: 'jmv 9/18/2009 00:12'!
updateableActionMap
	"Answer an updateable action map, saving it in my #actionMap property"
	"Do NOT duplicate this in Morphic3 / LightWidgets
	Views should not trigger events!!"
	
	| actionMap |
	actionMap := self valueOfProperty: #actionMap.
	actionMap ifNil: [
		actionMap := IdentityDictionary new.
		self setProperty: #actionMap toValue: actionMap].
	^ actionMap! !

!SMxMorph methodsFor: 'accessing' stamp: 'tk 12/16/1998 11:54'!
userString
	"Do I have a text string to be searched on?"

	^ nil! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 21:00'!
valueOfProperty: aSymbol 
	"answer the value of the receiver's property named aSymbol"
	^ self hasExtension
		ifTrue: [self extension valueOfProperty: aSymbol]! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 21:00'!
valueOfProperty: aSymbol ifAbsent: aBlock 
	"if the receiver possesses a property of the given name, answer  
	its value. If not then evaluate aBlock and answer the result of  
	this block evaluation"
	^ self hasExtension
		ifTrue: [self extension valueOfProperty: aSymbol ifAbsent: aBlock]
		ifFalse: [aBlock value]! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 20:55'!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	"If the receiver possesses a property of the given name, answer  
	its value. If not, then create a property of the given name, give 
	it the value obtained by evaluating aBlock, then answer that  
	value"
	^ self assureExtension valueOfProperty: aSymbol ifAbsentPut: aBlock! !

!SMxMorph methodsFor: 'accessing - properties' stamp: 'dgd 2/16/2003 20:55'!
valueOfProperty: aSymbol ifPresentDo: aBlock 
	"If the receiver has a property of the given name, evaluate  
	aBlock on behalf of the value of that property"
	self hasExtension
		ifFalse: [^ self].
	^ aBlock
		value: (self extension
				valueOfProperty: aSymbol
				ifAbsent: [^ self])! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 12/6/2004 09:54'!
vanishAfterSlidingTo: aPosition event: evt

	| aForm aWorld startPoint endPoint |
	aForm := self imageForm offset: 0@0.
	aWorld := self world.
	startPoint := evt hand fullBounds origin.
	self delete.
	aWorld displayWorld.
	endPoint := aPosition.
	aForm slideFrom: startPoint  to: endPoint nSteps: 12 delay: 15
! !

!SMxMorph methodsFor: 'copying' stamp: 'tk 1/6/1999 17:27'!
veryDeepCopyWith: deepCopier
	"Copy me and the entire tree of objects I point to.  An object in the tree twice is copied once, and both references point to him.  deepCopier holds a dictionary of objects we have seen.  See veryDeepInner:, veryDeepFixupWith:"

	self prepareToBeSaved.
	^ super veryDeepCopyWith: deepCopier! !

!SMxMorph methodsFor: 'copying' stamp: 'jmv 3/2/2010 09:59'!
veryDeepFixupWith: deepCopier
	"If some fields were weakly copied, fix new copy here."

	"super veryDeepFixupWith: deepCopier.	Object has no fixups, so don't call it"

	"If my owner is being duplicated too, then store his duplicate.
	 If I am owned outside the duplicated tree, then I am no longer owned!!"
	owner := deepCopier references at: owner ifAbsent: nil

! !

!SMxMorph methodsFor: 'copying' stamp: 'JuanVuletich 11/1/2010 15:49'!
veryDeepInner: deepCopier 
	"The inner loop, so it can be overridden when a field should not  
	be traced."
	"super veryDeepInner: deepCopier.	know Object has no inst vars"
	bounds := bounds shallowCopy.
	"Points are shared with original"
	"owner := owner.	special, see veryDeepFixupWith:"
	submorphs := submorphs veryDeepCopyWith: deepCopier.
	"each submorph's fixup will install me as the owner"
	"fullBounds := fullBounds.	fullBounds is shared with original!!"
	color := color veryDeepCopyWith: deepCopier.
	"color, if simple, will return self. may be complex"
	extension := extension.
	self
		privateExtension: (self extension veryDeepCopyWith: deepCopier)! !

!SMxMorph methodsFor: 'structure' stamp: 'jmv 11/10/2008 15:13'!
veryLastLeave
	"Answer the last submorph, recursively, i.e. the very last leave of the morph tree"

	^submorphs size = 0
		ifTrue: [ self ]
		ifFalse: [ submorphs last veryLastLeave ]! !

!SMxMorph methodsFor: 'drawing' stamp: 'dgd 2/16/2003 21:41'!
visible
	"answer whether the receiver is visible"
	self hasExtension
		ifFalse: [^ true].
	^ self extension visible! !

!SMxMorph methodsFor: 'drawing' stamp: 'dgd 2/16/2003 20:24'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean"
	(self hasExtension not and:[aBoolean])
				ifTrue: [^ self].
	self visible == aBoolean
		ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'rhi 10/5/2001 20:49'!
wantsBalloon
	"Answer true if receiver wants to show a balloon help text is a few moments."

	^ (self balloonText notNil) and: [SMxPreferences balloonHelpEnabled]! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:24'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. Note that for a successful drop operation both parties need to agree. The symmetric check is done automatically via aMorph wantsToBeDroppedInto: self."

	^self dropEnabled! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'sw 1/25/2000 17:43'!
wantsHaloFromClick
	^ true! !

!SMxMorph methodsFor: 'halos and balloon help' stamp: 'jmv 11/12/2006 22:14'!
wantsHaloHandleWithSelector: aSelector inHalo: aHaloMorph
	"Answer whether the receiver would like to offer the halo handle with the given selector (e.g. #addCollapseHandle:)"

	(#(addDismissHandle:) includes: aSelector) ifTrue:
		[^ self resistsRemoval not].

	(#( addDragHandle: ) includes: aSelector) ifTrue:
		[^ self okayToBrownDragEasily].

	(#(addGrowHandle:) includes: aSelector) ifTrue:
		[^ self okayToResizeEasily].

	(#( addRotateHandle: ) includes: aSelector) ifTrue:
		[^ self okayToRotateEasily].

	(#(addRecolorHandle:) includes: aSelector) ifTrue:
		[^ self wantsRecolorHandle].

	true ifTrue: [^ true]
	! !

!SMxMorph methodsFor: 'e-toy support' stamp: 'sw 11/27/2001 14:52'!
wantsRecolorHandle
	"Answer whether the receiver would like a recoloring halo handle to be put up.  Since this handle also presently affords access to the property-sheet, it is presently always allowed, even though SketchMorphs don't like regular recoloring"

	^ true
	
! !

!SMxMorph methodsFor: 'stepping' stamp: ''!
wantsSteps
	"Return true if the receiver overrides the default SMxMorph step method."
	"Details: Find first class in superclass chain that implements #step and return true if it isn't class SMxMorph."

	| c |
	c := self class.
	[c includesSelector: #step] whileFalse: [c := c superclass].
	^ c ~= SMxMorph! !

!SMxMorph methodsFor: 'dropping/grabbing' stamp: 'ar 9/18/2000 18:34'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph. This check is symmetric to #wantsDroppedMorph:event: to give both parties a chance of figuring out whether they like each other."
	^true! !

!SMxMorph methodsFor: 'geometry' stamp: ''!
width

	^ bounds width! !

!SMxMorph methodsFor: 'geometry' stamp: 'jm 1/29/98 14:26'!
width: aNumber

	self extent: aNumber asInteger@self height.
! !

!SMxMorph methodsFor: 'event handling' stamp: 'bf 8/30/2007 20:32'!
windowEvent: anEvent
	"Host window event"! !

!SMxMorph methodsFor: 'structure' stamp: 'ar 9/14/2000 16:48'!
withAllOwnersDo: aBlock
	"Evaluate aBlock with the receiver and all of its owners"
	aBlock value: self.
	owner ifNotNil:[^owner withAllOwnersDo: aBlock].! !

!SMxMorph methodsFor: 'structure' stamp: 'jmv 10/9/2009 13:56'!
world
	^owner
		ifNotNil: [ owner world ]! !

!SMxMorph methodsFor: 'geometry' stamp: 'jmv 4/27/2010 10:22'!
worldBoundsForHalo
	"Answer the rectangle to be used as the inner dimension of my halos.
	Allow for showing either bounds or fullBounds, and compensate for the optional bounds rectangle."

	| r |
	r := (SMxPreferences haloEnclosesFullBounds)
		ifFalse: [ self displayBounds ]
		ifTrue: [ self fullDisplayBounds ].
	SMxPreferences showBoundsInHalo ifTrue: [ ^r outsetBy: 1 ].
	^r! !

SMxMorph subclass: #SMxOneLineEditorMorph
	instanceVariableNames: 'font emphasis contents editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxOneLineEditorMorph commentStamp: 'jmv 4/2/2009 12:45' prior: 0!
A plain text editor for Morphic. Handles only one line. Similar to SMxStringMorphEditor. Does not handle fonts/styles, alignment, Smalltalk utilities and any other advanced stuff in SMxTextMorph. Just a simple text editor.!

!SMxOneLineEditorMorph class methodsFor: 'instance creation' stamp: 'jmv 4/1/2009 21:45'!
contents: aString
	" 'SMxStringMorph contents: str' is faster than 'SMxStringMorph new contents: str' 
	(StringEditorMorph contents: 'Some string') openInWorld
	"
	^ self contents: aString font: nil! !

!SMxOneLineEditorMorph class methodsFor: 'instance creation' stamp: 'jmv 11/4/2008 12:47'!
contents: aString font: aFont
	^ self basicNew initWithContents: aString font: aFont emphasis: 0! !

!SMxOneLineEditorMorph class methodsFor: 'instance creation' stamp: 'jmv 11/4/2008 12:47'!
contents: aString font: aFont emphasis: emphasisCode
	^ self basicNew initWithContents: aString font: aFont emphasis: emphasisCode! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 3/2/2010 16:19'!
baseFont

	font ifNil: [ font := StrikeFont default ].
	^font! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/13/2010 11:11'!
characterIndexAtPoint: aPoint

	| line block f |
	f := self fontToUse.
	
	line := TextLine 
		start: 1
		stop: contents size
		internalSpaces: 0
		paddingWidth: 0.
	line
		rectangle: bounds;
		lineHeight: f height baseline: f ascent.
		
	block := (CharacterBlockScanner new text:
			(Text initialFont: font stringOrText: contents))
		characterBlockAtPoint: aPoint index: nil
		in: line.

	^ block stringIndex! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/12/2010 23:38'!
contents: newContents 
	contents := newContents isText
		ifTrue: [
			emphasis := newContents emphasisAt: 1.
			 newContents string]
		ifFalse: [
			contents = newContents ifTrue: [^self].	"no substantive change"
			newContents].
	editor := nil.
	self fitContents! !

!SMxOneLineEditorMorph methodsFor: 'initialization' stamp: 'jmv 11/4/2008 12:50'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'jmv 3/31/2010 09:09'!
drawCaretOn: aCanvas
	"Essentially copied from #displayInsertionMarkAtX:top:bottom:emphasis:on:"
	|  caretColor top bottom x isBold isItalic xtraWidth x0 x1 x2 e |

	top := bounds top.
	bottom := top + self baseFont height.
	x := (self fontToUse widthOfString: contents from: 1 to: editor startIndex-1) + bounds left.
	isBold := emphasis allMask: 1.
	isItalic := emphasis allMask: 2.
	caretColor := self insertionPointColor.
	xtraWidth := isBold ifTrue: [ 1 ] ifFalse: [ 0 ].
	isItalic ifTrue:
		[x0 := x - 2.
		x1 := x0 - 2.
		x2 := x0 - 6 ]
	ifFalse:
		[x0 := x.
		x1 := x0 - 4.
		x2 := x1 ].
	1 to: 2 do: [ :i | 
		"Draw caret triangles at top and bottom"
		e := (2 - i) * 2 + 4+xtraWidth @ 1.
		aCanvas fillRectangle: (x1 + i @ (top + i - 1) extent: e)
			color: caretColor.
		aCanvas fillRectangle: (x2 + i @ (bottom - i) extent: e)
			color: caretColor].
	aCanvas fillRectangle: (x0-1 @ top corner: x0+1+xtraWidth @ bottom)
		color: caretColor! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'jmv 1/22/2009 13:55'!
drawOn: aCanvas
	self hasSelection ifTrue: [
		self drawSelectionOn: aCanvas ].
	self hasVisibleCaret ifTrue: [
		self drawCaretOn: aCanvas].
	aCanvas drawString: contents in: bounds font: self fontToUse color: color! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'jmv 11/5/2008 14:00'!
drawSelectionOn: aCanvas
	| rightX leftX top bottom |

	top := bounds top.
	bottom := top + self baseFont height.
	leftX := (self fontToUse widthOfString: contents from: 1 to: editor startIndex-1) + bounds left.
	rightX := (self fontToUse widthOfString: contents from: 1 to: editor stopIndex-1) + bounds left.

	aCanvas fillRectangle: (leftX @ top corner: rightX @ bottom)
		color: self selectionColor! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 15:47'!
editor
	"Return my current editor, or install a new one."
	editor ifNotNil: [^ editor].
	^ self installEditorToReplace: nil! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 12:53'!
fitContents

	| newBounds boundsChanged |
	newBounds := self measureContents.
	boundsChanged := bounds extent ~= newBounds.
	self extent: newBounds.		"default short-circuits if bounds not changed"
	boundsChanged ifFalse: [self changed]! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 11/5/2008 13:18'!
fontToUse

	^ (emphasis isNil or: [emphasis = 0]) 
		ifTrue: [ self baseFont ]
		ifFalse: [ self baseFont emphasized: emphasis ]! !

!SMxOneLineEditorMorph methodsFor: 'editing' stamp: 'jmv 9/2/2009 13:51'!
handleInteraction: interactionBlock
	"Perform the changes in interactionBlock, noting any change in selection
	and possibly a change in the size of the paragraph (ar 9/22/2001 - added for TextPrintIts)"

	"Also couple the editor to Morphic keyboard events"

	| oldEditor oldContents |
	oldEditor := editor.
	oldContents := contents.
	interactionBlock value.
	oldContents == contents 
		ifTrue: 
			["this will not work if the paragraph changed"

			editor := oldEditor	"since it may have been changed while in block"].
	self changed! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 11/18/2008 13:53'!
handlesKeyboard

	^self visible! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 11/4/2008 15:36'!
handlesMouseDown: evt
	^ self innerBounds containsPoint: evt cursorPoint! !

!SMxOneLineEditorMorph methodsFor: 'testing' stamp: 'jmv 11/5/2008 12:41'!
hasSelection

	^editor notNil and: [editor hasSelection]! !

!SMxOneLineEditorMorph methodsFor: 'unaccepted edits' stamp: 'JuanVuletich 11/1/2010 15:44'!
hasUnacceptedEdits: aBoolean
	"Set the hasUnacceptedEdits flag to the given value. "
	
	"Not used in this morph, as it doesn't do accept / cancel"
	self changed! !

!SMxOneLineEditorMorph methodsFor: 'testing' stamp: 'jmv 1/22/2009 13:55'!
hasVisibleCaret

	^ self hasKeyboardFocus and: [editor hasCaret]! !

!SMxOneLineEditorMorph methodsFor: 'initialization' stamp: 'jmv 11/5/2008 12:15'!
initWithContents: aString font: aFont emphasis: emphasisCode 
	self initialize.
	
	font := aFont.
	emphasis := emphasisCode.
	self contents: aString! !

!SMxOneLineEditorMorph methodsFor: 'initialization' stamp: 'jmv 1/26/2009 15:55'!
initialize
	super initialize.
	contents := ''.
	font := nil.
	emphasis := 0! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'jmv 11/5/2008 12:40'!
insertionPointColor

	^ Display depth <= 2
		ifTrue: [Color black]
		ifFalse: [SMxPreferences insertionPointColor]! !

!SMxOneLineEditorMorph methodsFor: 'private' stamp: 'JuanVuletich 10/13/2010 11:06'!
installEditorToReplace: priorEditor
	"Install an editor for my contents.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	editor := SimpleEditor new morph: self.
	editor changeString: contents.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self changed.
	^editor! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 9/17/2010 14:57'!
keyStroke: evt
	"Handle a keystroke event."

	(self focusKeyboardFor: evt)
		ifTrue: [ ^ self ].

	"CR - check for special action
	Note: Code below assumes that this was some
	input field reacting on CR. Break the keyboard
	focus so that the receiver can be safely deleted.
	jmv - Currently not implemented"
	"
	evt keyValue = 13 ifTrue: [
		action := self crAction.
		action ifNotNil: [
			evt hand newKeyboardFocus: nil.
			^action value ] ].
	"
	self handleInteraction: [ editor processKeyStroke: evt ].
	self updateFromContents.
	super keyStroke: evt  "sends to keyStroke event handler, if any"! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 11/10/2008 13:28'!
keyboardFocusChange: aBoolean 

	aBoolean ifTrue: [
		"A hand is wanting to send us characters... Ensure editor."
		self editor ].
	self changed! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 11/5/2008 13:19'!
measureContents
	| f |

	f := self fontToUse.
	^((f widthOfString: contents) max: self minimumWidth)  @ f height.! !

!SMxOneLineEditorMorph methodsFor: 'accessing' stamp: 'jmv 11/4/2008 12:55'!
minimumWidth
	"Answer the minimum width that the receiver can have.  A nonzero value here keeps the receiver from degenerating into something that cannot ever be seen or touched again!!  Obeyed by fitContents."

	^ 3! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 9/2/2009 13:53'!
mouseDown: evt
	"Make this SMxTextMorph be the keyboard input focus, if it isn't already,
		and repond to the text selection gesture."

	evt hand newKeyboardFocus: self.
	self handleInteraction: [
		editor mouseDown: evt index: (self characterIndexAtPoint: evt cursorPoint) ]! !

!SMxOneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 9/2/2009 13:53'!
mouseMove: evt
	evt redButtonPressed ifFalse: [^ self].
	self handleInteraction: [
		editor mouseMove: evt index: (self characterIndexAtPoint: evt cursorPoint) ]! !

!SMxOneLineEditorMorph methodsFor: 'drawing' stamp: 'jmv 11/10/2008 13:27'!
selectionColor
	| c |
	Display depth = 1 ifTrue: [^ Color veryLightGray].
	Display depth = 2 ifTrue: [^ Color gray: 0.87].
	c := SMxPreferences textHighlightColor.
	self hasKeyboardFocus ifFalse: [c := c alphaMixed: 0.2 with: Color veryVeryLightGray].
	^ c! !

!SMxOneLineEditorMorph methodsFor: 'private' stamp: 'jmv 11/4/2008 16:08'!
updateFromContents


	"O contents deberia ser un StringHolder????"
	contents := editor string.
	self changed! !

SMxMorph subclass: #SMxSketchMorph
	instanceVariableNames: 'originalForm'
	classVariableNames: 'PaintingIcon'
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxSketchMorph commentStamp: '<historical>' prior: 0!
The morph that results when the user draws a color bitmap using the PaintBox (SketchEditorMorph and PaintBoxMorph).  

forwardDirection is the angle at which the object will go forward.  When the rotationStyle is not #normal, then forwardDirection is any angle, while the rotation is highly restricted.  If flexed, this is remembered by the Transform morph.  For non-normal rotationStyle, it is rotationDegrees.

setupAngle (a property) is where the user put the green arrow to indicate which direction on the picture is forward.  When #normal, draw the morph initially at (0.0 - setupAngle).  The enclosing TransformationMorph then rotates it to the true angle.
 
rotationDegrees  In a #normal object, rotationDegrees is constant an equal to setupAngle.
	For non-normal, it is the direction the object is going.

When repainting, set it back to its original state. The green arrow is set to setupAngle, and the sketch is shown as drawn originally (rotationDegrees = 0). 

rotationStyle = normal (turns), leftRight, upDown, fixed.  
When leftRight upDown or fixed, bit map has severe restrictions.
!

SMxSketchMorph subclass: #SMxColorPickerMorph
	instanceVariableNames: 'selectedColor sourceHand deleteOnMouseUp updateContinuously target selector argument originalColor isModal clickedTranslucency'
	classVariableNames: 'ColorChart DragBox EyedropperIcon FeedbackBox RevertBox TransText TransparentBox'
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxColorPickerMorph commentStamp: 'kfr 10/27/2003 16:16' prior: 0!
A gui for setting color and transparency. Behaviour can be changed with the SMxPreference modalColorPickers.!

!SMxColorPickerMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:18'!
eyedropperIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ EyedropperIcon ifNil: [
		EyedropperIcon := Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAACYAAAAkCAYAAADl9UilAAABiklEQVR4XuXYoZKDMBAGYO6Z
YpBIJBKJYngTHoHJEyCRlUhMfCWyEonc5l+aTI62c+qy6TQzO7HfbDY/abPvX5+yjNZk2paM
UqTtngbKQsiCiPcHzpYsykIYdCrgWimcCTH2KH05WJZR13UUGaX52F6hQhgqKszP1BsUZkwx
6oeSQrUe9Y8wjoFH/XV80VDHzVMcB8f+AqUEUFj6FAO+Y4/8ctGgYqI8DoAA5+q5SxFR4zjS
PM+MCGdJFDVNE63rSljLsjDmOQ4EUNu2MWrfd7per5zk6JJGakjMVIi63W5kjD1FO/DKdqrv
e96joy6XC3foF8p+gvI89wjumMdFRKGA0lYFVFmWcs+Yc6eAwkwpybcV4sANOaO0obquqSgK
2U6FN8+hmqaRQyGbzijMk+hMhSjcPIdKolNhRgEV/Sn8aqZCFDJKtFNI9HNGAYU0F0PhlYAP
sosDdAhxIIpqzfE6cCjMU1VV8r+YAUMcuM/LMAxp/IwHDEcmeutCzLtK5t+YpDDfD/vkdQfd
hqlIh/LZTwAAAABJRU5ErkJggg==' base64Decoded asByteArray readStream.
		EyedropperIcon offset: -12 @ -35 ]! !

!SMxColorPickerMorph class methodsFor: 'class initialization' stamp: 'di 9/28/2000 11:09'!
initialize
	"SMxColorPickerMorph initialize"

	ColorChart := Color colorPaletteForDepth: 16 extent: 190@60.
	DragBox :=  (11@0) extent: 9@8.
	RevertBox := (ColorChart width - 20)@1 extent: 9@8.
	FeedbackBox := (ColorChart width - 10)@1 extent: 9@8.
	TransparentBox := DragBox topRight corner: RevertBox bottomLeft.

		ColorChart fillBlack: ((DragBox left - 1)@0 extent: 1@9).
		ColorChart fillBlack: ((TransparentBox left)@0 extent: 1@9).
		ColorChart fillBlack: ((FeedbackBox left - 1)@0 extent: 1@9).
		ColorChart fillBlack: ((RevertBox left - 1)@0 extent: 1@9).
		(Form dotOfSize: 5) displayOn: ColorChart at: DragBox center + (0@1).

	TransText := (Form extent: 63@8 depth: 1   "Where there's a will there's a way..."
			fromArray: #(4194306 1024 4194306 1024 15628058 2476592640
					4887714 2485462016 1883804850 2486772764 4756618
					2485462016 4748474 1939416064 0 0)
			offset: 0@0).
	TransText := ColorForm mappingWhiteToTransparentFrom: TransText
! !

!SMxColorPickerMorph class methodsFor: 'as yet unclassified' stamp: 'sw 10/27/1999 11:40'!
perniciousBorderColor
	"Answer the color of the border lines of a color picker; this color gets reported as you drag the mouse through from the translucent box to the true color area, for example, and can cause some difficulties in some special cases, so it is faithfully reported here in this hard-coded fashion in order that energetic clients wishing to handle it as special-case it can do so."

	^ Color r: 0.0 g: 0.0 b: 0.032! !

!SMxColorPickerMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	deleteOnMouseUp
		ifTrue: [aCustomMenu add: 'stay up' translated action: #toggleDeleteOnMouseUp]
		ifFalse: [aCustomMenu add: 'do not stay up' translated action: #toggleDeleteOnMouseUp].
	updateContinuously
		ifTrue: [aCustomMenu add: 'update only at end' translated action: #toggleUpdateContinuously]
		ifFalse: [aCustomMenu add: 'update continuously' translated action: #toggleUpdateContinuously].
! !

!SMxColorPickerMorph methodsFor: 'other' stamp: 'jmv 4/27/2010 11:37'!
addToWorld: world near: box
	| goodLocation |
	goodLocation := self bestPositionNear: box inWorld: world.
	world allMorphsDo:
		[:p | (p isMemberOf: SMxColorPickerMorph) ifTrue:
		[(p ~~ self and: [p owner notNil and: [p target == target]]) ifTrue:
			[(p selector == selector and: [p argument == argument])
				ifTrue: [^ p comeToFront  "uncover existing picker"]
				ifFalse: ["place second picker relative to first"
						goodLocation := self bestPositionNear: p displayBounds inWorld: world]]]].
	self position: goodLocation.
	world addMorphFront: self.
	self changed
! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'di 9/27/2000 10:36'!
anchorAndRunModeless: aHand
	"If user clicks on the drag-dot of a modal picker,
	anchor it, and change to modeless operation."

	aHand showTemporaryCursor: nil.  "revert to normal cursor"
	self initializeModal: false; originalColor: originalColor.  "reset as modeless"
	aHand flushEvents.  "Drop any events gathered during modal loop"
	aHand position: Sensor cursorPoint; grabMorph: self.  "Slip into drag operation"
! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'ar 6/25/1999 11:33'!
argument
	^argument! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'ar 6/25/1999 11:33'!
argument: anObject
	argument := anObject! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'ar 7/19/2003 20:40'!
argumentsWith: aColor
	"Return an argument array appropriate to this action selector"

	| nArgs |
	nArgs := selector ifNil:[0] ifNotNil:[selector numArgs].
	nArgs = 0 ifTrue:[^#()].
	nArgs = 1 ifTrue:[^ {aColor}].
	nArgs = 2 ifTrue:[^ {aColor. sourceHand}].
	nArgs = 3 ifTrue:[^ {aColor. argument. sourceHand}].
! !

!SMxColorPickerMorph methodsFor: 'other' stamp: 'jmv 4/27/2010 11:34'!
bestPositionNear: box inWorld: world
	| points b |
	points := #(topCenter rightCenter bottomCenter leftCenter).  "possible anchors"
	1 to: 4 do:
		[:i |  "Try the four obvious anchor points"
		b := bounds align: (bounds perform: (points at: i))
					with: (box perform: (points atWrap: i + 2)).
		(world viewBox containsRect: b) ifTrue:
			[^ b topLeft"  Yes, it fits"]].

	^ 20@20  "when all else fails"
! !

!SMxColorPickerMorph methodsFor: 'initialization' stamp: 'jmv 5/7/2009 13:07'!
buildChartForm
	| chartForm |
	chartForm := ColorChart deepCopy asFormOfDepth: Display depth.
	chartForm fill: ((TransparentBox left + 9)@0 extent: 1@9) fillColor: Color lightGray.
	chartForm fill: ((TransparentBox right - 10)@0 extent: 1@9) fillColor: Color lightGray.
	TransText displayOn: chartForm at: 62@0.
	Display depth = 32 ifTrue:
		["Set opaque bits for 32-bit display"
		chartForm fill: chartForm boundingBox rule: Form under
				fillColor: (Color r: 0.0 g: 0.0 b: 0.0 alpha: 1.0)].
	chartForm borderWidth: 1.
	self form: chartForm.
	selectedColor ifNotNil: [self updateAlpha: selectedColor alpha]

! !

!SMxColorPickerMorph methodsFor: 'initialization' stamp: 'sw 9/8/2000 18:14'!
choseModalityFromPreference
	"Decide whether to be modal or not by consulting the prevailing preference"

	self initializeModal: SMxPreferences modalColorPickers! !

!SMxColorPickerMorph methodsFor: 'geometry testing' stamp: 'jmv 1/8/2010 15:29'!
containsPoint: aPoint
	^ (bounds containsPoint: aPoint)
		or: [ RevertBox containsPoint: aPoint - self topLeft ]! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'di 9/27/2000 12:55'!
deleteAllBalloons

	self submorphsDo: [:m | m deleteBalloon].
! !

!SMxColorPickerMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:27'!
drawOn: aCanvas
	aCanvas depth = 1 ifTrue: [aCanvas fillRectangle: bounds color: Color white].
	Display depth = originalForm depth ifFalse: [self buildChartForm].
	super drawOn: aCanvas! !

!SMxColorPickerMorph methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
handlesMouseDown: evt

	^ true
! !

!SMxColorPickerMorph methodsFor: 'other' stamp: 'di 9/25/2000 15:38'!
indicateColorUnderMouse
	"Track the mouse with the special eyedropper cursor, and accept whatever color is under the mouse as the currently-chosen color; reflect that choice in the feedback box, and return that color."

	| pt |
	self pickColorAt: (pt := Sensor cursorPoint).
	isModal ifTrue:
		[self activeHand position: pt.
		self world displayWorldSafely; runStepMethods].
	^ selectedColor	! !

!SMxColorPickerMorph methodsFor: 'event handling' stamp: 'RAA 2/19/2001 13:16'!
inhibitDragging

	^self hasProperty: #noDraggingThisPicker! !

!SMxColorPickerMorph methodsFor: 'initialization' stamp: 'ar 9/4/2001 13:26'!
initialize
	"Initialize the receiver.  Obey the modalColorPickers preference when deciding how to configure myself.  This is not quite satisfactory -- we'd like to have explicit calls tell us things like whether whether to be modal, whether to allow transparency, but for the moment, in grand Morphic fashion, this is rather inflexibly all housed right here"

	super initialize.
	self clipSubmorphs: true.
	self buildChartForm.
	
	selectedColor := Color white.
	sourceHand := nil.
	deleteOnMouseUp := false.
	clickedTranslucency := false.
	updateContinuously := true.
	selector := nil.
	target := nil! !

!SMxColorPickerMorph methodsFor: 'initialization' stamp: 'jmv 9/12/2009 23:22'!
initializeModal: beModal 
	"Initialize the receiver.  If beModal is true, it will be a modal color picker, else not"

	isModal := beModal.
	self removeAllMorphs.
	isModal ifFalse: [
		self addMorph: (SMxSimpleButtonMorph new
			borderWidth: 0;
			label: 'x' font: nil;
			color: Color transparent;
			actionSelector: #delete;
			target: self;
			position: self topLeft - (0 @ 1);
			extent: 10 @ 12;
			setBalloonText: 'dismiss color picker')].
	self addMorph: ((SMxMorph newBounds: (DragBox translateBy: self topLeft))
				color: Color transparent;
				setBalloonText: 'put me somewhere').
	self 
		addMorph: ((SMxMorph newBounds: (RevertBox translateBy: self topLeft))
				color: Color transparent;
				setBalloonText: 'restore original color').
	self 
		addMorph: ((SMxMorph newBounds: (FeedbackBox translateBy: self topLeft))
				color: Color transparent;
				setBalloonText: 'shows selected color').
	self 
		addMorph: ((SMxMorph newBounds: (TransparentBox translateBy: self topLeft))
				color: Color transparent;
				setBalloonText: 'adjust translucency').
	self buildChartForm.
	selectedColor ifNil: [selectedColor := Color white].
	sourceHand := nil.
	deleteOnMouseUp := false.
	updateContinuously := true! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jmv 3/1/2010 15:19'!
locationIndicator

	^self valueOfProperty: #locationIndicator ifAbsent: [
		| loc |
		loc := SMxEllipseMorph new.
		loc color: Color transparent; 
			borderWidth: 1; 
			borderColor: Color red; 
			extent: 6@6.
		self setProperty: #locationIndicator toValue: loc.
		self addMorphFront: loc.
		loc]! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'jmv 3/2/2010 15:54'!
modalBalloonHelpAtPoint: cursorPoint 
	self flag: #arNote.	"Throw this away. There needs to be another way."
	self submorphsDo: 
			[:m | 
			m wantsBalloon 
				ifTrue: [
					(m valueOfProperty: #balloon)
						ifNil: [ 
							(m containsPoint: cursorPoint) ifTrue: [m showBalloon: m balloonText]]
						ifNotNil: [(m containsPoint: cursorPoint) ifFalse: [m deleteBalloon]]]]! !

!SMxColorPickerMorph methodsFor: 'event handling' stamp: 'RAA 2/19/2001 13:17'!
mouseDown: evt
	| localPt |
	localPt := evt cursorPoint - self topLeft.
	self deleteAllBalloons.
	clickedTranslucency := TransparentBox containsPoint: localPt.
	self inhibitDragging ifFalse: [
		(DragBox containsPoint: localPt)
			ifTrue: [^ evt hand grabMorph: self].
	].
	(RevertBox containsPoint: localPt)
		ifTrue: [^ self updateColor: originalColor feedbackColor: originalColor].
	self inhibitDragging ifFalse: [self comeToFront].
	sourceHand := evt hand.
	self startStepping.
! !

!SMxColorPickerMorph methodsFor: 'event handling' stamp: 'jm 11/4/97 07:46'!
mouseUp: evt

	self stopStepping.
	sourceHand := nil.
	deleteOnMouseUp ifTrue: [self delete].
	self updateTargetColor.
! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'JuanVuletich 11/1/2010 15:52'!
originalColor: colorOrSymbol 
	"Set the receiver's original color.  It is at this point that a command is launched to represent the action of the picker, in support of Undo."

	originalColor := (colorOrSymbol isColor) 
				ifTrue: [colorOrSymbol]
				ifFalse: [Color lightGreen].
	originalForm fill: RevertBox fillColor: originalColor.
	selectedColor := originalColor.
	self locationIndicator 
		center: self topLeft + (self positionOfColor: originalColor)! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'JuanVuletich 11/1/2010 15:52'!
pickColorAt: aGlobalPoint

	| alpha selfRelativePoint pickedColor |
	clickedTranslucency ifNil: [clickedTranslucency := false].
	selfRelativePoint := (self internalizePositionToOwner: aGlobalPoint from: nil) - self topLeft.
	(FeedbackBox containsPoint: selfRelativePoint) ifTrue: [^ self].
	(RevertBox containsPoint: selfRelativePoint)
		ifTrue: [^ self updateColor: originalColor feedbackColor: originalColor].

	"check for transparent color and update using appropriate feedback color "
	(TransparentBox containsPoint: selfRelativePoint) ifTrue:
		[clickedTranslucency ifFalse: [^ self].  "Can't wander into translucency control"
		alpha := (selfRelativePoint x - TransparentBox left - 10) asFloat /
							(TransparentBox width - 20)
							min: 1.0 max: 0.0.
					"(alpha roundTo: 0.01) printString , '   ' displayAt: 0@0." " -- debug"
		self 
			updateColor: (selectedColor alpha: alpha)
			feedbackColor: (selectedColor alpha: alpha).
		^ self].

	"pick up color, either inside or outside this world"
	clickedTranslucency ifTrue: [^ self].  "Can't wander out of translucency control"
	self locationIndicator visible: false. self refreshWorld.
	pickedColor := Display colorAt: aGlobalPoint.
	self locationIndicator visible: true. self refreshWorld.
	self 
		updateColor: (
			((selectedColor isColor) and: [ selectedColor isOpaque not ])
						ifTrue: [ pickedColor alpha: selectedColor alpha ]
						ifFalse: [ pickedColor ]
		)
		feedbackColor: pickedColor! !

!SMxColorPickerMorph methodsFor: 'menu' stamp: 'JuanVuletich 10/12/2010 09:26'!
pickUpColorFor: aMorph
	"Show the eyedropper cursor, and modally track the mouse through a mouse-down and mouse-up cycle"

      | aHand localPt |
	aHand := aMorph ifNil: [self activeHand] ifNotNil: [aMorph activeHand].
	aHand ifNil: [aHand := self currentHand].
	self addToWorld: aHand world near: (aMorph ifNil: [aHand world]) fullDisplayBounds.
	self owner ifNil: [^ self].

	aHand showTemporaryCursor: self class eyedropperIcon 
			hotSpotOffset: 6 negated @ 4 negated.    "<<<< the form was changed a bit??"

	self updateContinuously: false.
	[Sensor anyButtonPressed]
		whileFalse: 
			 [self trackColorUnderMouse].
	self deleteAllBalloons.

	localPt := Sensor cursorPoint - self topLeft.
	self inhibitDragging ifFalse: [
		(DragBox containsPoint: localPt) ifTrue:
			["Click or drag the drag-dot means to anchor as a modeless picker"
			^ self anchorAndRunModeless: aHand].
	].
	(clickedTranslucency := TransparentBox containsPoint: localPt)
		ifTrue: [selectedColor := originalColor].

	self updateContinuously: true.
	[Sensor anyButtonPressed]
		whileTrue:
			 [self updateTargetColorWith: self indicateColorUnderMouse].
	aHand newMouseFocus: nil;
		showTemporaryCursor: nil;
		flushEvents.
	self delete.
		 
 ! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'ar 9/4/2001 13:27'!
positionOfColor: aColor
	"Compute the position of the given color in the color chart form"
	| rgbRect x y h s v |
	rgbRect := (0@0 extent: originalForm boundingBox extent) insetBy: (1@10 corner: 11@1).
	h := aColor hue.
	s := aColor saturation.
	v := aColor brightness.
	h = 0.0 ifTrue:["gray"
		^(rgbRect right + 6) @ (rgbRect height * (1.0 - v) + rgbRect top)].
	x := (h + 22 \\ 360 / 360.0 * rgbRect width) rounded.
	y := 0.5.
	s < 1.0 ifTrue:[y := y - (1.0 - s * 0.5)].
	v < 1.0 ifTrue:[y := y + (1.0 - v * 0.5)].
	y := (y * rgbRect height) rounded.
	^x@y + (1@10)! !

!SMxColorPickerMorph methodsFor: 'other' stamp: 'jmv 4/27/2010 10:21'!
putUpFor: aMorph near: aRectangle
	"Put the receiver up on the screen.   Note highly variant behavior depending on the setting of the #modalColorPickers preference"
	| layerNumber |
	(aMorph is: #SMxMorph) ifTrue: [
		layerNumber := aMorph morphicLayerNumber.
		aMorph allOwnersDo: [ : m|
			layerNumber := layerNumber min: m morphicLayerNumber].
		self setProperty: #morphicLayerNumber toValue: layerNumber - 0.1
	].

	isModal == true "backward compatibility"
		ifTrue: [
			self pickUpColorFor: aMorph]
		ifFalse: [
			self addToWorld:
				((aMorph notNil and: [aMorph world notNil])
					ifTrue:
						[aMorph world]
					ifFalse:
						[self currentWorld])
		  		near:
					(aRectangle ifNil:
						[aMorph ifNil: [100@100 extent: 1@1] ifNotNil: [aMorph fullDisplayBounds]])]! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:15'!
selector

	^ selector
! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jmv 5/7/2009 13:07'!
selector: aSymbol
	"Set the selector to be associated with the receiver.  Store it in the receiver's command, if appropriate"

	selector := aSymbol! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:15'!
sourceHand: aHand

	sourceHand := aHand.
! !

!SMxColorPickerMorph methodsFor: 'stepping and presenter' stamp: 'jm 11/4/97 07:15'!
step

	sourceHand ifNotNil:
		[self pickColorAt: sourceHand position].
! !

!SMxColorPickerMorph methodsFor: 'testing' stamp: 'jm 11/4/97 07:15'!
stepTime

	^ 50
! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:15'!
target

	^ target
! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/22/2010 11:26'!
target: anObject 
	target := anObject.
	selectedColor := target color! !

!SMxColorPickerMorph methodsFor: 'menu' stamp: 'jm 11/4/97 07:46'!
toggleDeleteOnMouseUp

	deleteOnMouseUp := deleteOnMouseUp not.
! !

!SMxColorPickerMorph methodsFor: 'menu' stamp: 'jm 11/4/97 07:46'!
toggleUpdateContinuously

	updateContinuously := updateContinuously not.
! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'jmv 3/8/2010 14:26'!
trackColorAt: aGlobalPoint 
	"Before the mouse comes down in a modal color picker, track the color under the cursor, and show it in the feedback box, but do not make transparency changes"

	| selfRelativePoint pickedColor |
	selfRelativePoint := (self internalizePositionToOwner: aGlobalPoint from: nil) - self topLeft.
	(FeedbackBox containsPoint: selfRelativePoint) ifTrue: [^ self].
	(RevertBox containsPoint: selfRelativePoint)
		ifTrue: [^ self updateColor: originalColor feedbackColor: originalColor].

	"check for transparent color and update using appropriate feedback color "
	(TransparentBox containsPoint: selfRelativePoint) ifTrue: [^ self].

	"pick up color, either inside or outside this world"
	pickedColor := Display colorAt: aGlobalPoint.
	self updateColor: (pickedColor alpha: originalColor alpha)
		feedbackColor: pickedColor! !

!SMxColorPickerMorph methodsFor: 'other' stamp: 'di 9/27/2000 11:48'!
trackColorUnderMouse
	"Track the mouse with the special eyedropper cursor, and accept whatever color is under the mouse as the currently-chosen color; reflect that choice in the feedback box, and return that color."

	| pt |
	selectedColor := originalColor.
	self trackColorAt: (pt := Sensor cursorPoint).
	isModal ifTrue:
		[self activeHand position: pt.
		self world displayWorldSafely; runStepMethods.
		self modalBalloonHelpAtPoint: pt].
	^ selectedColor	! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'di 9/28/2000 11:10'!
updateAlpha: alpha
	| sliderRect |
	sliderRect := (TransparentBox left + 10)@1 corner: (TransparentBox right - 9)@9.
	originalForm fill: (sliderRect withRight: sliderRect left + (alpha*sliderRect width))
				fillColor: Color lightGray.
	originalForm fillWhite: (sliderRect withLeft: sliderRect left + (alpha*sliderRect width)).
	originalForm fill: ((TransparentBox right - 9)@1 extent: 8@8)
				fillColor: (alpha < 1.0 ifTrue: [Color white] ifFalse: [Color lightGray]).
	TransText displayOn: originalForm at: 62@1 rule: Form paint.
! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'ar 8/25/2001 20:50'!
updateColor: aColor feedbackColor: feedbackColor
	"Set my selected color to the given color if it is different. Give user feedback. Inform the target of the change if the target and selector are not nil." 

	selectedColor = aColor ifTrue: [^ self].  "do nothing if color doesn't change"

	self updateAlpha: aColor alpha.
	originalForm fill: FeedbackBox fillColor: feedbackColor.
	self form: originalForm.
	selectedColor := aColor.
	updateContinuously ifTrue: [self updateTargetColor].
	self locationIndicator center: self topLeft + (self positionOfColor: feedbackColor).! !

!SMxColorPickerMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
updateContinuously: aBoolean

	updateContinuously := aBoolean.
! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'jmv 5/7/2009 13:08'!
updateTargetColor
	| nArgs |
	(target notNil and: [selector notNil]) 
		ifTrue: [
			nArgs := selector numArgs.
			nArgs = 1 ifTrue: [^target perform: selector with: selectedColor].
			nArgs = 2 
				ifTrue: 
					[^target 
						perform: selector
						with: selectedColor
						with: sourceHand].
			nArgs = 3 
				ifTrue: 
					[^target 
						perform: selector
						with: selectedColor
						with: argument
						with: sourceHand]]! !

!SMxColorPickerMorph methodsFor: 'private' stamp: 'jmv 5/7/2009 13:08'!
updateTargetColorWith: aColor 
	"Update the target so that it reflects aColor as the color choice"

	(target notNil and: [selector notNil]) 
		ifTrue: [
			^target perform: selector withArguments: (self argumentsWith: aColor)]! !

!SMxSketchMorph class methodsFor: 'new-morph participation' stamp: 'sw 9/28/1998 17:15'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!SMxSketchMorph class methodsFor: 'accessing - icons' stamp: 'JuanVuletich 10/12/2010 09:19'!
paintingIcon
	"Created using:
	Clipboard default clipboardText:
	 	((ByteArray streamContents:[:s|
			PNGReadWriter
				putForm: (aForm)
				onStream: s]) asString base64Encoded)
	"
	^ PaintingIcon ifNil: [
		PaintingIcon := Form fromBinaryStream: 'iVBORw0KGgoAAAANSUhEUgAAACkAAAA0CAYAAAAXKBGzAAABgElEQVR4XuWZP5KCMBTGU1p6
BEtLSkpLj7ClJUfwCJaWW3oES46w5R7B0tLSUj9nGLMxgUjeP1xmvhEI4G++l/cIifvobbfK
l1kwcdASOBHQXIBDpQSa86e/c+cus78aAlYHFAPNDXEKEGoXzKGXghwN+k629oWbLePDBzR1
7ZZV62bV9SHs45x/DRwb4yAJJGA6OF8ALSlBpJAxwCFQdsgcF01BQn5fDLWutzYgw6Qx52II
C+egMLNFBxpUzrAOMMxDph62+ro3bp/CsSlIH87XojES6tDBUCWOkkHCLS5IsnBv1v2QaBdP
otjNAAkdxTEl4FvAfTcitJ1US5RkjRwNahHyBXTo4uP+KTXQPrjT+VXfjQJorAEgMUAN0KSb
KRc7SYd+upDQTxsHxHmVBEo1ou/BNYDht6QvlpQ81lpJNeBmK+qUXwZmZnPJ3j7cs7ifA6m9
wiAyfPu3kCwTBiIuaoCyfKhRgorMupXATnrmTWyNx8RCqXlADuDJL9jfAEQTbn3reyhsAAAA
AElFTkSuQmCC' base64Decoded asByteArray readStream ]! !

!SMxSketchMorph class methodsFor: 'instance creation' stamp: 'di 2/17/2000 20:21'!
withForm: aForm
	"Note: 'SMxSketchMorph withForm: zz' is MUCH faster
	than 'SMxSketchMorph new form: zz'."

	^ self basicNew initializeWith: aForm! !

!SMxSketchMorph methodsFor: 'menus' stamp: 'ar 6/18/1999 06:40'!
addFillStyleMenuItems: aMenu hand: aHand
	"Do nothing here - we do not allow changing the fill style of a SMxSketchMorph yet."! !

!SMxSketchMorph methodsFor: 'geometry testing' stamp: 'jmv 4/27/2010 11:32'!
containsPoint: aPoint

	^ (bounds containsPoint: aPoint) and: [
		(originalForm isTransparentAt: aPoint - bounds origin) not ]
! !

!SMxSketchMorph methodsFor: 'drawing' stamp: 'jmv 5/23/2009 00:03'!
drawOn: aCanvas
	aCanvas translucentImage: originalForm at: bounds origin
! !

!SMxSketchMorph methodsFor: 'geometry' stamp: 'jmv 5/23/2009 00:08'!
extent: newExtent
	"Change my scale to fit myself into the given extent."
	self extent = newExtent ifTrue:[^self].
	self layoutChanged.
! !

!SMxSketchMorph methodsFor: 'accessing' stamp: ''!
form

	^ originalForm
! !

!SMxSketchMorph methodsFor: 'accessing' stamp: 'jmv 5/19/2009 23:25'!
form: aForm
	"Set the receiver's form"

	| oldForm |
	oldForm := originalForm.
	originalForm := aForm.
	self layoutChanged.

	oldForm ifNotNil: [self position: self position + (oldForm extent - aForm extent // 2)].
! !

!SMxSketchMorph methodsFor: 'initialization' stamp: 'jmv 10/11/2010 23:57'!
initialize

	^ self initializeWith: self class paintingIcon deepCopy.

! !

!SMxSketchMorph methodsFor: 'initialization' stamp: 'jmv 5/23/2009 00:09'!
initializeWith: aForm

	super initialize.
	originalForm := aForm.
	self extent: originalForm extent.
! !

!SMxSketchMorph methodsFor: 'layout' stamp: 'jmv 5/23/2009 00:05'!
layoutChanged
	"Update rotatedForm and compute new bounds."
	self changed.
	bounds := bounds origin extent: originalForm extent.
	super layoutChanged.
	self changed.
! !

SMxMorph subclass: #SMxStringMorph
	instanceVariableNames: 'font emphasis contents hasFocus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxStringMorph commentStamp: 'efc 3/7/2003 17:34' prior: 0!
SMxStringMorph is a "lightweight" SMxMorph to display a String. It supports only a single font, color, and emphasis combination. For multiple text styles, use SMxTextMorph.

Structure:
instance var    	Type              Description 
font 			StrikeFont 		(normally nil; then the accessor #font gives back TextStyle 
				or nil			defaultFont) 
emphasis 		SmallInteger	bitmask determining character attributes (underline, bold, 								italics, narrow, struckout) 
contents 		String 			The text that will be displayed. 
hasFocus 		Boolean 		Do I have the keyboard focus or not? 

If you shift-click on a SMxStringMorph you can edit its string. This is accomplished the following way: SMxStringMorph can launch a SMxStringMorphEditor if it receives a #mouseDown event.

A SMxStringMorph may also be used like a SMxSimpleButtonMorph to do an action when clicked. Use the menu 'extras' / 'add mouseUpAction'.

The following propery will be defined:
aStringMorph valueOfProperty: #mouseUpCodeToRun!

SMxStringMorph subclass: #SMxIndentingListItemMorph
	instanceVariableNames: 'indentLevel isExpanded complexContents firstChild container nextSibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Widgets'!

!SMxIndentingListItemMorph commentStamp: '<historical>' prior: 0!
An SMxIndentingListItemMorph is a SMxStringMorph that draws itself with an optional toggle at its left, as part of the display of the SMxSimpleHierarchicalListMorph.

It will also display lines around the toggle if the #showLinesInHierarchyViews SMxPreference is set.

Instance variables:

indentLevel <SmallInteger> 	the indent level, from 0 at the root and increasing by 1 at each level of the hierarchy.

isExpanded <Boolean>		true if this item is expanded (showing its children)

complexContents <ListItemWrapper>	an adapter wrapping my represented item that can answer its children, etc.
	
firstChild <SMxIndentingListItemMorph|nil>	my first child, or nil if none
	
container <SMxSimpleHierarchicalListMorph>	my container
	
nextSibling <SMxIndentingListItemMorph|nil>	the next item in the linked list of siblings, or nil if none.

Contributed by Bob Arning as part of the ObjectExplorer package.
Don't blame him if it's not perfect.  We wanted to get it out for people to play with.!

!SMxIndentingListItemMorph methodsFor: 'drag and drop' stamp: 'nk 6/12/2004 16:49'!
acceptDroppingMorph: toDrop event: evt
	complexContents acceptDroppingObject: toDrop complexContents.
	toDrop delete.
	self highlightForDrop: false.! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'RAA 7/30/2000 19:49'!
addChildrenForList: hostList addingTo: morphList withExpandedItems: expandedItems

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode delete].
	].
	firstChild := nil.
	complexContents hasContents ifFalse: [^self].
	firstChild := hostList 
		addMorphsTo: morphList
		from: complexContents contents 
		allowSorting: true
		withExpandedItems: expandedItems
		atLevel: indentLevel + 1.
	! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 7/21/2000 11:00'!
balloonText

	^complexContents balloonText ifNil: [super balloonText]! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 3/31/1999 17:44'!
canExpand

	^complexContents hasContents! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/26/2010 14:46'!
children
	| children |
	children := OrderedCollection new.
	self childrenDo: [:each | children add: each].
	^children! !

!SMxIndentingListItemMorph methodsFor: 'enumeration' stamp: 'panda 4/28/2000 15:29'!
childrenDo: aBlock

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aBlock value: aNode].
	]! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'RAA 7/11/1998 14:34'!
complexContents

	^complexContents! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 11:25'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge"

	| myBounds myCenter hLineY hLineLeft |
	self isSoleItem ifTrue: [ ^self ].
	myBounds := self toggleBounds.
	myCenter := myBounds center.
	hLineY := myCenter y.
	hasToggle
		ifTrue: [hLineLeft := myBounds right - 3]
		ifFalse: [hLineLeft := myCenter x - 1].
	"Draw line from toggle to text"
	aCanvas
		line: hLineLeft @ hLineY
		to: myBounds right + 0 @ hLineY
		width: 1
		color: lineColor! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 11:43'!
drawLinesOn: aCanvas lineColor: lineColor 
	| hasToggle |
	hasToggle := self hasToggle.
	"Draw line from toggle to text"
	self drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle.

	"Draw the line from my toggle to the nextSibling's toggle"
	self nextSibling ifNotNil: [ self drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle ].

	"If I have children and am expanded, draw a line to my first child"
	(self firstChild notNil and: [ self isExpanded ])
		ifTrue: [ self drawLinesToFirstChildOn: aCanvas lineColor: lineColor]! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 11:44'!
drawLinesToFirstChildOn: aCanvas lineColor: lineColor 
	"Draw line from me to next sibling"

	| vLineX vLineTop vLineBottom childBounds childCenter |
	childBounds := self firstChild toggleBounds.
	childCenter := childBounds center.
	vLineX := childCenter x - 1.
	vLineTop := bounds bottom.
	self firstChild hasToggle
		ifTrue: [vLineBottom := childCenter y - 7]
		ifFalse: [vLineBottom := childCenter y].
	aCanvas
		line: vLineX @ vLineTop
		to: vLineX @ vLineBottom
		width: 1
		color: lineColor! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'nk 3/8/2004 11:41'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom |
	myBounds := self toggleBounds.
	nextSibBounds := self nextSibling toggleBounds.
	myCenter := myBounds center.
	vLineX := myCenter x - 1.
	hasToggle
		ifTrue: [vLineTop := myCenter y + 5]
		ifFalse: [vLineTop := myCenter y].
	self nextSibling hasToggle
		ifTrue: [vLineBottom := nextSibBounds top + 2 ]
		ifFalse: [vLineBottom :=  nextSibBounds center y ].
	"Draw line from me to next sibling"
	aCanvas
		line: vLineX @ vLineTop
		to: vLineX @ vLineBottom
		width: 1
		color: lineColor! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/26/2010 14:47'!
drawOn: aCanvas

	| tRect sRect columnRect columnScanner columnData columnLeft colorToUse |

	tRect := self toggleRectangle.
	sRect := bounds withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	colorToUse := complexContents preferredColor ifNil: [color].
	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: colorToUse.
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns do: [ :width |
			columnRect := columnLeft @ sRect top extent: width @ sRect height.
			columnData := columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: colorToUse.
			].
			columnLeft := columnRect right + 5.
		].
	]
! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'nk 2/19/2004 18:19'!
drawToggleOn: aCanvas in: aRectangle

	| aForm centeringOffset |
	complexContents hasContents ifFalse: [^self].
	aForm := isExpanded 
		ifTrue: [container expandedForm]
		ifFalse: [container notExpandedForm].
	centeringOffset := ((aRectangle height - aForm extent y) / 2.0) rounded.
	^aCanvas 
		paintImage: aForm 
		at: (aRectangle topLeft translateBy: 0 @ centeringOffset).
! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 8/2/1999 16:48'!
firstChild

	^firstChild! !

!SMxIndentingListItemMorph methodsFor: 'private' stamp: 'nk 2/19/2004 18:29'!
hasToggle
	^ complexContents hasContents! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'RAA 8/3/1999 09:47'!
highlight

	complexContents highlightingColor ifNotNil: [self color: complexContents highlightingColor].
	self changed.
	
! !

!SMxIndentingListItemMorph methodsFor: 'mouse events' stamp: 'ar 3/17/2001 17:32'!
inToggleArea: aPoint

	^self toggleRectangle containsPoint: aPoint! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 7/30/2000 19:15'!
indentLevel

	^indentLevel! !

!SMxIndentingListItemMorph methodsFor: 'initialization' stamp: 'nop 2/10/2001 15:06'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	container := hostList.
	complexContents := anObject.
	self initWithContents: anObject asString font: SMxPreferences standardListFont emphasis: nil.
	indentLevel := 0.
	isExpanded := false.
 	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel := newLevel.
! !

!SMxIndentingListItemMorph methodsFor: 'initialization' stamp: 'RAA 7/15/1998 00:14'!
initialize

	super initialize.
	indentLevel := 0.
	isExpanded := false.! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 7/31/1998 00:30'!
isExpanded

	^isExpanded! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 7/31/1998 00:48'!
isExpanded: aBoolean

	isExpanded := aBoolean! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'nk 3/8/2004 09:14'!
isFirstItem
	^owner submorphs first == self! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'nk 3/8/2004 09:15'!
isSoleItem
	^self isFirstItem and: [ owner submorphs size = 1 ]! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 7/11/1998 12:15'!
nextSibling

	^nextSibling! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'RAA 8/1/1998 01:05'!
nextSibling: anotherMorph

	nextSibling := anotherMorph! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'tpr 11/27/2003 14:15'!
openPath: anArray

	anArray isEmpty ifTrue: [^container setSelectedMorph: nil].
	self withSiblingsDo: [:each | 
		(anArray first isNil or: [each complexContents asString = anArray first]) ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				container adjustSubmorphPositions.
			].
			each changed.
			anArray size = 1 ifTrue: [
				^container setSelectedMorph: each
			].
			each firstChild ifNil: [^container setSelectedMorph: nil].
			^each firstChild openPath: anArray allButFirst.
		].
	].
	^container setSelectedMorph: nil

! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'RAA 6/21/1999 14:54'!
recursiveAddTo: aCollection

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: aCollection].
	].
	aCollection add: self
	! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'RAA 4/2/1999 18:02'!
recursiveDelete

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveDelete].
	].
	self delete
	! !

!SMxIndentingListItemMorph methodsFor: 'private' stamp: 'nk 12/5/2002 15:16'!
toggleBounds
	^self toggleRectangle! !

!SMxIndentingListItemMorph methodsFor: 'private-container protocol' stamp: 'JuanVuletich 10/26/2010 14:46'!
toggleExpandedState
	| newChildren toDelete c |
	isExpanded := isExpanded not.
	toDelete := OrderedCollection new.
	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode |
			aNode recursiveAddTo: toDelete ]].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [ complexContents hasContents ]) ifFalse: [ ^ self changed ].
	(c := complexContents contents) isEmpty ifTrue: [ ^ self changed ].
	newChildren := container
		addSubmorphsAfter: self
		fromCollection: c
		allowSorting: true.
	firstChild := newChildren first.! !

!SMxIndentingListItemMorph methodsFor: 'private' stamp: 'RAA 7/29/2000 22:06'!
toggleRectangle

	| h |
	h := bounds height.
	^(bounds left + (12 * indentLevel)) @ bounds top extent: 12@h! !

!SMxIndentingListItemMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/26/2010 14:46'!
unhighlight

	complexContents highlightingColor ifNotNil: [self color: Color black].
	self changed.
	
	
! !

!SMxIndentingListItemMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/26/2010 14:46'!
userString
	"Add leading tabs to my userString"
	^ (String new: indentLevel withAll: Character tab), super userString
! !

!SMxIndentingListItemMorph methodsFor: 'private' stamp: 'RAA 7/11/1998 14:25'!
withSiblingsDo: aBlock

	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node nextSibling
	].! !

!SMxIndentingListItemMorph methodsFor: 'converting' stamp: 'RAA 3/31/1999 12:13'!
withoutListWrapper

	^complexContents withoutListWrapper! !

SMxStringMorph subclass: #SMxMenuItemMorph
	instanceVariableNames: 'isEnabled subMenu isSelected target selector arguments icon'
	classVariableNames: 'SubMenuMarker'
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxMenuItemMorph commentStamp: 'jmv 5/6/2009 22:52' prior: 0!
I represent an item in a menu.

Instance variables:
	isEnabled 	<Boolean>			True if the menu item can be executed.
	subMenu 	<SMxMenuMorph | nil>	The submenu to activate automatically when the user mouses over the item.
	isSelected 	<Boolean>			True if the item is currently selected.
	target 		<Object>			The target of the associated action.
	selector 	<Symbol>			The associated action.
	arguments 	<Array>			The arguments for the associated action.
	icon		<Form | nil>		An optional icon form to be displayed to my left.

If I have a dynamic marker, created by strings like <yes> or <no> in my contents, it will be installed as a submorph.!

!SMxMenuItemMorph class methodsFor: 'class initialization' stamp: 'jm 11/16/97 09:17'!
initialize
	"SMxMenuItemMorph initialize"

	| f |
	f := Form
		extent: 5@9
		fromArray: #(2147483648 3221225472 3758096384 4026531840 4160749568 4026531840 3758096384 3221225472 2147483648)
		offset: 0@0.
	SubMenuMarker := ColorForm mappingWhiteToTransparentFrom: f.
! !

!SMxMenuItemMorph methodsFor: 'grabbing' stamp: 'jmv 4/27/2010 11:29'!
aboutToBeGrabbedBy: aHand
	"Don't allow the receiver to act outside a Menu"
	| menu box |
	(owner notNil and:[owner submorphs size = 1]) ifTrue:[
		"I am a lonely menuitem already; just grab my owner"
		owner stayUp: true.
		^owner aboutToBeGrabbedBy: aHand].
	box := bounds.
	menu := SMxMenuMorph new defaultTarget: nil.
	menu addMorphFront: self.
	menu bounds: box.
	menu stayUp: true.
	self isSelected: false.
	^menu! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 10/10/2000 01:38'!
activateOwnerMenu: evt
	"Activate our owner menu; e.g., pass control to it"
	owner ifNil:[^false]. "not applicable"
	(owner fullContainsPoint: evt position) ifFalse:[^false].
	owner activate: evt.
	^true! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'jmv 5/15/2009 21:48'!
activateSubmenu: evt
	"Activate our submenu; e.g., pass control to it"
	subMenu ifNil:[^false]. "not applicable"
	(subMenu fullContainsPoint: evt position) ifFalse:[^false].
	subMenu activate: evt.
	self removeAlarm: #deselectTimeOut:.
	^true! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
arguments

	^ arguments
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
arguments: aCollection

	arguments := aCollection.
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'ar 1/16/2001 16:58'!
contentString
	^self valueOfProperty: #contentString! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jmv 3/2/2010 16:11'!
contentString: aString 
	aString 
		ifNil: [self removeProperty: #contentString]
		ifNotNil: [self setProperty: #contentString toValue: aString]! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'ar 9/17/2000 18:32'!
contents: aString
	^self contents: aString withMarkers: true! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'ar 1/16/2001 16:57'!
contents: aString withMarkers: aBool
	^self contents: aString withMarkers: aBool inverse: false! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'nk 3/10/2004 15:55'!
contents: aString withMarkers: aBool inverse: inverse 
	"Set the menu item entry. If aBool is true, parse aString for embedded markers."

	| markerIndex marker |
	self contentString: nil.	"get rid of old"
	aBool ifFalse: [^super contents: aString].
	self removeAllMorphs.	"get rid of old markers if updating"
	self hasIcon ifTrue: [ self icon: nil ].
	(aString notEmpty and: [aString first = $<]) 
		ifFalse: [^super contents: aString].
	markerIndex := aString indexOf: $>.
	markerIndex = 0 ifTrue: [^super contents: aString].
	marker := (aString copyFrom: 1 to: markerIndex) asLowercase.
	(#('<on>' '<off>' '<yes>' '<no>') includes: marker) 
		ifFalse: [^super contents: aString].
	self contentString: aString.	"remember actual string"
	marker := (marker = '<on>' or: [marker = '<yes>']) ~= inverse 
				ifTrue: [self onImage]
				ifFalse: [self offImage].
	super contents:  (aString copyFrom: markerIndex + 1 to: aString size).
	"And set the marker"
	marker := SMxImageMorph new image: marker.
	marker position: self left @ (self top + 2).
	self addMorphFront: marker! !

!SMxMenuItemMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 extent: 10 @ 10! !

!SMxMenuItemMorph methodsFor: 'initialization' stamp: 'ar 10/10/2000 02:05'!
deleteIfPopUp: evt
	"Recurse up for nested pop ups"
	owner ifNotNil:[owner deleteIfPopUp: evt].! !

!SMxMenuItemMorph methodsFor: 'selecting' stamp: 'jmv 5/15/2009 21:48'!
deselect: evt

	self isSelected: false.
	subMenu ifNotNil: [
		owner ifNotNil:[ owner activeSubmenu: nil ].
		self removeAlarm: #deselectTimeOut: ].! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'jmv 5/15/2009 21:48'!
deselectTimeOut: evt
	"Deselect timout. Now really deselect"
	owner selectedItem == self ifTrue:[owner selectItem: nil event: evt].! !

!SMxMenuItemMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:29'!
drawOn: aCanvas 
	| stringColor stringBounds leftEdge |

	stringColor := color.
	isSelected & isEnabled
		ifTrue: [
			aCanvas fillRectangle: bounds color: (
				Display depth < 8
					ifTrue: [ Color veryLightGray ]
					ifFalse: [ Color lightBlue ])].
	leftEdge := 0.
	self hasIcon
		ifTrue: [| iconForm | 
			iconForm := isEnabled ifTrue:[self icon] ifFalse:[self icon asGrayScale].
			aCanvas paintImage: iconForm at: self left @ (self top + (self height - iconForm height // 2)).
			leftEdge := iconForm width + 2].

	self hasMarker
		ifTrue: [ leftEdge := leftEdge + self submorphBounds width + 8 ].

	stringBounds := bounds left: bounds left + leftEdge.

	aCanvas
		drawString: contents
		in: stringBounds
		font: self fontToUse
		color: stringColor.
	subMenu
		ifNotNil: [aCanvas paintImage: SubMenuMarker at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)]! !

!SMxMenuItemMorph methodsFor: 'grabbing' stamp: 'jmv 4/27/2010 11:29'!
duplicateMorph: evt
	"Make and return a duplicate of the receiver's argument"
	| dup menu |
	dup := self duplicate isSelected: false.
	menu := SMxMenuMorph new defaultTarget: nil.
	menu addMorphFront: dup.
	menu bounds: bounds.
	menu stayUp: true.
	evt hand grabMorph: menu from: owner. "duplicate was ownerless so use #grabMorph:from: here"
	^menu! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 10/10/2000 22:45'!
handleMouseUp: anEvent
	"The handling of control between menu item requires them to act on mouse up even if not the current focus. This is different from the default behavior which really only wants to handle mouse ups when they got mouse downs before"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand releaseMouseFocus: self.
	anEvent wasHandled: true.
	anEvent blueButtonChanged
		ifTrue:[self blueButtonUp: anEvent]
		ifFalse:[self mouseUp: anEvent].! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'jm 11/4/97 07:15'!
handlesMouseDown: evt

	^ true
! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 9/16/2000 14:40'!
handlesMouseOver: anEvent
	^true! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 9/18/2000 21:46'!
handlesMouseOverDragging: evt
	^true! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'nk 3/10/2004 15:19'!
hasIcon
	"Answer whether the receiver has an icon."
	^ icon notNil! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'nk 3/10/2004 15:19'!
hasIconOrMarker
	"Answer whether the receiver has an icon or a marker."
	^ self hasIcon or: [ submorphs isEmpty not ]! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'nk 3/10/2004 15:25'!
hasMarker
	"Answer whether the receiver has a marker morph."
	^ submorphs isEmpty not! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'ar 9/18/2000 11:40'!
hasSubMenu
	"Return true if the receiver has a submenu"
	^subMenu notNil! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'dgd 3/22/2003 14:45'!
icon
	"answer the receiver's icon"
	^ icon! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'dgd 3/22/2003 14:45'!
icon: aForm 
	"change the the receiver's icon"
	icon := aForm! !

!SMxMenuItemMorph methodsFor: 'initialization' stamp: 'jmv 5/10/2009 10:23'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	contents := ''.
	isEnabled := true.
	subMenu := nil.
	isSelected := false.
	target := nil.
	selector := nil.
	arguments := nil.
	font := SMxPreferences standardMenuFont! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'jmv 5/17/2009 23:27'!
invokeWithEvent: evt
	"Perform the action associated with the given menu item."

	| selArgCount w |
	self isEnabled ifFalse: [^ self].
	owner ifNotNil: [
		self flag: #workAround. "The tile system invokes menus straightforwardly so the menu might not be in the world."
		(w := self world) ifNotNil:[
			owner deleteIfPopUp: evt.
			"Repair damage before invoking the action for better feedback"
			w displayWorldSafely]].
	selector ifNil:[^self].
	Cursor normal showWhile: [  "show cursor in case item opens a new MVC window"
		(selArgCount := selector numArgs) = 0
			ifTrue:
				[target perform: selector]
			ifFalse:
				[selArgCount = arguments size
					ifTrue: [target perform: selector withArguments: arguments]
					ifFalse: [target perform: selector withArguments: (arguments copyWith: evt)]]].! !

!SMxMenuItemMorph methodsFor: 'testing' stamp: 'JuanVuletich 10/22/2010 11:27'!
is: aSymbol
	^aSymbol == #answersminItemWidth or: [ super is: aSymbol ]! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
isEnabled

	^ isEnabled
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jmv 3/13/2009 10:04'!
isEnabled: aBoolean

	isEnabled = aBoolean ifTrue: [^ self].
	isEnabled := aBoolean.
	self color: (aBoolean ifTrue: [Color black] ifFalse: [Color gray]).
! !

!SMxMenuItemMorph methodsFor: 'selecting' stamp: 'ar 9/18/2000 11:09'!
isSelected: aBoolean

	isSelected := aBoolean.
	self changed.
! !

!SMxMenuItemMorph methodsFor: 'layout' stamp: 'jmv 5/14/2009 15:44'!
minItemWidth
	| fontToUse iconWidth subMenuWidth markerWidth |
	fontToUse := self fontToUse.
	subMenuWidth := self hasSubMenu
				ifFalse: [0]
				ifTrue: [10].
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	markerWidth := self hasMarker
		ifTrue: [ self submorphBounds width + 8 ]
		ifFalse: [ 0 ].
	^ (fontToUse widthOfString: contents)
		+ subMenuWidth + iconWidth + markerWidth.! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 10/10/2000 00:26'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt.! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'sw 10/3/2002 02:16'!
mouseEnter: evt
	"The mouse entered the receiver"

	owner ifNotNil: [owner stayUp ifFalse: [self mouseEnterDragging: evt]]! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 10/10/2000 00:24'!
mouseEnterDragging: evt
	"The mouse entered the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	evt hand mouseFocus == owner ifTrue:[owner selectItem: self event: evt]! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'sw 5/5/2001 00:25'!
mouseLeave: evt
	"The mouse has left the interior of the receiver..."

	owner ifNotNil: [owner stayUp ifFalse: [self mouseLeaveDragging: evt]]! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'jmv 3/2/2010 16:11'!
mouseLeaveDragging: evt 
	"The mouse left the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	owner ifNil: [^self].
	evt hand mouseFocus == owner ifFalse: [^self].
	"If we have a submenu, make sure we've got some time to enter it before actually leaving the menu item"
	subMenu 
		ifNil: [owner selectItem: nil event: evt]
		ifNotNil: [
			self 
				addAlarm: #deselectTimeOut:
				with: evt
				after: 500]! !

!SMxMenuItemMorph methodsFor: 'events' stamp: 'ar 1/16/2001 17:39'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	evt hand mouseFocus == owner ifFalse:[^self].
	self contentString ifNotNil:[
		self contents: self contentString withMarkers: true inverse: true.
		self refreshWorld.
		(Delay forMilliseconds: 200) wait].
	self deselect: evt.
	self invokeWithEvent: evt.		
! !

!SMxMenuItemMorph methodsFor: 'private' stamp: 'ar 9/17/2000 18:36'!
offImage
	"Return the form to be used for indicating an '<off>' marker"
	| form |
	form := Form extent: (self fontToUse ascent-2) asPoint depth: 16.
	(form getCanvas)
		frameAndFillRectangle: form boundingBox fillColor: (Color gray: 0.9) 
			borderWidth: 1 borderColor: Color black.
	^form! !

!SMxMenuItemMorph methodsFor: 'private' stamp: 'jmv 8/26/2008 11:42'!
onImage
	"Return the form to be used for indicating an '<off>' marker"
	| form |
	form := Form extent: (self fontToUse ascent-2) asPoint depth: 16.
	(form getCanvas)
		frameAndFillRectangle: form boundingBox fillColor: (Color gray: 0.8) 
			borderWidth: 1 borderColor: Color black;
		fillRectangle: (form boundingBox insetBy: 2) color: Color black.
	^form! !

!SMxMenuItemMorph methodsFor: 'selecting' stamp: 'jmv 4/27/2010 11:34'!
select: evt
	self isSelected: true.
	owner activeSubmenu: subMenu.
	subMenu ifNotNil: [
		subMenu delete.
		subMenu
			popUpAdjacentTo: (Array with: bounds topRight + (10@0)
									with: bounds topLeft)
			forHand: evt hand
			from: self.
		subMenu selectItem: nil event: evt].! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
selector

	^ selector
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
selector: aSymbol

	selector := aSymbol.
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
subMenu

	^ subMenu
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jmv 5/15/2009 21:58'!
subMenu: aMenuMorph
	subMenu := aMenuMorph.
	self changed.
! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
target

	^ target! !

!SMxMenuItemMorph methodsFor: 'accessing' stamp: 'jm 11/4/97 07:46'!
target: anObject

	target := anObject.
! !

!SMxMenuItemMorph methodsFor: 'copying' stamp: 'jmv 3/2/2010 17:07'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

	super veryDeepFixupWith: deepCopier.
	target := deepCopier references at: target ifAbsent: [target].
	arguments ifNotNil: [
	arguments := arguments collect: [:each |
		deepCopier references at: each ifAbsent: [each]]]! !

!SMxMenuItemMorph methodsFor: 'copying' stamp: 'dgd 3/22/2003 14:56'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied  
	at all, but shared. Warning!!!! Every instance variable defined in  
	this class must be handled. We must also implement  
	veryDeepFixupWith:. See DeepCopier class comment."
	super veryDeepInner: deepCopier.
	isEnabled := isEnabled veryDeepCopyWith: deepCopier.
	subMenu := subMenu veryDeepCopyWith: deepCopier.
	isSelected := isSelected veryDeepCopyWith: deepCopier.
	icon := icon veryDeepCopyWith: deepCopier.
	"target := target.		Weakly copied"
	"selector := selector.		a Symbol"
	arguments := arguments! !

SMxMenuItemMorph subclass: #SMxUpdatingMenuItemMorph
	instanceVariableNames: 'wordingProvider wordingSelector enablementSelector wordingArgument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Menus'!

!SMxUpdatingMenuItemMorph commentStamp: '<historical>' prior: 0!
A menu item whose textual label and whose enablement are updatable.  The wordingProvider provides the current wording, upon being being sent the wordingSelector.

The item can also dynamically update whether or not it should be enabled; to do this, give it an enablementSelector, which is also sent to the wordingProvider..!

!SMxUpdatingMenuItemMorph methodsFor: 'stepping and presenter' stamp: 'ar 10/7/2000 15:35'!
arrangeToStartSteppingIn: aWorld
	super arrangeToStartSteppingIn: aWorld.
	self updateContents.! !

!SMxUpdatingMenuItemMorph methodsFor: 'enablement' stamp: 'ajh 1/21/2003 13:17'!
enablement 

	enablementSelector isBlock
		ifTrue: [^ enablementSelector value]
		ifFalse: [enablementSelector numArgs = 0
				ifTrue: [^ wordingProvider perform: enablementSelector]
				ifFalse: [^ wordingProvider perform: enablementSelector
										withArguments: arguments]]! !

!SMxUpdatingMenuItemMorph methodsFor: 'enablement' stamp: 'eem 7/21/2008 12:07'!
enablementSelector: aSelector 
	enablementSelector := aSelector isBlock 
				ifTrue: [aSelector copyForSaving]
				ifFalse: [aSelector] ! !

!SMxUpdatingMenuItemMorph methodsFor: 'stepping and presenter' stamp: 'ar 10/7/2000 15:34'!
step
	super step.
	self updateContents.! !

!SMxUpdatingMenuItemMorph methodsFor: 'testing' stamp: 'sw 6/11/1999 18:31'!
stepTime
	^ 1200! !

!SMxUpdatingMenuItemMorph methodsFor: 'world' stamp: 'jmv 12/8/2008 15:42'!
updateContents
	"Update the receiver's contents"

	| newString enablement nArgs |
	((wordingProvider isNil) or: [wordingSelector isNil]) ifTrue: [^ self].
	nArgs := wordingSelector numArgs.
	newString := nArgs = 0
		ifTrue:
			[wordingProvider perform: wordingSelector]
		ifFalse:
			[(nArgs = 1 and: [wordingArgument notNil])
				ifTrue:
					[wordingProvider perform: wordingSelector with: wordingArgument]
				ifFalse:
					[nArgs = arguments size ifTrue:
						[wordingProvider perform: wordingSelector withArguments: arguments]]].
	newString = (self contentString ifNil: [ contents ])
		ifFalse: [self contents: newString.
			SMxMenuIcons decorateMenu: owner ].
	enablementSelector ifNotNil:
		[(enablement := self enablement) == isEnabled 
			ifFalse:	[self isEnabled: enablement]]! !

!SMxUpdatingMenuItemMorph methodsFor: 'wording' stamp: 'sw 11/6/2000 09:55'!
wordingArgument: anArgument
	"Set the receiver's wordingArgument as indicated"

	wordingArgument := anArgument! !

!SMxUpdatingMenuItemMorph methodsFor: 'wording' stamp: 'sw 6/11/1999 15:12'!
wordingProvider: aProvider wordingSelector: aSelector
	wordingProvider := aProvider.
	wordingSelector := aSelector! !

!SMxStringMorph class methodsFor: 'instance creation' stamp: 'sw 8/22/97 22:19'!
contents: aString
	" 'SMxStringMorph contents: str' is faster than 'SMxStringMorph new contents: str' "
	^ self contents: aString font: nil! !

!SMxStringMorph class methodsFor: 'instance creation' stamp: 'di 4/1/1999 17:15'!
contents: aString font: aFont
	^ self basicNew initWithContents: aString font: aFont emphasis: 0! !

!SMxStringMorph class methodsFor: 'instance creation' stamp: 'di 4/1/1999 17:15'!
contents: aString font: aFont emphasis: emphasisCode
	^ self basicNew initWithContents: aString font: aFont emphasis: emphasisCode! !

!SMxStringMorph methodsFor: 'editing' stamp: ''!
acceptContents
	"The message is sent when the user hits enter or Cmd-S. Accept the current contents and end editing. This default implementation does nothing."
! !

!SMxStringMorph methodsFor: 'editing' stamp: 'sw 9/8/1999 17:04'!
acceptValue: aValue
	| val |
	self contents: (val := aValue asString).
	^ val! !

!SMxStringMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'change font' translated action: #changeFont.
	aCustomMenu add: 'change emphasis' translated action: #changeEmphasis.
! !

!SMxStringMorph methodsFor: 'halos and balloon help' stamp: 'sw 6/15/1998 15:34'!
addOptionalHandlesTo: aHalo box: box
	self flag: #deferred.

	"Eventually...
	self addFontHandlesTo: aHalo box: box"! !

!SMxStringMorph methodsFor: 'editing' stamp: 'sw 9/17/1999 13:27'!
cancelEdits

	self doneWithEdits! !

!SMxStringMorph methodsFor: 'menu' stamp: 'JuanVuletich 10/12/2010 23:47'!
changeEmphasis

	| reply aList |
	aList := #(normal bold italic narrow underlined struckOut).
	reply := (SMxSelectionMenu labelList: aList selections: aList) startUp.
	reply ifNotNil:[
		self emphasis: (TextEmphasis perform: reply) emphasisCode.
	].
! !

!SMxStringMorph methodsFor: 'menu' stamp: 'ar 1/5/2002 21:45'!
changeFont
	| newFont |
	newFont := StrikeFont fromUser: self fontToUse.
	newFont ifNotNil:[self font: newFont].! !

!SMxStringMorph methodsFor: 'accessing' stamp: ''!
contents

	^ contents! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'JuanVuletich 10/12/2010 23:38'!
contents: newContents
	contents := newContents isText
		ifTrue: [
			emphasis := newContents emphasisAt: 1.
			 newContents string ]
		ifFalse: [
			contents = newContents ifTrue: [ ^self ].	"no substantive change"
			newContents].
	self fitContents! !

!SMxStringMorph methodsFor: 'accessing' stamp: ''!
contentsClipped: aString
	"Change my text, but do not change my size as a result"
	contents = aString ifTrue: [^ self].  "No substantive change"
	contents := aString.
	self changed! !

!SMxStringMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!SMxStringMorph methodsFor: 'editing' stamp: 'di 9/6/1999 22:44'!
doneWithEdits

	hasFocus := false! !

!SMxStringMorph methodsFor: 'drawing' stamp: 'ar 12/31/2001 02:38'!
drawOn: aCanvas

	aCanvas drawString: contents in: bounds font: self fontToUse color: color.! !

!SMxStringMorph methodsFor: 'font' stamp: 'efc 2/22/2003 21:35'!
emphasis: aNumber
	"Set the receiver's emphasis as indicated. aNumber is a bitmask with the following format:

	bit	attribute
	1	bold
	2	italic
	4	underlined
	8	narrow
	16	struckOut"

	"examples: 0 -> plain.  
	1 -> bold.  2 -> italic.  3 -> bold italic.  4 -> underlined  
	5 -> bold underlined.  6 -> italic underlined.   7 -> bold italic underlined   
	etc..."

	emphasis := aNumber.
	^ self font: font emphasis: emphasis! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 02:44'!
fitContents

	| newBounds boundsChanged |
	newBounds := self measureContents.
	boundsChanged := bounds extent ~= newBounds.
	self extent: newBounds.		"default short-circuits if bounds not changed"
	boundsChanged ifFalse: [self changed]! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'ar 1/31/2001 19:33'!
font
	"who came up with #fontToUse rather than font?!!"
	^self fontToUse! !

!SMxStringMorph methodsFor: 'printing' stamp: 'efc 2/22/2003 21:35'!
font: aFont 
	"Set the font my text will use. The emphasis remains unchanged."

	font := aFont.
	^ self font: font emphasis: emphasis! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'di 4/2/1999 16:11'!
font: aFont emphasis: emphasisCode
	font := aFont.
	emphasis := emphasisCode.
	self fitContents.
"
in inspector say,
	 self font: (TextStyle default fontAt: 2) emphasis: 1
"! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'jmv 3/2/2010 16:38'!
fontToUse
	| fontToUse |
	fontToUse := font ifNil: [StrikeFont default].
	^(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [ fontToUse]
		ifFalse: [ fontToUse emphasized: emphasis]! !

!SMxStringMorph methodsFor: 'event handling' stamp: 'jmv 11/10/2008 13:53'!
handlesMouseDown: evt

	^ (evt shiftPressed and: [self userEditsAllowed]) 
		or: [super handlesMouseDown: evt]! !

!SMxStringMorph methodsFor: 'event handling' stamp: 'sw 9/8/1999 11:26'!
hasFocus
	^ hasFocus! !

!SMxStringMorph methodsFor: 'initialization' stamp: 'jmv 11/10/2008 13:21'!
initWithContents: aString font: aFont emphasis: emphasisCode 
	self initialize.
	
	font := aFont.
	emphasis := emphasisCode.
	self contents: aString! !

!SMxStringMorph methodsFor: 'initialization' stamp: 'jmv 9/12/2009 21:08'!
initialize
	super initialize.
	font := nil.
	emphasis := 0.
	hasFocus := false.
	self contents: 'String SMxMorph'
! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'sw 9/8/1999 11:10'!
interimContents: aString
	"The receiver is under edit and aString represents the string the user sees as she edits, which typically will not have been accepted and indeed may be abandoned"

	self contents: aString! !

!SMxStringMorph methodsFor: 'editing' stamp: 'JuanVuletich 10/13/2010 09:11'!
launchMiniEditor: evt 
	| textMorph |
	hasFocus := true.	"Really only means edit in progress for this morph"
	textMorph := SMxStringMorphEditor new contentsAsIs: 
		(Text initialFont: self fontToUse stringOrText: contents).
	textMorph bounds: (bounds expandBy: 0 @ 2).
	self addMorphFront: textMorph.
	evt hand newMouseFocus: textMorph.
	self flag: #arNote.	"Why???"
"
	evt hand newKeyboardFocus: textMorph."
	textMorph editor selectFrom: 1 to: textMorph paragraph text string size! !

!SMxStringMorph methodsFor: 'editing' stamp: 'sw 9/8/1999 10:42'!
lostFocusWithoutAccepting
	"The message is sent when the user, having been in an editing episode on the receiver, changes the keyboard focus -- typically by clicking on some editable text somewhere else -- without having accepted the current edits."

	self acceptContents! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'ar 12/30/2001 20:45'!
measureContents
	| f |
	f := self fontToUse.
	^(((f widthOfString: contents) max: self minimumWidth)  @ f height).! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'sw 9/8/1999 13:44'!
minimumWidth
	"Answer the minimum width that the receiver can have.  A nonzero value here keeps the receiver from degenerating into something that cannot ever be seen or touched again!!  Obeyed by fitContents."

	^ 3! !

!SMxStringMorph methodsFor: 'event handling' stamp: 'jmv 11/10/2008 12:34'!
mouseDown: evt
	"If the shift key is pressed, make this string the keyboard input focus."

	(evt shiftPressed and: [self userEditsAllowed])
		ifTrue: [self launchMiniEditor: evt]
		ifFalse: [super mouseDown: evt].
! !

!SMxStringMorph methodsFor: 'printing' stamp: 'jm 11/3/97 16:52'!
printOn: aStream

	super printOn: aStream.
	aStream print: contents.
! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'jmv 7/27/2009 17:49'!
setWidth: width

	self extent: width @ (font ifNil: [StrikeFont default]) height! !

!SMxStringMorph methodsFor: 'event handling' stamp: 'jmv 11/10/2008 12:31'!
userEditsAllowed
	"Answer whether user-edits are allowed to this field"

	^ self isLocked not! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'tk 12/16/1998 11:55'!
userString
	"Do I have a text string to be searched on?"

	^ contents! !

!SMxStringMorph methodsFor: 'accessing' stamp: 'sw 9/16/1999 22:57'!
valueFromContents
	"Return a new value from the current contents string."
	^ contents! !

SMxMorph subclass: #SMxTransformMorph
	instanceVariableNames: 'localBounds txOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Basic'!

!SMxTransformMorph commentStamp: 'efc 7/24/2003 17:01' prior: 0!
A SMxTransformMorph introduces a 2-D transformation between its (global) coordinates and the (local) coordinates of its submorphs, while also clipping all display to its bounds.  Specifically, with no offset, angle or scaling, a submorph with coordinates (0@0) will appear exactly at the topLeft of the windowMorph (its position).  Rotation and scaling are relative to the local origin, (0@0).

instance var	type				description
 transform		MorphicTransform	The coordinate transform between my coordinates and the
									local coordinates of my submorphs.
 smoothing		Boolean 			Perform smoothing of my contents during drawing
 localBounds	Rectangle or nil		caches the value of #localSubmorphBounds for performance

TransformMorphs operate with two different display strategies, depending on whether the transformation is a pure translation or not.  If so, then they simply use a clipping canvas and display their submorphs with the appropriate offset.  If the transformation includes scaling or rotation, then a caching canvas is used, whose active area covers the fullBounds of the submorphs intersected with the source quadrilateral corresponding to the window bounds.!

!SMxTransformMorph methodsFor: 'accessing' stamp: 'di 2/23/98 14:44'!
colorForInsets
	^ owner ifNil: [color] ifNotNil: [owner color]! !

!SMxTransformMorph methodsFor: 'geometry testing' stamp: 'jmv 3/11/2010 13:31'!
containsPoint: aPoint
	(bounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"
	self hasSubmorphs
		ifTrue: [
			self submorphsDo: [ :m |
				(m containsPoint: aPoint + self txOffset)
					ifTrue: [^ true]].
			^ false]
		ifFalse: [^ true]! !

!SMxTransformMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGreen! !

!SMxTransformMorph methodsFor: 'layout' stamp: 'jmv 4/27/2010 11:03'!
doLayoutIfNeeded
	"Overridden to do nothing, just as #fullBounds"! !

!SMxTransformMorph methodsFor: 'drawing' stamp: 'jmv 3/11/2010 13:30'!
drawSubmorphsOn: aCanvas

	| clippedCanvas |
	clippedCanvas := aCanvas
		copyOffset: self txOffset negated truncated
		clipRect: self innerBounds.

	submorphs reverseDo: [ :m | clippedCanvas fullDrawMorph: m]! !

!SMxTransformMorph methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:45'!
externalizePosition: pointInSelf to: aReferenceMorph
	"aPoint is in our coordinate system
	answer is in aReferenceMorph's coordinateSystem"

	| pointInOwner |
	self == aReferenceMorph
		ifTrue: [ ^pointInSelf ].

	pointInOwner := pointInSelf - self txOffset.
	
	"This might actually indicate an error condition. For now, just answer something!!"
	owner ifNil: [
		^pointInOwner ].
	
	^owner externalizePosition: pointInOwner to: aReferenceMorph! !

!SMxTransformMorph methodsFor: 'layout' stamp: 'jmv 9/12/2009 23:08'!
fullBounds
	"Overridden to clip submorph hit detection to my bounds."
	"It might be better to override doLayoutIn:, and remove this method"

	fullBounds ifNotNil: [ ^fullBounds ].
	fullBounds := bounds.
	^fullBounds! !

!SMxTransformMorph methodsFor: 'initialization' stamp: 'jmv 3/11/2010 17:30'!
initialize
	"initialize the state of the receiver"
	super initialize.
	txOffset := 0@0! !

!SMxTransformMorph methodsFor: 'geometry' stamp: 'JuanVuletich 11/1/2010 15:45'!
internalizePosition: pointInReferenceMorph from: aReferenceMorph
	"aPoint is in aReferenceMorph's coordinateSystem
	answer is in our coordinate system"

	| pointInOwner |
	self == aReferenceMorph
		ifTrue: [
			^pointInReferenceMorph + self txOffset].

	"This might actually indicate an error condition. For now, just answer something!!"
	owner ifNil: [
		^pointInReferenceMorph + self txOffset].
	pointInOwner := owner internalizePosition: pointInReferenceMorph from: aReferenceMorph.

	^ pointInOwner + self txOffset! !

!SMxTransformMorph methodsFor: 'change reporting' stamp: 'jmv 3/11/2010 13:34'!
invalidRect: damageRect from: aMorph
	"Translate damage reports from submorphs by the scrollOffset."
	aMorph == self
		ifTrue:[super invalidRect: damageRect from: self]
		ifFalse:[super invalidRect: (((damageRect translateBy: self txOffset negated) intersect: bounds) expandBy: 1) from: self].! !

!SMxTransformMorph methodsFor: 'geometry' stamp: 'efc 7/24/2003 16:43'!
layoutChanged

	"A submorph could have moved, thus changing my localBounds. Invalidate the cache."
	localBounds := nil.

	^super layoutChanged! !

!SMxTransformMorph methodsFor: 'geometry' stamp: 'efc 7/24/2003 16:41'!
localSubmorphBounds
	"Answer, in my coordinate system, the bounds of all my submorphs (or nil if no submorphs). We will cache this value for performance. The value is invalidated upon recieving #layoutChanged."

	localBounds ifNil:[
		self submorphsDo:[:m |
			localBounds ifNil: [localBounds := m fullBounds]
						ifNotNil: [localBounds := localBounds quickMerge: m fullBounds]].
	].	

	^ localBounds! !

!SMxTransformMorph methodsFor: 'accessing' stamp: 'jmv 3/11/2010 13:29'!
offset
	^ self txOffset + self innerBounds topLeft! !

!SMxTransformMorph methodsFor: 'accessing' stamp: 'jmv 3/11/2010 15:10'!
offset: newOffset
	| o |
	o := newOffset - self innerBounds topLeft.
	txOffset = o ifFalse: [
		txOffset := o.
		self changed ]! !

!SMxTransformMorph methodsFor: 'private' stamp: 'jmv 3/11/2010 17:46'!
privateFullMoveBy: delta
	"Private!! Relocate me, but not my subMorphs."

	self privateMoveBy: delta.
	txOffset := txOffset - delta! !

!SMxTransformMorph methodsFor: 'accessing' stamp: 'jmv 3/11/2010 17:46'!
txOffset
	^txOffset! !

Object subclass: #SMxMorphExtension
	instanceVariableNames: 'layoutSpec eventHandler otherProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxMorphExtension commentStamp: '<historical>' prior: 0!
SMxMorphExtension provides access to extra instance state that is not required in most simple morphs.  This allows simple morphs to remain relatively lightweight while still admitting more complex structures as necessary.  The otherProperties field takes this policy to the extreme of allowing any number of additional named attributes, albeit at a certain cost in speed and space.!

!SMxMorphExtension methodsFor: 'private' stamp: 'jmv 8/23/2010 13:09'!
assureOtherProperties
	"creates an otherProperties for the receiver if needed"
	otherProperties ifNil: [ otherProperties := IdentityDictionary new ].
	^ otherProperties! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:38'!
balloonText
	^self valueOfProperty: #balloonText ifAbsent: nil! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:39'!
balloonText: newValue
	newValue
		ifNil: [ self removeProperty: #balloonText ]
		ifNotNil: [ self setProperty: #balloonText toValue: newValue ]! !

!SMxMorphExtension methodsFor: 'objects from disk' stamp: 'jmv 8/23/2010 13:28'!
comeFullyUpOnReload: smartRefStream
	"inst vars have default booplean values."

	^ self! !

!SMxMorphExtension methodsFor: 'accessing - basic properties' stamp: 'di 8/10/1998 12:54'!
eventHandler
	^ eventHandler! !

!SMxMorphExtension methodsFor: 'accessing - basic properties' stamp: 'di 8/10/1998 12:56'!
eventHandler: newValue
	eventHandler := newValue! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'jmv 8/23/2010 13:10'!
hasProperty: aSymbol
	"Answer whether the receiver has the property named aSymbol"
	| property |
	otherProperties ifNil: [ ^ false ].
	property := otherProperties
		at: aSymbol
		ifAbsent: nil.
	property ifNil: [ ^ false ].
	property == false ifTrue: [ ^ false ].
	^ true! !

!SMxMorphExtension methodsFor: 'initialization' stamp: 'jmv 8/23/2010 13:27'!
initialize
	"Init all booleans to default values"
! !

!SMxMorphExtension methodsFor: 'other' stamp: 'jmv 8/23/2010 11:53'!
inspectElement
	"Create and schedule an Inspector on the otherProperties and the 
	named properties."
	| key obj |
	key := (SMxSelectionMenu selections: self sortedPropertyNames) startUpWithCaption: 'Inspect which property?'.
	key ifNil: [ ^ self ].
	obj := otherProperties
		at: key
		ifAbsent: [ 'nOT a vALuE' ].
	obj = 'nOT a vALuE'
		ifTrue: [ (self perform: key) inspect
			"named properties" ]
		ifFalse: [ obj inspect ].! !

!SMxMorphExtension methodsFor: 'other' stamp: 'jmv 8/23/2010 13:37'!
isDefault
	"Return true if the receiver is a default and can be omitted"
	layoutSpec ifNotNil: [ ^ false ].
	eventHandler ifNotNil: [ ^ false ].
	otherProperties ifNotNil: [
		otherProperties isEmpty ifFalse: [ ^ false ]].
	^ true.! !

!SMxMorphExtension methodsFor: 'accessing - basic properties' stamp: 'JuanVuletich 10/22/2010 10:48'!
layoutFrame
	^ layoutSpec! !

!SMxMorphExtension methodsFor: 'accessing - basic properties' stamp: 'jmv 8/23/2010 13:31'!
layoutFrame: aLayoutFrame 

	layoutSpec := aLayoutFrame! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:27'!
locked
	^self valueOfProperty: #locked ifAbsent: [ false ]! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:27'!
locked: aBoolean
	aBoolean
		ifFalse: [ self removeProperty: #locked ]
		ifTrue: [ self setProperty: #locked toValue: aBoolean ]! !

!SMxMorphExtension methodsFor: 'printing' stamp: 'jmv 8/23/2010 13:37'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that 
	identifies the receiver."
	super printOn: aStream.
	aStream nextPutAll: ' ' , self identityHashPrintString.
	layoutSpec ifNotNil: [ aStream nextPutAll: ' [layoutSpec = ] ' , layoutSpec printString , '] ' ].
	eventHandler ifNotNil: [ aStream nextPutAll: ' [eventHandler = ' , eventHandler printString , '] ' ].
	(otherProperties isNil or: [ otherProperties isEmpty ]) ifTrue: [ ^ self ].
	aStream nextPutAll: ' [other: '.
	otherProperties keysDo: [ :aKey |
		aStream nextPutAll: ' (' , aKey , ' -> ' , (otherProperties at: aKey) printString , ')' ].
	aStream nextPut: $].! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'jmv 8/23/2010 13:10'!
removeProperty: aSymbol
	"removes the property named aSymbol if it exists"
	otherProperties ifNil: [ ^ self ].
	otherProperties
		removeKey: aSymbol
		ifAbsent: nil.
	otherProperties isEmpty ifTrue: [ otherProperties := nil ]! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'dgd 2/16/2003 21:49'!
setProperty: aSymbol toValue: abObject 
	"change the receiver's property named aSymbol to anObject"
	self assureOtherProperties at: aSymbol put: abObject! !

!SMxMorphExtension methodsFor: 'private' stamp: 'jmv 8/23/2010 13:38'!
sortedPropertyNames
	"answer the receiver's property names in a sorted way"
	| props |
	props := WriteStream on: (Array new: 10).
	layoutSpec ifNotNil: [ props nextPut: #layoutSpec ].
	eventHandler ifNotNil: [ props nextPut: #eventHandler ].
	otherProperties ifNotNil: [
		otherProperties associationsDo: [ :a |
			props nextPut: a key ]].
	^ props contents sort: [ :s1 :s2 |
		s1 <= s2 ]! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:13'!
sticky
	^self valueOfProperty: #sticky ifAbsent: [ false ]! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:14'!
sticky: aBoolean
	aBoolean
		ifFalse: [ self removeProperty: #sticky ]
		ifTrue: [ self setProperty: #sticky toValue: aBoolean ]! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'jmv 3/2/2010 09:59'!
valueOfProperty: propName 
	^ self valueOfProperty: propName ifAbsent: nil! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'jmv 8/23/2010 13:10'!
valueOfProperty: aSymbol ifAbsent: aBlock
	"if the receiver possesses a property of the given name, answer  
	its value. If not then evaluate aBlock and answer the result of  
	this block evaluation"
	otherProperties ifNil: [ ^ aBlock value ].
	^ otherProperties
		at: aSymbol
		ifAbsent: [ ^ aBlock value ].! !

!SMxMorphExtension methodsFor: 'accessing - other properties' stamp: 'dgd 2/16/2003 21:28'!
valueOfProperty: aSymbol ifAbsentPut: aBlock 
	"If the receiver possesses a property of the given name, answer  
	its value. If not, then create a property of the given name, give 
	it the value obtained by evaluating aBlock, then answer that  
	value"
	^self assureOtherProperties at: aSymbol ifAbsentPut: aBlock! !

!SMxMorphExtension methodsFor: 'copying' stamp: 'jmv 8/23/2010 13:36'!
veryDeepInner: deepCopier
	"Copy all of my instance variables. Some need to be not copied at 
	all, but shared. This is special code for the dictionary. See  
	DeepCopier."
	super veryDeepInner: deepCopier.
	eventHandler := eventHandler veryDeepCopyWith: deepCopier.
	otherProperties ifNotNil: [
		"This copies all of them. If there are some that should not be copied, handle them here.
		See for example how Squeak does it"
		otherProperties := otherProperties veryDeepCopyWith: deepCopier ].! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:16'!
visible
	^self valueOfProperty: #visible ifAbsent: [ true ]! !

!SMxMorphExtension methodsFor: 'accessing - optional properties' stamp: 'jmv 8/23/2010 13:26'!
visible: aBoolean
	aBoolean
		ifTrue: [ self removeProperty: #visible ]
		ifFalse: [ self setProperty: #visible toValue: aBoolean ]! !

Object subclass: #SMxMorphicEvent
	instanceVariableNames: 'timeStamp source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMorphicEvent commentStamp: '<historical>' prior: 0!
This class represents the base for all events.

Instance variables:
	stamp	<Integer>	The millisecond clock time stamp (based on Time millisecondClock)
	source	<Hand | nil>	If non-nil the hand that generated the event.!

SMxMorphicEvent subclass: #SMxDropEvent
	instanceVariableNames: 'position contents wasHandled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 18:33'!
contents
	^contents! !

!SMxDropEvent methodsFor: 'initialize' stamp: 'ar 10/10/2000 01:19'!
copyHandlerState: anEvent
	"Copy the handler state from anEvent. Used for quickly transferring handler information between transformed events."
	wasHandled := anEvent wasHandled.! !

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 19:21'!
cursorPoint
	"For compatibility with mouse events"
	^position! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:57'!
externalizeFromOwnerOf: targetMorph to: outerMorph
	"Transform from the receiver owner's to an outer coordinate system (outerMorph)."
	position :=  targetMorph externalizePositionFromOwner: position to: outerMorph! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:58'!
externalizedFromOwnerOf: targetMorph to: outerMorph
	"Return a new event, transformed from the receiver owner's to an outer coordinate system (outerMorph)."
	^self shallowCopy externalizeFromOwnerOf: targetMorph to: outerMorph! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:58'!
internalizeTo: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph's)."
	position :=  targetMorph internalizePosition: position from: outerMorph! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:59'!
internalizeToOwnerOf: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph onwer's)."
	position :=  targetMorph internalizePositionToOwner: position from: outerMorph! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:01'!
internalizedTo: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph's)."
	^self shallowCopy internalizeTo: targetMorph from: outerMorph! !

!SMxDropEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:02'!
internalizedToOwnerOf: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph owner's)."
	^self shallowCopy internalizeToOwnerOf: targetMorph from: outerMorph! !

!SMxDropEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 18:33'!
isDropEvent
	^true! !

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 18:33'!
position
	^position! !

!SMxDropEvent methodsFor: 'printing' stamp: 'ar 9/14/2000 18:15'!
printOn: aStream

	aStream nextPut: $[.
	aStream nextPutAll: self position printString; space.
	aStream nextPutAll: self type.
	aStream nextPut: $].! !

!SMxDropEvent methodsFor: 'initialize' stamp: 'ar 10/10/2000 01:18'!
resetHandlerFields
	"Reset anything that is used to cross-communicate between two eventual handlers during event dispatch"
	wasHandled := false.! !

!SMxDropEvent methodsFor: 'dispatching' stamp: 'ar 1/10/2001 21:24'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	self type == #dropEvent ifTrue:[^anObject handleDropMorph: self].! !

!SMxDropEvent methodsFor: 'private' stamp: 'ar 9/13/2000 19:23'!
setPosition: pos contents: aMorph hand: aHand
	position := pos.
	contents := aMorph.
	source := aHand.
	wasHandled := false.! !

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 18:33'!
type
	^#dropEvent! !

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 18:44'!
wasHandled
	^wasHandled! !

!SMxDropEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 18:44'!
wasHandled: aBool
	wasHandled := aBool.! !

!SMxMorphicEvent class methodsFor: 'instance creation' stamp: 'ar 10/26/2000 00:49'!
readFrom: aStream
	"Read a SMxMorphicEvent from the given stream."
	| typeString c |
	typeString := String streamContents:
		[:s |   [(c := aStream next) isLetter] whileTrue: [s nextPut: c]].
	typeString = 'mouseMove' ifTrue:[^SMxMouseMoveEvent type: #mouseMove readFrom: aStream].
	typeString = 'mouseDown' ifTrue:[^SMxMouseButtonEvent type: #mouseDown readFrom: aStream].
	typeString = 'mouseUp' ifTrue:[^SMxMouseButtonEvent type: #mouseUp readFrom: aStream].

	typeString = 'keystroke' ifTrue:[^SMxKeyboardEvent type: #keystroke readFrom: aStream].
	typeString = 'keyDown' ifTrue:[^SMxKeyboardEvent type: #keyDown readFrom: aStream].
	typeString = 'keyUp' ifTrue:[^SMxKeyboardEvent type: #keyUp readFrom: aStream].

	typeString = 'mouseOver' ifTrue:[^SMxMouseEvent type: #mouseOver readFrom: aStream].
	typeString = 'mouseEnter' ifTrue:[^SMxMouseEvent type: #mouseEnter readFrom: aStream].
	typeString = 'mouseLeave' ifTrue:[^SMxMouseEvent type: #mouseLeave readFrom: aStream].

	typeString = 'unknown' ifTrue:[^SMxMorphicUnknownEvent type: #unknown readFrom: aStream].

	^nil
! !

!SMxMorphicEvent class methodsFor: 'instance creation' stamp: 'ar 10/24/2000 16:32'!
type: eventType readFrom: aStream
	^self new type: eventType readFrom: aStream! !

!SMxMorphicEvent methodsFor: 'comparing' stamp: 'jmv 12/5/2009 20:37'!
= anEvent
	(anEvent is: #SMxMorphicEvent) ifFalse: [^false].
	^self type = anEvent type! !

!SMxMorphicEvent methodsFor: 'initialize' stamp: 'ar 10/10/2000 01:18'!
copyHandlerState: anEvent
	"Copy the handler state from anEvent. Used for quickly transferring handler information between transformed events."
! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 10/10/2000 21:28'!
cursorPoint
	"Backward compatibility. Use #position instead"
	^ self position! !

!SMxMorphicEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:58'!
externalizedFromOwnerOf: targetMorph to: outerMorph
	"Return a new event, transformed from the receiver owner's to an outer coordinate system (outerMorph)."! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 16:48'!
hand
	"Return the source that generated the event"
	^source! !

!SMxMorphicEvent methodsFor: 'comparing' stamp: 'ar 9/13/2000 15:36'!
hash
	^self type hash! !

!SMxMorphicEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:02'!
internalizedTo: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph's)."
! !

!SMxMorphicEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:02'!
internalizedToOwnerOf: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph owner's)."
! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'jmv 12/5/2009 20:36'!
is: aSymbol
	^ aSymbol = #SMxMorphicEvent or: [ super is: aSymbol ]! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 9/22/2000 10:36'!
isDraggingEvent
	^false! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 19:17'!
isDropEvent
	^false! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 19:19'!
isKeyboard
	^false! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 10/10/2000 21:27'!
isKeystroke
	^false! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 19:19'!
isMouse
	^false! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'ar 9/14/2000 18:21'!
isMouseOver
	^self type == #mouseOver! !

!SMxMorphicEvent methodsFor: 'testing' stamp: 'JMM 10/6/2004 21:35'!
isWindowEvent
	^false! !

!SMxMorphicEvent methodsFor: 'initialize' stamp: 'ar 10/10/2000 01:18'!
resetHandlerFields
	"Reset anything that is used to cross-communicate between two eventual handlers during event dispatch"! !

!SMxMorphicEvent methodsFor: 'dispatching' stamp: 'ar 9/15/2000 21:12'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	^anObject handleUnknownEvent: self! !

!SMxMorphicEvent methodsFor: 'private' stamp: 'ar 10/25/2000 20:53'!
setTimeStamp: stamp
	timeStamp := stamp.! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:29'!
timeStamp
	"Return the millisecond clock value at which the event was generated"
	^timeStamp ifNil:[timeStamp := Time millisecondClockValue]! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:34'!
type
	"Return a symbol indicating the type this event."
	^self subclassResponsibility! !

!SMxMorphicEvent methodsFor: 'initialize' stamp: 'ar 10/24/2000 16:21'!
type: eventType readFrom: aStream
	"Read a SMxMorphicEvent from the given stream."
! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 10/10/2000 01:19'!
wasHandled
	"Return true if this event was handled. May be ignored for some types of events."
	^false! !

!SMxMorphicEvent methodsFor: 'accessing' stamp: 'ar 10/10/2000 01:20'!
wasHandled: aBool
	"Determine if this event was handled. May be ignored for some types of events."! !

SMxMorphicEvent subclass: #SMxWindowEvent
	instanceVariableNames: 'action rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxWindowEvent commentStamp: '<historical>' prior: 0!
I'm an event related to the host window, only dispatched to the World. !

!SMxWindowEvent methodsFor: 'accessing' stamp: 'JMM 10/6/2004 21:11'!
action
	^action! !

!SMxWindowEvent methodsFor: 'accessing' stamp: 'JMM 10/6/2004 21:10'!
action: aValue
	action := aValue.! !

!SMxWindowEvent methodsFor: 'testing' stamp: 'JMM 10/6/2004 21:35'!
isWindowEvent
	^true! !

!SMxWindowEvent methodsFor: 'accessing' stamp: 'JMM 10/6/2004 21:12'!
rectangle
	^rectangle! !

!SMxWindowEvent methodsFor: 'accessing' stamp: 'JMM 10/6/2004 21:12'!
rectangle: aValue
	rectangle := aValue.! !

!SMxWindowEvent methodsFor: 'dispatching' stamp: 'bf 8/30/2007 17:31'!
sentTo:anObject
	"Dispatch the receiver into anObject"
	^anObject handleWindowEvent: self.! !

!SMxWindowEvent methodsFor: 'accessing' stamp: 'bf 8/30/2007 20:42'!
type
	"This should match the definitions in sq.h"
	^#(
		windowMetricChange
		windowClose
		windowIconise
		windowActivated
		windowPaint
	) at: action ifAbsent: [#windowEventUnknown]! !

Object subclass: #SMxMorphicEventDispatcher
	instanceVariableNames: 'lastType lastDispatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMorphicEventDispatcher commentStamp: '<historical>' prior: 0!
The class represents a strategy for dispatching events to some immediate child of a morph. It is used by morphs to delegate the somewhat complex action of dispatching events accurately. !

!SMxMorphicEventDispatcher methodsFor: 'dispatching' stamp: 'jmv 10/9/2009 12:50'!
dispatchDefault: anEvent with: aMorph
	"Dispatch the given event. The event will be passed to the front-most visible submorph that contains the position wrt. to the event."
	| localEvt inside |
	"See if we're fully outside aMorphs bounds"
	(aMorph fullBounds containsPoint: anEvent position) ifFalse: [ ^#rejected ]. "outside"

	"Traverse children"
	inside := false.
	aMorph submorphsDo: [ :eachChild |
		inside ifFalse: [
			localEvt := anEvent internalizedToOwnerOf: eachChild from: aMorph.
			(eachChild processEvent: localEvt using: self) == #rejected ifFalse: [
				"Not rejected. The event was in some submorph of the receiver"
				inside := true.
				localEvt wasHandled ifTrue: [ anEvent copyHandlerState: localEvt ].
			]]].

	"Check for being inside the receiver"
	inside ifFalse: [ inside := aMorph containsPoint: anEvent position event: anEvent ].
	inside ifTrue: [ ^aMorph handleEvent: anEvent ].
	^ #rejected! !

!SMxMorphicEventDispatcher methodsFor: 'dispatching' stamp: 'jmv 10/9/2009 12:50'!
dispatchDropEvent: anEvent with: aMorph
	"Find the appropriate receiver for the event and let it handle it. The dispatch is similar to the default dispatch with one difference: Morphs are given the chance to reject an entire drop operation. If the operation is rejected, no drop will be executed."
	| inside localEvt |

	"Try to get out quickly"
	(aMorph fullBounds containsPoint: anEvent cursorPoint)
		ifFalse: [ ^#rejected ].

	"Give aMorph a chance to repel the dropping morph"
	aMorph rejectDropEvent: anEvent.
	anEvent wasHandled ifTrue:[^self].

	"Go looking if any of our submorphs wants it"
	inside := false.
	aMorph submorphsDo: [ :eachChild |
		inside ifFalse: [
			localEvt := anEvent internalizedToOwnerOf: eachChild from: aMorph.
			(eachChild processEvent: localEvt using: self) == #rejected ifFalse: [
				localEvt wasHandled ifTrue: [ ^anEvent wasHandled: true ]. "done"
				inside := true
			]]].

	inside ifFalse: [ inside := aMorph containsPoint: anEvent cursorPoint event: anEvent ].
	inside ifTrue: [ ^aMorph handleEvent: anEvent ].
	^#rejected! !

!SMxMorphicEventDispatcher methodsFor: 'dispatching' stamp: 'bf 8/30/2007 20:30'!
dispatchEvent: anEvent with: aMorph
	"Dispatch the given event for a morph that has chosen the receiver to dispatch its events. The method implements a shortcut for repeated dispatches of events using the same dispatcher."
	anEvent type == lastType ifTrue:[^self perform: lastDispatch with: anEvent with: aMorph].
	"Otherwise classify"
	lastType := anEvent type.
	anEvent isMouse ifTrue:[
		anEvent isMouseDown ifTrue:[
			lastDispatch := #dispatchMouseDown:with:.
			^self dispatchMouseDown: anEvent with: aMorph]].
	anEvent type == #dropEvent ifTrue:[
		lastDispatch := #dispatchDropEvent:with:.
		^self dispatchDropEvent: anEvent with: aMorph].
	anEvent isWindowEvent ifTrue:[
		lastDispatch := #dispatchWindowEvent:with:.
		^self dispatchWindowEvent: anEvent with: aMorph].
	lastDispatch := #dispatchDefault:with:.
	^self dispatchDefault: anEvent with: aMorph! !

!SMxMorphicEventDispatcher methodsFor: 'dispatching' stamp: 'jmv 10/9/2009 12:50'!
dispatchMouseDown: anEvent with: aMorph
	"Find the appropriate receiver for the event and let it handle it. Default rules:
	* The top-most chain of visible, unlocked morphs containing the event position will get a chance to handle the event.
	* When travelling down the hierarchy a prospective handler for the event is installed. This prospective handler can be used by submorphs wishing to handle the mouse down for negotiating who the receiver is.
	* When travelling up, the prospective handler is always executed. The handler needs to check if the event was handled before as well as checking if somebody else's handler has been installed.
	* If another handler has been installed but the event was not handled it means that somebody up in the hierarchy wants to handle the event.
"
	| globalPt localEvt handler inside lastHandler |
	"Try to get out quickly"
	globalPt := anEvent cursorPoint.
	(aMorph fullBounds containsPoint: globalPt) ifFalse: [ ^#rejected ].

	"Install the prospective handler for the receiver"
	lastHandler := anEvent handler. "in case the mouse wasn't even in the receiver"
	handler := aMorph handlerForMouseDown: anEvent.
	handler ifNotNil: [ anEvent handler: handler ].

	"Now give our submorphs a chance to handle the event"
	inside := false.
	aMorph submorphsDo: [ :eachChild |
		inside ifFalse: [
			localEvt := anEvent internalizedToOwnerOf: eachChild from: aMorph.
			(eachChild processEvent: localEvt using: self) == #rejected ifFalse: [
				"Some child did contain the point so we're part of the top-most chain."
				inside := true.
				localEvt wasHandled ifTrue: [ anEvent copyHandlerState: localEvt ].
			]]].

	(inside or: [ aMorph containsPoint: anEvent cursorPoint event: anEvent ]) ifTrue:[
		"Receiver is in the top-most unlocked, visible chain."
		handler ifNotNil: [ handler handleEvent: anEvent ].
		"Note: Re-installing the handler is not really necessary but good style."
		anEvent handler: lastHandler.
		^self ].

	"Mouse was not on receiver nor any of its children"
	anEvent handler: lastHandler.
	^#rejected! !

!SMxMorphicEventDispatcher methodsFor: 'dispatching' stamp: 'bf 8/30/2007 20:29'!
dispatchWindowEvent: anEvent with: aMorph
	"Host window events do not have a position and are only dispatched to the World"
	aMorph isWorldMorph ifFalse: [^#rejected].
	anEvent wasHandled ifTrue:[^self].
	^aMorph handleEvent: anEvent! !

Object subclass: #SMxMouseClickState
	instanceVariableNames: 'clickClient clickState firstClickDown firstClickUp firstClickTime clickSelector dblClickSelector dblClickTime dblClickTimeoutSelector dragSelector dragThreshold sendYellowButtonActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxMouseClickState commentStamp: '<historical>' prior: 0!
SMxMouseClickState is a simple class managing the distinction between clicks, double clicks, and drag operations. It has been factored out of SMxHandMorph due to the many instVars.

Instance variables:
	clickClient 	<SMxMorph>		The client wishing to receive #click:, #dblClick:, or #drag messages
	clickState 	<Symbol>	The internal state of handling the last event (#firstClickDown, #firstClickUp, #firstClickTimedOut)
	firstClickDown 	<SMxMorphicEvent>	The #mouseDown event after which the client wished to receive #click: or similar messages
	firstClickUp 	<SMxMorphicEvent>	The first mouse up event which came in before the double click time out was exceeded (it is sent if there is a timout after the first mouse up event occured)
	firstClickTime 	<Integer>	The millisecond clock value of the first event
	clickSelector 	<Symbol>	The selector to use for sending #click: messages
	dblClickSelector 	<Symbol>	The selector to use for sending #doubleClick: messages
	dblClickTime 	<Integer>	Timout in milliseconds for a double click operation
	dragSelector 	<Symbol>	The selector to use for sending #drag: messages
	dragThreshold 	<Integer>	Threshold used for determining if a #drag: message is sent (pixels!!)
!

!SMxMouseClickState methodsFor: 'event handling' stamp: 'jcg 9/21/2001 11:23'!
click

	clickSelector ifNotNil: [clickClient perform: clickSelector with: firstClickDown]! !

!SMxMouseClickState methodsFor: 'initialize' stamp: 'jmv 5/11/2009 23:37'!
client: aMorph click: aClickSelector dblClick: aDblClickSelector dblClickTime: timeOut dblClickTimeout: aDblClickTimeoutSelector drag: aDragSelector event: firstClickEvent sendYellowButtonActivity: aBoolean
	clickClient := aMorph.
	clickSelector := aClickSelector.
	dblClickSelector := aDblClickSelector.
	dblClickTime := timeOut.
	dblClickTimeoutSelector := aDblClickTimeoutSelector.
	dragSelector := aDragSelector.
	dragThreshold := 4.
	firstClickDown := firstClickEvent.
	firstClickTime := firstClickEvent timeStamp.
	clickState := #firstClickDown.
	sendYellowButtonActivity := aBoolean! !

!SMxMouseClickState methodsFor: 'event handling' stamp: 'jcg 9/21/2001 11:24'!
doubleClick

	dblClickSelector ifNotNil: [clickClient perform: dblClickSelector with: firstClickDown]! !

!SMxMouseClickState methodsFor: 'event handling' stamp: 'jcg 9/21/2001 13:09'!
doubleClickTimeout

	dblClickTimeoutSelector ifNotNil: [
		clickClient perform: dblClickTimeoutSelector with: firstClickDown]! !

!SMxMouseClickState methodsFor: 'event handling' stamp: 'jcg 9/21/2001 11:27'!
drag: event

	dragSelector ifNotNil: [clickClient perform: dragSelector with: event]! !

!SMxMouseClickState methodsFor: 'event handling' stamp: 'jmv 10/9/2009 12:50'!
handleEvent: evt from: aHand
	"Process the given mouse event to detect a click, double-click, or drag.
	Return true if the event should be processed by the sender, false if it shouldn't.
	NOTE: This method heavily relies on getting *all* mouse button events."
	| localEvt timedOut isDrag distance |
	timedOut := (evt timeStamp - firstClickTime) > dblClickTime.
	localEvt := evt internalizedToOwnerOf: clickClient from: aHand owner.
	distance := (localEvt position - firstClickDown position) r.
	isDrag := distance > dragThreshold.
	clickState == #firstClickDown ifTrue: [
		"Careful here - if we had a slow cycle we may have a timedOut mouseUp event"
		(timedOut and:[localEvt isMouseUp not]) ifTrue:[
			"timeout before #mouseUp -> keep waiting for drag or sendYellowButtonActivity if requested"
			clickState := #firstClickTimedOut.
			(sendYellowButtonActivity not and: [ dragSelector isNil ]) ifTrue: [
				aHand resetClickState.
				self doubleClickTimeout; click "***"].
			^true].
		localEvt isMouseUp ifTrue:[
			(timedOut or: [ dblClickSelector isNil ]) ifTrue:[
				self click.
				aHand resetClickState.
				^true ].
			"Otherwise transfer to #firstClickUp"
			firstClickUp := evt copy.
			clickState := #firstClickUp.
			"If timedOut or the client's not interested in dbl clicks get outta here"
			self click.
			aHand handleEvent: firstClickUp.
			^false ].
		isDrag ifTrue: [ "drag start"
			self doubleClickTimeout. "***"
			aHand resetClickState.
			dragSelector "If no drag selector send #click instead"
				ifNil: [ self click ]
				ifNotNil: [ self drag: firstClickDown ].
			^true ].
		^false ].

	clickState == #firstClickTimedOut ifTrue: [
		localEvt isMouseUp ifTrue:[ "neither drag nor double click"
			aHand resetClickState.
			self doubleClickTimeout; click. "***"
			^true ].
		isDrag ifTrue: [ "drag start"
			aHand resetClickState.
			self doubleClickTimeout; drag: firstClickDown. "***"
			^true ].
		"Neither drag nor double click. Simulate yellow button click. This is useful, for example, for pen computers"
		(sendYellowButtonActivity and: [ distance = 0 ]) ifTrue: [
			aHand resetClickState.
			clickClient yellowButtonActivity: evt shiftPressed.
			^true ].
		^false ].

	clickState = #firstClickUp ifTrue:[
		timedOut ifTrue:[
			"timed out after mouseUp - send #click: and mouseUp"
			aHand resetClickState.
			self doubleClickTimeout. "***"
			^true ].
		localEvt isMouseDown ifTrue:[ "double click"
			clickState := #secondClickDown.
			^false ]].

	clickState == #secondClickDown ifTrue: [
		localEvt isMouseUp ifTrue: ["double click"
			aHand resetClickState.
			self doubleClick.
			^false ]
	].

	^true! !

Object subclass: #SMxMouseOverHandler
	instanceVariableNames: 'mouseOverMorphs enteredMorphs overMorphs leftMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMouseOverHandler methodsFor: 'initialize-release' stamp: 'ar 9/28/2000 17:08'!
initialize
	mouseOverMorphs := #().! !

!SMxMouseOverHandler methodsFor: 'event handling' stamp: 'ar 9/28/2000 18:52'!
noticeMouseOver: aMorph event: anEvent
	"Remember that the mouse is currently over some morph"
	(leftMorphs includes: aMorph) 
		ifTrue:[leftMorphs remove: aMorph]
		ifFalse:[enteredMorphs nextPut: aMorph].
	overMorphs nextPut: aMorph.
! !

!SMxMouseOverHandler methodsFor: 'event handling' stamp: 'jmv 10/9/2009 12:50'!
processMouseOver: anEvent 
	"Re-establish the z-order for all morphs wrt the given event"

	| hand localEvt focus evt |
	hand := anEvent hand.
	leftMorphs := mouseOverMorphs asIdentitySet.
	"Assume some coherence for the number of objects in over list"
	overMorphs := WriteStream on: (Array new: leftMorphs size).
	enteredMorphs := WriteStream on: #().
	"Now go looking for eventual mouse overs"
	hand handleEvent: anEvent asMouseOver.
	"Get out early if there's no change"
	(leftMorphs isEmpty and: [enteredMorphs position = 0]) 
		ifTrue: [^leftMorphs := enteredMorphs := overMorphs := nil].
	focus := hand mouseFocus.
	"Send #mouseLeave as appropriate"
	evt := anEvent asMouseLeave.
	"Keep the order of the left morphs by recreating it from the mouseOverMorphs"
	leftMorphs size > 1 
		ifTrue: [leftMorphs := mouseOverMorphs select: [:m | leftMorphs includes: m]].
	leftMorphs do: 
			[:m | 
			(m == focus or: [m hasOwner: focus]) 
				ifTrue: [
					localEvt := evt internalizedToOwnerOf: m from: hand.
					m handleEvent: localEvt]
				ifFalse: [overMorphs nextPut: m]].
	"Send #mouseEnter as appropriate"
	evt := anEvent asMouseEnter.
	enteredMorphs ifNil: 
			["inform: was called in handleEvent:"

			^leftMorphs := enteredMorphs := overMorphs := nil].
	enteredMorphs := enteredMorphs contents.
	enteredMorphs reverseDo: 
			[:m | 
			(m == focus or: [m hasOwner: focus]) 
				ifTrue: 
					[localEvt := evt internalizedToOwnerOf: m  from: hand.
					m handleEvent: localEvt]].
	"And remember the over list"
	overMorphs ifNil: 
			["inform: was called in handleEvent:"

			^leftMorphs := enteredMorphs := overMorphs := nil].
	mouseOverMorphs := overMorphs contents.
	leftMorphs := enteredMorphs := overMorphs := nil! !

Object subclass: #SMxPopUpMenu
	instanceVariableNames: 'labelString lineArray'
	classVariableNames: 'MenuStyle'
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools-Menu'!

!SMxPopUpMenu commentStamp: '<historical>' prior: 0!
I represent a list of items. My instances are presented on the display screen in a rectangular area. The user points to an item, pressing a mouse button; the item is highlighted. When the button is released, the highlighted item indicates the selection.!

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/18/2010 09:30'!
chooseFrom: aList lines: linesArray title: aString

	^ (self labelArray: aList lines: linesArray) startUpWithCaption: aString! !

!SMxPopUpMenu class methodsFor: 'dialogs' stamp: 'JuanVuletich 10/28/2010 15:37'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	"SMxPopUpMenu confirm: 'Are you hungry?'"

	^ self confirm: queryString trueChoice: 'Yes' translated falseChoice: 'No' translated! !

!SMxPopUpMenu class methodsFor: 'dialogs' stamp: 'JuanVuletich 10/29/2010 10:28'!
confirm: queryString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString. Answer true if  
	the response is yes, false if no. If cancel is chosen, evaluate  
	cancelBlock. This is a modal question--the user must respond yes or no."

	"SMxPopUpMenu confirm: 'Reboot universe' orCancel: [^'Nevermind'] 'Nevermind'"

	| menu choice |
	menu := SMxPopUpMenu labelArray: {'Yes' translated. 'No' translated. 'Cancel' translated}.
	choice := menu startUpWithCaption: queryString.
	choice = 1 ifTrue: [^ true].
	choice = 2 ifTrue: [^ false].
	^ cancelBlock value! !

!SMxPopUpMenu class methodsFor: 'dialogs' stamp: 'sma 6/5/2000 09:12'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice
	"Put up a yes/no menu with caption queryString. The actual wording 
	for the two choices will be as provided in the trueChoice and 
	falseChoice parameters. Answer true if the response is the true-choice, 
	false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."

	"SMxPopUpMenu 
		confirm: 'Are you hungry?'
		trueChoice: 'yes, I''m famished'
		falseChoice: 'no, I just ate'"

	| menu choice |
	menu := SMxPopUpMenu labelArray: {trueChoice. falseChoice}.
	[(choice := menu startUpWithCaption: queryString) isNil] whileTrue.
	^ choice = 1! !

!SMxPopUpMenu class methodsFor: 'dialogs' stamp: 'JuanVuletich 10/29/2010 10:59'!
inform: aString
	"SMxPopUpMenu inform: 'I like Squeak'"

	(SMxPopUpMenu labels: ' OK ' translated) startUpWithCaption: aString! !

!SMxPopUpMenu class methodsFor: 'class initialization' stamp: 'JuanVuletich 10/13/2010 10:25'!
initialize  "SMxPopUpMenu initialize"
	MenuStyle := TextStyle default.
	SMxPopUpMenu allSubInstancesDo: [:m | m rescan]! !

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: 'sma 5/28/2000 15:44'!
labelArray: labelArray
	"Answer an instance of me whose items are in labelArray."

	^ self labelArray: labelArray lines: nil! !

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/10/2010 20:06'!
labelArray: labelArray lines: lineArray
	"Answer an instance of me whose items are in labelArray, with lines 
	drawn after each item indexed by anArray. 2/1/96 sw"

	labelArray isEmpty ifTrue: [self error: 'Menu must not be zero size'].
	^ self
		labels: (String streamContents: 
			[:stream |
			labelArray do: [:each | stream nextPutAll: each; cr].
			stream skip: -1 "remove last CR"])
		lines: lineArray

"Example:
	(SMxPopUpMenu labelArray: #('frog' 'and' 'toad') lines: #()) startUp"! !

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: ''!
labels: aString
	"Answer an instance of me whose items are in aString."

	^self labels: aString lines: nil! !

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: 'jmv 7/24/2009 20:49'!
labels: aString lines: anArray
	"Answer an instance of me whose items are in aString, with lines drawn 
	after each item indexed by anArray."

	^ self new
		labels: aString
		lines: anArray! !

!SMxPopUpMenu class methodsFor: 'dialogs' stamp: 'sma 5/28/2000 15:57'!
notify: message
	"Deprecated. Use #inform: instead."

	self inform: message! !

!SMxPopUpMenu class methodsFor: 'class initialization' stamp: 'JuanVuletich 10/13/2010 10:26'!
setMenuFontTo: aFont
	"Set the menu font as indicated"

	MenuStyle := aFont textStyle.
	self allSubInstancesDo: [:m | m rescan]! !

!SMxPopUpMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/10/2010 20:06'!
withCaption: cap chooseFrom: labels
	"Simply put up a menu.  Get the args in the right order with the caption first.  labels may be either an array of items or a string with CRs in it.  May use backslashes for returns."

	(labels isKindOf: String) 
		ifTrue: [^ (self labels: labels withCRs lines: nil) startUpWithCaption: cap withCRs]
		ifFalse: [^ (self labelArray: labels lines: nil) startUpWithCaption: cap withCRs]! !

!SMxPopUpMenu methodsFor: 'accessing' stamp: 'JuanVuletich 10/13/2010 10:19'!
frameHeight
	"Designed to avoid the entire frame computation (includes MVC form),
	since the menu may well end up being displayed in Morphic anyway."
	| nItems |
	nItems := 1 + (labelString occurrencesOf: Character cr).
	^ (nItems * MenuStyle lineGrid) + 4 "border width"! !

!SMxPopUpMenu methodsFor: 'accessing' stamp: ''!
labelString

	^ labelString! !

!SMxPopUpMenu methodsFor: 'private' stamp: 'jmv 7/24/2009 20:49'!
labels: aString lines: anArray

	labelString := aString.
	lineArray := anArray.
! !

!SMxPopUpMenu methodsFor: 'accessing' stamp: ''!
lineArray

	^ lineArray! !

!SMxPopUpMenu methodsFor: 'accessing' stamp: 'JuanVuletich 10/10/2010 20:09'!
nItems
	^ (labelString occurrencesOf: Character cr) + 1! !

!SMxPopUpMenu methodsFor: 'private' stamp: 'jmv 3/1/2010 13:10'!
rescan
	"Cause my form to be recomputed after a font change."

	labelString ifNil: [labelString := 'NoText!!'].
	self labels: labelString lines: lineArray.

	"SMxPopUpMenu allSubInstancesDo: [:m | m rescan]"! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: ''!
startUp
	"Display and make a selection from the receiver as long as the button 
	is pressed. Answer the current selection."
	
	^ self startUpWithCaption: nil! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: 'JuanVuletich 10/13/2010 10:19'!
startUpSegmented: segmentHeight withCaption: captionOrNil at: location allowKeyboard: aBoolean
	"This menu is too big to fit comfortably on the screen.
	Break it up into smaller chunks, and manage the relative indices.
	Inspired by a special-case solution by Reinier van Loon.  The boolean parameter indicates whether the menu should be given keyboard focus (if in morphic)"

"
(SMxPopUpMenu labels: (String streamContents: [:s | 1 to: 100 do: [:i | s print: i; cr]. s skip: -1])
		lines: (5 to: 100 by: 5)) startUpWithCaption: 'Give it a whirl...'.
"
	| nLines nLinesPer allLabels from to subset subLines index |
	allLabels := labelString findTokens: Character cr asString.
	nLines := allLabels size.
	lineArray ifNil: [lineArray := Array new].
	nLinesPer := segmentHeight // MenuStyle lineGrid - 3.
	from := 1.
	[ true ] whileTrue:
		[to := (from + nLinesPer) min: nLines.
		subset := allLabels copyFrom: from to: to.
		subset add: (to = nLines ifTrue: ['start over...'] ifFalse: ['more...'])
			before: subset first.
		subLines := lineArray select: [:n | n >= from] thenCollect: [:n | n - (from-1) + 1].
		subLines := (Array with: 1) , subLines.
		index := (SMxPopUpMenu labels: subset asStringWithCr lines: subLines)
					startUpWithCaption: captionOrNil at: location allowKeyboard: aBoolean.
		index = 1
			ifTrue: [from := to + 1.
					from > nLines ifTrue: [ from := 1 ]]
			ifFalse: [index = 0 ifTrue: [^ 0].
					^ from + index - 2]]! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: 'JuanVuletich 11/1/2010 15:29'!
startUpWithCaption: captionOrNil
	"Display the menu, slightly offset from the cursor,
	so that a slight tweak is required to confirm any action."
	^ self startUpWithCaption: captionOrNil at: (SimpleMorphicUIManager smxActiveHand ifNil:[Sensor]) cursorPoint! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: 'ar 12/27/2001 22:47'!
startUpWithCaption: captionOrNil at: location
	"Display the menu, with caption if supplied. Wait for the mouse button to go down,
	then track the selection as long as the button is pressed. When the button is released, 
	answer the index of the current selection, or zero if the mouse is not released over 
	any menu item. Location specifies the desired topLeft of the menu body rectangle."

		^ self startUpWithCaption: captionOrNil at: location allowKeyboard: SMxPreferences menuKeyboardControl! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: 'JuanVuletich 11/1/2010 15:34'!
startUpWithCaption: captionOrNil at: location allowKeyboard: aBoolean 
	"Display the menu, with caption if supplied. Wait for the mouse button to go down, then track the selection as long as the button is pressed. When the button is released,
	Answer the index of the current selection, or zero if the mouse is not released over  any menu item. Location specifies the desired topLeft of the menu body rectangle. The final argument indicates whether the menu should seize the keyboard focus in order to allow the user to navigate it via the keyboard."

	| maxHeight |
	maxHeight := Display height * 3 // 4.
	self frameHeight > maxHeight 
		ifTrue: 
			[^self 
				startUpSegmented: maxHeight
				withCaption: captionOrNil
				at: location
				allowKeyboard: aBoolean].
	^Cursor normal showWhile: 
							[(SMxMVCMenuMorph from: self title: captionOrNil) 
								invokeAt: location
								in: SimpleMorphicUIManager smxActiveWorld
								allowKeyboard: aBoolean]! !

!SMxPopUpMenu methodsFor: 'basic control sequence' stamp: 'JuanVuletich 11/1/2010 15:29'!
startUpWithoutKeyboard
	"Display and make a selection from the receiver as long as the button  is pressed. Answer the current selection.  Do not allow keyboard input into the menu"
	
	^ self startUpWithCaption: nil at: ((SimpleMorphicUIManager smxActiveHand ifNil:[Sensor]) cursorPoint) allowKeyboard: false! !

SMxPopUpMenu subclass: #SMxSelectionMenu
	instanceVariableNames: 'selections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools-Menu'!

SMxSelectionMenu subclass: #SMxCustomMenu
	instanceVariableNames: 'labels dividers lastDivider title targets arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools-Menu'!

!SMxCustomMenu commentStamp: '<historical>' prior: 0!
I am used to build menus on-the-fly. I maintain lists of menu items, actions (usually symbols to be sent as messages), and menu section dividing lines to which my clients may append new entries and lines by sending me the messages:

	add: aString action: anAction
	addLine

After the menu is constructed, it may be invoked with one of the following messages:

	startUp: initialSelection
	startUp

I am a subclass of ActionMenu, so I inherit a number of instance variables. The ones I am particularly concerned with are:

	items := an OrderedCollection of strings to appear in the menu
	selectors := an OrderedCollection of Symbols to be used as message selectors
	lineArray := an OrderedCollection of line positions
	lastLine := used to keep track of the last line to avoid making duplicate entries in lineArray!

!SMxCustomMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/10/2010 20:07'!
add: aString action: actionItem
	"Add the given string as the next menu item. If it is selected, the given action (usually but not necessarily a symbol) will be returned to the client."

	| s |
	aString ifNil: [^ self addLine].
	s := String new: aString size + 2.
	s at: 1 put: Character space.
	s replaceFrom: 2 to: s size - 1 with: aString.
	s at: s size put: Character space.
	labels addLast: s.
	selections addLast: actionItem.! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'ads 2/20/2003 08:59'!
add: aString subMenu: aMenu target: target selector: aSymbol argumentList: argList
	"Create a sub-menu with the given label. This isn't really a sub-menu the way Morphic does it; it'll just pop up another menu."

	self
		add: aString
		target: aMenu
		selector: #invokeOn:
		argumentList: argList asArray.! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'JuanVuletich 10/10/2010 20:09'!
add: aString target: target selector: aSymbol argument: arg
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given argument."

	self add: aString
		target: target
		selector: aSymbol
		argumentList: (Array with: arg)! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'sumim 2/10/2002 01:18'!
add: aString target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument."

	self add: aString action: aSymbol.
	targets addLast: target.
	arguments addLast: argList asArray
! !

!SMxCustomMenu methodsFor: 'construction' stamp: ''!
addLine
	"Append a line to the menu after the last entry. Suppress duplicate lines."

	(lastDivider ~= selections size) ifTrue: [
		lastDivider := selections size.
		dividers addLast: lastDivider].! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'sw 2/27/2001 07:52'!
addList: listOfTuplesAndDashes
	"Add a menu item to the receiver for each tuple in the given list of the form (<what to show> <selector>). Add a line for each dash (-) in the list.  The tuples may have an optional third element, providing balloon help for the item, but such an element is ignored in mvc."

	listOfTuplesAndDashes do: [:aTuple |
		aTuple == #-
			ifTrue: [self addLine]
			ifFalse: [self add: aTuple first action: aTuple second]]

	"SMxCustomMenu new addList: #(
		('apples' buyApples)
		('oranges' buyOranges)
		-
		('milk' buyMilk)); startUp"

! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'nk 2/15/2004 16:19'!
addService: aService for: serviceUser
	"Append a menu item with the given service. If the item is selected, it will perform the given service."

	aService addServiceFor: serviceUser toMenu: self.! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'nk 2/15/2004 16:02'!
addServices2: services for: served extraLines: linesArray

	services withIndexDo: [:service :i |
		service addServiceFor: served toMenu: self.
		(linesArray includes: i)  ifTrue: [self addLine] ]! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'sumim 2/10/2002 01:20'!
addServices: services for: served extraLines: linesArray

	services withIndexDo: [:service :i |
		self addService: service for: served.
		(linesArray includes: i) | service useLineAfter 
			ifTrue: [self addLine]]! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'jmv 5/17/2009 23:41'!
addStayUpIcons
	"For compatibility with SMxMenuMorph.  Here it is a no-op"! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'nk 11/25/2003 10:00'!
addTranslatedList: listOfTuplesAndDashes
	"Add a menu item to the receiver for each tuple in the given list of the form (<what to show> <selector>). Add a line for each dash (-) in the list.  The tuples may have an optional third element, providing balloon help for the item, but such an element is ignored in mvc.
	The first element will be translated."

	listOfTuplesAndDashes do: [:aTuple |
		aTuple == #-
			ifTrue: [self addLine]
			ifFalse: [self add: aTuple first translated action: aTuple second]]

	"SMxCustomMenu new addTranslatedList: #(
		('apples' buyApples)
		('oranges' buyOranges)
		-
		('milk' buyMilk)); startUp"

! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'JuanVuletich 10/10/2010 20:07'!
arguments
	"Answer my arguments, initializing them to an empty collection if they're found to be nil."

	^ arguments ifNil: [arguments := OrderedCollection new]! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'sw 7/20/1999 18:47'!
balloonTextForLastItem: aString
	"Vacuous backstop provided for compatibility with MorphicMenu"! !

!SMxCustomMenu methodsFor: 'private' stamp: 'JuanVuletich 10/10/2010 20:06'!
build
	"Turn myself into an invokable ActionMenu."

	| stream |
	stream := WriteStream on: String new.
	labels do: [:label | stream nextPutAll: label; cr].
	(labels isEmpty) ifFalse: [stream skip: -1].  "remove final cr"
	super labels: stream contents
		lines: dividers! !

!SMxCustomMenu methodsFor: 'initialize-release' stamp: 'JuanVuletich 10/10/2010 20:08'!
initialize

	labels := OrderedCollection new.
	selections := OrderedCollection new.
	dividers := OrderedCollection new.
	lastDivider := 0.
	targets := OrderedCollection new.
	arguments := OrderedCollection new	! !

!SMxCustomMenu methodsFor: 'invocation' stamp: 'sw 2/17/2002 04:48'!
invokeOn: targetObject
	"Pop up this menu and return the result of sending to the target object the selector corresponding to the menu item selected by the user. Return nil if no item is selected.  If the chosen selector has arguments, obtain them from my arguments"

	^ self invokeOn: targetObject orSendTo: nil! !

!SMxCustomMenu methodsFor: 'invocation' stamp: 'jmv 12/8/2008 15:35'!
invokeOn: targetObject orSendTo: anObject
	"Pop up this menu and return the result of sending to the target object the selector corresponding to the menu item selected by the user. Return  nil if no item is selected.  If the chosen selector has arguments, obtain appropriately.  If the recipient does not respond to the resulting message, send it to the alternate object provided"

	| aSelector anIndex recipient |
	^ (aSelector := self startUp) ifNotNil:
		[anIndex := self selection.
		recipient := ((targets := self targets) isEmptyOrNil or: [anIndex > targets size])
			ifTrue:
				[targetObject]
			ifFalse:
				[targets at: anIndex].
		aSelector numArgs = 0
			ifTrue:
				[recipient perform: aSelector orSendTo: anObject]
			ifFalse:
				[recipient perform: aSelector withArguments: (self arguments at: anIndex)]]! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/10/2010 20:07'!
labels: aString lines: anArrayOrNil
	"This method allows the receiver to accept old-style SMxSelectionMenu creation messages. It should be used only for backward compatibility during the MVC-to-Morphic transition. New code should be written using the other menu construction protocol such as addList:."

	| labelList linesArray |
	labelList := (aString findTokens: String cr) asArray.
	anArrayOrNil
		ifNil: [linesArray := #()]
		ifNotNil: [linesArray := anArrayOrNil].
	1 to: labelList size do: [:i |
		self add: (labelList at: i) action: (labelList at: i).
		(linesArray includes: i) ifTrue: [self addLine]]
! !

!SMxCustomMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/21/2010 11:38'!
labels: labelList lines: linesArray selections: selectionsArray
	"This method allows the receiver to accept old-style SMxSelectionMenu creation messages. It should be used only for backward compatibility during the MVC-to-Morphic transition. New code should be written using the other menu construction protocol such as addList:."
	"Labels can be either a sting with embedded crs, or a collection of strings."

	| labelArray |
	labelArray := labelList isString
				ifTrue: [ labelList lines ]
				ifFalse: [ labelList ].
	1 to: labelArray size do: [:i |
		self add: (labelArray at: i) action: (selectionsArray at: i).
		(linesArray includes: i) ifTrue: [self addLine]].
! !

!SMxCustomMenu methodsFor: 'invocation' stamp: 'jmv 7/24/2009 20:32'!
startUp
	"Build and invoke this menu with no initial selection. Answer the selection associated with the menu item chosen by the user or nil if none is chosen."

	^ self startUpWithCaption: title! !

!SMxCustomMenu methodsFor: 'invocation' stamp: 'jmv 7/24/2009 20:33'!
startUpWithCaption: caption
	"Build and invoke this menu with no initial selection. Answer the selection associated with the menu item chosen by the user or nil if none is chosen; use the provided caption"

	self build.
	^ super startUpWithCaption: caption! !

!SMxCustomMenu methodsFor: 'compatibility' stamp: 'JuanVuletich 10/10/2010 20:07'!
targets
	"Answer my targets, initializing them to an empty collection if found to be nil"

	^ targets ifNil: [targets := OrderedCollection new]! !

!SMxCustomMenu methodsFor: 'initialize-release' stamp: 'sw 8/18/1998 12:01'!
title: aTitle
	title := aTitle! !

SMxSelectionMenu subclass: #SMxEmphasizedMenu
	instanceVariableNames: 'emphases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Tools-Menu'!

!SMxEmphasizedMenu commentStamp: '<historical>' prior: 0!
A selection menu in which individual selections are allowed to have different emphases.  Emphases allowed are: bold, italic, struckThrough, and plain.  Provide an emphasis array, with one element per selection, to use.  Refer to the class method #example.!

!SMxEmphasizedMenu class methodsFor: 'examples' stamp: 'fc 2/19/2004 22:06'!
example1
	"SMxEmphasizedMenu example1"

	^ (self
		selections: #('how' 'well' 'does' 'this' 'work?' ) 
		emphases: #(#bold #normal #italic #struckOut #normal ))
			startUpWithCaption: 'A Menu with Emphases'! !

!SMxEmphasizedMenu class methodsFor: 'examples' stamp: 'sw 9/11/97 16:14'!
example2
	"SMxEmphasizedMenu example2"

	| aMenu |
	aMenu := SMxEmphasizedMenu selections: #('One' 'Two' 'Three' 'Four').
	aMenu onlyBoldItem: 3.
	^ aMenu startUpWithCaption: 'Only the Bold'! !

!SMxEmphasizedMenu class methodsFor: 'examples' stamp: 'fc 2/19/2004 22:08'!
example3
	"SMxEmphasizedMenu example3"

	^ (self
		selectionAndEmphasisPairs: #('how' #bold 'well' #normal 'does' #italic 'this' #struckOut 'work' #normal))
		startUpWithCaption: 'A Menu with Emphases'! !

!SMxEmphasizedMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/10/2010 20:07'!
selectionAndEmphasisPairs: interleavedList
	"An alternative form of call.  "
	| selList  emphList |
	selList := OrderedCollection new.
	emphList := OrderedCollection new.
	interleavedList pairsDo:
		[:aSel :anEmph |
			selList add: aSel.
			emphList add: anEmph].
	^ self selections:selList emphases: emphList! !

!SMxEmphasizedMenu class methodsFor: 'instance creation' stamp: 'jmv 4/1/2009 15:37'!
selections: selList emphases: emphList
	"Answer an instance of the receiver with the given selections and emphases.  "

	^ (self selections: selList) emphases: emphList

"(SMxEmphasizedMenu selections: #('how' 'well' 'does' 'this' 'work?') emphases: #(bold normal italic struckOut normal)) startUp" ! !

!SMxEmphasizedMenu methodsFor: 'emphasis' stamp: ''!
emphases: emphasisArray
	emphases := emphasisArray! !

!SMxEmphasizedMenu methodsFor: 'emphasis' stamp: 'JuanVuletich 10/10/2010 20:09'!
onlyBoldItem: itemNumber
	"Set up emphasis such that all items are plain except for the given item number.  "

	emphases := (Array new: selections size) atAllPut: #normal.
	emphases at: itemNumber put: #bold! !

!SMxEmphasizedMenu methodsFor: 'private' stamp: 'JuanVuletich 10/12/2010 23:46'!
setEmphasis
	"Set up the receiver to reflect the emphases in the emphases array.  "

	| selStart selEnd currEmphasis |
	
	labelString := labelString asText.
	emphases isEmptyOrNil ifTrue: [^ self].
	selStart := 1.
	1 to: selections size do:
		[:line |
			selEnd := selStart + (selections at: line) size - 1.
			((currEmphasis := emphases at: line) size > 0 and: [currEmphasis ~~ #normal]) ifTrue:
				[labelString addAttribute: (TextEmphasis perform: currEmphasis)
					from: selStart to: selEnd].
			selStart := selEnd + 2]! !

!SMxEmphasizedMenu methodsFor: 'display' stamp: ''!
startUpWithCaption: captionOrNil
	self setEmphasis.
	^ super startUpWithCaption: captionOrNil! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/10/2010 20:04'!
fromArray: anArray
	"Construct a menu from anArray.  The elements of anArray must be either:
	*  A pair of the form: <label> <selector>
or	*  The 'dash' (or 'minus sign') symbol

	Refer to the example at the bottom of the method"

	| labelList lines selections anIndex |
	labelList := OrderedCollection new.
	lines := OrderedCollection new.
	selections := OrderedCollection new.
	anIndex := 0.
	anArray do:
		[:anElement |
			anElement size = 1
				ifTrue:
					[(anElement == #-) ifFalse: [self error: 'badly-formed menu constructor'].
					lines add: anIndex]
				ifFalse:
					[anElement size = 2 ifFalse: [self error: 'badly-formed menu constructor'].
					anIndex := anIndex + 1.
					labelList add: anElement first.
					selections add: anElement second]].
	^ self labelList: labelList lines: lines selections: selections

"(SelectionMenu fromArray:
	#(	('first label'		moja)
		('second label'	mbili)
		-
		('third label' 	tatu)
		-
		('fourth label'	nne)
		('fifth label'	tano))) startUp"! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'sma 5/28/2000 16:04'!
labelList: labelList lines: lines selections: selections
	^ (self labelArray: labelList lines: lines) selections: selections! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'sma 5/28/2000 16:04'!
labelList: labelList selections: selections
	^ self
		labelList: labelList
		lines: #()
		selections: selections! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'JuanVuletich 10/10/2010 20:06'!
labels: labels lines: linesArray
	"Answer an instance of me whose items are in labels, with lines drawn  
	after each item indexed by linesArray. Labels can be either a string 
	with embedded CRs, or a collection of strings."

	(labels isKindOf: String)
		ifTrue: [^ super labels: labels lines: linesArray]
		ifFalse: [^ super labelArray: labels lines: linesArray]! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'sma 5/28/2000 16:09'!
labels: labels lines: linesArray selections: selectionsArray
	"Answer an instance of me whose items are in labels, with lines drawn  
	after each item indexed by linesArray. Labels can be either a string  
	with embedded CRs, or a collection of strings. Record the given array of 
	selections corresponding to the items in labels."

	^ (self labels: labels lines: linesArray) selections: selectionsArray! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'sma 5/28/2000 16:10'!
labels: labels selections: selectionsArray
	"Answer an instance of me whose items are in labels, recording 
	the given array of selections corresponding to the items in labels."

	^ self
		labels: labels
		lines: #()
		selections: selectionsArray! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'bf 9/18/1999 19:55'!
selections: aList
	"Answer an instance of me whose labels and selections are identical.  "

	^ self selections: aList lines: nil! !

!SMxSelectionMenu class methodsFor: 'instance creation' stamp: 'bf 9/18/1999 19:58'!
selections: aList lines: lineList
	"Answer an instance of me whose labels and selections are identical"

	^ self labelList: (aList collect: [:each | each asString])
		lines: lineList
		selections: aList! !

!SMxSelectionMenu methodsFor: 'basic control sequence' stamp: 'jmv 3/2/2010 11:23'!
invokeOn: targetObject
	"Pop up this menu and return the result of sending to the target object
	 the selector corresponding to the menu item selected by the user. Return
	 nil if no item is selected."

	| sel |
	sel := self startUp.
	^sel ifNotNil: [ targetObject perform: sel]

"(SMxSelectionMenu labels:
'sin
cos
neg' lines: #() selections: #(sin cos negated)) invokeOn: 0.7"! !

!SMxSelectionMenu methodsFor: 'invocation' stamp: 'sw 11/18/2002 16:24'!
invokeOn: targetObject orSendTo: anObject
	"Pop up the receiver, obtaining a selector; return the result of having the target object perform the selector.  If it dos not understand the selector, give the alternate object a chance"

	| aSelector |
	^ (aSelector := self startUp) ifNotNil:
		[(targetObject respondsTo: aSelector)
			ifTrue:
				[targetObject perform: aSelector]
			ifFalse:
				[anObject perform: aSelector]]! !

!SMxSelectionMenu methodsFor: 'access' stamp: ''!
selections

	^ selections! !

!SMxSelectionMenu methodsFor: 'accessing' stamp: 'sma 5/28/2000 11:38'!
selections: selectionArray
	selections := selectionArray! !

!SMxSelectionMenu methodsFor: 'basic control sequence' stamp: 'jmv 3/2/2010 11:23'!
startUpWithCaption: captionOrNil at: location allowKeyboard: aBoolean
	"Overridden to return value returned by manageMarker.  The boolean parameter indicates whether the menu should be given keyboard focus (if in morphic)"

	| index |
	index := super startUpWithCaption: captionOrNil at: location allowKeyboard: aBoolean.
	(selections isNil or: [(index between: 1 and: selections size) not])
		ifTrue: [^ nil].
	^ selections at: index! !

Object subclass: #SMxPreference
	instanceVariableNames: 'name value defaultValue helpString categoryList changeInformee changeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-System-Support'!

!SMxPreference commentStamp: 'sw 1/14/2003 22:33' prior: 0!
Represents a true/false flag that is under user control and which can be interrogated by a call to SMxPreferences

	name 				a symbol, the formal name of the preference.
	value				a boolean, the current value
	defaultValue		the default value of the preference
	helpString 			string or text, constituting the help message
	localToProject		boolean, whether each project holds its own version
	categoryList			list of categories under which to offer this
	changeInformee 	whom, if anyone, to inform if the value changes:
	changeSelector 		what selector to send to the changeInformee when the value changes!

!SMxPreference methodsFor: 'menu' stamp: 'sw 4/12/2001 23:42'!
categoryList
	"Answer the categoryList"

	^ categoryList! !

!SMxPreference methodsFor: 'initialization' stamp: 'sw 4/29/2001 23:51'!
categoryList: aList
	"Set the receiver's categoryList"

	categoryList := aList! !

!SMxPreference methodsFor: 'change notification' stamp: 'sw 4/12/2001 01:39'!
changeInformee: informee changeSelector: aSelector
	"Set the changeInformee and changeSelector as specified"

	changeInformee := informee.
	changeSelector := aSelector! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/10/2001 15:01'!
defaultValue
	"Answer this preference's defaultValue"

	^ defaultValue! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/18/2002 12:15'!
defaultValue: aValue
	"Set the receiver's defaultValue"

	defaultValue := aValue.! !

!SMxPreference methodsFor: 'menu' stamp: 'sw 4/13/2001 00:04'!
helpString
	"Answer the help string provided for the receiver"

	^ helpString ifNil: ['no help available']! !

!SMxPreference methodsFor: 'menu' stamp: 'sw 4/10/2001 15:02'!
name
	"Answer this preference's name"

	^ name! !

!SMxPreference methodsFor: 'initialization' stamp: 'JuanVuletich 10/10/2010 19:56'!
name: aName defaultValue: aValue helpString: aString categoryList: aList changeInformee: informee changeSelector:  aChangeSelector
	"Initialize the preference from the given values.  There is an extra tolerence here for the symbols #true, #false, and #nil, which are interpreted, when appropriate, as meaning true, false, and nil"

	name := aName asSymbol.
	defaultValue := aValue.
	defaultValue = #true ifTrue: [ defaultValue := true ].
	defaultValue = #false ifTrue: [ defaultValue := false ].
	value := defaultValue.
	helpString := aString.
	categoryList := (aList ifNil: [OrderedCollection with: #unclassified]) collect:
		[:elem | elem asSymbol].

	changeInformee := (informee == nil or: [informee == #nil])
						ifTrue: [nil]
						ifFalse:	[(informee isKindOf: Symbol)
							ifTrue:
								[Smalltalk at: informee]
							ifFalse:
								[informee]].
	changeSelector  := aChangeSelector! !

!SMxPreference methodsFor: 'change notification' stamp: 'sw 4/12/2001 00:03'!
notifyInformeeOfChange
	"If there is a changeInformee, notify her that I have changed value"

	changeInformee ifNotNil: [changeInformee perform: changeSelector]! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/10/2001 15:35'!
preferenceValue
	"Answer the current value of the preference"

	^ value! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/12/2001 23:28'!
preferenceValue: aValue
	"set the value as indicated, and invoke the change selector if appropriate"

	| oldValue |
	oldValue := value.
	value := aValue.
	oldValue ~~ value ifTrue:
		[self notifyInformeeOfChange]! !

!SMxPreference methodsFor: 'debugging' stamp: 'sw 4/13/2001 00:05'!
printOn: aStream
	"Print a string decribing the receiver to the given stream"

	super printOn: aStream.
	aStream nextPutAll: name storeString, ' ', value storeString! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/12/2001 23:28'!
rawValue: aValue
	"set the value as indicated, with no side effects"

	value := aValue! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/12/2001 00:04'!
restoreDefaultValue
	"restore the default value to the preference"

	value := defaultValue! !

!SMxPreference methodsFor: 'value' stamp: 'sw 4/12/2001 00:04'!
togglePreferenceValue
	"Toggle whether the value of the preference"

	value := value not.
	self notifyInformeeOfChange! !

Object subclass: #SMxPreferences
	instanceVariableNames: ''
	classVariableNames: 'DesktopColor DictionaryOfPreferences Parameters'
	poolDictionaries: ''
	category: 'SimpleMorphic-System-Support'!

!SMxPreferences commentStamp: '<historical>' prior: 0!
A general mechanism to store preference choices.  The default setup treats any symbol as a potential boolean flag; flags unknown to the preference dictionary are always returned as false.  

	To open the control panel:		SMxPreferences openFactoredPanel
	To read how to use the panel (and how to make a preference be per-project):
		 SMxPreferences giveHelpWithPreferences

All messages are on the class side.

To query a a preference:
	SMxPreferences logDebuggerStackToFile
or some people prefer the more verbose
	SMxPreferences valueOfFlag: #logDebuggerStackToFile

You can make up a new preference any time.  Do not define a new message in SMxPreferences class. Accessor methods are compiled automatically when you add a preference as illustrated below:

To add a preference (e.g. in the Postscript of a fileout):
	SMxPreferences addPreference: #samplePreference categories: #(general browsing)
		default: true balloonHelp: 'This is an example of a preference added by a do-it'
		projectLocal: false changeInformee: nil changeSelector: nil.

To change a preference programatically:
	SMxPreferences disable: #logDebuggerStackToFile.
Or to turn it on,
	SMxPreferences enable: #logDebuggerStackToFile.
!

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
biggerCursors
	^ self
		valueOfFlag: #biggerCursors
		ifAbsent: [false]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/11/2010 20:12'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont
	AbstractFont promptForFont: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
collapseWindowsInPlace
	^ self
		valueOfFlag: #collapseWindowsInPlace
		ifAbsent: [ false ].! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
debugHaloHandle
	^ self
		valueOfFlag: #debugHaloHandle
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
debugShowDamage
	^ self
		valueOfFlag: #debugShowDamage
		ifAbsent: [ false ].! !

!SMxPreferences class methodsFor: 'hard-coded prefs' stamp: 'JuanVuletich 10/11/2010 22:14'!
desktopMenuTitle
	"Answer the title to be used for the 'meta menu'.  For now, you can hard-code this, later someone should make this be a parameter the user can easily change.  sw 9/6/2000"

	^ 'World'    "This is what it has always been"! !

!SMxPreferences class methodsFor: 'get/set' stamp: 'sw 11/11/1998 11:40'!
doesNotUnderstand: aMessage
	"Look up the message selector as a flag."
	aMessage arguments size > 0 ifTrue: [^ super doesNotUnderstand: aMessage].
	^ self valueOfFlag: aMessage selector
! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
fastDragWindowForMorphic
	^ self
		valueOfFlag: #fastDragWindowForMorphic
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'jmv 4/12/2009 22:15'!
focusFollowsMouse
	^ self
		valueOfFlag: #focusFollowsMouse
		ifAbsent: [ true ]! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'JuanVuletich 10/11/2010 20:35'!
focusIndicatorColor
	^ self
		valueOfFlag: #focusIndicatorColor
		ifAbsent: [Color darkGray]! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'jmv 4/11/2009 23:16'!
focusIndicatorWidth
	^ self
		valueOfFlag: #focusIndicatorWidth
		ifAbsent: [1]! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'jmv 12/9/2009 00:13'!
fullScreenLeavesDeskMargins
	^ self
		valueOfFlag: #fullScreenLeavesDeskMargins
		ifAbsent: [true]! !

!SMxPreferences class methodsFor: 'halos' stamp: 'sw 10/30/2000 13:32'!
haloSpecifications
	"Answer a list of HaloSpecs that describe which halos are to be used, what they should look like, and where they should be situated"

	^ Parameters at: #HaloSpecs ifAbsent:
			[self installHaloTheme: #iconicHaloSpecifications.
			^ Parameters at: #HaloSpecs]

	"SMxPreferences haloSpecifications"
	"SMxPreferences resetHaloSpecifications"
! !

!SMxPreferences class methodsFor: 'halos' stamp: 'JuanVuletich 10/13/2010 11:22'!
iconicHaloSpecifications
	"Answer an array that characterizes the locations, colors, icons, and selectors of the halo handles that may be used in the iconic halo scheme"

	"SMxPreferences resetHaloSpecifications"

^ #(
	"selector					horiz			vert			color info						icon key
	 ---------						------			-----------			-------------------------------			---------------"
	(addCollapseHandle:		left				topCenter		(tan)							collapseIcon)
	(addDebugHandle:			right			topCenter		(blue veryMuchLighter)			debugIcon)
	(addDismissHandle:			left				top				(red muchLighter)				dismissIcon)
	(addRotateHandle:			left				bottom			(blue)							rotateIcon)
	(addMenuHandle:			leftCenter		top				(red)							menuIcon)
	(addGrabHandle:			center			top				(black)							grabIcon)
	(addDragHandle:			rightCenter		top				(brown)							dragIcon)
	(addDupHandle:				right			top				(green)							duplicateIcon)	
	(addHelpHandle:			center			bottom			(lightBlue)						helpIcon)
	(addGrowHandle:			right			bottom			(yellow)							scaleIcon)
	(addFontSizeHandle:		leftCenter		bottom			(lightGreen)						fontSizeIcon)
	(addFontEmphHandle:		rightCenter		bottom			(lightBrown darker)				fontEmphIcon)
	(addRecolorHandle:			right			bottomCenter	(magenta darker)				recolorIcon)
)! !

!SMxPreferences class methodsFor: 'scrollbar parameters' stamp: 'JuanVuletich 10/12/2010 17:02'!
inboardScrollbars
	^ "self
		valueOfFlag: #inboardScrollbars
		ifAbsent: [false]" true! !

!SMxPreferences class methodsFor: 'initialization' stamp: 'JuanVuletich 10/11/2010 20:43'!
initialize
	self initializeParameters.
	self initializeDictionaryOfPreferences! !

!SMxPreferences class methodsFor: 'initialization' stamp: 'JuanVuletich 10/11/2010 20:44'!
initializeDictionaryOfPreferences
	"Initialize the DictionaryOfPreferences to be an empty IdentityDictionary"

	"SMxPreferences initializeDictionaryOfPreferences"

	DictionaryOfPreferences := IdentityDictionary new.! !

!SMxPreferences class methodsFor: 'parameters' stamp: 'JuanVuletich 10/11/2010 20:44'!
initializeParameters
	"SMxPreferences initializeParameters"
	Parameters := IdentityDictionary new.
	self restoreDefaultMenuParameters.
	Parameters at: #maxBalloonHelpLineLength put: 28.
	self initializeTextHighlightingParameters! !

!SMxPreferences class methodsFor: 'text highlighting' stamp: 'JuanVuletich 10/11/2010 20:44'!
initializeTextHighlightingParameters
	"
	SMxPreferences initializeTextHighlightingParameters
	"
	Parameters at: #insertionPointColor put:
		"(Color r: 0.4 g: 1.0 b: 0)"
		"(Color r: 0.9 g: 0.2 b: 0)"
		Color black.
	Parameters at: #textHighlightColor put: (Color r: 0.4 g: 1.0 b: 0).! !

!SMxPreferences class methodsFor: 'text highlighting' stamp: 'JuanVuletich 10/12/2010 12:48'!
insertionPointColor
	^ "Parameters at: #insertionPointColor" Color black! !

!SMxPreferences class methodsFor: 'halos' stamp: 'JuanVuletich 10/11/2010 22:29'!
installHaloSpecsFromArray: anArray

	| aColor |
	^ Parameters at: #HaloSpecs put: 
		(anArray collect:
			[:quin |
				aColor := Color.
				quin fourth do: [:sel | aColor := aColor perform: sel].
				SMxHaloSpec new 
					horizontalPlacement: quin second
					verticalPlacement: quin third 
					color: aColor
					iconSymbol: quin fifth
					addHandleSelector: quin first])! !

!SMxPreferences class methodsFor: 'halos' stamp: 'sw 1/27/2000 23:15'!
installHaloTheme: themeSymbol
	self installHaloSpecsFromArray: (self perform: themeSymbol).
	self setParameter: #HaloTheme to: themeSymbol
	! !

!SMxPreferences class methodsFor: 'parameters' stamp: 'JuanVuletich 10/11/2010 22:13'!
maxBalloonHelpLineLength
	^ "Parameters at: #maxBalloonHelpLineLength" 40! !

!SMxPreferences class methodsFor: 'menu parameters' stamp: 'JuanVuletich 10/11/2010 22:11'!
menuBorderWidth
	^ "Parameters at: #menuBorderWidth" 2! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'jmv 10/11/2010 22:51'!
menuButtonInToolPane
	^ true! !

!SMxPreferences class methodsFor: 'menu parameters' stamp: 'JuanVuletich 10/29/2010 10:45'!
menuColor
	Display depth <= 2 ifTrue: [^ Color white].
	^ Color veryVeryLightGray! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'JuanVuletich 10/29/2010 10:43'!
menuColorFromWorld
	^ self
		valueOfFlag: #menuColorFromWorld
		ifAbsent: [ false ].! !

!SMxPreferences class methodsFor: 'misc' stamp: 'dgd 9/21/2003 13:51'!
menuColorString
	^ ((self valueOfFlag: #menuColorFromWorld)
		ifTrue: ['stop menu-color-from-world']
		ifFalse: ['start menu-color-from-world']) translated! !

!SMxPreferences class methodsFor: 'menu parameters' stamp: 'JuanVuletich 10/11/2010 22:16'!
menuTitleBorderWidth
	^ "Parameters at: #menuTitleBorderWidth"1! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'JuanVuletich 10/29/2010 10:35'!
menuTitleColor
	Display depth = 1 ifTrue: [^ Color white].
	Display depth = 2 ifTrue: [^ Color gray].
	^ (Color r: 0.333 g: 0.667 b: 0.751)! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
modalColorPickers
	^ self
		valueOfFlag: #modalColorPickers
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'personalization' stamp: 'JuanVuletich 10/11/2010 20:45'!
personalizeUserMenu: aMenu
	"The user has clicked on the morphic desktop with the yellow mouse button (option+click on the Mac); a menu is being constructed to present to the user in response; its default target is the current world.  In this method, you are invited to add items to the menu as per personal preferences.
	The default implementation, for illustrative purposes, sets the menu title to 'personal', and adds items for go-to-previous-project, show/hide flaps, and load code updates"
	
	aMenu addTitle: 'personal' translated.  "Remove or modify this as per personal choice"

	aMenu addStayUpIcons.
	aMenu add: 'about this system...' translated target: Smalltalk action: #aboutThisSystem! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
personalizedWorldMenu
	^ self
		valueOfFlag: #personalizedWorldMenu
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'preference-object access' stamp: 'JuanVuletich 10/10/2010 19:41'!
preferenceAt: aSymbol ifAbsent: aBlock
	"Answer the SMxPreference object at the given symbol, or the value of aBlock if not present"
	DictionaryOfPreferences ifNil: [ DictionaryOfPreferences := Dictionary new ].
	^ DictionaryOfPreferences at: aSymbol ifAbsent: aBlock! !

!SMxPreferences class methodsFor: 'halos' stamp: 'jmv 3/2/2010 10:03'!
resetHaloSpecifications
	"SMxPreferences resetHaloSpecifications"

	^ Parameters removeKey: #HaloSpecs ifAbsent: nil! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 11/1/2010 15:45'!
restoreDefaultFonts
	"Since this is called from menus, we can take the opportunity to prompt for missing font styles."
	"SMxPreferences restoreDefaultFonts"
	SMxPreferences setDefaultFonts: #(
"		(setSystemFontTo: 'DejaVu' 9)"
		(setListFontTo: 'DejaVu' 9)
		(setMenuFontTo: 'DejaVu' 10)
		(setWindowTitleFontTo: 'DejaVu' 12)
		(setBalloonHelpFontTo: 'DejaVu' 10)
		(setCodeFontTo: 'DejaVu' 9)
		(setButtonFontTo: 'DejaVu' 9))! !

!SMxPreferences class methodsFor: 'scrollbar parameters' stamp: 'JuanVuletich 10/12/2010 17:02'!
scrollBarsOnRight
	^true! !

!SMxPreferences class methodsFor: 'scrollbar parameters' stamp: 'jmv 8/21/2009 09:35'!
scrollbarThickness
	"Includes border"
	| result |
	result := SMxPreferences standardListFont pointSize + 3.

	self inboardScrollbars
		ifFalse: [ result := result + 2 ].
	
	^ result! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
selectionsMayShrink
	^ self
		valueOfFlag: #selectionsMayShrink
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
selectiveHalos
	^ self
		valueOfFlag: #selectiveHalos
		ifAbsent: [ true ].! !

!SMxPreferences class methodsFor: 'standard queries' stamp: 'al 7/31/2007 16:17'!
serverMode
	^ self
		valueOfFlag: #serverMode
		ifAbsent: [false]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/12/2010 11:46'!
setBalloonHelpFontTo: aFont 
	Smalltalk at: #SMxBalloonMorph
		ifPresent: [:thatClass | thatClass setBalloonFontTo: aFont]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'sw 12/8/1999 22:06'!
setButtonFontTo: aFont
	Parameters at: #standardButtonFont put: aFont! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'jmv 12/1/2004 13:26'!
setCodeFontTo: aFont
	"Not currently sent, but once protocols are sorted out so that we can discriminate on whether a text object being launched is for code or not, might deserve to be reincorporated"

	Parameters at: #standardCodeFont put: aFont! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/12/2010 11:43'!
setDefaultFonts: defaultFontsSpec
		
	| font |
	defaultFontsSpec do: [ :triplet |
		font := StrikeFont familyName: triplet second pointSize: triplet third.
		triplet size > 3 ifTrue: [
			font := font emphasized: triplet fourth ].
		self
			perform: triplet first
			with: font]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'jmv 7/24/2009 19:22'!
setListFontTo: aFont
	"Set the list font as indicated"

	Parameters at: #standardListFont put: aFont! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'sw 12/8/1999 18:04'!
setMenuFontTo: aFont

	Parameters at: #standardMenuFont put: aFont.
	SMxPopUpMenu setMenuFontTo: aFont! !

!SMxPreferences class methodsFor: 'parameters' stamp: 'stp 01/13/2000 13:29'!
setParameter: paramName to: paramValue
	"Set the given field in the parameters dictionary."

	Parameters at: paramName put: paramValue! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/13/2010 10:25'!
setSystemFontTo: aFont
	"Establish the default text font and style"

	aFont ifNil: [^ self].
	StrikeFont default: aFont.! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'jmv 2/12/2008 20:05'!
setWindowTitleFontTo: aFont
	"Set the window-title font to be as indicated"

	Parameters at: #windowTitleFont put: aFont! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
simpleMenus
	^ self
		valueOfFlag: #simpleMenus
		ifAbsent: [ false ].! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'jmv 7/27/2009 19:21'!
standardButtonFont
	"Answer an attractive font to use for buttons"
	"Answer the font to be used for textual flap tab labels"
	^ Parameters at: #standardButtonFont! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/12/2010 15:10'!
standardCodeFont
	"Answer the font to be used in code"

	 ^ Parameters at: #standardCodeFont ifAbsent:
		[Parameters at: #standardCodeFont put: StrikeFont default]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/11/2010 20:24'!
standardListFont
	"Answer the font to be used in lists"

	 ^ Parameters at: #standardListFont ifAbsent:
		[Parameters at: #standardListFont put: StrikeFont default]! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'JuanVuletich 10/11/2010 20:13'!
standardMenuFont
	"Answer the font to be used in menus"

	 ^ Parameters at: #standardMenuFont ifAbsent:
		[Parameters at: #standardMenuFont put: StrikeFont default]! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
systemWindowEmbedOK
	^ self
		valueOfFlag: #systemWindowEmbedOK
		ifAbsent: [false]! !

!SMxPreferences class methodsFor: 'get/set' stamp: 'sw 4/13/2001 01:07'!
valueOfFlag: aFlagName
	"Answer the value of the given flag"

	^ (self preferenceAt: aFlagName ifAbsent: [^ false]) preferenceValue! !

!SMxPreferences class methodsFor: 'get/set' stamp: 'jmv 7/28/2010 11:40'!
valueOfFlag: aFlagName ifAbsent: aBlock
	"Answer the value of the given flag
	Not limited to booleans..."

	^ (self preferenceAt: aFlagName ifAbsent: [^ aBlock value]) preferenceValue! !

!SMxPreferences class methodsFor: 'fonts' stamp: 'jmv 7/27/2009 19:21'!
windowTitleFont
	"Answer the standard font to use for window titles"
	^  Parameters at: #windowTitleFont! !

!SMxPreferences class methodsFor: 'standard queries' stamp: ''!
wordStyleCursorMovement
	^ self
		valueOfFlag: #wordStyleCursorMovement
		ifAbsent: [ true ].! !

!SMxPreferences methodsFor: 'look in class' stamp: 'di 12/4/1999 15:11'!
seeClassSide
	"All the code for SMxPreferences is on the class side"! !

Object subclass: #SMxReadme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxReadme commentStamp: 'StephaneDucasse 12/11/2010 18:47' prior: 0!
SimpleMorphic is an attempt made by juan Vuletich and sponsored by ESUG to clean Morphic.

To start SimpleMorphic do 'SimpleMorphicUIManager start'.

To go back, evaluate 'SimpleMorphicUIManager stop'.

Let's do a comparison:

Size of 4 core classes (Morph, MorphExtension, PasteUpMorph and WorldState)
Pharo / Squeak / Cuis
totalIvars:  39 / 46 / 26
totalClassVars: 15 / 10 / 5
totalInstMethods: 1170 / 1764 / 663
totalClassMethods: 55 / 71 / 16

Size of the whole Morph hierarchy
Pharo / Squeak / Cuis
totalClasses: 197 / 331 / 58
totalIvars:  649 / 1063 / 257
totalClassVars: 54 / 138 / 28
totalInstMethods: 6651 / 9186 / 2115
totalClassMethods: 303 / 858 / 127

SimpleMorphic is much smaller. Core classes are simpler and easier to understand, fix and extend. The most important part is that this is not blind removal of unused code. A lot of the functionality has been redesigned to make it simpler, and the removal was done with great care to result in a consistent system. This work started in 2004, so we're talking of about 6 years of careful work. All this means that SimpleMorphic does not support all the features that Pharo or Squeak might support. Please use the browsers and other tools in Cuis to check what it indeed can do.

Talking about complexity, let's take for example, morph layout. This is started with #doLayoutIn: in Pharo and #doLayoutIfNeeded in SimpleMorphic.

In Pharo, this method calls #adjustLayoutBounds: (19), #layout:in: (149), #layoutProportionallyIn: (10), #computeCellArrangement:in:horizontal:target: (87), #computeGlobalCellArrangement:in:horizontal:wrap:spacing: (31), #computeCellSizes:in:horizontal: (30), #computeExtraSpacing:in:horizontal:target: (136), #layoutLeftToRight:in: (91), #layoutTopToBottom:in: (91), #placeCells:in:horizontal:target: (70). The numbers in parenthesis are the sum of the lines of code of the implementors. Total lines of code for layout (taking only these most important methods) is 714. I doubt there are many people who really understand all of this code.

In SimpleMorphic (Cuis), this calls #layoutSubmorphsIn: (10), #applyLayoutFrameIn: (11), #layout:in: (24). Total lines of code is 45. I believe any smalltalker could understand these in just minutes.

I hope this makes makes it clearer to you what SimpleMorphic is.

Cheers,
Juan Vuletich

================================================
Todo: 
	remove all the FillInTheBlank, PopUp and other bad beast
	remove all the preferences and use settings instead
	kill some more.
	
Welcome to help.



!

Object subclass: #SMxTheWorldMenu
	instanceVariableNames: 'myWorld myHand'
	classVariableNames: 'OpenMenuRegistry'
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxTheWorldMenu commentStamp: 'sw 10/5/2002 00:44' prior: 0!
Instances of SMxTheWorldMenu serve to present the primary Squeak menu obtained by clicking on open desktop, which is variously spoken of as the "screen menu", the "desktop menu", or the "world menu".

myProject is the Project I pertain to.
myWorld is the world, a SMxPasteUpMorph, that I pertain to.
myHand is the hand that invoked the menu.!

!SMxTheWorldMenu class methodsFor: 'open-menu registry' stamp: 'sw 11/10/2002 22:56'!
registerOpenCommand: anArray
	"The array received should be of form {'A Label String'. {TargetObject. #command}  'A Help String'} ; the final element is optional but if present will be used to supply balloon help for the menu item in the Open menu.
	If any previous registration of the same label string is already known, delete the old one."

	self unregisterOpenCommand: anArray first.
	OpenMenuRegistry addLast: anArray! !

!SMxTheWorldMenu class methodsFor: 'open-menu registry' stamp: 'nk 6/29/2003 13:56'!
registeredOpenCommands
	"Answer the list of dynamic open commands, sorted by description"
	
	^self registry asArray sort: [ :a :b | a first asLowercase < b first asLowercase ]! !

!SMxTheWorldMenu class methodsFor: 'open-menu registry' stamp: 'nk 6/29/2003 13:55'!
registry
	"Answer the registry of dynamic open commands"
	
	^OpenMenuRegistry ifNil: [OpenMenuRegistry := OrderedCollection new].
! !

!SMxTheWorldMenu class methodsFor: 'open-menu registry' stamp: 'nk 6/29/2003 13:55'!
unregisterOpenCommand: label
	"Remove the open command with the given label from the registry"
	
	self registry removeAllSuchThat: [:e | e first = label]! !

!SMxTheWorldMenu methodsFor: 'mechanics' stamp: 'jmv 5/20/2006 16:35'!
adaptToWorld: aWorld
        myWorld := aWorld.
        myHand := aWorld primaryHand.! !

!SMxTheWorldMenu methodsFor: 'menu' stamp: 'nk 2/15/2004 09:38'!
addGestureHelpItemsTo: aMenuMorph 
! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'jmv 8/23/2010 10:20'!
alphabeticalMorphMenu
	| list splitLists menu firstChar lastChar subMenu |
	list := SMxMorph withAllSubclasses select: [:m | m includeInNewMorphMenu].
	list := list asArray sort: [:c1 :c2 | c1 name < c2 name].
	splitLists := self splitNewMorphList: list depth: 3.
	menu := SMxMenuMorph new defaultTarget: self.
	1 to: splitLists size
		do: 
			[:i | 
			firstChar := i = 1 
				ifTrue: [$A]
				ifFalse: 
					[((splitLists at: i - 1) last name first asInteger + 1) 
								asCharacter].
			lastChar := i = splitLists size 
						ifTrue: [$Z]
						ifFalse: [(splitLists at: i) last name first].
			subMenu := SMxMenuMorph new.
			(splitLists at: i) do: 
					[:cl | 
					subMenu 
						add: cl name
						target: self
						selector: #newMorphOfClass:event:
						argument: cl].
			menu add: firstChar asString , ' - ' , lastChar asString subMenu: subMenu].
	^menu! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:25'!
appearanceDo
	"Build and show the appearance menu for the world."

	self doPopUp: self appearanceMenu! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'jmv 8/26/2008 11:30'!
appearanceMenu
	"Build the appearance menu for the world."
	
	^self fillIn: (self menu: 'appearance...') from: {

		{'system fonts...' . { self . #standardFontDo} . 'Choose the standard fonts to use for code, lists, menus, window titles, etc.'}.
		nil.
		{#menuColorString . { SMxPreferences . #toggleMenuColorPolicy} . 'Governs whether menu colors should be derived from the desktop color.'}.
		nil.
		{'full screen on' . { self . #fullScreenOn} . 'puts you in full-screen mode, if not already there.'}.
		{'full screen off' . { self . #fullScreenOff} . 'if in full-screen mode, takes you out of it.'}.
		nil.
		{'set display depth...' . {self. #setDisplayDepth} . 'choose how many bits per pixel.'}.
		{'set desktop color...' . {self. #changeBackgroundColor} . 'choose a uniform color to use as desktop background.'}.
	}! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'JuanVuletich 11/1/2010 15:37'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu := SMxMenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpIcons.
	self fillIn: menu
		from: { 
				{ 
					'restore display (r)'.
					{ 
						SimpleMorphicUIManager smxWorld.
						#restoreMorphicDisplay}.
					'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.'}.
				nil}.
	SMxPreferences simpleMenus 
		ifFalse: 
			[self fillIn: menu
				from: { 
						{ 
							'open...'.
							{ 
								self.
								#openWindow}}.
						{ 
							'windows...'.
							{ 
								self.
								#windowsDo}}.
						{ 
							'changes...'.
							{ 
								self.
								#changesDo}}}].
	self fillIn: menu
		from: { 
				{ 
					'help...'.
					{ 
						self.
						#helpDo}.
					'puts up a menu of useful items for updating the system, determining what version you are running, and much else'}.
				{ 
					'appearance...'.
					{ 
						self.
						#appearanceDo}.
					'put up a menu offering many controls over appearance.'}}.
	self fillIn: menu
		from: { 
				nil.
				{ 
					'new morph...'.
					{ 
						self.
						#newMorph}.
					'Offers a variety of ways to create new objects'}.
				}.
	SMxPreferences simpleMenus 
		ifFalse: 
			[self fillIn: menu
				from: { 
						{ 
							'debug...'.
							{ 
								self.
								#debugDo}.
							'a menu of debugging items'}}].
	self fillIn: menu
		from: { 
				nil.
				{ 
					'save'.
					{ 
						Smalltalk .
						#saveSession}.
					'save the current version of the image on disk'}.
				{ 
					'save as...'.
					{ 
						Smalltalk .
						#saveAs}.
					'save the current version of the image on disk under a new name.'}.
				{ 
					'save as new version'.
					{ 
						Smalltalk .
						#saveAsNewVersion}.
					'give the current image a new version-stamped name and save it under that name on disk.'}.
				{ 
					'save and quit'.
					{ 
						self.
						#saveAndQuit}.
					'save the current image on disk, and quit out of Squeak.'}.
				{ 
					'quit'.
					{ 
						self.
						#quitSession}.
					'quit out of Squeak.'}}.
	^menu! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'ar 10/5/2000 18:54'!
changeBackgroundColor
	"Let the user select a new background color for the world"

	myWorld changeColorTarget: myWorld selector: #color: originalColor: myWorld color hand: myWorld activeHand.
! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:26'!
changesDo
	"Build the changes menu for the world."

	self doPopUp: self changesMenu! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'jmv 7/21/2009 09:26'!
changesMenu
        "Build the changes menu for the world."

        | menu |
        menu := self menu: 'changes...'.
        self fillIn: menu from: {
                { 'file out current change set' . { ChangeSet current . #verboseFileOut}.
                                'Write the current change set out to a file whose name reflects the change set name and the current date & time.'}.
                { 'create new change set...' . { ChangeSorter . #newChangeSet}. 'Create a new change set and make it the current one.'}.
                { 'browse changed methods' . { ChangeSet  . #browseChangedMessages}.  'Open a message-list browser showing all methods in the current change set'}.
                { 'check change set for slips' . { self  . #lookForSlips}.
                                'Check the current change set for halts, references to the Transcript, etc., and if any such thing is found, open up a message-list browser detailing all possible slips.'}.

                nil.
                { 'simple change sorter' . {self. #openChangeSorter1}.  'Open a 3-paned changed-set viewing tool'}.
                { 'dual change sorter' . {self. #openChangeSorter2}.
                                'Open a change sorter that shows you two change sets at a time, making it easy to copy and move methods and classes between them.'}.
                nil.
                { 'browse recent submissions' . { RecentMessageSet . #browseRecentSubmissions}.
                                'Open a new recent-submissions browser.  A recent-submissions browser is a message-list browser that shows the most recent methods that have been submitted.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions.'}.

                { 'find recent submissions' . { #myWorld . #openRecentSubmissionsBrowser:}.
                                'Make an open recent-submissions browser be the front-window, expanding a collapsed one or creating a new one if necessary.  A recent-submissions browser is a message-list browser that shows the most recent methods that have been submitted, latest first.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions at the top of the browser.'}.

			nil.
                { 'recently logged changes...' . { ChangeList . #browseRecentLog}.'Open a change-list browser on the latter part of the changes log.  You can use this browser to recover logged changes which were not saved in your image, in the event of a crash or other interruption.'}.

                { 'recent log file...' . { Smalltalk . #writeRecentToFile}.
                                'Create a file holding the logged changes (going as far back as you wish), and open a window on that file.'}.

                nil.
                { 'save world as morph file' . {self. #saveWorldInFile}. 'Save a file that, when reloaded, reconstitutes the current World.'}.
                nil.
        }.
        ^ menu! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'dgd 9/21/2003 17:43'!
cleanUpWorld
	(SMxSelectionMenu confirm:
'This will remove all windows except those
containing unsubmitted text edits, and will
also remove all non-window morphs (other
than flaps) found on the desktop.  Are you
sure you want to do this?' translated)
		ifFalse: [^ self].

	myWorld allNonFlapRelatedSubmorphs do:
		[:m | m delete].
	(SMxSystemWindow windowsIn: myWorld satisfying: [:w | w model canDiscardEdits])
		do: [:w | w delete]! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'RAA 6/16/2000 09:50'!
colorForDebugging: aMenu

        "aMenu color: self myMenuColor"

        "aMenu color: Color lightRed"

! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:26'!
debugDo

	self doPopUp: self debugMenu! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'jmv 7/21/2009 09:29'!
debugMenu

        | menu |

        menu := self menu: 'debug...'.
        ^self fillIn: menu from: { 
                { 'inspect world' . { #myWorld . #inspect } }.
                { 'explore world' . { #myWorld . #explore } }.
                { 'MessageTally all Processes' . { self . #startMessageTally } }.
                { 'MessageTally UI and browse' . { self . #startThenBrowseMessageTally } }.
                nil.
                { 'start drawing all again' . { #myWorld . #removeAllKnownFailing } }.
                { 'start stepping again' . { #myWorld . #resumeAfterStepError } }.
                { 'close all debuggers' . { Debugger . #closeAllDebuggers } }.
        }
! !

!SMxTheWorldMenu methodsFor: 'action' stamp: 'jmv 5/20/2006 16:37'!
doMenuItem: aCollection with: event
	| realTarget selector nArgs |
	selector := aCollection second.
	nArgs := selector numArgs.
	realTarget := aCollection first.
	realTarget == #myWorld ifTrue: [realTarget := myWorld].
	realTarget == #myHand ifTrue: [realTarget := myHand].
	^nArgs = 0 
		ifTrue:[realTarget perform: selector]
		ifFalse:[realTarget perform: selector with: event].
! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 6/12/2000 09:13'!
doPopUp: aMenu

	aMenu popUpForHand: myHand in: myWorld.
! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'jmv 5/6/2009 22:48'!
fillIn: aMenu from: dataForMenu
	"A menu constructor utility by RAA.  dataForMenu is a list of items which mean:
			nil								Indicates to add a line

			first element is symbol		Add updating item with the symbol as the wording selector
			second element is a list		second element has the receiver and selector

			first element is a string		Add menu item with the string as its wording
			second element is a list		second element has the receiver and selector

			a third element exists			Use it as the balloon text
			a fourth element exists		Use it as the enablement selector (updating case only)"

	| item |

	dataForMenu do: [ :itemData |
		itemData ifNil: [aMenu addLine] ifNotNil:
			[item := (itemData first isKindOf: Symbol)
				ifTrue: 
					[aMenu 
						addUpdating: itemData first 
						target: self 
						selector: #doMenuItem:with: 
						argumentList: {itemData second}]
				 ifFalse:
					[aMenu 
						add: itemData first translated
						target: self 
						selector: #doMenuItem:with: 
						argumentList: {itemData second}].
			itemData size >= 3 ifTrue:
				[aMenu balloonTextForLastItem: itemData third translated.
			itemData size >= 4 ifTrue:
				[item enablementSelector: itemData fourth]]]].

	^ aMenu! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 11/1/2010 15:37'!
fullScreenOff

	Display fullScreenMode: false.
	DisplayScreen checkForNewScreenSize.
	SimpleMorphicUIManager smxWorld restoreMorphicDisplay! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 11/1/2010 15:37'!
fullScreenOn

	Display fullScreenMode: true.
	DisplayScreen checkForNewScreenSize.
	SimpleMorphicUIManager smxWorld restoreMorphicDisplay! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'nk 2/15/2004 09:37'!
garbageCollect
	"Do a garbage collection, and report results to the user."

	SmalltalkImage current garbageCollectAndReport! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:26'!
helpDo
	"Build and show the help menu for the world."

	self doPopUp: self helpMenu! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/10/2010 08:07'!
helpMenu
        "Build the help menu for the world."
        |  menu |

  	menu := self menu: 'help...' translated.

        self fillIn: menu from:
        {
                {'about this system...'. {Smalltalk. #aboutThisSystem}. 'current version information.'}.
                {'preferences...'. {SMxPreferences. #openPreferencesInspector}. 'view and change various options.'}.
	}.

	self addGestureHelpItemsTo: menu.

	self fillIn: menu from:
	{
                {'world menu help'. { self . #worldMenuHelp}. 'helps find menu items buried in submenus.'}.
                nil.

                {'vm statistics' . { self . #vmStatistics}.  'obtain some intriguing data about the vm.'}.
			nil.
                {'space left' . { self . #garbageCollect}. 'perform a full garbage-collection and report how many bytes of space remain in the image.'}.
        }.

	^menu

! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'sd 5/23/2003 14:49'!
lookForSlips

	ChangeSet current lookForSlips! !

!SMxTheWorldMenu methodsFor: 'mechanics' stamp: 'jmv 5/17/2009 23:42'!
menu: titleString
	"Create a menu with the given title, ready for filling"

	| menu |
	(menu := SMxMenuMorph entitled: titleString translated) 
		defaultTarget: self; 
		addStayUpIcons;
		commandKeyHandler: self.
	self colorForDebugging: menu.
	^ menu
! !

!SMxTheWorldMenu methodsFor: 'action' stamp: 'RAA 5/26/2000 10:18'!
menuColorString

	^ SMxPreferences menuColorString! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/10/2010 07:52'!
newMorph
	"The user requested 'new morph' from the world menu.  Put up a menu that allows many ways of obtaining new morphs.  If the preference #classicNewMorphMenu is true, the full form of yore is used; otherwise, a much shortened form is used."
	| menu subMenu catDict shortCat class |
	menu := self menu: 'Add a new morph'.
	menu
		
		add: 'from paste buffer' translated
		target: myHand
		action: #pasteMorph;
		
		add: 'from alphabetical list' translated
		subMenu: self alphabeticalMorphMenu.
	menu addLine.
	SMxPreferences classicNewMorphMenu ifTrue: [
		menu addLine.
		catDict := Dictionary new.
		Smalltalk globals organization categories do: [ :cat |
			((cat beginsWith: 'SimpleMorphic-') and: [ (#('SimpleMorphic-Menus' 'SimpleMorphic-Support' ) includes: cat) not ]) ifTrue: [
				shortCat := (cat
					copyFrom: 'SimpleMorphic-' size + 1
					to: cat size) translated.
				(Smalltalk globals organization listAtCategoryNamed: cat) do: [ :cName |
					class := Smalltalk at: cName.
					((class inheritsFrom: SMxMorph) and: [ class includeInNewMorphMenu ]) ifTrue: [
						(catDict includesKey: shortCat)
							ifTrue: [ (catDict at: shortCat) addLast: class ]
							ifFalse: [
								catDict
									at: shortCat
									put: (OrderedCollection with: class) ]]]]].
		catDict keys asArray sort do: [ :categ |
			subMenu := SMxMenuMorph new.
			((catDict at: categ) asArray sort: [ :c1 :c2 |
				c1 name < c2 name ]) do: [ :cl |
				subMenu
					add: cl name
					target: self
					selector: #newMorphOfClass:event:
					argument: cl ].
			menu
				add: categ
				subMenu: subMenu ]].
	self doPopUp: menu.! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'jmv 4/6/2009 16:57'!
newMorphOfClass: morphClass event: evt
	"Attach a new morph of the given class to the invoking hand."

	| m |
	m := morphClass new.
	evt hand attachMorph: m.
	myWorld startSteppingSubmorphsOf: m.
! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/14/2010 09:07'!
openBrowser
	SMxBrowserWindow openBrowser! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/21/2010 17:30'!
openChangeSorter1

	SMxBrowserWindow openChangeSorterAsMorph: ChangeSorter new! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/21/2010 17:38'!
openChangeSorter2

	SMxBrowserWindow openDualChangeSorterAsMorph: DualChangeSorter new! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/28/2010 16:10'!
openFileList
	UIManager default openFileList: (FileList new directory: FileDirectory default)! !

!SMxTheWorldMenu methodsFor: 'construction' stamp: 'JuanVuletich 10/12/2010 11:31'!
openMenu
	"Build the open window menu for the world."

	| menu |
	menu := self menu: 'open...'.
	self fillIn: menu from: {

		{'browser' . { self . #openBrowser}. 'A five-paned tool that lets you see all the code in the system'}.
		{'workspace' . {self . #openWorkspace}. 'A window for evaluating Smalltalk expressions' }.
		{'text editor' . {self . #openTextEditor}. 'A window for composing text' }.
		{'file list' . {self . #openFileList} . 'A tool allowing you to browse any file' }.
		{'transcript' . {self . #openTranscript}. 'A window used to report messages sent to Transcript' }.
		{ 'process browser' . { ProcessBrowser . #open } }.
		nil.
		{'message names' . { self . #openMessageNames} . 'A tool for finding and editing methods that contain any given keyword in their names.'}.
		nil.
		{'simple change sorter' . {self . #openChangeSorter1} . 'A tool allowing you to view the methods in a single change set' }.
		{'dual change sorter' . {self . #openChangeSorter2} . 'A tool allowing you to compare and manipulate two change sets concurrently' }.
		nil.
	}.
	self fillIn: menu from: self class registeredOpenCommands.
	^menu! !

!SMxTheWorldMenu methodsFor: 'action' stamp: 'JuanVuletich 10/12/2010 11:31'!
openMessageNames
	"Bring a MessageNames tool to the front"

	MessageNames openMessageNames! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/15/2010 21:35'!
openTextEditor

	SMxSystemWindow
		openStringHolder: StringHolder new
		asMorphLabel: 'Text Editor'
		inWorld: myWorld! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/15/2010 21:36'!
openTranscript

	SMxSystemWindow
		openStringHolder: Transcript
		asMorphLabel: 'Transcript'
		inWorld: myWorld
		wrap: true! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:26'!
openWindow

	self doPopUp: self openMenu! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/18/2010 14:19'!
openWorkspace

	SMxSystemWindow
		openStringHolder: Workspace new
		asMorphLabel: 'Workspace'
		inWorld: myWorld! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'jmv 2/15/2008 00:47'!
quitSession
	Smalltalk 
		snapshot: (self confirm: 'Save changes before quitting?' translated orCancel: [^ self])
		andQuit: true! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'jmv 2/15/2008 00:47'!
saveAndQuit

	Smalltalk snapshot: true andQuit: true! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'StephaneDucasse 12/11/2010 21:05'!
saveWorldInFile
	"Save the world's submorphs, model, and stepList in a file.  "

	| fileName fileStream aClass |
	fileName := SMxFillInTheBlankMorph request: 'File name for this morph?'.
	fileName isEmpty ifTrue: [^ self].  "abort"

	"Save only model, stepList, submorphs in this world"
	myWorld submorphsDo: [:m |
		m allMorphsDo: [:subM | subM prepareToBeSaved]].	"Amen"

	fileStream := FileStream newFileNamed: fileName, '.morph'.
	aClass := myWorld model ifNil: [nil] ifNotNil: [myWorld model class].
	fileStream fileOutClass: aClass andObject: myWorld.
! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'jmv 10/7/2009 11:14'!
setDisplayDepth
	"Let the user choose a new depth for the display. "

	| result oldDepth allDepths allLabels menu hasBoth |
	oldDepth := Display nativeDepth.
	allDepths := #(1 -1 2 -2 4 -4 8 -8 16 -16 32 -32) 
				select: [:d | Display supportsDisplayDepth: d].
	hasBoth := (allDepths anySatisfy: [:d | d > 0]) 
				and: [allDepths anySatisfy: [:d | d < 0]].
	allLabels := allDepths collect: 
					[:d | 
					String streamContents: 
							[:s | 
							s nextPutAll: (d = oldDepth ifTrue: ['<on>'] ifFalse: ['<off>']).
							s print: d abs.
							hasBoth 
								ifTrue: 
									[s 
										nextPutAll: (d > 0 ifTrue: ['  (big endian)'] ifFalse: ['  (little endian)'])]]].
	menu := SMxSelectionMenu labels: allLabels selections: allDepths.
	result := menu startUpWithCaption: 'Choose a display depth' translated.
	result ifNotNil: [Display newDepth: result].
	oldDepth := oldDepth abs! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'aoy 2/15/2003 21:19'!
splitNewMorphList: list depth: d 
	| middle c prev next out |
	d <= 0 ifTrue: [^Array with: list].
	middle := list size // 2 + 1.
	c := (list at: middle) name first.
	prev := middle - 1.
	[prev > 0 and: [(list at: prev) name first = c]] 
		whileTrue: [prev := prev - 1].
	next := middle + 1.
	[next <= list size and: [(list at: next) name first = c]] 
		whileTrue: [next := next + 1].
	"Choose the better cluster"
	middle := middle - prev < (next - middle) 
				ifTrue: [prev + 1]
				ifFalse: [next]. 
	middle = 1 ifTrue: [middle := next].
	middle >= list size ifTrue: [middle := prev + 1].
	(middle = 1 or: [middle >= list size]) ifTrue: [^Array with: list].
	out := WriteStream on: Array new.
	out nextPutAll: (self splitNewMorphList: (list copyFrom: 1 to: middle - 1)
				depth: d - 1).
	out 
		nextPutAll: (self splitNewMorphList: (list copyFrom: middle to: list size)
				depth: d - 1).
	^out contents! !

!SMxTheWorldMenu methodsFor: 'popups' stamp: 'RAA 5/26/2000 10:27'!
standardFontDo
	"Build and show the standard font menu"

	self doPopUp: SMxPreferences fontConfigurationMenu! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 11/1/2010 15:37'!
startMessageTally
	"Tally on all the processes in the system, and not only the UI"
	
	(self confirm: 'MessageTally all the processes in
the system, until the mouse pointer
goes to the top of the screen') ifTrue: [
		MessageTally spyAllOn: [
			[Sensor peekMousePt y > 0] whileTrue: [SimpleMorphicUIManager smxWorld doOneCycle]]]! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 11/1/2010 15:37'!
startThenBrowseMessageTally
	"Tally only the UI process"
	
	(self confirm: 'MessageTally the UI process until the
mouse pointer goes to the top of the screen')
		ifTrue: [TimeProfileBrowser
				onBlock: [[Sensor peekMousePt y > 10]
						whileTrue: [SimpleMorphicUIManager smxWorld doOneCycle]]]! !

!SMxTheWorldMenu methodsFor: 'action' stamp: 'RAA 5/26/2000 11:32'!
toggleWindowPolicy

	SMxPreferences toggleWindowPolicy! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/15/2010 21:35'!
vmStatistics
	"Open a string view on a report of vm statistics"
	SMxSystemWindow
		openStringHolder: (StringHolder new contents: SmalltalkImage current vmStatisticsReportString)
		asMorphLabel: 'VM Statistics'
		inWorld: myWorld! !

!SMxTheWorldMenu methodsFor: 'windows & flaps menu' stamp: 'RAA 5/26/2000 10:27'!
windowsDo
	"Build the windows menu for the world."

	self doPopUp: self windowsMenu! !

!SMxTheWorldMenu methodsFor: 'windows & flaps menu' stamp: 'JuanVuletich 11/1/2010 10:27'!
windowsMenu
        "Build the windows menu for the world."

	^ self fillIn: (self menu: 'windows') from: {  
		{ 'find window' . { #myWorld . #findWindow: }. 'Presents a list of all windows; if you choose one from the list, it becomes the active window.'}.
		{ 'find changed browsers...' . { #myWorld . #findDirtyBrowsers: }. 'Presents a list of browsers that have unsubmitted changes; if you choose one from the list, it becomes the active window.'}.
		{ 'find changed windows...' . { #myWorld . #findDirtyWindows: }. 'Presents a list of all windows that have unsubmitted changes; if you choose one from the list, it becomes the active window.'}.
		nil.
		{ 'find a transcript' . { #myWorld . #findATranscript: }. 'Brings an open Transcript to the front, creating one if necessary, and makes it the active window'}.
		{ 'find a fileList' . { #myWorld . #findAFileList: }. 'Brings an open fileList  to the front, creating one if necessary, and makes it the active window'}.
		{ 'find a change sorter' . { #myWorld . #findAChangeSorter: }. 'Brings an open change sorter to the front, creating one if necessary, and makes it the active window'}.
		{ 'find message names' . { #myWorld . #findAMessageNamesWindow: }. 'Brings an open MessageNames window to the front, creating one if necessary, and makes it the active window'}.
		nil.
		{ 'collapse all windows' . { #myWorld . #collapseAll }. 'Reduce all open windows to collapsed forms that only show titles.'}.
		{ 'expand all windows' . { #myWorld . #expandAll }. 'Expand all collapsed windows back to their expanded forms.'}.
		{ 'close top window' . { SMxSystemWindow . #closeTopWindow }. 'Close the topmost window if possible.'}.
		{ 'send top window to back' . { SMxSystemWindow . #sendTopWindowToBack  }. 'Make the topmost window become the backmost one, and activate the window just beneath it.'}.
		{ 'move windows onscreen' . { #myWorld . #bringWindowsFullOnscreen }. 'Make all windows fully visible on the screen'}.
		nil.
		{ 'delete unchanged windows' . { #myWorld . #closeUnchangedWindows }. 'Deletes all windows that do not have unsaved text edits.'}.
		{ 'delete non-windows' . { #myWorld . #deleteNonWindows }. 'Deletes all non-window morphs lying on the world.'}.
		{ 'delete both of the above' . { self . #cleanUpWorld }. 'deletes all unchanged windows and also all non-window morphs lying on the world, other than flaps.'}.
	}! !

!SMxTheWorldMenu methodsFor: 'mechanics' stamp: 'jmv 5/20/2006 16:38'!
world: aWorld hand: aHand

	myWorld := aWorld.
	myHand := aHand.! !

!SMxTheWorldMenu methodsFor: 'commands' stamp: 'JuanVuletich 10/15/2010 21:36'!
worldMenuHelp
	| aList aMenu cnts explanation |
	"self currentWorld primaryHand worldMenuHelp"

	aList := OrderedCollection new.
	#(helpMenu changesMenu openMenu debugMenu windowsMenu appearanceMenu) 
		with:
	#('help' 'changes' 'open' 'debug' 'windows' 'appearance' ) do:
		[:sel :title | aMenu := self perform: sel.
			aMenu items do:
				[:it | (((cnts := it contents) = 'keep this menu up') or: [cnts isEmpty])
					ifFalse: [aList add: (cnts, ' - ', title translated)]]].
	aList := aList asArray sort: [:a :b | a asLowercase < b asLowercase].

	explanation := String streamContents: [:aStream | aList do:
		[:anItem | aStream nextPutAll: anItem; cr]].

	SMxSystemWindow
		openStringHolder: (StringHolder new contents: explanation)
		asMorphLabel: 'Where in the world menu is...' translated
		inWorld: myWorld! !

Object subclass: #SMxWorldState
	instanceVariableNames: 'hands viewBox canvas damageRecorder stepList lastStepTime lastStepMessage lastCycleTime alarms lastAlarmTime remoteServer drawingFailingMorphs waitDelay pause'
	classVariableNames: 'DeferredUIMessages MaxCycleLapse MinCycleLapse'
	poolDictionaries: ''
	category: 'SimpleMorphic-Kernel'!

!SMxWorldState commentStamp: 'ls 7/10/2003 19:30' prior: 0!
The state of a Morphic world.  (This needs some serious commenting!!!!)


The MinCycleLapse variable holds the minimum amount of time that a morphic cycle is allowed to take.  If a cycle takes less than this, then interCyclePause: will wait until the full time has been used up.!

!SMxWorldState class methodsFor: 'class initialization' stamp: 'RAA 7/15/2000 12:58'!
addDeferredUIMessage: valuableObject

	self deferredUIMessages nextPut: valuableObject.

! !

!SMxWorldState class methodsFor: 'accessing' stamp: 'RAA 1/7/2001 16:32'!
classVersion

	^1		"force cleanup of alarms and stepList"! !

!SMxWorldState class methodsFor: 'class initialization' stamp: 'RAA 7/15/2000 12:58'!
deferredUIMessages

	^DeferredUIMessages ifNil: [DeferredUIMessages := SharedQueue new].
! !

!SMxWorldState class methodsFor: 'class initialization' stamp: 'jmv 5/27/2010 09:50'!
initialize
	"SMxWorldState initialize"

	MinCycleLapse := 20.		"allows 50 frames per second..."
	MaxCycleLapse := 200.		"never wait more than this to react to user events"
	DeferredUIMessages := SharedQueue new.! !

!SMxWorldState class methodsFor: 'class initialization' stamp: 'jmv 11/6/2009 12:37'!
minCycleLapse: anInteger

	MinCycleLapse := anInteger! !

!SMxWorldState methodsFor: 'hands' stamp: 'JuanVuletich 11/1/2010 15:29'!
activeHand

	^ SimpleMorphicUIManager smxActiveHand! !

!SMxWorldState methodsFor: 'alarms' stamp: 'ar 9/11/2000 16:43'!
addAlarm: aSelector withArguments: argArray for: aTarget at: scheduledTime
	"Add a new alarm with the given set of parameters"
	self alarms add: 
		(SMxMorphicAlarm 
			scheduledAt: scheduledTime
			receiver: aTarget
			selector: aSelector
			arguments: argArray).! !

!SMxWorldState methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 22:59'!
addKnownFailing: aMorph
	drawingFailingMorphs add: aMorph! !

!SMxWorldState methodsFor: 'alarms' stamp: 'ar 9/11/2000 17:11'!
adjustAlarmTimes: nowTime
	"Adjust the alarm times after some clock weirdness (such as roll-over, image-startup etc)"
	| deltaTime |
	deltaTime := nowTime - lastAlarmTime.
	self alarms do:[:alarm| alarm scheduledTime: alarm scheduledTime + deltaTime].! !

!SMxWorldState methodsFor: 'stepping' stamp: 'jmv 11/12/2009 10:41'!
adjustWakeupTimes: now
	"Fix the wakeup times in my step list. This is necessary when this world has been restarted after a pause, say because some other view had control, after a snapshot, or because the millisecond clock has wrapped around. (The latter is a rare occurence with a 32-bit clock!!)"
	"jmv: I say it is only needed on clock rollover. See senders of #adjustWakeupTimes:
	and the conditions under it is called"

	| deltaTime |
	deltaTime := now - lastStepTime.
	stepList do: [ :entry | entry scheduledTime: entry scheduledTime + deltaTime ].
	lastStepTime := now! !

!SMxWorldState methodsFor: 'stepping' stamp: 'jmv 11/12/2009 10:40'!
adjustWakeupTimesIfNecessary
	"Fix the wakeup times in my step list if necessary. This is needed after a snapshot, after a long pause (say because some other view had control or because the user was selecting from an MVC-style menu) or when the millisecond clock wraps around (a very rare occurence with a 32-bit clock!!)."
	"jmv: I say it is only needed on clock rollover. See commented code below."

	| now |
	now := Time millisecondClockValue.
	
	"((now < lastStepTime) or: [(now - lastStepTime) > 5000])"
	now < lastStepTime		"clock slipped"
		 ifTrue: [ self adjustWakeupTimes: now ]! !

!SMxWorldState methodsFor: 'alarms' stamp: 'jmv 12/30/2009 11:06'!
alarmSortBlock

	"Please pardon the hackery below. Since the block provided by this method is retained elsewhere, it is possible that the block argument variables would retain references to objects that were no longer really needed. In one case, this feature resulted in doubling the size of a published project."
"
	| answer |
	^[ :alarm1 :alarm2 | 
		answer := alarm1 scheduledTime < alarm2 scheduledTime.
		alarm1 := alarm2 := nil.
		answer
	]
"

	"This used to be needed, as old BlockContext kept referencing to the last value of the arguments.
	This is no longer true with Eliot's BlockClosures, and asigning to block args is discouraged, 
	and perhaps not supported (see preference #allowBlockArgumentAssignment)"

	^[ :alarm1 :alarm2 | alarm1 scheduledTime < alarm2 scheduledTime ]! !

!SMxWorldState methodsFor: 'alarms' stamp: 'RAA 1/5/2001 10:46'!
alarms

	^alarms ifNil: [alarms := Heap sortBlock: self alarmSortBlock]! !

!SMxWorldState methodsFor: 'canvas' stamp: 'JuanVuletich 10/12/2010 11:49'!
assuredCanvas
	(canvas isNil or: [(canvas extent ~= viewBox extent) or: [canvas form depth ~= Display depth]])
		ifTrue: [
			"allocate a new offscreen canvas the size of the window"
			self canvas: ("Display defaultCanvasClass" SMxFormCanvas extent: viewBox extent)].
	^ self canvas! !

!SMxWorldState methodsFor: 'canvas' stamp: 'di 6/7/1999 17:44'!
canvas

	^ canvas! !

!SMxWorldState methodsFor: 'canvas' stamp: 'jmv 3/2/2010 16:46'!
canvas: x 
	canvas := x.
	damageRecorder
		ifNil: [ damageRecorder := SMxDamageRecorder new]
		ifNotNil: [ damageRecorder doFullRepaint]! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'RAA 5/24/2000 13:13'!
checkIfUpdateNeeded

	damageRecorder updateIsNeeded ifTrue: [^true].
	hands do: [:h | (h hasChanged and: [h needsToBeDrawn]) ifTrue: [^true]].
	^false  "display is already up-to-date"
! !

!SMxWorldState methodsFor: 'stepping' stamp: 'jmv 1/12/2010 11:05'!
cleanseStepListForWorld: aWorld
	"Remove morphs from the step list that are not in this World.  Often were in a flap that has moved on to another world."

	| deletions morphToStep |
	deletions := nil.
	stepList do: [:entry |
		morphToStep := entry receiver.
		morphToStep world == aWorld ifFalse:[
			deletions ifNil: [deletions := OrderedCollection new].
			deletions addLast: entry]].

	deletions ifNotNil:[
		deletions do: [:entry|
			self stopStepping: entry receiver]].

	self alarms copy do:[:entry|
		morphToStep := entry receiver.
		((morphToStep is: #SMxMorph) and: [ morphToStep world == aWorld ]) 
			ifFalse: [ self removeAlarm: entry selector for: entry receiver ]].! !

!SMxWorldState methodsFor: 'initialization' stamp: 'jmv 1/2/2010 23:13'!
clearWaitDelay
	waitDelay ifNotNil: [
		waitDelay unschedule.
		waitDelay := nil ]! !

!SMxWorldState methodsFor: 'object fileIn' stamp: 'jmv 12/29/2009 15:18'!
convertAlarms
	
	alarms ifNotNil: [alarms sortBlock: self alarmSortBlock].	"ensure cleaner block"! !

!SMxWorldState methodsFor: 'object fileIn' stamp: 'jmv 12/29/2009 15:20'!
convertStepList
	"Convert the old-style step list (an Array of Arrays) into the new-style SMxStepMessage heap"

	stepList sortBlock: self stepListSortBlock	"ensure that we have a cleaner block"! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 4/27/2010 11:07'!
displayWorld: aWorld submorphs: submorphs
	"Update this world's display."

	| deferredUpdateMode worldDamageRects handsToDraw handDamageRects allDamage |

	submorphs do: [:m | m doLayoutIfNeeded].  "force re-layout if needed"
	self checkIfUpdateNeeded ifFalse: [^ self].  "display is already up-to-date"

	deferredUpdateMode := self doDeferredUpdatingFor: aWorld.
	deferredUpdateMode ifFalse: [self assuredCanvas].

	worldDamageRects := self drawWorld: aWorld submorphs: submorphs invalidAreasOn: canvas.  "repair world's damage on canvas"
	"self handsDo:[:h| h noticeDamageRects: worldDamageRects]."
	handsToDraw := self selectHandsToDrawForDamage: worldDamageRects.
	handDamageRects := handsToDraw collect: [:h | h savePatchFrom: canvas].
	allDamage := worldDamageRects, handDamageRects.

	handsToDraw reverseDo: [:h | canvas fullDrawMorph: h].  "draw hands onto world canvas"

	"*make this true to flash damaged areas for testing*"
	SMxPreferences debugShowDamage ifTrue: [aWorld flashRects: allDamage color: Color black].

	canvas finish.
	"quickly copy altered rects of canvas to Display:"
	deferredUpdateMode
		ifTrue: [self forceDamageToScreen: allDamage]
		ifFalse: [canvas showAt: aWorld viewBox origin invalidRects: allDamage].
	handsToDraw do: [:h | h restoreSavedPatchOn: canvas].  "restore world canvas under hands"
	Display deferUpdates: false; forceDisplayUpdate.
! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 1/12/2010 11:05'!
displayWorldSafely: aWorld
	"Update this world's display and keep track of errors during draw methods."

	[aWorld displayWorld] ifError: [:err :rcvr |
		"Handle a drawing error"
		| errCtx errMorph |
		errCtx := thisContext.
		[
			errCtx := errCtx sender.
			"Search the sender chain to find the morph causing the problem"
			[errCtx notNil and: [ (errCtx receiver is: #SMxMorph) not ]] 
				whileTrue:[errCtx := errCtx sender].
			"If we're at the root of the context chain then we have a fatal drawing problem"
			errCtx ifNil:[^self handleFatalDrawingError: err].
			errMorph := errCtx receiver.
			"If the morph causing the problem has already the #drawError flag set,
			then search for the next morph above in the caller chain."
			errMorph isKnownFailing
		] whileTrue.
		errMorph drawingFails.
		"Install the old error handler, so we can re-raise the error"
		rcvr error: err.
	].! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'JuanVuletich 11/1/2010 15:42'!
doDeferredUpdatingFor: aWorld
        "If this platform supports deferred updates, then make my canvas be the Display (or a rectangular portion of it), set the Display to deferred update mode, and answer true. Otherwise, do nothing and answer false. One can set the class variable DisableDeferredUpdates to true to completely disable the deferred updating feature."
	| properDisplay |
	SMxPasteUpMorph disableDeferredUpdates ifTrue: [^ false].
	(Display deferUpdates: true) ifNil: [^ false].  "deferred updates not supported"
	remoteServer ifNotNil:[
		self assuredCanvas.
		^true].
	properDisplay := canvas notNil and: [canvas form == Display].
	aWorld == SimpleMorphicUIManager smxWorld ifTrue: [  "this world fills the entire Display"
		properDisplay ifFalse: [
			aWorld viewBox: Display boundingBox.    "do first since it may clear canvas"
			self canvas: ("Display getCanvas" (SMxFormCanvas on: Display) copyClipRect: Display boundingBox).
		]
	].
	^ true! !

!SMxWorldState methodsFor: 'canvas' stamp: 'RAA 5/25/2000 15:12'!
doFullRepaint

	damageRecorder doFullRepaint
! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'JuanVuletich 10/13/2010 13:50'!
doOneCycleFor: aWorld
	"Do one cycle of the interaction loop. This method is called repeatedly when the world is running.
	
	Make for low cpu usage if the ui is inactive, but quick response when ui is in use.
	However, after some inactivity, there will be a MaxCycleLapse delay before the ui gets responsive again."

	| hadAnyEvent thisPause |

	thisPause := pause.
	"pause is set to very short if we have events already enqueued, so they are processed quickly."
	Sensor someEventInQueue
		ifTrue: [ thisPause := 1 ].
	self interCyclePause: thisPause.

	hadAnyEvent := self doOneCycleNowFor: aWorld.
	hadAnyEvent
		ifTrue: [  pause := MinCycleLapse ]
		ifFalse: [
			pause < MaxCycleLapse		"No events processed? Start saving CPU!!"
				ifTrue: [
					pause := pause * 21//20 ]]! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'JuanVuletich 11/1/2010 15:30'!
doOneCycleNowFor: aWorld
	"Immediately do one cycle of the interaction loop.
	This should not be called directly, but only via doOneCycleFor:"

	| hadAnyEvent |
	DisplayScreen checkForNewScreenSize.

	"process user input events"
	self handsDo: [ :h |
		SimpleMorphicUIManager smxActiveHand: h.
		hadAnyEvent := h processEvents.
		SimpleMorphicUIManager smxActiveHand: nil
	].

	"the default is the primary hand"
	SimpleMorphicUIManager smxActiveHand: self hands first.

	aWorld runStepMethods.		"there are currently some variations here"
	self displayWorldSafely: aWorld.

	^hadAnyEvent! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'JuanVuletich 11/1/2010 15:30'!
doOneSubCycleFor: aWorld
	"Like doOneCycle, but preserves activeHand."

	| currentHand |
	currentHand := SimpleMorphicUIManager smxActiveHand.
	self doOneCycleFor: aWorld.
	SimpleMorphicUIManager smxActiveHand: currentHand! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 4/27/2010 11:19'!
drawWorld: aWorld submorphs: submorphs invalidAreasOn: aCanvas 
	"Redraw the damaged areas of the given canvas and clear the damage list. Return a collection of the areas that
were redrawn."

	| rectList c i n mm morphs rects rectToFill remnants rect validList |
	rectList := damageRecorder invalidRectsFullBounds: aWorld viewBox.
	"sort by areas to draw largest portions first"
	rectList := rectList asArray sort: [:r1 :r2 | r1 area > r2 area].
	damageRecorder reset.
	n := submorphs size.
	morphs := OrderedCollection new: n * 2.
	rects := OrderedCollection new: n * 2.
	validList := OrderedCollection new: n * 2.
	rectList do: 
			[:dirtyRect | 
			dirtyRect allAreasOutsideList: validList
				do: 
					[:r | 
					"Experimental top-down drawing --
			Traverses top to bottom, stopping if the entire area is filled.
			If only a single rectangle remains, then continue with the reduced rectangle."

					rectToFill := r.
					i := 1.
					[rectToFill isNil or: [i > n]] whileFalse: 
							[mm := submorphs at: i.
							((mm fullDisplayBounds intersects: r) and: [mm visible]) 
								ifTrue: 
									[morphs addLast: mm.
									rects addLast: rectToFill.
									remnants := mm areasRemainingToFill: rectToFill.
									remnants size = 1 ifTrue: [rectToFill := remnants first].
									remnants isEmpty ifTrue: [rectToFill := nil]].
							i := i + 1].

					"Now paint from bottom to top, but using the reduced rectangles."
					rectToFill 
						ifNotNil: [aWorld drawOn: (c := aCanvas copyClipRect: rectToFill)].
					[morphs isEmpty] whileFalse: 
							[(rect := rects removeLast) == rectToFill 
								ifFalse: [c := aCanvas copyClipRect: (rectToFill := rect)].
							c fullDrawMorph: morphs removeLast].
					morphs reset.
					rects reset.
					validList add: r]].
	^validList! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 12/28/2004 23:27'!
forceDamageToScreen: allDamage
	Display forceDamageToScreen: allDamage! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 2/12/2008 19:10'!
handleFatalDrawingError: errMsg
	"Handle a fatal drawing error."
	
	Display deferUpdates: false. "Just in case"
	self primitiveError: errMsg.

	"Hm... we should jump into a 'safe' worldState here, but how do we find it?!!"! !

!SMxWorldState methodsFor: 'hands' stamp: 'di 6/7/1999 17:40'!
hands

	^ hands! !

!SMxWorldState methodsFor: 'hands' stamp: 'RAA 5/24/2000 10:13'!
handsDo: aBlock

	^ hands do: aBlock! !

!SMxWorldState methodsFor: 'hands' stamp: 'RAA 5/24/2000 12:09'!
handsReverseDo: aBlock

	^ hands reverseDo: aBlock! !

!SMxWorldState methodsFor: 'initialization' stamp: 'JuanVuletich 10/11/2010 19:48'!
initialize

	damageRecorder:= SMxDamageRecorder new.
	stepList := Heap sortBlock: self stepListSortBlock.
	lastStepTime := 0.
	lastAlarmTime := 0.
	drawingFailingMorphs := IdentitySet new.
	pause := MinCycleLapse! !

!SMxWorldState methodsFor: 'update cycle' stamp: 'jmv 5/27/2010 09:42'!
interCyclePause: milliSecs
	"delay enough that the previous cycle plus the amount of delay will equal milliSecs.  If the cycle is already expensive, then no delay occurs.  However, if the system is idly waiting for interaction from the user, the method will delay for a proportionally long time and cause the overall CPU usage of Squeak to be low."

	| wait |
	waitDelay ifNil: [ waitDelay := Delay forMilliseconds: 50 ].
	wait := lastCycleTime notNil
		ifTrue: [ lastCycleTime + milliSecs - Time millisecondClockValue ]
		ifFalse: [ 0 ].
	SMxPreferences serverMode
		ifTrue: [ wait := wait max: 50 ].	"Always wait at least a bit on servers, even if this makes the UI slow."
	(wait > 0 and: [ wait <= milliSecs ])
		ifTrue: [
			waitDelay beingWaitedOn
				ifFalse: [ waitDelay setDelay: wait; wait ]
				ifTrue: [
					"If we are called from a different process than that of the main UI, we might be called in the main
					interCyclePause. In such case, use a new Delay to avoid 'This Delay has already been scheduled' errors"
					(Delay forMilliseconds: wait) wait ]].

	lastCycleTime :=  Time millisecondClockValue! !

!SMxWorldState methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 22:59'!
isKnownFailing: aMorph
	^drawingFailingMorphs includes: aMorph! !

!SMxWorldState methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:05'!
listOfSteppingMorphs
	^stepList collect:[:entry| entry receiver].
! !

!SMxWorldState methodsFor: 'canvas' stamp: 'ar 1/30/2001 23:25'!
recordDamagedRect: damageRect

	damageRecorder ifNotNil: [damageRecorder recordInvalidRect: damageRect truncated]
! !

!SMxWorldState methodsFor: 'alarms' stamp: 'jmv 3/2/2010 16:47'!
removeAlarm: aSelector for: aTarget 
	"Remove the alarm with the given selector"

	| alarm |
	alarm := self alarms 
				detect: [:any | any receiver == aTarget and: [any selector == aSelector]]
				ifNone: nil.
	alarm ifNotNil: [self alarms remove: alarm]! !

!SMxWorldState methodsFor: 'errors on draw' stamp: 'jmv 11/6/2007 23:27'!
removeAllKnownFailing
	drawingFailingMorphs copy do: [ :each |
		drawingFailingMorphs remove: each ]! !

!SMxWorldState methodsFor: 'errors on draw' stamp: 'jmv 11/5/2007 22:59'!
removeKnownFailing: aMorph
	drawingFailingMorphs remove: aMorph! !

!SMxWorldState methodsFor: 'stepping' stamp: 'JuanVuletich 11/1/2010 15:35'!
runLocalStepMethodsIn: aWorld 
	"Run morph 'step' methods (LOCAL TO THIS WORLD) whose time has come. Purge any morphs that are no longer in this world."

	| now morphToStep stepTime priorWorld |
	now := Time millisecondClockValue.
	priorWorld := SimpleMorphicUIManager smxActiveWorld.
	SimpleMorphicUIManager smxActiveWorld: aWorld.
	self triggerAlarmsBefore: now.
	stepList isEmpty 
		ifTrue: [
			SimpleMorphicUIManager smxActiveWorld: priorWorld.
			^self].
	"jmv: I say it is only needed on clock rollover. See commented code below."
	"(now < lastStepTime or: [now - lastStepTime > 5000]) "
	now < lastStepTime		"clock slipped"
		ifTrue: [ self adjustWakeupTimes: now ].
	[ stepList isEmpty not and: [ stepList first scheduledTime < now ]] 
		whileTrue: [
			lastStepMessage := stepList removeFirst.
			morphToStep := lastStepMessage receiver.
			(morphToStep shouldGetStepsFrom: aWorld) 
				ifTrue: [
					lastStepMessage value: now.
					lastStepMessage ifNotNil: [
							stepTime := lastStepMessage stepTime ifNil: [ morphToStep stepTime ].
							lastStepMessage scheduledTime: now + (stepTime max: 1).
							stepList add: lastStepMessage]].
			lastStepMessage := nil].
	lastStepTime := now.
	SimpleMorphicUIManager smxActiveWorld: priorWorld! !

!SMxWorldState methodsFor: 'stepping' stamp: 'StephaneDucasse 1/31/2011 16:51'!
runStepMethodsIn: aWorld
	"Perform periodic activity inbetween event cycles"
	
	| queue msg |
	queue := self class deferredUIMessages.
	[ (msg := queue nextOrNil) isNil ] 
		whileFalse: [ msg value ].
	self runLocalStepMethodsIn: aWorld.! !

!SMxWorldState methodsFor: 'hands' stamp: 'jmv 4/27/2010 11:19'!
selectHandsToDrawForDamage: damageList
	"Select the set of hands that must be redrawn because either (a) the hand itself has changed or (b) the hand intersects some damage rectangle."

	| result hBnds |
	result := OrderedCollection new.
	hands do: [:h |
		h needsToBeDrawn ifTrue: [
			h hasChanged
				ifTrue: [result add: h]
				ifFalse: [
					hBnds := h fullDisplayBounds.
					(damageList detect: [:r | r intersects: hBnds] ifNone: nil)
						ifNotNil: [result add: h]]]].
	^ result
! !

!SMxWorldState methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:36'!
startStepping: aMorph at: scheduledTime selector: aSelector arguments: args stepTime: stepTime
	"Add the given morph to the step list. Do nothing if it is already being stepped."

	self stopStepping: aMorph selector: aSelector.
	self adjustWakeupTimesIfNecessary.
	stepList add:(
		SMxStepMessage 
			scheduledAt: scheduledTime
			stepTime: stepTime
			receiver: aMorph
			selector: aSelector
			arguments: args)! !

!SMxWorldState methodsFor: 'initialization' stamp: 'sw 9/5/2000 06:39'!
stepListSize
	^ stepList size! !

!SMxWorldState methodsFor: 'initialization' stamp: 'jmv 12/30/2009 11:08'!
stepListSortBlock

	"Please pardon the hackery below. Since the block provided by this method is retained elsewhere, it is possible that the block argument variables would retain references to objects that were no longer really needed. In one case, this feature resulted in doubling the size of a published project."
"
	| answer |
	^[ :stepMsg1 :stepMsg2 | 
		answer := stepMsg1 scheduledTime <= stepMsg2 scheduledTime.
		stepMsg1 := stepMsg2 := nil.
		answer
	]
"

	"This used to be needed, as old BlockContext kept referencing to the last value of the arguments.
	This is no longer true with Eliot's BlockClosures, and asigning to block args is discouraged, 
	and perhaps not supported (see preference #allowBlockArgumentAssignment)"

	^[ :stepMsg1 :stepMsg2 | stepMsg1 scheduledTime <= stepMsg2 scheduledTime ]! !

!SMxWorldState methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:10'!
stopStepping: aMorph
	"Remove the given morph from the step list."
	lastStepMessage ifNotNil:[
		(lastStepMessage receiver == aMorph) ifTrue:[lastStepMessage := nil]].
	stepList removeAll: (stepList select:[:stepMsg| stepMsg receiver == aMorph]).
! !

!SMxWorldState methodsFor: 'stepping' stamp: 'ar 10/22/2000 16:10'!
stopStepping: aMorph selector: aSelector
	"Remove the given morph from the step list."
	lastStepMessage ifNotNil:[
		(lastStepMessage receiver == aMorph and:[lastStepMessage selector == aSelector])
			ifTrue:[lastStepMessage := nil]].
	stepList removeAll: (stepList select:[:stepMsg| stepMsg receiver == aMorph and:[stepMsg selector == aSelector]]).! !

!SMxWorldState methodsFor: 'alarms' stamp: 'ar 10/22/2000 16:55'!
triggerAlarmsBefore: nowTime
	"Trigger all pending alarms that are to be executed before nowTime."
	| pending |
	lastAlarmTime ifNil:[lastAlarmTime := nowTime].
	(nowTime < lastAlarmTime or:[nowTime - lastAlarmTime > 10000])
		ifTrue:[self adjustAlarmTimes: nowTime].
	pending := self alarms.
	[pending isEmpty not and:[pending first scheduledTime < nowTime]]
		whileTrue:[pending removeFirst value: nowTime].
	lastAlarmTime := nowTime.! !

!SMxWorldState methodsFor: 'canvas' stamp: 'di 6/7/1999 17:44'!
viewBox

	^ viewBox! !

!SMxWorldState methodsFor: 'canvas' stamp: 'di 6/7/1999 17:58'!
viewBox: x

	viewBox := x! !

SMxMorph subclass: #SMxHandMorph
	instanceVariableNames: 'mouseFocus keyboardFocus eventListeners mouseListeners keyboardListeners mouseClickState mouseOverHandler lastMouseEvent targetOffset damageRecorder temporaryCursor temporaryCursorOffset hasChanged savedPatch userInitials lastEventBuffer'
	classVariableNames: 'DoubleClickTime EventStats NewEventRules NormalCursor PasteBuffer ShowEvents'
	poolDictionaries: 'EventSensorConstants'
	category: 'SimpleMorphic-Kernel'!

!SMxHandMorph commentStamp: '<historical>' prior: 0!
The cursor may be thought of as the SMxHandMorph.  The hand's submorphs hold anything being carried by dragging.  

There is some minimal support for multiple hands in the same world.!

!SMxHandMorph class methodsFor: 'utilities' stamp: 'sma 4/30/2000 10:34'!
attach: aMorph
	"Attach aMorph the current world's primary hand."

	self currentWorld primaryHand attachMorph: aMorph! !

!SMxHandMorph class methodsFor: 'accessing' stamp: ''!
doubleClickTime

	^ DoubleClickTime
! !

!SMxHandMorph class methodsFor: 'accessing' stamp: ''!
doubleClickTime: milliseconds

	DoubleClickTime := milliseconds.
! !

!SMxHandMorph class methodsFor: 'new-morph participation' stamp: 'di 6/22/97 09:07'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!SMxHandMorph class methodsFor: 'class initialization' stamp: 'kfr 7/13/2003 14:15'!
initialize
	"SMxHandMorph initialize"

	PasteBuffer := nil.
	DoubleClickTime := 350.
	NormalCursor := CursorWithMask normal asCursorForm.
! !

!SMxHandMorph class methodsFor: 'utilities' stamp: 'ar 9/17/2000 17:02'!
newEventRules: aBool
	NewEventRules := aBool.! !

!SMxHandMorph class methodsFor: 'utilities' stamp: 'JuanVuletich 11/1/2010 15:33'!
showEvents: aBool
	"SMxHandMorph showEvents: true"
	"SMxHandMorph showEvents: false"
	ShowEvents := aBool.
	aBool ifFalse: [ SimpleMorphicUIManager smxActiveWorld invalidRect: (0@0 extent: 250@120) ].! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:43'!
addEventListener: anObject
	"Make anObject a listener for all events. All events will be reported to the object."
	self eventListeners: (self addListener: anObject to: self eventListeners)! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:42'!
addKeyboardListener: anObject
	"Make anObject a listener for keyboard events. All keyboard events will be reported to the object."
	self keyboardListeners: (self addListener: anObject to: self keyboardListeners)! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:40'!
addListener: anObject to: aListenerGroup
	"Add anObject to the given listener group. Return the new group."
	| listeners |
	listeners := aListenerGroup.
	(listeners notNil and:[listeners includes: anObject]) ifFalse:[
		listeners
			ifNil:[listeners := WeakArray with: anObject]
			ifNotNil:[listeners := listeners copyWith: anObject]].
	listeners := listeners copyWithout: nil. "obsolete entries"
	^listeners! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:42'!
addMouseListener: anObject
	"Make anObject a listener for mouse events. All mouse events will be reported to the object."
	self mouseListeners: (self addListener: anObject to: self mouseListeners)! !

!SMxHandMorph methodsFor: 'grabbing/dropping' stamp: 'ar 10/8/2000 23:42'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	self releaseMouseFocus. "Break focus"
	delta := m bounds extent // 2.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset := m position - self position.
	self addMorphBack: m.! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'ar 10/3/2000 16:49'!
balloonHelp
	"Return the balloon morph associated with this hand"
	^self valueOfProperty: #balloonHelpMorph! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'ar 10/3/2000 16:51'!
balloonHelp: aBalloonMorph
	"Return the balloon morph associated with this hand"
	| oldHelp |
	oldHelp := self balloonHelp.
	oldHelp ifNotNil:[oldHelp delete].
	aBalloonMorph
		ifNil:[self removeProperty: #balloonHelpMorph]
		ifNotNil:[self setProperty: #balloonHelpMorph toValue: aBalloonMorph]! !

!SMxHandMorph methodsFor: 'updating' stamp: 'jm 2/20/98 19:54'!
changed

	hasChanged := true.
! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'sw 2/11/98 18:00'!
colorForInsets
	"Morphs being dragged by the hand use the world's color"
	^ owner colorForInsets! !

!SMxHandMorph methodsFor: 'meta-actions' stamp: 'jmv 5/16/2009 10:19'!
copyToPasteBuffer: aMorph
	"Save this morph in the paste buffer. This is mostly useful for copying morphs between projects."
	aMorph ifNil:[^PasteBuffer := nil].
	Cursor wait showWhile:[
		PasteBuffer := aMorph copy.
		PasteBuffer privateOwner: nil].

! !

!SMxHandMorph methodsFor: 'cursor' stamp: 'jmv 3/1/2010 11:27'!
cursorBounds

	^temporaryCursor
		ifNil: [ self position extent: NormalCursor extent]
		ifNotNil: [self position + temporaryCursorOffset
								extent: temporaryCursor extent]! !

!SMxHandMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:33'!
cursorPoint
	"Implemented for allowing embedded worlds in an event cycle to query a hand's position and get it in its coordinates. The same can be achieved by #internalizePositionToOwner:from: but this is simply much more convenient since it will look as if the hand is in the lower world."

	| pos |
	pos := self position.
	(SimpleMorphicUIManager smxActiveWorld isNil or: [SimpleMorphicUIManager smxActiveWorld == owner]) ifTrue: [^pos].
	^SimpleMorphicUIManager smxActiveWorld internalizePositionToOwner: pos from: owner! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'sw 10/15/2002 20:01'!
deleteBalloonTarget: aMorph
	"Delete any existing balloon help.  This is now done unconditionally, whether or not the morph supplied is the same as the current balloon target"
	
	self balloonHelp: nil

"	| h |
	h := self balloonHelp ifNil: [^ self].
	h balloonOwner == aMorph ifTrue: [self balloonHelp: nil]"! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'jmv 3/2/2010 16:04'!
drawOn: aCanvas 
	"Draw the hand itself (i.e., the cursor)."

	 aCanvas paintImage: (temporaryCursor ifNil: [NormalCursor]) at: bounds topLeft.
	self hasUserInformation 
		ifTrue: [
			aCanvas 
				drawString: userInitials
				at: self cursorBounds topRight + (0 @ 4)
				font: nil
				color: color.
			self userPicture ifNotNil: [ :userPic |
					aCanvas paintImage: userPic at: self cursorBounds topRight + (0 @ 24)]]! !

!SMxHandMorph methodsFor: 'grabbing/dropping' stamp: 'jmv 11/6/2008 15:37'!
dropMorph: aMorph event: anEvent
	"Drop the given morph which was carried by the hand"
	| event |
	(anEvent isMouseUp and:[aMorph shouldDropOnMouseUp not]) ifTrue:[^self].

	"Note: For robustness in drag and drop handling we remove the morph BEFORE we drop him, but we keep his owner set to the hand. This prevents system lockups when there is a problem in drop handling (for example if there's an error in #wantsToBeDroppedInto:). THIS TECHNIQUE IS NOT RECOMMENDED FOR CASUAL USE."
	self privateRemove: aMorph.
	aMorph privateOwner: self.

	event := SMxDropEvent new setPosition: self position contents: aMorph hand: self.
	self sendEvent: event.
	event wasHandled ifFalse:[aMorph rejectDropMorphEvent: event].
	aMorph owner == self ifTrue:[aMorph delete].
	self mouseOverHandler processMouseOver: anEvent.! !

!SMxHandMorph methodsFor: 'grabbing/dropping' stamp: 'ar 9/14/2000 11:22'!
dropMorphs: anEvent
	"Drop the morphs at the hands position"
	self submorphsReverseDo:[:m|
		"Drop back to front to maintain z-order"
		self dropMorph: m event: anEvent.
	].! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:27'!
eventListeners
	^eventListeners! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:27'!
eventListeners: anArrayOrNil
	eventListeners := anArrayOrNil! !

!SMxHandMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:48'!
flushEvents
	"Flush any events that may be pending"
	self flag: #arNote. "Remove it and fix senders"
	Sensor flushEvents.! !

!SMxHandMorph methodsFor: 'layout' stamp: 'jmv 4/27/2010 11:09'!
fullBounds
	"Extend my bounds by the shadow offset when carrying morphs."

	self doLayoutIfNeeded.
	submorphs isEmpty
		ifTrue: [^ fullBounds ]
		ifFalse: [^ fullBounds topLeft corner: fullBounds bottomRight + self shadowOffset].
! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 10:26'!
fullDrawOn: aCanvas 
	"A SMxHandMorph has unusual drawing requirements:
		1. the hand itself (i.e., the cursor) appears in front of its submorphs
		2. morphs being held by the hand cast a shadow on the world/morphs below
	The illusion is that the hand plucks up morphs and carries them above the world."

	self visible ifFalse: [^self].
	(aCanvas isVisible: self fullDisplayBounds) ifFalse: [^self].
	self nonCachingFullDrawOn: aCanvas.
! !

!SMxHandMorph methodsFor: 'private events' stamp: 'JuanVuletich 11/1/2010 15:43'!
generateKeyboardEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	| buttons modifiers type keyValue pressType stamp |
	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	keyValue := evtBuf third.
	pressType := evtBuf fourth.
	pressType = EventKeyDown ifTrue: [type := #keyDown].
	pressType = EventKeyUp ifTrue: [type := #keyUp].
	pressType = EventKeyChar ifTrue: [type := #keystroke].
	modifiers := evtBuf fifth.
	buttons := modifiers bitShift: 3.
	^SMxKeyboardEvent new 
		setType: type
		buttons: buttons
		position: self position
		keyValue: keyValue
		hand: self
		stamp: stamp! !

!SMxHandMorph methodsFor: 'private events' stamp: 'jmv 9/10/2009 14:23'!
generateMouseEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	| position buttons modifiers type trail stamp oldButtons |
	stamp := evtBuf second.
	stamp = 0 ifTrue: [ stamp := Time millisecondClockValue ].
	position := evtBuf third @ evtBuf fourth.
	buttons := evtBuf fifth.
	modifiers := evtBuf sixth.
	type := buttons = 0 
		ifTrue: [
			lastEventBuffer fifth = 0 ifTrue: [#mouseMove] ifFalse: [#mouseUp]]
		ifFalse: [
			lastEventBuffer fifth = 0 
						ifTrue: [#mouseDown]
						ifFalse: [#mouseMove]].
	buttons := buttons bitOr: (modifiers bitShift: 3).
	oldButtons := lastEventBuffer fifth 
				bitOr: (lastEventBuffer sixth bitShift: 3).
	lastEventBuffer := evtBuf.
	type == #mouseMove 
		ifTrue: [
			trail := self mouseTrailFrom: evtBuf.
			^SMxMouseMoveEvent new 
				setType: type
				startPoint: trail first
				endPoint: trail last
				trail: trail
				buttons: buttons
				hand: self
				stamp: stamp].
	^SMxMouseButtonEvent new 
		setType: type
		position: position
		which: (oldButtons bitXor: buttons)
		buttons: buttons
		hand: self
		stamp: stamp! !

!SMxHandMorph methodsFor: 'private events' stamp: 'JMM 1/15/2007 11:09'!
generateWindowEvent: evtBuf 
	"Generate the appropriate window event for the given raw event buffer"

	| evt |
	evt := SMxWindowEvent new.
	evt setTimeStamp: evtBuf second.
	evt timeStamp = 0 ifTrue: [evt setTimeStamp: Time millisecondClockValue].
	evt action: evtBuf third.
	evt rectangle: (Rectangle origin: evtBuf fourth @ evtBuf fifth corner: evtBuf sixth @ evtBuf seventh ).
	
	^evt! !

!SMxHandMorph methodsFor: 'meta-actions' stamp: 'jmv 11/12/2006 22:08'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| grabbed |
	self releaseMouseFocus. "Break focus"
	grabbed := aMorph aboutToBeGrabbedBy: self.
	grabbed ifNil:[^self].
	grabbed := grabbed.
	^self grabMorph: grabbed from: grabbed owner! !

!SMxHandMorph methodsFor: 'grabbing/dropping' stamp: 'jmv 5/27/2006 16:52'!
grabMorph: aMorph from: formerOwner
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."

	self releaseMouseFocus. "Break focus"
	"And compute distance from hand's position"
	targetOffset := aMorph position - self position.
	self addMorphBack: aMorph.
	aMorph justGrabbedFrom: formerOwner.! !

!SMxHandMorph methodsFor: 'halos and balloon help' stamp: 'ar 10/4/2000 13:40'!
halo
	"Return the halo associated with this hand, if any"
	^self valueOfProperty: #halo! !

!SMxHandMorph methodsFor: 'halo handling' stamp: 'ar 10/4/2000 13:40'!
halo: newHalo
	"Set halo associated with this hand"
	| oldHalo |
	oldHalo := self halo.
	(oldHalo isNil or:[oldHalo == newHalo]) ifFalse:[oldHalo delete].
	newHalo
		ifNil:[self removeProperty: #halo]
		ifNotNil:[self setProperty: #halo toValue: newHalo]! !

!SMxHandMorph methodsFor: 'events-processing' stamp: 'JuanVuletich 10/11/2010 19:52'!
handleEvent: anEvent
	| evt ofs |
	owner ifNil: [^self].
	evt := anEvent.

	EventStats ifNil:[EventStats := IdentityDictionary new].
	EventStats at: #count put: (EventStats at: #count ifAbsent:[0]) + 1.
	EventStats at: evt type put: (EventStats at: evt type ifAbsent:[0]) + 1.

	evt isMouseOver ifTrue:[^self sendMouseEvent: evt].

ShowEvents == true ifTrue:[
	Display fill: (0@0 extent: 250@120) rule: Form over fillColor: Color white.
	ofs := (owner hands indexOf: self) - 1 * 60.
	evt printString displayAt: (0@ofs) + (evt isKeyboard ifTrue:[0@30] ifFalse:[0@0]).
	self keyboardFocus printString displayAt: (0@ofs)+(0@45).
].
	"Notify listeners"
	self sendListenEvent: evt to: self eventListeners.
	
	evt isWindowEvent ifTrue: [
		self sendEvent: evt.
		^ self mouseOverHandler processMouseOver: lastMouseEvent ].

	evt isKeyboard ifTrue:[
		self sendListenEvent: evt to: self keyboardListeners.
		self sendKeyboardEvent: evt.
		^self mouseOverHandler processMouseOver: lastMouseEvent].

	evt isDropEvent ifTrue:[
		self sendEvent: evt.
		^self mouseOverHandler processMouseOver: lastMouseEvent].

	evt isMouse ifTrue:[
		self sendListenEvent: evt to: self mouseListeners.
		lastMouseEvent := evt].

	"Check for pending drag or double click operations."
	mouseClickState ifNotNil:[
		(mouseClickState handleEvent: evt from: self) ifFalse:[
			"Possibly dispatched #click: or something and will not re-establish otherwise"
			^self mouseOverHandler processMouseOver: lastMouseEvent]].

	evt isMove ifTrue:[
		self position: evt position.
		self sendMouseEvent: evt.
	] ifFalse:[
		"Issue a synthetic move event if we're not at the position of the event"
		(evt position = self position) ifFalse:[self moveToEvent: evt].
		"Drop submorphs on button events"
		(self hasSubmorphs) 
			ifTrue:[self dropMorphs: evt]
			ifFalse:[self sendMouseEvent: evt].
	].
	ShowEvents == true ifTrue:[self mouseFocus printString displayAt: (0@ofs) + (0@15)].
	self mouseOverHandler processMouseOver: lastMouseEvent.
! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'ls 4/3/2000 20:30'!
hasChanged
	"Return true if this hand has changed, either because it has moved or because some morph it is holding has changed."

	^ hasChanged ifNil: [ true ]
! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'dgd 2/21/2003 22:46'!
hasUserInformation
	^self userInitials notEmpty or: [self userPicture notNil]! !

!SMxHandMorph methodsFor: 'initialization' stamp: 'tk 8/9/2001 16:55'!
initForEvents
	mouseOverHandler := nil.
	lastMouseEvent := SMxMouseEvent new setType: #mouseMove position: 0@0 buttons: 0 hand: self.
	lastEventBuffer := {1. 0. 0. 0. 0. 0. nil. nil}.
	self resetClickState.! !

!SMxHandMorph methodsFor: 'initialization' stamp: 'jmv 11/6/2007 23:18'!
initialize
	super initialize.
	self initForEvents.
	keyboardFocus := nil.
	mouseFocus := nil.
	bounds := 0@0 extent: Cursor normal extent.
	userInitials := ''.
	damageRecorder := SMxDamageRecorder new.
	temporaryCursor := temporaryCursorOffset := nil.
	self initForEvents.! !

!SMxHandMorph methodsFor: 'initialization' stamp: 'nk 2/14/2004 18:28'!
interrupted
	"Something went wrong - we're about to bring up a debugger. 
	Release some stuff that could be problematic."
	self releaseAllFoci. "or else debugger might not handle clicks"
! !

!SMxHandMorph methodsFor: 'change reporting' stamp: 'ar 12/30/2001 17:32'!
invalidRect: damageRect from: aMorph
	"Note that a change has occurred and record the given damage rectangle relative to the origin this hand's cache."
	hasChanged := true.
	aMorph == self ifTrue:[^self].
	damageRecorder recordInvalidRect: damageRect.
! !

!SMxHandMorph methodsFor: 'classification' stamp: 'jmv 12/5/2009 20:17'!
is: aSymbol
	^ aSymbol = #SMxHandMorph or: [ super is: aSymbol ]! !

!SMxHandMorph methodsFor: 'events-processing' stamp: 'nk 2/15/2004 09:01'!
isCapturingGesturePoints
	^false! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:09'!
keyboardFocus 
	^ keyboardFocus! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'JuanVuletich 11/1/2010 15:36'!
keyboardFocusNext

	| firstCandidate candidate |
	firstCandidate := keyboardFocus
		ifNil: [ SimpleMorphicUIManager smxWorld submorphs first ]
		ifNotNil: [ keyboardFocus nextMorph ].
	
	candidate := firstCandidate.
	candidate handlesKeyboard ifFalse: [
		[
			candidate := candidate nextMorph.
			candidate handlesKeyboard not and: [ candidate ~~ firstCandidate ] ] whileTrue ].

	candidate activateWindowAndSendTopToBack: true.
	self newKeyboardFocus: candidate! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'JuanVuletich 11/1/2010 15:36'!
keyboardFocusPrevious

	| firstCandidate candidate |
	firstCandidate := keyboardFocus
		ifNil: [ SimpleMorphicUIManager smxWorld ]
		ifNotNil: [ keyboardFocus previousMorph ].

	candidate := firstCandidate.
	candidate handlesKeyboard ifFalse: [
		[
			candidate := candidate previousMorph.
			candidate handlesKeyboard not and: [ candidate ~~ firstCandidate ] ] whileTrue ].

	candidate activateWindow.
	self newKeyboardFocus: candidate! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:28'!
keyboardListeners
	^keyboardListeners! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:27'!
keyboardListeners: anArrayOrNil
	keyboardListeners := anArrayOrNil! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'ar 10/5/2000 23:17'!
lastEvent
	^ lastMouseEvent! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:10'!
mouseFocus
	^mouseFocus! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:28'!
mouseListeners
	^mouseListeners! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/26/2000 01:27'!
mouseListeners: anArrayOrNil
	mouseListeners := anArrayOrNil! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'ar 9/25/2000 14:24'!
mouseOverHandler
	^mouseOverHandler ifNil:[mouseOverHandler := SMxMouseOverHandler new].! !

!SMxHandMorph methodsFor: 'private events' stamp: 'dgd 2/22/2003 14:58'!
mouseTrailFrom: currentBuf 
	"Current event, a mouse event buffer, is about to be processed.  If there are other similar mouse events queued up, then drop them from the queue, and report the positions inbetween."

	| nextEvent trail |
	trail := WriteStream on: (Array new: 1).
	trail nextPut: currentBuf third @ currentBuf fourth.
	[(nextEvent := Sensor peekEvent) isNil] whileFalse: 
			[nextEvent first = currentBuf first 
				ifFalse: [^trail contents	"different event type"].
			nextEvent fifth = currentBuf fifth 
				ifFalse: [^trail contents	"buttons changed"].
			nextEvent sixth = currentBuf sixth 
				ifFalse: [^trail contents	"modifiers changed"].
			"nextEvent is similar.  Remove it from the queue, and check the next."
			nextEvent := Sensor nextEvent.
			trail nextPut: nextEvent third @ nextEvent fourth].
	^trail contents! !

!SMxHandMorph methodsFor: 'private events' stamp: 'ar 10/6/2000 00:08'!
moveToEvent: anEvent
	"Issue a mouse move event to make the receiver appear at the given position"
	self handleEvent: (SMxMouseMoveEvent new
		setType: #mouseMove 
		startPoint: self position 
		endPoint: anEvent position 
		trail: (Array with: self position with: anEvent position)
		buttons: anEvent buttons
		hand: self
		stamp: anEvent timeStamp)! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'nk 5/6/2003 20:55'!
needsToBeDrawn
	"Return true if this hand must be drawn explicitely instead of being drawn via the hardware cursor. This is the case if it (a) it is a remote hand, (b) it is showing a temporary cursor, or (c) it is not empty and there are any visible submorphs. If using the software cursor, ensure that the hardware cursor is hidden."
	"Details:  Return true if this hand has a saved patch to ensure that is is processed by the world. This saved patch will be deleted after one final display pass when it becomes possible to start using the hardware cursor again. This trick gives us one last display cycle to allow us to remove the software cursor and shadow from the display."
	(savedPatch notNil
		or: [ (submorphs anySatisfy: [ :ea | ea visible ])
			or: [ temporaryCursor notNil
				or: [ self hasUserInformation ]]])
		ifTrue: [
			"using the software cursor; hide the hardware one"
			Sensor currentCursor == Cursor blank ifFalse: [Cursor blank show].
			^ true].

	^ false
! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'jmv 11/10/2008 13:30'!
newKeyboardFocus: aMorphOrNil
	"Make the given morph the new keyboard focus, canceling the previous keyboard focus if any. If the argument is nil, the current keyboard focus is cancelled."
	| oldFocus |
	oldFocus := keyboardFocus.
	keyboardFocus := aMorphOrNil.
	oldFocus ifNotNil: [oldFocus == aMorphOrNil ifFalse: [oldFocus keyboardFocusChange: false]].
	aMorphOrNil ifNotNil: [aMorphOrNil keyboardFocusChange: true].
! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'jmv 11/6/2008 23:00'!
newMouseFocus: aMorphOrNil
	"Make the given morph the new mouse focus, canceling the previous mouse focus if any. If the argument is nil, the current mouse focus is cancelled."
	mouseFocus := aMorphOrNil.
! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'jmv 3/2/2010 16:06'!
newMouseFocus: aMorph event: event 
	aMorph ifNotNil: [ 
		targetOffset := event cursorPoint - aMorph position].
	^self newMouseFocus: aMorph! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'jmv 3/11/2010 12:09'!
nonCachingFullDrawOn: aCanvas
	| shadowForm |
	"A SMxHandMorph has unusual drawing requirements:
		1. the hand itself (i.e., the cursor) appears in front of its submorphs
		2. morphs being held by the hand cast a shadow on the world/morphs below
	The illusion is that the hand plucks up morphs and carries them above the world."
	"Note: This version does not cache an image of the morphs being held by the hand.
	 Thus, it is slower for complex morphs, but consumes less space."

	submorphs isEmpty ifTrue: [^ self drawOn: aCanvas].  "just draw the hand itself"

	"Note: We use a shadow form here to prevent drawing
	overlapping morphs multiple times using the transparent
	shadow color."
	shadowForm := self shadowForm.

	"draw shadows"
	aCanvas stencil: shadowForm at: shadowForm offset  + self shadowOffset color: (Color black alpha: 0.5).
	
	"draw morphs in front of shadows"
	self drawSubmorphsOn: aCanvas.
	self drawOn: aCanvas.  "draw the hand itself in front of morphs"! !

!SMxHandMorph methodsFor: 'event handling' stamp: 'ar 9/25/2000 14:27'!
noticeMouseOver: aMorph event: anEvent
	mouseOverHandler ifNil:[^self].
	mouseOverHandler noticeMouseOver: aMorph event: anEvent.! !

!SMxHandMorph methodsFor: 'objects from disk' stamp: 'jmv 5/21/2006 19:38'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."

	"owned by the project"
"	(refStrm project world hands includes: self) ifTrue: [
		^ self].	"
	dp := DiskProxy global: #World selector: #primaryHand args: #().
	refStrm replace: self with: dp.
	^ dp
	"Note, when this file is loaded in an MVC project, this will return nil.  The SMxMenuItemMorph that has this in a field will have that item not work.  Maybe warn the user at load time?"! !

!SMxHandMorph methodsFor: 'paste buffer' stamp: 'jmv 5/16/2009 10:19'!
objectToPaste
	"It may need to be sent #startRunning by the client"
	^ Cursor wait showWhile: [PasteBuffer copy]

	"PasteBuffer usableDuplicateIn: self world"
! !

!SMxHandMorph methodsFor: 'halo handling' stamp: 'jmv 3/2/2010 09:56'!
obtainHalo: aHalo
	"Used for transfering halos between hands"
	| formerOwner |
	self halo == aHalo ifTrue:[^self].
	"Find former owner"
	formerOwner := self world hands detect: [ :h | h halo == aHalo] ifNone: nil.
	formerOwner ifNotNil:[formerOwner releaseHalo: aHalo].
	self halo: aHalo! !

!SMxHandMorph methodsFor: 'paste buffer' stamp: 'ar 10/5/2000 19:10'!
pasteBuffer
	"Return the paste buffer associated with this hand"
	^ PasteBuffer! !

!SMxHandMorph methodsFor: 'paste buffer' stamp: 'ar 10/5/2000 19:11'!
pasteBuffer: aMorphOrNil
	"Set the contents of the paste buffer."
	PasteBuffer := aMorphOrNil.

! !

!SMxHandMorph methodsFor: 'paste buffer' stamp: 'jmv 1/6/2005 22:45'!
pasteMorph

	| aPastee |
	PasteBuffer ifNil: [^ self inform: 'Nothing to paste.'].
	self attachMorph: (aPastee := self objectToPaste).
	aPastee align: aPastee center with: self position
! !

!SMxHandMorph methodsFor: 'geometry' stamp: 'ar 3/20/2001 20:34'!
position

	^temporaryCursor
		ifNil: [bounds topLeft]
		ifNotNil: [bounds topLeft - temporaryCursorOffset]! !

!SMxHandMorph methodsFor: 'geometry' stamp: 'di 8/28/2000 19:13'!
position: aPoint
	"Overridden to align submorph origins to the grid if gridding is on."
	| adjustedPosition |
	adjustedPosition := aPoint.
	temporaryCursor ifNotNil: [adjustedPosition := adjustedPosition + temporaryCursorOffset].
	^ super position: adjustedPosition
! !

!SMxHandMorph methodsFor: 'event handling' stamp: 'JuanVuletich 11/1/2010 15:24'!
processEvents
	"Process user input events from the local input devices."

	| evt evtBuf type hadAny |
	SimpleMorphicUIManager smxActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response.
		Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].

	hadAny := false.
	[ (evtBuf := Sensor nextEvent) isNil ] whileFalse: [
		evt := nil.	"for unknown event types"
		type := evtBuf first.
		type = EventTypeMouse
			ifTrue: [ evt := self generateMouseEvent: evtBuf ].
		type = EventTypeKeyboard 
			ifTrue: [ evt := self generateKeyboardEvent: evtBuf ].
		type = EventTypeWindow
			ifTrue: [ evt := self generateWindowEvent: evtBuf ].
		"All other events are ignored"
		evt
			ifNil: [
				^hadAny]
			ifNotNil: [
				"Finally, handle it"
				self handleEvent: evt.
				hadAny := true.
				"For better user feedback, return immediately after a mouse event has been processed."
				evt isMouse ifTrue: [ ^hadAny ]]].
	"note: if we come here we didn't have any mouse events"
	mouseClickState 
		ifNotNil: [ 
			"No mouse events during this cycle. Make sure click states time out accordingly"
			mouseClickState handleEvent: lastMouseEvent asMouseMove from: self].
	^hadAny! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:09'!
releaseAllFoci
	mouseFocus := nil.
	keyboardFocus := nil.
! !

!SMxHandMorph methodsFor: 'caching' stamp: 'jmv 11/6/2007 23:19'!
releaseCachedState
	| oo ui |
	ui := userInitials.
	super releaseCachedState.
	oo := owner.
	self removeAllMorphs.
	self initialize.	"nuke everything"
	self privateOwner: oo.
	self releaseAllFoci.
	self userInitials: ui andPicture: (self userPicture).! !

!SMxHandMorph methodsFor: 'halo handling' stamp: 'ar 10/24/2000 18:40'!
releaseHalo: aHalo
	"Used for transfering halos between hands"
	self removeProperty: #halo! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:09'!
releaseKeyboardFocus
	"Release the current keyboard focus unconditionally"
	self newKeyboardFocus: nil.
! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'jmv 11/10/2008 13:30'!
releaseKeyboardFocus: aMorph
	"If the given morph had the keyboard focus before, release it"
	keyboardFocus == aMorph ifTrue:[self releaseKeyboardFocus].! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:10'!
releaseMouseFocus
	"Release the current mouse focus unconditionally."
	self newMouseFocus: nil.! !

!SMxHandMorph methodsFor: 'focus handling' stamp: 'ar 10/6/2000 00:10'!
releaseMouseFocus: aMorph
	"If the given morph had the mouse focus before, release it"
	self mouseFocus == aMorph ifTrue:[self releaseMouseFocus].! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:41'!
removeEventListener: anObject
	"Remove anObject from the current event listeners."
	self eventListeners: (self removeListener: anObject from: self eventListeners).! !

!SMxHandMorph methodsFor: 'halo handling' stamp: 'RAA 2/13/2001 17:24'!
removeHaloFromClick: anEvent on: aMorph
	| halo |
	halo := self halo ifNil:[^self].
	(halo target hasOwner: self) ifTrue:[^self].
	(halo staysUpWhenMouseIsDownIn: aMorph) ifFalse:[
		halo delete.
		self removeProperty: #halo.
	].! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:41'!
removeKeyboardListener: anObject
	"Remove anObject from the current keyboard listeners."
	self keyboardListeners: (self removeListener: anObject from: self keyboardListeners).! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'dgd 2/21/2003 22:48'!
removeListener: anObject from: aListenerGroup 
	"Remove anObject from the given listener group. Return the new group."

	| listeners |
	aListenerGroup ifNil: [^nil].
	listeners := aListenerGroup.
	listeners := listeners copyWithout: anObject.
	listeners := listeners copyWithout: nil.	"obsolete entries"
	listeners isEmpty ifTrue: [listeners := nil].
	^listeners! !

!SMxHandMorph methodsFor: 'listeners' stamp: 'ar 10/24/2000 20:41'!
removeMouseListener: anObject
	"Remove anObject from the current mouse listeners."
	self mouseListeners: (self removeListener: anObject from: self mouseListeners).! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'ar 10/6/2000 00:14'!
removePendingBalloonFor: aMorph
	"Get rid of pending balloon help."
	self removeAlarm: #spawnBalloonFor:.
	self deleteBalloonTarget: aMorph.! !

!SMxHandMorph methodsFor: 'double click support' stamp: 'ar 9/18/2000 17:16'!
resetClickState
	"Reset the double-click detection state to normal (i.e., not waiting for a double-click)."
	mouseClickState := nil.! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'dgd 2/21/2003 22:49'!
restoreSavedPatchOn: aCanvas 
	"Clear the changed flag and restore the part of the given canvas under this hand from the previously saved patch. If necessary, handle the transition to using the hardware cursor."

	hasChanged := false.
	savedPatch ifNotNil: 
			[aCanvas drawImage: savedPatch at: savedPatch offset.
			self hasUserInformation ifTrue: [^self].	"cannot use hw cursor if so"
			submorphs notEmpty ifTrue: [^self].
			temporaryCursor ifNotNil: [^self].

			"Make the transition to using hardware cursor. Clear savedPatch and
		 report one final damage rectangle to erase the image of the software cursor."
			super invalidRect: (savedPatch offset 
						extent: savedPatch extent + self shadowOffset)
				from: self.
			Sensor currentCursor == Cursor normal ifFalse: [Cursor normal show].	"show hardware cursor"
			savedPatch := nil]! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'jmv 4/27/2010 11:16'!
savePatchFrom: aCanvas 
	"Save the part of the given canvas under this hand as a Form and return its bounding rectangle."

	"Details: The previously used patch Form is recycled when possible to reduce the burden on storage management."

	| damageRect myBnds |
	damageRect := myBnds := self fullDisplayBounds.
	savedPatch ifNotNil: 
			[damageRect := myBnds merge: (savedPatch offset extent: savedPatch extent)].
	(savedPatch isNil or: [savedPatch extent ~= myBnds extent]) 
		ifTrue: 
			["allocate new patch form if needed"

			savedPatch := aCanvas form allocateForm: myBnds extent].
	aCanvas contentsOfArea: (myBnds translateBy: aCanvas origin)
		into: savedPatch.
	savedPatch offset: myBnds topLeft.
	^damageRect! !

!SMxHandMorph methodsFor: 'private events' stamp: 'JuanVuletich 11/1/2010 15:25'!
sendEvent: anEvent
	"Send the event to the morph currently holding the focus, or if none to the owner of the hand."
	
	| result |
	SimpleMorphicUIManager smxActiveEvent: anEvent.
	result := owner processEvent: anEvent.
	SimpleMorphicUIManager smxActiveEvent: nil.
	^result! !

!SMxHandMorph methodsFor: 'private events' stamp: 'JuanVuletich 11/1/2010 15:27'!
sendFocusEvent: anEvent to: focusHolder in: world
	"Send the event to focusHolder, the morph currently holding the focus"
	| result |
	world becomeActiveDuring: [
		SimpleMorphicUIManager smxActiveHand: self.
		SimpleMorphicUIManager smxActiveEvent: anEvent.
		result := focusHolder handleFocusEvent: 
			(anEvent internalizedToOwnerOf: focusHolder from: self).
	].
	^result! !

!SMxHandMorph methodsFor: 'private events' stamp: 'JuanVuletich 11/1/2010 15:43'!
sendKeyboardEvent: anEvent
	"Send the event to the morph currently holding the focus, or if none to the owner of the hand."
	
	| w |
	keyboardFocus ifNotNil: [
		(w := keyboardFocus world) ifNil: [
			keyboardFocus := nil.
			^self ].
		^self sendFocusEvent: anEvent to: keyboardFocus in: w ]! !

!SMxHandMorph methodsFor: 'private events' stamp: 'ar 10/26/2000 01:43'!
sendListenEvent: anEvent to: listenerGroup
	"Send the event to the given group of listeners"
	listenerGroup ifNil:[^self].
	listenerGroup do:[:listener| 
		listener ifNotNil:[listener handleListenEvent: anEvent copy]].! !

!SMxHandMorph methodsFor: 'private events' stamp: 'jmv 11/6/2008 15:42'!
sendMouseEvent: anEvent
	"Send the event to the morph currently holding the focus, or if none to the owner of the hand."

	| w |
	mouseFocus ifNotNil: [
		(w := mouseFocus world) ifNil: [
			mouseFocus := nil.
			^self ].
		^self sendFocusEvent: anEvent to: mouseFocus in: w].

	^self sendEvent: anEvent! !

!SMxHandMorph methodsFor: 'drawing' stamp: 'JuanVuletich 10/11/2010 22:26'!
shadowForm
	"Return a 1-bit shadow of my submorphs.  Assumes submorphs is not empty"
	| bnds canvas |
	bnds := Rectangle merging: (submorphs collect: [:m | m fullDisplayBounds]).
	canvas := "Display defaultCanvasClass"SMxFormCanvas forShadowOver: bnds.
	self drawSubmorphsOn: canvas.
	^ canvas formWithOffset! !

!SMxHandMorph methodsFor: 'drop shadows' stamp: ''!
shadowOffset

	^ 6@8! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'jm 6/11/97 17:26'!
showTemporaryCursor: cursorOrNil
	"Set the temporary cursor to the given Form. If the argument is nil, revert to the normal cursor."

	self showTemporaryCursor: cursorOrNil hotSpotOffset: 0@0.
! !

!SMxHandMorph methodsFor: 'cursor' stamp: 'JuanVuletich 11/1/2010 15:51'!
showTemporaryCursor: cursorOrNil hotSpotOffset: hotSpotOffset 
	"Set the temporary cursor to the given Form.
	If the argument is nil, revert to the normal hardware cursor."

	self changed.
	temporaryCursorOffset 
		ifNotNil: [ bounds := bounds translateBy: temporaryCursorOffset negated ].
	cursorOrNil
		ifNil: [temporaryCursor := temporaryCursorOffset := nil]
		ifNotNil: [
			temporaryCursor := (SMxPreferences biggerCursors and: [ cursorOrNil isKindOf: Cursor ])
					ifTrue: [ cursorOrNil asBigCursor asCursorForm ]
					ifFalse: [ cursorOrNil asCursorForm ].
			temporaryCursorOffset := temporaryCursor offset - hotSpotOffset ].
	bounds := self cursorBounds.
	self
		userInitials: userInitials andPicture: self userPicture;
		layoutChanged;
		changed! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'ar 10/3/2000 17:15'!
spawnBalloonFor: aMorph
	aMorph showBalloon: aMorph balloonText hand: self.! !

!SMxHandMorph methodsFor: 'accessing' stamp: ''!
targetOffset
	"Return the offset of the last mouseDown location relative to the origin of the recipient morph. During menu interactions, this is the absolute location of the mouse down event that invoked the menu."

	^ targetOffset
! !

!SMxHandMorph methodsFor: 'cursor' stamp: 'NS 2/17/2001 11:01'!
temporaryCursor
	^ temporaryCursor! !

!SMxHandMorph methodsFor: 'balloon help' stamp: 'ar 10/3/2000 17:14'!
triggerBalloonFor: aMorph after: timeOut
	"Trigger balloon help after the given time out for some morph"
	self addAlarm: #spawnBalloonFor: with: aMorph after: timeOut.! !

!SMxHandMorph methodsFor: 'accessing' stamp: ''!
userInitials

	^ userInitials! !

!SMxHandMorph methodsFor: 'geometry' stamp: 'jmv 7/27/2009 17:48'!
userInitials: aString andPicture: aForm

	| cb pictRect initRect f |

	userInitials := aString.
	pictRect := initRect := cb := self cursorBounds.
	userInitials isEmpty ifFalse: [
		f := StrikeFont default.
		initRect := cb topRight + (0@4) extent: (f widthOfString: userInitials)@(f height).
	].
	self userPicture: aForm.
	aForm ifNotNil: [
		pictRect := (self cursorBounds topRight + (0@24)) extent: aForm extent.
	].
	self bounds: ((cb merge: initRect) merge: pictRect).


! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'ar 10/26/2000 15:18'!
userPicture
	^self valueOfProperty: #remoteUserPicture

! !

!SMxHandMorph methodsFor: 'accessing' stamp: 'ar 10/26/2000 15:34'!
userPicture: aFormOrNil
	^self setProperty: #remoteUserPicture toValue: aFormOrNil
! !

!SMxHandMorph methodsFor: 'copying' stamp: 'ar 10/6/2000 00:11'!
veryDeepCopyWith: deepCopier
	"Return self.  Do not copy hands this way."
	^ self! !

!SMxHandMorph methodsFor: 'double click support' stamp: 'jmv 5/11/2009 23:38'!
waitForClicksOrDrag: aMorph event: evt

	"Wait until the difference between click, double-click, or drag gesture is known, then inform the given morph what transpired. This message is sent when the given morph first receives a mouse-down event. If the mouse button goes up, then down again within DoubleClickTime, then 'doubleClick: evt' is sent to the morph. If the mouse button goes up but not down again within DoubleClickTime, then the message 'click: evt' is sent to the morph. Finally, if the button does not go up within DoubleClickTime, then 'drag: evt' is sent to the morph. In all cases, the event supplied is the original mouseDown event that initiated the gesture. mouseMove: and mouseUp: events are not sent to the morph until it becomes the mouse focus, which is typically done by the client in its click:, doubleClick:, or drag: methods." 
	
	^self 
		waitForClicksOrDrag: aMorph 
		event: evt 
		clkSel: #click:
		dblClkSel: #doubleClick:
		dblClkTimeoutSel: #doubleClickTimeout:
		dragSel: #startDrag:! !

!SMxHandMorph methodsFor: 'double click support' stamp: 'jmv 5/11/2009 23:37'!
waitForClicksOrDrag: aMorph event: evt  clkSel: clkSel dblClkSel: dblClkSel dblClkTimeoutSel: dblClkTimeoutSel dragSel: dragSel

	"Wait until the difference between click, double-click, or drag gesture is known, then inform the given morph what transpired. This message is sent when the given morph first receives a mouse-down event. If the mouse button goes up, then down again within DoubleClickTime, then 'doubleClick: evt' is sent to the morph. If the mouse button goes up but not down again within DoubleClickTime, then the message 'click: evt' is sent to the morph. Finally, if the button does not go up within DoubleClickTime, then 'drag: evt' is sent to the morph. In all cases, the event supplied is the original mouseDown event that initiated the gesture. mouseMove: and mouseUp: events are not sent to the morph until it becomes the mouse focus, which is typically done by the client in its click:, doubleClick:, or drag: methods." 

	mouseClickState := 
		SMxMouseClickState new
			client: aMorph 
			click: clkSel 
			dblClick: dblClkSel
			dblClickTime: DoubleClickTime 
			dblClickTimeout: dblClkTimeoutSel
			drag: dragSel
			event: evt
			sendYellowButtonActivity: false! !

!SMxHandMorph methodsFor: 'double click support' stamp: 'jmv 5/11/2009 23:38'!
waitForClicksOrDragOrSimulatedYellow: aMorph event: evt clkSel: clkSel dblClkSel: dblClkSel dblClkTimeoutSel: dblClkTimeoutSel dragSel: dragSel

	"Wait until the difference between click, double-click, or drag gesture is known, then inform the given morph what transpired. This message is sent when the given morph first receives a mouse-down event. If the mouse button goes up, then down again within DoubleClickTime, then 'doubleClick: evt' is sent to the morph. If the mouse button goes up but not down again within DoubleClickTime, then the message 'click: evt' is sent to the morph. Finally, if the button does not go up within DoubleClickTime, then 'drag: evt' is sent to the morph. In all cases, the event supplied is the original mouseDown event that initiated the gesture. mouseMove: and mouseUp: events are not sent to the morph until it becomes the mouse focus, which is typically done by the client in its click:, doubleClick:, or drag: methods." 

	mouseClickState := 
		SMxMouseClickState new
			client: aMorph 
			click: clkSel 
			dblClick: dblClkSel
			dblClickTime: DoubleClickTime 
			dblClickTimeout: dblClkTimeoutSel
			drag: dragSel
			event: evt
			sendYellowButtonActivity: true! !

!SMxHandMorph methodsFor: 'double click support' stamp: 'jmv 6/29/2010 20:52'!
waitForSimulatedYellow: aMorph event: evt dblClkSel: dblClkSel

	"Wait until the difference between click, double-click, or drag gesture is known, then inform the given morph what transpired. This message is sent when the given morph first receives a mouse-down event. If the mouse button goes up, then down again within DoubleClickTime, then 'doubleClick: evt' is sent to the morph. If the mouse button goes up but not down again within DoubleClickTime, then the message 'click: evt' is sent to the morph. Finally, if the button does not go up within DoubleClickTime, then 'drag: evt' is sent to the morph. In all cases, the event supplied is the original mouseDown event that initiated the gesture. mouseMove: and mouseUp: events are not sent to the morph until it becomes the mouse focus, which is typically done by the client in its click:, doubleClick:, or drag: methods." 

	mouseClickState := 
		SMxMouseClickState new
			client: aMorph 
			click: nil 
			dblClick: dblClkSel
			dblClickTime: DoubleClickTime 
			dblClickTimeout: nil
			drag: nil
			event: evt
			sendYellowButtonActivity: true! !

SMxMorphicEvent subclass: #SMxMorphicUnknownEvent
	instanceVariableNames: 'type argument'
	classVariableNames: ''
	poolDictionaries: 'EventSensorConstants'
	category: 'SimpleMorphic-Events'!

!SMxMorphicUnknownEvent methodsFor: 'accessing' stamp: 'ar 10/25/2000 20:04'!
argument
	^argument! !

!SMxMorphicUnknownEvent methodsFor: 'accessing' stamp: 'ar 10/25/2000 20:04'!
argument: arg
	argument := arg! !

!SMxMorphicUnknownEvent methodsFor: 'accessing' stamp: 'ar 10/25/2000 19:55'!
position
	^0@0! !

!SMxMorphicUnknownEvent methodsFor: 'private' stamp: 'ar 10/25/2000 19:59'!
setType: evtType argument: arg
	type := evtType.
	argument := arg.! !

!SMxMorphicUnknownEvent methodsFor: 'private' stamp: 'ar 10/25/2000 19:58'!
setType: evtType argument: arg hand: evtHand stamp: stamp
	type := evtType.
	argument := arg.
	source := evtHand.
	timeStamp := stamp.! !

!SMxMorphicUnknownEvent methodsFor: 'printing' stamp: 'ar 10/26/2000 01:19'!
storeOn: aStream
	aStream nextPutAll: 'unknown'.
	aStream space.
	self timeStamp storeOn: aStream.
	aStream space.
	{type. argument} storeOn: aStream.! !

!SMxMorphicUnknownEvent methodsFor: 'accessing' stamp: 'ar 10/25/2000 19:55'!
type
	^type! !

!SMxMorphicUnknownEvent methodsFor: 'initialize' stamp: 'ar 10/26/2000 01:20'!
type: eventType readFrom: aStream
	| typeAndArg |
	timeStamp := Integer readFrom: aStream.
	aStream skip: 1.
	typeAndArg := Object readFrom: aStream.
	type := typeAndArg first.
	argument := typeAndArg last.! !

SMxMorphicEvent subclass: #SMxUserInputEvent
	instanceVariableNames: 'type buttons position handler wasHandled'
	classVariableNames: ''
	poolDictionaries: 'EventSensorConstants'
	category: 'SimpleMorphic-Events'!

SMxUserInputEvent subclass: #SMxKeyboardEvent
	instanceVariableNames: 'keyValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxKeyboardEvent methodsFor: 'comparing' stamp: 'ar 10/24/2000 17:44'!
= aMorphicEvent
	super = aMorphicEvent ifFalse:[^false].
	buttons = aMorphicEvent buttons ifFalse: [^ false].
	keyValue = aMorphicEvent keyValue ifFalse: [^ false].
	^ true
! !

!SMxKeyboardEvent methodsFor: 'comparing' stamp: 'ar 9/13/2000 15:50'!
hash
	^buttons hash + keyValue hash
! !

!SMxKeyboardEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:49'!
isKeyDown
	^self type == #keyDown! !

!SMxKeyboardEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:49'!
isKeyUp
	^self type == #keyUp! !

!SMxKeyboardEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:49'!
isKeyboard
	^true! !

!SMxKeyboardEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:49'!
isKeystroke
	^self type == #keystroke! !

!SMxKeyboardEvent methodsFor: 'testing' stamp: 'ar 10/9/2000 00:43'!
isMouseMove
	^false! !

!SMxKeyboardEvent methodsFor: 'keyboard' stamp: 'ar 9/13/2000 15:51'!
keyCharacter
	"Answer the character corresponding this keystroke. This is defined only for keystroke events."

	^ keyValue asCharacter! !

!SMxKeyboardEvent methodsFor: 'keyboard' stamp: 'ar 9/13/2000 15:51'!
keyValue
	"Answer the ascii value for this keystroke. This is defined only for keystroke events."

	^ keyValue! !

!SMxKeyboardEvent methodsFor: 'printing' stamp: 'JuanVuletich 10/18/2010 09:03'!
printOn: aStream

	aStream nextPut: $[.
	aStream nextPutAll: type; nextPutAll: ' '''.
	self controlKeyPressed ifTrue: [ aStream nextPutAll: 'Ctrl-' ].
	self commandKeyPressed ifTrue: [ aStream nextPutAll: 'Cmd/Alt-' ].
	(buttons anyMask: 32) ifTrue: [ aStream nextPutAll: 'Opt-' ].
	self controlKeyPressed ifTrue: [
		aStream nextPut: (keyValue + $a asciiValue - 1) asCharacter.
	] ifFalse: [
		aStream nextPut: self keyCharacter.
	].
	aStream nextPut: $'.
	aStream nextPut: $].! !

!SMxKeyboardEvent methodsFor: 'dispatching' stamp: 'ar 9/15/2000 21:13'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	type == #keystroke ifTrue:[^anObject handleKeystroke: self].
	type == #keyDown ifTrue:[^anObject handleKeyDown: self].
	type == #keyUp ifTrue:[^anObject handleKeyUp: self].
	^super sentTo: anObject.! !

!SMxKeyboardEvent methodsFor: 'private' stamp: 'ar 10/5/2000 23:54'!
setType: aSymbol buttons: anInteger position: pos keyValue: aValue hand: aHand stamp: stamp
	type := aSymbol.
	buttons := anInteger.
	position := pos.
	keyValue := aValue.
	source := aHand.
	wasHandled := false.
	timeStamp := stamp.! !

!SMxKeyboardEvent methodsFor: 'printing' stamp: 'ar 10/25/2000 22:07'!
storeOn: aStream

	aStream nextPutAll: type.
	aStream space.
	self timeStamp storeOn: aStream.
	aStream space.
	buttons storeOn: aStream.
	aStream space.
	keyValue storeOn: aStream.
! !

!SMxKeyboardEvent methodsFor: 'initialize' stamp: 'ar 10/25/2000 22:08'!
type: eventType readFrom: aStream
	type := eventType.
	timeStamp := Integer readFrom: aStream.
	aStream skip: 1.
	buttons := Integer readFrom: aStream.
	aStream skip: 1.
	keyValue := Integer readFrom: aStream.! !

SMxUserInputEvent subclass: #SMxMouseEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

SMxMouseEvent subclass: #SMxMouseButtonEvent
	instanceVariableNames: 'whichButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMouseButtonEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 19:58'!
blueButtonChanged
	"Answer true if the blue mouse button has changed. This is the third mouse button or cmd+click on the Mac."

	^ whichButton anyMask: 1! !

!SMxMouseButtonEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 19:58'!
redButtonChanged
	"Answer true if the red mouse button has changed. This is the first mouse button."

	^ whichButton anyMask: 4! !

!SMxMouseButtonEvent methodsFor: 'dispatching' stamp: 'ar 9/16/2000 13:05'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	type == #mouseDown ifTrue:[^anObject handleMouseDown: self].
	type == #mouseUp ifTrue:[^anObject handleMouseUp: self].
	^super sentTo: anObject! !

!SMxMouseButtonEvent methodsFor: 'private' stamp: 'ar 10/5/2000 23:55'!
setType: evtType position: evtPos which: button buttons: evtButtons hand: evtHand stamp: stamp
	type := evtType.
	position := evtPos.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.
	whichButton := button.
	timeStamp := stamp.! !

!SMxMouseButtonEvent methodsFor: 'printing' stamp: 'ar 10/24/2000 16:29'!
storeOn: aStream
	super storeOn: aStream.
	aStream space.
	whichButton storeOn: aStream.! !

!SMxMouseButtonEvent methodsFor: 'initialize' stamp: 'ar 10/24/2000 16:29'!
type: eventType readFrom: aStream
	super type: eventType readFrom: aStream.
	aStream skip: 1.
	whichButton := Integer readFrom: aStream.! !

!SMxMouseButtonEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 19:59'!
yellowButtonChanged
	"Answer true if the yellow mouse button has changed. This is the second mouse button or option+click on the Mac."

	^ whichButton anyMask: 2! !

!SMxMouseEvent class methodsFor: 'constants' stamp: 'NS 5/19/2003 15:16'!
anyButton
	^ 7! !

!SMxMouseEvent class methodsFor: 'constants' stamp: 'NS 5/19/2003 15:16'!
blueButton
	^ 1! !

!SMxMouseEvent class methodsFor: 'constants' stamp: 'NS 5/19/2003 15:16'!
redButton
	^ 4! !

!SMxMouseEvent class methodsFor: 'constants' stamp: 'NS 5/19/2003 15:16'!
yellowButton
	^ 2! !

!SMxMouseEvent methodsFor: 'comparing' stamp: 'ar 9/15/2000 22:50'!
= aMorphicEvent
	super = aMorphicEvent ifFalse:[^false].
	position = aMorphicEvent position ifFalse: [^ false].
	buttons = aMorphicEvent buttons ifFalse: [^ false].
	^ true
! !

!SMxMouseEvent methodsFor: 'button state' stamp: 'NS 5/19/2003 15:17'!
anyButtonPressed
	"Answer true if any mouse button is being pressed."

	^ buttons anyMask: self class anyButton! !

!SMxMouseEvent methodsFor: 'converting' stamp: 'JuanVuletich 11/1/2010 15:49'!
asMouseEnter
	^self shallowCopy setType: #mouseEnter! !

!SMxMouseEvent methodsFor: 'converting' stamp: 'JuanVuletich 11/1/2010 15:49'!
asMouseLeave
	^self shallowCopy setType: #mouseLeave! !

!SMxMouseEvent methodsFor: 'converting' stamp: 'ar 10/6/2000 18:59'!
asMouseMove
	"Convert the receiver into a mouse move"
	^SMxMouseMoveEvent new setType: #mouseMove startPoint: position endPoint: position trail: {position. position} buttons: buttons hand: source stamp: Time millisecondClockValue.! !

!SMxMouseEvent methodsFor: 'converting' stamp: 'ar 9/25/2000 14:29'!
asMouseOver
	"Convert the receiver into a mouse over event"
	^SMxMouseEvent new setType: #mouseOver position: position buttons: buttons hand: source! !

!SMxMouseEvent methodsFor: 'button state' stamp: 'NS 5/19/2003 15:17'!
blueButtonPressed
	"Answer true if the blue mouse button is being pressed. This is the third mouse button or cmd+click on the Mac."

	^ buttons anyMask: self class blueButton! !

!SMxMouseEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 22:51'!
cursorPoint
	"Answer the location of the cursor's hotspot when this event occured."

	^ position! !

!SMxMouseEvent methodsFor: 'comparing' stamp: 'ar 9/15/2000 22:47'!
hash
	^ position hash + buttons hash! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 10/5/2000 19:43'!
isDraggingEvent
	source ifNil:[^false].
	source hasSubmorphs ifTrue:[^true].
	self anyButtonPressed ifTrue:[^true].
	^false! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:30'!
isMouse
	^true! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:32'!
isMouseDown
	^self type == #mouseDown! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:32'!
isMouseEnter
	^self type == #mouseEnter! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:32'!
isMouseLeave
	^self type == #mouseLeave! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:32'!
isMouseMove
	^self type == #mouseMove! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 15:32'!
isMouseUp
	^self type == #mouseUp! !

!SMxMouseEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 19:29'!
isMove
	^false! !

!SMxMouseEvent methodsFor: 'accessing' stamp: 'ar 9/25/2000 14:26'!
noticeMouseOver: aMorph
	source ifNotNil:[source noticeMouseOver: aMorph event: self].! !

!SMxMouseEvent methodsFor: 'printing' stamp: 'ar 10/7/2000 22:01'!
printOn: aStream

	aStream nextPut: $[.
	aStream nextPutAll: self cursorPoint printString; space.
	aStream nextPutAll: type; space.
	aStream nextPutAll: self modifierString.
	aStream nextPutAll: self buttonString.
	aStream nextPutAll: timeStamp printString.
	aStream nextPut: $].! !

!SMxMouseEvent methodsFor: 'button state' stamp: 'NS 5/19/2003 15:17'!
redButtonPressed
	"Answer true if the red mouse button is being pressed. This is the first mouse button."

	^ buttons anyMask: self class redButton! !

!SMxMouseEvent methodsFor: 'dispatching' stamp: 'ar 10/10/2000 21:15'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	type == #mouseOver ifTrue:[^anObject handleMouseOver: self].
	type == #mouseEnter ifTrue:[^anObject handleMouseEnter: self].
	type == #mouseLeave ifTrue:[^anObject handleMouseLeave: self].
	^super sentTo: anObject.! !

!SMxMouseEvent methodsFor: 'private' stamp: 'ar 10/10/2000 21:15'!
setType: aSymbol
	"For quick conversion between event types"
	type := aSymbol.! !

!SMxMouseEvent methodsFor: 'private' stamp: 'ar 9/15/2000 22:53'!
setType: evtType position: evtPos buttons: evtButtons hand: evtHand
	type := evtType.
	position := evtPos.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.! !

!SMxMouseEvent methodsFor: 'printing' stamp: 'ar 10/25/2000 22:09'!
storeOn: aStream

	aStream nextPutAll: type.
	aStream space.
	self timeStamp storeOn: aStream.
	aStream space.
	position x storeOn: aStream.
	aStream space.
	position y storeOn: aStream.
	aStream space.
	buttons storeOn: aStream.! !

!SMxMouseEvent methodsFor: 'button state' stamp: 'ar 9/15/2000 22:51'!
targetPoint
	"Answer the location of the cursor's hotspot, adjusted by the offset
	of the last mouseDown relative to the recipient morph."

	^ position - source targetOffset! !

!SMxMouseEvent methodsFor: 'initialize' stamp: 'ar 10/25/2000 22:08'!
type: eventType readFrom: aStream
	| x y |
	type := eventType.
	timeStamp := Integer readFrom: aStream.
	aStream skip: 1.
	x := Integer readFrom: aStream.
	aStream skip: 1.
	y := Integer readFrom: aStream.
	aStream skip: 1.
	buttons := Integer readFrom: aStream.
	position := x@y.
! !

!SMxMouseEvent methodsFor: 'button state' stamp: 'NS 5/19/2003 15:17'!
yellowButtonPressed
	"Answer true if the yellow mouse button is being pressed. This is the second mouse button or option+click on the Mac."

	^ buttons anyMask: self class yellowButton! !

SMxMouseEvent subclass: #SMxMouseMoveEvent
	instanceVariableNames: 'startPoint trail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleMorphic-Events'!

!SMxMouseMoveEvent methodsFor: 'comparing' stamp: 'ar 9/15/2000 22:49'!
= aMorphicEvent
	super = aMorphicEvent ifFalse:[^false].
	position = aMorphicEvent position ifFalse: [^ false].
	startPoint = aMorphicEvent startPoint ifFalse: [^ false].
	buttons = aMorphicEvent buttons ifFalse: [^ false].
	^ true
! !

!SMxMouseMoveEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 22:51'!
endPoint
	"Return the point where the movement ended."
	^position! !

!SMxMouseMoveEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:57'!
externalizeFromOwnerOf: targetMorph to: outerMorph
	"Transform from the receiver owner's to an outer coordinate system (outerMorph)."
	position :=  targetMorph externalizePositionFromOwner: position to: outerMorph.
	startPoint :=  targetMorph externalizePositionFromOwner: startPoint to: outerMorph! !

!SMxMouseMoveEvent methodsFor: 'comparing' stamp: 'ar 9/15/2000 22:49'!
hash
	^ position hash + startPoint hash + buttons hash! !

!SMxMouseMoveEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:59'!
internalizeTo: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph's)."
	position :=  targetMorph internalizePosition: position from: outerMorph.
	startPoint :=  targetMorph internalizePosition: startPoint from: outerMorph! !

!SMxMouseMoveEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:59'!
internalizeToOwnerOf: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph onwer's)."
	position :=  targetMorph internalizePositionToOwner: position from: outerMorph.
	startPoint :=  targetMorph internalizePositionToOwner: startPoint from: outerMorph! !

!SMxMouseMoveEvent methodsFor: 'testing' stamp: 'ar 9/13/2000 19:29'!
isMove
	^true! !

!SMxMouseMoveEvent methodsFor: 'printing' stamp: 'ar 10/7/2000 22:00'!
printOn: aStream

	aStream nextPut: $[.
	aStream nextPutAll: self startPoint printString; space.
	aStream nextPutAll: self endPoint printString; space.
	aStream nextPutAll: self type; space.
	aStream nextPutAll: self modifierString.
	aStream nextPutAll: self buttonString.
	aStream nextPutAll: timeStamp printString.
	aStream nextPut: $].! !

!SMxMouseMoveEvent methodsFor: 'dispatching' stamp: 'ar 10/10/2000 21:15'!
sentTo: anObject
	"Dispatch the receiver into anObject"
	type == #mouseMove ifTrue:[^anObject handleMouseMove: self].
	^super sentTo: anObject.
! !

!SMxMouseMoveEvent methodsFor: 'private' stamp: 'ar 10/5/2000 23:55'!
setType: evtType startPoint: evtStart endPoint: evtEnd trail: evtTrail buttons: evtButtons hand: evtHand stamp: stamp
	type := evtType.
	startPoint := evtStart.
	position := evtEnd.
	trail := evtTrail.
	buttons := evtButtons.
	source := evtHand.
	wasHandled := false.
	timeStamp := stamp.! !

!SMxMouseMoveEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 16:25'!
startPoint
	"Return the point where the movement started."
	^startPoint! !

!SMxMouseMoveEvent methodsFor: 'printing' stamp: 'ar 10/24/2000 16:30'!
storeOn: aStream
	super storeOn: aStream.
	aStream space.
	self startPoint x storeOn: aStream.
	aStream space.
	self startPoint y storeOn: aStream.
	aStream space.
	"trail storeOn: aStream."! !

!SMxMouseMoveEvent methodsFor: 'accessing' stamp: 'ar 10/24/2000 16:33'!
trail
	"Return any immediate points that have been assembled along the move"
	^trail ifNil:[#()]! !

!SMxMouseMoveEvent methodsFor: 'transforming' stamp: 'ar 9/15/2000 22:52'!
translateBy: delta
	"add delta to cursorPoint, and return the new event"
	position := position + delta.
	startPoint := startPoint + delta.! !

!SMxMouseMoveEvent methodsFor: 'initialize' stamp: 'ar 10/24/2000 16:31'!
type: eventType readFrom: aStream
	| x y |
	super type: eventType readFrom: aStream.
	aStream skip: 1.
	x := Integer readFrom: aStream.
	aStream skip: 1.
	y := Integer readFrom: aStream.
	startPoint := x@y.! !

!SMxUserInputEvent methodsFor: 'modifier state' stamp: 'ar 9/13/2000 15:43'!
anyModifierKeyPressed
	"ignore, however, the shift keys 'cause that's not REALLY a command key "

	^ self buttons anyMask: 16r70	"cmd | opt | ctrl"! !

!SMxUserInputEvent methodsFor: 'printing' stamp: 'ar 10/7/2000 21:57'!
buttonString
	"Return a string identifying the currently pressed buttons"
	| string |
	string := ''.
	self redButtonPressed ifTrue:[string := string,'red '].
	self yellowButtonPressed ifTrue:[string := string,'yellow '].
	self blueButtonPressed ifTrue:[string := string,'blue '].
	^string! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:45'!
buttons
	"Return the a word encoding the mouse and modifier buttons for this event."

	^ buttons! !

!SMxUserInputEvent methodsFor: 'modifier state' stamp: 'JuanVuletich 10/18/2010 09:00'!
commandKeyPressed
	"Answer true if the command (Mac) / alt(Windows) key on the keyboard was being held down when this event occurred."

	^ buttons anyMask: 64! !

!SMxUserInputEvent methodsFor: 'modifier state' stamp: 'jmv 9/7/2010 17:13'!
controlKeyPressed
	"Answer true if the control/ctrl key on the keyboard was being held down when this event occurred."

	^ buttons anyMask: 16! !

!SMxUserInputEvent methodsFor: 'initialize' stamp: 'ar 9/13/2000 15:54'!
copyHandlerState: anEvent
	"Copy the handler state from anEvent. Used for quickly transferring handler information between transformed events."
	handler := anEvent handler.
	wasHandled := anEvent wasHandled.! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:57'!
externalizeFromOwnerOf: targetMorph to: outerMorph
	"Transform from the receiver owner's to an outer coordinate system (outerMorph)."
	position :=  targetMorph externalizePositionFromOwner: position to: outerMorph! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:58'!
externalizedFromOwnerOf: targetMorph to: outerMorph
	"Return a new event, transformed from the receiver owner's to an outer coordinate system (outerMorph)."
	^self shallowCopy externalizeFromOwnerOf: targetMorph to: outerMorph! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:54'!
handler
	^handler! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:54'!
handler: anObject
	handler := anObject! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:59'!
internalizeTo: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph's)."
	position :=  targetMorph internalizePosition: position from: outerMorph! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 22:59'!
internalizeToOwnerOf: targetMorph from: outerMorph
	"Transform the receiver into an inner coordinate system (targetMorph onwer's)."
	position :=  targetMorph internalizePositionToOwner: position from: outerMorph! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:02'!
internalizedTo: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph's)."
	^self shallowCopy internalizeTo: targetMorph from: outerMorph
! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'jmv 6/30/2010 23:02'!
internalizedToOwnerOf: targetMorph from: outerMorph
	"Return a new event, transformed into an inner coordinate system (targetMorph owner's)."
	^self shallowCopy internalizeToOwnerOf: targetMorph from: outerMorph
! !

!SMxUserInputEvent methodsFor: 'printing' stamp: 'JuanVuletich 10/18/2010 09:04'!
modifierString
	"Return a string identifying the currently pressed modifiers"
	| string |
	string := ''.
	self commandKeyPressed ifTrue:[string := string,'CMD '].
	self shiftPressed ifTrue:[string := string,'SHIFT '].
	self controlKeyPressed ifTrue:[string := string,'CTRL '].
	^string! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/15/2000 22:45'!
position
	^position! !

!SMxUserInputEvent methodsFor: 'initialize' stamp: 'ar 9/13/2000 15:54'!
resetHandlerFields
	"Reset anything that is used to cross-communicate between two eventual handlers during event dispatch"
	handler := nil.
	wasHandled := false.! !

!SMxUserInputEvent methodsFor: 'private' stamp: 'ar 10/24/2000 16:33'!
setPosition: aPoint
	position := aPoint! !

!SMxUserInputEvent methodsFor: 'modifier state' stamp: 'ar 9/13/2000 15:44'!
shiftPressed
	"Answer true if the shift key on the keyboard was being held down when this event occurred."

	^ buttons anyMask: 8
! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'ar 10/9/2000 00:37'!
translateBy: delta
	"add delta to cursorPoint, and return the new event"
	position := position + delta.! !

!SMxUserInputEvent methodsFor: 'transforming' stamp: 'ar 10/9/2000 00:38'!
translatedBy: delta
	"add delta to cursorPoint, and return the new event"
	^self shallowCopy translateBy: delta! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:45'!
type
	"Return a symbol indicating the type this event."

	^ type! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:54'!
wasHandled
	^wasHandled! !

!SMxUserInputEvent methodsFor: 'accessing' stamp: 'ar 9/13/2000 15:54'!
wasHandled: aBool
	wasHandled := aBool.! !
SMxMorph initialize!
SMxMenuMorph initialize!
SMxColorPickerMorph initialize!
SMxMenuIcons initialize!
SMxHandMorph initialize!
SMxMenuItemMorph initialize!
SMxPopUpMenu initialize!
SMxPreferences initialize!
SMxImageMorph initialize!
SMxThreePhaseButtonMorph initialize!
SMxHaloMorph initialize!
SMxWorldState initialize!
